/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "ekvdefs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

#define _STATIC
#define _DYNAMIC

int ekvtemp(GENmodel *inModel, CKTcircuit *ckt)
{
  ekvmodel *model = (ekvmodel*)inModel;
  ekvinstance *here;
  NG_IGNOREABLE(ckt);
  for ( ; model != NULL; model = ekvnextModel(model) )
  {
{
if
(model->nmos_Given)
{
model->MOStype=1;
EXIT_IF_ISNAN(model->MOStype)
}
else
{
if
(model->pmos_Given)
{
model->MOStype=(-1);
EXIT_IF_ISNAN(model->MOStype)
}
else
{
model->MOStype=(model->type_Given?model->type:1);
EXIT_IF_ISNAN(model->MOStype)
}
}
if
(model->cox_Given)
{
model->cox_p=model->cox;
EXIT_IF_ISNAN(model->cox_p)
}
else
{
model->cox_p=((model->tox>0)?((8.854187817e-12*3.9)/model->tox):0.7e-3);
EXIT_IF_ISNAN(model->cox_p)
}
if
(model->gamma_Given)
{
model->gamma_p=model->gamma;
EXIT_IF_ISNAN(model->gamma_p)
}
else
{
{
double __sqrt_0=0.0;
_f_sqrt(__sqrt_0,((((((2*1.6021766208e-19)*8.854187817e-12)*11.7)*model->nsub)*1e+6)))
EXIT_IF_ISNAN(__sqrt_0)
model->gamma_p=((model->nsub>0)?(__sqrt_0/model->cox_p):0.7);
EXIT_IF_ISNAN(model->gamma_p)
}
}
if
(model->phi_Given)
{
model->phi_p=model->phi;
EXIT_IF_ISNAN(model->phi_p)
}
else
{
{
double __exp_0=0.0;
double __logE_1=0.0;
_f_exp(__exp_0,((((1.16-((0.000702*(300.15*300.15))/(300.15+1108)))/(2*((1.3806503e-23*300.15)/1.6021766208e-19)))-((1.16-((0.000702*((model->tnom+273.15)*(model->tnom+273.15)))/((model->tnom+273.15)+1108)))/(2*((1.3806503e-23*model->tnom)+(273.15/1.6021766208e-19)))))))
EXIT_IF_ISNAN(__exp_0)
_f_logE(__logE_1,(((model->nsub*1e+6)/((1.45e16*(model->tnom+(273.15/300.15)))*__exp_0))))
EXIT_IF_ISNAN(__logE_1)
model->phi_p=((model->nsub>0)?((2*((1.3806503e-23*model->tnom)+(273.15/1.6021766208e-19)))*__logE_1):0.5);
EXIT_IF_ISNAN(model->phi_p)
}
}
if
(model->kp_Given)
{
model->kp_p=model->kp;
EXIT_IF_ISNAN(model->kp_p)
}
else
{
model->kp_p=((model->uo>0)?((model->uo*1e-4)*model->cox_p):20e-6);
EXIT_IF_ISNAN(model->kp_p)
}
if
(model->vto_Given)
{
model->vto_p=model->vto;
EXIT_IF_ISNAN(model->vto_p)
}
else
{
{
double __sqrt_0=0.0;
_f_sqrt(__sqrt_0,(model->phi_p))
EXIT_IF_ISNAN(__sqrt_0)
model->vto_p=(model->vfb_Given?((model->vfb+model->phi_p)+(model->gamma_p*__sqrt_0)):0.5);
EXIT_IF_ISNAN(model->vto_p)
}
}
if
(model->ucrit_Given)
{
model->ucrit_p=model->ucrit;
EXIT_IF_ISNAN(model->ucrit_p)
}
else
{
model->ucrit_p=(((model->vmax>0)&&(model->uo>0))?(model->vmax/(model->uo*1e-4)):100e+3);
EXIT_IF_ISNAN(model->ucrit_p)
}
{
double __sqrt_0=0.0;
_f_sqrt(__sqrt_0,((((8.854187817e-12*11.7)/model->cox_p)*model->xj)))
EXIT_IF_ISNAN(__sqrt_0)
model->lc=__sqrt_0;
EXIT_IF_ISNAN(model->lc)
}
}

    /* loop through all the instances of the model */
    for (here = ekvinstances(model); here != NULL ; here = ekvnextInstance(here))
    {
double xsi=0.0/0.0;
double ca=0.0/0.0;
double ceps=0.0/0.0;
double PSeff=0.0/0.0;
double PDeff=0.0/0.0;
double ASeff=0.0/0.0;
double ADeff=0.0/0.0;
{
here->weff=(here->w+model->dw);
EXIT_IF_ISNAN(here->weff)
here->leff=(here->l+model->dl);
EXIT_IF_ISNAN(here->leff)
here->lmin=((0.1*here->ns)*here->leff);
EXIT_IF_ISNAN(here->lmin)
if
((model->hdif>0))
{
here->RSeff=((((here->ns/here->m)*model->rsh)*model->hdif)/here->weff);
EXIT_IF_ISNAN(here->RSeff)
here->RDeff=((((here->ns/here->m)*model->rsh)*model->hdif)/here->weff);
EXIT_IF_ISNAN(here->RDeff)
ADeff=((2*model->hdif)*here->weff);
EXIT_IF_ISNAN(ADeff)
ASeff=((2*model->hdif)*here->weff);
EXIT_IF_ISNAN(ASeff)
PDeff=((4*model->hdif)+(2*here->weff));
EXIT_IF_ISNAN(PDeff)
PSeff=((4*model->hdif)+(2*here->weff));
EXIT_IF_ISNAN(PSeff)
}
else
{
here->RSeff=(((here->ns/here->m)*model->rsh)*here->nrs);
EXIT_IF_ISNAN(here->RSeff)
here->RDeff=(((here->ns/here->m)*model->rsh)*here->nrd);
EXIT_IF_ISNAN(here->RDeff)
ADeff=here->ad;
EXIT_IF_ISNAN(ADeff)
ASeff=here->as;
EXIT_IF_ISNAN(ASeff)
PDeff=here->pd;
EXIT_IF_ISNAN(PDeff)
PSeff=here->ps;
EXIT_IF_ISNAN(PSeff)
}
if
((here->RDeff<0.001))
{
here->RDeff=0.001;
EXIT_IF_ISNAN(here->RDeff)
}
if
((here->RSeff<0.001))
{
here->RSeff=0.001;
EXIT_IF_ISNAN(here->RSeff)
}
ceps=((4*22e-3)*22e-3);
EXIT_IF_ISNAN(ceps)
ca=0.028;
EXIT_IF_ISNAN(ca)
xsi=(ca*(((10*here->leff)/model->lk)-1));
EXIT_IF_ISNAN(xsi)
{
double __sqrt_0=0.0;
double __sqrt_1=0.0;
_f_sqrt(__sqrt_0,(((xsi*xsi)+ceps)))
EXIT_IF_ISNAN(__sqrt_0)
_f_sqrt(__sqrt_1,(((xsi*xsi)+ceps)))
EXIT_IF_ISNAN(__sqrt_1)
here->dvrsce=(((2*model->q0)/model->cox_p)/((1+(0.5*(xsi+__sqrt_0)))*(1+(0.5*(xsi+__sqrt_1)))));
EXIT_IF_ISNAN(here->dvrsce)
}
#if defined(_DYNAMIC)
here->coxt=((((here->m*here->ns)*model->cox_p)*here->weff)*here->leff);
EXIT_IF_ISNAN(here->coxt)
#endif /*_DYNAMIC*/
#if defined(_DYNAMIC)
here->cbs0=(((here->m*here->ns)*model->cj)*ASeff);
EXIT_IF_ISNAN(here->cbs0)
#endif /*_DYNAMIC*/
#if defined(_DYNAMIC)
here->cbd0=(((here->m*here->ns)*model->cj)*ADeff);
EXIT_IF_ISNAN(here->cbd0)
#endif /*_DYNAMIC*/
#if defined(_DYNAMIC)
here->cbs0sw=(((here->m*here->ns)*model->cjsw)*PSeff);
EXIT_IF_ISNAN(here->cbs0sw)
#endif /*_DYNAMIC*/
#if defined(_DYNAMIC)
here->cbd0sw=(((here->m*here->ns)*model->cjsw)*PDeff);
EXIT_IF_ISNAN(here->cbd0sw)
#endif /*_DYNAMIC*/
#if defined(_DYNAMIC)
here->cgso_s=(((here->m*here->ns)*model->cgso)*here->weff);
EXIT_IF_ISNAN(here->cgso_s)
#endif /*_DYNAMIC*/
#if defined(_DYNAMIC)
here->cgdo_s=(((here->m*here->ns)*model->cgdo)*here->weff);
EXIT_IF_ISNAN(here->cgdo_s)
#endif /*_DYNAMIC*/
#if defined(_DYNAMIC)
here->cgbo_s=(((here->m*here->ns)*model->cgbo)*here->leff);
EXIT_IF_ISNAN(here->cgbo_s)
#endif /*_DYNAMIC*/
}
#if defined(_DERIVATE)
double tmp_Vg_b=0.0;
double tmp_Vdp_b=0.0;
double tmp_Vsp_b=0.0;
#endif /*_DERIVATE*/
double fact=0.0/0.0;
double sqrt_A=0.0/0.0;
double TnomK=0.0/0.0;
double TempK=0.0/0.0;
{
if
((here->dtemp>0.0))
{
TempK=(_circuit_temp+here->dtemp);
EXIT_IF_ISNAN(TempK)
}
else
{
TempK=_circuit_temp;
EXIT_IF_ISNAN(TempK)
}
TnomK=(model->tnom+273.15);
EXIT_IF_ISNAN(TnomK)
here->Vt=((1.3806503e-23*TempK)/1.6021766208e-19);
EXIT_IF_ISNAN(here->Vt)
{
double __sqrt_0=0.0;
_f_sqrt(__sqrt_0,((((here->m*here->weff)*here->ns)*here->leff)))
EXIT_IF_ISNAN(__sqrt_0)
sqrt_A=__sqrt_0;
EXIT_IF_ISNAN(sqrt_A)
}
here->vto_a=((model->MOStype*(model->vto_p+(model->tcv*(TempK-TnomK))))+(model->avto/sqrt_A));
EXIT_IF_ISNAN(here->vto_a)
{
double __pow_0=0.0;
_f_pow(__pow_0,(TempK/TnomK),model->bex)
EXIT_IF_ISNAN(__pow_0)
here->kp_a=(((here->m*model->kp_p)*__pow_0)*(1+(model->akp/sqrt_A)));
EXIT_IF_ISNAN(here->kp_a)
}
here->gamma_a=(model->gamma_p+(model->agamma/sqrt_A));
EXIT_IF_ISNAN(here->gamma_a)
{
double __pow_0=0.0;
_f_pow(__pow_0,(TempK/TnomK),model->ucex)
EXIT_IF_ISNAN(__pow_0)
here->ucrit_a=(model->ucrit_p*__pow_0);
EXIT_IF_ISNAN(here->ucrit_a)
}
{
double __logE_0=0.0;
_f_logE(__logE_0,((TempK/TnomK)))
EXIT_IF_ISNAN(__logE_0)
here->phi_a=(((((model->phi_p*TempK)/TnomK)-((3*here->Vt)*__logE_0))-(((1.16-((0.000702*(TnomK*TnomK))/(TnomK+1108)))*TempK)/TnomK))+(1.16-((0.000702*(TempK*TempK))/(TempK+1108))));
EXIT_IF_ISNAN(here->phi_a)
}
here->ibb_a=(model->ibb*(1+(model->ibbt*(TempK-TnomK))));
EXIT_IF_ISNAN(here->ibb_a)
here->vc=((here->ucrit_a*here->ns)*here->leff);
EXIT_IF_ISNAN(here->vc)
{
double __sqrt_0=0.0;
_f_sqrt(__sqrt_0,(here->phi_a))
EXIT_IF_ISNAN(__sqrt_0)
here->qb0=(here->gamma_a*__sqrt_0);
EXIT_IF_ISNAN(here->qb0)
}
{
double __pow_0=0.0;
_f_pow(__pow_0,(TempK/TnomK),model->xti)
EXIT_IF_ISNAN(__pow_0)
fact=((((1.16-((0.000702*(TnomK*TnomK))/(TnomK+1108)))/((1.3806503e-23*TnomK)/1.6021766208e-19))-((1.16-((0.000702*(TempK*TempK))/(TempK+1108)))/here->Vt))*__pow_0);
EXIT_IF_ISNAN(fact)
}
if
((fact<200.0))
{
{
double __exp_0=0.0;
_f_exp(__exp_0,(fact))
EXIT_IF_ISNAN(__exp_0)
here->tmp=__exp_0;
EXIT_IF_ISNAN(here->tmp)
#if defined(_DERIVATE)
tmp_Vg_b=0.0;
tmp_Vdp_b=0.0;
tmp_Vsp_b=0.0;
#endif /*_DERIVATE*/
}
}
else
{
{
double __exp_0=0.0;
_f_exp(__exp_0,(200.0))
EXIT_IF_ISNAN(__exp_0)
here->tmp=(__exp_0*(1.0+(fact-200.0)));
EXIT_IF_ISNAN(here->tmp)
#if defined(_DERIVATE)
tmp_Vg_b=0.0;
tmp_Vdp_b=0.0;
tmp_Vsp_b=0.0;
#endif /*_DERIVATE*/
}
}
here->isat_s=(((here->m*here->ns)*((model->js*ASeff)+(model->jsw*PSeff)))*here->tmp);
EXIT_IF_ISNAN(here->isat_s)
here->isat_d=(((here->m*here->ns)*((model->js*ADeff)+(model->jsw*PDeff)))*here->tmp);
EXIT_IF_ISNAN(here->isat_d)
if
((here->isat_s>0))
{
{
double __logE_0=0.0;
_f_logE(__logE_0,(((model->imax/here->isat_s)+1)))
EXIT_IF_ISNAN(__logE_0)
here->vexp_s=(here->Vt*__logE_0);
EXIT_IF_ISNAN(here->vexp_s)
}
here->gexp_s=((model->imax+here->isat_s)/here->Vt);
EXIT_IF_ISNAN(here->gexp_s)
}
else
{
here->vexp_s=(-1e9);
EXIT_IF_ISNAN(here->vexp_s)
here->gexp_s=0;
EXIT_IF_ISNAN(here->gexp_s)
}
if
((here->isat_d>0))
{
{
double __logE_0=0.0;
_f_logE(__logE_0,(((model->imax/here->isat_d)+1)))
EXIT_IF_ISNAN(__logE_0)
here->vexp_d=(here->Vt*__logE_0);
EXIT_IF_ISNAN(here->vexp_d)
}
here->gexp_d=((model->imax+here->isat_d)/here->Vt);
EXIT_IF_ISNAN(here->gexp_d)
}
else
{
here->vexp_d=(-1e9);
EXIT_IF_ISNAN(here->vexp_d)
here->gexp_d=0;
EXIT_IF_ISNAN(here->gexp_d)
}
}

    } /* End of MOSFET Instance */
  } /* End of Model Instance */
  return(OK);
}
