/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "psp102defs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

#define jacobian(a,b) here->PTR_J_##a##_##b##_required=1;
#define static_jacobian4(p,q,r,s)  jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define static_jacobian2s(p,q,r)   jacobian(p,r) jacobian(q,r)
#define static_jacobian2p(p,r,s)   jacobian(p,r) jacobian(p,s)
#define static_jacobian1(p,r)      jacobian(p,r)
#define dynamic_jacobian4(p,q,r,s) jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define dynamic_jacobian2s(p,q,r)  jacobian(p,r) jacobian(q,r)
#define dynamic_jacobian2p(p,r,s)  jacobian(p,r) jacobian(p,s)
#define dynamic_jacobian1(p,r)     jacobian(p,r)
#define whitenoise_jacobian4(p,q,r,s)
#define whitenoise_jacobian2s(p,q,r)
#define whitenoise_jacobian2p(p,r,s)
#define whitenoise_jacobian1(p)
#define flickernoise_jacobian4(p,q,r,s)
#define flickernoise_jacobian2s(p,q,r)
#define flickernoise_jacobian2p(p,r,s)
#define flickernoise_jacobian1(p)


int psp102guesstopology (SMPmatrix *matrix, CKTcircuit *ckt, psp102model *model, psp102instance *here)
     /* guess topology */
{
  NG_IGNOREABLE(matrix);
  NG_IGNOREABLE(ckt);
double rwellnoise=0.0/0.0;
double rjundnoise=0.0/0.0;
double rjunsnoise=0.0/0.0;
double rbulknoise=0.0/0.0;
double rgatenoise=0.0/0.0;
double inv_xg1=0.0/0.0;
double x_mrg_ov=0.0/0.0;
double inv_xi_ov=0.0/0.0;
double xi_ov=0.0/0.0;
double GOV2=0.0/0.0;
double GOV=0.0/0.0;
if
((model->CHNL_TYPE==(+1)))
{
}
else
{
}
if
((here->DNSUB_i>0.0))
{
}
else
{
}
if
((((((model->SWIGATE!=0)&&((here->IGOV_i>0)||(here->IGOVD_i>0)))||((model->SWGIDL!=0)&&((here->AGIDL_i>0)||(here->AGIDLD_i>0))))||(here->CGOV_i>0))||(here->CGOVD_i>0)))
{
GOV=here->GOV_s;
GOV2=here->GOV2_s;
xi_ov=here->xi_ov_s;
inv_xi_ov=here->inv_xi_ov_s;
x_mrg_ov=here->x_mrg_ov_s;
inv_xg1=here->inv_xg1_s;
GOV=here->GOV_d;
GOV2=here->GOV2_d;
xi_ov=here->xi_ov_d;
inv_xi_ov=here->inv_xi_ov_d;
x_mrg_ov=here->x_mrg_ov_d;
inv_xg1=here->inv_xg1_d;
}
if
((model->SWIGATE!=0))
{
if
((here->IGOV_i>0))
{
if
((here->GC3_i<0))
{
}
}
if
((here->IGOVD_i>0))
{
if
((here->GC3_i<0))
{
}
}
if
((here->IGINV_i>0))
{
if
((here->GC3_i<0))
{
}
}
}
if
((model->SWGIDL!=0))
{
}
if
((here->qq>0.0))
{
}
if
((model->SWJUNCAP>0.0))
{
if
((model->SWJUNEXP_i==1.0))
{
if
((here->m0flag_s>0))
{
}
else
{
}
if
((here->m0flag_d>0))
{
}
else
{
}
here->h1=((4.0*here->vch_s)*here->vch_s);
here->h2=(here->vch_s/here->vfmin_s);
if
((here->zflagbot_s>0.5))
{
if
((model->one_minus_PBOT==0.5))
{
}
else
{
}
}
if
((here->zflagsti_s>0.5))
{
if
((model->one_minus_PSTI==0.5))
{
}
else
{
}
}
if
((here->zflaggat_s>0.5))
{
if
((model->one_minus_PGAT==0.5))
{
}
else
{
}
}
here->h1=((4.0*here->vch_d)*here->vch_d);
here->h2=(here->vch_d/here->vfmin_d);
if
((here->zflagbot_d>0.5))
{
if
((model->one_minus_PBOT_d==0.5))
{
}
else
{
}
}
if
((here->zflagsti_d>0.5))
{
if
((model->one_minus_PSTI_d==0.5))
{
}
else
{
}
}
if
((here->zflaggat_d>0.5))
{
if
((model->one_minus_PGAT_d==0.5))
{
}
else
{
}
}
}
else
{
if
((!(((here->ABSOURCE_i==0)&&(here->LSSOURCE_i==0))&&(here->LGSOURCE_i==0))))
{
here->h1=((4.0*here->vch_s)*here->vch_s);
here->h2=(here->vch_s/here->vfmin_s);
}
if
((here->ABSOURCE_i==0))
{
}
else
{
if
((model->one_minus_PBOT==0.5))
{
}
else
{
}
if
(((model->CSRHBOT_i==0)&&(model->CTATBOT_i==0)))
{
}
else
{
if
((model->PBOT_i==0.5))
{
}
else
{
}
if
((model->PBOT_i==0.5))
{
}
else
{
}
}
if
((model->CTATBOT_i==0))
{
}
else
{
if
((((-model->PBOT_i)*model->one_over_one_minus_PBOT)==(-1)))
{
}
else
{
}
}
if
((model->CBBTBOT_i==0))
{
}
else
{
if
((model->PBOT_i==0.5))
{
}
else
{
}
}
if
((model->VBRBOT_i>1000))
{
}
else
{
}
}
if
((here->LSSOURCE_i==0))
{
}
else
{
if
((model->one_minus_PSTI==0.5))
{
}
else
{
}
if
(((model->CSRHSTI_i==0)&&(model->CTATSTI_i==0)))
{
}
else
{
if
((model->PSTI_i==0.5))
{
}
else
{
}
if
((model->PSTI_i==0.5))
{
}
else
{
}
}
if
((model->CTATSTI_i==0))
{
}
else
{
if
((((-model->PSTI_i)*model->one_over_one_minus_PSTI)==(-1)))
{
}
else
{
}
}
if
((model->CBBTSTI_i==0))
{
}
else
{
if
((model->PSTI_i==0.5))
{
}
else
{
}
}
if
((model->VBRSTI_i>1000))
{
}
else
{
}
}
if
((here->LGSOURCE_i==0))
{
}
else
{
if
((model->one_minus_PGAT==0.5))
{
}
else
{
}
if
(((model->CSRHGAT_i==0)&&(model->CTATGAT_i==0)))
{
}
else
{
if
((model->PGAT_i==0.5))
{
}
else
{
}
if
((model->PGAT_i==0.5))
{
}
else
{
}
}
if
((model->CTATGAT_i==0))
{
}
else
{
if
((((-model->PGAT_i)*model->one_over_one_minus_PGAT)==(-1)))
{
}
else
{
}
}
if
((model->CBBTGAT_i==0))
{
}
else
{
if
((model->PGAT_i==0.5))
{
}
else
{
}
}
if
((model->VBRGAT_i>1000))
{
}
else
{
}
}
if
((!(((here->ABDRAIN_i==0)&&(here->LSDRAIN_i==0))&&(here->LGDRAIN_i==0))))
{
here->h1=((4.0*here->vch_d)*here->vch_d);
here->h2=(here->vch_d/here->vfmin_d);
}
if
((here->ABDRAIN_i==0))
{
}
else
{
if
((model->one_minus_PBOT_d==0.5))
{
}
else
{
}
if
(((model->CSRHBOTD_i==0)&&(model->CTATBOTD_i==0)))
{
}
else
{
if
((model->PBOTD_i==0.5))
{
}
else
{
}
if
((model->PBOTD_i==0.5))
{
}
else
{
}
}
if
((model->CTATBOTD_i==0))
{
}
else
{
if
((((-model->PBOTD_i)*model->one_over_one_minus_PBOT_d)==(-1)))
{
}
else
{
}
}
if
((model->CBBTBOTD_i==0))
{
}
else
{
if
((model->PBOTD_i==0.5))
{
}
else
{
}
}
if
((model->VBRBOTD_i>1000))
{
}
else
{
}
}
if
((here->LSDRAIN_i==0))
{
}
else
{
if
((model->one_minus_PSTI_d==0.5))
{
}
else
{
}
if
(((model->CSRHSTID_i==0)&&(model->CTATSTID_i==0)))
{
}
else
{
if
((model->PSTID_i==0.5))
{
}
else
{
}
if
((model->PSTID_i==0.5))
{
}
else
{
}
}
if
((model->CTATSTID_i==0))
{
}
else
{
if
((((-model->PSTID_i)*model->one_over_one_minus_PSTI_d)==(-1)))
{
}
else
{
}
}
if
((model->CBBTSTID_i==0))
{
}
else
{
if
((model->PSTID_i==0.5))
{
}
else
{
}
}
if
((model->VBRSTID_i>1000))
{
}
else
{
}
}
if
((here->LGDRAIN_i==0))
{
}
else
{
if
((model->one_minus_PGAT_d==0.5))
{
}
else
{
}
if
(((model->CSRHGATD_i==0)&&(model->CTATGATD_i==0)))
{
}
else
{
if
((model->PGATD_i==0.5))
{
}
else
{
}
if
((model->PGATD_i==0.5))
{
}
else
{
}
}
if
((model->CTATGATD_i==0))
{
}
else
{
if
((((-model->PGATD_i)*model->one_over_one_minus_PGAT_d)==(-1)))
{
}
else
{
}
}
if
((model->CBBTGATD_i==0))
{
}
else
{
if
((model->PGATD_i==0.5))
{
}
else
{
}
}
if
((model->VBRGATD_i>1000))
{
}
else
{
}
}
}
}
rgatenoise=(model->nt0*here->ggate);
rbulknoise=(model->nt0*here->gbulk);
rjunsnoise=(model->nt0*here->gjuns);
rjundnoise=(model->nt0*here->gjund);
rwellnoise=(model->nt0*here->gwell);
  static_jacobian4(GP,BP,S,BP)
  static_jacobian4(GP,BP,D,S)
  static_jacobian4(GP,BP,GP,S)
  static_jacobian4(GP,S,S,BP)
  static_jacobian4(GP,S,D,S)
  static_jacobian4(GP,S,GP,S)
  static_jacobian4(GP,D,S,BP)
  static_jacobian4(GP,D,D,S)
  static_jacobian4(GP,D,GP,S)
  static_jacobian4(S,BP,D,S)
  static_jacobian4(S,BP,GP,S)
  static_jacobian4(S,BP,S,BP)
  static_jacobian4(D,BP,GP,S)
  static_jacobian4(D,BP,S,BP)
  static_jacobian4(D,BP,D,S)
  static_jacobian4(BS,S,S,BS)
  static_jacobian4(BS,S,D,BD)
  static_jacobian4(BD,D,S,BS)
  static_jacobian4(BD,D,D,BD)
  static_jacobian4(G,GP,G,GP)
  static_jacobian4(BP,BI,BP,BI)
  static_jacobian4(BS,BI,BS,BI)
  static_jacobian4(BD,BI,BD,BI)
  static_jacobian4(B,BI,B,BI)
  static_jacobian4(D,S,D,S)
  dynamic_jacobian4(GP,S,S,BP)
  dynamic_jacobian4(GP,S,GP,S)
  dynamic_jacobian4(GP,S,D,S)
  dynamic_jacobian4(BP,S,S,BP)
  dynamic_jacobian4(BP,S,GP,S)
  dynamic_jacobian4(BP,S,D,S)
  dynamic_jacobian4(D,S,S,BP)
  dynamic_jacobian4(D,S,D,S)
  dynamic_jacobian4(D,S,GP,S)
  dynamic_jacobian4(GP,S,GP,S)
  dynamic_jacobian4(GP,S,S,BP)
  dynamic_jacobian4(GP,S,D,S)
  dynamic_jacobian4(GP,D,D,S)
  dynamic_jacobian4(GP,D,GP,S)
  dynamic_jacobian4(GP,D,S,BP)
  dynamic_jacobian4(GP,BP,S,BP)
  dynamic_jacobian4(GP,BP,GP,S)
  dynamic_jacobian4(GP,BP,D,S)
  dynamic_jacobian4(BS,S,S,BS)
  dynamic_jacobian4(BS,S,D,BD)
  dynamic_jacobian4(BD,D,S,BS)
  dynamic_jacobian4(BD,D,D,BD)
  static_jacobian1(NOI2,NOI2)
  static_jacobian2p(NOI2,S,BP)
  static_jacobian2p(NOI2,GP,S)
  static_jacobian2p(NOI2,D,S)
  static_jacobian2p(NOI,S,BP)
  static_jacobian2p(NOI,GP,S)
  static_jacobian2p(NOI,D,S)
  static_jacobian1(NOI,NOI2)
  static_jacobian2p(NOI,S,BP)
  static_jacobian2p(NOI,GP,S)
  static_jacobian2p(NOI,D,S)
  static_jacobian1(NOI,NOI)
  dynamic_jacobian1(NOI,NOI)
  dynamic_jacobian2p(NOI,S,BP)
  dynamic_jacobian2p(NOI,GP,S)
  dynamic_jacobian2p(NOI,D,S)
  static_jacobian4(D,S,S,BP)
  static_jacobian4(D,S,GP,S)
  static_jacobian4(D,S,D,S)
  static_jacobian4(D,S,S,BP)
  static_jacobian4(D,S,GP,S)
  static_jacobian4(D,S,D,S)
  static_jacobian4(GP,S,S,BP)
  static_jacobian4(GP,S,D,S)
  static_jacobian4(GP,S,GP,S)
  static_jacobian4(GP,D,S,BP)
  static_jacobian4(GP,D,D,S)
  static_jacobian4(GP,D,GP,S)
  static_jacobian4(BS,S,S,BS)
  static_jacobian4(BS,S,D,BD)
  static_jacobian4(BS,S,S,BP)
  static_jacobian4(BS,S,GP,S)
  static_jacobian4(BS,S,D,S)
  static_jacobian4(BD,D,S,BP)
  static_jacobian4(BD,D,GP,S)
  static_jacobian4(BD,D,D,S)
  static_jacobian4(BD,D,S,BS)
  static_jacobian4(BD,D,D,BD)

  return(OK);
}
