

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

/* arithmetics */
#define EXP90 1.220403294317841e+039
#define m00_hypot(v00,x,y)      v00 = sqrt((x)*(x)+(y)*(y));
#define m10_hypot(v10,v00,x,y)  v10 = (x)/(v00);
#define m11_hypot(v11,v00,x,y)  v11 = (y)/(v00);
#define m00_max(v00,x,y)        v00 = ((x)>(y))?(x):(y);
#define m10_max(v10,v00,x,y)    v10 = ((x)>(y))?1.0:0.0;
#define m11_max(v11,v00,x,y)    v11 = ((x)>(y))?0.0:1.0;
#define m00_min(v00,x,y)        v00 = ((x)<(y))?(x):(y);
#define m10_min(v10,v00,x,y)    v10 = ((x)<(y))?1.0:0.0;
#define m11_min(v11,v00,x,y)    v11 = ((x)<(y))?0.0:1.0;
#define m00_pow(v00,x,y)        v00 = pow(x,y);
#define m10_pow(v10,v00,x,y)    v10 = (x==0.0)?0.0:(v00)*(y)/(x);
#define m11_pow(v11,v00,x,y)    v11 = (x==0.0)?0.0:(log(x)*(v00));
#define m00_div(v00,v10,x,y)    double v10=1/(y); double v00=(x)*v10;
#define m10_div(v10,v00,vv,x,y)
#define m11_div(v11,v00,vv,x,y) double v11 = -v00*vv;
#define m00_mult(v00,v10,v11,x,y) double v10=(x); double v11=(y); double v00=v10*v11;
#define m00_add(v00,x,y)        double v00=(x)+(y);
#define m00_cos(v00,x)          v00 = cos(x);
#define m10_cos(v10,v00,x)      v10 = (-sin(x));
#define m00_sin(v00,x)          v00 = sin(x);
#define m10_sin(v10,v00,x)      v10 = (cos(x));
#define m00_tan(v00,x)          v00 = tan(x);
#define m10_tan(v10,v00,x)      v10 = (1.0/cos(x)/cos(x));
#define m00_cosh(v00,x)         v00 = cosh(x);
#define m10_cosh(v10,v00,x)     v10 = (sinh(x));
#define m00_sinh(v00,x)         v00 = sinh(x);
#define m10_sinh(v10,v00,x)     v10 = (cosh(x));
#define m00_tanh(v00,x)         v00 = tanh(x);
#define m10_tanh(v10,v00,x)     v10 = (1.0/cosh(x)/cosh(x));
#define m00_acos(v00,x)         v00 = acos(x);
#define m10_acos(v10,v00,x)     v10 = (-1.0/sqrt(1-x*x));
#define m00_asin(v00,x)         v00 = asin(x);
#define m10_asin(v10,v00,x)     v10 = (+1.0/sqrt(1-x*x));
#define m00_atan(v00,x)         v00 = atan(x);
#define m10_atan(v10,v00,x)     v10 = (+1.0/(1+x*x));
#define m00_logE(v00,x)         v00 = log(x);
#define m10_logE(v10,v00,x)     v10 = (1.0/x);
#define m00_log10(v00,x)        v00 = log10(x);
#define m10_log10(v10,v00,x)    v10 = (1.0/x/log(10));
#define m00_sqrt(v00,x)         v00 = sqrt(x);
#define m10_sqrt(v10,v00,x)     v10 = (0.5/v00);
#define m00_fabs(v00,x)         v00 = fabs(x);
#define m10_fabs(v10,v00,x)     v10 = (((x)>=0)?(+1.0):(-1.0));
#define m00_exp(v00,x)          v00 = exp(x);
#define m10_exp(v10,v00,x)      v10 = v00;
#define m00_abs(v00)            ((v00)<(0)?(-(v00)):(v00))
#define m00_floor(v00,x)        v00 = floor(x);
#define m00_ceil(v00,x)         v00 = ceil(x);
#define m00_limexp(v00,x)       v00 = ((x)<90.0?exp(x):EXP90*(x-89.0));
#define m10_limexp(v10,v00,x)   v10 = ((x)<90.0?(v00):EXP90);
#define m00_atan2(v00,x,y)      v00 = atan2(x,y);
#define m10_atan2(v10,x,y)      v10 = (-(y)/((x)*(x)+(y)*(y)));
#define m11_atan2(v11,x,y)      v11 = ((x)/((x)*(x)+(y)*(y)));
#define m00_acosh(v00,x)        v00 = acosh(x);
#define m10_acosh(v10,v00,x)    v10 = (1.0/(sqrt(x-1)*sqrt(x+1)));
#define m00_asinh(v00,x)        v00 = asinh(x);
#define m10_asinh(v10,v00,x)    v10 = (1.0/(sqrt(x*x+1)));
#define m00_atanh(v00,x)        v00 = atanh(x);
#define m10_atanh(v10,v00,x)    v10 = (1.0/(1-x*x));

#define m20_logE(v00)         (-1.0/v00/v00)
#define m20_exp(v00)          exp(v00)
#define m20_limexp(v00)       ((v00)<90.0?exp(v00):0.0)
#define m20_sqrt(v00)         (-0.25/(v00)/sqrt(v00))
#define m20_fabs(v00)         0.0

/*wrapper*/
#define pModel model
#define pInst here
#define mint_get_circuit_tempK() _circuit_temp
#define voltages(n) NP(n)
#define _DDT(q) q
#define _DDX
#define _DERIVATEFORDDX
double it_wop;
#if defined(_DYNAMIC)
double Qbiei;
#if defined(_DERIVATE)
double Qbiei_Vtnode_GND;
double Qbiei_Vci_ei;
double Qbiei_Vbi_ei;
double Qbiei_Vb_ci;
double Qbiei_Vbi_ci;
double Qbiei_Vxf_GND;
#endif
#endif
#if defined(_DYNAMIC)
double Qbici;
#if defined(_DERIVATE)
double Qbici_Vb_ci;
double Qbici_Vtnode_GND;
double Qbici_Vbi_ci;
double Qbici_Vbi_ei;
double Qbici_Vci_ei;
#endif
#endif
#if defined(_DYNAMIC)
double Qbe;
#if defined(_DERIVATE)
double Qbe_Vb_e;
#endif
#endif
#if defined(_DYNAMIC)
double Qbci;
#if defined(_DERIVATE)
double Qbci_Vb_ci;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Ibici_Vtnode_GND;
double Ibici_Vbi_ci;
double Ibici_Vbi_ei;
double Ibici_Vb_ci;
double Ibici_Vci_ei;
#if defined(_DERIVATE2)
  double Ibici_Vci_ei_Vtnode_GND;
  double Ibici_Vci_ei_Vbi_ci;
  double Ibici_Vci_ei_Vbi_ei;
  double Ibici_Vci_ei_Vb_ci;
  double Ibici_Vci_ei_Vci_ei;
  double Ibici_Vb_ci_Vtnode_GND;
  double Ibici_Vb_ci_Vbi_ci;
  double Ibici_Vb_ci_Vbi_ei;
  double Ibici_Vb_ci_Vb_ci;
  double Ibici_Vb_ci_Vci_ei;
  double Ibici_Vbi_ci_Vtnode_GND;
  double Ibici_Vbi_ci_Vbi_ci;
  double Ibici_Vbi_ci_Vbi_ei;
  double Ibici_Vbi_ci_Vb_ci;
  double Ibici_Vbi_ci_Vci_ei;
#endif
#endif
#if defined(_DYNAMIC)
double Qxf;
#if defined(_DERIVATE)
double Qxf_Vxf_GND;
#endif
#endif
double Ixf;
#if defined(_DERIVATE)
double Ixf_Vxf_GND;
double Ixf_Vtnode_GND;
double Ixf_Vb_ci;
double Ixf_Vbi_ci;
double Ixf_Vbi_ei;
double Ixf_Vci_ei;
#endif
double fact;
#if defined(_DERIVATE)
double fact_Vtnode_GND;
double fact_Vb_ci;
double fact_Vbi_ci;
double fact_Vci_ei;
double fact_Vbi_ei;
#endif
double Vxf;
#if defined(_DERIVATE)
double Vxf_Vxf_GND;
#endif
#if defined(_DYNAMIC)
double Qxf2;
#if defined(_DERIVATE)
double Qxf2_Vxf2_GND;
#endif
#endif
#if defined(_DYNAMIC)
double Qxf1;
#if defined(_DERIVATE)
double Qxf1_Vxf1_GND;
#endif
#endif
double Ixf2;
#if defined(_DERIVATE)
double Ixf2_Vxf2_GND;
double Ixf2_Vxf1_GND;
double Ixf2_Vtnode_GND;
double Ixf2_Vb_ci;
double Ixf2_Vbi_ci;
double Ixf2_Vci_ei;
double Ixf2_Vbi_ei;
#endif
double Ixf1;
#if defined(_DERIVATE)
double Ixf1_Vxf1_GND;
double Ixf1_Vxf2_GND;
double Ixf1_Vtnode_GND;
double Ixf1_Vbi_ei;
double Ixf1_Vb_ci;
double Ixf1_Vbi_ci;
double Ixf1_Vci_ei;
#endif
double Vxf2;
#if defined(_DERIVATE)
double Vxf2_Vxf2_GND;
#endif
double Vxf1;
#if defined(_DERIVATE)
double Vxf1_Vxf1_GND;
#endif
#if defined(_DYNAMIC)
double Qdeix;
#if defined(_DERIVATE)
double Qdeix_Vxf_GND;
double Qdeix_Vtnode_GND;
double Qdeix_Vb_ci;
double Qdeix_Vbi_ci;
double Qdeix_Vbi_ei;
double Qdeix_Vci_ei;
#endif
#endif
double Itxf;
#if defined(_DERIVATEFORDDX)
double Itxf_Vxf2_GND;
double Itxf_Vtnode_GND;
double Itxf_Vbi_ei;
double Itxf_Vb_ci;
double Itxf_Vbi_ci;
double Itxf_Vci_ei;
#if defined(_DERIVATE2)
  double Itxf_Vbi_ci_Vxf2_GND;
  double Itxf_Vbi_ci_Vtnode_GND;
  double Itxf_Vbi_ci_Vbi_ei;
  double Itxf_Vbi_ci_Vb_ci;
  double Itxf_Vbi_ci_Vbi_ci;
  double Itxf_Vbi_ci_Vci_ei;
  double Itxf_Vbi_ei_Vxf2_GND;
  double Itxf_Vbi_ei_Vtnode_GND;
  double Itxf_Vbi_ei_Vbi_ei;
  double Itxf_Vbi_ei_Vb_ci;
  double Itxf_Vbi_ei_Vbi_ci;
  double Itxf_Vbi_ei_Vci_ei;
#endif
#endif
double pterm;
#if defined(_DERIVATE)
double pterm_Vci_c;
double pterm_Vei_e;
double pterm_Vb_bi;
double pterm_Vs_ci;
double pterm_Vtnode_GND;
double pterm_Vbi_ei;
double pterm_Vb_ci;
double pterm_Vbi_ci;
double pterm_Vci_ei;
#endif
#if defined(_DYNAMIC)
double qjs;
#if defined(_DERIVATEFORDDX)
double qjs_Vci_ei;
double qjs_Vbi_ei;
double qjs_Vs_ci;
double qjs_Vb_ci;
double qjs_Vtnode_GND;
double qjs_Vbi_ci;
#if defined(_DERIVATE2)
  double qjs_Vs_ci_Vci_ei;
  double qjs_Vs_ci_Vbi_ei;
  double qjs_Vs_ci_Vs_ci;
  double qjs_Vs_ci_Vb_ci;
  double qjs_Vs_ci_Vtnode_GND;
  double qjs_Vs_ci_Vbi_ci;
#endif
#endif
#endif
#if defined(_DERIVATE)
double ijsc_Vtnode_GND;
double ijsc_Vs_ci;
double ijsc_Vbi_ci;
double ijsc_Vbi_ei;
#endif
double HSI_Tsu;
#if defined(_DERIVATE)
double HSI_Tsu_Vtnode_GND;
double HSI_Tsu_Vb_ci;
double HSI_Tsu_Vs_ci;
#endif
double HSb;
#if defined(_DERIVATE)
double HSb_Vs_ci;
double HSb_Vtnode_GND;
#endif
double HSa;
#if defined(_DERIVATE)
double HSa_Vb_ci;
double HSa_Vtnode_GND;
#endif
double HSUM;
#if defined(_DERIVATE)
double HSUM_Vtnode_GND;
#endif
double rb;
#if defined(_DERIVATE)
double rb_Vtnode_GND;
double rb_Vbi_ei;
double rb_Vci_ei;
double rb_Vb_ci;
double rb_Vbi_ci;
#endif
double eta;
#if defined(_DERIVATE)
double eta_Vtnode_GND;
double eta_Vbi_ei;
double eta_Vci_ei;
double eta_Vb_ci;
double eta_Vbi_ci;
#endif
double rbi;
#if defined(_DERIVATE)
double rbi_Vtnode_GND;
double rbi_Vbi_ei;
double rbi_Vci_ei;
double rbi_Vb_ci;
double rbi_Vbi_ci;
#endif
double fQz;
#if defined(_DERIVATE)
double fQz_Vtnode_GND;
double fQz_Vbi_ei;
double fQz_Vci_ei;
double fQz_Vb_ci;
double fQz_Vbi_ci;
#endif
double Qz_nom;
#if defined(_DERIVATE)
double Qz_nom_Vtnode_GND;
double Qz_nom_Vbi_ei;
double Qz_nom_Vci_ei;
double Qz_nom_Vb_ci;
double Qz_nom_Vbi_ci;
#endif
double lncc;
#if defined(_DERIVATEFORDDX)
double lncc_Vtnode_GND;
double lncc_Vb_ci;
double lncc_Vbi_ci;
#if defined(_DERIVATE2)
  double lncc_Vbi_ci_Vtnode_GND;
  double lncc_Vbi_ci_Vb_ci;
  double lncc_Vbi_ci_Vbi_ci;
  double lncc_Vb_ci_Vtnode_GND;
  double lncc_Vb_ci_Vb_ci;
  double lncc_Vb_ci_Vbi_ci;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double iavl_Vtnode_GND;
double iavl_Vbi_ei;
double iavl_Vb_ci;
double iavl_Vbi_ci;
double iavl_Vci_ei;
#if defined(_DERIVATE2)
  double iavl_Vci_ei_Vtnode_GND;
  double iavl_Vci_ei_Vbi_ei;
  double iavl_Vci_ei_Vb_ci;
  double iavl_Vci_ei_Vbi_ci;
  double iavl_Vci_ei_Vci_ei;
  double iavl_Vbi_ci_Vtnode_GND;
  double iavl_Vbi_ci_Vbi_ei;
  double iavl_Vbi_ci_Vb_ci;
  double iavl_Vbi_ci_Vbi_ci;
  double iavl_Vbi_ci_Vci_ei;
  double iavl_Vb_ci_Vtnode_GND;
  double iavl_Vb_ci_Vbi_ei;
  double iavl_Vb_ci_Vb_ci;
  double iavl_Vb_ci_Vbi_ci;
  double iavl_Vb_ci_Vci_ei;
#endif
#endif
double a_iavl;
#if defined(_DERIVATEFORDDX)
double a_iavl_Vtnode_GND;
double a_iavl_Vb_ci;
double a_iavl_Vbi_ci;
#if defined(_DERIVATE2)
  double a_iavl_Vbi_ci_Vtnode_GND;
  double a_iavl_Vbi_ci_Vb_ci;
  double a_iavl_Vbi_ci_Vbi_ci;
  double a_iavl_Vb_ci_Vtnode_GND;
  double a_iavl_Vb_ci_Vb_ci;
  double a_iavl_Vb_ci_Vbi_ci;
#endif
#endif
double v_bord;
#if defined(_DERIVATE)
double v_bord_Vtnode_GND;
#endif
double ibi;
#if defined(_DERIVATE)
double ibi_Vtnode_GND;
double ibi_Vbi_ei;
double ibi_Vbi_ci;
#endif
#if defined(_DERIVATEFORDDX)
double ijbc_Vtnode_GND;
double ijbc_Vbi_ci;
double ijbc_Vbi_ei;
#if defined(_DERIVATE2)
  double ijbc_Vbi_ci_Vtnode_GND;
  double ijbc_Vbi_ci_Vbi_ci;
  double ijbc_Vbi_ci_Vbi_ei;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double ijbe_Vtnode_GND;
double ijbe_Vbi_ei;
#if defined(_DERIVATE2)
  double ijbe_Vbi_ei_Vtnode_GND;
  double ijbe_Vbi_ei_Vbi_ei;
#endif
#endif
double ire;
#if defined(_DERIVATEFORDDX)
double ire_Vtnode_GND;
double ire_Vbi_ei;
#if defined(_DERIVATE2)
  double ire_Vbi_ei_Vtnode_GND;
  double ire_Vbi_ei_Vbi_ei;
#endif
#endif
double ibe;
#if defined(_DERIVATEFORDDX)
double ibe_Vtnode_GND;
double ibe_Vbi_ei;
#if defined(_DERIVATE2)
  double ibe_Vbi_ei_Vtnode_GND;
  double ibe_Vbi_ei_Vbi_ei;
#endif
#endif
double le;
#if defined(_DERIVATEFORDDX)
double le_Vs_ci;
double le_Vbi_ci;
double le_Vbi_ei;
double le_Vtnode_GND;
#if defined(_DERIVATE2)
  double le_Vbi_ei_Vs_ci;
  double le_Vbi_ei_Vbi_ci;
  double le_Vbi_ei_Vbi_ei;
  double le_Vbi_ei_Vtnode_GND;
  double le_Vbi_ci_Vs_ci;
  double le_Vbi_ci_Vbi_ci;
  double le_Vbi_ci_Vbi_ei;
  double le_Vbi_ci_Vtnode_GND;
  double le_Vs_ci_Vs_ci;
  double le_Vs_ci_Vbi_ci;
  double le_Vs_ci_Vbi_ei;
  double le_Vs_ci_Vtnode_GND;
#endif
#endif
double DIOY;
#if defined(_DERIVATEFORDDX)
double DIOY_Vs_ci;
double DIOY_Vbi_ci;
double DIOY_Vbi_ei;
double DIOY_Vtnode_GND;
#if defined(_DERIVATE2)
  double DIOY_Vbi_ei_Vs_ci;
  double DIOY_Vbi_ei_Vbi_ci;
  double DIOY_Vbi_ei_Vbi_ei;
  double DIOY_Vbi_ei_Vtnode_GND;
  double DIOY_Vbi_ci_Vs_ci;
  double DIOY_Vbi_ci_Vbi_ci;
  double DIOY_Vbi_ci_Vbi_ei;
  double DIOY_Vbi_ci_Vtnode_GND;
  double DIOY_Vs_ci_Vs_ci;
  double DIOY_Vs_ci_Vbi_ci;
  double DIOY_Vs_ci_Vbi_ei;
  double DIOY_Vs_ci_Vtnode_GND;
#endif
#endif
#if defined(_DYNAMIC)
double qr;
#if defined(_DERIVATEFORDDX)
double qr_Vtnode_GND;
double qr_Vbi_ci;
double qr_Vb_ci;
double qr_Vbi_ei;
double qr_Vci_ei;
#if defined(_DERIVATE2)
  double qr_Vci_ei_Vtnode_GND;
  double qr_Vci_ei_Vbi_ci;
  double qr_Vci_ei_Vb_ci;
  double qr_Vci_ei_Vbi_ei;
  double qr_Vci_ei_Vci_ei;
  double qr_Vb_ci_Vtnode_GND;
  double qr_Vb_ci_Vbi_ci;
  double qr_Vb_ci_Vb_ci;
  double qr_Vb_ci_Vbi_ei;
  double qr_Vb_ci_Vci_ei;
  double qr_Vbi_ci_Vtnode_GND;
  double qr_Vbi_ci_Vbi_ci;
  double qr_Vbi_ci_Vb_ci;
  double qr_Vbi_ci_Vbi_ei;
  double qr_Vbi_ci_Vci_ei;
#endif
#endif
#endif
double tf;
#if defined(_DERIVATE)
double tf_Vtnode_GND;
double tf_Vb_ci;
double tf_Vbi_ci;
double tf_Vci_ei;
double tf_Vbi_ei;
#endif
double qf;
#if defined(_DERIVATEFORDDX)
double qf_Vtnode_GND;
double qf_Vb_ci;
double qf_Vbi_ci;
double qf_Vbi_ei;
double qf_Vci_ei;
#if defined(_DERIVATE2)
  double qf_Vci_ei_Vtnode_GND;
  double qf_Vci_ei_Vb_ci;
  double qf_Vci_ei_Vbi_ci;
  double qf_Vci_ei_Vbi_ei;
  double qf_Vci_ei_Vci_ei;
  double qf_Vbi_ei_Vtnode_GND;
  double qf_Vbi_ei_Vb_ci;
  double qf_Vbi_ei_Vbi_ci;
  double qf_Vbi_ei_Vbi_ei;
  double qf_Vbi_ei_Vci_ei;
#endif
#endif
double dqef;
#if defined(_DERIVATEFORDDX)
double dqef_Vtnode_GND;
double dqef_Vbi_ei;
double dqef_Vb_ci;
double dqef_Vbi_ci;
double dqef_Vci_ei;
#if defined(_DERIVATE2)
  double dqef_Vci_ei_Vtnode_GND;
  double dqef_Vci_ei_Vbi_ei;
  double dqef_Vci_ei_Vb_ci;
  double dqef_Vci_ei_Vbi_ci;
  double dqef_Vci_ei_Vci_ei;
  double dqef_Vbi_ei_Vtnode_GND;
  double dqef_Vbi_ei_Vbi_ei;
  double dqef_Vbi_ei_Vb_ci;
  double dqef_Vbi_ei_Vbi_ci;
  double dqef_Vbi_ei_Vci_ei;
#endif
#endif
double dtef;
#if defined(_DERIVATEFORDDX)
double dtef_Vtnode_GND;
double dtef_Vbi_ei;
double dtef_Vb_ci;
double dtef_Vbi_ci;
double dtef_Vci_ei;
#if defined(_DERIVATE2)
  double dtef_Vci_ei_Vtnode_GND;
  double dtef_Vci_ei_Vbi_ei;
  double dtef_Vci_ei_Vb_ci;
  double dtef_Vci_ei_Vbi_ci;
  double dtef_Vci_ei_Vci_ei;
  double dtef_Vbi_ei_Vtnode_GND;
  double dtef_Vbi_ei_Vbi_ei;
  double dtef_Vbi_ei_Vb_ci;
  double dtef_Vbi_ei_Vbi_ci;
  double dtef_Vbi_ei_Vci_ei;
#endif
#endif
double dtfh;
#if defined(_DERIVATE)
double dtfh_Vtnode_GND;
double dtfh_Vci_ei;
double dtfh_Vbi_ei;
double dtfh_Vb_ci;
double dtfh_Vbi_ci;
#endif
double dqfh;
#if defined(_DERIVATEFORDDX)
double dqfh_Vtnode_GND;
double dqfh_Vci_ei;
double dqfh_Vbi_ei;
double dqfh_Vb_ci;
double dqfh_Vbi_ci;
#if defined(_DERIVATE2)
  double dqfh_Vbi_ei_Vtnode_GND;
  double dqfh_Vbi_ei_Vci_ei;
  double dqfh_Vbi_ei_Vbi_ei;
  double dqfh_Vbi_ei_Vb_ci;
  double dqfh_Vbi_ei_Vbi_ci;
  double dqfh_Vci_ei_Vtnode_GND;
  double dqfh_Vci_ei_Vci_ei;
  double dqfh_Vci_ei_Vbi_ei;
  double dqfh_Vci_ei_Vb_ci;
  double dqfh_Vci_ei_Vbi_ci;
#endif
#endif
double tww;
#if defined(_DERIVATEFORDDX)
double tww_Vtnode_GND;
double tww_Vci_ei;
double tww_Vbi_ei;
double tww_Vb_ci;
double tww_Vbi_ci;
#if defined(_DERIVATE2)
  double tww_Vbi_ei_Vtnode_GND;
  double tww_Vbi_ei_Vci_ei;
  double tww_Vbi_ei_Vbi_ei;
  double tww_Vbi_ei_Vb_ci;
  double tww_Vbi_ei_Vbi_ci;
  double tww_Vci_ei_Vtnode_GND;
  double tww_Vci_ei_Vci_ei;
  double tww_Vci_ei_Vbi_ei;
  double tww_Vci_ei_Vb_ci;
  double tww_Vci_ei_Vbi_ci;
#endif
#endif
double w;
#if defined(_DERIVATEFORDDX)
double w_Vci_ei;
double w_Vbi_ei;
double w_Vb_ci;
double w_Vbi_ci;
double w_Vtnode_GND;
#if defined(_DERIVATE2)
  double w_Vbi_ei_Vci_ei;
  double w_Vbi_ei_Vbi_ei;
  double w_Vbi_ei_Vb_ci;
  double w_Vbi_ei_Vbi_ci;
  double w_Vbi_ei_Vtnode_GND;
  double w_Vci_ei_Vci_ei;
  double w_Vci_ei_Vbi_ei;
  double w_Vci_ei_Vb_ci;
  double w_Vci_ei_Vbi_ci;
  double w_Vci_ei_Vtnode_GND;
#endif
#endif
double s3;
#if defined(_DERIVATEFORDDX)
double s3_Vci_ei;
double s3_Vbi_ei;
double s3_Vb_ci;
double s3_Vbi_ci;
double s3_Vtnode_GND;
#if defined(_DERIVATE2)
  double s3_Vbi_ei_Vci_ei;
  double s3_Vbi_ei_Vbi_ei;
  double s3_Vbi_ei_Vb_ci;
  double s3_Vbi_ei_Vbi_ci;
  double s3_Vbi_ei_Vtnode_GND;
  double s3_Vci_ei_Vci_ei;
  double s3_Vci_ei_Vbi_ei;
  double s3_Vci_ei_Vb_ci;
  double s3_Vci_ei_Vbi_ci;
  double s3_Vci_ei_Vtnode_GND;
#endif
#endif
double qf0;
#if defined(_DERIVATEFORDDX)
double qf0_Vtnode_GND;
double qf0_Vb_ci;
double qf0_Vbi_ci;
double qf0_Vbi_ei;
double qf0_Vci_ei;
#if defined(_DERIVATE2)
  double qf0_Vci_ei_Vtnode_GND;
  double qf0_Vci_ei_Vb_ci;
  double qf0_Vci_ei_Vbi_ci;
  double qf0_Vci_ei_Vbi_ei;
  double qf0_Vci_ei_Vci_ei;
  double qf0_Vbi_ei_Vtnode_GND;
  double qf0_Vbi_ei_Vb_ci;
  double qf0_Vbi_ei_Vbi_ci;
  double qf0_Vbi_ei_Vbi_ei;
  double qf0_Vbi_ei_Vci_ei;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double it_Vxf2_GND;
double it_Vtnode_GND;
double it_Vbi_ei;
double it_Vb_ci;
double it_Vbi_ci;
double it_Vci_ei;
#if defined(_DERIVATE2)
  double it_Vci_ei_Vxf2_GND;
  double it_Vci_ei_Vtnode_GND;
  double it_Vci_ei_Vbi_ei;
  double it_Vci_ei_Vb_ci;
  double it_Vci_ei_Vbi_ci;
  double it_Vci_ei_Vci_ei;
  double it_Vbi_ci_Vxf2_GND;
  double it_Vbi_ci_Vtnode_GND;
  double it_Vbi_ci_Vbi_ei;
  double it_Vbi_ci_Vb_ci;
  double it_Vbi_ci_Vbi_ci;
  double it_Vbi_ci_Vci_ei;
  double it_Vb_ci_Vxf2_GND;
  double it_Vb_ci_Vtnode_GND;
  double it_Vb_ci_Vbi_ei;
  double it_Vb_ci_Vb_ci;
  double it_Vb_ci_Vbi_ci;
  double it_Vb_ci_Vci_ei;
  double it_Vbi_ei_Vxf2_GND;
  double it_Vbi_ei_Vtnode_GND;
  double it_Vbi_ei_Vbi_ei;
  double it_Vbi_ei_Vb_ci;
  double it_Vbi_ei_Vbi_ci;
  double it_Vbi_ei_Vci_ei;
#endif
#endif
double itr;
#if defined(_DERIVATEFORDDX)
double itr_Vtnode_GND;
double itr_Vbi_ci;
double itr_Vb_ci;
double itr_Vbi_ei;
double itr_Vci_ei;
#if defined(_DERIVATE2)
  double itr_Vci_ei_Vtnode_GND;
  double itr_Vci_ei_Vbi_ci;
  double itr_Vci_ei_Vb_ci;
  double itr_Vci_ei_Vbi_ei;
  double itr_Vci_ei_Vci_ei;
  double itr_Vbi_ei_Vtnode_GND;
  double itr_Vbi_ei_Vbi_ci;
  double itr_Vbi_ei_Vb_ci;
  double itr_Vbi_ei_Vbi_ei;
  double itr_Vbi_ei_Vci_ei;
  double itr_Vb_ci_Vtnode_GND;
  double itr_Vb_ci_Vbi_ci;
  double itr_Vb_ci_Vb_ci;
  double itr_Vb_ci_Vbi_ei;
  double itr_Vb_ci_Vci_ei;
  double itr_Vbi_ci_Vtnode_GND;
  double itr_Vbi_ci_Vbi_ci;
  double itr_Vbi_ci_Vb_ci;
  double itr_Vbi_ci_Vbi_ei;
  double itr_Vbi_ci_Vci_ei;
#endif
#endif
double itf;
#if defined(_DERIVATEFORDDX)
double itf_Vtnode_GND;
double itf_Vbi_ei;
double itf_Vb_ci;
double itf_Vbi_ci;
double itf_Vci_ei;
#if defined(_DERIVATE2)
  double itf_Vci_ei_Vtnode_GND;
  double itf_Vci_ei_Vbi_ei;
  double itf_Vci_ei_Vb_ci;
  double itf_Vci_ei_Vbi_ci;
  double itf_Vci_ei_Vci_ei;
  double itf_Vbi_ci_Vtnode_GND;
  double itf_Vbi_ci_Vbi_ei;
  double itf_Vbi_ci_Vb_ci;
  double itf_Vbi_ci_Vbi_ci;
  double itf_Vbi_ci_Vci_ei;
  double itf_Vb_ci_Vtnode_GND;
  double itf_Vb_ci_Vbi_ei;
  double itf_Vb_ci_Vb_ci;
  double itf_Vb_ci_Vbi_ci;
  double itf_Vb_ci_Vci_ei;
  double itf_Vbi_ei_Vtnode_GND;
  double itf_Vbi_ei_Vbi_ei;
  double itf_Vbi_ei_Vb_ci;
  double itf_Vbi_ei_Vbi_ci;
  double itf_Vbi_ei_Vci_ei;
#endif
#endif
double p2_v;
#if defined(_DERIVATEFORDDX)
double p2_v_Vb_ci;
double p2_v_Vtnode_GND;
double p2_v_Vbi_ci;
double p2_v_Vbi_ei;
double p2_v_Vci_ei;
#if defined(_DERIVATE2)
  double p2_v_Vci_ei_Vb_ci;
  double p2_v_Vci_ei_Vtnode_GND;
  double p2_v_Vci_ei_Vbi_ci;
  double p2_v_Vci_ei_Vbi_ei;
  double p2_v_Vci_ei_Vci_ei;
  double p2_v_Vbi_ei_Vb_ci;
  double p2_v_Vbi_ei_Vtnode_GND;
  double p2_v_Vbi_ei_Vbi_ci;
  double p2_v_Vbi_ei_Vbi_ei;
  double p2_v_Vbi_ei_Vci_ei;
  double p2_v_Vbi_ci_Vb_ci;
  double p2_v_Vbi_ci_Vtnode_GND;
  double p2_v_Vbi_ci_Vbi_ci;
  double p2_v_Vbi_ci_Vbi_ei;
  double p2_v_Vbi_ci_Vci_ei;
  double p2_v_Vb_ci_Vb_ci;
  double p2_v_Vb_ci_Vtnode_GND;
  double p2_v_Vb_ci_Vbi_ci;
  double p2_v_Vb_ci_Vbi_ei;
  double p2_v_Vb_ci_Vci_ei;
#endif
#endif
double p2_u;
#if defined(_DERIVATEFORDDX)
double p2_u_Vb_ci;
double p2_u_Vtnode_GND;
double p2_u_Vbi_ci;
double p2_u_Vbi_ei;
double p2_u_Vci_ei;
#if defined(_DERIVATE2)
  double p2_u_Vci_ei_Vb_ci;
  double p2_u_Vci_ei_Vtnode_GND;
  double p2_u_Vci_ei_Vbi_ci;
  double p2_u_Vci_ei_Vbi_ei;
  double p2_u_Vci_ei_Vci_ei;
  double p2_u_Vbi_ei_Vb_ci;
  double p2_u_Vbi_ei_Vtnode_GND;
  double p2_u_Vbi_ei_Vbi_ci;
  double p2_u_Vbi_ei_Vbi_ei;
  double p2_u_Vbi_ei_Vci_ei;
  double p2_u_Vbi_ci_Vb_ci;
  double p2_u_Vbi_ci_Vtnode_GND;
  double p2_u_Vbi_ci_Vbi_ci;
  double p2_u_Vbi_ci_Vbi_ei;
  double p2_u_Vbi_ci_Vci_ei;
  double p2_u_Vb_ci_Vb_ci;
  double p2_u_Vb_ci_Vtnode_GND;
  double p2_u_Vb_ci_Vbi_ci;
  double p2_u_Vb_ci_Vbi_ei;
  double p2_u_Vb_ci_Vci_ei;
#endif
#endif
double tmp3;
#if defined(_DERIVATEFORDDX)
double tmp3_Vb_ci;
double tmp3_Vtnode_GND;
double tmp3_Vbi_ci;
double tmp3_Vbi_ei;
double tmp3_Vci_ei;
#if defined(_DERIVATE2)
  double tmp3_Vci_ei_Vb_ci;
  double tmp3_Vci_ei_Vtnode_GND;
  double tmp3_Vci_ei_Vbi_ci;
  double tmp3_Vci_ei_Vbi_ei;
  double tmp3_Vci_ei_Vci_ei;
  double tmp3_Vbi_ei_Vb_ci;
  double tmp3_Vbi_ei_Vtnode_GND;
  double tmp3_Vbi_ei_Vbi_ci;
  double tmp3_Vbi_ei_Vbi_ei;
  double tmp3_Vbi_ei_Vci_ei;
  double tmp3_Vbi_ci_Vb_ci;
  double tmp3_Vbi_ci_Vtnode_GND;
  double tmp3_Vbi_ci_Vbi_ci;
  double tmp3_Vbi_ci_Vbi_ei;
  double tmp3_Vbi_ci_Vci_ei;
  double tmp3_Vb_ci_Vb_ci;
  double tmp3_Vb_ci_Vtnode_GND;
  double tmp3_Vb_ci_Vbi_ci;
  double tmp3_Vb_ci_Vbi_ei;
  double tmp3_Vb_ci_Vci_ei;
#endif
#endif
double tmp2;
#if defined(_DERIVATEFORDDX)
double tmp2_Vb_ci;
double tmp2_Vtnode_GND;
double tmp2_Vbi_ci;
double tmp2_Vbi_ei;
double tmp2_Vci_ei;
#if defined(_DERIVATE2)
  double tmp2_Vci_ei_Vb_ci;
  double tmp2_Vci_ei_Vtnode_GND;
  double tmp2_Vci_ei_Vbi_ci;
  double tmp2_Vci_ei_Vbi_ei;
  double tmp2_Vci_ei_Vci_ei;
  double tmp2_Vbi_ei_Vb_ci;
  double tmp2_Vbi_ei_Vtnode_GND;
  double tmp2_Vbi_ei_Vbi_ci;
  double tmp2_Vbi_ei_Vbi_ei;
  double tmp2_Vbi_ei_Vci_ei;
  double tmp2_Vbi_ci_Vb_ci;
  double tmp2_Vbi_ci_Vtnode_GND;
  double tmp2_Vbi_ci_Vbi_ci;
  double tmp2_Vbi_ci_Vbi_ei;
  double tmp2_Vbi_ci_Vci_ei;
  double tmp2_Vb_ci_Vb_ci;
  double tmp2_Vb_ci_Vtnode_GND;
  double tmp2_Vb_ci_Vbi_ci;
  double tmp2_Vb_ci_Vbi_ei;
  double tmp2_Vb_ci_Vci_ei;
#endif
#endif
double q_p3;
#if defined(_DERIVATEFORDDX)
double q_p3_Vb_ci;
double q_p3_Vtnode_GND;
double q_p3_Vbi_ci;
double q_p3_Vbi_ei;
double q_p3_Vci_ei;
#if defined(_DERIVATE2)
  double q_p3_Vci_ei_Vb_ci;
  double q_p3_Vci_ei_Vtnode_GND;
  double q_p3_Vci_ei_Vbi_ci;
  double q_p3_Vci_ei_Vbi_ei;
  double q_p3_Vci_ei_Vci_ei;
  double q_p3_Vbi_ei_Vb_ci;
  double q_p3_Vbi_ei_Vtnode_GND;
  double q_p3_Vbi_ei_Vbi_ci;
  double q_p3_Vbi_ei_Vbi_ei;
  double q_p3_Vbi_ei_Vci_ei;
  double q_p3_Vbi_ci_Vb_ci;
  double q_p3_Vbi_ci_Vtnode_GND;
  double q_p3_Vbi_ci_Vbi_ci;
  double q_p3_Vbi_ci_Vbi_ei;
  double q_p3_Vbi_ci_Vci_ei;
  double q_p3_Vb_ci_Vb_ci;
  double q_p3_Vb_ci_Vtnode_GND;
  double q_p3_Vb_ci_Vbi_ci;
  double q_p3_Vb_ci_Vbi_ei;
  double q_p3_Vb_ci_Vci_ei;
#endif
#endif
double p2_D;
#if defined(_DERIVATEFORDDX)
double p2_D_Vb_ci;
double p2_D_Vtnode_GND;
double p2_D_Vbi_ci;
double p2_D_Vbi_ei;
double p2_D_Vci_ei;
#if defined(_DERIVATE2)
  double p2_D_Vci_ei_Vb_ci;
  double p2_D_Vci_ei_Vtnode_GND;
  double p2_D_Vci_ei_Vbi_ci;
  double p2_D_Vci_ei_Vbi_ei;
  double p2_D_Vci_ei_Vci_ei;
  double p2_D_Vbi_ei_Vb_ci;
  double p2_D_Vbi_ei_Vtnode_GND;
  double p2_D_Vbi_ei_Vbi_ci;
  double p2_D_Vbi_ei_Vbi_ei;
  double p2_D_Vbi_ei_Vci_ei;
  double p2_D_Vbi_ci_Vb_ci;
  double p2_D_Vbi_ci_Vtnode_GND;
  double p2_D_Vbi_ci_Vbi_ci;
  double p2_D_Vbi_ci_Vbi_ei;
  double p2_D_Vbi_ci_Vci_ei;
  double p2_D_Vb_ci_Vb_ci;
  double p2_D_Vb_ci_Vtnode_GND;
  double p2_D_Vb_ci_Vbi_ci;
  double p2_D_Vb_ci_Vbi_ei;
  double p2_D_Vb_ci_Vci_ei;
#endif
#endif
double p2_q;
#if defined(_DERIVATEFORDDX)
double p2_q_Vb_ci;
double p2_q_Vtnode_GND;
double p2_q_Vbi_ci;
double p2_q_Vbi_ei;
double p2_q_Vci_ei;
#if defined(_DERIVATE2)
  double p2_q_Vci_ei_Vb_ci;
  double p2_q_Vci_ei_Vtnode_GND;
  double p2_q_Vci_ei_Vbi_ci;
  double p2_q_Vci_ei_Vbi_ei;
  double p2_q_Vci_ei_Vci_ei;
  double p2_q_Vbi_ei_Vb_ci;
  double p2_q_Vbi_ei_Vtnode_GND;
  double p2_q_Vbi_ei_Vbi_ci;
  double p2_q_Vbi_ei_Vbi_ei;
  double p2_q_Vbi_ei_Vci_ei;
  double p2_q_Vbi_ci_Vb_ci;
  double p2_q_Vbi_ci_Vtnode_GND;
  double p2_q_Vbi_ci_Vbi_ci;
  double p2_q_Vbi_ci_Vbi_ei;
  double p2_q_Vbi_ci_Vci_ei;
  double p2_q_Vb_ci_Vb_ci;
  double p2_q_Vb_ci_Vtnode_GND;
  double p2_q_Vb_ci_Vbi_ci;
  double p2_q_Vb_ci_Vbi_ei;
  double p2_q_Vb_ci_Vci_ei;
#endif
#endif
double p2_p;
#if defined(_DERIVATEFORDDX)
double p2_p_Vtnode_GND;
double p2_p_Vbi_ei;
double p2_p_Vb_ci;
double p2_p_Vbi_ci;
double p2_p_Vci_ei;
#if defined(_DERIVATE2)
  double p2_p_Vci_ei_Vtnode_GND;
  double p2_p_Vci_ei_Vbi_ei;
  double p2_p_Vci_ei_Vb_ci;
  double p2_p_Vci_ei_Vbi_ci;
  double p2_p_Vci_ei_Vci_ei;
  double p2_p_Vbi_ci_Vtnode_GND;
  double p2_p_Vbi_ci_Vbi_ei;
  double p2_p_Vbi_ci_Vb_ci;
  double p2_p_Vbi_ci_Vbi_ci;
  double p2_p_Vbi_ci_Vci_ei;
  double p2_p_Vb_ci_Vtnode_GND;
  double p2_p_Vb_ci_Vbi_ei;
  double p2_p_Vb_ci_Vb_ci;
  double p2_p_Vb_ci_Vbi_ci;
  double p2_p_Vb_ci_Vci_ei;
  double p2_p_Vbi_ei_Vtnode_GND;
  double p2_p_Vbi_ei_Vbi_ei;
  double p2_p_Vbi_ei_Vb_ci;
  double p2_p_Vbi_ei_Vbi_ci;
  double p2_p_Vbi_ei_Vci_ei;
#endif
#endif
double tmp;
#if defined(_DERIVATEFORDDX)
double tmp_Vb_ci;
double tmp_Vtnode_GND;
double tmp_Vbi_ci;
double tmp_Vbi_ei;
double tmp_Vci_ei;
#if defined(_DERIVATE2)
  double tmp_Vci_ei_Vb_ci;
  double tmp_Vci_ei_Vtnode_GND;
  double tmp_Vci_ei_Vbi_ci;
  double tmp_Vci_ei_Vbi_ei;
  double tmp_Vci_ei_Vci_ei;
  double tmp_Vbi_ei_Vb_ci;
  double tmp_Vbi_ei_Vtnode_GND;
  double tmp_Vbi_ei_Vbi_ci;
  double tmp_Vbi_ei_Vbi_ei;
  double tmp_Vbi_ei_Vci_ei;
  double tmp_Vbi_ci_Vb_ci;
  double tmp_Vbi_ci_Vtnode_GND;
  double tmp_Vbi_ci_Vbi_ci;
  double tmp_Vbi_ci_Vbi_ei;
  double tmp_Vbi_ci_Vci_ei;
  double tmp_Vb_ci_Vb_ci;
  double tmp_Vb_ci_Vtnode_GND;
  double tmp_Vb_ci_Vbi_ci;
  double tmp_Vb_ci_Vbi_ei;
  double tmp_Vb_ci_Vci_ei;
#endif
#endif
double p2_c;
#if defined(_DERIVATEFORDDX)
double p2_c_Vtnode_GND;
double p2_c_Vbi_ei;
double p2_c_Vci_ei;
#if defined(_DERIVATE2)
  double p2_c_Vci_ei_Vtnode_GND;
  double p2_c_Vci_ei_Vbi_ei;
  double p2_c_Vci_ei_Vci_ei;
  double p2_c_Vbi_ei_Vtnode_GND;
  double p2_c_Vbi_ei_Vbi_ei;
  double p2_c_Vbi_ei_Vci_ei;
#endif
#endif
double p2_b;
#if defined(_DERIVATEFORDDX)
double p2_b_Vtnode_GND;
double p2_b_Vbi_ei;
double p2_b_Vb_ci;
double p2_b_Vbi_ci;
double p2_b_Vci_ei;
#if defined(_DERIVATE2)
  double p2_b_Vci_ei_Vtnode_GND;
  double p2_b_Vci_ei_Vbi_ei;
  double p2_b_Vci_ei_Vb_ci;
  double p2_b_Vci_ei_Vbi_ci;
  double p2_b_Vci_ei_Vci_ei;
  double p2_b_Vbi_ci_Vtnode_GND;
  double p2_b_Vbi_ci_Vbi_ei;
  double p2_b_Vbi_ci_Vb_ci;
  double p2_b_Vbi_ci_Vbi_ci;
  double p2_b_Vbi_ci_Vci_ei;
  double p2_b_Vb_ci_Vtnode_GND;
  double p2_b_Vb_ci_Vbi_ei;
  double p2_b_Vb_ci_Vb_ci;
  double p2_b_Vb_ci_Vbi_ci;
  double p2_b_Vb_ci_Vci_ei;
  double p2_b_Vbi_ei_Vtnode_GND;
  double p2_b_Vbi_ei_Vbi_ei;
  double p2_b_Vbi_ei_Vb_ci;
  double p2_b_Vbi_ei_Vbi_ci;
  double p2_b_Vbi_ei_Vci_ei;
#endif
#endif
double p2_a;
#if defined(_DERIVATEFORDDX)
double p2_a_Vb_ci;
double p2_a_Vtnode_GND;
double p2_a_Vbi_ci;
double p2_a_Vbi_ei;
double p2_a_Vci_ei;
#if defined(_DERIVATE2)
  double p2_a_Vci_ei_Vb_ci;
  double p2_a_Vci_ei_Vtnode_GND;
  double p2_a_Vci_ei_Vbi_ci;
  double p2_a_Vci_ei_Vbi_ei;
  double p2_a_Vci_ei_Vci_ei;
  double p2_a_Vbi_ei_Vb_ci;
  double p2_a_Vbi_ei_Vtnode_GND;
  double p2_a_Vbi_ei_Vbi_ci;
  double p2_a_Vbi_ei_Vbi_ei;
  double p2_a_Vbi_ei_Vci_ei;
  double p2_a_Vbi_ci_Vb_ci;
  double p2_a_Vbi_ci_Vtnode_GND;
  double p2_a_Vbi_ci_Vbi_ci;
  double p2_a_Vbi_ci_Vbi_ei;
  double p2_a_Vbi_ci_Vci_ei;
  double p2_a_Vb_ci_Vb_ci;
  double p2_a_Vb_ci_Vtnode_GND;
  double p2_a_Vb_ci_Vbi_ci;
  double p2_a_Vb_ci_Vbi_ei;
  double p2_a_Vb_ci_Vci_ei;
#endif
#endif
double o3;
double qpt;
#if defined(_DERIVATEFORDDX)
double qpt_Vb_ci;
double qpt_Vtnode_GND;
double qpt_Vbi_ci;
double qpt_Vbi_ei;
double qpt_Vci_ei;
#if defined(_DERIVATE2)
  double qpt_Vci_ei_Vb_ci;
  double qpt_Vci_ei_Vtnode_GND;
  double qpt_Vci_ei_Vbi_ci;
  double qpt_Vci_ei_Vbi_ei;
  double qpt_Vci_ei_Vci_ei;
  double qpt_Vbi_ei_Vb_ci;
  double qpt_Vbi_ei_Vtnode_GND;
  double qpt_Vbi_ei_Vbi_ci;
  double qpt_Vbi_ei_Vbi_ei;
  double qpt_Vbi_ei_Vci_ei;
  double qpt_Vbi_ci_Vb_ci;
  double qpt_Vbi_ci_Vtnode_GND;
  double qpt_Vbi_ci_Vbi_ci;
  double qpt_Vbi_ci_Vbi_ei;
  double qpt_Vbi_ci_Vci_ei;
  double qpt_Vb_ci_Vb_ci;
  double qpt_Vb_ci_Vtnode_GND;
  double qpt_Vb_ci_Vbi_ci;
  double qpt_Vb_ci_Vbi_ei;
  double qpt_Vb_ci_Vci_ei;
#endif
#endif
double qm;
#if defined(_DERIVATEFORDDX)
double qm_Vtnode_GND;
double qm_Vbi_ei;
double qm_Vb_ci;
double qm_Vbi_ci;
double qm_Vci_ei;
#if defined(_DERIVATE2)
  double qm_Vci_ei_Vtnode_GND;
  double qm_Vci_ei_Vbi_ei;
  double qm_Vci_ei_Vb_ci;
  double qm_Vci_ei_Vbi_ci;
  double qm_Vci_ei_Vci_ei;
  double qm_Vbi_ci_Vtnode_GND;
  double qm_Vbi_ci_Vbi_ei;
  double qm_Vbi_ci_Vb_ci;
  double qm_Vbi_ci_Vbi_ci;
  double qm_Vbi_ci_Vci_ei;
  double qm_Vb_ci_Vtnode_GND;
  double qm_Vb_ci_Vbi_ei;
  double qm_Vb_ci_Vb_ci;
  double qm_Vb_ci_Vbi_ci;
  double qm_Vb_ci_Vci_ei;
  double qm_Vbi_ei_Vtnode_GND;
  double qm_Vbi_ei_Vbi_ei;
  double qm_Vbi_ei_Vb_ci;
  double qm_Vbi_ei_Vbi_ci;
  double qm_Vbi_ei_Vci_ei;
#endif
#endif
double wdc;
#if defined(_DERIVATEFORDDX)
double wdc_Vtnode_GND;
double wdc_Vci_ei;
double wdc_Vbi_ei;
double wdc_Vb_ci;
double wdc_Vbi_ci;
#if defined(_DERIVATE2)
  double wdc_Vbi_ci_Vtnode_GND;
  double wdc_Vbi_ci_Vci_ei;
  double wdc_Vbi_ci_Vbi_ei;
  double wdc_Vbi_ci_Vb_ci;
  double wdc_Vbi_ci_Vbi_ci;
  double wdc_Vb_ci_Vtnode_GND;
  double wdc_Vb_ci_Vci_ei;
  double wdc_Vb_ci_Vbi_ei;
  double wdc_Vb_ci_Vb_ci;
  double wdc_Vb_ci_Vbi_ci;
  double wdc_Vbi_ei_Vtnode_GND;
  double wdc_Vbi_ei_Vci_ei;
  double wdc_Vbi_ei_Vbi_ei;
  double wdc_Vbi_ei_Vb_ci;
  double wdc_Vbi_ei_Vbi_ci;
  double wdc_Vci_ei_Vtnode_GND;
  double wdc_Vci_ei_Vci_ei;
  double wdc_Vci_ei_Vbi_ei;
  double wdc_Vci_ei_Vb_ci;
  double wdc_Vci_ei_Vbi_ci;
#endif
#endif
double aa;
#if defined(_DERIVATEFORDDX)
double aa_Vtnode_GND;
double aa_Vci_ei;
double aa_Vbi_ei;
double aa_Vb_ci;
double aa_Vbi_ci;
#if defined(_DERIVATE2)
  double aa_Vbi_ci_Vtnode_GND;
  double aa_Vbi_ci_Vci_ei;
  double aa_Vbi_ci_Vbi_ei;
  double aa_Vbi_ci_Vb_ci;
  double aa_Vbi_ci_Vbi_ci;
  double aa_Vb_ci_Vtnode_GND;
  double aa_Vb_ci_Vci_ei;
  double aa_Vb_ci_Vbi_ei;
  double aa_Vb_ci_Vb_ci;
  double aa_Vb_ci_Vbi_ci;
  double aa_Vbi_ei_Vtnode_GND;
  double aa_Vbi_ei_Vci_ei;
  double aa_Vbi_ei_Vbi_ei;
  double aa_Vbi_ei_Vb_ci;
  double aa_Vbi_ei_Vbi_ci;
  double aa_Vci_ei_Vtnode_GND;
  double aa_Vci_ei_Vci_ei;
  double aa_Vci_ei_Vbi_ei;
  double aa_Vci_ei_Vb_ci;
  double aa_Vci_ei_Vbi_ci;
#endif
#endif
double a2;
#if defined(_DERIVATEFORDDX)
double a2_Vtnode_GND;
double a2_Vci_ei;
double a2_Vbi_ei;
double a2_Vb_ci;
double a2_Vbi_ci;
#if defined(_DERIVATE2)
  double a2_Vbi_ci_Vtnode_GND;
  double a2_Vbi_ci_Vci_ei;
  double a2_Vbi_ci_Vbi_ei;
  double a2_Vbi_ci_Vb_ci;
  double a2_Vbi_ci_Vbi_ci;
  double a2_Vb_ci_Vtnode_GND;
  double a2_Vb_ci_Vci_ei;
  double a2_Vb_ci_Vbi_ei;
  double a2_Vb_ci_Vb_ci;
  double a2_Vb_ci_Vbi_ci;
  double a2_Vbi_ei_Vtnode_GND;
  double a2_Vbi_ei_Vci_ei;
  double a2_Vbi_ei_Vbi_ei;
  double a2_Vbi_ei_Vb_ci;
  double a2_Vbi_ei_Vbi_ci;
  double a2_Vci_ei_Vtnode_GND;
  double a2_Vci_ei_Vci_ei;
  double a2_Vci_ei_Vbi_ei;
  double a2_Vci_ei_Vb_ci;
  double a2_Vci_ei_Vbi_ci;
#endif
#endif
double a1;
#if defined(_DERIVATEFORDDX)
double a1_Vtnode_GND;
double a1_Vci_ei;
double a1_Vbi_ei;
double a1_Vb_ci;
double a1_Vbi_ci;
#if defined(_DERIVATE2)
  double a1_Vbi_ci_Vtnode_GND;
  double a1_Vbi_ci_Vci_ei;
  double a1_Vbi_ci_Vbi_ei;
  double a1_Vbi_ci_Vb_ci;
  double a1_Vbi_ci_Vbi_ci;
  double a1_Vb_ci_Vtnode_GND;
  double a1_Vb_ci_Vci_ei;
  double a1_Vb_ci_Vbi_ei;
  double a1_Vb_ci_Vb_ci;
  double a1_Vb_ci_Vbi_ci;
  double a1_Vbi_ei_Vtnode_GND;
  double a1_Vbi_ei_Vci_ei;
  double a1_Vbi_ei_Vbi_ei;
  double a1_Vbi_ei_Vb_ci;
  double a1_Vbi_ei_Vbi_ci;
  double a1_Vci_ei_Vtnode_GND;
  double a1_Vci_ei_Vci_ei;
  double a1_Vci_ei_Vbi_ei;
  double a1_Vci_ei_Vb_ci;
  double a1_Vci_ei_Vbi_ci;
#endif
#endif
double diff_q;
#if defined(_DERIVATE)
double diff_q_Vtnode_GND;
double diff_q_Vbi_ei;
double diff_q_Vb_ci;
double diff_q_Vbi_ci;
double diff_q_Vci_ei;
#endif
double qpt_h;
#if defined(_DERIVATEFORDDX)
double qpt_h_Vb_ci;
double qpt_h_Vtnode_GND;
double qpt_h_Vbi_ci;
double qpt_h_Vbi_ei;
double qpt_h_Vci_ei;
#if defined(_DERIVATE2)
  double qpt_h_Vci_ei_Vb_ci;
  double qpt_h_Vci_ei_Vtnode_GND;
  double qpt_h_Vci_ei_Vbi_ci;
  double qpt_h_Vci_ei_Vbi_ei;
  double qpt_h_Vci_ei_Vci_ei;
  double qpt_h_Vbi_ei_Vb_ci;
  double qpt_h_Vbi_ei_Vtnode_GND;
  double qpt_h_Vbi_ei_Vbi_ci;
  double qpt_h_Vbi_ei_Vbi_ei;
  double qpt_h_Vbi_ei_Vci_ei;
  double qpt_h_Vbi_ci_Vb_ci;
  double qpt_h_Vbi_ci_Vtnode_GND;
  double qpt_h_Vbi_ci_Vbi_ci;
  double qpt_h_Vbi_ci_Vbi_ei;
  double qpt_h_Vbi_ci_Vci_ei;
  double qpt_h_Vb_ci_Vb_ci;
  double qpt_h_Vb_ci_Vtnode_GND;
  double qpt_h_Vb_ci_Vbi_ci;
  double qpt_h_Vb_ci_Vbi_ei;
  double qpt_h_Vb_ci_Vci_ei;
#endif
#endif
double qpt_l;
#if defined(_DERIVATEFORDDX)
double qpt_l_Vb_ci;
double qpt_l_Vtnode_GND;
double qpt_l_Vbi_ci;
double qpt_l_Vbi_ei;
double qpt_l_Vci_ei;
#if defined(_DERIVATE2)
  double qpt_l_Vci_ei_Vb_ci;
  double qpt_l_Vci_ei_Vtnode_GND;
  double qpt_l_Vci_ei_Vbi_ci;
  double qpt_l_Vci_ei_Vbi_ei;
  double qpt_l_Vci_ei_Vci_ei;
  double qpt_l_Vbi_ei_Vb_ci;
  double qpt_l_Vbi_ei_Vtnode_GND;
  double qpt_l_Vbi_ei_Vbi_ci;
  double qpt_l_Vbi_ei_Vbi_ei;
  double qpt_l_Vbi_ei_Vci_ei;
  double qpt_l_Vbi_ci_Vb_ci;
  double qpt_l_Vbi_ci_Vtnode_GND;
  double qpt_l_Vbi_ci_Vbi_ci;
  double qpt_l_Vbi_ci_Vbi_ei;
  double qpt_l_Vbi_ci_Vci_ei;
  double qpt_l_Vb_ci_Vb_ci;
  double qpt_l_Vb_ci_Vtnode_GND;
  double qpt_l_Vb_ci_Vbi_ci;
  double qpt_l_Vb_ci_Vbi_ei;
  double qpt_l_Vb_ci_Vci_ei;
#endif
#endif
double qmh;
#if defined(_DERIVATEFORDDX)
double qmh_Vtnode_GND;
double qmh_Vbi_ei;
double qmh_Vb_ci;
double qmh_Vbi_ci;
double qmh_Vci_ei;
#if defined(_DERIVATE2)
  double qmh_Vci_ei_Vtnode_GND;
  double qmh_Vci_ei_Vbi_ei;
  double qmh_Vci_ei_Vb_ci;
  double qmh_Vci_ei_Vbi_ci;
  double qmh_Vci_ei_Vci_ei;
  double qmh_Vbi_ci_Vtnode_GND;
  double qmh_Vbi_ci_Vbi_ei;
  double qmh_Vbi_ci_Vb_ci;
  double qmh_Vbi_ci_Vbi_ci;
  double qmh_Vbi_ci_Vci_ei;
  double qmh_Vb_ci_Vtnode_GND;
  double qmh_Vb_ci_Vbi_ei;
  double qmh_Vb_ci_Vb_ci;
  double qmh_Vb_ci_Vbi_ci;
  double qmh_Vb_ci_Vci_ei;
  double qmh_Vbi_ei_Vtnode_GND;
  double qmh_Vbi_ei_Vbi_ei;
  double qmh_Vbi_ei_Vb_ci;
  double qmh_Vbi_ei_Vbi_ci;
  double qmh_Vbi_ei_Vci_ei;
#endif
#endif
double qml;
#if defined(_DERIVATEFORDDX)
double qml_Vtnode_GND;
double qml_Vbi_ei;
double qml_Vb_ci;
double qml_Vbi_ci;
double qml_Vci_ei;
#if defined(_DERIVATE2)
  double qml_Vci_ei_Vtnode_GND;
  double qml_Vci_ei_Vbi_ei;
  double qml_Vci_ei_Vb_ci;
  double qml_Vci_ei_Vbi_ci;
  double qml_Vci_ei_Vci_ei;
  double qml_Vbi_ci_Vtnode_GND;
  double qml_Vbi_ci_Vbi_ei;
  double qml_Vbi_ci_Vb_ci;
  double qml_Vbi_ci_Vbi_ci;
  double qml_Vbi_ci_Vci_ei;
  double qml_Vb_ci_Vtnode_GND;
  double qml_Vb_ci_Vbi_ei;
  double qml_Vb_ci_Vb_ci;
  double qml_Vb_ci_Vbi_ci;
  double qml_Vb_ci_Vci_ei;
  double qml_Vbi_ei_Vtnode_GND;
  double qml_Vbi_ei_Vbi_ei;
  double qml_Vbi_ei_Vb_ci;
  double qml_Vbi_ei_Vbi_ci;
  double qml_Vbi_ei_Vci_ei;
#endif
#endif
double itri;
#if defined(_DERIVATEFORDDX)
double itri_Vtnode_GND;
double itri_Vbi_ci;
#if defined(_DERIVATE2)
  double itri_Vbi_ci_Vtnode_GND;
  double itri_Vbi_ci_Vbi_ci;
#endif
#endif
double le2;
#if defined(_DERIVATEFORDDX)
double le2_Vbi_ci;
double le2_Vtnode_GND;
#if defined(_DERIVATE2)
  double le2_Vbi_ci_Vbi_ci;
  double le2_Vbi_ci_Vtnode_GND;
#endif
#endif
double arg2;
#if defined(_DERIVATEFORDDX)
double arg2_Vbi_ci;
double arg2_Vtnode_GND;
#if defined(_DERIVATE2)
  double arg2_Vbi_ci_Vbi_ci;
  double arg2_Vbi_ci_Vtnode_GND;
#endif
#endif
double itfi;
#if defined(_DERIVATEFORDDX)
double itfi_Vtnode_GND;
double itfi_Vbi_ei;
#if defined(_DERIVATE2)
  double itfi_Vbi_ei_Vtnode_GND;
  double itfi_Vbi_ei_Vbi_ei;
#endif
#endif
double le1;
#if defined(_DERIVATEFORDDX)
double le1_Vbi_ei;
double le1_Vtnode_GND;
#if defined(_DERIVATE2)
  double le1_Vbi_ei_Vbi_ei;
  double le1_Vbi_ei_Vtnode_GND;
#endif
#endif
double arg1;
#if defined(_DERIVATEFORDDX)
double arg1_Vbi_ei;
double arg1_Vtnode_GND;
#if defined(_DERIVATE2)
  double arg1_Vbi_ei_Vbi_ei;
  double arg1_Vbi_ei_Vtnode_GND;
#endif
#endif
double ickr;
double ickf;
#if defined(_DERIVATEFORDDX)
double ickf_Vtnode_GND;
double ickf_Vb_ci;
double ickf_Vbi_ci;
#if defined(_DERIVATE2)
  double ickf_Vbi_ci_Vtnode_GND;
  double ickf_Vbi_ci_Vb_ci;
  double ickf_Vbi_ci_Vbi_ci;
  double ickf_Vb_ci_Vtnode_GND;
  double ickf_Vb_ci_Vb_ci;
  double ickf_Vb_ci_Vbi_ci;
#endif
#endif
double denom_iqf;
#if defined(_DERIVATEFORDDX)
double denom_iqf_Vtnode_GND;
double denom_iqf_Vb_ci;
double denom_iqf_Vbi_ci;
#if defined(_DERIVATE2)
  double denom_iqf_Vbi_ci_Vtnode_GND;
  double denom_iqf_Vbi_ci_Vb_ci;
  double denom_iqf_Vbi_ci_Vbi_ci;
  double denom_iqf_Vb_ci_Vtnode_GND;
  double denom_iqf_Vb_ci_Vb_ci;
  double denom_iqf_Vb_ci_Vbi_ci;
#endif
#endif
double tf0;
#if defined(_DERIVATEFORDDX)
double tf0_Vtnode_GND;
double tf0_Vb_ci;
double tf0_Vbi_ci;
#if defined(_DERIVATE2)
  double tf0_Vbi_ci_Vtnode_GND;
  double tf0_Vbi_ci_Vb_ci;
  double tf0_Vbi_ci_Vbi_ci;
  double tf0_Vb_ci_Vtnode_GND;
  double tf0_Vb_ci_Vb_ci;
  double tf0_Vb_ci_Vbi_ci;
#endif
#endif
double qj_2;
#if defined(_DERIVATEFORDDX)
double qj_2_Vb_ci;
double qj_2_Vtnode_GND;
double qj_2_Vbi_ci;
double qj_2_Vbi_ei;
double qj_2_Vci_ei;
#if defined(_DERIVATE2)
  double qj_2_Vci_ei_Vb_ci;
  double qj_2_Vci_ei_Vtnode_GND;
  double qj_2_Vci_ei_Vbi_ci;
  double qj_2_Vci_ei_Vbi_ei;
  double qj_2_Vci_ei_Vci_ei;
  double qj_2_Vbi_ei_Vb_ci;
  double qj_2_Vbi_ei_Vtnode_GND;
  double qj_2_Vbi_ei_Vbi_ci;
  double qj_2_Vbi_ei_Vbi_ei;
  double qj_2_Vbi_ei_Vci_ei;
  double qj_2_Vbi_ci_Vb_ci;
  double qj_2_Vbi_ci_Vtnode_GND;
  double qj_2_Vbi_ci_Vbi_ci;
  double qj_2_Vbi_ci_Vbi_ei;
  double qj_2_Vbi_ci_Vci_ei;
  double qj_2_Vb_ci_Vb_ci;
  double qj_2_Vb_ci_Vtnode_GND;
  double qj_2_Vb_ci_Vbi_ci;
  double qj_2_Vb_ci_Vbi_ei;
  double qj_2_Vb_ci_Vci_ei;
#endif
#endif
double b_q;
#if defined(_DERIVATEFORDDX)
double b_q_Vb_ci;
double b_q_Vtnode_GND;
double b_q_Vbi_ci;
double b_q_Vbi_ei;
double b_q_Vci_ei;
#if defined(_DERIVATE2)
  double b_q_Vci_ei_Vb_ci;
  double b_q_Vci_ei_Vtnode_GND;
  double b_q_Vci_ei_Vbi_ci;
  double b_q_Vci_ei_Vbi_ei;
  double b_q_Vci_ei_Vci_ei;
  double b_q_Vbi_ei_Vb_ci;
  double b_q_Vbi_ei_Vtnode_GND;
  double b_q_Vbi_ei_Vbi_ci;
  double b_q_Vbi_ei_Vbi_ei;
  double b_q_Vbi_ei_Vci_ei;
  double b_q_Vbi_ci_Vb_ci;
  double b_q_Vbi_ci_Vtnode_GND;
  double b_q_Vbi_ci_Vbi_ci;
  double b_q_Vbi_ci_Vbi_ei;
  double b_q_Vbi_ci_Vci_ei;
  double b_q_Vb_ci_Vb_ci;
  double b_q_Vb_ci_Vtnode_GND;
  double b_q_Vb_ci_Vbi_ci;
  double b_q_Vb_ci_Vbi_ei;
  double b_q_Vb_ci_Vci_ei;
#endif
#endif
double qj;
#if defined(_DERIVATEFORDDX)
double qj_Vb_ci;
double qj_Vtnode_GND;
double qj_Vbi_ci;
double qj_Vbi_ei;
double qj_Vci_ei;
#if defined(_DERIVATE2)
  double qj_Vci_ei_Vb_ci;
  double qj_Vci_ei_Vtnode_GND;
  double qj_Vci_ei_Vbi_ci;
  double qj_Vci_ei_Vbi_ei;
  double qj_Vci_ei_Vci_ei;
  double qj_Vbi_ei_Vb_ci;
  double qj_Vbi_ei_Vtnode_GND;
  double qj_Vbi_ei_Vbi_ci;
  double qj_Vbi_ei_Vbi_ei;
  double qj_Vbi_ei_Vci_ei;
  double qj_Vbi_ci_Vb_ci;
  double qj_Vbi_ci_Vtnode_GND;
  double qj_Vbi_ci_Vbi_ci;
  double qj_Vbi_ci_Vbi_ei;
  double qj_Vbi_ci_Vci_ei;
  double qj_Vb_ci_Vb_ci;
  double qj_Vb_ci_Vtnode_GND;
  double qj_Vb_ci_Vbi_ci;
  double qj_Vb_ci_Vbi_ei;
  double qj_Vb_ci_Vci_ei;
#endif
#endif
double qje;
#if defined(_DERIVATEFORDDX)
double qje_Vtnode_GND;
double qje_Vbi_ei;
double qje_Vci_ei;
double qje_Vb_ci;
double qje_Vbi_ci;
#if defined(_DERIVATE2)
  double qje_Vbi_ci_Vtnode_GND;
  double qje_Vbi_ci_Vbi_ei;
  double qje_Vbi_ci_Vci_ei;
  double qje_Vbi_ci_Vb_ci;
  double qje_Vbi_ci_Vbi_ci;
  double qje_Vb_ci_Vtnode_GND;
  double qje_Vb_ci_Vbi_ei;
  double qje_Vb_ci_Vci_ei;
  double qje_Vb_ci_Vb_ci;
  double qje_Vb_ci_Vbi_ci;
  double qje_Vci_ei_Vtnode_GND;
  double qje_Vci_ei_Vbi_ei;
  double qje_Vci_ei_Vci_ei;
  double qje_Vci_ei_Vb_ci;
  double qje_Vci_ei_Vbi_ci;
  double qje_Vbi_ei_Vtnode_GND;
  double qje_Vbi_ei_Vbi_ei;
  double qje_Vbi_ei_Vci_ei;
  double qje_Vbi_ei_Vb_ci;
  double qje_Vbi_ei_Vbi_ci;
#endif
#endif
double vj_z;
#if defined(_DERIVATEFORDDX)
double vj_z_Vtnode_GND;
double vj_z_Vbi_ei;
#if defined(_DERIVATE2)
  double vj_z_Vbi_ei_Vtnode_GND;
  double vj_z_Vbi_ei_Vbi_ei;
#endif
#endif
double vjh;
#if defined(_DERIVATEFORDDX)
double vjh_Vtnode_GND;
double vjh_Vbi_ei;
#if defined(_DERIVATE2)
  double vjh_Vbi_ei_Vtnode_GND;
  double vjh_Vbi_ei_Vbi_ei;
#endif
#endif
double h_vbe;
#if defined(_DERIVATEFORDDX)
double h_vbe_Vtnode_GND;
double h_vbe_Vbi_ei;
#if defined(_DERIVATE2)
  double h_vbe_Vbi_ei_Vtnode_GND;
  double h_vbe_Vbi_ei_Vbi_ei;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double qjei_Vtnode_GND;
double qjei_Vci_ei;
double qjei_Vbi_ei;
double qjei_Vb_ci;
double qjei_Vbi_ci;
#if defined(_DERIVATE2)
  double qjei_Vbi_ci_Vtnode_GND;
  double qjei_Vbi_ci_Vci_ei;
  double qjei_Vbi_ci_Vbi_ei;
  double qjei_Vbi_ci_Vb_ci;
  double qjei_Vbi_ci_Vbi_ci;
  double qjei_Vb_ci_Vtnode_GND;
  double qjei_Vb_ci_Vci_ei;
  double qjei_Vb_ci_Vbi_ei;
  double qjei_Vb_ci_Vb_ci;
  double qjei_Vb_ci_Vbi_ci;
  double qjei_Vbi_ei_Vtnode_GND;
  double qjei_Vbi_ei_Vci_ei;
  double qjei_Vbi_ei_Vbi_ei;
  double qjei_Vbi_ei_Vb_ci;
  double qjei_Vbi_ei_Vbi_ci;
  double qjei_Vci_ei_Vtnode_GND;
  double qjei_Vci_ei_Vci_ei;
  double qjei_Vci_ei_Vbi_ei;
  double qjei_Vci_ei_Vb_ci;
  double qjei_Vci_ei_Vbi_ci;
#endif
#endif
double cc;
#if defined(_DERIVATEFORDDX)
double cc_Vtnode_GND;
double cc_Vb_ci;
double cc_Vbi_ci;
#if defined(_DERIVATE2)
  double cc_Vbi_ci_Vtnode_GND;
  double cc_Vbi_ci_Vb_ci;
  double cc_Vbi_ci_Vbi_ci;
  double cc_Vb_ci_Vtnode_GND;
  double cc_Vb_ci_Vb_ci;
  double cc_Vb_ci_Vbi_ci;
#endif
#endif
double ick;
#if defined(_DERIVATEFORDDX)
double ick_Vtnode_GND;
double ick_Vci_ei;
#if defined(_DERIVATE2)
  double ick_Vci_ei_Vtnode_GND;
  double ick_Vci_ei_Vci_ei;
#endif
#endif
double vceff;
#if defined(_DERIVATEFORDDX)
double vceff_Vtnode_GND;
double vceff_Vci_ei;
#if defined(_DERIVATE2)
  double vceff_Vci_ei_Vtnode_GND;
  double vceff_Vci_ei_Vci_ei;
#endif
#endif
double uvc;
#if defined(_DERIVATEFORDDX)
double uvc_Vci_ei;
double uvc_Vtnode_GND;
#if defined(_DERIVATE2)
  double uvc_Vci_ei_Vci_ei;
  double uvc_Vci_ei_Vtnode_GND;
#endif
#endif
double vc;
#if defined(_DERIVATEFORDDX)
double vc_Vci_ei;
double vc_Vtnode_GND;
#if defined(_DERIVATE2)
  double vc_Vci_ei_Vci_ei;
  double vc_Vci_ei_Vtnode_GND;
#endif
#endif
double cjcii;
#if defined(_DERIVATEFORDDX)
double cjcii_Vtnode_GND;
double cjcii_Vb_ci;
double cjcii_Vbi_ci;
#if defined(_DERIVATE2)
  double cjcii_Vbi_ci_Vtnode_GND;
  double cjcii_Vbi_ci_Vb_ci;
  double cjcii_Vbi_ci_Vbi_ci;
  double cjcii_Vb_ci_Vtnode_GND;
  double cjcii_Vb_ci_Vb_ci;
  double cjcii_Vb_ci_Vbi_ci;
#endif
#endif
double dvj;
#if defined(_DERIVATEFORDDX)
double dvj_Vb_ci;
double dvj_Vtnode_GND;
double dvj_Vbi_ci;
#if defined(_DERIVATE2)
  double dvj_Vbi_ci_Vb_ci;
  double dvj_Vbi_ci_Vtnode_GND;
  double dvj_Vbi_ci_Vbi_ci;
  double dvj_Vb_ci_Vb_ci;
  double dvj_Vb_ci_Vtnode_GND;
  double dvj_Vb_ci_Vbi_ci;
#endif
#endif
#if defined(_DYNAMIC)
double qjcii;
#if defined(_DERIVATE)
double qjcii_Vb_ci;
double qjcii_Vtnode_GND;
double qjcii_Vbi_ci;
#endif
#endif
double qjci_int;
#if defined(_DERIVATEFORDDX)
double qjci_Vb_ci;
double qjci_Vtnode_GND;
double qjci_Vbi_ci;
#if defined(_DERIVATE2)
  double qjci_Vbi_ci_Vb_ci;
  double qjci_Vbi_ci_Vtnode_GND;
  double qjci_Vbi_ci_Vbi_ci;
  double qjci_Vb_ci_Vb_ci;
  double qjci_Vb_ci_Vtnode_GND;
  double qjci_Vb_ci_Vbi_ci;
#endif
#endif
#if defined(_DYNAMIC)
double qjcx;
#if defined(_DERIVATE)
double qjcx_Vb_ci;
double qjcx_Vtnode_GND;
double qjcx_Vbi_ci;
#endif
#endif
double cjcx0_t_i;
#if defined(_DERIVATE)
double cjcx0_t_i_Vtnode_GND;
#endif
double y;
#if defined(_DERIVATEFORDDX)
double y_Vs_ci;
double y_Vci_ei;
double y_Vbi_ei;
double y_Vb_ci;
double y_Vtnode_GND;
double y_Vbi_ci;
#if defined(_DERIVATE2)
  double y_Vbi_ci_Vs_ci;
  double y_Vbi_ci_Vci_ei;
  double y_Vbi_ci_Vbi_ei;
  double y_Vbi_ci_Vb_ci;
  double y_Vbi_ci_Vtnode_GND;
  double y_Vbi_ci_Vbi_ci;
  double y_Vb_ci_Vs_ci;
  double y_Vb_ci_Vci_ei;
  double y_Vb_ci_Vbi_ei;
  double y_Vb_ci_Vb_ci;
  double y_Vb_ci_Vtnode_GND;
  double y_Vb_ci_Vbi_ci;
  double y_Vbi_ei_Vs_ci;
  double y_Vbi_ei_Vci_ei;
  double y_Vbi_ei_Vbi_ei;
  double y_Vbi_ei_Vb_ci;
  double y_Vbi_ei_Vtnode_GND;
  double y_Vbi_ei_Vbi_ci;
  double y_Vci_ei_Vs_ci;
  double y_Vci_ei_Vci_ei;
  double y_Vci_ei_Vbi_ei;
  double y_Vci_ei_Vb_ci;
  double y_Vci_ei_Vtnode_GND;
  double y_Vci_ei_Vbi_ci;
  double y_Vs_ci_Vs_ci;
  double y_Vs_ci_Vci_ei;
  double y_Vs_ci_Vbi_ei;
  double y_Vs_ci_Vb_ci;
  double y_Vs_ci_Vtnode_GND;
  double y_Vs_ci_Vbi_ci;
#endif
#endif
double x;
#if defined(_DERIVATEFORDDX)
double x_Vtnode_GND;
double x_Vci_ei;
#if defined(_DERIVATE2)
  double x_Vci_ei_Vtnode_GND;
  double x_Vci_ei_Vci_ei;
#endif
#endif
double v_j;
#if defined(_DERIVATEFORDDX)
double v_j_Vs_ci;
double v_j_Vbi_ei;
double v_j_Vb_ci;
double v_j_Vtnode_GND;
double v_j_Vbi_ci;
#if defined(_DERIVATE2)
  double v_j_Vbi_ci_Vs_ci;
  double v_j_Vbi_ci_Vbi_ei;
  double v_j_Vbi_ci_Vb_ci;
  double v_j_Vbi_ci_Vtnode_GND;
  double v_j_Vbi_ci_Vbi_ci;
  double v_j_Vb_ci_Vs_ci;
  double v_j_Vb_ci_Vbi_ei;
  double v_j_Vb_ci_Vb_ci;
  double v_j_Vb_ci_Vtnode_GND;
  double v_j_Vb_ci_Vbi_ci;
  double v_j_Vbi_ei_Vs_ci;
  double v_j_Vbi_ei_Vbi_ei;
  double v_j_Vbi_ei_Vb_ci;
  double v_j_Vbi_ei_Vtnode_GND;
  double v_j_Vbi_ei_Vbi_ci;
  double v_j_Vs_ci_Vs_ci;
  double v_j_Vs_ci_Vbi_ei;
  double v_j_Vs_ci_Vb_ci;
  double v_j_Vs_ci_Vtnode_GND;
  double v_j_Vs_ci_Vbi_ci;
#endif
#endif
double xvf2;
#if defined(_DERIVATEFORDDX)
double xvf2_Vs_ci;
double xvf2_Vbi_ei;
double xvf2_Vb_ci;
double xvf2_Vtnode_GND;
double xvf2_Vbi_ci;
#if defined(_DERIVATE2)
  double xvf2_Vbi_ci_Vs_ci;
  double xvf2_Vbi_ci_Vbi_ei;
  double xvf2_Vbi_ci_Vb_ci;
  double xvf2_Vbi_ci_Vtnode_GND;
  double xvf2_Vbi_ci_Vbi_ci;
  double xvf2_Vb_ci_Vs_ci;
  double xvf2_Vb_ci_Vbi_ei;
  double xvf2_Vb_ci_Vb_ci;
  double xvf2_Vb_ci_Vtnode_GND;
  double xvf2_Vb_ci_Vbi_ci;
  double xvf2_Vbi_ei_Vs_ci;
  double xvf2_Vbi_ei_Vbi_ei;
  double xvf2_Vbi_ei_Vb_ci;
  double xvf2_Vbi_ei_Vtnode_GND;
  double xvf2_Vbi_ei_Vbi_ci;
  double xvf2_Vs_ci_Vs_ci;
  double xvf2_Vs_ci_Vbi_ei;
  double xvf2_Vs_ci_Vb_ci;
  double xvf2_Vs_ci_Vtnode_GND;
  double xvf2_Vs_ci_Vbi_ci;
#endif
#endif
double xvf;
#if defined(_DERIVATEFORDDX)
double xvf_Vs_ci;
double xvf_Vbi_ei;
double xvf_Vb_ci;
double xvf_Vtnode_GND;
double xvf_Vbi_ci;
#if defined(_DERIVATE2)
  double xvf_Vbi_ci_Vs_ci;
  double xvf_Vbi_ci_Vbi_ei;
  double xvf_Vbi_ci_Vb_ci;
  double xvf_Vbi_ci_Vtnode_GND;
  double xvf_Vbi_ci_Vbi_ci;
  double xvf_Vb_ci_Vs_ci;
  double xvf_Vb_ci_Vbi_ei;
  double xvf_Vb_ci_Vb_ci;
  double xvf_Vb_ci_Vtnode_GND;
  double xvf_Vb_ci_Vbi_ci;
  double xvf_Vbi_ei_Vs_ci;
  double xvf_Vbi_ei_Vbi_ei;
  double xvf_Vbi_ei_Vb_ci;
  double xvf_Vbi_ei_Vtnode_GND;
  double xvf_Vbi_ei_Vbi_ci;
  double xvf_Vs_ci_Vs_ci;
  double xvf_Vs_ci_Vbi_ei;
  double xvf_Vs_ci_Vb_ci;
  double xvf_Vs_ci_Vtnode_GND;
  double xvf_Vs_ci_Vbi_ci;
#endif
#endif
#if defined(_DYNAMIC)
double qjcxi;
#if defined(_DERIVATEFORDDX)
double qjcxi_Vtnode_GND;
double qjcxi_Vbi_ci;
#if defined(_DERIVATE2)
  double qjcxi_Vbi_ci_Vtnode_GND;
  double qjcxi_Vbi_ci_Vbi_ci;
#endif
#endif
#endif
double qj3;
#if defined(_DERIVATEFORDDX)
double qj3_Vci_ei;
double qj3_Vbi_ei;
double qj3_Vs_ci;
double qj3_Vb_ci;
double qj3_Vtnode_GND;
double qj3_Vbi_ci;
#if defined(_DERIVATE2)
  double qj3_Vbi_ci_Vci_ei;
  double qj3_Vbi_ci_Vbi_ei;
  double qj3_Vbi_ci_Vs_ci;
  double qj3_Vbi_ci_Vb_ci;
  double qj3_Vbi_ci_Vtnode_GND;
  double qj3_Vbi_ci_Vbi_ci;
  double qj3_Vb_ci_Vci_ei;
  double qj3_Vb_ci_Vbi_ei;
  double qj3_Vb_ci_Vs_ci;
  double qj3_Vb_ci_Vb_ci;
  double qj3_Vb_ci_Vtnode_GND;
  double qj3_Vb_ci_Vbi_ci;
  double qj3_Vs_ci_Vci_ei;
  double qj3_Vs_ci_Vbi_ei;
  double qj3_Vs_ci_Vs_ci;
  double qj3_Vs_ci_Vb_ci;
  double qj3_Vs_ci_Vtnode_GND;
  double qj3_Vs_ci_Vbi_ci;
  double qj3_Vbi_ei_Vci_ei;
  double qj3_Vbi_ei_Vbi_ei;
  double qj3_Vbi_ei_Vs_ci;
  double qj3_Vbi_ei_Vb_ci;
  double qj3_Vbi_ei_Vtnode_GND;
  double qj3_Vbi_ei_Vbi_ci;
  double qj3_Vci_ei_Vci_ei;
  double qj3_Vci_ei_Vbi_ei;
  double qj3_Vci_ei_Vs_ci;
  double qj3_Vci_ei_Vb_ci;
  double qj3_Vci_ei_Vtnode_GND;
  double qj3_Vci_ei_Vbi_ci;
#endif
#endif
double qj2;
#if defined(_DERIVATEFORDDX)
double qj2_Vci_ei;
double qj2_Vbi_ei;
double qj2_Vs_ci;
double qj2_Vb_ci;
double qj2_Vtnode_GND;
double qj2_Vbi_ci;
#if defined(_DERIVATE2)
  double qj2_Vbi_ci_Vci_ei;
  double qj2_Vbi_ci_Vbi_ei;
  double qj2_Vbi_ci_Vs_ci;
  double qj2_Vbi_ci_Vb_ci;
  double qj2_Vbi_ci_Vtnode_GND;
  double qj2_Vbi_ci_Vbi_ci;
  double qj2_Vb_ci_Vci_ei;
  double qj2_Vb_ci_Vbi_ei;
  double qj2_Vb_ci_Vs_ci;
  double qj2_Vb_ci_Vb_ci;
  double qj2_Vb_ci_Vtnode_GND;
  double qj2_Vb_ci_Vbi_ci;
  double qj2_Vs_ci_Vci_ei;
  double qj2_Vs_ci_Vbi_ei;
  double qj2_Vs_ci_Vs_ci;
  double qj2_Vs_ci_Vb_ci;
  double qj2_Vs_ci_Vtnode_GND;
  double qj2_Vs_ci_Vbi_ci;
  double qj2_Vbi_ei_Vci_ei;
  double qj2_Vbi_ei_Vbi_ei;
  double qj2_Vbi_ei_Vs_ci;
  double qj2_Vbi_ei_Vb_ci;
  double qj2_Vbi_ei_Vtnode_GND;
  double qj2_Vbi_ei_Vbi_ci;
  double qj2_Vci_ei_Vci_ei;
  double qj2_Vci_ei_Vbi_ei;
  double qj2_Vci_ei_Vs_ci;
  double qj2_Vci_ei_Vb_ci;
  double qj2_Vci_ei_Vtnode_GND;
  double qj2_Vci_ei_Vbi_ci;
#endif
#endif
double qj1;
#if defined(_DERIVATEFORDDX)
double qj1_Vci_ei;
double qj1_Vbi_ei;
double qj1_Vs_ci;
double qj1_Vb_ci;
double qj1_Vtnode_GND;
double qj1_Vbi_ci;
#if defined(_DERIVATE2)
  double qj1_Vbi_ci_Vci_ei;
  double qj1_Vbi_ci_Vbi_ei;
  double qj1_Vbi_ci_Vs_ci;
  double qj1_Vbi_ci_Vb_ci;
  double qj1_Vbi_ci_Vtnode_GND;
  double qj1_Vbi_ci_Vbi_ci;
  double qj1_Vb_ci_Vci_ei;
  double qj1_Vb_ci_Vbi_ei;
  double qj1_Vb_ci_Vs_ci;
  double qj1_Vb_ci_Vb_ci;
  double qj1_Vb_ci_Vtnode_GND;
  double qj1_Vb_ci_Vbi_ci;
  double qj1_Vs_ci_Vci_ei;
  double qj1_Vs_ci_Vbi_ei;
  double qj1_Vs_ci_Vs_ci;
  double qj1_Vs_ci_Vb_ci;
  double qj1_Vs_ci_Vtnode_GND;
  double qj1_Vs_ci_Vbi_ci;
  double qj1_Vbi_ei_Vci_ei;
  double qj1_Vbi_ei_Vbi_ei;
  double qj1_Vbi_ei_Vs_ci;
  double qj1_Vbi_ei_Vb_ci;
  double qj1_Vbi_ei_Vtnode_GND;
  double qj1_Vbi_ei_Vbi_ci;
  double qj1_Vci_ei_Vci_ei;
  double qj1_Vci_ei_Vbi_ei;
  double qj1_Vci_ei_Vs_ci;
  double qj1_Vci_ei_Vb_ci;
  double qj1_Vci_ei_Vtnode_GND;
  double qj1_Vci_ei_Vbi_ci;
#endif
#endif
double vdj2;
#if defined(_DERIVATEFORDDX)
double vdj2_Vci_ei;
double vdj2_Vbi_ei;
double vdj2_Vs_ci;
double vdj2_Vb_ci;
double vdj2_Vtnode_GND;
double vdj2_Vbi_ci;
#if defined(_DERIVATE2)
  double vdj2_Vbi_ci_Vci_ei;
  double vdj2_Vbi_ci_Vbi_ei;
  double vdj2_Vbi_ci_Vs_ci;
  double vdj2_Vbi_ci_Vb_ci;
  double vdj2_Vbi_ci_Vtnode_GND;
  double vdj2_Vbi_ci_Vbi_ci;
  double vdj2_Vb_ci_Vci_ei;
  double vdj2_Vb_ci_Vbi_ei;
  double vdj2_Vb_ci_Vs_ci;
  double vdj2_Vb_ci_Vb_ci;
  double vdj2_Vb_ci_Vtnode_GND;
  double vdj2_Vb_ci_Vbi_ci;
  double vdj2_Vs_ci_Vci_ei;
  double vdj2_Vs_ci_Vbi_ei;
  double vdj2_Vs_ci_Vs_ci;
  double vdj2_Vs_ci_Vb_ci;
  double vdj2_Vs_ci_Vtnode_GND;
  double vdj2_Vs_ci_Vbi_ci;
  double vdj2_Vbi_ei_Vci_ei;
  double vdj2_Vbi_ei_Vbi_ei;
  double vdj2_Vbi_ei_Vs_ci;
  double vdj2_Vbi_ei_Vb_ci;
  double vdj2_Vbi_ei_Vtnode_GND;
  double vdj2_Vbi_ei_Vbi_ci;
  double vdj2_Vci_ei_Vci_ei;
  double vdj2_Vci_ei_Vbi_ei;
  double vdj2_Vci_ei_Vs_ci;
  double vdj2_Vci_ei_Vb_ci;
  double vdj2_Vci_ei_Vtnode_GND;
  double vdj2_Vci_ei_Vbi_ci;
#endif
#endif
double vdj1;
#if defined(_DERIVATEFORDDX)
double vdj1_Vci_ei;
double vdj1_Vbi_ei;
double vdj1_Vs_ci;
double vdj1_Vb_ci;
double vdj1_Vtnode_GND;
double vdj1_Vbi_ci;
#if defined(_DERIVATE2)
  double vdj1_Vbi_ci_Vci_ei;
  double vdj1_Vbi_ci_Vbi_ei;
  double vdj1_Vbi_ci_Vs_ci;
  double vdj1_Vbi_ci_Vb_ci;
  double vdj1_Vbi_ci_Vtnode_GND;
  double vdj1_Vbi_ci_Vbi_ci;
  double vdj1_Vb_ci_Vci_ei;
  double vdj1_Vb_ci_Vbi_ei;
  double vdj1_Vb_ci_Vs_ci;
  double vdj1_Vb_ci_Vb_ci;
  double vdj1_Vb_ci_Vtnode_GND;
  double vdj1_Vb_ci_Vbi_ci;
  double vdj1_Vs_ci_Vci_ei;
  double vdj1_Vs_ci_Vbi_ei;
  double vdj1_Vs_ci_Vs_ci;
  double vdj1_Vs_ci_Vb_ci;
  double vdj1_Vs_ci_Vtnode_GND;
  double vdj1_Vs_ci_Vbi_ci;
  double vdj1_Vbi_ei_Vci_ei;
  double vdj1_Vbi_ei_Vbi_ei;
  double vdj1_Vbi_ei_Vs_ci;
  double vdj1_Vbi_ei_Vb_ci;
  double vdj1_Vbi_ei_Vtnode_GND;
  double vdj1_Vbi_ei_Vbi_ci;
  double vdj1_Vci_ei_Vci_ei;
  double vdj1_Vci_ei_Vbi_ei;
  double vdj1_Vci_ei_Vs_ci;
  double vdj1_Vci_ei_Vb_ci;
  double vdj1_Vci_ei_Vtnode_GND;
  double vdj1_Vci_ei_Vbi_ci;
#endif
#endif
double ezr;
double ez;
double vj4;
#if defined(_DERIVATEFORDDX)
double vj4_Vs_ci;
double vj4_Vci_ei;
double vj4_Vbi_ei;
double vj4_Vb_ci;
double vj4_Vbi_ci;
double vj4_Vtnode_GND;
#if defined(_DERIVATE2)
  double vj4_Vbi_ci_Vs_ci;
  double vj4_Vbi_ci_Vci_ei;
  double vj4_Vbi_ci_Vbi_ei;
  double vj4_Vbi_ci_Vb_ci;
  double vj4_Vbi_ci_Vbi_ci;
  double vj4_Vbi_ci_Vtnode_GND;
  double vj4_Vb_ci_Vs_ci;
  double vj4_Vb_ci_Vci_ei;
  double vj4_Vb_ci_Vbi_ei;
  double vj4_Vb_ci_Vb_ci;
  double vj4_Vb_ci_Vbi_ci;
  double vj4_Vb_ci_Vtnode_GND;
  double vj4_Vbi_ei_Vs_ci;
  double vj4_Vbi_ei_Vci_ei;
  double vj4_Vbi_ei_Vbi_ei;
  double vj4_Vbi_ei_Vb_ci;
  double vj4_Vbi_ei_Vbi_ci;
  double vj4_Vbi_ei_Vtnode_GND;
  double vj4_Vci_ei_Vs_ci;
  double vj4_Vci_ei_Vci_ei;
  double vj4_Vci_ei_Vbi_ei;
  double vj4_Vci_ei_Vb_ci;
  double vj4_Vci_ei_Vbi_ci;
  double vj4_Vci_ei_Vtnode_GND;
  double vj4_Vs_ci_Vs_ci;
  double vj4_Vs_ci_Vci_ei;
  double vj4_Vs_ci_Vbi_ei;
  double vj4_Vs_ci_Vb_ci;
  double vj4_Vs_ci_Vbi_ci;
  double vj4_Vs_ci_Vtnode_GND;
#endif
#endif
double vj2;
#if defined(_DERIVATEFORDDX)
double vj2_Vci_ei;
double vj2_Vbi_ei;
double vj2_Vs_ci;
double vj2_Vb_ci;
double vj2_Vtnode_GND;
double vj2_Vbi_ci;
#if defined(_DERIVATE2)
  double vj2_Vbi_ci_Vci_ei;
  double vj2_Vbi_ci_Vbi_ei;
  double vj2_Vbi_ci_Vs_ci;
  double vj2_Vbi_ci_Vb_ci;
  double vj2_Vbi_ci_Vtnode_GND;
  double vj2_Vbi_ci_Vbi_ci;
  double vj2_Vb_ci_Vci_ei;
  double vj2_Vb_ci_Vbi_ei;
  double vj2_Vb_ci_Vs_ci;
  double vj2_Vb_ci_Vb_ci;
  double vj2_Vb_ci_Vtnode_GND;
  double vj2_Vb_ci_Vbi_ci;
  double vj2_Vs_ci_Vci_ei;
  double vj2_Vs_ci_Vbi_ei;
  double vj2_Vs_ci_Vs_ci;
  double vj2_Vs_ci_Vb_ci;
  double vj2_Vs_ci_Vtnode_GND;
  double vj2_Vs_ci_Vbi_ci;
  double vj2_Vbi_ei_Vci_ei;
  double vj2_Vbi_ei_Vbi_ei;
  double vj2_Vbi_ei_Vs_ci;
  double vj2_Vbi_ei_Vb_ci;
  double vj2_Vbi_ei_Vtnode_GND;
  double vj2_Vbi_ei_Vbi_ci;
  double vj2_Vci_ei_Vci_ei;
  double vj2_Vci_ei_Vbi_ei;
  double vj2_Vci_ei_Vs_ci;
  double vj2_Vci_ei_Vb_ci;
  double vj2_Vci_ei_Vtnode_GND;
  double vj2_Vci_ei_Vbi_ci;
#endif
#endif
double vr;
#if defined(_DERIVATEFORDDX)
double vr_Vci_ei;
double vr_Vbi_ei;
double vr_Vs_ci;
double vr_Vb_ci;
double vr_Vtnode_GND;
double vr_Vbi_ci;
#if defined(_DERIVATE2)
  double vr_Vbi_ci_Vci_ei;
  double vr_Vbi_ci_Vbi_ei;
  double vr_Vbi_ci_Vs_ci;
  double vr_Vbi_ci_Vb_ci;
  double vr_Vbi_ci_Vtnode_GND;
  double vr_Vbi_ci_Vbi_ci;
  double vr_Vb_ci_Vci_ei;
  double vr_Vb_ci_Vbi_ei;
  double vr_Vb_ci_Vs_ci;
  double vr_Vb_ci_Vb_ci;
  double vr_Vb_ci_Vtnode_GND;
  double vr_Vb_ci_Vbi_ci;
  double vr_Vs_ci_Vci_ei;
  double vr_Vs_ci_Vbi_ei;
  double vr_Vs_ci_Vs_ci;
  double vr_Vs_ci_Vb_ci;
  double vr_Vs_ci_Vtnode_GND;
  double vr_Vs_ci_Vbi_ci;
  double vr_Vbi_ei_Vci_ei;
  double vr_Vbi_ei_Vbi_ei;
  double vr_Vbi_ei_Vs_ci;
  double vr_Vbi_ei_Vb_ci;
  double vr_Vbi_ei_Vtnode_GND;
  double vr_Vbi_ei_Vbi_ci;
  double vr_Vci_ei_Vci_ei;
  double vr_Vci_ei_Vbi_ei;
  double vr_Vci_ei_Vs_ci;
  double vr_Vci_ei_Vb_ci;
  double vr_Vci_ei_Vtnode_GND;
  double vr_Vci_ei_Vbi_ci;
#endif
#endif
double vj1;
#if defined(_DERIVATEFORDDX)
double vj1_Vci_ei;
double vj1_Vbi_ei;
double vj1_Vs_ci;
double vj1_Vb_ci;
double vj1_Vtnode_GND;
double vj1_Vbi_ci;
#if defined(_DERIVATE2)
  double vj1_Vbi_ci_Vci_ei;
  double vj1_Vbi_ci_Vbi_ei;
  double vj1_Vbi_ci_Vs_ci;
  double vj1_Vbi_ci_Vb_ci;
  double vj1_Vbi_ci_Vtnode_GND;
  double vj1_Vbi_ci_Vbi_ci;
  double vj1_Vb_ci_Vci_ei;
  double vj1_Vb_ci_Vbi_ei;
  double vj1_Vb_ci_Vs_ci;
  double vj1_Vb_ci_Vb_ci;
  double vj1_Vb_ci_Vtnode_GND;
  double vj1_Vb_ci_Vbi_ci;
  double vj1_Vs_ci_Vci_ei;
  double vj1_Vs_ci_Vbi_ei;
  double vj1_Vs_ci_Vs_ci;
  double vj1_Vs_ci_Vb_ci;
  double vj1_Vs_ci_Vtnode_GND;
  double vj1_Vs_ci_Vbi_ci;
  double vj1_Vbi_ei_Vci_ei;
  double vj1_Vbi_ei_Vbi_ei;
  double vj1_Vbi_ei_Vs_ci;
  double vj1_Vbi_ei_Vb_ci;
  double vj1_Vbi_ei_Vtnode_GND;
  double vj1_Vbi_ei_Vbi_ci;
  double vj1_Vci_ei_Vci_ei;
  double vj1_Vci_ei_Vbi_ei;
  double vj1_Vci_ei_Vs_ci;
  double vj1_Vci_ei_Vb_ci;
  double vj1_Vci_ei_Vtnode_GND;
  double vj1_Vci_ei_Vbi_ci;
#endif
#endif
double ee1;
#if defined(_DERIVATEFORDDX)
double ee1_Vs_ci;
double ee1_Vci_ei;
double ee1_Vbi_ei;
double ee1_Vb_ci;
double ee1_Vtnode_GND;
double ee1_Vbi_ci;
#if defined(_DERIVATE2)
  double ee1_Vbi_ci_Vs_ci;
  double ee1_Vbi_ci_Vci_ei;
  double ee1_Vbi_ci_Vbi_ei;
  double ee1_Vbi_ci_Vb_ci;
  double ee1_Vbi_ci_Vtnode_GND;
  double ee1_Vbi_ci_Vbi_ci;
  double ee1_Vb_ci_Vs_ci;
  double ee1_Vb_ci_Vci_ei;
  double ee1_Vb_ci_Vbi_ei;
  double ee1_Vb_ci_Vb_ci;
  double ee1_Vb_ci_Vtnode_GND;
  double ee1_Vb_ci_Vbi_ci;
  double ee1_Vbi_ei_Vs_ci;
  double ee1_Vbi_ei_Vci_ei;
  double ee1_Vbi_ei_Vbi_ei;
  double ee1_Vbi_ei_Vb_ci;
  double ee1_Vbi_ei_Vtnode_GND;
  double ee1_Vbi_ei_Vbi_ci;
  double ee1_Vci_ei_Vs_ci;
  double ee1_Vci_ei_Vci_ei;
  double ee1_Vci_ei_Vbi_ei;
  double ee1_Vci_ei_Vb_ci;
  double ee1_Vci_ei_Vtnode_GND;
  double ee1_Vci_ei_Vbi_ci;
  double ee1_Vs_ci_Vs_ci;
  double ee1_Vs_ci_Vci_ei;
  double ee1_Vs_ci_Vbi_ei;
  double ee1_Vs_ci_Vb_ci;
  double ee1_Vs_ci_Vtnode_GND;
  double ee1_Vs_ci_Vbi_ci;
#endif
#endif
double ex1;
#if defined(_DERIVATEFORDDX)
double ex1_Vs_ci;
double ex1_Vci_ei;
double ex1_Vbi_ei;
double ex1_Vb_ci;
double ex1_Vtnode_GND;
double ex1_Vbi_ci;
#if defined(_DERIVATE2)
  double ex1_Vbi_ci_Vs_ci;
  double ex1_Vbi_ci_Vci_ei;
  double ex1_Vbi_ci_Vbi_ei;
  double ex1_Vbi_ci_Vb_ci;
  double ex1_Vbi_ci_Vtnode_GND;
  double ex1_Vbi_ci_Vbi_ci;
  double ex1_Vb_ci_Vs_ci;
  double ex1_Vb_ci_Vci_ei;
  double ex1_Vb_ci_Vbi_ei;
  double ex1_Vb_ci_Vb_ci;
  double ex1_Vb_ci_Vtnode_GND;
  double ex1_Vb_ci_Vbi_ci;
  double ex1_Vbi_ei_Vs_ci;
  double ex1_Vbi_ei_Vci_ei;
  double ex1_Vbi_ei_Vbi_ei;
  double ex1_Vbi_ei_Vb_ci;
  double ex1_Vbi_ei_Vtnode_GND;
  double ex1_Vbi_ei_Vbi_ci;
  double ex1_Vci_ei_Vs_ci;
  double ex1_Vci_ei_Vci_ei;
  double ex1_Vci_ei_Vbi_ei;
  double ex1_Vci_ei_Vb_ci;
  double ex1_Vci_ei_Vtnode_GND;
  double ex1_Vci_ei_Vbi_ci;
  double ex1_Vs_ci_Vs_ci;
  double ex1_Vs_ci_Vci_ei;
  double ex1_Vs_ci_Vbi_ei;
  double ex1_Vs_ci_Vb_ci;
  double ex1_Vs_ci_Vtnode_GND;
  double ex1_Vs_ci_Vbi_ci;
#endif
#endif
double ve;
#if defined(_DERIVATEFORDDX)
double ve_Vs_ci;
double ve_Vci_ei;
double ve_Vbi_ei;
double ve_Vb_ci;
double ve_Vtnode_GND;
double ve_Vbi_ci;
#if defined(_DERIVATE2)
  double ve_Vbi_ci_Vs_ci;
  double ve_Vbi_ci_Vci_ei;
  double ve_Vbi_ci_Vbi_ei;
  double ve_Vbi_ci_Vb_ci;
  double ve_Vbi_ci_Vtnode_GND;
  double ve_Vbi_ci_Vbi_ci;
  double ve_Vb_ci_Vs_ci;
  double ve_Vb_ci_Vci_ei;
  double ve_Vb_ci_Vbi_ei;
  double ve_Vb_ci_Vb_ci;
  double ve_Vb_ci_Vtnode_GND;
  double ve_Vb_ci_Vbi_ci;
  double ve_Vbi_ei_Vs_ci;
  double ve_Vbi_ei_Vci_ei;
  double ve_Vbi_ei_Vbi_ei;
  double ve_Vbi_ei_Vb_ci;
  double ve_Vbi_ei_Vtnode_GND;
  double ve_Vbi_ei_Vbi_ci;
  double ve_Vci_ei_Vs_ci;
  double ve_Vci_ei_Vci_ei;
  double ve_Vci_ei_Vbi_ei;
  double ve_Vci_ei_Vb_ci;
  double ve_Vci_ei_Vtnode_GND;
  double ve_Vci_ei_Vbi_ci;
  double ve_Vs_ci_Vs_ci;
  double ve_Vs_ci_Vci_ei;
  double ve_Vs_ci_Vbi_ei;
  double ve_Vs_ci_Vb_ci;
  double ve_Vs_ci_Vtnode_GND;
  double ve_Vs_ci_Vbi_ci;
#endif
#endif
double a;
#if defined(_DERIVATEFORDDX)
double a_Vci_ei;
double a_Vbi_ei;
double a_Vb_ci;
double a_Vbi_ci;
double a_Vtnode_GND;
#if defined(_DERIVATE2)
  double a_Vbi_ci_Vci_ei;
  double a_Vbi_ci_Vbi_ei;
  double a_Vbi_ci_Vb_ci;
  double a_Vbi_ci_Vbi_ci;
  double a_Vbi_ci_Vtnode_GND;
  double a_Vb_ci_Vci_ei;
  double a_Vb_ci_Vbi_ei;
  double a_Vb_ci_Vb_ci;
  double a_Vb_ci_Vbi_ci;
  double a_Vb_ci_Vtnode_GND;
  double a_Vbi_ei_Vci_ei;
  double a_Vbi_ei_Vbi_ei;
  double a_Vbi_ei_Vb_ci;
  double a_Vbi_ei_Vbi_ci;
  double a_Vbi_ei_Vtnode_GND;
  double a_Vci_ei_Vci_ei;
  double a_Vci_ei_Vbi_ei;
  double a_Vci_ei_Vb_ci;
  double a_Vci_ei_Vbi_ci;
  double a_Vci_ei_Vtnode_GND;
#endif
#endif
double cr;
#if defined(_DERIVATE)
double cr_Vtnode_GND;
#endif
double cmax;
#if defined(_DERIVATE)
double cmax_Vtnode_GND;
#endif
double vf;
#if defined(_DERIVATE)
double vf_Vtnode_GND;
#endif
double vp;
#if defined(_DERIVATE)
double vp_Vtnode_GND;
#endif
double zr;
double cjcx0_t_ii;
#if defined(_DERIVATE)
double cjcx0_t_ii_Vtnode_GND;
#endif
double cjci0_t_ii;
#if defined(_DERIVATE)
double cjci0_t_ii_Vtnode_GND;
#endif
double ahq_t;
double tfh_t;
#if defined(_DERIVATE)
double tfh_t_Vtnode_GND;
#endif
double iqfh_t;
#if defined(_DERIVATE)
double iqfh_t_Vtnode_GND;
#endif
double ver_t;
#if defined(_DERIVATE)
double ver_t_Vtnode_GND;
#endif
double aver_t;
#if defined(_DERIVATE)
double aver_t_Vtnode_GND;
#endif
double rth_t;
#if defined(_DERIVATE)
double rth_t_Vtnode_GND;
#endif
double kavl_t;
#if defined(_DERIVATE)
double kavl_t_Vtnode_GND;
#endif
double eavl_t;
#if defined(_DERIVATE)
double eavl_t_Vtnode_GND;
#endif
double re_t;
#if defined(_DERIVATE)
double re_t_Vtnode_GND;
#endif
double rbi0_t;
#if defined(_DERIVATE)
double rbi0_t_Vtnode_GND;
#endif
double rcx_t;
#if defined(_DERIVATE)
double rcx_t_Vtnode_GND;
#endif
double rbx_t;
#if defined(_DERIVATE)
double rbx_t_Vtnode_GND;
#endif
double tef0_t;
#if defined(_DERIVATE)
double tef0_t_Vtnode_GND;
#endif
double dvg;
double zetatef;
double thcs_t;
#if defined(_DERIVATE)
double thcs_t_Vtnode_GND;
#endif
double t0_t;
#if defined(_DERIVATE)
double t0_t_Vtnode_GND;
#endif
double vces_t;
#if defined(_DERIVATE)
double vces_t_Vtnode_GND;
#endif
double vlim_t;
#if defined(_DERIVATE)
double vlim_t_Vtnode_GND;
#endif
double rci0_t;
#if defined(_DERIVATE)
double rci0_t_Vtnode_GND;
#endif
double iqf_t;
#if defined(_DERIVATE)
double iqf_t_Vtnode_GND;
#endif
#if defined(_DYNAMIC)
double cjs0_t;
#if defined(_DERIVATE)
double cjs0_t_Vtnode_GND;
#endif
#endif
#if defined(_DYNAMIC)
double vds_t;
#if defined(_DERIVATE)
double vds_t_Vtnode_GND;
#endif
#endif
double cjcx0_t;
#if defined(_DERIVATE)
double cjcx0_t_Vtnode_GND;
#endif
double vdcx_t;
#if defined(_DERIVATE)
double vdcx_t_Vtnode_GND;
#endif
double cjci0_t;
#if defined(_DERIVATE)
double cjci0_t_Vtnode_GND;
#endif
double vdci_t;
#if defined(_DERIVATE)
double vdci_t_Vtnode_GND;
#endif
double ajedc_t;
#if defined(_DERIVATE)
double ajedc_t_Vtnode_GND;
#endif
double aje_t;
#if defined(_DERIVATE)
double aje_t_Vtnode_GND;
#endif
double cje0_dc_t;
#if defined(_DERIVATE)
double cje0_dc_t_Vtnode_GND;
#endif
double vdedc_t;
#if defined(_DERIVATE)
double vdedc_t_Vtnode_GND;
#endif
double cje0_dc;
double cje0_t;
#if defined(_DERIVATE)
double cje0_t_Vtnode_GND;
#endif
double vde_t;
#if defined(_DERIVATE)
double vde_t_Vtnode_GND;
#endif
double vdjt;
#if defined(_DERIVATE)
double vdjt_Vtnode_GND;
#endif
double vdj0;
double arg;
double iscs_t;
#if defined(_DERIVATE)
double iscs_t_Vtnode_GND;
#endif
double itss_t;
#if defined(_DERIVATE)
double itss_t_Vtnode_GND;
#endif
double ibcs_t;
#if defined(_DERIVATE)
double ibcs_t_Vtnode_GND;
#endif
double ires_t;
#if defined(_DERIVATE)
double ires_t_Vtnode_GND;
#endif
double ibes_t;
#if defined(_DERIVATE)
double ibes_t_Vtnode_GND;
#endif
double is_t;
#if defined(_DERIVATE)
double is_t_Vtnode_GND;
#endif
double zetasct;
double zetabci;
double mg;
#if defined(_DYNAMIC)
double vgsc;
#endif
double vgbc;
double vgbe;
double avs;
double ln_qtt0;
#if defined(_DERIVATE)
double ln_qtt0_Vtnode_GND;
#endif
double qtt0;
#if defined(_DERIVATE)
double qtt0_Vtnode_GND;
#endif
double dT;
#if defined(_DERIVATE)
double dT_Vtnode_GND;
#endif
double VT;
#if defined(_DERIVATE)
double VT_Vtnode_GND;
#endif
double vt0;
double Tdev;
#if defined(_DERIVATE)
double Tdev_Vtnode_GND;
#endif
double Tamb;
double TnomK;
double Vrth;
#if defined(_DERIVATE)
double Vrth_Vtnode_GND;
#endif
#if defined(_DYNAMIC)
double Vbe;
#if defined(_DERIVATE)
double Vbe_Vb_e;
#endif
#endif
double Vbbi;
#if defined(_DERIVATE)
double Vbbi_Vb_bi;
#endif
double Vcic;
#if defined(_DERIVATE)
double Vcic_Vci_c;
#endif
double Veie;
#if defined(_DERIVATE)
double Veie_Vei_e;
#endif
double Vsci;
#if defined(_DERIVATEFORDDX)
double Vsci_Vs_ci;
#if defined(_DERIVATE2)
  double Vsci_Vs_ci_Vs_ci;
#endif
#endif
double Vciei;
#if defined(_DERIVATEFORDDX)
double Vciei_Vci_ei;
#if defined(_DERIVATE2)
  double Vciei_Vci_ei_Vci_ei;
#endif
#endif
double Vbiei;
#if defined(_DERIVATEFORDDX)
double Vbiei_Vbi_ei;
#if defined(_DERIVATE2)
  double Vbiei_Vbi_ei_Vbi_ei;
#endif
#endif
double Vbici;
#if defined(_DERIVATEFORDDX)
double Vbici_Vbi_ci;
#if defined(_DERIVATE2)
  double Vbici_Vbi_ci_Vbi_ci;
#endif
#endif
double Vbci;
#if defined(_DERIVATEFORDDX)
double Vbci_Vb_ci;
#if defined(_DERIVATE2)
  double Vbci_Vb_ci_Vb_ci;
#endif
#endif
double gmin;
gmin=_circuit_gmin;
EXIT_IF_ISNAN(_circuit_gmin)
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci) ddxprobe=V(s,GND)V(bi,GND)V(ci,GND)V(ei,GND) */
Vbci_Vb_ci=(pModel->HICUMtype);
#if defined(_DERIVATE2)
  Vbci_Vb_ci_Vb_ci=(+0.0*(NP(b)-NP(ci))+0.0*1.0+0.0*1.0+pModel->HICUMtype*0.0);
#endif
#endif
Vbci=(pModel->HICUMtype*(NP(b)-NP(ci)));
EXIT_IF_ISNAN((pModel->HICUMtype*(NP(b)-NP(ci))))
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ci) ddxprobe=V(bi,GND)V(ei,GND)V(s,GND)V(ci,GND) */
Vbici_Vbi_ci=(pModel->HICUMtype);
#if defined(_DERIVATE2)
  Vbici_Vbi_ci_Vbi_ci=(+0.0*(NP(bi)-NP(ci))+0.0*1.0+0.0*1.0+pModel->HICUMtype*0.0);
#endif
#endif
Vbici=(pModel->HICUMtype*(NP(bi)-NP(ci)));
EXIT_IF_ISNAN((pModel->HICUMtype*(NP(bi)-NP(ci))))
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ei) ddxprobe=V(ei,GND)V(ci,GND)V(s,GND)V(bi,GND) */
Vbiei_Vbi_ei=(pModel->HICUMtype);
#if defined(_DERIVATE2)
  Vbiei_Vbi_ei_Vbi_ei=(+0.0*(NP(bi)-NP(ei))+0.0*1.0+0.0*1.0+pModel->HICUMtype*0.0);
#endif
#endif
Vbiei=(pModel->HICUMtype*(NP(bi)-NP(ei)));
EXIT_IF_ISNAN((pModel->HICUMtype*(NP(bi)-NP(ei))))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
Vciei_Vci_ei=(pModel->HICUMtype);
#if defined(_DERIVATE2)
  Vciei_Vci_ei_Vci_ei=(+0.0*(NP(ci)-NP(ei))+0.0*1.0+0.0*1.0+pModel->HICUMtype*0.0);
#endif
#endif
Vciei=(pModel->HICUMtype*(NP(ci)-NP(ei)));
EXIT_IF_ISNAN((pModel->HICUMtype*(NP(ci)-NP(ei))))
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci) ddxprobe=V(s,GND) */
Vsci_Vs_ci=(pModel->HICUMtype);
#if defined(_DERIVATE2)
  Vsci_Vs_ci_Vs_ci=(+0.0*(NP(s)-NP(ci))+0.0*1.0+0.0*1.0+pModel->HICUMtype*0.0);
#endif
#endif
Vsci=(pModel->HICUMtype*(NP(s)-NP(ci)));
EXIT_IF_ISNAN((pModel->HICUMtype*(NP(s)-NP(ci))))
#if defined(_DERIVATE) /* probe=V(ei,e) ddxprobe= */
Veie_Vei_e=1.0;
#endif
Veie=(NP(ei)-NP(e));
EXIT_IF_ISNAN((NP(ei)-NP(e)))
#if defined(_DERIVATE) /* probe=V(ci,c) ddxprobe= */
Vcic_Vci_c=1.0;
#endif
Vcic=(NP(ci)-NP(c));
EXIT_IF_ISNAN((NP(ci)-NP(c)))
#if defined(_DERIVATE) /* probe=V(b,bi) ddxprobe= */
Vbbi_Vb_bi=1.0;
#endif
Vbbi=(NP(b)-NP(bi));
EXIT_IF_ISNAN((NP(b)-NP(bi)))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,e) ddxprobe= */
Vbe_Vb_e=(pModel->HICUMtype);
#endif
Vbe=(pModel->HICUMtype*(NP(b)-NP(e)));
EXIT_IF_ISNAN((pModel->HICUMtype*(NP(b)-NP(e))))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
Vrth_Vtnode_GND=1.0;
#endif
Vrth=NP(tnode);
EXIT_IF_ISNAN(NP(tnode))
TnomK=(pModel->tnom+273.15);
EXIT_IF_ISNAN((pModel->tnom+273.15))
Tamb=mint_get_circuit_tempK();
EXIT_IF_ISNAN(mint_get_circuit_tempK())
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
Tdev_Vtnode_GND=Vrth_Vtnode_GND;
#endif
Tdev=((Tamb+pInst->dtemp)+Vrth);
EXIT_IF_ISNAN(((Tamb+pInst->dtemp)+Vrth))
if
((Tdev<((-100.00)+273.15)))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
Tdev_Vtnode_GND=0.0;
#endif
Tdev=((-100.00)+273.15);
EXIT_IF_ISNAN(((-100.00)+273.15))
}
else
{
if
((Tdev>(326.85+273.15)))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
Tdev_Vtnode_GND=0.0;
#endif
Tdev=(326.85+273.15);
EXIT_IF_ISNAN((326.85+273.15))
}
}
vt0=((1.3806503e-23*TnomK)/1.6021766208e-19);
EXIT_IF_ISNAN(((1.3806503e-23*TnomK)/1.6021766208e-19))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
VT_Vtnode_GND=((1.3806503e-23*Tdev_Vtnode_GND)/1.6021766208e-19);
#endif
VT=((1.3806503e-23*Tdev)/1.6021766208e-19);
EXIT_IF_ISNAN(((1.3806503e-23*Tdev)/1.6021766208e-19))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
dT_Vtnode_GND=Tdev_Vtnode_GND;
#endif
dT=(Tdev-TnomK);
EXIT_IF_ISNAN((Tdev-TnomK))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qtt0_Vtnode_GND=(Tdev_Vtnode_GND/TnomK);
#endif
qtt0=(Tdev/TnomK);
EXIT_IF_ISNAN((Tdev/TnomK))
{
double m00_logE(d00_logE0,qtt0)
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,qtt0)
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
ln_qtt0_Vtnode_GND=qtt0_Vtnode_GND*d10_logE0;
#endif
ln_qtt0=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
avs=(pModel->alvs*TnomK);
EXIT_IF_ISNAN((pModel->alvs*TnomK))
vgbe=((pModel->vgb+pModel->vge)/2);
EXIT_IF_ISNAN(((pModel->vgb+pModel->vge)/2))
vgbc=((pModel->vgb+pModel->vgc)/2);
EXIT_IF_ISNAN(((pModel->vgb+pModel->vgc)/2))
#if defined(_DYNAMIC)
vgsc=((pModel->vgs+pModel->vgc)/2);
EXIT_IF_ISNAN(((pModel->vgs+pModel->vgc)/2))
#endif
mg=(3-((1.6021766208e-19*pModel->f1vg)/1.3806503e-23));
EXIT_IF_ISNAN((3-((1.6021766208e-19*pModel->f1vg)/1.3806503e-23)))
zetabci=((mg+1)-pModel->zetaci);
EXIT_IF_ISNAN(((mg+1)-pModel->zetaci))
zetasct=(mg-1.5);
EXIT_IF_ISNAN((mg-1.5))
{
double m00_exp(d00_exp0,((pModel->zetact*ln_qtt0)+((pModel->vgb/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
is_t_Vtnode_GND=(pModel->is*((pModel->zetact*ln_qtt0_Vtnode_GND)+(((-pModel->vgb*VT_Vtnode_GND/VT/VT)*(qtt0-1))+((pModel->vgb/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
is_t=(pModel->is*d00_exp0);
EXIT_IF_ISNAN((pModel->is*d00_exp0))
}
{
double m00_exp(d00_exp0,((pModel->zetabet*ln_qtt0)+((pModel->vge/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(bi,GND) */
ibes_t_Vtnode_GND=(pModel->ibes*((pModel->zetabet*ln_qtt0_Vtnode_GND)+(((-pModel->vge*VT_Vtnode_GND/VT/VT)*(qtt0-1))+((pModel->vge/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
ibes_t=(pModel->ibes*d00_exp0);
EXIT_IF_ISNAN((pModel->ibes*d00_exp0))
}
{
double m00_exp(d00_exp0,(((0.5*mg)*ln_qtt0)+(((0.5*vgbe)/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(bi,GND) */
ires_t_Vtnode_GND=(pModel->ires*(((0.5*mg)*ln_qtt0_Vtnode_GND)+(((-(0.5*vgbe)*VT_Vtnode_GND/VT/VT)*(qtt0-1))+(((0.5*vgbe)/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
ires_t=(pModel->ires*d00_exp0);
EXIT_IF_ISNAN((pModel->ires*d00_exp0))
}
{
double m00_exp(d00_exp0,((zetabci*ln_qtt0)+((pModel->vgc/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND) */
ibcs_t_Vtnode_GND=(pModel->ibcs*((zetabci*ln_qtt0_Vtnode_GND)+(((-pModel->vgc*VT_Vtnode_GND/VT/VT)*(qtt0-1))+((pModel->vgc/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
ibcs_t=(pModel->ibcs*d00_exp0);
EXIT_IF_ISNAN((pModel->ibcs*d00_exp0))
}
{
double m00_exp(d00_exp0,((zetasct*ln_qtt0)+((pModel->vgc/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
itss_t_Vtnode_GND=(pModel->itss*((zetasct*ln_qtt0_Vtnode_GND)+(((-pModel->vgc*VT_Vtnode_GND/VT/VT)*(qtt0-1))+((pModel->vgc/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
itss_t=(pModel->itss*d00_exp0);
EXIT_IF_ISNAN((pModel->itss*d00_exp0))
}
{
double m00_exp(d00_exp0,((zetasct*ln_qtt0)+((pModel->vgs/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
iscs_t_Vtnode_GND=(pModel->iscs*((zetasct*ln_qtt0_Vtnode_GND)+(((-pModel->vgs*VT_Vtnode_GND/VT/VT)*(qtt0-1))+((pModel->vgs/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
iscs_t=(pModel->iscs*d00_exp0);
EXIT_IF_ISNAN((pModel->iscs*d00_exp0))
}
arg=((0.5*pModel->vde)/vt0);
EXIT_IF_ISNAN(((0.5*pModel->vde)/vt0))
{
double m00_exp(d00_exp0,arg)
double m00_exp(d00_exp1,(-arg))
double m00_logE(d00_logE2,(d00_exp0-d00_exp1))
vdj0=((2*vt0)*d00_logE2);
EXIT_IF_ISNAN(((2*vt0)*d00_logE2))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
vdjt_Vtnode_GND=(((vdj0*qtt0_Vtnode_GND)+(vgbe*(-qtt0_Vtnode_GND)))-(((mg*VT_Vtnode_GND)*ln_qtt0)+((mg*VT)*ln_qtt0_Vtnode_GND)));
#endif
vdjt=(((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0));
EXIT_IF_ISNAN((((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0)))
{
double m00_exp(d00_exp0,((-vdjt)/VT))
double m00_sqrt(d00_sqrt1,(1+(4*d00_exp0)))
double m00_logE(d00_logE2,(0.5*(1+d00_sqrt1)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_sqrt(d10_sqrt1,d00_sqrt1,(1+(4*d00_exp0)))
double m10_logE(d10_logE2,d00_logE2,(0.5*(1+d00_sqrt1)))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND)V(bi,GND) */
vde_t_Vtnode_GND=(vdjt_Vtnode_GND+(((2*VT_Vtnode_GND)*d00_logE2)+((2*VT)*(0.5*(4*(((-vdjt_Vtnode_GND)*VT-(-vdjt)*VT_Vtnode_GND)/VT/VT)*d10_exp0)*d10_sqrt1)*d10_logE2)));
#endif
vde_t=(vdjt+((2*VT)*d00_logE2));
EXIT_IF_ISNAN((vdjt+((2*VT)*d00_logE2)))
}
{
double m00_logE(d00_logE0,(pModel->vde/vde_t))
double m00_exp(d00_exp1,(pModel->ze*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(pModel->vde/vde_t))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(bi,GND) */
cje0_t_Vtnode_GND=(pModel->cje0*(pModel->ze*(-pModel->vde*vde_t_Vtnode_GND/vde_t/vde_t)*d10_logE0)*d10_exp1);
#endif
cje0_t=(pModel->cje0*d00_exp1);
EXIT_IF_ISNAN((pModel->cje0*d00_exp1))
}
cje0_dc=pModel->cje0;
EXIT_IF_ISNAN(pModel->cje0)
arg=((0.5*pModel->vdedc)/vt0);
EXIT_IF_ISNAN(((0.5*pModel->vdedc)/vt0))
{
double m00_exp(d00_exp0,arg)
double m00_exp(d00_exp1,(-arg))
double m00_logE(d00_logE2,(d00_exp0-d00_exp1))
vdj0=((2*vt0)*d00_logE2);
EXIT_IF_ISNAN(((2*vt0)*d00_logE2))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
vdjt_Vtnode_GND=(((vdj0*qtt0_Vtnode_GND)+(vgbe*(-qtt0_Vtnode_GND)))-(((mg*VT_Vtnode_GND)*ln_qtt0)+((mg*VT)*ln_qtt0_Vtnode_GND)));
#endif
vdjt=(((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0));
EXIT_IF_ISNAN((((vdj0*qtt0)+(vgbe*(1-qtt0)))-((mg*VT)*ln_qtt0)))
{
double m00_exp(d00_exp0,((-vdjt)/VT))
double m00_sqrt(d00_sqrt1,(1+(4*d00_exp0)))
double m00_logE(d00_logE2,(0.5*(1+d00_sqrt1)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_sqrt(d10_sqrt1,d00_sqrt1,(1+(4*d00_exp0)))
double m10_logE(d10_logE2,d00_logE2,(0.5*(1+d00_sqrt1)))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
vdedc_t_Vtnode_GND=(vdjt_Vtnode_GND+(((2*VT_Vtnode_GND)*d00_logE2)+((2*VT)*(0.5*(4*(((-vdjt_Vtnode_GND)*VT-(-vdjt)*VT_Vtnode_GND)/VT/VT)*d10_exp0)*d10_sqrt1)*d10_logE2)));
#endif
vdedc_t=(vdjt+((2*VT)*d00_logE2));
EXIT_IF_ISNAN((vdjt+((2*VT)*d00_logE2)))
}
{
double m00_logE(d00_logE0,(pModel->vdedc/vdedc_t))
double m00_exp(d00_exp1,(pModel->zedc*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(pModel->vdedc/vdedc_t))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
cje0_dc_t_Vtnode_GND=(cje0_dc*(pModel->zedc*(-pModel->vdedc*vdedc_t_Vtnode_GND/vdedc_t/vdedc_t)*d10_logE0)*d10_exp1);
#endif
cje0_dc_t=(cje0_dc*d00_exp1);
EXIT_IF_ISNAN((cje0_dc*d00_exp1))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND)V(bi,GND) */
aje_t_Vtnode_GND=((pModel->aje*vde_t_Vtnode_GND)/pModel->vde);
#endif
aje_t=((pModel->aje*vde_t)/pModel->vde);
EXIT_IF_ISNAN(((pModel->aje*vde_t)/pModel->vde))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND)V(s,GND)V(ei,GND) */
ajedc_t_Vtnode_GND=((pModel->ajedc*vdedc_t_Vtnode_GND)/pModel->vdedc);
#endif
ajedc_t=((pModel->ajedc*vdedc_t)/pModel->vdedc);
EXIT_IF_ISNAN(((pModel->ajedc*vdedc_t)/pModel->vdedc))
arg=((0.5*pModel->vdci)/vt0);
EXIT_IF_ISNAN(((0.5*pModel->vdci)/vt0))
{
double m00_exp(d00_exp0,arg)
double m00_exp(d00_exp1,(-arg))
double m00_logE(d00_logE2,(d00_exp0-d00_exp1))
vdj0=((2*vt0)*d00_logE2);
EXIT_IF_ISNAN(((2*vt0)*d00_logE2))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
vdjt_Vtnode_GND=(((vdj0*qtt0_Vtnode_GND)+(vgbc*(-qtt0_Vtnode_GND)))-(((mg*VT_Vtnode_GND)*ln_qtt0)+((mg*VT)*ln_qtt0_Vtnode_GND)));
#endif
vdjt=(((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0));
EXIT_IF_ISNAN((((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0)))
{
double m00_exp(d00_exp0,((-vdjt)/VT))
double m00_sqrt(d00_sqrt1,(1+(4*d00_exp0)))
double m00_logE(d00_logE2,(0.5*(1+d00_sqrt1)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_sqrt(d10_sqrt1,d00_sqrt1,(1+(4*d00_exp0)))
double m10_logE(d10_logE2,d00_logE2,(0.5*(1+d00_sqrt1)))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
vdci_t_Vtnode_GND=(vdjt_Vtnode_GND+(((2*VT_Vtnode_GND)*d00_logE2)+((2*VT)*(0.5*(4*(((-vdjt_Vtnode_GND)*VT-(-vdjt)*VT_Vtnode_GND)/VT/VT)*d10_exp0)*d10_sqrt1)*d10_logE2)));
#endif
vdci_t=(vdjt+((2*VT)*d00_logE2));
EXIT_IF_ISNAN((vdjt+((2*VT)*d00_logE2)))
}
{
double m00_logE(d00_logE0,(pModel->vdci/vdci_t))
double m00_exp(d00_exp1,(pModel->zci*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(pModel->vdci/vdci_t))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
cjci0_t_Vtnode_GND=(pModel->cjci0*(pModel->zci*(-pModel->vdci*vdci_t_Vtnode_GND/vdci_t/vdci_t)*d10_logE0)*d10_exp1);
#endif
cjci0_t=(pModel->cjci0*d00_exp1);
EXIT_IF_ISNAN((pModel->cjci0*d00_exp1))
}
arg=((0.5*pModel->vdcx)/vt0);
EXIT_IF_ISNAN(((0.5*pModel->vdcx)/vt0))
{
double m00_exp(d00_exp0,arg)
double m00_exp(d00_exp1,(-arg))
double m00_logE(d00_logE2,(d00_exp0-d00_exp1))
vdj0=((2*vt0)*d00_logE2);
EXIT_IF_ISNAN(((2*vt0)*d00_logE2))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
vdjt_Vtnode_GND=(((vdj0*qtt0_Vtnode_GND)+(vgbc*(-qtt0_Vtnode_GND)))-(((mg*VT_Vtnode_GND)*ln_qtt0)+((mg*VT)*ln_qtt0_Vtnode_GND)));
#endif
vdjt=(((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0));
EXIT_IF_ISNAN((((vdj0*qtt0)+(vgbc*(1-qtt0)))-((mg*VT)*ln_qtt0)))
{
double m00_exp(d00_exp0,((-vdjt)/VT))
double m00_sqrt(d00_sqrt1,(1+(4*d00_exp0)))
double m00_logE(d00_logE2,(0.5*(1+d00_sqrt1)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_sqrt(d10_sqrt1,d00_sqrt1,(1+(4*d00_exp0)))
double m10_logE(d10_logE2,d00_logE2,(0.5*(1+d00_sqrt1)))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND)V(bi,GND)V(ei,GND)V(ci,GND) */
vdcx_t_Vtnode_GND=(vdjt_Vtnode_GND+(((2*VT_Vtnode_GND)*d00_logE2)+((2*VT)*(0.5*(4*(((-vdjt_Vtnode_GND)*VT-(-vdjt)*VT_Vtnode_GND)/VT/VT)*d10_exp0)*d10_sqrt1)*d10_logE2)));
#endif
vdcx_t=(vdjt+((2*VT)*d00_logE2));
EXIT_IF_ISNAN((vdjt+((2*VT)*d00_logE2)))
}
{
double m00_logE(d00_logE0,(pModel->vdcx/vdcx_t))
double m00_exp(d00_exp1,(pModel->zcx*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(pModel->vdcx/vdcx_t))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
cjcx0_t_Vtnode_GND=(pModel->cjcx0*(pModel->zcx*(-pModel->vdcx*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t)*d10_logE0)*d10_exp1);
#endif
cjcx0_t=(pModel->cjcx0*d00_exp1);
EXIT_IF_ISNAN((pModel->cjcx0*d00_exp1))
}
#if defined(_DYNAMIC)
arg=((0.5*pModel->vds)/vt0);
EXIT_IF_ISNAN(((0.5*pModel->vds)/vt0))
#endif
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,arg)
double m00_exp(d00_exp1,(-arg))
double m00_logE(d00_logE2,(d00_exp0-d00_exp1))
vdj0=((2*vt0)*d00_logE2);
EXIT_IF_ISNAN(((2*vt0)*d00_logE2))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
vdjt_Vtnode_GND=(((vdj0*qtt0_Vtnode_GND)+(vgsc*(-qtt0_Vtnode_GND)))-(((mg*VT_Vtnode_GND)*ln_qtt0)+((mg*VT)*ln_qtt0_Vtnode_GND)));
#endif
vdjt=(((vdj0*qtt0)+(vgsc*(1-qtt0)))-((mg*VT)*ln_qtt0));
EXIT_IF_ISNAN((((vdj0*qtt0)+(vgsc*(1-qtt0)))-((mg*VT)*ln_qtt0)))
#endif
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,((-vdjt)/VT))
double m00_sqrt(d00_sqrt1,(1+(4*d00_exp0)))
double m00_logE(d00_logE2,(0.5*(1+d00_sqrt1)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_sqrt(d10_sqrt1,d00_sqrt1,(1+(4*d00_exp0)))
double m10_logE(d10_logE2,d00_logE2,(0.5*(1+d00_sqrt1)))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND) */
vds_t_Vtnode_GND=(vdjt_Vtnode_GND+(((2*VT_Vtnode_GND)*d00_logE2)+((2*VT)*(0.5*(4*(((-vdjt_Vtnode_GND)*VT-(-vdjt)*VT_Vtnode_GND)/VT/VT)*d10_exp0)*d10_sqrt1)*d10_logE2)));
#endif
vds_t=(vdjt+((2*VT)*d00_logE2));
EXIT_IF_ISNAN((vdjt+((2*VT)*d00_logE2)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(pModel->vds/vds_t))
double m00_exp(d00_exp1,(pModel->zs*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(pModel->vds/vds_t))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND) */
cjs0_t_Vtnode_GND=(pModel->cjs0*(pModel->zs*(-pModel->vds*vds_t_Vtnode_GND/vds_t/vds_t)*d10_logE0)*d10_exp1);
#endif
cjs0_t=(pModel->cjs0*d00_exp1);
EXIT_IF_ISNAN((pModel->cjs0*d00_exp1))
}
#endif
{
double m00_exp(d00_exp0,((pModel->zetaiqf*ln_qtt0)-((pModel->dvgbe/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
iqf_t_Vtnode_GND=(pModel->iqf*((pModel->zetaiqf*ln_qtt0_Vtnode_GND)-(((-pModel->dvgbe*VT_Vtnode_GND/VT/VT)*(qtt0-1))+((pModel->dvgbe/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
iqf_t=(pModel->iqf*d00_exp0);
EXIT_IF_ISNAN((pModel->iqf*d00_exp0))
}
{
double m00_exp(d00_exp0,(pModel->zetaci*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
rci0_t_Vtnode_GND=(pModel->rci0*(pModel->zetaci*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
rci0_t=(pModel->rci0*d00_exp0);
EXIT_IF_ISNAN((pModel->rci0*d00_exp0))
}
{
double m00_exp(d00_exp0,((pModel->zetaci-avs)*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
vlim_t_Vtnode_GND=(pModel->vlim*((pModel->zetaci-avs)*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
vlim_t=(pModel->vlim*d00_exp0);
EXIT_IF_ISNAN((pModel->vlim*d00_exp0))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
vces_t_Vtnode_GND=(pModel->vces*(pModel->alces*dT_Vtnode_GND));
#endif
vces_t=(pModel->vces*(1+(pModel->alces*dT)));
EXIT_IF_ISNAN((pModel->vces*(1+(pModel->alces*dT))))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
t0_t_Vtnode_GND=(pModel->t0*((pModel->alt0*dT_Vtnode_GND)+(((pModel->kt0*dT_Vtnode_GND)*dT)+((pModel->kt0*dT)*dT_Vtnode_GND))));
#endif
t0_t=(pModel->t0*((1+(pModel->alt0*dT))+((pModel->kt0*dT)*dT)));
EXIT_IF_ISNAN((pModel->t0*((1+(pModel->alt0*dT))+((pModel->kt0*dT)*dT))))
{
double m00_exp(d00_exp0,((pModel->zetaci-1)*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND) */
thcs_t_Vtnode_GND=(pModel->thcs*((pModel->zetaci-1)*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
thcs_t=(pModel->thcs*d00_exp0);
EXIT_IF_ISNAN((pModel->thcs*d00_exp0))
}
zetatef=((pModel->zetabet-pModel->zetact)-0.5);
EXIT_IF_ISNAN(((pModel->zetabet-pModel->zetact)-0.5))
dvg=(pModel->vgb-pModel->vge);
EXIT_IF_ISNAN((pModel->vgb-pModel->vge))
if
((pModel->tef_temp==1))
{
{
double m00_exp(d00_exp0,((zetatef*ln_qtt0)-((dvg/VT)*(qtt0-1))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND) */
tef0_t_Vtnode_GND=(pModel->tef0*((zetatef*ln_qtt0_Vtnode_GND)-(((-dvg*VT_Vtnode_GND/VT/VT)*(qtt0-1))+((dvg/VT)*qtt0_Vtnode_GND)))*d10_exp0);
#endif
tef0_t=(pModel->tef0*d00_exp0);
EXIT_IF_ISNAN((pModel->tef0*d00_exp0))
}
}
else
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND) */
tef0_t_Vtnode_GND=0.0;
#endif
tef0_t=pModel->tef0;
EXIT_IF_ISNAN(pModel->tef0)
}
{
double m00_exp(d00_exp0,(pModel->zetarbx*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
rbx_t_Vtnode_GND=(pModel->rbx*(pModel->zetarbx*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
rbx_t=(pModel->rbx*d00_exp0);
EXIT_IF_ISNAN((pModel->rbx*d00_exp0))
}
{
double m00_exp(d00_exp0,(pModel->zetarcx*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
rcx_t_Vtnode_GND=(pModel->rcx*(pModel->zetarcx*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
rcx_t=(pModel->rcx*d00_exp0);
EXIT_IF_ISNAN((pModel->rcx*d00_exp0))
}
{
double m00_exp(d00_exp0,(pModel->zetarbi*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
rbi0_t_Vtnode_GND=(pModel->rbi0*(pModel->zetarbi*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
rbi0_t=(pModel->rbi0*d00_exp0);
EXIT_IF_ISNAN((pModel->rbi0*d00_exp0))
}
{
double m00_exp(d00_exp0,(pModel->zetare*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
re_t_Vtnode_GND=(pModel->re*(pModel->zetare*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
re_t=(pModel->re*d00_exp0);
EXIT_IF_ISNAN((pModel->re*d00_exp0))
}
{
double m00_exp(d00_exp0,(pModel->aleav*dT))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND) */
eavl_t_Vtnode_GND=(pModel->eavl*(pModel->aleav*dT_Vtnode_GND)*d10_exp0);
#endif
eavl_t=(pModel->eavl*d00_exp0);
EXIT_IF_ISNAN((pModel->eavl*d00_exp0))
}
{
double m00_exp(d00_exp0,(pModel->alkav*dT))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND) */
kavl_t_Vtnode_GND=(pModel->kavl*(pModel->alkav*dT_Vtnode_GND)*d10_exp0);
#endif
kavl_t=(pModel->kavl*d00_exp0);
EXIT_IF_ISNAN((pModel->kavl*d00_exp0))
}
if
((pModel->zetarth!=0))
{
{
double m00_logE(d00_logE0,(Tdev/TnomK))
double m00_exp(d00_exp1,(pModel->zetarth*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(Tdev/TnomK))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
rth_t_Vtnode_GND=(pModel->rth*(pModel->zetarth*(Tdev_Vtnode_GND/TnomK)*d10_logE0)*d10_exp1);
#endif
rth_t=(pModel->rth*d00_exp1);
EXIT_IF_ISNAN((pModel->rth*d00_exp1))
}
}
else
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
rth_t_Vtnode_GND=0.0;
#endif
rth_t=pModel->rth;
EXIT_IF_ISNAN(pModel->rth)
}
{
double m00_exp(d00_exp0,(pModel->zetaver*ln_qtt0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
aver_t_Vtnode_GND=(pModel->aver*(pModel->zetaver*ln_qtt0_Vtnode_GND)*d10_exp0);
#endif
aver_t=(pModel->aver*d00_exp0);
EXIT_IF_ISNAN((pModel->aver*d00_exp0))
}
{
double m00_exp(d00_exp0,(pModel->zetavgbe*ln_qtt0))
double m00_exp(d00_exp1,((pModel->dvgbe/VT)*(d00_exp0-1)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
ver_t_Vtnode_GND=(-pModel->ver*(((-pModel->dvgbe*VT_Vtnode_GND/VT/VT)*(d00_exp0-1))+((pModel->dvgbe/VT)*(pModel->zetavgbe*ln_qtt0_Vtnode_GND)*d10_exp0))*d10_exp1/d00_exp1/d00_exp1);
#endif
ver_t=(pModel->ver/d00_exp1);
EXIT_IF_ISNAN((pModel->ver/d00_exp1))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
iqfh_t_Vtnode_GND=(pModel->iqfh*((pModel->aliqfh*dT_Vtnode_GND)+(((pModel->kiqfh*dT_Vtnode_GND)*dT)+((pModel->kiqfh*dT)*dT_Vtnode_GND))));
#endif
iqfh_t=(pModel->iqfh*((1+(pModel->aliqfh*dT))+((pModel->kiqfh*dT)*dT)));
EXIT_IF_ISNAN((pModel->iqfh*((1+(pModel->aliqfh*dT))+((pModel->kiqfh*dT)*dT))))
{
double m00_exp(d00_exp0,(((pModel->vgb-pModel->vge)/VT)*(qtt0-1)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
tfh_t_Vtnode_GND=(((pModel->tfh*((pModel->aliqfh*dT_Vtnode_GND)+(((pModel->kiqfh*dT_Vtnode_GND)*dT)+((pModel->kiqfh*dT)*dT_Vtnode_GND))))*d00_exp0)+((pModel->tfh*((1+(pModel->aliqfh*dT))+((pModel->kiqfh*dT)*dT)))*(((-(pModel->vgb-pModel->vge)*VT_Vtnode_GND/VT/VT)*(qtt0-1))+(((pModel->vgb-pModel->vge)/VT)*qtt0_Vtnode_GND))*d10_exp0));
#endif
tfh_t=((pModel->tfh*((1+(pModel->aliqfh*dT))+((pModel->kiqfh*dT)*dT)))*d00_exp0);
EXIT_IF_ISNAN(((pModel->tfh*((1+(pModel->aliqfh*dT))+((pModel->kiqfh*dT)*dT)))*d00_exp0))
}
ahq_t=pModel->ahq;
EXIT_IF_ISNAN(pModel->ahq)
if
((cjcx0_t>0.0))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
cjci0_t_ii_Vtnode_GND=cjci0_t_Vtnode_GND;
#endif
cjci0_t_ii=cjci0_t;
EXIT_IF_ISNAN(cjci0_t)
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND)V(bi,GND)V(ei,GND)V(ci,GND) */
cjcx0_t_ii_Vtnode_GND=cjcx0_t_Vtnode_GND*pModel->fbc;
#endif
cjcx0_t_ii=(cjcx0_t*pModel->fbc);
EXIT_IF_ISNAN((cjcx0_t*pModel->fbc))
if
((pModel->vptcx<1.0e2))
{
if
((cjcx0_t_ii>0.0))
{
zr=(pModel->zcx/4.0);
EXIT_IF_ISNAN((pModel->zcx/4.0))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vp_Vtnode_GND=(-vdcx_t_Vtnode_GND);
#endif
vp=(pModel->vptcx-vdcx_t);
EXIT_IF_ISNAN((pModel->vptcx-vdcx_t))
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zcx))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdcx_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdcx_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdcx_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
cmax_Vtnode_GND=(2.4*cjcx0_t_ii_Vtnode_GND);
#endif
cmax=(2.4*cjcx0_t_ii);
EXIT_IF_ISNAN((2.4*cjcx0_t_ii))
{
double m00_logE(d00_logE0,(vdcx_t/pModel->vptcx))
double m00_exp(d00_exp1,((pModel->zcx-zr)*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(vdcx_t/pModel->vptcx))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
cr_Vtnode_GND=((cjcx0_t_ii_Vtnode_GND*d00_exp1)+(cjcx0_t_ii*((pModel->zcx-zr)*(vdcx_t_Vtnode_GND/pModel->vptcx)*d10_logE0)*d10_exp1));
#endif
cr=(cjcx0_t_ii*d00_exp1);
EXIT_IF_ISNAN((cjcx0_t_ii*d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=VT_Vtnode_GND;
#endif
#endif
a=VT;
EXIT_IF_ISNAN(VT)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ve_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vs_ci_Vs_ci=0.0;
  ve_Vs_ci_Vci_ei=0.0;
  ve_Vs_ci_Vbi_ei=0.0;
  ve_Vs_ci_Vb_ci=0.0;
  ve_Vs_ci_Vtnode_GND=0.0;
  ve_Vs_ci_Vbi_ci=0.0;
#endif
ve_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vci_ei_Vs_ci=0.0;
  ve_Vci_ei_Vci_ei=0.0;
  ve_Vci_ei_Vbi_ei=0.0;
  ve_Vci_ei_Vb_ci=0.0;
  ve_Vci_ei_Vtnode_GND=0.0;
  ve_Vci_ei_Vbi_ci=0.0;
#endif
ve_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vbi_ei_Vs_ci=0.0;
  ve_Vbi_ei_Vci_ei=0.0;
  ve_Vbi_ei_Vbi_ei=0.0;
  ve_Vbi_ei_Vb_ci=0.0;
  ve_Vbi_ei_Vtnode_GND=0.0;
  ve_Vbi_ei_Vbi_ci=0.0;
#endif
ve_Vb_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vb_ci_Vs_ci=0.0;
  ve_Vb_ci_Vci_ei=0.0;
  ve_Vb_ci_Vbi_ei=0.0;
  ve_Vb_ci_Vb_ci=0.0;
  ve_Vb_ci_Vtnode_GND=0.0;
  ve_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
ve_Vtnode_GND=((vf_Vtnode_GND*a-(vf-Vbici)*a_Vtnode_GND)/a/a);
#endif
ve_Vbi_ci=(((-Vbici_Vbi_ci)*a-(vf-Vbici)*a_Vbi_ci)/a/a);
#if defined(_DERIVATE2)
  ve_Vbi_ci_Vs_ci=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*0.0+0.0*a_Vbi_ci+(vf-Vbici)*0.0)/a/a+2*(vf-Vbici)*a_Vbi_ci*0.0/a/a/a);
  ve_Vbi_ci_Vci_ei=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vci_ei+0.0*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vci_ei)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vci_ei/a/a/a);
  ve_Vbi_ci_Vbi_ei=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vbi_ei+0.0*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vbi_ei)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  ve_Vbi_ci_Vb_ci=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vb_ci+0.0*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vb_ci)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vb_ci/a/a/a);
  ve_Vbi_ci_Vtnode_GND=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vtnode_GND+vf_Vtnode_GND*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  ve_Vbi_ci_Vbi_ci=((+0.0-Vbici_Vbi_ci_Vbi_ci)/a-((-Vbici_Vbi_ci)*a_Vbi_ci+(-Vbici_Vbi_ci)*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vbi_ci)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
ve=((vf-Vbici)/a);
EXIT_IF_ISNAN(((vf-Vbici)/a))
if
((ve<=80.0))
{
{
double m00_exp(d00_exp0,ve)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=0.0;
  ex1_Vb_ci_Vci_ei=0.0;
  ex1_Vb_ci_Vbi_ei=0.0;
  ex1_Vb_ci_Vb_ci=0.0;
  ex1_Vb_ci_Vtnode_GND=0.0;
  ex1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=ve_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=ve_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=0.0;
  ee1_Vb_ci_Vci_ei=0.0;
  ee1_Vb_ci_Vbi_ei=0.0;
  ee1_Vb_ci_Vb_ci=0.0;
  ee1_Vb_ci_Vtnode_GND=0.0;
  ee1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=0.0;
  vj1_Vb_ci_Vbi_ei=0.0;
  vj1_Vb_ci_Vs_ci=0.0;
  vj1_Vb_ci_Vb_ci=0.0;
  vj1_Vb_ci_Vtnode_GND=0.0;
  vj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=(vf_Vtnode_GND-((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj1_Vbi_ci=(-((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=(+0.0-(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj1_Vbi_ci_Vbi_ei=(+0.0-(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj1_Vbi_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj1_Vbi_ci_Vb_ci=(+0.0-(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj1_Vbi_ci_Vtnode_GND=(+0.0-(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj1_Vbi_ci_Vbi_ci=(+0.0-(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj1=(vf-(a*d00_logE0));
EXIT_IF_ISNAN((vf-(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=0.0;
  vj1_Vb_ci_Vbi_ei=0.0;
  vj1_Vb_ci_Vs_ci=0.0;
  vj1_Vb_ci_Vb_ci=0.0;
  vj1_Vb_ci_Vtnode_GND=0.0;
  vj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=0.0;
#endif
vj1_Vbi_ci=Vbici_Vbi_ci;
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=0.0;
  vj1_Vbi_ci_Vbi_ei=0.0;
  vj1_Vbi_ci_Vs_ci=0.0;
  vj1_Vbi_ci_Vb_ci=0.0;
  vj1_Vbi_ci_Vtnode_GND=0.0;
  vj1_Vbi_ci_Vbi_ci=Vbici_Vbi_ci_Vbi_ci;
#endif
#endif
vj1=Vbici;
EXIT_IF_ISNAN(Vbici)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=((0.1*vp_Vtnode_GND)+(4.0*VT_Vtnode_GND));
#endif
#endif
a=((0.1*vp)+(4.0*VT));
EXIT_IF_ISNAN(((0.1*vp)+(4.0*VT)))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vr_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vci_ei_Vci_ei=0.0;
  vr_Vci_ei_Vbi_ei=0.0;
  vr_Vci_ei_Vs_ci=0.0;
  vr_Vci_ei_Vb_ci=0.0;
  vr_Vci_ei_Vtnode_GND=0.0;
  vr_Vci_ei_Vbi_ci=0.0;
#endif
vr_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vbi_ei_Vci_ei=0.0;
  vr_Vbi_ei_Vbi_ei=0.0;
  vr_Vbi_ei_Vs_ci=0.0;
  vr_Vbi_ei_Vb_ci=0.0;
  vr_Vbi_ei_Vtnode_GND=0.0;
  vr_Vbi_ei_Vbi_ci=0.0;
#endif
vr_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vr_Vs_ci_Vci_ei=0.0;
  vr_Vs_ci_Vbi_ei=0.0;
  vr_Vs_ci_Vs_ci=0.0;
  vr_Vs_ci_Vb_ci=0.0;
  vr_Vs_ci_Vtnode_GND=0.0;
  vr_Vs_ci_Vbi_ci=0.0;
#endif
vr_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vr_Vb_ci_Vci_ei=0.0;
  vr_Vb_ci_Vbi_ei=0.0;
  vr_Vb_ci_Vs_ci=0.0;
  vr_Vb_ci_Vb_ci=0.0;
  vr_Vb_ci_Vtnode_GND=0.0;
  vr_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vr_Vtnode_GND=(((vp_Vtnode_GND+vj1_Vtnode_GND)*a-(vp+vj1)*a_Vtnode_GND)/a/a);
#endif
vr_Vbi_ci=((vj1_Vbi_ci*a-(vp+vj1)*a_Vbi_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vbi_ci_Vci_ei=((+0.0+vj1_Vbi_ci_Vci_ei)/a-(vj1_Vbi_ci*a_Vci_ei+vj1_Vci_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vci_ei/a/a/a);
  vr_Vbi_ci_Vbi_ei=((+0.0+vj1_Vbi_ci_Vbi_ei)/a-(vj1_Vbi_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  vr_Vbi_ci_Vs_ci=((+0.0+vj1_Vbi_ci_Vs_ci)/a-(vj1_Vbi_ci*0.0+vj1_Vs_ci*a_Vbi_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vbi_ci*0.0/a/a/a);
  vr_Vbi_ci_Vb_ci=((+0.0+vj1_Vbi_ci_Vb_ci)/a-(vj1_Vbi_ci*a_Vb_ci+vj1_Vb_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vb_ci/a/a/a);
  vr_Vbi_ci_Vtnode_GND=((+0.0+vj1_Vbi_ci_Vtnode_GND)/a-(vj1_Vbi_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  vr_Vbi_ci_Vbi_ci=((+0.0+vj1_Vbi_ci_Vbi_ci)/a-(vj1_Vbi_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
vr=((vp+vj1)/a);
EXIT_IF_ISNAN(((vp+vj1)/a))
if
((vr<=80.0))
{
{
double m00_exp(d00_exp0,vr)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=0.0;
  ex1_Vb_ci_Vci_ei=0.0;
  ex1_Vb_ci_Vbi_ei=0.0;
  ex1_Vb_ci_Vb_ci=0.0;
  ex1_Vb_ci_Vtnode_GND=0.0;
  ex1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=vr_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=vr_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=0.0;
  ee1_Vb_ci_Vci_ei=0.0;
  ee1_Vb_ci_Vbi_ei=0.0;
  ee1_Vb_ci_Vb_ci=0.0;
  ee1_Vb_ci_Vtnode_GND=0.0;
  ee1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=0.0;
  vj2_Vb_ci_Vbi_ei=0.0;
  vj2_Vb_ci_Vs_ci=0.0;
  vj2_Vb_ci_Vb_ci=0.0;
  vj2_Vb_ci_Vtnode_GND=0.0;
  vj2_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=((-vp_Vtnode_GND)+((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj2_Vbi_ci=((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=(+0.0+(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj2_Vbi_ci_Vbi_ei=(+0.0+(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj2_Vbi_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj2_Vbi_ci_Vb_ci=(+0.0+(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj2_Vbi_ci_Vtnode_GND=(+0.0+(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj2_Vbi_ci_Vbi_ci=(+0.0+(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj2=((-vp)+(a*d00_logE0));
EXIT_IF_ISNAN(((-vp)+(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=0.0;
  vj2_Vb_ci_Vbi_ei=0.0;
  vj2_Vb_ci_Vs_ci=0.0;
  vj2_Vb_ci_Vb_ci=0.0;
  vj2_Vb_ci_Vtnode_GND=0.0;
  vj2_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=vj1_Vtnode_GND;
#endif
vj2_Vbi_ci=vj1_Vbi_ci;
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=vj1_Vbi_ci_Vci_ei;
  vj2_Vbi_ci_Vbi_ei=vj1_Vbi_ci_Vbi_ei;
  vj2_Vbi_ci_Vs_ci=vj1_Vbi_ci_Vs_ci;
  vj2_Vbi_ci_Vb_ci=vj1_Vbi_ci_Vb_ci;
  vj2_Vbi_ci_Vtnode_GND=vj1_Vbi_ci_Vtnode_GND;
  vj2_Vbi_ci_Vbi_ci=vj1_Vbi_ci_Vbi_ci;
#endif
#endif
vj2=vj1;
EXIT_IF_ISNAN(vj1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj4_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj4_Vs_ci_Vs_ci=0.0;
  vj4_Vs_ci_Vci_ei=0.0;
  vj4_Vs_ci_Vbi_ei=0.0;
  vj4_Vs_ci_Vb_ci=0.0;
  vj4_Vs_ci_Vbi_ci=0.0;
  vj4_Vs_ci_Vtnode_GND=0.0;
#endif
vj4_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vci_ei_Vs_ci=0.0;
  vj4_Vci_ei_Vci_ei=0.0;
  vj4_Vci_ei_Vbi_ei=0.0;
  vj4_Vci_ei_Vb_ci=0.0;
  vj4_Vci_ei_Vbi_ci=0.0;
  vj4_Vci_ei_Vtnode_GND=0.0;
#endif
vj4_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vbi_ei_Vs_ci=0.0;
  vj4_Vbi_ei_Vci_ei=0.0;
  vj4_Vbi_ei_Vbi_ei=0.0;
  vj4_Vbi_ei_Vb_ci=0.0;
  vj4_Vbi_ei_Vbi_ci=0.0;
  vj4_Vbi_ei_Vtnode_GND=0.0;
#endif
vj4_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vj4_Vb_ci_Vs_ci=0.0;
  vj4_Vb_ci_Vci_ei=0.0;
  vj4_Vb_ci_Vbi_ei=0.0;
  vj4_Vb_ci_Vb_ci=0.0;
  vj4_Vb_ci_Vbi_ci=0.0;
  vj4_Vb_ci_Vtnode_GND=0.0;
#endif
vj4_Vbi_ci=(Vbici_Vbi_ci-vj1_Vbi_ci);
#if defined(_DERIVATE2)
  vj4_Vbi_ci_Vs_ci=(+0.0-vj1_Vbi_ci_Vs_ci);
  vj4_Vbi_ci_Vci_ei=(+0.0-vj1_Vbi_ci_Vci_ei);
  vj4_Vbi_ci_Vbi_ei=(+0.0-vj1_Vbi_ci_Vbi_ei);
  vj4_Vbi_ci_Vb_ci=(+0.0-vj1_Vbi_ci_Vb_ci);
  vj4_Vbi_ci_Vbi_ci=(+Vbici_Vbi_ci_Vbi_ci-vj1_Vbi_ci_Vbi_ci);
  vj4_Vbi_ci_Vtnode_GND=(+0.0-vj1_Vbi_ci_Vtnode_GND);
#endif
#if defined(_DERIVATE)
vj4_Vtnode_GND=(-vj1_Vtnode_GND);
#endif
#endif
vj4=(Vbici-vj1);
EXIT_IF_ISNAN((Vbici-vj1))
ez=(1.0-pModel->zcx);
EXIT_IF_ISNAN((1.0-pModel->zcx))
ezr=(1.0-zr);
EXIT_IF_ISNAN((1.0-zr))
{
double m00_logE(d00_logE0,(1.0-(vj1/vdcx_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj1/vdcx_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vci_ei_Vci_ei=0.0;
  vdj1_Vci_ei_Vbi_ei=0.0;
  vdj1_Vci_ei_Vs_ci=0.0;
  vdj1_Vci_ei_Vb_ci=0.0;
  vdj1_Vci_ei_Vtnode_GND=0.0;
  vdj1_Vci_ei_Vbi_ci=0.0;
#endif
vdj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ei_Vci_ei=0.0;
  vdj1_Vbi_ei_Vbi_ei=0.0;
  vdj1_Vbi_ei_Vs_ci=0.0;
  vdj1_Vbi_ei_Vb_ci=0.0;
  vdj1_Vbi_ei_Vtnode_GND=0.0;
  vdj1_Vbi_ei_Vbi_ci=0.0;
#endif
vdj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj1_Vs_ci_Vci_ei=0.0;
  vdj1_Vs_ci_Vbi_ei=0.0;
  vdj1_Vs_ci_Vs_ci=0.0;
  vdj1_Vs_ci_Vb_ci=0.0;
  vdj1_Vs_ci_Vtnode_GND=0.0;
  vdj1_Vs_ci_Vbi_ci=0.0;
#endif
vdj1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vdj1_Vb_ci_Vci_ei=0.0;
  vdj1_Vb_ci_Vbi_ei=0.0;
  vdj1_Vb_ci_Vs_ci=0.0;
  vdj1_Vb_ci_Vb_ci=0.0;
  vdj1_Vb_ci_Vtnode_GND=0.0;
  vdj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vdj1_Vtnode_GND=(-((vj1_Vtnode_GND*vdcx_t-vj1*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0;
#endif
vdj1_Vbi_ci=(-(vj1_Vbi_ci/vdcx_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vci_ei/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vci_ei/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vbi_ei/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ei/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vs_ci/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vs_ci/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vb_ci/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vb_ci/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vdcx_t)))*(-((vj1_Vtnode_GND*vdcx_t-vj1*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vtnode_GND/vdcx_t-(vj1_Vbi_ci*vdcx_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vbi_ci/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ci/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
#endif
#endif
vdj1=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_logE(d00_logE0,(1.0-(vj2/vdcx_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj2/vdcx_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vci_ei_Vci_ei=0.0;
  vdj2_Vci_ei_Vbi_ei=0.0;
  vdj2_Vci_ei_Vs_ci=0.0;
  vdj2_Vci_ei_Vb_ci=0.0;
  vdj2_Vci_ei_Vtnode_GND=0.0;
  vdj2_Vci_ei_Vbi_ci=0.0;
#endif
vdj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ei_Vci_ei=0.0;
  vdj2_Vbi_ei_Vbi_ei=0.0;
  vdj2_Vbi_ei_Vs_ci=0.0;
  vdj2_Vbi_ei_Vb_ci=0.0;
  vdj2_Vbi_ei_Vtnode_GND=0.0;
  vdj2_Vbi_ei_Vbi_ci=0.0;
#endif
vdj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj2_Vs_ci_Vci_ei=0.0;
  vdj2_Vs_ci_Vbi_ei=0.0;
  vdj2_Vs_ci_Vs_ci=0.0;
  vdj2_Vs_ci_Vb_ci=0.0;
  vdj2_Vs_ci_Vtnode_GND=0.0;
  vdj2_Vs_ci_Vbi_ci=0.0;
#endif
vdj2_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vdj2_Vb_ci_Vci_ei=0.0;
  vdj2_Vb_ci_Vbi_ei=0.0;
  vdj2_Vb_ci_Vs_ci=0.0;
  vdj2_Vb_ci_Vb_ci=0.0;
  vdj2_Vb_ci_Vtnode_GND=0.0;
  vdj2_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vdj2_Vtnode_GND=(-((vj2_Vtnode_GND*vdcx_t-vj2*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0;
#endif
vdj2_Vbi_ci=(-(vj2_Vbi_ci/vdcx_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vci_ei/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vci_ei/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vbi_ei/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ei/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vs_ci/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vs_ci/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vb_ci/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vb_ci/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vdcx_t)))*(-((vj2_Vtnode_GND*vdcx_t-vj2*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vtnode_GND/vdcx_t-(vj2_Vbi_ci*vdcx_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vbi_ci/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ci/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
#endif
#endif
vdj2=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_exp(d00_exp0,(vdj2*ez))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vci_ei_Vci_ei=0.0;
  qj1_Vci_ei_Vbi_ei=0.0;
  qj1_Vci_ei_Vs_ci=0.0;
  qj1_Vci_ei_Vb_ci=0.0;
  qj1_Vci_ei_Vtnode_GND=0.0;
  qj1_Vci_ei_Vbi_ci=0.0;
#endif
qj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vbi_ei_Vci_ei=0.0;
  qj1_Vbi_ei_Vbi_ei=0.0;
  qj1_Vbi_ei_Vs_ci=0.0;
  qj1_Vbi_ei_Vb_ci=0.0;
  qj1_Vbi_ei_Vtnode_GND=0.0;
  qj1_Vbi_ei_Vbi_ci=0.0;
#endif
qj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj1_Vs_ci_Vci_ei=0.0;
  qj1_Vs_ci_Vbi_ei=0.0;
  qj1_Vs_ci_Vs_ci=0.0;
  qj1_Vs_ci_Vb_ci=0.0;
  qj1_Vs_ci_Vtnode_GND=0.0;
  qj1_Vs_ci_Vbi_ci=0.0;
#endif
qj1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qj1_Vb_ci_Vci_ei=0.0;
  qj1_Vb_ci_Vbi_ei=0.0;
  qj1_Vb_ci_Vs_ci=0.0;
  qj1_Vb_ci_Vb_ci=0.0;
  qj1_Vb_ci_Vtnode_GND=0.0;
  qj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qj1_Vtnode_GND=(((cjcx0_t_ii_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_ii*(-vdj2_Vtnode_GND*ez*d10_exp0)))/ez);
#endif
qj1_Vbi_ci=((cjcx0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_ii*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_ii*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_ii*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_ii*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjcx0_t_ii_Vtnode_GND*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ez+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjcx0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+(((cjcx0_t_ii_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_ii*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjcx0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_ii*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#endif
qj1=((cjcx0_t_ii*(1.0-d00_exp0))/ez);
EXIT_IF_ISNAN(((cjcx0_t_ii*(1.0-d00_exp0))/ez))
}
{
double m00_exp(d00_exp0,(vdj1*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vci_ei_Vci_ei=0.0;
  qj2_Vci_ei_Vbi_ei=0.0;
  qj2_Vci_ei_Vs_ci=0.0;
  qj2_Vci_ei_Vb_ci=0.0;
  qj2_Vci_ei_Vtnode_GND=0.0;
  qj2_Vci_ei_Vbi_ci=0.0;
#endif
qj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vbi_ei_Vci_ei=0.0;
  qj2_Vbi_ei_Vbi_ei=0.0;
  qj2_Vbi_ei_Vs_ci=0.0;
  qj2_Vbi_ei_Vb_ci=0.0;
  qj2_Vbi_ei_Vtnode_GND=0.0;
  qj2_Vbi_ei_Vbi_ci=0.0;
#endif
qj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj2_Vs_ci_Vci_ei=0.0;
  qj2_Vs_ci_Vbi_ei=0.0;
  qj2_Vs_ci_Vs_ci=0.0;
  qj2_Vs_ci_Vb_ci=0.0;
  qj2_Vs_ci_Vtnode_GND=0.0;
  qj2_Vs_ci_Vbi_ci=0.0;
#endif
qj2_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qj2_Vb_ci_Vci_ei=0.0;
  qj2_Vb_ci_Vbi_ei=0.0;
  qj2_Vb_ci_Vs_ci=0.0;
  qj2_Vb_ci_Vb_ci=0.0;
  qj2_Vb_ci_Vtnode_GND=0.0;
  qj2_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qj2_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj1_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj2_Vbi_ci=((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vci_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vs_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vb_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vtnode_GND*ezr+vdj1_Vbi_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj2=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
{
double m00_exp(d00_exp0,(vdj2*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj3_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vci_ei_Vci_ei=0.0;
  qj3_Vci_ei_Vbi_ei=0.0;
  qj3_Vci_ei_Vs_ci=0.0;
  qj3_Vci_ei_Vb_ci=0.0;
  qj3_Vci_ei_Vtnode_GND=0.0;
  qj3_Vci_ei_Vbi_ci=0.0;
#endif
qj3_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vbi_ei_Vci_ei=0.0;
  qj3_Vbi_ei_Vbi_ei=0.0;
  qj3_Vbi_ei_Vs_ci=0.0;
  qj3_Vbi_ei_Vb_ci=0.0;
  qj3_Vbi_ei_Vtnode_GND=0.0;
  qj3_Vbi_ei_Vbi_ci=0.0;
#endif
qj3_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj3_Vs_ci_Vci_ei=0.0;
  qj3_Vs_ci_Vbi_ei=0.0;
  qj3_Vs_ci_Vs_ci=0.0;
  qj3_Vs_ci_Vb_ci=0.0;
  qj3_Vs_ci_Vtnode_GND=0.0;
  qj3_Vs_ci_Vbi_ci=0.0;
#endif
qj3_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qj3_Vb_ci_Vci_ei=0.0;
  qj3_Vb_ci_Vbi_ei=0.0;
  qj3_Vb_ci_Vs_ci=0.0;
  qj3_Vb_ci_Vb_ci=0.0;
  qj3_Vb_ci_Vtnode_GND=0.0;
  qj3_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qj3_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj2_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj3_Vbi_ci=((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ezr+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj3=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
qjcxi_Vtnode_GND=(((((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*vdcx_t)+(((qj1+qj2)-qj3)*vdcx_t_Vtnode_GND))+((cmax_Vtnode_GND*vj4)+(cmax*vj4_Vtnode_GND)));
#endif
qjcxi_Vbi_ci=(((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*vdcx_t+(cmax*vj4_Vbi_ci));
#if defined(_DERIVATE2)
  qjcxi_Vbi_ci_Vtnode_GND=(+(+(+(+qj1_Vbi_ci_Vtnode_GND+qj2_Vbi_ci_Vtnode_GND)-qj3_Vbi_ci_Vtnode_GND)*vdcx_t+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*vdcx_t_Vtnode_GND+((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vtnode_GND+cmax_Vtnode_GND*vj4_Vbi_ci+cmax*vj4_Vbi_ci_Vtnode_GND));
  qjcxi_Vbi_ci_Vbi_ci=(+(+(+(+qj1_Vbi_ci_Vbi_ci+qj2_Vbi_ci_Vbi_ci)-qj3_Vbi_ci_Vbi_ci)*vdcx_t+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*0.0+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vbi_ci+0.0*vj4_Vbi_ci+cmax*vj4_Vbi_ci_Vbi_ci));
#endif
#endif
qjcxi=((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4));
EXIT_IF_ISNAN(((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
qjcxi_Vtnode_GND=0.0;
#endif
qjcxi_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjcxi_Vbi_ci_Vtnode_GND=0.0;
  qjcxi_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
qjcxi=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
else
{
if
((cjcx0_t_ii>0.0))
{
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zcx))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdcx_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdcx_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdcx_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=0.0;
  xvf_Vs_ci_Vbi_ei=0.0;
  xvf_Vs_ci_Vb_ci=0.0;
  xvf_Vs_ci_Vtnode_GND=0.0;
  xvf_Vs_ci_Vbi_ci=0.0;
#endif
xvf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=0.0;
  xvf_Vbi_ei_Vbi_ei=0.0;
  xvf_Vbi_ei_Vb_ci=0.0;
  xvf_Vbi_ei_Vtnode_GND=0.0;
  xvf_Vbi_ei_Vbi_ci=0.0;
#endif
xvf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=0.0;
  xvf_Vb_ci_Vbi_ei=0.0;
  xvf_Vb_ci_Vb_ci=0.0;
  xvf_Vb_ci_Vtnode_GND=0.0;
  xvf_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vbici)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=((-Vbici_Vbi_ci)/VT);
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vbi_ei=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vb_ci=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vtnode_GND=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vbi_ci_Vbi_ci=((+0.0-Vbici_Vbi_ci_Vbi_ci)/VT-((-Vbici_Vbi_ci)*0.0+(-Vbici_Vbi_ci)*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
#endif
#endif
xvf=((vf-Vbici)/VT);
EXIT_IF_ISNAN(((vf-Vbici)/VT))
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=0.0;
  xvf2_Vs_ci_Vbi_ei=0.0;
  xvf2_Vs_ci_Vb_ci=0.0;
  xvf2_Vs_ci_Vtnode_GND=0.0;
  xvf2_Vs_ci_Vbi_ci=0.0;
#endif
xvf2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=0.0;
  xvf2_Vbi_ei_Vbi_ei=0.0;
  xvf2_Vbi_ei_Vb_ci=0.0;
  xvf2_Vbi_ei_Vtnode_GND=0.0;
  xvf2_Vbi_ei_Vbi_ci=0.0;
#endif
xvf2_Vb_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=0.0;
  xvf2_Vb_ci_Vbi_ei=0.0;
  xvf2_Vb_ci_Vb_ci=0.0;
  xvf2_Vb_ci_Vtnode_GND=0.0;
  xvf2_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=0.0;
  v_j_Vs_ci_Vbi_ei=0.0;
  v_j_Vs_ci_Vb_ci=0.0;
  v_j_Vs_ci_Vtnode_GND=0.0;
  v_j_Vs_ci_Vbi_ci=0.0;
#endif
v_j_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=0.0;
  v_j_Vbi_ei_Vbi_ei=0.0;
  v_j_Vbi_ei_Vb_ci=0.0;
  v_j_Vbi_ei_Vtnode_GND=0.0;
  v_j_Vbi_ei_Vbi_ci=0.0;
#endif
v_j_Vb_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=0.0;
  v_j_Vb_ci_Vbi_ei=0.0;
  v_j_Vb_ci_Vb_ci=0.0;
  v_j_Vb_ci_Vtnode_GND=0.0;
  v_j_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=0.0;
#endif
x_Vci_ei=0.0;
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=0.0;
  x_Vci_ei_Vci_ei=0.0;
#endif
#endif
x=(1.0-pModel->zcx);
EXIT_IF_ISNAN((1.0-pModel->zcx))
{
double m00_logE(d00_logE0,(1.0-(v_j/vdcx_t)))
double m00_exp(d00_exp1,(x*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(v_j/vdcx_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
y_Vs_ci=0.0;
#if defined(_DERIVATE2)
  y_Vs_ci_Vs_ci=0.0;
  y_Vs_ci_Vci_ei=0.0;
  y_Vs_ci_Vbi_ei=0.0;
  y_Vs_ci_Vb_ci=0.0;
  y_Vs_ci_Vtnode_GND=0.0;
  y_Vs_ci_Vbi_ci=0.0;
#endif
y_Vci_ei=0.0;
#if defined(_DERIVATE2)
  y_Vci_ei_Vs_ci=0.0;
  y_Vci_ei_Vci_ei=0.0;
  y_Vci_ei_Vbi_ei=0.0;
  y_Vci_ei_Vb_ci=0.0;
  y_Vci_ei_Vtnode_GND=0.0;
  y_Vci_ei_Vbi_ci=0.0;
#endif
y_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  y_Vbi_ei_Vs_ci=0.0;
  y_Vbi_ei_Vci_ei=0.0;
  y_Vbi_ei_Vbi_ei=0.0;
  y_Vbi_ei_Vb_ci=0.0;
  y_Vbi_ei_Vtnode_GND=0.0;
  y_Vbi_ei_Vbi_ci=0.0;
#endif
y_Vb_ci=0.0;
#if defined(_DERIVATE2)
  y_Vb_ci_Vs_ci=0.0;
  y_Vb_ci_Vci_ei=0.0;
  y_Vb_ci_Vbi_ei=0.0;
  y_Vb_ci_Vb_ci=0.0;
  y_Vb_ci_Vtnode_GND=0.0;
  y_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
y_Vtnode_GND=(-((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0))*d10_exp1);
#endif
y_Vbi_ci=(-(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vs_ci/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vs_ci/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*0.0)));
  y_Vbi_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vbi_ei/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ei/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vb_ci/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0)))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vdcx_t-(v_j_Vbi_ci*vdcx_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vbi_ci/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
#endif
#endif
y=(1.0-d00_exp1);
EXIT_IF_ISNAN((1.0-d00_exp1))
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
qjcxi_Vtnode_GND=(((((((cjcx0_t_ii_Vtnode_GND*vdcx_t)+(cjcx0_t_ii*vdcx_t_Vtnode_GND))*y)+((cjcx0_t_ii*vdcx_t)*y_Vtnode_GND))*x-((cjcx0_t_ii*vdcx_t)*y)*x_Vtnode_GND)/x/x)+(((2.4*cjcx0_t_ii_Vtnode_GND)*(Vbici-v_j))+((2.4*cjcx0_t_ii)*(-v_j_Vtnode_GND))));
#endif
qjcxi_Vbi_ci=((((cjcx0_t_ii*vdcx_t)*y_Vbi_ci)/x)+((2.4*cjcx0_t_ii)*(Vbici_Vbi_ci-v_j_Vbi_ci)));
#if defined(_DERIVATE2)
  qjcxi_Vbi_ci_Vtnode_GND=(+((+(+0.0*vdcx_t+0.0*vdcx_t_Vtnode_GND+cjcx0_t_ii_Vtnode_GND*0.0+cjcx0_t_ii*0.0)*y+0.0*y_Vtnode_GND+(((cjcx0_t_ii_Vtnode_GND*vdcx_t)+(cjcx0_t_ii*vdcx_t_Vtnode_GND)))*y_Vbi_ci+(cjcx0_t_ii*vdcx_t)*y_Vbi_ci_Vtnode_GND)/x-(((cjcx0_t_ii*vdcx_t)*y_Vbi_ci)*x_Vtnode_GND+((((((cjcx0_t_ii_Vtnode_GND*vdcx_t)+(cjcx0_t_ii*vdcx_t_Vtnode_GND)))*y)+((cjcx0_t_ii*vdcx_t)*y_Vtnode_GND)))*0.0+((cjcx0_t_ii*vdcx_t)*y)*0.0)/x/x+2*((cjcx0_t_ii*vdcx_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cjcx0_t_ii+0.0*cjcx0_t_ii_Vtnode_GND+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(-v_j_Vtnode_GND)+((2.4*cjcx0_t_ii_Vtnode_GND))*(Vbici_Vbi_ci-v_j_Vbi_ci)+(2.4*cjcx0_t_ii)*(+0.0-v_j_Vbi_ci_Vtnode_GND)));
  qjcxi_Vbi_ci_Vbi_ci=(+((+(+0.0*vdcx_t+0.0*0.0+0.0*0.0+cjcx0_t_ii*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vbi_ci+(cjcx0_t_ii*vdcx_t)*y_Vbi_ci_Vbi_ci)/x-(((cjcx0_t_ii*vdcx_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cjcx0_t_ii*vdcx_t)*y_Vbi_ci)))*0.0+((cjcx0_t_ii*vdcx_t)*y)*0.0)/x/x+2*((cjcx0_t_ii*vdcx_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjcx0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(Vbici_Vbi_ci-v_j_Vbi_ci)+(0.0)*(Vbici_Vbi_ci-v_j_Vbi_ci)+(2.4*cjcx0_t_ii)*(+Vbici_Vbi_ci_Vbi_ci-v_j_Vbi_ci_Vbi_ci)));
#endif
#endif
qjcxi=((((cjcx0_t_ii*vdcx_t)*y)/x)+((2.4*cjcx0_t_ii)*(Vbici-v_j)));
EXIT_IF_ISNAN(((((cjcx0_t_ii*vdcx_t)*y)/x)+((2.4*cjcx0_t_ii)*(Vbici-v_j))))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
qjcxi_Vtnode_GND=0.0;
#endif
qjcxi_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjcxi_Vbi_ci_Vtnode_GND=0.0;
  qjcxi_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
qjcxi=0.00;
EXIT_IF_ISNAN(0.00)
#endif
}
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND)V(ci,GND)V(bi,GND)V(ei,GND) */
cjcx0_t_i_Vtnode_GND=cjcx0_t_Vtnode_GND*(1-pModel->fbc);
#endif
cjcx0_t_i=(cjcx0_t*(1-pModel->fbc));
EXIT_IF_ISNAN((cjcx0_t*(1-pModel->fbc)))
if
((pModel->vptcx<1.0e2))
{
if
((cjcx0_t_i>0.0))
{
zr=(pModel->zcx/4.0);
EXIT_IF_ISNAN((pModel->zcx/4.0))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vp_Vtnode_GND=(-vdcx_t_Vtnode_GND);
#endif
vp=(pModel->vptcx-vdcx_t);
EXIT_IF_ISNAN((pModel->vptcx-vdcx_t))
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zcx))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdcx_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdcx_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdcx_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
cmax_Vtnode_GND=(2.4*cjcx0_t_i_Vtnode_GND);
#endif
cmax=(2.4*cjcx0_t_i);
EXIT_IF_ISNAN((2.4*cjcx0_t_i))
{
double m00_logE(d00_logE0,(vdcx_t/pModel->vptcx))
double m00_exp(d00_exp1,((pModel->zcx-zr)*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(vdcx_t/pModel->vptcx))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
cr_Vtnode_GND=((cjcx0_t_i_Vtnode_GND*d00_exp1)+(cjcx0_t_i*((pModel->zcx-zr)*(vdcx_t_Vtnode_GND/pModel->vptcx)*d10_logE0)*d10_exp1));
#endif
cr=(cjcx0_t_i*d00_exp1);
EXIT_IF_ISNAN((cjcx0_t_i*d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=VT_Vtnode_GND;
#endif
#endif
a=VT;
EXIT_IF_ISNAN(VT)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ve_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vs_ci_Vs_ci=0.0;
  ve_Vs_ci_Vci_ei=0.0;
  ve_Vs_ci_Vbi_ei=0.0;
  ve_Vs_ci_Vb_ci=0.0;
  ve_Vs_ci_Vtnode_GND=0.0;
  ve_Vs_ci_Vbi_ci=0.0;
#endif
ve_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vci_ei_Vs_ci=0.0;
  ve_Vci_ei_Vci_ei=0.0;
  ve_Vci_ei_Vbi_ei=0.0;
  ve_Vci_ei_Vb_ci=0.0;
  ve_Vci_ei_Vtnode_GND=0.0;
  ve_Vci_ei_Vbi_ci=0.0;
#endif
ve_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vbi_ei_Vs_ci=0.0;
  ve_Vbi_ei_Vci_ei=0.0;
  ve_Vbi_ei_Vbi_ei=0.0;
  ve_Vbi_ei_Vb_ci=0.0;
  ve_Vbi_ei_Vtnode_GND=0.0;
  ve_Vbi_ei_Vbi_ci=0.0;
#endif
ve_Vb_ci=(((-Vbci_Vb_ci)*a-(vf-Vbci)*a_Vb_ci)/a/a);
#if defined(_DERIVATE2)
  ve_Vb_ci_Vs_ci=((+0.0-0.0)/a-((-Vbci_Vb_ci)*0.0+0.0*a_Vb_ci+(vf-Vbci)*0.0)/a/a+2*(vf-Vbci)*a_Vb_ci*0.0/a/a/a);
  ve_Vb_ci_Vci_ei=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vci_ei+0.0*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vci_ei)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vci_ei/a/a/a);
  ve_Vb_ci_Vbi_ei=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vbi_ei+0.0*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vbi_ei)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vbi_ei/a/a/a);
  ve_Vb_ci_Vb_ci=((+0.0-Vbci_Vb_ci_Vb_ci)/a-((-Vbci_Vb_ci)*a_Vb_ci+(-Vbci_Vb_ci)*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vb_ci)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vb_ci/a/a/a);
  ve_Vb_ci_Vtnode_GND=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vtnode_GND+vf_Vtnode_GND*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vtnode_GND)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vtnode_GND/a/a/a);
  ve_Vb_ci_Vbi_ci=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vbi_ci+0.0*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vbi_ci)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vbi_ci/a/a/a);
#endif
#if defined(_DERIVATE)
ve_Vtnode_GND=((vf_Vtnode_GND*a-(vf-Vbci)*a_Vtnode_GND)/a/a);
#endif
ve_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vbi_ci_Vs_ci=0.0;
  ve_Vbi_ci_Vci_ei=0.0;
  ve_Vbi_ci_Vbi_ei=0.0;
  ve_Vbi_ci_Vb_ci=0.0;
  ve_Vbi_ci_Vtnode_GND=0.0;
  ve_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
ve=((vf-Vbci)/a);
EXIT_IF_ISNAN(((vf-Vbci)/a))
if
((ve<=80.0))
{
{
double m00_exp(d00_exp0,ve)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=ve_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=ve_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=ve_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=(-((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=(+0.0-(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj1_Vb_ci_Vbi_ei=(+0.0-(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj1_Vb_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj1_Vb_ci_Vb_ci=(+0.0-(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj1_Vb_ci_Vtnode_GND=(+0.0-(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj1_Vb_ci_Vbi_ci=(+0.0-(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=(vf_Vtnode_GND-((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj1_Vbi_ci=(-((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=(+0.0-(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj1_Vbi_ci_Vbi_ei=(+0.0-(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj1_Vbi_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj1_Vbi_ci_Vb_ci=(+0.0-(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj1_Vbi_ci_Vtnode_GND=(+0.0-(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj1_Vbi_ci_Vbi_ci=(+0.0-(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj1=(vf-(a*d00_logE0));
EXIT_IF_ISNAN((vf-(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=Vbci_Vb_ci;
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=0.0;
  vj1_Vb_ci_Vbi_ei=0.0;
  vj1_Vb_ci_Vs_ci=0.0;
  vj1_Vb_ci_Vb_ci=Vbci_Vb_ci_Vb_ci;
  vj1_Vb_ci_Vtnode_GND=0.0;
  vj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=0.0;
#endif
vj1_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=0.0;
  vj1_Vbi_ci_Vbi_ei=0.0;
  vj1_Vbi_ci_Vs_ci=0.0;
  vj1_Vbi_ci_Vb_ci=0.0;
  vj1_Vbi_ci_Vtnode_GND=0.0;
  vj1_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
vj1=Vbci;
EXIT_IF_ISNAN(Vbci)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=((0.1*vp_Vtnode_GND)+(4.0*VT_Vtnode_GND));
#endif
#endif
a=((0.1*vp)+(4.0*VT));
EXIT_IF_ISNAN(((0.1*vp)+(4.0*VT)))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vr_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vci_ei_Vci_ei=0.0;
  vr_Vci_ei_Vbi_ei=0.0;
  vr_Vci_ei_Vs_ci=0.0;
  vr_Vci_ei_Vb_ci=0.0;
  vr_Vci_ei_Vtnode_GND=0.0;
  vr_Vci_ei_Vbi_ci=0.0;
#endif
vr_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vbi_ei_Vci_ei=0.0;
  vr_Vbi_ei_Vbi_ei=0.0;
  vr_Vbi_ei_Vs_ci=0.0;
  vr_Vbi_ei_Vb_ci=0.0;
  vr_Vbi_ei_Vtnode_GND=0.0;
  vr_Vbi_ei_Vbi_ci=0.0;
#endif
vr_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vr_Vs_ci_Vci_ei=0.0;
  vr_Vs_ci_Vbi_ei=0.0;
  vr_Vs_ci_Vs_ci=0.0;
  vr_Vs_ci_Vb_ci=0.0;
  vr_Vs_ci_Vtnode_GND=0.0;
  vr_Vs_ci_Vbi_ci=0.0;
#endif
vr_Vb_ci=((vj1_Vb_ci*a-(vp+vj1)*a_Vb_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vb_ci_Vci_ei=((+0.0+vj1_Vb_ci_Vci_ei)/a-(vj1_Vb_ci*a_Vci_ei+vj1_Vci_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vci_ei/a/a/a);
  vr_Vb_ci_Vbi_ei=((+0.0+vj1_Vb_ci_Vbi_ei)/a-(vj1_Vb_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ei/a/a/a);
  vr_Vb_ci_Vs_ci=((+0.0+vj1_Vb_ci_Vs_ci)/a-(vj1_Vb_ci*0.0+vj1_Vs_ci*a_Vb_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vb_ci*0.0/a/a/a);
  vr_Vb_ci_Vb_ci=((+0.0+vj1_Vb_ci_Vb_ci)/a-(vj1_Vb_ci*a_Vb_ci+vj1_Vb_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vb_ci/a/a/a);
  vr_Vb_ci_Vtnode_GND=((+0.0+vj1_Vb_ci_Vtnode_GND)/a-(vj1_Vb_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vtnode_GND/a/a/a);
  vr_Vb_ci_Vbi_ci=((+0.0+vj1_Vb_ci_Vbi_ci)/a-(vj1_Vb_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ci/a/a/a);
#endif
#if defined(_DERIVATE)
vr_Vtnode_GND=(((vp_Vtnode_GND+vj1_Vtnode_GND)*a-(vp+vj1)*a_Vtnode_GND)/a/a);
#endif
vr_Vbi_ci=((vj1_Vbi_ci*a-(vp+vj1)*a_Vbi_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vbi_ci_Vci_ei=((+0.0+vj1_Vbi_ci_Vci_ei)/a-(vj1_Vbi_ci*a_Vci_ei+vj1_Vci_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vci_ei/a/a/a);
  vr_Vbi_ci_Vbi_ei=((+0.0+vj1_Vbi_ci_Vbi_ei)/a-(vj1_Vbi_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  vr_Vbi_ci_Vs_ci=((+0.0+vj1_Vbi_ci_Vs_ci)/a-(vj1_Vbi_ci*0.0+vj1_Vs_ci*a_Vbi_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vbi_ci*0.0/a/a/a);
  vr_Vbi_ci_Vb_ci=((+0.0+vj1_Vbi_ci_Vb_ci)/a-(vj1_Vbi_ci*a_Vb_ci+vj1_Vb_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vb_ci/a/a/a);
  vr_Vbi_ci_Vtnode_GND=((+0.0+vj1_Vbi_ci_Vtnode_GND)/a-(vj1_Vbi_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  vr_Vbi_ci_Vbi_ci=((+0.0+vj1_Vbi_ci_Vbi_ci)/a-(vj1_Vbi_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
vr=((vp+vj1)/a);
EXIT_IF_ISNAN(((vp+vj1)/a))
if
((vr<=80.0))
{
{
double m00_exp(d00_exp0,vr)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=vr_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=vr_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=vr_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=(+0.0+(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj2_Vb_ci_Vbi_ei=(+0.0+(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj2_Vb_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj2_Vb_ci_Vb_ci=(+0.0+(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj2_Vb_ci_Vtnode_GND=(+0.0+(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj2_Vb_ci_Vbi_ci=(+0.0+(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=((-vp_Vtnode_GND)+((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj2_Vbi_ci=((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=(+0.0+(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj2_Vbi_ci_Vbi_ei=(+0.0+(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj2_Vbi_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj2_Vbi_ci_Vb_ci=(+0.0+(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj2_Vbi_ci_Vtnode_GND=(+0.0+(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj2_Vbi_ci_Vbi_ci=(+0.0+(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj2=((-vp)+(a*d00_logE0));
EXIT_IF_ISNAN(((-vp)+(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=vj1_Vb_ci;
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=vj1_Vb_ci_Vci_ei;
  vj2_Vb_ci_Vbi_ei=vj1_Vb_ci_Vbi_ei;
  vj2_Vb_ci_Vs_ci=vj1_Vb_ci_Vs_ci;
  vj2_Vb_ci_Vb_ci=vj1_Vb_ci_Vb_ci;
  vj2_Vb_ci_Vtnode_GND=vj1_Vb_ci_Vtnode_GND;
  vj2_Vb_ci_Vbi_ci=vj1_Vb_ci_Vbi_ci;
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=vj1_Vtnode_GND;
#endif
vj2_Vbi_ci=vj1_Vbi_ci;
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=vj1_Vbi_ci_Vci_ei;
  vj2_Vbi_ci_Vbi_ei=vj1_Vbi_ci_Vbi_ei;
  vj2_Vbi_ci_Vs_ci=vj1_Vbi_ci_Vs_ci;
  vj2_Vbi_ci_Vb_ci=vj1_Vbi_ci_Vb_ci;
  vj2_Vbi_ci_Vtnode_GND=vj1_Vbi_ci_Vtnode_GND;
  vj2_Vbi_ci_Vbi_ci=vj1_Vbi_ci_Vbi_ci;
#endif
#endif
vj2=vj1;
EXIT_IF_ISNAN(vj1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj4_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj4_Vs_ci_Vs_ci=0.0;
  vj4_Vs_ci_Vci_ei=0.0;
  vj4_Vs_ci_Vbi_ei=0.0;
  vj4_Vs_ci_Vb_ci=0.0;
  vj4_Vs_ci_Vbi_ci=0.0;
  vj4_Vs_ci_Vtnode_GND=0.0;
#endif
vj4_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vci_ei_Vs_ci=0.0;
  vj4_Vci_ei_Vci_ei=0.0;
  vj4_Vci_ei_Vbi_ei=0.0;
  vj4_Vci_ei_Vb_ci=0.0;
  vj4_Vci_ei_Vbi_ci=0.0;
  vj4_Vci_ei_Vtnode_GND=0.0;
#endif
vj4_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vbi_ei_Vs_ci=0.0;
  vj4_Vbi_ei_Vci_ei=0.0;
  vj4_Vbi_ei_Vbi_ei=0.0;
  vj4_Vbi_ei_Vb_ci=0.0;
  vj4_Vbi_ei_Vbi_ci=0.0;
  vj4_Vbi_ei_Vtnode_GND=0.0;
#endif
vj4_Vb_ci=(Vbci_Vb_ci-vj1_Vb_ci);
#if defined(_DERIVATE2)
  vj4_Vb_ci_Vs_ci=(+0.0-vj1_Vb_ci_Vs_ci);
  vj4_Vb_ci_Vci_ei=(+0.0-vj1_Vb_ci_Vci_ei);
  vj4_Vb_ci_Vbi_ei=(+0.0-vj1_Vb_ci_Vbi_ei);
  vj4_Vb_ci_Vb_ci=(+Vbci_Vb_ci_Vb_ci-vj1_Vb_ci_Vb_ci);
  vj4_Vb_ci_Vbi_ci=(+0.0-vj1_Vb_ci_Vbi_ci);
  vj4_Vb_ci_Vtnode_GND=(+0.0-vj1_Vb_ci_Vtnode_GND);
#endif
vj4_Vbi_ci=(-vj1_Vbi_ci);
#if defined(_DERIVATE2)
  vj4_Vbi_ci_Vs_ci=(+0.0-vj1_Vbi_ci_Vs_ci);
  vj4_Vbi_ci_Vci_ei=(+0.0-vj1_Vbi_ci_Vci_ei);
  vj4_Vbi_ci_Vbi_ei=(+0.0-vj1_Vbi_ci_Vbi_ei);
  vj4_Vbi_ci_Vb_ci=(+0.0-vj1_Vbi_ci_Vb_ci);
  vj4_Vbi_ci_Vbi_ci=(+0.0-vj1_Vbi_ci_Vbi_ci);
  vj4_Vbi_ci_Vtnode_GND=(+0.0-vj1_Vbi_ci_Vtnode_GND);
#endif
#if defined(_DERIVATE)
vj4_Vtnode_GND=(-vj1_Vtnode_GND);
#endif
#endif
vj4=(Vbci-vj1);
EXIT_IF_ISNAN((Vbci-vj1))
ez=(1.0-pModel->zcx);
EXIT_IF_ISNAN((1.0-pModel->zcx))
ezr=(1.0-zr);
EXIT_IF_ISNAN((1.0-zr))
{
double m00_logE(d00_logE0,(1.0-(vj1/vdcx_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj1/vdcx_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vci_ei_Vci_ei=0.0;
  vdj1_Vci_ei_Vbi_ei=0.0;
  vdj1_Vci_ei_Vs_ci=0.0;
  vdj1_Vci_ei_Vb_ci=0.0;
  vdj1_Vci_ei_Vtnode_GND=0.0;
  vdj1_Vci_ei_Vbi_ci=0.0;
#endif
vdj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ei_Vci_ei=0.0;
  vdj1_Vbi_ei_Vbi_ei=0.0;
  vdj1_Vbi_ei_Vs_ci=0.0;
  vdj1_Vbi_ei_Vb_ci=0.0;
  vdj1_Vbi_ei_Vtnode_GND=0.0;
  vdj1_Vbi_ei_Vbi_ci=0.0;
#endif
vdj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj1_Vs_ci_Vci_ei=0.0;
  vdj1_Vs_ci_Vbi_ei=0.0;
  vdj1_Vs_ci_Vs_ci=0.0;
  vdj1_Vs_ci_Vb_ci=0.0;
  vdj1_Vs_ci_Vtnode_GND=0.0;
  vdj1_Vs_ci_Vbi_ci=0.0;
#endif
vdj1_Vb_ci=(-(vj1_Vb_ci/vdcx_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vb_ci_Vci_ei=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vci_ei/vdcx_t))*(-(vj1_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vci_ei/vdcx_t-(vj1_Vb_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vbi_ei/vdcx_t))*(-(vj1_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ei/vdcx_t-(vj1_Vb_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vb_ci_Vs_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vs_ci/vdcx_t))*(-(vj1_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vs_ci/vdcx_t-(vj1_Vb_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vb_ci_Vb_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vb_ci/vdcx_t))*(-(vj1_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vb_ci/vdcx_t-(vj1_Vb_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vdcx_t)))*(-((vj1_Vtnode_GND*vdcx_t-vj1*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(vj1_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vtnode_GND/vdcx_t-(vj1_Vb_ci*vdcx_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vbi_ci/vdcx_t))*(-(vj1_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ci/vdcx_t-(vj1_Vb_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
#endif
#if defined(_DERIVATE)
vdj1_Vtnode_GND=(-((vj1_Vtnode_GND*vdcx_t-vj1*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0;
#endif
vdj1_Vbi_ci=(-(vj1_Vbi_ci/vdcx_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vci_ei/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vci_ei/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vbi_ei/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ei/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vs_ci/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vs_ci/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vb_ci/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vb_ci/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vdcx_t)))*(-((vj1_Vtnode_GND*vdcx_t-vj1*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vtnode_GND/vdcx_t-(vj1_Vbi_ci*vdcx_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t)));
  vdj1_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj1/vdcx_t)))*(-(vj1_Vbi_ci/vdcx_t))*(-(vj1_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ci/vdcx_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vdcx_t/vdcx_t+2*vj1*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
#endif
#endif
vdj1=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_logE(d00_logE0,(1.0-(vj2/vdcx_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj2/vdcx_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vci_ei_Vci_ei=0.0;
  vdj2_Vci_ei_Vbi_ei=0.0;
  vdj2_Vci_ei_Vs_ci=0.0;
  vdj2_Vci_ei_Vb_ci=0.0;
  vdj2_Vci_ei_Vtnode_GND=0.0;
  vdj2_Vci_ei_Vbi_ci=0.0;
#endif
vdj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ei_Vci_ei=0.0;
  vdj2_Vbi_ei_Vbi_ei=0.0;
  vdj2_Vbi_ei_Vs_ci=0.0;
  vdj2_Vbi_ei_Vb_ci=0.0;
  vdj2_Vbi_ei_Vtnode_GND=0.0;
  vdj2_Vbi_ei_Vbi_ci=0.0;
#endif
vdj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj2_Vs_ci_Vci_ei=0.0;
  vdj2_Vs_ci_Vbi_ei=0.0;
  vdj2_Vs_ci_Vs_ci=0.0;
  vdj2_Vs_ci_Vb_ci=0.0;
  vdj2_Vs_ci_Vtnode_GND=0.0;
  vdj2_Vs_ci_Vbi_ci=0.0;
#endif
vdj2_Vb_ci=(-(vj2_Vb_ci/vdcx_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vb_ci_Vci_ei=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vci_ei/vdcx_t))*(-(vj2_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vci_ei/vdcx_t-(vj2_Vb_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vbi_ei/vdcx_t))*(-(vj2_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ei/vdcx_t-(vj2_Vb_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vb_ci_Vs_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vs_ci/vdcx_t))*(-(vj2_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vs_ci/vdcx_t-(vj2_Vb_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vb_ci_Vb_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vb_ci/vdcx_t))*(-(vj2_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vb_ci/vdcx_t-(vj2_Vb_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vdcx_t)))*(-((vj2_Vtnode_GND*vdcx_t-vj2*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(vj2_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vtnode_GND/vdcx_t-(vj2_Vb_ci*vdcx_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vbi_ci/vdcx_t))*(-(vj2_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ci/vdcx_t-(vj2_Vb_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
#endif
#if defined(_DERIVATE)
vdj2_Vtnode_GND=(-((vj2_Vtnode_GND*vdcx_t-vj2*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0;
#endif
vdj2_Vbi_ci=(-(vj2_Vbi_ci/vdcx_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vci_ei/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vci_ei/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vbi_ei/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ei/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vs_ci/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vs_ci/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vb_ci/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vb_ci/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vdcx_t)))*(-((vj2_Vtnode_GND*vdcx_t-vj2*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vtnode_GND/vdcx_t-(vj2_Vbi_ci*vdcx_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t)));
  vdj2_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj2/vdcx_t)))*(-(vj2_Vbi_ci/vdcx_t))*(-(vj2_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ci/vdcx_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vdcx_t/vdcx_t+2*vj2*0.0*0.0/vdcx_t/vdcx_t/vdcx_t)));
#endif
#endif
vdj2=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_exp(d00_exp0,(vdj2*ez))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vci_ei_Vci_ei=0.0;
  qj1_Vci_ei_Vbi_ei=0.0;
  qj1_Vci_ei_Vs_ci=0.0;
  qj1_Vci_ei_Vb_ci=0.0;
  qj1_Vci_ei_Vtnode_GND=0.0;
  qj1_Vci_ei_Vbi_ci=0.0;
#endif
qj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vbi_ei_Vci_ei=0.0;
  qj1_Vbi_ei_Vbi_ei=0.0;
  qj1_Vbi_ei_Vs_ci=0.0;
  qj1_Vbi_ei_Vb_ci=0.0;
  qj1_Vbi_ei_Vtnode_GND=0.0;
  qj1_Vbi_ei_Vbi_ci=0.0;
#endif
qj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj1_Vs_ci_Vci_ei=0.0;
  qj1_Vs_ci_Vbi_ei=0.0;
  qj1_Vs_ci_Vs_ci=0.0;
  qj1_Vs_ci_Vb_ci=0.0;
  qj1_Vs_ci_Vtnode_GND=0.0;
  qj1_Vs_ci_Vbi_ci=0.0;
#endif
qj1_Vb_ci=((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjcx0_t_i_Vtnode_GND*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ez+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+(((cjcx0_t_i_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_i*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#if defined(_DERIVATE)
qj1_Vtnode_GND=(((cjcx0_t_i_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_i*(-vdj2_Vtnode_GND*ez*d10_exp0)))/ez);
#endif
qj1_Vbi_ci=((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjcx0_t_i_Vtnode_GND*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ez+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+(((cjcx0_t_i_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_i*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#endif
qj1=((cjcx0_t_i*(1.0-d00_exp0))/ez);
EXIT_IF_ISNAN(((cjcx0_t_i*(1.0-d00_exp0))/ez))
}
{
double m00_exp(d00_exp0,(vdj1*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vci_ei_Vci_ei=0.0;
  qj2_Vci_ei_Vbi_ei=0.0;
  qj2_Vci_ei_Vs_ci=0.0;
  qj2_Vci_ei_Vb_ci=0.0;
  qj2_Vci_ei_Vtnode_GND=0.0;
  qj2_Vci_ei_Vbi_ci=0.0;
#endif
qj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vbi_ei_Vci_ei=0.0;
  qj2_Vbi_ei_Vbi_ei=0.0;
  qj2_Vbi_ei_Vs_ci=0.0;
  qj2_Vbi_ei_Vb_ci=0.0;
  qj2_Vbi_ei_Vtnode_GND=0.0;
  qj2_Vbi_ei_Vbi_ci=0.0;
#endif
qj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj2_Vs_ci_Vci_ei=0.0;
  qj2_Vs_ci_Vbi_ei=0.0;
  qj2_Vs_ci_Vs_ci=0.0;
  qj2_Vs_ci_Vb_ci=0.0;
  qj2_Vs_ci_Vtnode_GND=0.0;
  qj2_Vs_ci_Vbi_ci=0.0;
#endif
qj2_Vb_ci=((cr*(-vdj1_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vci_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vs_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vb_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vtnode_GND*ezr+vdj1_Vb_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj2_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj1_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj2_Vbi_ci=((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vci_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vs_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vb_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vtnode_GND*ezr+vdj1_Vbi_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj2=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
{
double m00_exp(d00_exp0,(vdj2*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj3_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vci_ei_Vci_ei=0.0;
  qj3_Vci_ei_Vbi_ei=0.0;
  qj3_Vci_ei_Vs_ci=0.0;
  qj3_Vci_ei_Vb_ci=0.0;
  qj3_Vci_ei_Vtnode_GND=0.0;
  qj3_Vci_ei_Vbi_ci=0.0;
#endif
qj3_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vbi_ei_Vci_ei=0.0;
  qj3_Vbi_ei_Vbi_ei=0.0;
  qj3_Vbi_ei_Vs_ci=0.0;
  qj3_Vbi_ei_Vb_ci=0.0;
  qj3_Vbi_ei_Vtnode_GND=0.0;
  qj3_Vbi_ei_Vbi_ci=0.0;
#endif
qj3_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj3_Vs_ci_Vci_ei=0.0;
  qj3_Vs_ci_Vbi_ei=0.0;
  qj3_Vs_ci_Vs_ci=0.0;
  qj3_Vs_ci_Vb_ci=0.0;
  qj3_Vs_ci_Vtnode_GND=0.0;
  qj3_Vs_ci_Vbi_ci=0.0;
#endif
qj3_Vb_ci=((cr*(-vdj2_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ezr+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj3_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj2_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj3_Vbi_ci=((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ezr+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj3=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=(((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*vdcx_t+(cmax*vj4_Vb_ci));
qjcx_Vtnode_GND=(((((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*vdcx_t)+(((qj1+qj2)-qj3)*vdcx_t_Vtnode_GND))+((cmax_Vtnode_GND*vj4)+(cmax*vj4_Vtnode_GND)));
qjcx_Vbi_ci=(((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*vdcx_t+(cmax*vj4_Vbi_ci));
#endif
qjcx=((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4));
EXIT_IF_ISNAN(((((qj1+qj2)-qj3)*vdcx_t)+(cmax*vj4)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=0.0;
qjcx_Vtnode_GND=0.0;
qjcx_Vbi_ci=0.0;
#endif
qjcx=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
else
{
if
((cjcx0_t_i>0.0))
{
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zcx))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdcx_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdcx_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdcx_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=0.0;
  xvf_Vs_ci_Vbi_ei=0.0;
  xvf_Vs_ci_Vb_ci=0.0;
  xvf_Vs_ci_Vtnode_GND=0.0;
  xvf_Vs_ci_Vbi_ci=0.0;
#endif
xvf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=0.0;
  xvf_Vbi_ei_Vbi_ei=0.0;
  xvf_Vbi_ei_Vb_ci=0.0;
  xvf_Vbi_ei_Vtnode_GND=0.0;
  xvf_Vbi_ei_Vbi_ci=0.0;
#endif
xvf_Vb_ci=((-Vbci_Vb_ci)/VT);
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*0.0+0.0*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
  xvf_Vb_ci_Vbi_ei=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*0.0+0.0*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
  xvf_Vb_ci_Vb_ci=((+0.0-Vbci_Vb_ci_Vb_ci)/VT-((-Vbci_Vb_ci)*0.0+(-Vbci_Vb_ci)*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
  xvf_Vb_ci_Vtnode_GND=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vb_ci_Vbi_ci=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*0.0+0.0*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vbci)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=0.0;
  xvf_Vbi_ci_Vbi_ei=0.0;
  xvf_Vbi_ci_Vb_ci=0.0;
  xvf_Vbi_ci_Vtnode_GND=0.0;
  xvf_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
xvf=((vf-Vbci)/VT);
EXIT_IF_ISNAN(((vf-Vbci)/VT))
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=0.0;
  xvf2_Vs_ci_Vbi_ei=0.0;
  xvf2_Vs_ci_Vb_ci=0.0;
  xvf2_Vs_ci_Vtnode_GND=0.0;
  xvf2_Vs_ci_Vbi_ci=0.0;
#endif
xvf2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=0.0;
  xvf2_Vbi_ei_Vbi_ei=0.0;
  xvf2_Vbi_ei_Vb_ci=0.0;
  xvf2_Vbi_ei_Vtnode_GND=0.0;
  xvf2_Vbi_ei_Vbi_ci=0.0;
#endif
xvf2_Vb_ci=((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vs_ci*xvf+xvf_Vb_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vs_ci)+0.0));
  xvf2_Vb_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ei*xvf+xvf_Vb_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ei)+0.0));
  xvf2_Vb_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vb_ci*xvf+xvf_Vb_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vb_ci)+0.0));
  xvf2_Vb_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vtnode_GND*xvf+xvf_Vb_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vb_ci+xvf*xvf_Vb_ci_Vtnode_GND)+0.0));
  xvf2_Vb_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ci*xvf+xvf_Vb_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ci)+0.0));
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=0.0;
  v_j_Vs_ci_Vbi_ei=0.0;
  v_j_Vs_ci_Vb_ci=0.0;
  v_j_Vs_ci_Vtnode_GND=0.0;
  v_j_Vs_ci_Vbi_ci=0.0;
#endif
v_j_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=0.0;
  v_j_Vbi_ei_Vbi_ei=0.0;
  v_j_Vbi_ei_Vb_ci=0.0;
  v_j_Vbi_ei_Vtnode_GND=0.0;
  v_j_Vbi_ei_Vbi_ci=0.0;
#endif
v_j_Vb_ci=(-(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vs_ci+xvf2_Vb_ci_Vs_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ei+xvf2_Vb_ci_Vbi_ei))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=0.0;
#endif
x_Vci_ei=0.0;
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=0.0;
  x_Vci_ei_Vci_ei=0.0;
#endif
#endif
x=(1.0-pModel->zcx);
EXIT_IF_ISNAN((1.0-pModel->zcx))
{
double m00_logE(d00_logE0,(1.0-(v_j/vdcx_t)))
double m00_exp(d00_exp1,(x*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(v_j/vdcx_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
y_Vs_ci=0.0;
#if defined(_DERIVATE2)
  y_Vs_ci_Vs_ci=0.0;
  y_Vs_ci_Vci_ei=0.0;
  y_Vs_ci_Vbi_ei=0.0;
  y_Vs_ci_Vb_ci=0.0;
  y_Vs_ci_Vtnode_GND=0.0;
  y_Vs_ci_Vbi_ci=0.0;
#endif
y_Vci_ei=0.0;
#if defined(_DERIVATE2)
  y_Vci_ei_Vs_ci=0.0;
  y_Vci_ei_Vci_ei=0.0;
  y_Vci_ei_Vbi_ei=0.0;
  y_Vci_ei_Vb_ci=0.0;
  y_Vci_ei_Vtnode_GND=0.0;
  y_Vci_ei_Vbi_ci=0.0;
#endif
y_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  y_Vbi_ei_Vs_ci=0.0;
  y_Vbi_ei_Vci_ei=0.0;
  y_Vbi_ei_Vbi_ei=0.0;
  y_Vbi_ei_Vb_ci=0.0;
  y_Vbi_ei_Vtnode_GND=0.0;
  y_Vbi_ei_Vbi_ci=0.0;
#endif
y_Vb_ci=(-(x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vb_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vs_ci/vdcx_t))*(-(v_j_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vs_ci/vdcx_t-(v_j_Vb_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vb_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+x*0.0)));
  y_Vb_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdcx_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdcx_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vbi_ei/vdcx_t))*(-(v_j_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ei/vdcx_t-(v_j_Vb_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vb_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vb_ci/vdcx_t))*(-(v_j_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vb_ci/vdcx_t-(v_j_Vb_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vb_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0)))*(x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(v_j_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vtnode_GND/vdcx_t-(v_j_Vb_ci*vdcx_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vb_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vbi_ci/vdcx_t))*(-(v_j_Vb_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ci/vdcx_t-(v_j_Vb_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
#endif
#if defined(_DERIVATE)
y_Vtnode_GND=(-((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0))*d10_exp1);
#endif
y_Vbi_ci=(-(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vs_ci/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vs_ci/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*0.0)));
  y_Vbi_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vbi_ei/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ei/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vb_ci/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0)))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-((v_j_Vtnode_GND*vdcx_t-v_j*vdcx_t_Vtnode_GND)/vdcx_t/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vdcx_t-(v_j_Vbi_ci*vdcx_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*vdcx_t_Vtnode_GND/vdcx_t/vdcx_t/vdcx_t))))));
  y_Vbi_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdcx_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdcx_t)))*(-(v_j_Vbi_ci/vdcx_t))*(-(v_j_Vbi_ci/vdcx_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vdcx_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdcx_t/vdcx_t+2*v_j*0.0*0.0/vdcx_t/vdcx_t/vdcx_t))))));
#endif
#endif
y=(1.0-d00_exp1);
EXIT_IF_ISNAN((1.0-d00_exp1))
}
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=((((cjcx0_t_i*vdcx_t)*y_Vb_ci)/x)+((2.4*cjcx0_t_i)*(Vbci_Vb_ci-v_j_Vb_ci)));
qjcx_Vtnode_GND=(((((((cjcx0_t_i_Vtnode_GND*vdcx_t)+(cjcx0_t_i*vdcx_t_Vtnode_GND))*y)+((cjcx0_t_i*vdcx_t)*y_Vtnode_GND))*x-((cjcx0_t_i*vdcx_t)*y)*x_Vtnode_GND)/x/x)+(((2.4*cjcx0_t_i_Vtnode_GND)*(Vbci-v_j))+((2.4*cjcx0_t_i)*(-v_j_Vtnode_GND))));
qjcx_Vbi_ci=((((cjcx0_t_i*vdcx_t)*y_Vbi_ci)/x)+((2.4*cjcx0_t_i)*(-v_j_Vbi_ci)));
#endif
qjcx=((((cjcx0_t_i*vdcx_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j)));
EXIT_IF_ISNAN(((((cjcx0_t_i*vdcx_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j))))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=0.0;
qjcx_Vtnode_GND=0.0;
qjcx_Vbi_ci=0.0;
#endif
qjcx=0.00;
EXIT_IF_ISNAN(0.00)
#endif
}
}
}
else
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
cjci0_t_ii_Vtnode_GND=cjci0_t_Vtnode_GND*pModel->fbc;
#endif
cjci0_t_ii=(cjci0_t*pModel->fbc);
EXIT_IF_ISNAN((cjci0_t*pModel->fbc))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
qjcxi_Vtnode_GND=0.0;
#endif
qjcxi_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjcxi_Vbi_ci_Vtnode_GND=0.0;
  qjcxi_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
qjcxi=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(s,GND)V(ci,GND)V(bi,GND)V(ei,GND) */
cjcx0_t_i_Vtnode_GND=cjci0_t_Vtnode_GND*(1-pModel->fbc);
#endif
cjcx0_t_i=(cjci0_t*(1-pModel->fbc));
EXIT_IF_ISNAN((cjci0_t*(1-pModel->fbc)))
if
((pModel->vptci<1.0e2))
{
if
((cjcx0_t_i>0.0))
{
zr=(pModel->zci/4.0);
EXIT_IF_ISNAN((pModel->zci/4.0))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vp_Vtnode_GND=(-vdci_t_Vtnode_GND);
#endif
vp=(pModel->vptci-vdci_t);
EXIT_IF_ISNAN((pModel->vptci-vdci_t))
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zci))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdci_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdci_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdci_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
cmax_Vtnode_GND=(2.4*cjcx0_t_i_Vtnode_GND);
#endif
cmax=(2.4*cjcx0_t_i);
EXIT_IF_ISNAN((2.4*cjcx0_t_i))
{
double m00_logE(d00_logE0,(vdci_t/pModel->vptci))
double m00_exp(d00_exp1,((pModel->zci-zr)*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(vdci_t/pModel->vptci))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
cr_Vtnode_GND=((cjcx0_t_i_Vtnode_GND*d00_exp1)+(cjcx0_t_i*((pModel->zci-zr)*(vdci_t_Vtnode_GND/pModel->vptci)*d10_logE0)*d10_exp1));
#endif
cr=(cjcx0_t_i*d00_exp1);
EXIT_IF_ISNAN((cjcx0_t_i*d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=VT_Vtnode_GND;
#endif
#endif
a=VT;
EXIT_IF_ISNAN(VT)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ve_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vs_ci_Vs_ci=0.0;
  ve_Vs_ci_Vci_ei=0.0;
  ve_Vs_ci_Vbi_ei=0.0;
  ve_Vs_ci_Vb_ci=0.0;
  ve_Vs_ci_Vtnode_GND=0.0;
  ve_Vs_ci_Vbi_ci=0.0;
#endif
ve_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vci_ei_Vs_ci=0.0;
  ve_Vci_ei_Vci_ei=0.0;
  ve_Vci_ei_Vbi_ei=0.0;
  ve_Vci_ei_Vb_ci=0.0;
  ve_Vci_ei_Vtnode_GND=0.0;
  ve_Vci_ei_Vbi_ci=0.0;
#endif
ve_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vbi_ei_Vs_ci=0.0;
  ve_Vbi_ei_Vci_ei=0.0;
  ve_Vbi_ei_Vbi_ei=0.0;
  ve_Vbi_ei_Vb_ci=0.0;
  ve_Vbi_ei_Vtnode_GND=0.0;
  ve_Vbi_ei_Vbi_ci=0.0;
#endif
ve_Vb_ci=(((-Vbci_Vb_ci)*a-(vf-Vbci)*a_Vb_ci)/a/a);
#if defined(_DERIVATE2)
  ve_Vb_ci_Vs_ci=((+0.0-0.0)/a-((-Vbci_Vb_ci)*0.0+0.0*a_Vb_ci+(vf-Vbci)*0.0)/a/a+2*(vf-Vbci)*a_Vb_ci*0.0/a/a/a);
  ve_Vb_ci_Vci_ei=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vci_ei+0.0*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vci_ei)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vci_ei/a/a/a);
  ve_Vb_ci_Vbi_ei=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vbi_ei+0.0*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vbi_ei)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vbi_ei/a/a/a);
  ve_Vb_ci_Vb_ci=((+0.0-Vbci_Vb_ci_Vb_ci)/a-((-Vbci_Vb_ci)*a_Vb_ci+(-Vbci_Vb_ci)*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vb_ci)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vb_ci/a/a/a);
  ve_Vb_ci_Vtnode_GND=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vtnode_GND+vf_Vtnode_GND*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vtnode_GND)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vtnode_GND/a/a/a);
  ve_Vb_ci_Vbi_ci=((+0.0-0.0)/a-((-Vbci_Vb_ci)*a_Vbi_ci+0.0*a_Vb_ci+(vf-Vbci)*a_Vb_ci_Vbi_ci)/a/a+2*(vf-Vbci)*a_Vb_ci*a_Vbi_ci/a/a/a);
#endif
#if defined(_DERIVATE)
ve_Vtnode_GND=((vf_Vtnode_GND*a-(vf-Vbci)*a_Vtnode_GND)/a/a);
#endif
ve_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vbi_ci_Vs_ci=0.0;
  ve_Vbi_ci_Vci_ei=0.0;
  ve_Vbi_ci_Vbi_ei=0.0;
  ve_Vbi_ci_Vb_ci=0.0;
  ve_Vbi_ci_Vtnode_GND=0.0;
  ve_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
ve=((vf-Vbci)/a);
EXIT_IF_ISNAN(((vf-Vbci)/a))
if
((ve<=80.0))
{
{
double m00_exp(d00_exp0,ve)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=ve_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=ve_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=ve_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=(-((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=(+0.0-(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj1_Vb_ci_Vbi_ei=(+0.0-(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj1_Vb_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj1_Vb_ci_Vb_ci=(+0.0-(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj1_Vb_ci_Vtnode_GND=(+0.0-(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj1_Vb_ci_Vbi_ci=(+0.0-(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=(vf_Vtnode_GND-((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj1_Vbi_ci=(-((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=(+0.0-(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj1_Vbi_ci_Vbi_ei=(+0.0-(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj1_Vbi_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj1_Vbi_ci_Vb_ci=(+0.0-(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj1_Vbi_ci_Vtnode_GND=(+0.0-(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj1_Vbi_ci_Vbi_ci=(+0.0-(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj1=(vf-(a*d00_logE0));
EXIT_IF_ISNAN((vf-(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=Vbci_Vb_ci;
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=0.0;
  vj1_Vb_ci_Vbi_ei=0.0;
  vj1_Vb_ci_Vs_ci=0.0;
  vj1_Vb_ci_Vb_ci=Vbci_Vb_ci_Vb_ci;
  vj1_Vb_ci_Vtnode_GND=0.0;
  vj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=0.0;
#endif
vj1_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=0.0;
  vj1_Vbi_ci_Vbi_ei=0.0;
  vj1_Vbi_ci_Vs_ci=0.0;
  vj1_Vbi_ci_Vb_ci=0.0;
  vj1_Vbi_ci_Vtnode_GND=0.0;
  vj1_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
vj1=Vbci;
EXIT_IF_ISNAN(Vbci)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=((0.1*vp_Vtnode_GND)+(4.0*VT_Vtnode_GND));
#endif
#endif
a=((0.1*vp)+(4.0*VT));
EXIT_IF_ISNAN(((0.1*vp)+(4.0*VT)))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vr_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vci_ei_Vci_ei=0.0;
  vr_Vci_ei_Vbi_ei=0.0;
  vr_Vci_ei_Vs_ci=0.0;
  vr_Vci_ei_Vb_ci=0.0;
  vr_Vci_ei_Vtnode_GND=0.0;
  vr_Vci_ei_Vbi_ci=0.0;
#endif
vr_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vbi_ei_Vci_ei=0.0;
  vr_Vbi_ei_Vbi_ei=0.0;
  vr_Vbi_ei_Vs_ci=0.0;
  vr_Vbi_ei_Vb_ci=0.0;
  vr_Vbi_ei_Vtnode_GND=0.0;
  vr_Vbi_ei_Vbi_ci=0.0;
#endif
vr_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vr_Vs_ci_Vci_ei=0.0;
  vr_Vs_ci_Vbi_ei=0.0;
  vr_Vs_ci_Vs_ci=0.0;
  vr_Vs_ci_Vb_ci=0.0;
  vr_Vs_ci_Vtnode_GND=0.0;
  vr_Vs_ci_Vbi_ci=0.0;
#endif
vr_Vb_ci=((vj1_Vb_ci*a-(vp+vj1)*a_Vb_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vb_ci_Vci_ei=((+0.0+vj1_Vb_ci_Vci_ei)/a-(vj1_Vb_ci*a_Vci_ei+vj1_Vci_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vci_ei/a/a/a);
  vr_Vb_ci_Vbi_ei=((+0.0+vj1_Vb_ci_Vbi_ei)/a-(vj1_Vb_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ei/a/a/a);
  vr_Vb_ci_Vs_ci=((+0.0+vj1_Vb_ci_Vs_ci)/a-(vj1_Vb_ci*0.0+vj1_Vs_ci*a_Vb_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vb_ci*0.0/a/a/a);
  vr_Vb_ci_Vb_ci=((+0.0+vj1_Vb_ci_Vb_ci)/a-(vj1_Vb_ci*a_Vb_ci+vj1_Vb_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vb_ci/a/a/a);
  vr_Vb_ci_Vtnode_GND=((+0.0+vj1_Vb_ci_Vtnode_GND)/a-(vj1_Vb_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vtnode_GND/a/a/a);
  vr_Vb_ci_Vbi_ci=((+0.0+vj1_Vb_ci_Vbi_ci)/a-(vj1_Vb_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ci/a/a/a);
#endif
#if defined(_DERIVATE)
vr_Vtnode_GND=(((vp_Vtnode_GND+vj1_Vtnode_GND)*a-(vp+vj1)*a_Vtnode_GND)/a/a);
#endif
vr_Vbi_ci=((vj1_Vbi_ci*a-(vp+vj1)*a_Vbi_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vbi_ci_Vci_ei=((+0.0+vj1_Vbi_ci_Vci_ei)/a-(vj1_Vbi_ci*a_Vci_ei+vj1_Vci_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vci_ei/a/a/a);
  vr_Vbi_ci_Vbi_ei=((+0.0+vj1_Vbi_ci_Vbi_ei)/a-(vj1_Vbi_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  vr_Vbi_ci_Vs_ci=((+0.0+vj1_Vbi_ci_Vs_ci)/a-(vj1_Vbi_ci*0.0+vj1_Vs_ci*a_Vbi_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vbi_ci*0.0/a/a/a);
  vr_Vbi_ci_Vb_ci=((+0.0+vj1_Vbi_ci_Vb_ci)/a-(vj1_Vbi_ci*a_Vb_ci+vj1_Vb_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vb_ci/a/a/a);
  vr_Vbi_ci_Vtnode_GND=((+0.0+vj1_Vbi_ci_Vtnode_GND)/a-(vj1_Vbi_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  vr_Vbi_ci_Vbi_ci=((+0.0+vj1_Vbi_ci_Vbi_ci)/a-(vj1_Vbi_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
vr=((vp+vj1)/a);
EXIT_IF_ISNAN(((vp+vj1)/a))
if
((vr<=80.0))
{
{
double m00_exp(d00_exp0,vr)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=vr_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=vr_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=vr_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=(+0.0+(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj2_Vb_ci_Vbi_ei=(+0.0+(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj2_Vb_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj2_Vb_ci_Vb_ci=(+0.0+(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj2_Vb_ci_Vtnode_GND=(+0.0+(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj2_Vb_ci_Vbi_ci=(+0.0+(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=((-vp_Vtnode_GND)+((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj2_Vbi_ci=((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=(+0.0+(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj2_Vbi_ci_Vbi_ei=(+0.0+(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj2_Vbi_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj2_Vbi_ci_Vb_ci=(+0.0+(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj2_Vbi_ci_Vtnode_GND=(+0.0+(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj2_Vbi_ci_Vbi_ci=(+0.0+(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj2=((-vp)+(a*d00_logE0));
EXIT_IF_ISNAN(((-vp)+(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=vj1_Vb_ci;
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=vj1_Vb_ci_Vci_ei;
  vj2_Vb_ci_Vbi_ei=vj1_Vb_ci_Vbi_ei;
  vj2_Vb_ci_Vs_ci=vj1_Vb_ci_Vs_ci;
  vj2_Vb_ci_Vb_ci=vj1_Vb_ci_Vb_ci;
  vj2_Vb_ci_Vtnode_GND=vj1_Vb_ci_Vtnode_GND;
  vj2_Vb_ci_Vbi_ci=vj1_Vb_ci_Vbi_ci;
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=vj1_Vtnode_GND;
#endif
vj2_Vbi_ci=vj1_Vbi_ci;
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=vj1_Vbi_ci_Vci_ei;
  vj2_Vbi_ci_Vbi_ei=vj1_Vbi_ci_Vbi_ei;
  vj2_Vbi_ci_Vs_ci=vj1_Vbi_ci_Vs_ci;
  vj2_Vbi_ci_Vb_ci=vj1_Vbi_ci_Vb_ci;
  vj2_Vbi_ci_Vtnode_GND=vj1_Vbi_ci_Vtnode_GND;
  vj2_Vbi_ci_Vbi_ci=vj1_Vbi_ci_Vbi_ci;
#endif
#endif
vj2=vj1;
EXIT_IF_ISNAN(vj1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj4_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj4_Vs_ci_Vs_ci=0.0;
  vj4_Vs_ci_Vci_ei=0.0;
  vj4_Vs_ci_Vbi_ei=0.0;
  vj4_Vs_ci_Vb_ci=0.0;
  vj4_Vs_ci_Vbi_ci=0.0;
  vj4_Vs_ci_Vtnode_GND=0.0;
#endif
vj4_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vci_ei_Vs_ci=0.0;
  vj4_Vci_ei_Vci_ei=0.0;
  vj4_Vci_ei_Vbi_ei=0.0;
  vj4_Vci_ei_Vb_ci=0.0;
  vj4_Vci_ei_Vbi_ci=0.0;
  vj4_Vci_ei_Vtnode_GND=0.0;
#endif
vj4_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vbi_ei_Vs_ci=0.0;
  vj4_Vbi_ei_Vci_ei=0.0;
  vj4_Vbi_ei_Vbi_ei=0.0;
  vj4_Vbi_ei_Vb_ci=0.0;
  vj4_Vbi_ei_Vbi_ci=0.0;
  vj4_Vbi_ei_Vtnode_GND=0.0;
#endif
vj4_Vb_ci=(Vbci_Vb_ci-vj1_Vb_ci);
#if defined(_DERIVATE2)
  vj4_Vb_ci_Vs_ci=(+0.0-vj1_Vb_ci_Vs_ci);
  vj4_Vb_ci_Vci_ei=(+0.0-vj1_Vb_ci_Vci_ei);
  vj4_Vb_ci_Vbi_ei=(+0.0-vj1_Vb_ci_Vbi_ei);
  vj4_Vb_ci_Vb_ci=(+Vbci_Vb_ci_Vb_ci-vj1_Vb_ci_Vb_ci);
  vj4_Vb_ci_Vbi_ci=(+0.0-vj1_Vb_ci_Vbi_ci);
  vj4_Vb_ci_Vtnode_GND=(+0.0-vj1_Vb_ci_Vtnode_GND);
#endif
vj4_Vbi_ci=(-vj1_Vbi_ci);
#if defined(_DERIVATE2)
  vj4_Vbi_ci_Vs_ci=(+0.0-vj1_Vbi_ci_Vs_ci);
  vj4_Vbi_ci_Vci_ei=(+0.0-vj1_Vbi_ci_Vci_ei);
  vj4_Vbi_ci_Vbi_ei=(+0.0-vj1_Vbi_ci_Vbi_ei);
  vj4_Vbi_ci_Vb_ci=(+0.0-vj1_Vbi_ci_Vb_ci);
  vj4_Vbi_ci_Vbi_ci=(+0.0-vj1_Vbi_ci_Vbi_ci);
  vj4_Vbi_ci_Vtnode_GND=(+0.0-vj1_Vbi_ci_Vtnode_GND);
#endif
#if defined(_DERIVATE)
vj4_Vtnode_GND=(-vj1_Vtnode_GND);
#endif
#endif
vj4=(Vbci-vj1);
EXIT_IF_ISNAN((Vbci-vj1))
ez=(1.0-pModel->zci);
EXIT_IF_ISNAN((1.0-pModel->zci))
ezr=(1.0-zr);
EXIT_IF_ISNAN((1.0-zr))
{
double m00_logE(d00_logE0,(1.0-(vj1/vdci_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj1/vdci_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vci_ei_Vci_ei=0.0;
  vdj1_Vci_ei_Vbi_ei=0.0;
  vdj1_Vci_ei_Vs_ci=0.0;
  vdj1_Vci_ei_Vb_ci=0.0;
  vdj1_Vci_ei_Vtnode_GND=0.0;
  vdj1_Vci_ei_Vbi_ci=0.0;
#endif
vdj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ei_Vci_ei=0.0;
  vdj1_Vbi_ei_Vbi_ei=0.0;
  vdj1_Vbi_ei_Vs_ci=0.0;
  vdj1_Vbi_ei_Vb_ci=0.0;
  vdj1_Vbi_ei_Vtnode_GND=0.0;
  vdj1_Vbi_ei_Vbi_ci=0.0;
#endif
vdj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj1_Vs_ci_Vci_ei=0.0;
  vdj1_Vs_ci_Vbi_ei=0.0;
  vdj1_Vs_ci_Vs_ci=0.0;
  vdj1_Vs_ci_Vb_ci=0.0;
  vdj1_Vs_ci_Vtnode_GND=0.0;
  vdj1_Vs_ci_Vbi_ci=0.0;
#endif
vdj1_Vb_ci=(-(vj1_Vb_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vb_ci_Vci_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vci_ei/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vci_ei/vdci_t-(vj1_Vb_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ei/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ei/vdci_t-(vj1_Vb_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vs_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vs_ci/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vs_ci/vdci_t-(vj1_Vb_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vb_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vb_ci/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vb_ci/vdci_t-(vj1_Vb_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vdci_t)))*(-((vj1_Vtnode_GND*vdci_t-vj1*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vtnode_GND/vdci_t-(vj1_Vb_ci*vdci_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ci/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ci/vdci_t-(vj1_Vb_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#if defined(_DERIVATE)
vdj1_Vtnode_GND=(-((vj1_Vtnode_GND*vdci_t-vj1*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0;
#endif
vdj1_Vbi_ci=(-(vj1_Vbi_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vci_ei/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vci_ei/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ei/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ei/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vs_ci/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vs_ci/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vb_ci/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vb_ci/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vdci_t)))*(-((vj1_Vtnode_GND*vdci_t-vj1*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vtnode_GND/vdci_t-(vj1_Vbi_ci*vdci_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ci/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ci/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#endif
vdj1=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_logE(d00_logE0,(1.0-(vj2/vdci_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj2/vdci_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vci_ei_Vci_ei=0.0;
  vdj2_Vci_ei_Vbi_ei=0.0;
  vdj2_Vci_ei_Vs_ci=0.0;
  vdj2_Vci_ei_Vb_ci=0.0;
  vdj2_Vci_ei_Vtnode_GND=0.0;
  vdj2_Vci_ei_Vbi_ci=0.0;
#endif
vdj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ei_Vci_ei=0.0;
  vdj2_Vbi_ei_Vbi_ei=0.0;
  vdj2_Vbi_ei_Vs_ci=0.0;
  vdj2_Vbi_ei_Vb_ci=0.0;
  vdj2_Vbi_ei_Vtnode_GND=0.0;
  vdj2_Vbi_ei_Vbi_ci=0.0;
#endif
vdj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj2_Vs_ci_Vci_ei=0.0;
  vdj2_Vs_ci_Vbi_ei=0.0;
  vdj2_Vs_ci_Vs_ci=0.0;
  vdj2_Vs_ci_Vb_ci=0.0;
  vdj2_Vs_ci_Vtnode_GND=0.0;
  vdj2_Vs_ci_Vbi_ci=0.0;
#endif
vdj2_Vb_ci=(-(vj2_Vb_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vb_ci_Vci_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vci_ei/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vci_ei/vdci_t-(vj2_Vb_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ei/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ei/vdci_t-(vj2_Vb_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vs_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vs_ci/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vs_ci/vdci_t-(vj2_Vb_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vb_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vb_ci/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vb_ci/vdci_t-(vj2_Vb_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vdci_t)))*(-((vj2_Vtnode_GND*vdci_t-vj2*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vtnode_GND/vdci_t-(vj2_Vb_ci*vdci_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ci/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ci/vdci_t-(vj2_Vb_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#if defined(_DERIVATE)
vdj2_Vtnode_GND=(-((vj2_Vtnode_GND*vdci_t-vj2*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0;
#endif
vdj2_Vbi_ci=(-(vj2_Vbi_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vci_ei/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vci_ei/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ei/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ei/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vs_ci/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vs_ci/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vb_ci/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vb_ci/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vdci_t)))*(-((vj2_Vtnode_GND*vdci_t-vj2*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vtnode_GND/vdci_t-(vj2_Vbi_ci*vdci_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ci/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ci/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#endif
vdj2=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_exp(d00_exp0,(vdj2*ez))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vci_ei_Vci_ei=0.0;
  qj1_Vci_ei_Vbi_ei=0.0;
  qj1_Vci_ei_Vs_ci=0.0;
  qj1_Vci_ei_Vb_ci=0.0;
  qj1_Vci_ei_Vtnode_GND=0.0;
  qj1_Vci_ei_Vbi_ci=0.0;
#endif
qj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vbi_ei_Vci_ei=0.0;
  qj1_Vbi_ei_Vbi_ei=0.0;
  qj1_Vbi_ei_Vs_ci=0.0;
  qj1_Vbi_ei_Vb_ci=0.0;
  qj1_Vbi_ei_Vtnode_GND=0.0;
  qj1_Vbi_ei_Vbi_ci=0.0;
#endif
qj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj1_Vs_ci_Vci_ei=0.0;
  qj1_Vs_ci_Vbi_ei=0.0;
  qj1_Vs_ci_Vs_ci=0.0;
  qj1_Vs_ci_Vb_ci=0.0;
  qj1_Vs_ci_Vtnode_GND=0.0;
  qj1_Vs_ci_Vbi_ci=0.0;
#endif
qj1_Vb_ci=((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjcx0_t_i_Vtnode_GND*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ez+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+(((cjcx0_t_i_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_i*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#if defined(_DERIVATE)
qj1_Vtnode_GND=(((cjcx0_t_i_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_i*(-vdj2_Vtnode_GND*ez*d10_exp0)))/ez);
#endif
qj1_Vbi_ci=((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjcx0_t_i_Vtnode_GND*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ez+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+(((cjcx0_t_i_Vtnode_GND*(1.0-d00_exp0))+(cjcx0_t_i*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjcx0_t_i*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjcx0_t_i*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjcx0_t_i*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjcx0_t_i*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjcx0_t_i*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#endif
qj1=((cjcx0_t_i*(1.0-d00_exp0))/ez);
EXIT_IF_ISNAN(((cjcx0_t_i*(1.0-d00_exp0))/ez))
}
{
double m00_exp(d00_exp0,(vdj1*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vci_ei_Vci_ei=0.0;
  qj2_Vci_ei_Vbi_ei=0.0;
  qj2_Vci_ei_Vs_ci=0.0;
  qj2_Vci_ei_Vb_ci=0.0;
  qj2_Vci_ei_Vtnode_GND=0.0;
  qj2_Vci_ei_Vbi_ci=0.0;
#endif
qj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vbi_ei_Vci_ei=0.0;
  qj2_Vbi_ei_Vbi_ei=0.0;
  qj2_Vbi_ei_Vs_ci=0.0;
  qj2_Vbi_ei_Vb_ci=0.0;
  qj2_Vbi_ei_Vtnode_GND=0.0;
  qj2_Vbi_ei_Vbi_ci=0.0;
#endif
qj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj2_Vs_ci_Vci_ei=0.0;
  qj2_Vs_ci_Vbi_ei=0.0;
  qj2_Vs_ci_Vs_ci=0.0;
  qj2_Vs_ci_Vb_ci=0.0;
  qj2_Vs_ci_Vtnode_GND=0.0;
  qj2_Vs_ci_Vbi_ci=0.0;
#endif
qj2_Vb_ci=((cr*(-vdj1_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vci_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vs_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vb_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vtnode_GND*ezr+vdj1_Vb_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj2_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj1_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj2_Vbi_ci=((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vci_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vs_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vb_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vtnode_GND*ezr+vdj1_Vbi_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj2=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
{
double m00_exp(d00_exp0,(vdj2*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj3_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vci_ei_Vci_ei=0.0;
  qj3_Vci_ei_Vbi_ei=0.0;
  qj3_Vci_ei_Vs_ci=0.0;
  qj3_Vci_ei_Vb_ci=0.0;
  qj3_Vci_ei_Vtnode_GND=0.0;
  qj3_Vci_ei_Vbi_ci=0.0;
#endif
qj3_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vbi_ei_Vci_ei=0.0;
  qj3_Vbi_ei_Vbi_ei=0.0;
  qj3_Vbi_ei_Vs_ci=0.0;
  qj3_Vbi_ei_Vb_ci=0.0;
  qj3_Vbi_ei_Vtnode_GND=0.0;
  qj3_Vbi_ei_Vbi_ci=0.0;
#endif
qj3_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj3_Vs_ci_Vci_ei=0.0;
  qj3_Vs_ci_Vbi_ei=0.0;
  qj3_Vs_ci_Vs_ci=0.0;
  qj3_Vs_ci_Vb_ci=0.0;
  qj3_Vs_ci_Vtnode_GND=0.0;
  qj3_Vs_ci_Vbi_ci=0.0;
#endif
qj3_Vb_ci=((cr*(-vdj2_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ezr+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj3_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj2_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj3_Vbi_ci=((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ezr+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj3=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=(((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*vdci_t+(cmax*vj4_Vb_ci));
qjcx_Vtnode_GND=(((((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*vdci_t)+(((qj1+qj2)-qj3)*vdci_t_Vtnode_GND))+((cmax_Vtnode_GND*vj4)+(cmax*vj4_Vtnode_GND)));
qjcx_Vbi_ci=(((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*vdci_t+(cmax*vj4_Vbi_ci));
#endif
qjcx=((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4));
EXIT_IF_ISNAN(((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=0.0;
qjcx_Vtnode_GND=0.0;
qjcx_Vbi_ci=0.0;
#endif
qjcx=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
else
{
if
((cjcx0_t_i>0.0))
{
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zci))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdci_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdci_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdci_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=0.0;
  xvf_Vs_ci_Vbi_ei=0.0;
  xvf_Vs_ci_Vb_ci=0.0;
  xvf_Vs_ci_Vtnode_GND=0.0;
  xvf_Vs_ci_Vbi_ci=0.0;
#endif
xvf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=0.0;
  xvf_Vbi_ei_Vbi_ei=0.0;
  xvf_Vbi_ei_Vb_ci=0.0;
  xvf_Vbi_ei_Vtnode_GND=0.0;
  xvf_Vbi_ei_Vbi_ci=0.0;
#endif
xvf_Vb_ci=((-Vbci_Vb_ci)/VT);
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*0.0+0.0*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
  xvf_Vb_ci_Vbi_ei=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*0.0+0.0*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
  xvf_Vb_ci_Vb_ci=((+0.0-Vbci_Vb_ci_Vb_ci)/VT-((-Vbci_Vb_ci)*0.0+(-Vbci_Vb_ci)*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
  xvf_Vb_ci_Vtnode_GND=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vb_ci_Vbi_ci=((+0.0-0.0)/VT-((-Vbci_Vb_ci)*0.0+0.0*0.0+(vf-Vbci)*0.0)/VT/VT+2*(vf-Vbci)*0.0*0.0/VT/VT/VT);
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vbci)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=0.0;
  xvf_Vbi_ci_Vbi_ei=0.0;
  xvf_Vbi_ci_Vb_ci=0.0;
  xvf_Vbi_ci_Vtnode_GND=0.0;
  xvf_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
xvf=((vf-Vbci)/VT);
EXIT_IF_ISNAN(((vf-Vbci)/VT))
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=0.0;
  xvf2_Vs_ci_Vbi_ei=0.0;
  xvf2_Vs_ci_Vb_ci=0.0;
  xvf2_Vs_ci_Vtnode_GND=0.0;
  xvf2_Vs_ci_Vbi_ci=0.0;
#endif
xvf2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=0.0;
  xvf2_Vbi_ei_Vbi_ei=0.0;
  xvf2_Vbi_ei_Vb_ci=0.0;
  xvf2_Vbi_ei_Vtnode_GND=0.0;
  xvf2_Vbi_ei_Vbi_ci=0.0;
#endif
xvf2_Vb_ci=((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vs_ci*xvf+xvf_Vb_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vs_ci)+0.0));
  xvf2_Vb_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ei*xvf+xvf_Vb_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ei)+0.0));
  xvf2_Vb_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vb_ci*xvf+xvf_Vb_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vb_ci)+0.0));
  xvf2_Vb_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vtnode_GND*xvf+xvf_Vb_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vb_ci+xvf*xvf_Vb_ci_Vtnode_GND)+0.0));
  xvf2_Vb_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ci*xvf+xvf_Vb_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ci)+0.0));
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=0.0;
  v_j_Vs_ci_Vbi_ei=0.0;
  v_j_Vs_ci_Vb_ci=0.0;
  v_j_Vs_ci_Vtnode_GND=0.0;
  v_j_Vs_ci_Vbi_ci=0.0;
#endif
v_j_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=0.0;
  v_j_Vbi_ei_Vbi_ei=0.0;
  v_j_Vbi_ei_Vb_ci=0.0;
  v_j_Vbi_ei_Vtnode_GND=0.0;
  v_j_Vbi_ei_Vbi_ci=0.0;
#endif
v_j_Vb_ci=(-(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vs_ci+xvf2_Vb_ci_Vs_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ei+xvf2_Vb_ci_Vbi_ei))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=0.0;
#endif
x_Vci_ei=0.0;
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=0.0;
  x_Vci_ei_Vci_ei=0.0;
#endif
#endif
x=(1.0-pModel->zci);
EXIT_IF_ISNAN((1.0-pModel->zci))
{
double m00_logE(d00_logE0,(1.0-(v_j/vdci_t)))
double m00_exp(d00_exp1,(x*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(v_j/vdci_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
y_Vs_ci=0.0;
#if defined(_DERIVATE2)
  y_Vs_ci_Vs_ci=0.0;
  y_Vs_ci_Vci_ei=0.0;
  y_Vs_ci_Vbi_ei=0.0;
  y_Vs_ci_Vb_ci=0.0;
  y_Vs_ci_Vtnode_GND=0.0;
  y_Vs_ci_Vbi_ci=0.0;
#endif
y_Vci_ei=0.0;
#if defined(_DERIVATE2)
  y_Vci_ei_Vs_ci=0.0;
  y_Vci_ei_Vci_ei=0.0;
  y_Vci_ei_Vbi_ei=0.0;
  y_Vci_ei_Vb_ci=0.0;
  y_Vci_ei_Vtnode_GND=0.0;
  y_Vci_ei_Vbi_ci=0.0;
#endif
y_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  y_Vbi_ei_Vs_ci=0.0;
  y_Vbi_ei_Vci_ei=0.0;
  y_Vbi_ei_Vbi_ei=0.0;
  y_Vbi_ei_Vb_ci=0.0;
  y_Vbi_ei_Vtnode_GND=0.0;
  y_Vbi_ei_Vbi_ci=0.0;
#endif
y_Vb_ci=(-(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vb_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vs_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vs_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*0.0)));
  y_Vb_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ei/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ei/vdci_t-(v_j_Vb_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vb_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vb_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0)))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vtnode_GND/vdci_t-(v_j_Vb_ci*vdci_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
#endif
#if defined(_DERIVATE)
y_Vtnode_GND=(-((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*d10_exp1);
#endif
y_Vbi_ci=(-(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vs_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vs_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*0.0)));
  y_Vbi_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ei/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ei/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vb_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0)))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vdci_t-(v_j_Vbi_ci*vdci_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
#endif
#endif
y=(1.0-d00_exp1);
EXIT_IF_ISNAN((1.0-d00_exp1))
}
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=((((cjcx0_t_i*vdci_t)*y_Vb_ci)/x)+((2.4*cjcx0_t_i)*(Vbci_Vb_ci-v_j_Vb_ci)));
qjcx_Vtnode_GND=(((((((cjcx0_t_i_Vtnode_GND*vdci_t)+(cjcx0_t_i*vdci_t_Vtnode_GND))*y)+((cjcx0_t_i*vdci_t)*y_Vtnode_GND))*x-((cjcx0_t_i*vdci_t)*y)*x_Vtnode_GND)/x/x)+(((2.4*cjcx0_t_i_Vtnode_GND)*(Vbci-v_j))+((2.4*cjcx0_t_i)*(-v_j_Vtnode_GND))));
qjcx_Vbi_ci=((((cjcx0_t_i*vdci_t)*y_Vbi_ci)/x)+((2.4*cjcx0_t_i)*(-v_j_Vbi_ci)));
#endif
qjcx=((((cjcx0_t_i*vdci_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j)));
EXIT_IF_ISNAN(((((cjcx0_t_i*vdci_t)*y)/x)+((2.4*cjcx0_t_i)*(Vbci-v_j))))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=0.0;
qjcx_Vtnode_GND=0.0;
qjcx_Vbi_ci=0.0;
#endif
qjcx=0.00;
EXIT_IF_ISNAN(0.00)
#endif
}
}
}
if
((pModel->vptci<1.0e2))
{
if
((cjci0_t_ii>0.0))
{
zr=(pModel->zci/4.0);
EXIT_IF_ISNAN((pModel->zci/4.0))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vp_Vtnode_GND=(-vdci_t_Vtnode_GND);
#endif
vp=(pModel->vptci-vdci_t);
EXIT_IF_ISNAN((pModel->vptci-vdci_t))
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zci))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdci_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdci_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdci_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
cmax_Vtnode_GND=(2.4*cjci0_t_ii_Vtnode_GND);
#endif
cmax=(2.4*cjci0_t_ii);
EXIT_IF_ISNAN((2.4*cjci0_t_ii))
{
double m00_logE(d00_logE0,(vdci_t/pModel->vptci))
double m00_exp(d00_exp1,((pModel->zci-zr)*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(vdci_t/pModel->vptci))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
cr_Vtnode_GND=((cjci0_t_ii_Vtnode_GND*d00_exp1)+(cjci0_t_ii*((pModel->zci-zr)*(vdci_t_Vtnode_GND/pModel->vptci)*d10_logE0)*d10_exp1));
#endif
cr=(cjci0_t_ii*d00_exp1);
EXIT_IF_ISNAN((cjci0_t_ii*d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=VT_Vtnode_GND;
#endif
#endif
a=VT;
EXIT_IF_ISNAN(VT)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ve_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vs_ci_Vs_ci=0.0;
  ve_Vs_ci_Vci_ei=0.0;
  ve_Vs_ci_Vbi_ei=0.0;
  ve_Vs_ci_Vb_ci=0.0;
  ve_Vs_ci_Vtnode_GND=0.0;
  ve_Vs_ci_Vbi_ci=0.0;
#endif
ve_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vci_ei_Vs_ci=0.0;
  ve_Vci_ei_Vci_ei=0.0;
  ve_Vci_ei_Vbi_ei=0.0;
  ve_Vci_ei_Vb_ci=0.0;
  ve_Vci_ei_Vtnode_GND=0.0;
  ve_Vci_ei_Vbi_ci=0.0;
#endif
ve_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ve_Vbi_ei_Vs_ci=0.0;
  ve_Vbi_ei_Vci_ei=0.0;
  ve_Vbi_ei_Vbi_ei=0.0;
  ve_Vbi_ei_Vb_ci=0.0;
  ve_Vbi_ei_Vtnode_GND=0.0;
  ve_Vbi_ei_Vbi_ci=0.0;
#endif
ve_Vb_ci=0.0;
#if defined(_DERIVATE2)
  ve_Vb_ci_Vs_ci=0.0;
  ve_Vb_ci_Vci_ei=0.0;
  ve_Vb_ci_Vbi_ei=0.0;
  ve_Vb_ci_Vb_ci=0.0;
  ve_Vb_ci_Vtnode_GND=0.0;
  ve_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
ve_Vtnode_GND=((vf_Vtnode_GND*a-(vf-Vbici)*a_Vtnode_GND)/a/a);
#endif
ve_Vbi_ci=(((-Vbici_Vbi_ci)*a-(vf-Vbici)*a_Vbi_ci)/a/a);
#if defined(_DERIVATE2)
  ve_Vbi_ci_Vs_ci=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*0.0+0.0*a_Vbi_ci+(vf-Vbici)*0.0)/a/a+2*(vf-Vbici)*a_Vbi_ci*0.0/a/a/a);
  ve_Vbi_ci_Vci_ei=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vci_ei+0.0*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vci_ei)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vci_ei/a/a/a);
  ve_Vbi_ci_Vbi_ei=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vbi_ei+0.0*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vbi_ei)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  ve_Vbi_ci_Vb_ci=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vb_ci+0.0*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vb_ci)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vb_ci/a/a/a);
  ve_Vbi_ci_Vtnode_GND=((+0.0-0.0)/a-((-Vbici_Vbi_ci)*a_Vtnode_GND+vf_Vtnode_GND*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  ve_Vbi_ci_Vbi_ci=((+0.0-Vbici_Vbi_ci_Vbi_ci)/a-((-Vbici_Vbi_ci)*a_Vbi_ci+(-Vbici_Vbi_ci)*a_Vbi_ci+(vf-Vbici)*a_Vbi_ci_Vbi_ci)/a/a+2*(vf-Vbici)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
ve=((vf-Vbici)/a);
EXIT_IF_ISNAN(((vf-Vbici)/a))
if
((ve<=80.0))
{
{
double m00_exp(d00_exp0,ve)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=ve_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=ve_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=ve_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=(-((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=(+0.0-(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj1_Vb_ci_Vbi_ei=(+0.0-(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj1_Vb_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj1_Vb_ci_Vb_ci=(+0.0-(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj1_Vb_ci_Vtnode_GND=(+0.0-(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj1_Vb_ci_Vbi_ci=(+0.0-(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=(vf_Vtnode_GND-((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj1_Vbi_ci=(-((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=(+0.0-(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj1_Vbi_ci_Vbi_ei=(+0.0-(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj1_Vbi_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj1_Vbi_ci_Vb_ci=(+0.0-(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj1_Vbi_ci_Vtnode_GND=(+0.0-(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj1_Vbi_ci_Vbi_ci=(+0.0-(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj1=(vf-(a*d00_logE0));
EXIT_IF_ISNAN((vf-(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=0.0;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=0.0;
  vj1_Vb_ci_Vbi_ei=0.0;
  vj1_Vb_ci_Vs_ci=0.0;
  vj1_Vb_ci_Vb_ci=0.0;
  vj1_Vb_ci_Vtnode_GND=0.0;
  vj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=0.0;
#endif
vj1_Vbi_ci=Vbici_Vbi_ci;
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=0.0;
  vj1_Vbi_ci_Vbi_ei=0.0;
  vj1_Vbi_ci_Vs_ci=0.0;
  vj1_Vbi_ci_Vb_ci=0.0;
  vj1_Vbi_ci_Vtnode_GND=0.0;
  vj1_Vbi_ci_Vbi_ci=Vbici_Vbi_ci_Vbi_ci;
#endif
#endif
vj1=Vbici;
EXIT_IF_ISNAN(Vbici)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=((0.1*vp_Vtnode_GND)+(4.0*VT_Vtnode_GND));
#endif
#endif
a=((0.1*vp)+(4.0*VT));
EXIT_IF_ISNAN(((0.1*vp)+(4.0*VT)))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vr_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vci_ei_Vci_ei=0.0;
  vr_Vci_ei_Vbi_ei=0.0;
  vr_Vci_ei_Vs_ci=0.0;
  vr_Vci_ei_Vb_ci=0.0;
  vr_Vci_ei_Vtnode_GND=0.0;
  vr_Vci_ei_Vbi_ci=0.0;
#endif
vr_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vr_Vbi_ei_Vci_ei=0.0;
  vr_Vbi_ei_Vbi_ei=0.0;
  vr_Vbi_ei_Vs_ci=0.0;
  vr_Vbi_ei_Vb_ci=0.0;
  vr_Vbi_ei_Vtnode_GND=0.0;
  vr_Vbi_ei_Vbi_ci=0.0;
#endif
vr_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vr_Vs_ci_Vci_ei=0.0;
  vr_Vs_ci_Vbi_ei=0.0;
  vr_Vs_ci_Vs_ci=0.0;
  vr_Vs_ci_Vb_ci=0.0;
  vr_Vs_ci_Vtnode_GND=0.0;
  vr_Vs_ci_Vbi_ci=0.0;
#endif
vr_Vb_ci=((vj1_Vb_ci*a-(vp+vj1)*a_Vb_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vb_ci_Vci_ei=((+0.0+vj1_Vb_ci_Vci_ei)/a-(vj1_Vb_ci*a_Vci_ei+vj1_Vci_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vci_ei/a/a/a);
  vr_Vb_ci_Vbi_ei=((+0.0+vj1_Vb_ci_Vbi_ei)/a-(vj1_Vb_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ei/a/a/a);
  vr_Vb_ci_Vs_ci=((+0.0+vj1_Vb_ci_Vs_ci)/a-(vj1_Vb_ci*0.0+vj1_Vs_ci*a_Vb_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vb_ci*0.0/a/a/a);
  vr_Vb_ci_Vb_ci=((+0.0+vj1_Vb_ci_Vb_ci)/a-(vj1_Vb_ci*a_Vb_ci+vj1_Vb_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vb_ci/a/a/a);
  vr_Vb_ci_Vtnode_GND=((+0.0+vj1_Vb_ci_Vtnode_GND)/a-(vj1_Vb_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vtnode_GND/a/a/a);
  vr_Vb_ci_Vbi_ci=((+0.0+vj1_Vb_ci_Vbi_ci)/a-(vj1_Vb_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ci/a/a/a);
#endif
#if defined(_DERIVATE)
vr_Vtnode_GND=(((vp_Vtnode_GND+vj1_Vtnode_GND)*a-(vp+vj1)*a_Vtnode_GND)/a/a);
#endif
vr_Vbi_ci=((vj1_Vbi_ci*a-(vp+vj1)*a_Vbi_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vbi_ci_Vci_ei=((+0.0+vj1_Vbi_ci_Vci_ei)/a-(vj1_Vbi_ci*a_Vci_ei+vj1_Vci_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vci_ei/a/a/a);
  vr_Vbi_ci_Vbi_ei=((+0.0+vj1_Vbi_ci_Vbi_ei)/a-(vj1_Vbi_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  vr_Vbi_ci_Vs_ci=((+0.0+vj1_Vbi_ci_Vs_ci)/a-(vj1_Vbi_ci*0.0+vj1_Vs_ci*a_Vbi_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vbi_ci*0.0/a/a/a);
  vr_Vbi_ci_Vb_ci=((+0.0+vj1_Vbi_ci_Vb_ci)/a-(vj1_Vbi_ci*a_Vb_ci+vj1_Vb_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vb_ci/a/a/a);
  vr_Vbi_ci_Vtnode_GND=((+0.0+vj1_Vbi_ci_Vtnode_GND)/a-(vj1_Vbi_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  vr_Vbi_ci_Vbi_ci=((+0.0+vj1_Vbi_ci_Vbi_ci)/a-(vj1_Vbi_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
vr=((vp+vj1)/a);
EXIT_IF_ISNAN(((vp+vj1)/a))
if
((vr<=80.0))
{
{
double m00_exp(d00_exp0,vr)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=0.0;
  ex1_Vs_ci_Vci_ei=0.0;
  ex1_Vs_ci_Vbi_ei=0.0;
  ex1_Vs_ci_Vb_ci=0.0;
  ex1_Vs_ci_Vtnode_GND=0.0;
  ex1_Vs_ci_Vbi_ci=0.0;
#endif
ex1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=0.0;
  ex1_Vci_ei_Vci_ei=0.0;
  ex1_Vci_ei_Vbi_ei=0.0;
  ex1_Vci_ei_Vb_ci=0.0;
  ex1_Vci_ei_Vtnode_GND=0.0;
  ex1_Vci_ei_Vbi_ci=0.0;
#endif
ex1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=0.0;
  ex1_Vbi_ei_Vci_ei=0.0;
  ex1_Vbi_ei_Vbi_ei=0.0;
  ex1_Vbi_ei_Vb_ci=0.0;
  ex1_Vbi_ei_Vtnode_GND=0.0;
  ex1_Vbi_ei_Vbi_ci=0.0;
#endif
ex1_Vb_ci=vr_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=vr_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=vr_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=0.0;
  ee1_Vs_ci_Vci_ei=0.0;
  ee1_Vs_ci_Vbi_ei=0.0;
  ee1_Vs_ci_Vb_ci=0.0;
  ee1_Vs_ci_Vtnode_GND=0.0;
  ee1_Vs_ci_Vbi_ci=0.0;
#endif
ee1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=0.0;
  ee1_Vci_ei_Vci_ei=0.0;
  ee1_Vci_ei_Vbi_ei=0.0;
  ee1_Vci_ei_Vb_ci=0.0;
  ee1_Vci_ei_Vtnode_GND=0.0;
  ee1_Vci_ei_Vbi_ci=0.0;
#endif
ee1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=0.0;
  ee1_Vbi_ei_Vci_ei=0.0;
  ee1_Vbi_ei_Vbi_ei=0.0;
  ee1_Vbi_ei_Vb_ci=0.0;
  ee1_Vbi_ei_Vtnode_GND=0.0;
  ee1_Vbi_ei_Vbi_ci=0.0;
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=(+0.0+(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj2_Vb_ci_Vbi_ei=(+0.0+(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj2_Vb_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj2_Vb_ci_Vb_ci=(+0.0+(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj2_Vb_ci_Vtnode_GND=(+0.0+(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj2_Vb_ci_Vbi_ci=(+0.0+(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=((-vp_Vtnode_GND)+((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj2_Vbi_ci=((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=(+0.0+(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj2_Vbi_ci_Vbi_ei=(+0.0+(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj2_Vbi_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj2_Vbi_ci_Vb_ci=(+0.0+(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj2_Vbi_ci_Vtnode_GND=(+0.0+(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj2_Vbi_ci_Vbi_ci=(+0.0+(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj2=((-vp)+(a*d00_logE0));
EXIT_IF_ISNAN(((-vp)+(a*d00_logE0)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=0.0;
  vj2_Vci_ei_Vbi_ei=0.0;
  vj2_Vci_ei_Vs_ci=0.0;
  vj2_Vci_ei_Vb_ci=0.0;
  vj2_Vci_ei_Vtnode_GND=0.0;
  vj2_Vci_ei_Vbi_ci=0.0;
#endif
vj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=0.0;
  vj2_Vbi_ei_Vbi_ei=0.0;
  vj2_Vbi_ei_Vs_ci=0.0;
  vj2_Vbi_ei_Vb_ci=0.0;
  vj2_Vbi_ei_Vtnode_GND=0.0;
  vj2_Vbi_ei_Vbi_ci=0.0;
#endif
vj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=0.0;
  vj2_Vs_ci_Vbi_ei=0.0;
  vj2_Vs_ci_Vs_ci=0.0;
  vj2_Vs_ci_Vb_ci=0.0;
  vj2_Vs_ci_Vtnode_GND=0.0;
  vj2_Vs_ci_Vbi_ci=0.0;
#endif
vj2_Vb_ci=vj1_Vb_ci;
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=vj1_Vb_ci_Vci_ei;
  vj2_Vb_ci_Vbi_ei=vj1_Vb_ci_Vbi_ei;
  vj2_Vb_ci_Vs_ci=vj1_Vb_ci_Vs_ci;
  vj2_Vb_ci_Vb_ci=vj1_Vb_ci_Vb_ci;
  vj2_Vb_ci_Vtnode_GND=vj1_Vb_ci_Vtnode_GND;
  vj2_Vb_ci_Vbi_ci=vj1_Vb_ci_Vbi_ci;
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=vj1_Vtnode_GND;
#endif
vj2_Vbi_ci=vj1_Vbi_ci;
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=vj1_Vbi_ci_Vci_ei;
  vj2_Vbi_ci_Vbi_ei=vj1_Vbi_ci_Vbi_ei;
  vj2_Vbi_ci_Vs_ci=vj1_Vbi_ci_Vs_ci;
  vj2_Vbi_ci_Vb_ci=vj1_Vbi_ci_Vb_ci;
  vj2_Vbi_ci_Vtnode_GND=vj1_Vbi_ci_Vtnode_GND;
  vj2_Vbi_ci_Vbi_ci=vj1_Vbi_ci_Vbi_ci;
#endif
#endif
vj2=vj1;
EXIT_IF_ISNAN(vj1)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj4_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vj4_Vs_ci_Vs_ci=0.0;
  vj4_Vs_ci_Vci_ei=0.0;
  vj4_Vs_ci_Vbi_ei=0.0;
  vj4_Vs_ci_Vb_ci=0.0;
  vj4_Vs_ci_Vbi_ci=0.0;
  vj4_Vs_ci_Vtnode_GND=0.0;
#endif
vj4_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vci_ei_Vs_ci=0.0;
  vj4_Vci_ei_Vci_ei=0.0;
  vj4_Vci_ei_Vbi_ei=0.0;
  vj4_Vci_ei_Vb_ci=0.0;
  vj4_Vci_ei_Vbi_ci=0.0;
  vj4_Vci_ei_Vtnode_GND=0.0;
#endif
vj4_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj4_Vbi_ei_Vs_ci=0.0;
  vj4_Vbi_ei_Vci_ei=0.0;
  vj4_Vbi_ei_Vbi_ei=0.0;
  vj4_Vbi_ei_Vb_ci=0.0;
  vj4_Vbi_ei_Vbi_ci=0.0;
  vj4_Vbi_ei_Vtnode_GND=0.0;
#endif
vj4_Vb_ci=(-vj1_Vb_ci);
#if defined(_DERIVATE2)
  vj4_Vb_ci_Vs_ci=(+0.0-vj1_Vb_ci_Vs_ci);
  vj4_Vb_ci_Vci_ei=(+0.0-vj1_Vb_ci_Vci_ei);
  vj4_Vb_ci_Vbi_ei=(+0.0-vj1_Vb_ci_Vbi_ei);
  vj4_Vb_ci_Vb_ci=(+0.0-vj1_Vb_ci_Vb_ci);
  vj4_Vb_ci_Vbi_ci=(+0.0-vj1_Vb_ci_Vbi_ci);
  vj4_Vb_ci_Vtnode_GND=(+0.0-vj1_Vb_ci_Vtnode_GND);
#endif
vj4_Vbi_ci=(Vbici_Vbi_ci-vj1_Vbi_ci);
#if defined(_DERIVATE2)
  vj4_Vbi_ci_Vs_ci=(+0.0-vj1_Vbi_ci_Vs_ci);
  vj4_Vbi_ci_Vci_ei=(+0.0-vj1_Vbi_ci_Vci_ei);
  vj4_Vbi_ci_Vbi_ei=(+0.0-vj1_Vbi_ci_Vbi_ei);
  vj4_Vbi_ci_Vb_ci=(+0.0-vj1_Vbi_ci_Vb_ci);
  vj4_Vbi_ci_Vbi_ci=(+Vbici_Vbi_ci_Vbi_ci-vj1_Vbi_ci_Vbi_ci);
  vj4_Vbi_ci_Vtnode_GND=(+0.0-vj1_Vbi_ci_Vtnode_GND);
#endif
#if defined(_DERIVATE)
vj4_Vtnode_GND=(-vj1_Vtnode_GND);
#endif
#endif
vj4=(Vbici-vj1);
EXIT_IF_ISNAN((Vbici-vj1))
ez=(1.0-pModel->zci);
EXIT_IF_ISNAN((1.0-pModel->zci))
ezr=(1.0-zr);
EXIT_IF_ISNAN((1.0-zr))
{
double m00_logE(d00_logE0,(1.0-(vj1/vdci_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj1/vdci_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vci_ei_Vci_ei=0.0;
  vdj1_Vci_ei_Vbi_ei=0.0;
  vdj1_Vci_ei_Vs_ci=0.0;
  vdj1_Vci_ei_Vb_ci=0.0;
  vdj1_Vci_ei_Vtnode_GND=0.0;
  vdj1_Vci_ei_Vbi_ci=0.0;
#endif
vdj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ei_Vci_ei=0.0;
  vdj1_Vbi_ei_Vbi_ei=0.0;
  vdj1_Vbi_ei_Vs_ci=0.0;
  vdj1_Vbi_ei_Vb_ci=0.0;
  vdj1_Vbi_ei_Vtnode_GND=0.0;
  vdj1_Vbi_ei_Vbi_ci=0.0;
#endif
vdj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj1_Vs_ci_Vci_ei=0.0;
  vdj1_Vs_ci_Vbi_ei=0.0;
  vdj1_Vs_ci_Vs_ci=0.0;
  vdj1_Vs_ci_Vb_ci=0.0;
  vdj1_Vs_ci_Vtnode_GND=0.0;
  vdj1_Vs_ci_Vbi_ci=0.0;
#endif
vdj1_Vb_ci=(-(vj1_Vb_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vb_ci_Vci_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vci_ei/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vci_ei/vdci_t-(vj1_Vb_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ei/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ei/vdci_t-(vj1_Vb_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vs_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vs_ci/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vs_ci/vdci_t-(vj1_Vb_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vb_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vb_ci/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vb_ci/vdci_t-(vj1_Vb_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vdci_t)))*(-((vj1_Vtnode_GND*vdci_t-vj1*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vtnode_GND/vdci_t-(vj1_Vb_ci*vdci_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj1_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ci/vdci_t))*(-(vj1_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ci/vdci_t-(vj1_Vb_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#if defined(_DERIVATE)
vdj1_Vtnode_GND=(-((vj1_Vtnode_GND*vdci_t-vj1*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0;
#endif
vdj1_Vbi_ci=(-(vj1_Vbi_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vci_ei/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vci_ei/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ei/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ei/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vs_ci/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vs_ci/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vb_ci/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vb_ci/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vdci_t)))*(-((vj1_Vtnode_GND*vdci_t-vj1*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vtnode_GND/vdci_t-(vj1_Vbi_ci*vdci_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj1_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj1/vdci_t)))*(-(vj1_Vbi_ci/vdci_t))*(-(vj1_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ci/vdci_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vdci_t/vdci_t+2*vj1*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#endif
vdj1=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_logE(d00_logE0,(1.0-(vj2/vdci_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj2/vdci_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vci_ei_Vci_ei=0.0;
  vdj2_Vci_ei_Vbi_ei=0.0;
  vdj2_Vci_ei_Vs_ci=0.0;
  vdj2_Vci_ei_Vb_ci=0.0;
  vdj2_Vci_ei_Vtnode_GND=0.0;
  vdj2_Vci_ei_Vbi_ci=0.0;
#endif
vdj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ei_Vci_ei=0.0;
  vdj2_Vbi_ei_Vbi_ei=0.0;
  vdj2_Vbi_ei_Vs_ci=0.0;
  vdj2_Vbi_ei_Vb_ci=0.0;
  vdj2_Vbi_ei_Vtnode_GND=0.0;
  vdj2_Vbi_ei_Vbi_ci=0.0;
#endif
vdj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  vdj2_Vs_ci_Vci_ei=0.0;
  vdj2_Vs_ci_Vbi_ei=0.0;
  vdj2_Vs_ci_Vs_ci=0.0;
  vdj2_Vs_ci_Vb_ci=0.0;
  vdj2_Vs_ci_Vtnode_GND=0.0;
  vdj2_Vs_ci_Vbi_ci=0.0;
#endif
vdj2_Vb_ci=(-(vj2_Vb_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vb_ci_Vci_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vci_ei/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vci_ei/vdci_t-(vj2_Vb_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ei/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ei/vdci_t-(vj2_Vb_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vs_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vs_ci/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vs_ci/vdci_t-(vj2_Vb_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vb_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vb_ci/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vb_ci/vdci_t-(vj2_Vb_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vdci_t)))*(-((vj2_Vtnode_GND*vdci_t-vj2*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vtnode_GND/vdci_t-(vj2_Vb_ci*vdci_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj2_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ci/vdci_t))*(-(vj2_Vb_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ci/vdci_t-(vj2_Vb_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#if defined(_DERIVATE)
vdj2_Vtnode_GND=(-((vj2_Vtnode_GND*vdci_t-vj2*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0;
#endif
vdj2_Vbi_ci=(-(vj2_Vbi_ci/vdci_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vci_ei/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vci_ei/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ei/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ei/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vs_ci/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vs_ci/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vb_ci/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vb_ci/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vdci_t)))*(-((vj2_Vtnode_GND*vdci_t-vj2*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vtnode_GND/vdci_t-(vj2_Vbi_ci*vdci_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)));
  vdj2_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj2/vdci_t)))*(-(vj2_Vbi_ci/vdci_t))*(-(vj2_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ci/vdci_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vdci_t/vdci_t+2*vj2*0.0*0.0/vdci_t/vdci_t/vdci_t)));
#endif
#endif
vdj2=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_exp(d00_exp0,(vdj2*ez))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vci_ei_Vci_ei=0.0;
  qj1_Vci_ei_Vbi_ei=0.0;
  qj1_Vci_ei_Vs_ci=0.0;
  qj1_Vci_ei_Vb_ci=0.0;
  qj1_Vci_ei_Vtnode_GND=0.0;
  qj1_Vci_ei_Vbi_ci=0.0;
#endif
qj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj1_Vbi_ei_Vci_ei=0.0;
  qj1_Vbi_ei_Vbi_ei=0.0;
  qj1_Vbi_ei_Vs_ci=0.0;
  qj1_Vbi_ei_Vb_ci=0.0;
  qj1_Vbi_ei_Vtnode_GND=0.0;
  qj1_Vbi_ei_Vbi_ci=0.0;
#endif
qj1_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj1_Vs_ci_Vci_ei=0.0;
  qj1_Vs_ci_Vbi_ei=0.0;
  qj1_Vs_ci_Vs_ci=0.0;
  qj1_Vs_ci_Vb_ci=0.0;
  qj1_Vs_ci_Vtnode_GND=0.0;
  qj1_Vs_ci_Vbi_ci=0.0;
#endif
qj1_Vb_ci=((cjci0_t_ii*(-vdj2_Vb_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjci0_t_ii_Vtnode_GND*(-vdj2_Vb_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ez+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+(((cjci0_t_ii_Vtnode_GND*(1.0-d00_exp0))+(cjci0_t_ii*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#if defined(_DERIVATE)
qj1_Vtnode_GND=(((cjci0_t_ii_Vtnode_GND*(1.0-d00_exp0))+(cjci0_t_ii*(-vdj2_Vtnode_GND*ez*d10_exp0)))/ez);
#endif
qj1_Vbi_ci=((cjci0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjci0_t_ii_Vtnode_GND*(-vdj2_Vbi_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ez+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+(((cjci0_t_ii_Vtnode_GND*(1.0-d00_exp0))+(cjci0_t_ii*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjci0_t_ii*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjci0_t_ii*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjci0_t_ii*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjci0_t_ii*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjci0_t_ii*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#endif
qj1=((cjci0_t_ii*(1.0-d00_exp0))/ez);
EXIT_IF_ISNAN(((cjci0_t_ii*(1.0-d00_exp0))/ez))
}
{
double m00_exp(d00_exp0,(vdj1*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj2_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vci_ei_Vci_ei=0.0;
  qj2_Vci_ei_Vbi_ei=0.0;
  qj2_Vci_ei_Vs_ci=0.0;
  qj2_Vci_ei_Vb_ci=0.0;
  qj2_Vci_ei_Vtnode_GND=0.0;
  qj2_Vci_ei_Vbi_ci=0.0;
#endif
qj2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj2_Vbi_ei_Vci_ei=0.0;
  qj2_Vbi_ei_Vbi_ei=0.0;
  qj2_Vbi_ei_Vs_ci=0.0;
  qj2_Vbi_ei_Vb_ci=0.0;
  qj2_Vbi_ei_Vtnode_GND=0.0;
  qj2_Vbi_ei_Vbi_ci=0.0;
#endif
qj2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj2_Vs_ci_Vci_ei=0.0;
  qj2_Vs_ci_Vbi_ei=0.0;
  qj2_Vs_ci_Vs_ci=0.0;
  qj2_Vs_ci_Vb_ci=0.0;
  qj2_Vs_ci_Vtnode_GND=0.0;
  qj2_Vs_ci_Vbi_ci=0.0;
#endif
qj2_Vb_ci=((cr*(-vdj1_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vci_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vs_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vb_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vtnode_GND*ezr+vdj1_Vb_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj2_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj1_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj2_Vbi_ci=((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vci_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vs_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vb_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vtnode_GND*ezr+vdj1_Vbi_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj2=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
{
double m00_exp(d00_exp0,(vdj2*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj3_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vci_ei_Vci_ei=0.0;
  qj3_Vci_ei_Vbi_ei=0.0;
  qj3_Vci_ei_Vs_ci=0.0;
  qj3_Vci_ei_Vb_ci=0.0;
  qj3_Vci_ei_Vtnode_GND=0.0;
  qj3_Vci_ei_Vbi_ci=0.0;
#endif
qj3_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qj3_Vbi_ei_Vci_ei=0.0;
  qj3_Vbi_ei_Vbi_ei=0.0;
  qj3_Vbi_ei_Vs_ci=0.0;
  qj3_Vbi_ei_Vb_ci=0.0;
  qj3_Vbi_ei_Vtnode_GND=0.0;
  qj3_Vbi_ei_Vbi_ci=0.0;
#endif
qj3_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qj3_Vs_ci_Vci_ei=0.0;
  qj3_Vs_ci_Vbi_ei=0.0;
  qj3_Vs_ci_Vs_ci=0.0;
  qj3_Vs_ci_Vb_ci=0.0;
  qj3_Vs_ci_Vtnode_GND=0.0;
  qj3_Vs_ci_Vbi_ci=0.0;
#endif
qj3_Vb_ci=((cr*(-vdj2_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ezr+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj3_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj2_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj3_Vbi_ci=((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ezr+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj3=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
qjci_Vb_ci=(((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*vdci_t+(cmax*vj4_Vb_ci));
#if defined(_DERIVATE2)
  qjci_Vb_ci_Vb_ci=(+(+(+(+qj1_Vb_ci_Vb_ci+qj2_Vb_ci_Vb_ci)-qj3_Vb_ci_Vb_ci)*vdci_t+((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*0.0+((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vb_ci+0.0*vj4_Vb_ci+cmax*vj4_Vb_ci_Vb_ci));
  qjci_Vb_ci_Vtnode_GND=(+(+(+(+qj1_Vb_ci_Vtnode_GND+qj2_Vb_ci_Vtnode_GND)-qj3_Vb_ci_Vtnode_GND)*vdci_t+((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*vdci_t_Vtnode_GND+((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vtnode_GND+cmax_Vtnode_GND*vj4_Vb_ci+cmax*vj4_Vb_ci_Vtnode_GND));
  qjci_Vb_ci_Vbi_ci=(+(+(+(+qj1_Vb_ci_Vbi_ci+qj2_Vb_ci_Vbi_ci)-qj3_Vb_ci_Vbi_ci)*vdci_t+((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*0.0+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vbi_ci+0.0*vj4_Vb_ci+cmax*vj4_Vb_ci_Vbi_ci));
#endif
#if defined(_DERIVATE)
qjci_Vtnode_GND=(((((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*vdci_t)+(((qj1+qj2)-qj3)*vdci_t_Vtnode_GND))+((cmax_Vtnode_GND*vj4)+(cmax*vj4_Vtnode_GND)));
#endif
qjci_Vbi_ci=(((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*vdci_t+(cmax*vj4_Vbi_ci));
#if defined(_DERIVATE2)
  qjci_Vbi_ci_Vb_ci=(+(+(+(+qj1_Vbi_ci_Vb_ci+qj2_Vbi_ci_Vb_ci)-qj3_Vbi_ci_Vb_ci)*vdci_t+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*0.0+((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vb_ci+0.0*vj4_Vbi_ci+cmax*vj4_Vbi_ci_Vb_ci));
  qjci_Vbi_ci_Vtnode_GND=(+(+(+(+qj1_Vbi_ci_Vtnode_GND+qj2_Vbi_ci_Vtnode_GND)-qj3_Vbi_ci_Vtnode_GND)*vdci_t+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*vdci_t_Vtnode_GND+((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vtnode_GND+cmax_Vtnode_GND*vj4_Vbi_ci+cmax*vj4_Vbi_ci_Vtnode_GND));
  qjci_Vbi_ci_Vbi_ci=(+(+(+(+qj1_Vbi_ci_Vbi_ci+qj2_Vbi_ci_Vbi_ci)-qj3_Vbi_ci_Vbi_ci)*vdci_t+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*0.0+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vbi_ci+0.0*vj4_Vbi_ci+cmax*vj4_Vbi_ci_Vbi_ci));
#endif
#endif
pInst->qjci=((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4));
EXIT_IF_ISNAN(((((qj1+qj2)-qj3)*vdci_t)+(cmax*vj4)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
qjci_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qjci_Vb_ci_Vb_ci=0.0;
  qjci_Vb_ci_Vtnode_GND=0.0;
  qjci_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qjci_Vtnode_GND=0.0;
#endif
qjci_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjci_Vbi_ci_Vb_ci=0.0;
  qjci_Vbi_ci_Vtnode_GND=0.0;
  qjci_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
pInst->qjci=0.0;
EXIT_IF_ISNAN(0.0)
}
}
else
{
if
((cjci0_t_ii>0.0))
{
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zci))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdci_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdci_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdci_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=0.0;
  xvf_Vs_ci_Vbi_ei=0.0;
  xvf_Vs_ci_Vb_ci=0.0;
  xvf_Vs_ci_Vtnode_GND=0.0;
  xvf_Vs_ci_Vbi_ci=0.0;
#endif
xvf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=0.0;
  xvf_Vbi_ei_Vbi_ei=0.0;
  xvf_Vbi_ei_Vb_ci=0.0;
  xvf_Vbi_ei_Vtnode_GND=0.0;
  xvf_Vbi_ei_Vbi_ci=0.0;
#endif
xvf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=0.0;
  xvf_Vb_ci_Vbi_ei=0.0;
  xvf_Vb_ci_Vb_ci=0.0;
  xvf_Vb_ci_Vtnode_GND=0.0;
  xvf_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vbici)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=((-Vbici_Vbi_ci)/VT);
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vbi_ei=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vb_ci=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vtnode_GND=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vbi_ci_Vbi_ci=((+0.0-Vbici_Vbi_ci_Vbi_ci)/VT-((-Vbici_Vbi_ci)*0.0+(-Vbici_Vbi_ci)*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
#endif
#endif
xvf=((vf-Vbici)/VT);
EXIT_IF_ISNAN(((vf-Vbici)/VT))
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=0.0;
  xvf2_Vs_ci_Vbi_ei=0.0;
  xvf2_Vs_ci_Vb_ci=0.0;
  xvf2_Vs_ci_Vtnode_GND=0.0;
  xvf2_Vs_ci_Vbi_ci=0.0;
#endif
xvf2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=0.0;
  xvf2_Vbi_ei_Vbi_ei=0.0;
  xvf2_Vbi_ei_Vb_ci=0.0;
  xvf2_Vbi_ei_Vtnode_GND=0.0;
  xvf2_Vbi_ei_Vbi_ci=0.0;
#endif
xvf2_Vb_ci=((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vs_ci*xvf+xvf_Vb_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vs_ci)+0.0));
  xvf2_Vb_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ei*xvf+xvf_Vb_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ei)+0.0));
  xvf2_Vb_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vb_ci*xvf+xvf_Vb_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vb_ci)+0.0));
  xvf2_Vb_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vtnode_GND*xvf+xvf_Vb_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vb_ci+xvf*xvf_Vb_ci_Vtnode_GND)+0.0));
  xvf2_Vb_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ci*xvf+xvf_Vb_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ci)+0.0));
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=0.0;
  v_j_Vs_ci_Vbi_ei=0.0;
  v_j_Vs_ci_Vb_ci=0.0;
  v_j_Vs_ci_Vtnode_GND=0.0;
  v_j_Vs_ci_Vbi_ci=0.0;
#endif
v_j_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=0.0;
  v_j_Vbi_ei_Vbi_ei=0.0;
  v_j_Vbi_ei_Vb_ci=0.0;
  v_j_Vbi_ei_Vtnode_GND=0.0;
  v_j_Vbi_ei_Vbi_ci=0.0;
#endif
v_j_Vb_ci=(-(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vs_ci+xvf2_Vb_ci_Vs_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ei+xvf2_Vb_ci_Vbi_ei))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=0.0;
#endif
x_Vci_ei=0.0;
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=0.0;
  x_Vci_ei_Vci_ei=0.0;
#endif
#endif
x=(1.0-pModel->zci);
EXIT_IF_ISNAN((1.0-pModel->zci))
{
double m00_logE(d00_logE0,(1.0-(v_j/vdci_t)))
double m00_exp(d00_exp1,(x*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(v_j/vdci_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
y_Vs_ci=0.0;
#if defined(_DERIVATE2)
  y_Vs_ci_Vs_ci=0.0;
  y_Vs_ci_Vci_ei=0.0;
  y_Vs_ci_Vbi_ei=0.0;
  y_Vs_ci_Vb_ci=0.0;
  y_Vs_ci_Vtnode_GND=0.0;
  y_Vs_ci_Vbi_ci=0.0;
#endif
y_Vci_ei=0.0;
#if defined(_DERIVATE2)
  y_Vci_ei_Vs_ci=0.0;
  y_Vci_ei_Vci_ei=0.0;
  y_Vci_ei_Vbi_ei=0.0;
  y_Vci_ei_Vb_ci=0.0;
  y_Vci_ei_Vtnode_GND=0.0;
  y_Vci_ei_Vbi_ci=0.0;
#endif
y_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  y_Vbi_ei_Vs_ci=0.0;
  y_Vbi_ei_Vci_ei=0.0;
  y_Vbi_ei_Vbi_ei=0.0;
  y_Vbi_ei_Vb_ci=0.0;
  y_Vbi_ei_Vtnode_GND=0.0;
  y_Vbi_ei_Vbi_ci=0.0;
#endif
y_Vb_ci=(-(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vb_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vs_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vs_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*0.0)));
  y_Vb_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ei/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ei/vdci_t-(v_j_Vb_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vb_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vb_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0)))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vtnode_GND/vdci_t-(v_j_Vb_ci*vdci_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t))))));
  y_Vb_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
#endif
#if defined(_DERIVATE)
y_Vtnode_GND=(-((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*d10_exp1);
#endif
y_Vbi_ci=(-(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vs_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vs_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*0.0)));
  y_Vbi_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ei/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ei/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vb_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0)))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vdci_t-(v_j_Vbi_ci*vdci_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t))))));
  y_Vbi_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdci_t)))*(-(v_j_Vbi_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))));
#endif
#endif
y=(1.0-d00_exp1);
EXIT_IF_ISNAN((1.0-d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
qjci_Vb_ci=((((cjci0_t_ii*vdci_t)*y_Vb_ci)/x)+((2.4*cjci0_t_ii)*(-v_j_Vb_ci)));
#if defined(_DERIVATE2)
  qjci_Vb_ci_Vb_ci=(+((+(+0.0*vdci_t+0.0*0.0+0.0*0.0+cjci0_t_ii*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vb_ci+(cjci0_t_ii*vdci_t)*y_Vb_ci_Vb_ci)/x-(((cjci0_t_ii*vdci_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cjci0_t_ii*vdci_t)*y_Vb_ci)))*0.0+((cjci0_t_ii*vdci_t)*y)*0.0)/x/x+2*((cjci0_t_ii*vdci_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(-v_j_Vb_ci)+(2.4*cjci0_t_ii)*(+0.0-v_j_Vb_ci_Vb_ci)));
  qjci_Vb_ci_Vtnode_GND=(+((+(+0.0*vdci_t+0.0*vdci_t_Vtnode_GND+cjci0_t_ii_Vtnode_GND*0.0+cjci0_t_ii*0.0)*y+0.0*y_Vtnode_GND+(((cjci0_t_ii_Vtnode_GND*vdci_t)+(cjci0_t_ii*vdci_t_Vtnode_GND)))*y_Vb_ci+(cjci0_t_ii*vdci_t)*y_Vb_ci_Vtnode_GND)/x-(((cjci0_t_ii*vdci_t)*y_Vb_ci)*x_Vtnode_GND+((((((cjci0_t_ii_Vtnode_GND*vdci_t)+(cjci0_t_ii*vdci_t_Vtnode_GND)))*y)+((cjci0_t_ii*vdci_t)*y_Vtnode_GND)))*0.0+((cjci0_t_ii*vdci_t)*y)*0.0)/x/x+2*((cjci0_t_ii*vdci_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cjci0_t_ii+0.0*cjci0_t_ii_Vtnode_GND+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(-v_j_Vtnode_GND)+((2.4*cjci0_t_ii_Vtnode_GND))*(-v_j_Vb_ci)+(2.4*cjci0_t_ii)*(+0.0-v_j_Vb_ci_Vtnode_GND)));
  qjci_Vb_ci_Vbi_ci=(+((+(+0.0*vdci_t+0.0*0.0+0.0*0.0+cjci0_t_ii*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vb_ci+(cjci0_t_ii*vdci_t)*y_Vb_ci_Vbi_ci)/x-(((cjci0_t_ii*vdci_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cjci0_t_ii*vdci_t)*y_Vbi_ci)))*0.0+((cjci0_t_ii*vdci_t)*y)*0.0)/x/x+2*((cjci0_t_ii*vdci_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(Vbici_Vbi_ci-v_j_Vbi_ci)+(0.0)*(-v_j_Vb_ci)+(2.4*cjci0_t_ii)*(+0.0-v_j_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
qjci_Vtnode_GND=(((((((cjci0_t_ii_Vtnode_GND*vdci_t)+(cjci0_t_ii*vdci_t_Vtnode_GND))*y)+((cjci0_t_ii*vdci_t)*y_Vtnode_GND))*x-((cjci0_t_ii*vdci_t)*y)*x_Vtnode_GND)/x/x)+(((2.4*cjci0_t_ii_Vtnode_GND)*(Vbici-v_j))+((2.4*cjci0_t_ii)*(-v_j_Vtnode_GND))));
#endif
qjci_Vbi_ci=((((cjci0_t_ii*vdci_t)*y_Vbi_ci)/x)+((2.4*cjci0_t_ii)*(Vbici_Vbi_ci-v_j_Vbi_ci)));
#if defined(_DERIVATE2)
  qjci_Vbi_ci_Vb_ci=(+((+(+0.0*vdci_t+0.0*0.0+0.0*0.0+cjci0_t_ii*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vbi_ci+(cjci0_t_ii*vdci_t)*y_Vbi_ci_Vb_ci)/x-(((cjci0_t_ii*vdci_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cjci0_t_ii*vdci_t)*y_Vb_ci)))*0.0+((cjci0_t_ii*vdci_t)*y)*0.0)/x/x+2*((cjci0_t_ii*vdci_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(Vbici_Vbi_ci-v_j_Vbi_ci)+(2.4*cjci0_t_ii)*(+0.0-v_j_Vbi_ci_Vb_ci)));
  qjci_Vbi_ci_Vtnode_GND=(+((+(+0.0*vdci_t+0.0*vdci_t_Vtnode_GND+cjci0_t_ii_Vtnode_GND*0.0+cjci0_t_ii*0.0)*y+0.0*y_Vtnode_GND+(((cjci0_t_ii_Vtnode_GND*vdci_t)+(cjci0_t_ii*vdci_t_Vtnode_GND)))*y_Vbi_ci+(cjci0_t_ii*vdci_t)*y_Vbi_ci_Vtnode_GND)/x-(((cjci0_t_ii*vdci_t)*y_Vbi_ci)*x_Vtnode_GND+((((((cjci0_t_ii_Vtnode_GND*vdci_t)+(cjci0_t_ii*vdci_t_Vtnode_GND)))*y)+((cjci0_t_ii*vdci_t)*y_Vtnode_GND)))*0.0+((cjci0_t_ii*vdci_t)*y)*0.0)/x/x+2*((cjci0_t_ii*vdci_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cjci0_t_ii+0.0*cjci0_t_ii_Vtnode_GND+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(-v_j_Vtnode_GND)+((2.4*cjci0_t_ii_Vtnode_GND))*(Vbici_Vbi_ci-v_j_Vbi_ci)+(2.4*cjci0_t_ii)*(+0.0-v_j_Vbi_ci_Vtnode_GND)));
  qjci_Vbi_ci_Vbi_ci=(+((+(+0.0*vdci_t+0.0*0.0+0.0*0.0+cjci0_t_ii*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vbi_ci+(cjci0_t_ii*vdci_t)*y_Vbi_ci_Vbi_ci)/x-(((cjci0_t_ii*vdci_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cjci0_t_ii*vdci_t)*y_Vbi_ci)))*0.0+((cjci0_t_ii*vdci_t)*y)*0.0)/x/x+2*((cjci0_t_ii*vdci_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(Vbici-v_j)+0.0*(Vbici_Vbi_ci-v_j_Vbi_ci)+(0.0)*(Vbici_Vbi_ci-v_j_Vbi_ci)+(2.4*cjci0_t_ii)*(+Vbici_Vbi_ci_Vbi_ci-v_j_Vbi_ci_Vbi_ci)));
#endif
#endif
pInst->qjci=((((cjci0_t_ii*vdci_t)*y)/x)+((2.4*cjci0_t_ii)*(Vbici-v_j)));
EXIT_IF_ISNAN(((((cjci0_t_ii*vdci_t)*y)/x)+((2.4*cjci0_t_ii)*(Vbici-v_j))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
qjci_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qjci_Vb_ci_Vb_ci=0.0;
  qjci_Vb_ci_Vtnode_GND=0.0;
  qjci_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qjci_Vtnode_GND=0.0;
#endif
qjci_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjci_Vbi_ci_Vb_ci=0.0;
  qjci_Vbi_ci_Vtnode_GND=0.0;
  qjci_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
pInst->qjci=0.00;
EXIT_IF_ISNAN(0.00)
}
}
#if defined(_DYNAMIC)
qjci_int=pInst->qjci;
EXIT_IF_ISNAN(pInst->qjci)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
#if defined(_DERIVATE)
qjcii_Vb_ci=qjci_Vb_ci;
#endif
#if defined(_DERIVATE)
qjcii_Vtnode_GND=(qjci_Vtnode_GND+qjcxi_Vtnode_GND);
#endif
#if defined(_DERIVATE)
qjcii_Vbi_ci=(qjci_Vbi_ci+qjcxi_Vbi_ci);
#endif
#endif
qjcii=(pInst->qjci+qjcxi);
EXIT_IF_ISNAN((pInst->qjci+qjcxi))
#endif
if
((cjci0_t_ii>0.0))
{
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zci))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vdci_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vdci_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdci_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=0.0;
  xvf_Vs_ci_Vbi_ei=0.0;
  xvf_Vs_ci_Vb_ci=0.0;
  xvf_Vs_ci_Vtnode_GND=0.0;
  xvf_Vs_ci_Vbi_ci=0.0;
#endif
xvf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=0.0;
  xvf_Vbi_ei_Vbi_ei=0.0;
  xvf_Vbi_ei_Vb_ci=0.0;
  xvf_Vbi_ei_Vtnode_GND=0.0;
  xvf_Vbi_ei_Vbi_ci=0.0;
#endif
xvf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=0.0;
  xvf_Vb_ci_Vbi_ei=0.0;
  xvf_Vb_ci_Vb_ci=0.0;
  xvf_Vb_ci_Vtnode_GND=0.0;
  xvf_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vbici)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=((-Vbici_Vbi_ci)/VT);
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vbi_ei=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vb_ci=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*0.0+0.0*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ci_Vtnode_GND=((+0.0-0.0)/VT-((-Vbici_Vbi_ci)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vbi_ci_Vbi_ci=((+0.0-Vbici_Vbi_ci_Vbi_ci)/VT-((-Vbici_Vbi_ci)*0.0+(-Vbici_Vbi_ci)*0.0+(vf-Vbici)*0.0)/VT/VT+2*(vf-Vbici)*0.0*0.0/VT/VT/VT);
#endif
#endif
xvf=((vf-Vbici)/VT);
EXIT_IF_ISNAN(((vf-Vbici)/VT))
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=0.0;
  xvf2_Vs_ci_Vbi_ei=0.0;
  xvf2_Vs_ci_Vb_ci=0.0;
  xvf2_Vs_ci_Vtnode_GND=0.0;
  xvf2_Vs_ci_Vbi_ci=0.0;
#endif
xvf2_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=0.0;
  xvf2_Vbi_ei_Vbi_ei=0.0;
  xvf2_Vbi_ei_Vb_ci=0.0;
  xvf2_Vbi_ei_Vtnode_GND=0.0;
  xvf2_Vbi_ei_Vbi_ci=0.0;
#endif
xvf2_Vb_ci=((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vs_ci*xvf+xvf_Vb_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vs_ci)+0.0));
  xvf2_Vb_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ei*xvf+xvf_Vb_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ei)+0.0));
  xvf2_Vb_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vb_ci*xvf+xvf_Vb_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vb_ci)+0.0));
  xvf2_Vb_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vtnode_GND*xvf+xvf_Vb_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vb_ci+xvf*xvf_Vb_ci_Vtnode_GND)+0.0));
  xvf2_Vb_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ci*xvf+xvf_Vb_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ci)+0.0));
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=0.0;
  v_j_Vs_ci_Vbi_ei=0.0;
  v_j_Vs_ci_Vb_ci=0.0;
  v_j_Vs_ci_Vtnode_GND=0.0;
  v_j_Vs_ci_Vbi_ci=0.0;
#endif
v_j_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=0.0;
  v_j_Vbi_ei_Vbi_ei=0.0;
  v_j_Vbi_ei_Vb_ci=0.0;
  v_j_Vbi_ei_Vtnode_GND=0.0;
  v_j_Vbi_ei_Vbi_ci=0.0;
#endif
v_j_Vb_ci=(-(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vs_ci+xvf2_Vb_ci_Vs_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ei+xvf2_Vb_ci_Vbi_ei))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
dvj_Vb_ci=(((0.5*(xvf_Vb_ci+xvf2_Vb_ci))*xvf2-(0.5*(xvf+xvf2))*xvf2_Vb_ci)/xvf2/xvf2);
#if defined(_DERIVATE2)
  dvj_Vb_ci_Vb_ci=((+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.5*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))/xvf2-((0.5*(xvf_Vb_ci+xvf2_Vb_ci))*xvf2_Vb_ci+((0.5*(xvf_Vb_ci+xvf2_Vb_ci)))*xvf2_Vb_ci+(0.5*(xvf+xvf2))*xvf2_Vb_ci_Vb_ci)/xvf2/xvf2+2*(0.5*(xvf+xvf2))*xvf2_Vb_ci*xvf2_Vb_ci/xvf2/xvf2/xvf2);
  dvj_Vb_ci_Vtnode_GND=((+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.5*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))/xvf2-((0.5*(xvf_Vb_ci+xvf2_Vb_ci))*xvf2_Vtnode_GND+((0.5*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*xvf2_Vb_ci+(0.5*(xvf+xvf2))*xvf2_Vb_ci_Vtnode_GND)/xvf2/xvf2+2*(0.5*(xvf+xvf2))*xvf2_Vb_ci*xvf2_Vtnode_GND/xvf2/xvf2/xvf2);
  dvj_Vb_ci_Vbi_ci=((+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.5*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))/xvf2-((0.5*(xvf_Vb_ci+xvf2_Vb_ci))*xvf2_Vbi_ci+((0.5*(xvf_Vbi_ci+xvf2_Vbi_ci)))*xvf2_Vb_ci+(0.5*(xvf+xvf2))*xvf2_Vb_ci_Vbi_ci)/xvf2/xvf2+2*(0.5*(xvf+xvf2))*xvf2_Vb_ci*xvf2_Vbi_ci/xvf2/xvf2/xvf2);
#endif
#if defined(_DERIVATE)
dvj_Vtnode_GND=(((0.5*(xvf_Vtnode_GND+xvf2_Vtnode_GND))*xvf2-(0.5*(xvf+xvf2))*xvf2_Vtnode_GND)/xvf2/xvf2);
#endif
dvj_Vbi_ci=(((0.5*(xvf_Vbi_ci+xvf2_Vbi_ci))*xvf2-(0.5*(xvf+xvf2))*xvf2_Vbi_ci)/xvf2/xvf2);
#if defined(_DERIVATE2)
  dvj_Vbi_ci_Vb_ci=((+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.5*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))/xvf2-((0.5*(xvf_Vbi_ci+xvf2_Vbi_ci))*xvf2_Vb_ci+((0.5*(xvf_Vb_ci+xvf2_Vb_ci)))*xvf2_Vbi_ci+(0.5*(xvf+xvf2))*xvf2_Vbi_ci_Vb_ci)/xvf2/xvf2+2*(0.5*(xvf+xvf2))*xvf2_Vbi_ci*xvf2_Vb_ci/xvf2/xvf2/xvf2);
  dvj_Vbi_ci_Vtnode_GND=((+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.5*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))/xvf2-((0.5*(xvf_Vbi_ci+xvf2_Vbi_ci))*xvf2_Vtnode_GND+((0.5*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*xvf2_Vbi_ci+(0.5*(xvf+xvf2))*xvf2_Vbi_ci_Vtnode_GND)/xvf2/xvf2+2*(0.5*(xvf+xvf2))*xvf2_Vbi_ci*xvf2_Vtnode_GND/xvf2/xvf2/xvf2);
  dvj_Vbi_ci_Vbi_ci=((+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.5*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))/xvf2-((0.5*(xvf_Vbi_ci+xvf2_Vbi_ci))*xvf2_Vbi_ci+((0.5*(xvf_Vbi_ci+xvf2_Vbi_ci)))*xvf2_Vbi_ci+(0.5*(xvf+xvf2))*xvf2_Vbi_ci_Vbi_ci)/xvf2/xvf2+2*(0.5*(xvf+xvf2))*xvf2_Vbi_ci*xvf2_Vbi_ci/xvf2/xvf2/xvf2);
#endif
#endif
dvj=((0.5*(xvf+xvf2))/xvf2);
EXIT_IF_ISNAN(((0.5*(xvf+xvf2))/xvf2))
{
double m00_logE(d00_logE0,(1-(v_j/vdci_t)))
double m00_exp(d00_exp1,((-pModel->zci)*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1-(v_j/vdci_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
cjcii_Vtnode_GND=(((((cjci0_t_ii_Vtnode_GND*d00_exp1)+(cjci0_t_ii*((-pModel->zci)*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0)*d10_exp1))*dvj)+((cjci0_t_ii*d00_exp1)*dvj_Vtnode_GND))+(((2.4*cjci0_t_ii_Vtnode_GND)*(1-dvj))+((2.4*cjci0_t_ii)*(-dvj_Vtnode_GND))));
#endif
cjcii_Vb_ci=((((cjci0_t_ii*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj)+((cjci0_t_ii*d00_exp1)*dvj_Vb_ci))+((2.4*cjci0_t_ii)*(-dvj_Vb_ci)));
#if defined(_DERIVATE2)
  cjcii_Vb_ci_Vtnode_GND=(+(+(+0.0*d00_exp1+0.0*(((-pModel->zci)*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*d10_exp1+cjci0_t_ii_Vtnode_GND*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1+cjci0_t_ii*(m20_exp(((-pModel->zci)*d00_logE0))*(((-pModel->zci)*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+(-pModel->zci)*(m20_logE((1-(v_j/vdci_t)))*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vtnode_GND/vdci_t-(v_j_Vb_ci*vdci_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t))))))*dvj+(cjci0_t_ii*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj_Vtnode_GND+(((cjci0_t_ii_Vtnode_GND*d00_exp1)+(cjci0_t_ii*(((-pModel->zci)*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*d10_exp1)))*dvj_Vb_ci+(cjci0_t_ii*d00_exp1)*dvj_Vb_ci_Vtnode_GND)+(+(+0.0*cjci0_t_ii+0.0*cjci0_t_ii_Vtnode_GND+0.0*0.0+2.4*0.0)*(1-dvj)+0.0*(-dvj_Vtnode_GND)+((2.4*cjci0_t_ii_Vtnode_GND))*(-dvj_Vb_ci)+(2.4*cjci0_t_ii)*(+0.0-dvj_Vb_ci_Vtnode_GND)));
  cjcii_Vb_ci_Vb_ci=(+(+(+0.0*d00_exp1+0.0*(((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*d10_exp1+0.0*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1+cjci0_t_ii*(m20_exp(((-pModel->zci)*d00_logE0))*(((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+(-pModel->zci)*(m20_logE((1-(v_j/vdci_t)))*(-(v_j_Vb_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vb_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))))*dvj+(cjci0_t_ii*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj_Vb_ci+((cjci0_t_ii*(((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*d10_exp1))*dvj_Vb_ci+(cjci0_t_ii*d00_exp1)*dvj_Vb_ci_Vb_ci)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(1-dvj)+0.0*(-dvj_Vb_ci)+(0.0)*(-dvj_Vb_ci)+(2.4*cjci0_t_ii)*(+0.0-dvj_Vb_ci_Vb_ci)));
  cjcii_Vb_ci_Vbi_ci=(+(+(+0.0*d00_exp1+0.0*(((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*d10_exp1+0.0*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1+cjci0_t_ii*(m20_exp(((-pModel->zci)*d00_logE0))*(((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+(-pModel->zci)*(m20_logE((1-(v_j/vdci_t)))*(-(v_j_Vbi_ci/vdci_t))*(-(v_j_Vb_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ci/vdci_t-(v_j_Vb_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))))*dvj+(cjci0_t_ii*((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj_Vbi_ci+((cjci0_t_ii*(((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*d10_exp1))*dvj_Vb_ci+(cjci0_t_ii*d00_exp1)*dvj_Vb_ci_Vbi_ci)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(1-dvj)+0.0*(-dvj_Vbi_ci)+(0.0)*(-dvj_Vb_ci)+(2.4*cjci0_t_ii)*(+0.0-dvj_Vb_ci_Vbi_ci)));
#endif
cjcii_Vbi_ci=((((cjci0_t_ii*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj)+((cjci0_t_ii*d00_exp1)*dvj_Vbi_ci))+((2.4*cjci0_t_ii)*(-dvj_Vbi_ci)));
#if defined(_DERIVATE2)
  cjcii_Vbi_ci_Vtnode_GND=(+(+(+0.0*d00_exp1+0.0*(((-pModel->zci)*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*d10_exp1+cjci0_t_ii_Vtnode_GND*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1+cjci0_t_ii*(m20_exp(((-pModel->zci)*d00_logE0))*(((-pModel->zci)*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+(-pModel->zci)*(m20_logE((1-(v_j/vdci_t)))*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vdci_t-(v_j_Vbi_ci*vdci_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t))))))*dvj+(cjci0_t_ii*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj_Vtnode_GND+(((cjci0_t_ii_Vtnode_GND*d00_exp1)+(cjci0_t_ii*(((-pModel->zci)*(-((v_j_Vtnode_GND*vdci_t-v_j*vdci_t_Vtnode_GND)/vdci_t/vdci_t))*d10_logE0))*d10_exp1)))*dvj_Vbi_ci+(cjci0_t_ii*d00_exp1)*dvj_Vbi_ci_Vtnode_GND)+(+(+0.0*cjci0_t_ii+0.0*cjci0_t_ii_Vtnode_GND+0.0*0.0+2.4*0.0)*(1-dvj)+0.0*(-dvj_Vtnode_GND)+((2.4*cjci0_t_ii_Vtnode_GND))*(-dvj_Vbi_ci)+(2.4*cjci0_t_ii)*(+0.0-dvj_Vbi_ci_Vtnode_GND)));
  cjcii_Vbi_ci_Vb_ci=(+(+(+0.0*d00_exp1+0.0*(((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*d10_exp1+0.0*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1+cjci0_t_ii*(m20_exp(((-pModel->zci)*d00_logE0))*(((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+(-pModel->zci)*(m20_logE((1-(v_j/vdci_t)))*(-(v_j_Vb_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))))*dvj+(cjci0_t_ii*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj_Vb_ci+((cjci0_t_ii*(((-pModel->zci)*(-(v_j_Vb_ci/vdci_t))*d10_logE0))*d10_exp1))*dvj_Vbi_ci+(cjci0_t_ii*d00_exp1)*dvj_Vbi_ci_Vb_ci)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(1-dvj)+0.0*(-dvj_Vb_ci)+(0.0)*(-dvj_Vbi_ci)+(2.4*cjci0_t_ii)*(+0.0-dvj_Vbi_ci_Vb_ci)));
  cjcii_Vbi_ci_Vbi_ci=(+(+(+0.0*d00_exp1+0.0*(((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*d10_exp1+0.0*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1+cjci0_t_ii*(m20_exp(((-pModel->zci)*d00_logE0))*(((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdci_t))*d10_logE0+(-pModel->zci)*(m20_logE((1-(v_j/vdci_t)))*(-(v_j_Vbi_ci/vdci_t))*(-(v_j_Vbi_ci/vdci_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vdci_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdci_t/vdci_t+2*v_j*0.0*0.0/vdci_t/vdci_t/vdci_t))))))*dvj+(cjci0_t_ii*((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0)*d10_exp1)*dvj_Vbi_ci+((cjci0_t_ii*(((-pModel->zci)*(-(v_j_Vbi_ci/vdci_t))*d10_logE0))*d10_exp1))*dvj_Vbi_ci+(cjci0_t_ii*d00_exp1)*dvj_Vbi_ci_Vbi_ci)+(+(+0.0*cjci0_t_ii+0.0*0.0+0.0*0.0+2.4*0.0)*(1-dvj)+0.0*(-dvj_Vbi_ci)+(0.0)*(-dvj_Vbi_ci)+(2.4*cjci0_t_ii)*(+0.0-dvj_Vbi_ci_Vbi_ci)));
#endif
#endif
cjcii=(((cjci0_t_ii*d00_exp1)*dvj)+((2.4*cjci0_t_ii)*(1-dvj)));
EXIT_IF_ISNAN((((cjci0_t_ii*d00_exp1)*dvj)+((2.4*cjci0_t_ii)*(1-dvj))))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
cjcii_Vtnode_GND=0.0;
#endif
cjcii_Vb_ci=0.0;
#if defined(_DERIVATE2)
  cjcii_Vb_ci_Vtnode_GND=0.0;
  cjcii_Vb_ci_Vb_ci=0.0;
  cjcii_Vb_ci_Vbi_ci=0.0;
#endif
cjcii_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  cjcii_Vbi_ci_Vtnode_GND=0.0;
  cjcii_Vbi_ci_Vb_ci=0.0;
  cjcii_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
cjcii=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(tnode,GND) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
vc_Vci_ei=Vciei_Vci_ei;
#if defined(_DERIVATE2)
  vc_Vci_ei_Vci_ei=(+Vciei_Vci_ei_Vci_ei-0.0);
  vc_Vci_ei_Vtnode_GND=(+0.0-0.0);
#endif
#if defined(_DERIVATE)
vc_Vtnode_GND=(-vces_t_Vtnode_GND);
#endif
#endif
vc=(Vciei-vces_t);
EXIT_IF_ISNAN((Vciei-vces_t))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
uvc_Vci_ei=(vc_Vci_ei/VT);
#if defined(_DERIVATE2)
  uvc_Vci_ei_Vci_ei=(+(vc_Vci_ei_Vci_ei/VT-(vc_Vci_ei*0.0+vc_Vci_ei*0.0+vc*0.0)/VT/VT+2*vc*0.0*0.0/VT/VT/VT)-0.0);
  uvc_Vci_ei_Vtnode_GND=(+(vc_Vci_ei_Vtnode_GND/VT-(vc_Vci_ei*VT_Vtnode_GND+vc_Vtnode_GND*0.0+vc*0.0)/VT/VT+2*vc*0.0*VT_Vtnode_GND/VT/VT/VT)-0.0);
#endif
#if defined(_DERIVATE)
uvc_Vtnode_GND=((vc_Vtnode_GND*VT-vc*VT_Vtnode_GND)/VT/VT);
#endif
#endif
uvc=((vc/VT)-1);
EXIT_IF_ISNAN(((vc/VT)-1))
{
double m00_sqrt(d00_sqrt0,((uvc*uvc)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((uvc*uvc)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
vceff_Vtnode_GND=((VT_Vtnode_GND*(1+(0.5*(uvc+d00_sqrt0))))+(VT*(0.5*(uvc_Vtnode_GND+((uvc_Vtnode_GND*uvc)+(uvc*uvc_Vtnode_GND))*d10_sqrt0))));
#endif
vceff_Vci_ei=(VT*(0.5*(uvc_Vci_ei+((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei))*d10_sqrt0)));
#if defined(_DERIVATE2)
  vceff_Vci_ei_Vtnode_GND=(+0.0*(1+(0.5*(uvc+d00_sqrt0)))+0.0*((0.5*(uvc_Vtnode_GND+(((uvc_Vtnode_GND*uvc)+(uvc*uvc_Vtnode_GND)))*d10_sqrt0)))+VT_Vtnode_GND*(0.5*(uvc_Vci_ei+((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei))*d10_sqrt0))+VT*(+0.0+(+0.0*(uvc+d00_sqrt0)+0.0*(uvc_Vtnode_GND+(((uvc_Vtnode_GND*uvc)+(uvc*uvc_Vtnode_GND)))*d10_sqrt0)+0.0*(uvc_Vci_ei+((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei))*d10_sqrt0)+0.5*(+uvc_Vci_ei_Vtnode_GND+(m20_sqrt(((uvc*uvc)+1.921812))*(((uvc_Vtnode_GND*uvc)+(uvc*uvc_Vtnode_GND)))*((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei))+d10_sqrt0*(+(+uvc_Vci_ei_Vtnode_GND*uvc+uvc_Vci_ei*uvc_Vtnode_GND+uvc_Vtnode_GND*uvc_Vci_ei+uvc*uvc_Vci_ei_Vtnode_GND)+0.0))))));
  vceff_Vci_ei_Vci_ei=(+0.0*(1+(0.5*(uvc+d00_sqrt0)))+0.0*((0.5*(uvc_Vci_ei+(((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei)))*d10_sqrt0)))+0.0*(0.5*(uvc_Vci_ei+((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei))*d10_sqrt0))+VT*(+0.0+(+0.0*(uvc+d00_sqrt0)+0.0*(uvc_Vci_ei+(((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei)))*d10_sqrt0)+0.0*(uvc_Vci_ei+((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei))*d10_sqrt0)+0.5*(+uvc_Vci_ei_Vci_ei+(m20_sqrt(((uvc*uvc)+1.921812))*(((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei)))*((uvc_Vci_ei*uvc)+(uvc*uvc_Vci_ei))+d10_sqrt0*(+(+uvc_Vci_ei_Vci_ei*uvc+uvc_Vci_ei*uvc_Vci_ei+uvc_Vci_ei*uvc_Vci_ei+uvc*uvc_Vci_ei_Vci_ei)+0.0))))));
#endif
#endif
vceff=(VT*(1+(0.5*(uvc+d00_sqrt0))));
EXIT_IF_ISNAN((VT*(1+(0.5*(uvc+d00_sqrt0)))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=((vceff_Vtnode_GND-vlim_t_Vtnode_GND)/pModel->vpt);
#endif
x_Vci_ei=(vceff_Vci_ei/pModel->vpt);
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=((+vceff_Vci_ei_Vtnode_GND-0.0)/pModel->vpt-(vceff_Vci_ei*0.0+(vceff_Vtnode_GND-vlim_t_Vtnode_GND)*0.0+(vceff-vlim_t)*0.0)/pModel->vpt/pModel->vpt+2*(vceff-vlim_t)*0.0*0.0/pModel->vpt/pModel->vpt/pModel->vpt);
  x_Vci_ei_Vci_ei=((+vceff_Vci_ei_Vci_ei-0.0)/pModel->vpt-(vceff_Vci_ei*0.0+vceff_Vci_ei*0.0+(vceff-vlim_t)*0.0)/pModel->vpt/pModel->vpt+2*(vceff-vlim_t)*0.0*0.0/pModel->vpt/pModel->vpt/pModel->vpt);
#endif
#endif
x=((vceff-vlim_t)/pModel->vpt);
EXIT_IF_ISNAN(((vceff-vlim_t)/pModel->vpt))
{
double m00_sqrt(d00_sqrt0,((x*x)+1e-3))
double m00_sqrt(d00_sqrt1,(1+(((vceff*vceff)/vlim_t)/vlim_t)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((x*x)+1e-3))
double m10_sqrt(d10_sqrt1,d00_sqrt1,(1+(((vceff*vceff)/vlim_t)/vlim_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
ick_Vtnode_GND=((((((vceff_Vtnode_GND*(1+(0.5*(x+d00_sqrt0))))+(vceff*(0.5*(x_Vtnode_GND+((x_Vtnode_GND*x)+(x*x_Vtnode_GND))*d10_sqrt0))))*rci0_t-(vceff*(1+(0.5*(x+d00_sqrt0))))*rci0_t_Vtnode_GND)/rci0_t/rci0_t)*d00_sqrt1-((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)*((((((vceff_Vtnode_GND*vceff)+(vceff*vceff_Vtnode_GND))*vlim_t-(vceff*vceff)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*vlim_t-((vceff*vceff)/vlim_t)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*d10_sqrt1)/d00_sqrt1/d00_sqrt1);
#endif
ick_Vci_ei=(((((vceff_Vci_ei*(1+(0.5*(x+d00_sqrt0))))+(vceff*(0.5*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0))))/rci0_t)*d00_sqrt1-((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)*((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)/vlim_t)*d10_sqrt1)/d00_sqrt1/d00_sqrt1);
#if defined(_DERIVATE2)
  ick_Vci_ei_Vtnode_GND=(((+vceff_Vci_ei_Vtnode_GND*(1+(0.5*(x+d00_sqrt0)))+vceff_Vci_ei*((0.5*(x_Vtnode_GND+(((x_Vtnode_GND*x)+(x*x_Vtnode_GND)))*d10_sqrt0)))+vceff_Vtnode_GND*(0.5*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0))+vceff*(+0.0+(+0.0*(x+d00_sqrt0)+0.0*(x_Vtnode_GND+(((x_Vtnode_GND*x)+(x*x_Vtnode_GND)))*d10_sqrt0)+0.0*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0)+0.5*(+x_Vci_ei_Vtnode_GND+(m20_sqrt(((x*x)+1e-3))*(((x_Vtnode_GND*x)+(x*x_Vtnode_GND)))*((x_Vci_ei*x)+(x*x_Vci_ei))+d10_sqrt0*(+(+x_Vci_ei_Vtnode_GND*x+x_Vci_ei*x_Vtnode_GND+x_Vtnode_GND*x_Vci_ei+x*x_Vci_ei_Vtnode_GND)+0.0))))))/rci0_t-(((vceff_Vci_ei*(1+(0.5*(x+d00_sqrt0))))+(vceff*(0.5*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0))))*rci0_t_Vtnode_GND+(((vceff_Vtnode_GND*(1+(0.5*(x+d00_sqrt0))))+(vceff*((0.5*(x_Vtnode_GND+(((x_Vtnode_GND*x)+(x*x_Vtnode_GND)))*d10_sqrt0))))))*0.0+(vceff*(1+(0.5*(x+d00_sqrt0))))*0.0)/rci0_t/rci0_t+2*(vceff*(1+(0.5*(x+d00_sqrt0))))*0.0*rci0_t_Vtnode_GND/rci0_t/rci0_t/rci0_t)/d00_sqrt1-((((vceff_Vci_ei*(1+(0.5*(x+d00_sqrt0))))+(vceff*(0.5*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0))))/rci0_t)*(((((((vceff_Vtnode_GND*vceff)+(vceff*vceff_Vtnode_GND)))*vlim_t-(vceff*vceff)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*vlim_t-((vceff*vceff)/vlim_t)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*d10_sqrt1+(((((vceff_Vtnode_GND*(1+(0.5*(x+d00_sqrt0))))+(vceff*((0.5*(x_Vtnode_GND+(((x_Vtnode_GND*x)+(x*x_Vtnode_GND)))*d10_sqrt0))))))*rci0_t-(vceff*(1+(0.5*(x+d00_sqrt0))))*rci0_t_Vtnode_GND)/rci0_t/rci0_t)*((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)/vlim_t)*d10_sqrt1+((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)*(m20_sqrt((1+(((vceff*vceff)/vlim_t)/vlim_t)))*(((((((vceff_Vtnode_GND*vceff)+(vceff*vceff_Vtnode_GND)))*vlim_t-(vceff*vceff)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*vlim_t-((vceff*vceff)/vlim_t)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)/vlim_t)+d10_sqrt1*(+0.0+(((+vceff_Vci_ei_Vtnode_GND*vceff+vceff_Vci_ei*vceff_Vtnode_GND+vceff_Vtnode_GND*vceff_Vci_ei+vceff*vceff_Vci_ei_Vtnode_GND)/vlim_t-(((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))*vlim_t_Vtnode_GND+(((vceff_Vtnode_GND*vceff)+(vceff*vceff_Vtnode_GND)))*0.0+(vceff*vceff)*0.0)/vlim_t/vlim_t+2*(vceff*vceff)*0.0*vlim_t_Vtnode_GND/vlim_t/vlim_t/vlim_t)/vlim_t-((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)*vlim_t_Vtnode_GND+(((((vceff_Vtnode_GND*vceff)+(vceff*vceff_Vtnode_GND)))*vlim_t-(vceff*vceff)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*0.0+((vceff*vceff)/vlim_t)*0.0)/vlim_t/vlim_t+2*((vceff*vceff)/vlim_t)*0.0*vlim_t_Vtnode_GND/vlim_t/vlim_t/vlim_t))))/d00_sqrt1/d00_sqrt1+2*((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)*((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)/vlim_t)*d10_sqrt1*(((((((vceff_Vtnode_GND*vceff)+(vceff*vceff_Vtnode_GND)))*vlim_t-(vceff*vceff)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*vlim_t-((vceff*vceff)/vlim_t)*vlim_t_Vtnode_GND)/vlim_t/vlim_t)*d10_sqrt1/d00_sqrt1/d00_sqrt1/d00_sqrt1);
  ick_Vci_ei_Vci_ei=(((+vceff_Vci_ei_Vci_ei*(1+(0.5*(x+d00_sqrt0)))+vceff_Vci_ei*((0.5*(x_Vci_ei+(((x_Vci_ei*x)+(x*x_Vci_ei)))*d10_sqrt0)))+vceff_Vci_ei*(0.5*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0))+vceff*(+0.0+(+0.0*(x+d00_sqrt0)+0.0*(x_Vci_ei+(((x_Vci_ei*x)+(x*x_Vci_ei)))*d10_sqrt0)+0.0*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0)+0.5*(+x_Vci_ei_Vci_ei+(m20_sqrt(((x*x)+1e-3))*(((x_Vci_ei*x)+(x*x_Vci_ei)))*((x_Vci_ei*x)+(x*x_Vci_ei))+d10_sqrt0*(+(+x_Vci_ei_Vci_ei*x+x_Vci_ei*x_Vci_ei+x_Vci_ei*x_Vci_ei+x*x_Vci_ei_Vci_ei)+0.0))))))/rci0_t-(((vceff_Vci_ei*(1+(0.5*(x+d00_sqrt0))))+(vceff*(0.5*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0))))*0.0+(((vceff_Vci_ei*(1+(0.5*(x+d00_sqrt0))))+(vceff*((0.5*(x_Vci_ei+(((x_Vci_ei*x)+(x*x_Vci_ei)))*d10_sqrt0))))))*0.0+(vceff*(1+(0.5*(x+d00_sqrt0))))*0.0)/rci0_t/rci0_t+2*(vceff*(1+(0.5*(x+d00_sqrt0))))*0.0*0.0/rci0_t/rci0_t/rci0_t)/d00_sqrt1-((((vceff_Vci_ei*(1+(0.5*(x+d00_sqrt0))))+(vceff*(0.5*(x_Vci_ei+((x_Vci_ei*x)+(x*x_Vci_ei))*d10_sqrt0))))/rci0_t)*(((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei)))/vlim_t)/vlim_t)*d10_sqrt1+((((vceff_Vci_ei*(1+(0.5*(x+d00_sqrt0))))+(vceff*((0.5*(x_Vci_ei+(((x_Vci_ei*x)+(x*x_Vci_ei)))*d10_sqrt0))))))/rci0_t)*((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)/vlim_t)*d10_sqrt1+((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)*(m20_sqrt((1+(((vceff*vceff)/vlim_t)/vlim_t)))*(((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei)))/vlim_t)/vlim_t)*((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)/vlim_t)+d10_sqrt1*(+0.0+(((+vceff_Vci_ei_Vci_ei*vceff+vceff_Vci_ei*vceff_Vci_ei+vceff_Vci_ei*vceff_Vci_ei+vceff*vceff_Vci_ei_Vci_ei)/vlim_t-(((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))*0.0+(((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei)))*0.0+(vceff*vceff)*0.0)/vlim_t/vlim_t+2*(vceff*vceff)*0.0*0.0/vlim_t/vlim_t/vlim_t)/vlim_t-((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)*0.0+((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei)))/vlim_t)*0.0+((vceff*vceff)/vlim_t)*0.0)/vlim_t/vlim_t+2*((vceff*vceff)/vlim_t)*0.0*0.0/vlim_t/vlim_t/vlim_t))))/d00_sqrt1/d00_sqrt1+2*((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)*((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei))/vlim_t)/vlim_t)*d10_sqrt1*(((((vceff_Vci_ei*vceff)+(vceff*vceff_Vci_ei)))/vlim_t)/vlim_t)*d10_sqrt1/d00_sqrt1/d00_sqrt1/d00_sqrt1);
#endif
#endif
ick=(((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)/d00_sqrt1);
EXIT_IF_ISNAN((((vceff*(1+(0.5*(x+d00_sqrt0))))/rci0_t)/d00_sqrt1))
}
if
(((cjcii>0.0)&&(cjci0_t_ii>0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
cc_Vtnode_GND=((cjci0_t_ii_Vtnode_GND*cjcii-cjci0_t_ii*cjcii_Vtnode_GND)/cjcii/cjcii);
#endif
cc_Vb_ci=(-cjci0_t_ii*cjcii_Vb_ci/cjcii/cjcii);
#if defined(_DERIVATE2)
  cc_Vb_ci_Vtnode_GND=(0.0/cjcii-(0.0*cjcii_Vtnode_GND+cjci0_t_ii_Vtnode_GND*cjcii_Vb_ci+cjci0_t_ii*cjcii_Vb_ci_Vtnode_GND)/cjcii/cjcii+2*cjci0_t_ii*cjcii_Vb_ci*cjcii_Vtnode_GND/cjcii/cjcii/cjcii);
  cc_Vb_ci_Vb_ci=(0.0/cjcii-(0.0*cjcii_Vb_ci+0.0*cjcii_Vb_ci+cjci0_t_ii*cjcii_Vb_ci_Vb_ci)/cjcii/cjcii+2*cjci0_t_ii*cjcii_Vb_ci*cjcii_Vb_ci/cjcii/cjcii/cjcii);
  cc_Vb_ci_Vbi_ci=(0.0/cjcii-(0.0*cjcii_Vbi_ci+0.0*cjcii_Vb_ci+cjci0_t_ii*cjcii_Vb_ci_Vbi_ci)/cjcii/cjcii+2*cjci0_t_ii*cjcii_Vb_ci*cjcii_Vbi_ci/cjcii/cjcii/cjcii);
#endif
cc_Vbi_ci=(-cjci0_t_ii*cjcii_Vbi_ci/cjcii/cjcii);
#if defined(_DERIVATE2)
  cc_Vbi_ci_Vtnode_GND=(0.0/cjcii-(0.0*cjcii_Vtnode_GND+cjci0_t_ii_Vtnode_GND*cjcii_Vbi_ci+cjci0_t_ii*cjcii_Vbi_ci_Vtnode_GND)/cjcii/cjcii+2*cjci0_t_ii*cjcii_Vbi_ci*cjcii_Vtnode_GND/cjcii/cjcii/cjcii);
  cc_Vbi_ci_Vb_ci=(0.0/cjcii-(0.0*cjcii_Vb_ci+0.0*cjcii_Vbi_ci+cjci0_t_ii*cjcii_Vbi_ci_Vb_ci)/cjcii/cjcii+2*cjci0_t_ii*cjcii_Vbi_ci*cjcii_Vb_ci/cjcii/cjcii/cjcii);
  cc_Vbi_ci_Vbi_ci=(0.0/cjcii-(0.0*cjcii_Vbi_ci+0.0*cjcii_Vbi_ci+cjci0_t_ii*cjcii_Vbi_ci_Vbi_ci)/cjcii/cjcii+2*cjci0_t_ii*cjcii_Vbi_ci*cjcii_Vbi_ci/cjcii/cjcii/cjcii);
#endif
#endif
cc=(cjci0_t_ii/cjcii);
EXIT_IF_ISNAN((cjci0_t_ii/cjcii))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
qjci_Vb_ci=(qjci_Vb_ci/cjci0_t_ii);
#if defined(_DERIVATE2)
  qjci_Vb_ci_Vb_ci=(qjci_Vb_ci_Vb_ci/cjci0_t_ii-(qjci_Vb_ci*0.0+qjci_Vb_ci*0.0+pInst->qjci*0.0)/cjci0_t_ii/cjci0_t_ii+2*pInst->qjci*0.0*0.0/cjci0_t_ii/cjci0_t_ii/cjci0_t_ii);
  qjci_Vb_ci_Vtnode_GND=(qjci_Vb_ci_Vtnode_GND/cjci0_t_ii-(qjci_Vb_ci*cjci0_t_ii_Vtnode_GND+qjci_Vtnode_GND*0.0+pInst->qjci*0.0)/cjci0_t_ii/cjci0_t_ii+2*pInst->qjci*0.0*cjci0_t_ii_Vtnode_GND/cjci0_t_ii/cjci0_t_ii/cjci0_t_ii);
  qjci_Vb_ci_Vbi_ci=(qjci_Vb_ci_Vbi_ci/cjci0_t_ii-(qjci_Vb_ci*0.0+qjci_Vbi_ci*0.0+pInst->qjci*0.0)/cjci0_t_ii/cjci0_t_ii+2*pInst->qjci*0.0*0.0/cjci0_t_ii/cjci0_t_ii/cjci0_t_ii);
#endif
#if defined(_DERIVATE)
qjci_Vtnode_GND=((qjci_Vtnode_GND*cjci0_t_ii-pInst->qjci*cjci0_t_ii_Vtnode_GND)/cjci0_t_ii/cjci0_t_ii);
#endif
qjci_Vbi_ci=(qjci_Vbi_ci/cjci0_t_ii);
#if defined(_DERIVATE2)
  qjci_Vbi_ci_Vb_ci=(qjci_Vbi_ci_Vb_ci/cjci0_t_ii-(qjci_Vbi_ci*0.0+qjci_Vb_ci*0.0+pInst->qjci*0.0)/cjci0_t_ii/cjci0_t_ii+2*pInst->qjci*0.0*0.0/cjci0_t_ii/cjci0_t_ii/cjci0_t_ii);
  qjci_Vbi_ci_Vtnode_GND=(qjci_Vbi_ci_Vtnode_GND/cjci0_t_ii-(qjci_Vbi_ci*cjci0_t_ii_Vtnode_GND+qjci_Vtnode_GND*0.0+pInst->qjci*0.0)/cjci0_t_ii/cjci0_t_ii+2*pInst->qjci*0.0*cjci0_t_ii_Vtnode_GND/cjci0_t_ii/cjci0_t_ii/cjci0_t_ii);
  qjci_Vbi_ci_Vbi_ci=(qjci_Vbi_ci_Vbi_ci/cjci0_t_ii-(qjci_Vbi_ci*0.0+qjci_Vbi_ci*0.0+pInst->qjci*0.0)/cjci0_t_ii/cjci0_t_ii+2*pInst->qjci*0.0*0.0/cjci0_t_ii/cjci0_t_ii/cjci0_t_ii);
#endif
#endif
pInst->qjci=(pInst->qjci/cjci0_t_ii);
EXIT_IF_ISNAN((pInst->qjci/cjci0_t_ii))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
cc_Vtnode_GND=0.0;
#endif
cc_Vb_ci=0.0;
#if defined(_DERIVATE2)
  cc_Vb_ci_Vtnode_GND=0.0;
  cc_Vb_ci_Vb_ci=0.0;
  cc_Vb_ci_Vbi_ci=0.0;
#endif
cc_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  cc_Vbi_ci_Vtnode_GND=0.0;
  cc_Vbi_ci_Vb_ci=0.0;
  cc_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
cc=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
qjci_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qjci_Vb_ci_Vb_ci=0.0;
  qjci_Vb_ci_Vtnode_GND=0.0;
  qjci_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qjci_Vtnode_GND=0.0;
#endif
qjci_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjci_Vbi_ci_Vb_ci=0.0;
  qjci_Vbi_ci_Vtnode_GND=0.0;
  qjci_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
pInst->qjci=0;
EXIT_IF_ISNAN(0)
}
if
((cje0_dc_t>0.0))
{
{
double m00_logE(d00_logE0,ajedc_t)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zedc))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,ajedc_t)
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=((vdedc_t_Vtnode_GND*(1.0-d00_exp1))+(vdedc_t*(-((-ajedc_t_Vtnode_GND*d10_logE0)/pModel->zedc)*d10_exp1)));
#endif
vf=(vdedc_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vdedc_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=0.0;
  xvf_Vs_ci_Vbi_ei=0.0;
  xvf_Vs_ci_Vb_ci=0.0;
  xvf_Vs_ci_Vtnode_GND=0.0;
  xvf_Vs_ci_Vbi_ci=0.0;
#endif
xvf_Vbi_ei=((-Vbiei_Vbi_ei)/VT);
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*0.0+0.0*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ei_Vbi_ei=((+0.0-Vbiei_Vbi_ei_Vbi_ei)/VT-((-Vbiei_Vbi_ei)*0.0+(-Vbiei_Vbi_ei)*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ei_Vb_ci=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*0.0+0.0*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ei_Vtnode_GND=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vbi_ei_Vbi_ci=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*0.0+0.0*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
#endif
xvf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=0.0;
  xvf_Vb_ci_Vbi_ei=0.0;
  xvf_Vb_ci_Vb_ci=0.0;
  xvf_Vb_ci_Vtnode_GND=0.0;
  xvf_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vbiei)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=0.0;
  xvf_Vbi_ci_Vbi_ei=0.0;
  xvf_Vbi_ci_Vb_ci=0.0;
  xvf_Vbi_ci_Vtnode_GND=0.0;
  xvf_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
xvf=((vf-Vbiei)/VT);
EXIT_IF_ISNAN(((vf-Vbiei)/VT))
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=0.0;
  xvf2_Vs_ci_Vbi_ei=0.0;
  xvf2_Vs_ci_Vb_ci=0.0;
  xvf2_Vs_ci_Vtnode_GND=0.0;
  xvf2_Vs_ci_Vbi_ci=0.0;
#endif
xvf2_Vbi_ei=((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vs_ci*xvf+xvf_Vbi_ei*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vs_ci)+0.0));
  xvf2_Vbi_ei_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vbi_ei*xvf+xvf_Vbi_ei*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vbi_ei)+0.0));
  xvf2_Vbi_ei_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vb_ci*xvf+xvf_Vbi_ei*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vb_ci)+0.0));
  xvf2_Vbi_ei_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vtnode_GND*xvf+xvf_Vbi_ei*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vtnode_GND)+0.0));
  xvf2_Vbi_ei_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vbi_ci*xvf+xvf_Vbi_ei*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vbi_ci)+0.0));
#endif
xvf2_Vb_ci=((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vs_ci*xvf+xvf_Vb_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vs_ci)+0.0));
  xvf2_Vb_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ei*xvf+xvf_Vb_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ei)+0.0));
  xvf2_Vb_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vb_ci*xvf+xvf_Vb_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vb_ci)+0.0));
  xvf2_Vb_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vtnode_GND*xvf+xvf_Vb_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vb_ci+xvf*xvf_Vb_ci_Vtnode_GND)+0.0));
  xvf2_Vb_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ci*xvf+xvf_Vb_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ci)+0.0));
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=0.0;
  v_j_Vs_ci_Vbi_ei=0.0;
  v_j_Vs_ci_Vb_ci=0.0;
  v_j_Vs_ci_Vtnode_GND=0.0;
  v_j_Vs_ci_Vbi_ci=0.0;
#endif
v_j_Vbi_ei=(-(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vs_ci+xvf2_Vbi_ei_Vs_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vbi_ei+xvf2_Vbi_ei_Vbi_ei))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vb_ci+xvf2_Vbi_ei_Vb_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vtnode_GND+xvf2_Vbi_ei_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vbi_ci+xvf2_Vbi_ei_Vbi_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
v_j_Vb_ci=(-(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vs_ci+xvf2_Vb_ci_Vs_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ei+xvf2_Vb_ci_Vbi_ei))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=0.0;
#endif
x_Vci_ei=0.0;
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=0.0;
  x_Vci_ei_Vci_ei=0.0;
#endif
#endif
x=(1.0-pModel->zedc);
EXIT_IF_ISNAN((1.0-pModel->zedc))
{
double m00_logE(d00_logE0,(1.0-(v_j/vdedc_t)))
double m00_exp(d00_exp1,(x*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(v_j/vdedc_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
y_Vs_ci=0.0;
#if defined(_DERIVATE2)
  y_Vs_ci_Vs_ci=0.0;
  y_Vs_ci_Vci_ei=0.0;
  y_Vs_ci_Vbi_ei=0.0;
  y_Vs_ci_Vb_ci=0.0;
  y_Vs_ci_Vtnode_GND=0.0;
  y_Vs_ci_Vbi_ci=0.0;
#endif
y_Vci_ei=(-x_Vci_ei*d00_logE0*d10_exp1);
#if defined(_DERIVATE2)
  y_Vci_ei_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdedc_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vs_ci/vdedc_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*x_Vci_ei*d00_logE0+d10_exp1*(+x_Vci_ei_Vci_ei*d00_logE0+x_Vci_ei*0.0+x_Vci_ei*0.0+x*0.0)));
  y_Vci_ei_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0)))*x_Vci_ei*d00_logE0+d10_exp1*(+x_Vci_ei_Vtnode_GND*d00_logE0+x_Vci_ei*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0+x_Vtnode_GND*0.0+x*0.0)));
  y_Vci_ei_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+0.0*0.0+x*0.0)));
#endif
y_Vbi_ei=(-(x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ei_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vs_ci/vdedc_t))*(-(v_j_Vbi_ei/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vs_ci/vdedc_t-(v_j_Vbi_ei*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ei_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+x*0.0)));
  y_Vbi_ei_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vbi_ei/vdedc_t))*(-(v_j_Vbi_ei/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vbi_ei/vdedc_t-(v_j_Vbi_ei*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ei_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vb_ci/vdedc_t))*(-(v_j_Vbi_ei/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vb_ci/vdedc_t-(v_j_Vbi_ei*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ei_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0)))*(x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*(-(v_j_Vbi_ei/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vtnode_GND/vdedc_t-(v_j_Vbi_ei*vdedc_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*vdedc_t_Vtnode_GND/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ei_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vbi_ci/vdedc_t))*(-(v_j_Vbi_ei/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vbi_ci/vdedc_t-(v_j_Vbi_ei*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
#endif
y_Vb_ci=(-(x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vb_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vs_ci/vdedc_t))*(-(v_j_Vb_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vs_ci/vdedc_t-(v_j_Vb_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vb_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+x*0.0)));
  y_Vb_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vbi_ei/vdedc_t))*(-(v_j_Vb_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ei/vdedc_t-(v_j_Vb_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vb_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vb_ci/vdedc_t))*(-(v_j_Vb_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vb_ci/vdedc_t-(v_j_Vb_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vb_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0)))*(x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*(-(v_j_Vb_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vtnode_GND/vdedc_t-(v_j_Vb_ci*vdedc_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*vdedc_t_Vtnode_GND/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vb_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vbi_ci/vdedc_t))*(-(v_j_Vb_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ci/vdedc_t-(v_j_Vb_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
#endif
#if defined(_DERIVATE)
y_Vtnode_GND=(-((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0))*d10_exp1);
#endif
y_Vbi_ci=(-(x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vs_ci/vdedc_t))*(-(v_j_Vbi_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vs_ci/vdedc_t-(v_j_Vbi_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+x*0.0)));
  y_Vbi_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vbi_ei/vdedc_t))*(-(v_j_Vbi_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ei/vdedc_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vb_ci/vdedc_t))*(-(v_j_Vbi_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vdedc_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0)))*(x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-((v_j_Vtnode_GND*vdedc_t-v_j*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*(-(v_j_Vbi_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vdedc_t-(v_j_Vbi_ci*vdedc_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*vdedc_t_Vtnode_GND/vdedc_t/vdedc_t/vdedc_t))))));
  y_Vbi_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vdedc_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vdedc_t)))*(-(v_j_Vbi_ci/vdedc_t))*(-(v_j_Vbi_ci/vdedc_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vdedc_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vdedc_t/vdedc_t+2*v_j*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))));
#endif
#endif
y=(1.0-d00_exp1);
EXIT_IF_ISNAN((1.0-d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
qjei_Vtnode_GND=(((((((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND))*y)+((cje0_dc_t*vdedc_t)*y_Vtnode_GND))*x-((cje0_dc_t*vdedc_t)*y)*x_Vtnode_GND)/x/x)+((((ajedc_t_Vtnode_GND*cje0_dc_t)+(ajedc_t*cje0_dc_t_Vtnode_GND))*(Vbiei-v_j))+((ajedc_t*cje0_dc_t)*(-v_j_Vtnode_GND))));
#endif
qjei_Vci_ei=((((cje0_dc_t*vdedc_t)*y_Vci_ei)*x-((cje0_dc_t*vdedc_t)*y)*x_Vci_ei)/x/x);
#if defined(_DERIVATE2)
  qjei_Vci_ei_Vtnode_GND=(+((+(+0.0*vdedc_t+0.0*vdedc_t_Vtnode_GND+cje0_dc_t_Vtnode_GND*0.0+cje0_dc_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y_Vci_ei+(cje0_dc_t*vdedc_t)*y_Vci_ei_Vtnode_GND)/x-(((cje0_dc_t*vdedc_t)*y_Vci_ei)*x_Vtnode_GND+((((((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y)+((cje0_dc_t*vdedc_t)*y_Vtnode_GND)))*x_Vci_ei+((cje0_dc_t*vdedc_t)*y)*x_Vci_ei_Vtnode_GND)/x/x+2*((cje0_dc_t*vdedc_t)*y)*x_Vci_ei*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_dc_t+0.0*cje0_dc_t_Vtnode_GND+ajedc_t_Vtnode_GND*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((ajedc_t_Vtnode_GND*cje0_dc_t)+(ajedc_t*cje0_dc_t_Vtnode_GND)))*0.0+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vci_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vci_ei+(cje0_dc_t*vdedc_t)*y_Vci_ei_Vci_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vci_ei)*x_Vci_ei+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vci_ei)))*x_Vci_ei+((cje0_dc_t*vdedc_t)*y)*x_Vci_ei_Vci_ei)/x/x+2*((cje0_dc_t*vdedc_t)*y)*x_Vci_ei*x_Vci_ei/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*0.0+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vbi_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vci_ei+(cje0_dc_t*vdedc_t)*y_Vci_ei_Vbi_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vci_ei)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ei)))*x_Vci_ei+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*x_Vci_ei*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*0.0+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vb_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vci_ei+(cje0_dc_t*vdedc_t)*y_Vci_ei_Vb_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vci_ei)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vb_ci)))*x_Vci_ei+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*x_Vci_ei*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*0.0+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vbi_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vci_ei+(cje0_dc_t*vdedc_t)*y_Vci_ei_Vbi_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vci_ei)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ci)))*x_Vci_ei+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*x_Vci_ei*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*0.0+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
#endif
qjei_Vbi_ei=((((cje0_dc_t*vdedc_t)*y_Vbi_ei)/x)+((ajedc_t*cje0_dc_t)*(Vbiei_Vbi_ei-v_j_Vbi_ei)));
#if defined(_DERIVATE2)
  qjei_Vbi_ei_Vtnode_GND=(+((+(+0.0*vdedc_t+0.0*vdedc_t_Vtnode_GND+cje0_dc_t_Vtnode_GND*0.0+cje0_dc_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y_Vbi_ei+(cje0_dc_t*vdedc_t)*y_Vbi_ei_Vtnode_GND)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ei)*x_Vtnode_GND+((((((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y)+((cje0_dc_t*vdedc_t)*y_Vtnode_GND)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_dc_t+0.0*cje0_dc_t_Vtnode_GND+ajedc_t_Vtnode_GND*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((ajedc_t_Vtnode_GND*cje0_dc_t)+(ajedc_t*cje0_dc_t_Vtnode_GND)))*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vbi_ei_Vtnode_GND)));
  qjei_Vbi_ei_Vci_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vbi_ei+(cje0_dc_t*vdedc_t)*y_Vbi_ei_Vci_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ei)*x_Vci_ei+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vci_ei)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*x_Vci_ei/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
  qjei_Vbi_ei_Vbi_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vbi_ei+(cje0_dc_t*vdedc_t)*y_Vbi_ei_Vbi_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ei)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ei)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(ajedc_t*cje0_dc_t)*(+Vbiei_Vbi_ei_Vbi_ei-v_j_Vbi_ei_Vbi_ei)));
  qjei_Vbi_ei_Vb_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vbi_ei+(cje0_dc_t*vdedc_t)*y_Vbi_ei_Vb_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ei)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vb_ci)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vbi_ei_Vb_ci)));
  qjei_Vbi_ei_Vbi_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vbi_ei+(cje0_dc_t*vdedc_t)*y_Vbi_ei_Vbi_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ei)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ci)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vbi_ei_Vbi_ci)));
#endif
qjei_Vb_ci=((((cje0_dc_t*vdedc_t)*y_Vb_ci)/x)+((ajedc_t*cje0_dc_t)*(-v_j_Vb_ci)));
#if defined(_DERIVATE2)
  qjei_Vb_ci_Vtnode_GND=(+((+(+0.0*vdedc_t+0.0*vdedc_t_Vtnode_GND+cje0_dc_t_Vtnode_GND*0.0+cje0_dc_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y_Vb_ci+(cje0_dc_t*vdedc_t)*y_Vb_ci_Vtnode_GND)/x-(((cje0_dc_t*vdedc_t)*y_Vb_ci)*x_Vtnode_GND+((((((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y)+((cje0_dc_t*vdedc_t)*y_Vtnode_GND)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_dc_t+0.0*cje0_dc_t_Vtnode_GND+ajedc_t_Vtnode_GND*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((ajedc_t_Vtnode_GND*cje0_dc_t)+(ajedc_t*cje0_dc_t_Vtnode_GND)))*(-v_j_Vb_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vb_ci_Vtnode_GND)));
  qjei_Vb_ci_Vci_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vb_ci+(cje0_dc_t*vdedc_t)*y_Vb_ci_Vci_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vb_ci)*x_Vci_ei+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vci_ei)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*x_Vci_ei/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*(-v_j_Vb_ci)+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
  qjei_Vb_ci_Vbi_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vb_ci+(cje0_dc_t*vdedc_t)*y_Vb_ci_Vbi_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ei)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*(-v_j_Vb_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vb_ci_Vbi_ei)));
  qjei_Vb_ci_Vb_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vb_ci+(cje0_dc_t*vdedc_t)*y_Vb_ci_Vb_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vb_ci)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(-v_j_Vb_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vb_ci_Vb_ci)));
  qjei_Vb_ci_Vbi_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vb_ci+(cje0_dc_t*vdedc_t)*y_Vb_ci_Vbi_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ci)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*(-v_j_Vb_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vb_ci_Vbi_ci)));
#endif
qjei_Vbi_ci=((((cje0_dc_t*vdedc_t)*y_Vbi_ci)/x)+((ajedc_t*cje0_dc_t)*(-v_j_Vbi_ci)));
#if defined(_DERIVATE2)
  qjei_Vbi_ci_Vtnode_GND=(+((+(+0.0*vdedc_t+0.0*vdedc_t_Vtnode_GND+cje0_dc_t_Vtnode_GND*0.0+cje0_dc_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y_Vbi_ci+(cje0_dc_t*vdedc_t)*y_Vbi_ci_Vtnode_GND)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ci)*x_Vtnode_GND+((((((cje0_dc_t_Vtnode_GND*vdedc_t)+(cje0_dc_t*vdedc_t_Vtnode_GND)))*y)+((cje0_dc_t*vdedc_t)*y_Vtnode_GND)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_dc_t+0.0*cje0_dc_t_Vtnode_GND+ajedc_t_Vtnode_GND*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((ajedc_t_Vtnode_GND*cje0_dc_t)+(ajedc_t*cje0_dc_t_Vtnode_GND)))*(-v_j_Vbi_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vbi_ci_Vtnode_GND)));
  qjei_Vbi_ci_Vci_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vbi_ci+(cje0_dc_t*vdedc_t)*y_Vbi_ci_Vci_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ci)*x_Vci_ei+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vci_ei)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*x_Vci_ei/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*(-v_j_Vbi_ci)+(ajedc_t*cje0_dc_t)*(+0.0-0.0)));
  qjei_Vbi_ci_Vbi_ei=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vbi_ci+(cje0_dc_t*vdedc_t)*y_Vbi_ci_Vbi_ei)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ei)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*(-v_j_Vbi_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vbi_ci_Vbi_ei)));
  qjei_Vbi_ci_Vb_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vbi_ci+(cje0_dc_t*vdedc_t)*y_Vbi_ci_Vb_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vb_ci)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(-v_j_Vbi_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vbi_ci_Vb_ci)));
  qjei_Vbi_ci_Vbi_ci=(+((+(+0.0*vdedc_t+0.0*0.0+0.0*0.0+cje0_dc_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vbi_ci+(cje0_dc_t*vdedc_t)*y_Vbi_ci_Vbi_ci)/x-(((cje0_dc_t*vdedc_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cje0_dc_t*vdedc_t)*y_Vbi_ci)))*0.0+((cje0_dc_t*vdedc_t)*y)*0.0)/x/x+2*((cje0_dc_t*vdedc_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_dc_t+0.0*0.0+0.0*0.0+ajedc_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*(-v_j_Vbi_ci)+(ajedc_t*cje0_dc_t)*(+0.0-v_j_Vbi_ci_Vbi_ci)));
#endif
#endif
pInst->qjei=((((cje0_dc_t*vdedc_t)*y)/x)+((ajedc_t*cje0_dc_t)*(Vbiei-v_j)));
EXIT_IF_ISNAN(((((cje0_dc_t*vdedc_t)*y)/x)+((ajedc_t*cje0_dc_t)*(Vbiei-v_j))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
qjei_Vtnode_GND=0.0;
#endif
qjei_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qjei_Vci_ei_Vtnode_GND=0.0;
  qjei_Vci_ei_Vci_ei=0.0;
  qjei_Vci_ei_Vbi_ei=0.0;
  qjei_Vci_ei_Vb_ci=0.0;
  qjei_Vci_ei_Vbi_ci=0.0;
#endif
qjei_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qjei_Vbi_ei_Vtnode_GND=0.0;
  qjei_Vbi_ei_Vci_ei=0.0;
  qjei_Vbi_ei_Vbi_ei=0.0;
  qjei_Vbi_ei_Vb_ci=0.0;
  qjei_Vbi_ei_Vbi_ci=0.0;
#endif
qjei_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qjei_Vb_ci_Vtnode_GND=0.0;
  qjei_Vb_ci_Vci_ei=0.0;
  qjei_Vb_ci_Vbi_ei=0.0;
  qjei_Vb_ci_Vb_ci=0.0;
  qjei_Vb_ci_Vbi_ci=0.0;
#endif
qjei_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjei_Vbi_ci_Vtnode_GND=0.0;
  qjei_Vbi_ci_Vci_ei=0.0;
  qjei_Vbi_ci_Vbi_ei=0.0;
  qjei_Vbi_ci_Vb_ci=0.0;
  qjei_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
pInst->qjei=0.00;
EXIT_IF_ISNAN(0.00)
}
if
((pModel->aver==0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
h_vbe_Vtnode_GND=0.0;
#endif
h_vbe_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  h_vbe_Vbi_ei_Vtnode_GND=0.0;
  h_vbe_Vbi_ei_Vbi_ei=0.0;
#endif
#endif
h_vbe=1;
EXIT_IF_ISNAN(1)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
vjh_Vtnode_GND=((vdedc_t_Vtnode_GND*(2.0*VT)-(vdedc_t-Vbiei)*(2.0*VT_Vtnode_GND))/(2.0*VT)/(2.0*VT));
#endif
vjh_Vbi_ei=((-Vbiei_Vbi_ei)/(2.0*VT));
#if defined(_DERIVATE2)
  vjh_Vbi_ei_Vtnode_GND=((+0.0-0.0)/(2.0*VT)-((-Vbiei_Vbi_ei)*((2.0*VT_Vtnode_GND))+vdedc_t_Vtnode_GND*0.0+(vdedc_t-Vbiei)*(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+2.0*0.0))/(2.0*VT)/(2.0*VT)+2*(vdedc_t-Vbiei)*0.0*((2.0*VT_Vtnode_GND))/(2.0*VT)/(2.0*VT)/(2.0*VT));
  vjh_Vbi_ei_Vbi_ei=((+0.0-Vbiei_Vbi_ei_Vbi_ei)/(2.0*VT)-((-Vbiei_Vbi_ei)*(0.0)+(-Vbiei_Vbi_ei)*0.0+(vdedc_t-Vbiei)*(+0.0*VT+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*VT)/(2.0*VT)+2*(vdedc_t-Vbiei)*0.0*(0.0)/(2.0*VT)/(2.0*VT)/(2.0*VT));
#endif
#endif
vjh=((vdedc_t-Vbiei)/(2.0*VT));
EXIT_IF_ISNAN(((vdedc_t-Vbiei)/(2.0*VT)))
{
double m00_sqrt(d00_sqrt0,((vjh*vjh)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((vjh*vjh)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
vjh_Vtnode_GND=(vdedc_t_Vtnode_GND-(((2.0*VT_Vtnode_GND)*(vjh+d00_sqrt0))+((2.0*VT)*(vjh_Vtnode_GND+((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND))*d10_sqrt0)))*0.5);
#endif
vjh_Vbi_ei=(-((2.0*VT)*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0))*0.5);
#if defined(_DERIVATE2)
  vjh_Vbi_ei_Vtnode_GND=(+0.0-(+(+(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+2.0*0.0)*(vjh+d00_sqrt0)+0.0*(vjh_Vtnode_GND+(((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND)))*d10_sqrt0)+((2.0*VT_Vtnode_GND))*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0)+(2.0*VT)*(+vjh_Vbi_ei_Vtnode_GND+(m20_sqrt(((vjh*vjh)+1.921812))*(((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND)))*((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))+d10_sqrt0*(+(+vjh_Vbi_ei_Vtnode_GND*vjh+vjh_Vbi_ei*vjh_Vtnode_GND+vjh_Vtnode_GND*vjh_Vbi_ei+vjh*vjh_Vbi_ei_Vtnode_GND)+0.0))))*0.5+((2.0*VT)*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0))*0.0+(((((2.0*VT_Vtnode_GND))*(vjh+d00_sqrt0))+((2.0*VT)*(vjh_Vtnode_GND+(((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND)))*d10_sqrt0))))*0.0+((2.0*VT)*(vjh+d00_sqrt0))*0.0));
  vjh_Vbi_ei_Vbi_ei=(+0.0-(+(+(+0.0*VT+0.0*0.0+0.0*0.0+2.0*0.0)*(vjh+d00_sqrt0)+0.0*(vjh_Vbi_ei+(((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei)))*d10_sqrt0)+(0.0)*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0)+(2.0*VT)*(+vjh_Vbi_ei_Vbi_ei+(m20_sqrt(((vjh*vjh)+1.921812))*(((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei)))*((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))+d10_sqrt0*(+(+vjh_Vbi_ei_Vbi_ei*vjh+vjh_Vbi_ei*vjh_Vbi_ei+vjh_Vbi_ei*vjh_Vbi_ei+vjh*vjh_Vbi_ei_Vbi_ei)+0.0))))*0.5+((2.0*VT)*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0))*0.0+((((0.0)*(vjh+d00_sqrt0))+((2.0*VT)*(vjh_Vbi_ei+(((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei)))*d10_sqrt0))))*0.0+((2.0*VT)*(vjh+d00_sqrt0))*0.0));
#endif
#endif
vjh=(vdedc_t-(((2.0*VT)*(vjh+d00_sqrt0))*0.5));
EXIT_IF_ISNAN((vdedc_t-(((2.0*VT)*(vjh+d00_sqrt0))*0.5)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
vjh_Vtnode_GND=(((vjh_Vtnode_GND-VT_Vtnode_GND)*VT-(vjh-VT)*VT_Vtnode_GND)/VT/VT);
#endif
vjh_Vbi_ei=(vjh_Vbi_ei/VT);
#if defined(_DERIVATE2)
  vjh_Vbi_ei_Vtnode_GND=((+vjh_Vbi_ei_Vtnode_GND-0.0)/VT-(vjh_Vbi_ei*VT_Vtnode_GND+(vjh_Vtnode_GND-VT_Vtnode_GND)*0.0+(vjh-VT)*0.0)/VT/VT+2*(vjh-VT)*0.0*VT_Vtnode_GND/VT/VT/VT);
  vjh_Vbi_ei_Vbi_ei=((+vjh_Vbi_ei_Vbi_ei-0.0)/VT-(vjh_Vbi_ei*0.0+vjh_Vbi_ei*0.0+(vjh-VT)*0.0)/VT/VT+2*(vjh-VT)*0.0*0.0/VT/VT/VT);
#endif
#endif
vjh=((vjh-VT)/VT);
EXIT_IF_ISNAN(((vjh-VT)/VT))
{
double m00_sqrt(d00_sqrt0,((vjh*vjh)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((vjh*vjh)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
vjh_Vtnode_GND=((VT_Vtnode_GND*(1.0+((vjh+d00_sqrt0)*0.5)))+(VT*(vjh_Vtnode_GND+((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND))*d10_sqrt0)*0.5));
#endif
vjh_Vbi_ei=(VT*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0)*0.5);
#if defined(_DERIVATE2)
  vjh_Vbi_ei_Vtnode_GND=(+0.0*(1.0+((vjh+d00_sqrt0)*0.5))+0.0*((vjh_Vtnode_GND+(((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND)))*d10_sqrt0)*0.5)+VT_Vtnode_GND*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0)*0.5+VT*(+0.0+(+(+vjh_Vbi_ei_Vtnode_GND+(m20_sqrt(((vjh*vjh)+1.921812))*(((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND)))*((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))+d10_sqrt0*(+(+vjh_Vbi_ei_Vtnode_GND*vjh+vjh_Vbi_ei*vjh_Vtnode_GND+vjh_Vtnode_GND*vjh_Vbi_ei+vjh*vjh_Vbi_ei_Vtnode_GND)+0.0)))*0.5+(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0)*0.0+(vjh_Vtnode_GND+(((vjh_Vtnode_GND*vjh)+(vjh*vjh_Vtnode_GND)))*d10_sqrt0)*0.0+(vjh+d00_sqrt0)*0.0)));
  vjh_Vbi_ei_Vbi_ei=(+0.0*(1.0+((vjh+d00_sqrt0)*0.5))+0.0*((vjh_Vbi_ei+(((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei)))*d10_sqrt0)*0.5)+0.0*(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0)*0.5+VT*(+0.0+(+(+vjh_Vbi_ei_Vbi_ei+(m20_sqrt(((vjh*vjh)+1.921812))*(((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei)))*((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))+d10_sqrt0*(+(+vjh_Vbi_ei_Vbi_ei*vjh+vjh_Vbi_ei*vjh_Vbi_ei+vjh_Vbi_ei*vjh_Vbi_ei+vjh*vjh_Vbi_ei_Vbi_ei)+0.0)))*0.5+(vjh_Vbi_ei+((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei))*d10_sqrt0)*0.0+(vjh_Vbi_ei+(((vjh_Vbi_ei*vjh)+(vjh*vjh_Vbi_ei)))*d10_sqrt0)*0.0+(vjh+d00_sqrt0)*0.0)));
#endif
#endif
vjh=(VT*(1.0+((vjh+d00_sqrt0)*0.5)));
EXIT_IF_ISNAN((VT*(1.0+((vjh+d00_sqrt0)*0.5))))
}
{
double m00_logE(d00_logE0,(1.0-(vjh/vdedc_t)))
double m00_exp(d00_exp1,(pModel->zedc*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vjh/vdedc_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
vj_z_Vtnode_GND=(((-(pModel->zedc*(-((vjh_Vtnode_GND*vdedc_t-vjh*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0)*d10_exp1)*aver_t)+((1.0-d00_exp1)*aver_t_Vtnode_GND));
#endif
vj_z_Vbi_ei=(-(pModel->zedc*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0)*d10_exp1)*aver_t;
#if defined(_DERIVATE2)
  vj_z_Vbi_ei_Vtnode_GND=(+(+0.0-(m20_exp((pModel->zedc*d00_logE0))*((pModel->zedc*(-((vjh_Vtnode_GND*vdedc_t-vjh*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0))*(pModel->zedc*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((vjh_Vtnode_GND*vdedc_t-vjh*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0+0.0*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0+pModel->zedc*(m20_logE((1.0-(vjh/vdedc_t)))*(-((vjh_Vtnode_GND*vdedc_t-vjh*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*(-(vjh_Vbi_ei/vdedc_t))+d10_logE0*(+0.0-(vjh_Vbi_ei_Vtnode_GND/vdedc_t-(vjh_Vbi_ei*vdedc_t_Vtnode_GND+vjh_Vtnode_GND*0.0+vjh*0.0)/vdedc_t/vdedc_t+2*vjh*0.0*vdedc_t_Vtnode_GND/vdedc_t/vdedc_t/vdedc_t))))))*aver_t+(-(pModel->zedc*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0)*d10_exp1)*aver_t_Vtnode_GND+(-((pModel->zedc*(-((vjh_Vtnode_GND*vdedc_t-vjh*vdedc_t_Vtnode_GND)/vdedc_t/vdedc_t))*d10_logE0))*d10_exp1)*0.0+(1.0-d00_exp1)*0.0);
  vj_z_Vbi_ei_Vbi_ei=(+(+0.0-(m20_exp((pModel->zedc*d00_logE0))*((pModel->zedc*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0))*(pModel->zedc*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0+0.0*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0+pModel->zedc*(m20_logE((1.0-(vjh/vdedc_t)))*(-(vjh_Vbi_ei/vdedc_t))*(-(vjh_Vbi_ei/vdedc_t))+d10_logE0*(+0.0-(vjh_Vbi_ei_Vbi_ei/vdedc_t-(vjh_Vbi_ei*0.0+vjh_Vbi_ei*0.0+vjh*0.0)/vdedc_t/vdedc_t+2*vjh*0.0*0.0/vdedc_t/vdedc_t/vdedc_t))))))*aver_t+(-(pModel->zedc*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0)*d10_exp1)*0.0+(-((pModel->zedc*(-(vjh_Vbi_ei/vdedc_t))*d10_logE0))*d10_exp1)*0.0+(1.0-d00_exp1)*0.0);
#endif
#endif
vj_z=((1.0-d00_exp1)*aver_t);
EXIT_IF_ISNAN(((1.0-d00_exp1)*aver_t))
}
{
double m00_exp(d00_exp0,vj_z)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
h_vbe_Vtnode_GND=((vj_z_Vtnode_GND*d10_exp0*vj_z-(d00_exp0-1.0)*vj_z_Vtnode_GND)/vj_z/vj_z);
#endif
h_vbe_Vbi_ei=((vj_z_Vbi_ei*d10_exp0*vj_z-(d00_exp0-1.0)*vj_z_Vbi_ei)/vj_z/vj_z);
#if defined(_DERIVATE2)
  h_vbe_Vbi_ei_Vtnode_GND=((+(m20_exp(vj_z)*vj_z_Vtnode_GND*vj_z_Vbi_ei+d10_exp0*vj_z_Vbi_ei_Vtnode_GND)-0.0)/vj_z-(vj_z_Vbi_ei*d10_exp0*vj_z_Vtnode_GND+vj_z_Vtnode_GND*d10_exp0*vj_z_Vbi_ei+(d00_exp0-1.0)*vj_z_Vbi_ei_Vtnode_GND)/vj_z/vj_z+2*(d00_exp0-1.0)*vj_z_Vbi_ei*vj_z_Vtnode_GND/vj_z/vj_z/vj_z);
  h_vbe_Vbi_ei_Vbi_ei=((+(m20_exp(vj_z)*vj_z_Vbi_ei*vj_z_Vbi_ei+d10_exp0*vj_z_Vbi_ei_Vbi_ei)-0.0)/vj_z-(vj_z_Vbi_ei*d10_exp0*vj_z_Vbi_ei+vj_z_Vbi_ei*d10_exp0*vj_z_Vbi_ei+(d00_exp0-1.0)*vj_z_Vbi_ei_Vbi_ei)/vj_z/vj_z+2*(d00_exp0-1.0)*vj_z_Vbi_ei*vj_z_Vbi_ei/vj_z/vj_z/vj_z);
#endif
#endif
h_vbe=((d00_exp0-1.0)/vj_z);
EXIT_IF_ISNAN(((d00_exp0-1.0)/vj_z))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qje_Vtnode_GND=((((h_vbe_Vtnode_GND*pInst->qjei)+(h_vbe*qjei_Vtnode_GND))*cje0_dc_t-(h_vbe*pInst->qjei)*cje0_dc_t_Vtnode_GND)/cje0_dc_t/cje0_dc_t);
#endif
qje_Vbi_ei=(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei))/cje0_dc_t);
#if defined(_DERIVATE2)
  qje_Vbi_ei_Vtnode_GND=((+h_vbe_Vbi_ei_Vtnode_GND*pInst->qjei+h_vbe_Vbi_ei*qjei_Vtnode_GND+h_vbe_Vtnode_GND*qjei_Vbi_ei+h_vbe*qjei_Vbi_ei_Vtnode_GND)/cje0_dc_t-(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei))*cje0_dc_t_Vtnode_GND+(((h_vbe_Vtnode_GND*pInst->qjei)+(h_vbe*qjei_Vtnode_GND)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*cje0_dc_t_Vtnode_GND/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ei_Vbi_ei=((+h_vbe_Vbi_ei_Vbi_ei*pInst->qjei+h_vbe_Vbi_ei*qjei_Vbi_ei+h_vbe_Vbi_ei*qjei_Vbi_ei+h_vbe*qjei_Vbi_ei_Vbi_ei)/cje0_dc_t-(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei))*0.0+(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ei_Vci_ei=((+0.0*pInst->qjei+h_vbe_Vbi_ei*qjei_Vci_ei+0.0*qjei_Vbi_ei+h_vbe*qjei_Vbi_ei_Vci_ei)/cje0_dc_t-(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei))*0.0+((h_vbe*qjei_Vci_ei))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ei_Vb_ci=((+0.0*pInst->qjei+h_vbe_Vbi_ei*qjei_Vb_ci+0.0*qjei_Vbi_ei+h_vbe*qjei_Vbi_ei_Vb_ci)/cje0_dc_t-(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei))*0.0+((h_vbe*qjei_Vb_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ei_Vbi_ci=((+0.0*pInst->qjei+h_vbe_Vbi_ei*qjei_Vbi_ci+0.0*qjei_Vbi_ei+h_vbe*qjei_Vbi_ei_Vbi_ci)/cje0_dc_t-(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei))*0.0+((h_vbe*qjei_Vbi_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
#endif
qje_Vci_ei=((h_vbe*qjei_Vci_ei)/cje0_dc_t);
#if defined(_DERIVATE2)
  qje_Vci_ei_Vtnode_GND=((+0.0*pInst->qjei+0.0*qjei_Vtnode_GND+h_vbe_Vtnode_GND*qjei_Vci_ei+h_vbe*qjei_Vci_ei_Vtnode_GND)/cje0_dc_t-((h_vbe*qjei_Vci_ei)*cje0_dc_t_Vtnode_GND+(((h_vbe_Vtnode_GND*pInst->qjei)+(h_vbe*qjei_Vtnode_GND)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*cje0_dc_t_Vtnode_GND/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vci_ei_Vbi_ei=((+0.0*pInst->qjei+0.0*qjei_Vbi_ei+h_vbe_Vbi_ei*qjei_Vci_ei+h_vbe*qjei_Vci_ei_Vbi_ei)/cje0_dc_t-((h_vbe*qjei_Vci_ei)*0.0+(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vci_ei_Vci_ei=((+0.0*pInst->qjei+0.0*qjei_Vci_ei+0.0*qjei_Vci_ei+h_vbe*qjei_Vci_ei_Vci_ei)/cje0_dc_t-((h_vbe*qjei_Vci_ei)*0.0+((h_vbe*qjei_Vci_ei))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vci_ei_Vb_ci=((+0.0*pInst->qjei+0.0*qjei_Vb_ci+0.0*qjei_Vci_ei+h_vbe*qjei_Vci_ei_Vb_ci)/cje0_dc_t-((h_vbe*qjei_Vci_ei)*0.0+((h_vbe*qjei_Vb_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vci_ei_Vbi_ci=((+0.0*pInst->qjei+0.0*qjei_Vbi_ci+0.0*qjei_Vci_ei+h_vbe*qjei_Vci_ei_Vbi_ci)/cje0_dc_t-((h_vbe*qjei_Vci_ei)*0.0+((h_vbe*qjei_Vbi_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
#endif
qje_Vb_ci=((h_vbe*qjei_Vb_ci)/cje0_dc_t);
#if defined(_DERIVATE2)
  qje_Vb_ci_Vtnode_GND=((+0.0*pInst->qjei+0.0*qjei_Vtnode_GND+h_vbe_Vtnode_GND*qjei_Vb_ci+h_vbe*qjei_Vb_ci_Vtnode_GND)/cje0_dc_t-((h_vbe*qjei_Vb_ci)*cje0_dc_t_Vtnode_GND+(((h_vbe_Vtnode_GND*pInst->qjei)+(h_vbe*qjei_Vtnode_GND)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*cje0_dc_t_Vtnode_GND/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vb_ci_Vbi_ei=((+0.0*pInst->qjei+0.0*qjei_Vbi_ei+h_vbe_Vbi_ei*qjei_Vb_ci+h_vbe*qjei_Vb_ci_Vbi_ei)/cje0_dc_t-((h_vbe*qjei_Vb_ci)*0.0+(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vb_ci_Vci_ei=((+0.0*pInst->qjei+0.0*qjei_Vci_ei+0.0*qjei_Vb_ci+h_vbe*qjei_Vb_ci_Vci_ei)/cje0_dc_t-((h_vbe*qjei_Vb_ci)*0.0+((h_vbe*qjei_Vci_ei))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vb_ci_Vb_ci=((+0.0*pInst->qjei+0.0*qjei_Vb_ci+0.0*qjei_Vb_ci+h_vbe*qjei_Vb_ci_Vb_ci)/cje0_dc_t-((h_vbe*qjei_Vb_ci)*0.0+((h_vbe*qjei_Vb_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vb_ci_Vbi_ci=((+0.0*pInst->qjei+0.0*qjei_Vbi_ci+0.0*qjei_Vb_ci+h_vbe*qjei_Vb_ci_Vbi_ci)/cje0_dc_t-((h_vbe*qjei_Vb_ci)*0.0+((h_vbe*qjei_Vbi_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
#endif
qje_Vbi_ci=((h_vbe*qjei_Vbi_ci)/cje0_dc_t);
#if defined(_DERIVATE2)
  qje_Vbi_ci_Vtnode_GND=((+0.0*pInst->qjei+0.0*qjei_Vtnode_GND+h_vbe_Vtnode_GND*qjei_Vbi_ci+h_vbe*qjei_Vbi_ci_Vtnode_GND)/cje0_dc_t-((h_vbe*qjei_Vbi_ci)*cje0_dc_t_Vtnode_GND+(((h_vbe_Vtnode_GND*pInst->qjei)+(h_vbe*qjei_Vtnode_GND)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*cje0_dc_t_Vtnode_GND/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ci_Vbi_ei=((+0.0*pInst->qjei+0.0*qjei_Vbi_ei+h_vbe_Vbi_ei*qjei_Vbi_ci+h_vbe*qjei_Vbi_ci_Vbi_ei)/cje0_dc_t-((h_vbe*qjei_Vbi_ci)*0.0+(((h_vbe_Vbi_ei*pInst->qjei)+(h_vbe*qjei_Vbi_ei)))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ci_Vci_ei=((+0.0*pInst->qjei+0.0*qjei_Vci_ei+0.0*qjei_Vbi_ci+h_vbe*qjei_Vbi_ci_Vci_ei)/cje0_dc_t-((h_vbe*qjei_Vbi_ci)*0.0+((h_vbe*qjei_Vci_ei))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ci_Vb_ci=((+0.0*pInst->qjei+0.0*qjei_Vb_ci+0.0*qjei_Vbi_ci+h_vbe*qjei_Vbi_ci_Vb_ci)/cje0_dc_t-((h_vbe*qjei_Vbi_ci)*0.0+((h_vbe*qjei_Vb_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
  qje_Vbi_ci_Vbi_ci=((+0.0*pInst->qjei+0.0*qjei_Vbi_ci+0.0*qjei_Vbi_ci+h_vbe*qjei_Vbi_ci_Vbi_ci)/cje0_dc_t-((h_vbe*qjei_Vbi_ci)*0.0+((h_vbe*qjei_Vbi_ci))*0.0+(h_vbe*pInst->qjei)*0.0)/cje0_dc_t/cje0_dc_t+2*(h_vbe*pInst->qjei)*0.0*0.0/cje0_dc_t/cje0_dc_t/cje0_dc_t);
#endif
#endif
qje=((h_vbe*pInst->qjei)/cje0_dc_t);
EXIT_IF_ISNAN(((h_vbe*pInst->qjei)/cje0_dc_t))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qj_Vb_ci=((qjci_Vb_ci/pModel->vef)+(qje_Vb_ci/ver_t));
#if defined(_DERIVATE2)
  qj_Vb_ci_Vb_ci=(+(+0.0+(qjci_Vb_ci_Vb_ci/pModel->vef-(qjci_Vb_ci*0.0+qjci_Vb_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vb_ci_Vb_ci/ver_t-(qje_Vb_ci*0.0+qje_Vb_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vb_ci_Vtnode_GND=(+(+0.0+(qjci_Vb_ci_Vtnode_GND/pModel->vef-(qjci_Vb_ci*0.0+qjci_Vtnode_GND*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vb_ci_Vtnode_GND/ver_t-(qje_Vb_ci*ver_t_Vtnode_GND+qje_Vtnode_GND*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*ver_t_Vtnode_GND/ver_t/ver_t/ver_t));
  qj_Vb_ci_Vbi_ci=(+(+0.0+(qjci_Vb_ci_Vbi_ci/pModel->vef-(qjci_Vb_ci*0.0+qjci_Vbi_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vb_ci_Vbi_ci/ver_t-(qje_Vb_ci*0.0+qje_Vbi_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vb_ci_Vbi_ei=(+(+0.0+(0.0/pModel->vef-(qjci_Vb_ci*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vb_ci_Vbi_ei/ver_t-(qje_Vb_ci*0.0+qje_Vbi_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vb_ci_Vci_ei=(+(+0.0+(0.0/pModel->vef-(qjci_Vb_ci*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vb_ci_Vci_ei/ver_t-(qje_Vb_ci*0.0+qje_Vci_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
#endif
#if defined(_DERIVATE)
qj_Vtnode_GND=((qjci_Vtnode_GND/pModel->vef)+((qje_Vtnode_GND*ver_t-qje*ver_t_Vtnode_GND)/ver_t/ver_t));
#endif
qj_Vbi_ci=((qjci_Vbi_ci/pModel->vef)+(qje_Vbi_ci/ver_t));
#if defined(_DERIVATE2)
  qj_Vbi_ci_Vb_ci=(+(+0.0+(qjci_Vbi_ci_Vb_ci/pModel->vef-(qjci_Vbi_ci*0.0+qjci_Vb_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ci_Vb_ci/ver_t-(qje_Vbi_ci*0.0+qje_Vb_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vbi_ci_Vtnode_GND=(+(+0.0+(qjci_Vbi_ci_Vtnode_GND/pModel->vef-(qjci_Vbi_ci*0.0+qjci_Vtnode_GND*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ci_Vtnode_GND/ver_t-(qje_Vbi_ci*ver_t_Vtnode_GND+qje_Vtnode_GND*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*ver_t_Vtnode_GND/ver_t/ver_t/ver_t));
  qj_Vbi_ci_Vbi_ci=(+(+0.0+(qjci_Vbi_ci_Vbi_ci/pModel->vef-(qjci_Vbi_ci*0.0+qjci_Vbi_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ci_Vbi_ci/ver_t-(qje_Vbi_ci*0.0+qje_Vbi_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vbi_ci_Vbi_ei=(+(+0.0+(0.0/pModel->vef-(qjci_Vbi_ci*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ci_Vbi_ei/ver_t-(qje_Vbi_ci*0.0+qje_Vbi_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vbi_ci_Vci_ei=(+(+0.0+(0.0/pModel->vef-(qjci_Vbi_ci*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ci_Vci_ei/ver_t-(qje_Vbi_ci*0.0+qje_Vci_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
#endif
qj_Vbi_ei=(qje_Vbi_ei/ver_t);
#if defined(_DERIVATE2)
  qj_Vbi_ei_Vb_ci=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+qjci_Vb_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ei_Vb_ci/ver_t-(qje_Vbi_ei*0.0+qje_Vb_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vbi_ei_Vtnode_GND=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+qjci_Vtnode_GND*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ei_Vtnode_GND/ver_t-(qje_Vbi_ei*ver_t_Vtnode_GND+qje_Vtnode_GND*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*ver_t_Vtnode_GND/ver_t/ver_t/ver_t));
  qj_Vbi_ei_Vbi_ci=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+qjci_Vbi_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ei_Vbi_ci/ver_t-(qje_Vbi_ei*0.0+qje_Vbi_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vbi_ei_Vbi_ei=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ei_Vbi_ei/ver_t-(qje_Vbi_ei*0.0+qje_Vbi_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vbi_ei_Vci_ei=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vbi_ei_Vci_ei/ver_t-(qje_Vbi_ei*0.0+qje_Vci_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
#endif
qj_Vci_ei=(qje_Vci_ei/ver_t);
#if defined(_DERIVATE2)
  qj_Vci_ei_Vb_ci=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+qjci_Vb_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vci_ei_Vb_ci/ver_t-(qje_Vci_ei*0.0+qje_Vb_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vci_ei_Vtnode_GND=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+qjci_Vtnode_GND*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vci_ei_Vtnode_GND/ver_t-(qje_Vci_ei*ver_t_Vtnode_GND+qje_Vtnode_GND*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*ver_t_Vtnode_GND/ver_t/ver_t/ver_t));
  qj_Vci_ei_Vbi_ci=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+qjci_Vbi_ci*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vci_ei_Vbi_ci/ver_t-(qje_Vci_ei*0.0+qje_Vbi_ci*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vci_ei_Vbi_ei=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vci_ei_Vbi_ei/ver_t-(qje_Vci_ei*0.0+qje_Vbi_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
  qj_Vci_ei_Vci_ei=(+(+0.0+(0.0/pModel->vef-(0.0*0.0+0.0*0.0+pInst->qjci*0.0)/pModel->vef/pModel->vef+2*pInst->qjci*0.0*0.0/pModel->vef/pModel->vef/pModel->vef))+(qje_Vci_ei_Vci_ei/ver_t-(qje_Vci_ei*0.0+qje_Vci_ei*0.0+qje*0.0)/ver_t/ver_t+2*qje*0.0*0.0/ver_t/ver_t/ver_t));
#endif
#endif
qj=((1+(pInst->qjci/pModel->vef))+(qje/ver_t));
EXIT_IF_ISNAN(((1+(pInst->qjci/pModel->vef))+(qje/ver_t)))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
b_q_Vb_ci=(20*qj_Vb_ci);
#if defined(_DERIVATE2)
  b_q_Vb_ci_Vb_ci=(+(+0.0*qj+0.0*qj_Vb_ci+0.0*qj_Vb_ci+20*qj_Vb_ci_Vb_ci)-0.0);
  b_q_Vb_ci_Vtnode_GND=(+(+0.0*qj+0.0*qj_Vtnode_GND+0.0*qj_Vb_ci+20*qj_Vb_ci_Vtnode_GND)-0.0);
  b_q_Vb_ci_Vbi_ci=(+(+0.0*qj+0.0*qj_Vbi_ci+0.0*qj_Vb_ci+20*qj_Vb_ci_Vbi_ci)-0.0);
  b_q_Vb_ci_Vbi_ei=(+(+0.0*qj+0.0*qj_Vbi_ei+0.0*qj_Vb_ci+20*qj_Vb_ci_Vbi_ei)-0.0);
  b_q_Vb_ci_Vci_ei=(+(+0.0*qj+0.0*qj_Vci_ei+0.0*qj_Vb_ci+20*qj_Vb_ci_Vci_ei)-0.0);
#endif
#if defined(_DERIVATE)
b_q_Vtnode_GND=(20*qj_Vtnode_GND);
#endif
b_q_Vbi_ci=(20*qj_Vbi_ci);
#if defined(_DERIVATE2)
  b_q_Vbi_ci_Vb_ci=(+(+0.0*qj+0.0*qj_Vb_ci+0.0*qj_Vbi_ci+20*qj_Vbi_ci_Vb_ci)-0.0);
  b_q_Vbi_ci_Vtnode_GND=(+(+0.0*qj+0.0*qj_Vtnode_GND+0.0*qj_Vbi_ci+20*qj_Vbi_ci_Vtnode_GND)-0.0);
  b_q_Vbi_ci_Vbi_ci=(+(+0.0*qj+0.0*qj_Vbi_ci+0.0*qj_Vbi_ci+20*qj_Vbi_ci_Vbi_ci)-0.0);
  b_q_Vbi_ci_Vbi_ei=(+(+0.0*qj+0.0*qj_Vbi_ei+0.0*qj_Vbi_ci+20*qj_Vbi_ci_Vbi_ei)-0.0);
  b_q_Vbi_ci_Vci_ei=(+(+0.0*qj+0.0*qj_Vci_ei+0.0*qj_Vbi_ci+20*qj_Vbi_ci_Vci_ei)-0.0);
#endif
b_q_Vbi_ei=(20*qj_Vbi_ei);
#if defined(_DERIVATE2)
  b_q_Vbi_ei_Vb_ci=(+(+0.0*qj+0.0*qj_Vb_ci+0.0*qj_Vbi_ei+20*qj_Vbi_ei_Vb_ci)-0.0);
  b_q_Vbi_ei_Vtnode_GND=(+(+0.0*qj+0.0*qj_Vtnode_GND+0.0*qj_Vbi_ei+20*qj_Vbi_ei_Vtnode_GND)-0.0);
  b_q_Vbi_ei_Vbi_ci=(+(+0.0*qj+0.0*qj_Vbi_ci+0.0*qj_Vbi_ei+20*qj_Vbi_ei_Vbi_ci)-0.0);
  b_q_Vbi_ei_Vbi_ei=(+(+0.0*qj+0.0*qj_Vbi_ei+0.0*qj_Vbi_ei+20*qj_Vbi_ei_Vbi_ei)-0.0);
  b_q_Vbi_ei_Vci_ei=(+(+0.0*qj+0.0*qj_Vci_ei+0.0*qj_Vbi_ei+20*qj_Vbi_ei_Vci_ei)-0.0);
#endif
b_q_Vci_ei=(20*qj_Vci_ei);
#if defined(_DERIVATE2)
  b_q_Vci_ei_Vb_ci=(+(+0.0*qj+0.0*qj_Vb_ci+0.0*qj_Vci_ei+20*qj_Vci_ei_Vb_ci)-0.0);
  b_q_Vci_ei_Vtnode_GND=(+(+0.0*qj+0.0*qj_Vtnode_GND+0.0*qj_Vci_ei+20*qj_Vci_ei_Vtnode_GND)-0.0);
  b_q_Vci_ei_Vbi_ci=(+(+0.0*qj+0.0*qj_Vbi_ci+0.0*qj_Vci_ei+20*qj_Vci_ei_Vbi_ci)-0.0);
  b_q_Vci_ei_Vbi_ei=(+(+0.0*qj+0.0*qj_Vbi_ei+0.0*qj_Vci_ei+20*qj_Vci_ei_Vbi_ei)-0.0);
  b_q_Vci_ei_Vci_ei=(+(+0.0*qj+0.0*qj_Vci_ei+0.0*qj_Vci_ei+20*qj_Vci_ei_Vci_ei)-0.0);
#endif
#endif
b_q=((20*qj)-1);
EXIT_IF_ISNAN(((20*qj)-1))
{
double m00_sqrt(d00_sqrt0,((b_q*b_q)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((b_q*b_q)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qj_2_Vb_ci=(0.025*((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)/2));
#if defined(_DERIVATE2)
  qj_2_Vb_ci_Vb_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vb_ci_Vb_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))+d10_sqrt0*(+(+b_q_Vb_ci_Vb_ci*b_q+b_q_Vb_ci*b_q_Vb_ci+b_q_Vb_ci*b_q_Vb_ci+b_q*b_q_Vb_ci_Vb_ci)+0.0)))/2-((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)*0.0+(b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vb_ci_Vtnode_GND=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)/2)+0.0*((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vb_ci_Vtnode_GND+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))+d10_sqrt0*(+(+b_q_Vb_ci_Vtnode_GND*b_q+b_q_Vb_ci*b_q_Vtnode_GND+b_q_Vtnode_GND*b_q_Vb_ci+b_q*b_q_Vb_ci_Vtnode_GND)+0.0)))/2-((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)*0.0+(b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vb_ci_Vbi_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vb_ci_Vbi_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))+d10_sqrt0*(+(+b_q_Vb_ci_Vbi_ci*b_q+b_q_Vb_ci*b_q_Vbi_ci+b_q_Vbi_ci*b_q_Vb_ci+b_q*b_q_Vb_ci_Vbi_ci)+0.0)))/2-((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)*0.0+(b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vb_ci_Vbi_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vb_ci_Vbi_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))+d10_sqrt0*(+(+b_q_Vb_ci_Vbi_ei*b_q+b_q_Vb_ci*b_q_Vbi_ei+b_q_Vbi_ei*b_q_Vb_ci+b_q*b_q_Vb_ci_Vbi_ei)+0.0)))/2-((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)*0.0+(b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vb_ci_Vci_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vb_ci_Vci_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))+d10_sqrt0*(+(+b_q_Vb_ci_Vci_ei*b_q+b_q_Vb_ci*b_q_Vci_ei+b_q_Vci_ei*b_q_Vb_ci+b_q*b_q_Vb_ci_Vci_ei)+0.0)))/2-((b_q_Vb_ci+((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci))*d10_sqrt0)*0.0+(b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
#endif
#if defined(_DERIVATE)
qj_2_Vtnode_GND=(0.025*((b_q_Vtnode_GND+((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND))*d10_sqrt0)/2));
#endif
qj_2_Vbi_ci=(0.025*((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)/2));
#if defined(_DERIVATE2)
  qj_2_Vbi_ci_Vb_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ci_Vb_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))+d10_sqrt0*(+(+b_q_Vbi_ci_Vb_ci*b_q+b_q_Vbi_ci*b_q_Vb_ci+b_q_Vb_ci*b_q_Vbi_ci+b_q*b_q_Vbi_ci_Vb_ci)+0.0)))/2-((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)*0.0+(b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ci_Vtnode_GND=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ci_Vtnode_GND+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))+d10_sqrt0*(+(+b_q_Vbi_ci_Vtnode_GND*b_q+b_q_Vbi_ci*b_q_Vtnode_GND+b_q_Vtnode_GND*b_q_Vbi_ci+b_q*b_q_Vbi_ci_Vtnode_GND)+0.0)))/2-((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)*0.0+(b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ci_Vbi_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ci_Vbi_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))+d10_sqrt0*(+(+b_q_Vbi_ci_Vbi_ci*b_q+b_q_Vbi_ci*b_q_Vbi_ci+b_q_Vbi_ci*b_q_Vbi_ci+b_q*b_q_Vbi_ci_Vbi_ci)+0.0)))/2-((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)*0.0+(b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ci_Vbi_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ci_Vbi_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))+d10_sqrt0*(+(+b_q_Vbi_ci_Vbi_ei*b_q+b_q_Vbi_ci*b_q_Vbi_ei+b_q_Vbi_ei*b_q_Vbi_ci+b_q*b_q_Vbi_ci_Vbi_ei)+0.0)))/2-((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)*0.0+(b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ci_Vci_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ci_Vci_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))+d10_sqrt0*(+(+b_q_Vbi_ci_Vci_ei*b_q+b_q_Vbi_ci*b_q_Vci_ei+b_q_Vci_ei*b_q_Vbi_ci+b_q*b_q_Vbi_ci_Vci_ei)+0.0)))/2-((b_q_Vbi_ci+((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci))*d10_sqrt0)*0.0+(b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
#endif
qj_2_Vbi_ei=(0.025*((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)/2));
#if defined(_DERIVATE2)
  qj_2_Vbi_ei_Vb_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ei_Vb_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))+d10_sqrt0*(+(+b_q_Vbi_ei_Vb_ci*b_q+b_q_Vbi_ei*b_q_Vb_ci+b_q_Vb_ci*b_q_Vbi_ei+b_q*b_q_Vbi_ei_Vb_ci)+0.0)))/2-((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)*0.0+(b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ei_Vtnode_GND=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ei_Vtnode_GND+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))+d10_sqrt0*(+(+b_q_Vbi_ei_Vtnode_GND*b_q+b_q_Vbi_ei*b_q_Vtnode_GND+b_q_Vtnode_GND*b_q_Vbi_ei+b_q*b_q_Vbi_ei_Vtnode_GND)+0.0)))/2-((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)*0.0+(b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ei_Vbi_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ei_Vbi_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))+d10_sqrt0*(+(+b_q_Vbi_ei_Vbi_ci*b_q+b_q_Vbi_ei*b_q_Vbi_ci+b_q_Vbi_ci*b_q_Vbi_ei+b_q*b_q_Vbi_ei_Vbi_ci)+0.0)))/2-((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)*0.0+(b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ei_Vbi_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ei_Vbi_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))+d10_sqrt0*(+(+b_q_Vbi_ei_Vbi_ei*b_q+b_q_Vbi_ei*b_q_Vbi_ei+b_q_Vbi_ei*b_q_Vbi_ei+b_q*b_q_Vbi_ei_Vbi_ei)+0.0)))/2-((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)*0.0+(b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vbi_ei_Vci_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vbi_ei_Vci_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))+d10_sqrt0*(+(+b_q_Vbi_ei_Vci_ei*b_q+b_q_Vbi_ei*b_q_Vci_ei+b_q_Vci_ei*b_q_Vbi_ei+b_q*b_q_Vbi_ei_Vci_ei)+0.0)))/2-((b_q_Vbi_ei+((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei))*d10_sqrt0)*0.0+(b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
#endif
qj_2_Vci_ei=(0.025*((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)/2));
#if defined(_DERIVATE2)
  qj_2_Vci_ei_Vb_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vci_ei_Vb_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))+d10_sqrt0*(+(+b_q_Vci_ei_Vb_ci*b_q+b_q_Vci_ei*b_q_Vb_ci+b_q_Vb_ci*b_q_Vci_ei+b_q*b_q_Vci_ei_Vb_ci)+0.0)))/2-((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)*0.0+(b_q_Vb_ci+(((b_q_Vb_ci*b_q)+(b_q*b_q_Vb_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vci_ei_Vtnode_GND=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)/2)+0.0*((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vci_ei_Vtnode_GND+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))+d10_sqrt0*(+(+b_q_Vci_ei_Vtnode_GND*b_q+b_q_Vci_ei*b_q_Vtnode_GND+b_q_Vtnode_GND*b_q_Vci_ei+b_q*b_q_Vci_ei_Vtnode_GND)+0.0)))/2-((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)*0.0+(b_q_Vtnode_GND+(((b_q_Vtnode_GND*b_q)+(b_q*b_q_Vtnode_GND)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vci_ei_Vbi_ci=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)/2)+0.0*((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vci_ei_Vbi_ci+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))+d10_sqrt0*(+(+b_q_Vci_ei_Vbi_ci*b_q+b_q_Vci_ei*b_q_Vbi_ci+b_q_Vbi_ci*b_q_Vci_ei+b_q*b_q_Vci_ei_Vbi_ci)+0.0)))/2-((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)*0.0+(b_q_Vbi_ci+(((b_q_Vbi_ci*b_q)+(b_q*b_q_Vbi_ci)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vci_ei_Vbi_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vci_ei_Vbi_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))+d10_sqrt0*(+(+b_q_Vci_ei_Vbi_ei*b_q+b_q_Vci_ei*b_q_Vbi_ei+b_q_Vbi_ei*b_q_Vci_ei+b_q*b_q_Vci_ei_Vbi_ei)+0.0)))/2-((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)*0.0+(b_q_Vbi_ei+(((b_q_Vbi_ei*b_q)+(b_q*b_q_Vbi_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
  qj_2_Vci_ei_Vci_ei=(+0.0*(1+((b_q+d00_sqrt0)/2))+0.0*((b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)/2)+0.0*((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)/2)+0.025*(+0.0+((+b_q_Vci_ei_Vci_ei+(m20_sqrt(((b_q*b_q)+1.921812))*(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))+d10_sqrt0*(+(+b_q_Vci_ei_Vci_ei*b_q+b_q_Vci_ei*b_q_Vci_ei+b_q_Vci_ei*b_q_Vci_ei+b_q*b_q_Vci_ei_Vci_ei)+0.0)))/2-((b_q_Vci_ei+((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei))*d10_sqrt0)*0.0+(b_q_Vci_ei+(((b_q_Vci_ei*b_q)+(b_q*b_q_Vci_ei)))*d10_sqrt0)*0.0+(b_q+d00_sqrt0)*0.0)/2/2+2*(b_q+d00_sqrt0)*0.0*0.0/2/2/2)));
#endif
#endif
qj_2=(0.025*(1+((b_q+d00_sqrt0)/2)));
EXIT_IF_ISNAN((0.025*(1+((b_q+d00_sqrt0)/2))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
tf0_Vtnode_GND=((t0_t_Vtnode_GND+(pModel->dt0h*cc_Vtnode_GND))+(pModel->tbvl*(-1*cc_Vtnode_GND/cc/cc)));
#endif
tf0_Vb_ci=((pModel->dt0h*cc_Vb_ci)+(pModel->tbvl*(-1*cc_Vb_ci/cc/cc)));
#if defined(_DERIVATE2)
  tf0_Vb_ci_Vtnode_GND=(+(+0.0+(+0.0*(cc-1)+0.0*cc_Vtnode_GND+0.0*cc_Vb_ci+pModel->dt0h*(+cc_Vb_ci_Vtnode_GND-0.0)))+(+0.0*((1/cc)-1)+0.0*(-1*cc_Vtnode_GND/cc/cc)+0.0*(-1*cc_Vb_ci/cc/cc)+pModel->tbvl*(+(0.0/cc-(0.0*cc_Vtnode_GND+0.0*cc_Vb_ci+1*cc_Vb_ci_Vtnode_GND)/cc/cc+2*1*cc_Vb_ci*cc_Vtnode_GND/cc/cc/cc)-0.0)));
  tf0_Vb_ci_Vb_ci=(+(+0.0+(+0.0*(cc-1)+0.0*cc_Vb_ci+0.0*cc_Vb_ci+pModel->dt0h*(+cc_Vb_ci_Vb_ci-0.0)))+(+0.0*((1/cc)-1)+0.0*(-1*cc_Vb_ci/cc/cc)+0.0*(-1*cc_Vb_ci/cc/cc)+pModel->tbvl*(+(0.0/cc-(0.0*cc_Vb_ci+0.0*cc_Vb_ci+1*cc_Vb_ci_Vb_ci)/cc/cc+2*1*cc_Vb_ci*cc_Vb_ci/cc/cc/cc)-0.0)));
  tf0_Vb_ci_Vbi_ci=(+(+0.0+(+0.0*(cc-1)+0.0*cc_Vbi_ci+0.0*cc_Vb_ci+pModel->dt0h*(+cc_Vb_ci_Vbi_ci-0.0)))+(+0.0*((1/cc)-1)+0.0*(-1*cc_Vbi_ci/cc/cc)+0.0*(-1*cc_Vb_ci/cc/cc)+pModel->tbvl*(+(0.0/cc-(0.0*cc_Vbi_ci+0.0*cc_Vb_ci+1*cc_Vb_ci_Vbi_ci)/cc/cc+2*1*cc_Vb_ci*cc_Vbi_ci/cc/cc/cc)-0.0)));
#endif
tf0_Vbi_ci=((pModel->dt0h*cc_Vbi_ci)+(pModel->tbvl*(-1*cc_Vbi_ci/cc/cc)));
#if defined(_DERIVATE2)
  tf0_Vbi_ci_Vtnode_GND=(+(+0.0+(+0.0*(cc-1)+0.0*cc_Vtnode_GND+0.0*cc_Vbi_ci+pModel->dt0h*(+cc_Vbi_ci_Vtnode_GND-0.0)))+(+0.0*((1/cc)-1)+0.0*(-1*cc_Vtnode_GND/cc/cc)+0.0*(-1*cc_Vbi_ci/cc/cc)+pModel->tbvl*(+(0.0/cc-(0.0*cc_Vtnode_GND+0.0*cc_Vbi_ci+1*cc_Vbi_ci_Vtnode_GND)/cc/cc+2*1*cc_Vbi_ci*cc_Vtnode_GND/cc/cc/cc)-0.0)));
  tf0_Vbi_ci_Vb_ci=(+(+0.0+(+0.0*(cc-1)+0.0*cc_Vb_ci+0.0*cc_Vbi_ci+pModel->dt0h*(+cc_Vbi_ci_Vb_ci-0.0)))+(+0.0*((1/cc)-1)+0.0*(-1*cc_Vb_ci/cc/cc)+0.0*(-1*cc_Vbi_ci/cc/cc)+pModel->tbvl*(+(0.0/cc-(0.0*cc_Vb_ci+0.0*cc_Vbi_ci+1*cc_Vbi_ci_Vb_ci)/cc/cc+2*1*cc_Vbi_ci*cc_Vb_ci/cc/cc/cc)-0.0)));
  tf0_Vbi_ci_Vbi_ci=(+(+0.0+(+0.0*(cc-1)+0.0*cc_Vbi_ci+0.0*cc_Vbi_ci+pModel->dt0h*(+cc_Vbi_ci_Vbi_ci-0.0)))+(+0.0*((1/cc)-1)+0.0*(-1*cc_Vbi_ci/cc/cc)+0.0*(-1*cc_Vbi_ci/cc/cc)+pModel->tbvl*(+(0.0/cc-(0.0*cc_Vbi_ci+0.0*cc_Vbi_ci+1*cc_Vbi_ci_Vbi_ci)/cc/cc+2*1*cc_Vbi_ci*cc_Vbi_ci/cc/cc/cc)-0.0)));
#endif
#endif
tf0=((t0_t+(pModel->dt0h*(cc-1)))+(pModel->tbvl*((1/cc)-1)));
EXIT_IF_ISNAN(((t0_t+(pModel->dt0h*(cc-1)))+(pModel->tbvl*((1/cc)-1))))
if
((pModel->fiqf==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
denom_iqf_Vtnode_GND=(pModel->fiqf*((tf0_Vtnode_GND*t0_t-tf0*t0_t_Vtnode_GND)/t0_t/t0_t));
#endif
denom_iqf_Vb_ci=(pModel->fiqf*(tf0_Vb_ci/t0_t));
#if defined(_DERIVATE2)
  denom_iqf_Vb_ci_Vtnode_GND=(+0.0*((tf0/t0_t)-1)+0.0*((tf0_Vtnode_GND*t0_t-tf0*t0_t_Vtnode_GND)/t0_t/t0_t)+0.0*(tf0_Vb_ci/t0_t)+pModel->fiqf*(+(tf0_Vb_ci_Vtnode_GND/t0_t-(tf0_Vb_ci*t0_t_Vtnode_GND+tf0_Vtnode_GND*0.0+tf0*0.0)/t0_t/t0_t+2*tf0*0.0*t0_t_Vtnode_GND/t0_t/t0_t/t0_t)-0.0));
  denom_iqf_Vb_ci_Vb_ci=(+0.0*((tf0/t0_t)-1)+0.0*(tf0_Vb_ci/t0_t)+0.0*(tf0_Vb_ci/t0_t)+pModel->fiqf*(+(tf0_Vb_ci_Vb_ci/t0_t-(tf0_Vb_ci*0.0+tf0_Vb_ci*0.0+tf0*0.0)/t0_t/t0_t+2*tf0*0.0*0.0/t0_t/t0_t/t0_t)-0.0));
  denom_iqf_Vb_ci_Vbi_ci=(+0.0*((tf0/t0_t)-1)+0.0*(tf0_Vbi_ci/t0_t)+0.0*(tf0_Vb_ci/t0_t)+pModel->fiqf*(+(tf0_Vb_ci_Vbi_ci/t0_t-(tf0_Vb_ci*0.0+tf0_Vbi_ci*0.0+tf0*0.0)/t0_t/t0_t+2*tf0*0.0*0.0/t0_t/t0_t/t0_t)-0.0));
#endif
denom_iqf_Vbi_ci=(pModel->fiqf*(tf0_Vbi_ci/t0_t));
#if defined(_DERIVATE2)
  denom_iqf_Vbi_ci_Vtnode_GND=(+0.0*((tf0/t0_t)-1)+0.0*((tf0_Vtnode_GND*t0_t-tf0*t0_t_Vtnode_GND)/t0_t/t0_t)+0.0*(tf0_Vbi_ci/t0_t)+pModel->fiqf*(+(tf0_Vbi_ci_Vtnode_GND/t0_t-(tf0_Vbi_ci*t0_t_Vtnode_GND+tf0_Vtnode_GND*0.0+tf0*0.0)/t0_t/t0_t+2*tf0*0.0*t0_t_Vtnode_GND/t0_t/t0_t/t0_t)-0.0));
  denom_iqf_Vbi_ci_Vb_ci=(+0.0*((tf0/t0_t)-1)+0.0*(tf0_Vb_ci/t0_t)+0.0*(tf0_Vbi_ci/t0_t)+pModel->fiqf*(+(tf0_Vbi_ci_Vb_ci/t0_t-(tf0_Vbi_ci*0.0+tf0_Vb_ci*0.0+tf0*0.0)/t0_t/t0_t+2*tf0*0.0*0.0/t0_t/t0_t/t0_t)-0.0));
  denom_iqf_Vbi_ci_Vbi_ci=(+0.0*((tf0/t0_t)-1)+0.0*(tf0_Vbi_ci/t0_t)+0.0*(tf0_Vbi_ci/t0_t)+pModel->fiqf*(+(tf0_Vbi_ci_Vbi_ci/t0_t-(tf0_Vbi_ci*0.0+tf0_Vbi_ci*0.0+tf0*0.0)/t0_t/t0_t+2*tf0*0.0*0.0/t0_t/t0_t/t0_t)-0.0));
#endif
#endif
denom_iqf=(pModel->fiqf*((tf0/t0_t)-1));
EXIT_IF_ISNAN((pModel->fiqf*((tf0/t0_t)-1)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
ickf_Vtnode_GND=((iqf_t_Vtnode_GND*(1+denom_iqf)-iqf_t*denom_iqf_Vtnode_GND)/(1+denom_iqf)/(1+denom_iqf));
#endif
ickf_Vb_ci=(-iqf_t*denom_iqf_Vb_ci/(1+denom_iqf)/(1+denom_iqf));
#if defined(_DERIVATE2)
  ickf_Vb_ci_Vtnode_GND=(0.0/(1+denom_iqf)-(0.0*denom_iqf_Vtnode_GND+iqf_t_Vtnode_GND*denom_iqf_Vb_ci+iqf_t*(+0.0+denom_iqf_Vb_ci_Vtnode_GND))/(1+denom_iqf)/(1+denom_iqf)+2*iqf_t*denom_iqf_Vb_ci*denom_iqf_Vtnode_GND/(1+denom_iqf)/(1+denom_iqf)/(1+denom_iqf));
  ickf_Vb_ci_Vb_ci=(0.0/(1+denom_iqf)-(0.0*denom_iqf_Vb_ci+0.0*denom_iqf_Vb_ci+iqf_t*(+0.0+denom_iqf_Vb_ci_Vb_ci))/(1+denom_iqf)/(1+denom_iqf)+2*iqf_t*denom_iqf_Vb_ci*denom_iqf_Vb_ci/(1+denom_iqf)/(1+denom_iqf)/(1+denom_iqf));
  ickf_Vb_ci_Vbi_ci=(0.0/(1+denom_iqf)-(0.0*denom_iqf_Vbi_ci+0.0*denom_iqf_Vb_ci+iqf_t*(+0.0+denom_iqf_Vb_ci_Vbi_ci))/(1+denom_iqf)/(1+denom_iqf)+2*iqf_t*denom_iqf_Vb_ci*denom_iqf_Vbi_ci/(1+denom_iqf)/(1+denom_iqf)/(1+denom_iqf));
#endif
ickf_Vbi_ci=(-iqf_t*denom_iqf_Vbi_ci/(1+denom_iqf)/(1+denom_iqf));
#if defined(_DERIVATE2)
  ickf_Vbi_ci_Vtnode_GND=(0.0/(1+denom_iqf)-(0.0*denom_iqf_Vtnode_GND+iqf_t_Vtnode_GND*denom_iqf_Vbi_ci+iqf_t*(+0.0+denom_iqf_Vbi_ci_Vtnode_GND))/(1+denom_iqf)/(1+denom_iqf)+2*iqf_t*denom_iqf_Vbi_ci*denom_iqf_Vtnode_GND/(1+denom_iqf)/(1+denom_iqf)/(1+denom_iqf));
  ickf_Vbi_ci_Vb_ci=(0.0/(1+denom_iqf)-(0.0*denom_iqf_Vb_ci+0.0*denom_iqf_Vbi_ci+iqf_t*(+0.0+denom_iqf_Vbi_ci_Vb_ci))/(1+denom_iqf)/(1+denom_iqf)+2*iqf_t*denom_iqf_Vbi_ci*denom_iqf_Vb_ci/(1+denom_iqf)/(1+denom_iqf)/(1+denom_iqf));
  ickf_Vbi_ci_Vbi_ci=(0.0/(1+denom_iqf)-(0.0*denom_iqf_Vbi_ci+0.0*denom_iqf_Vbi_ci+iqf_t*(+0.0+denom_iqf_Vbi_ci_Vbi_ci))/(1+denom_iqf)/(1+denom_iqf)+2*iqf_t*denom_iqf_Vbi_ci*denom_iqf_Vbi_ci/(1+denom_iqf)/(1+denom_iqf)/(1+denom_iqf));
#endif
#endif
ickf=(iqf_t/(1+denom_iqf));
EXIT_IF_ISNAN((iqf_t/(1+denom_iqf)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
ickf_Vtnode_GND=iqf_t_Vtnode_GND;
#endif
ickf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  ickf_Vb_ci_Vtnode_GND=0.0;
  ickf_Vb_ci_Vb_ci=0.0;
  ickf_Vb_ci_Vbi_ci=0.0;
#endif
ickf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  ickf_Vbi_ci_Vtnode_GND=0.0;
  ickf_Vbi_ci_Vb_ci=0.0;
  ickf_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
ickf=iqf_t;
EXIT_IF_ISNAN(iqf_t)
}
ickr=pModel->iqr;
EXIT_IF_ISNAN(pModel->iqr)
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND)V(ei,GND)V(s,GND) */
arg1_Vbi_ei=(Vbiei_Vbi_ei/(pModel->mcf*VT));
#if defined(_DERIVATE2)
  arg1_Vbi_ei_Vbi_ei=(Vbiei_Vbi_ei_Vbi_ei/(pModel->mcf*VT)-(Vbiei_Vbi_ei*(0.0)+Vbiei_Vbi_ei*0.0+Vbiei*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mcf*0.0))/(pModel->mcf*VT)/(pModel->mcf*VT)+2*Vbiei*0.0*(0.0)/(pModel->mcf*VT)/(pModel->mcf*VT)/(pModel->mcf*VT));
  arg1_Vbi_ei_Vtnode_GND=(0.0/(pModel->mcf*VT)-(Vbiei_Vbi_ei*((pModel->mcf*VT_Vtnode_GND))+0.0*0.0+Vbiei*(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+pModel->mcf*0.0))/(pModel->mcf*VT)/(pModel->mcf*VT)+2*Vbiei*0.0*((pModel->mcf*VT_Vtnode_GND))/(pModel->mcf*VT)/(pModel->mcf*VT)/(pModel->mcf*VT));
#endif
#if defined(_DERIVATE)
arg1_Vtnode_GND=(-Vbiei*(pModel->mcf*VT_Vtnode_GND)/(pModel->mcf*VT)/(pModel->mcf*VT));
#endif
#endif
arg1=(Vbiei/(pModel->mcf*VT));
EXIT_IF_ISNAN((Vbiei/(pModel->mcf*VT)))
if
((arg1>80))
{
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ei)V(tnode,GND) ddxprobe=V(s,GND)V(ei,GND)V(ci,GND)V(bi,GND) */
le1_Vbi_ei=arg1_Vbi_ei;
#if defined(_DERIVATE2)
  le1_Vbi_ei_Vbi_ei=(+0.0+(+arg1_Vbi_ei_Vbi_ei-0.0));
  le1_Vbi_ei_Vtnode_GND=(+0.0+(+arg1_Vbi_ei_Vtnode_GND-0.0));
#endif
#if defined(_DERIVATE)
le1_Vtnode_GND=arg1_Vtnode_GND;
#endif
#endif
le1=(1+(arg1-80));
EXIT_IF_ISNAN((1+(arg1-80)))
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND)V(ei,GND)V(s,GND) */
arg1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  arg1_Vbi_ei_Vbi_ei=0.0;
  arg1_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
arg1_Vtnode_GND=0.0;
#endif
#endif
arg1=80;
EXIT_IF_ISNAN(80)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ei)V(tnode,GND) ddxprobe=V(s,GND)V(ei,GND)V(ci,GND)V(bi,GND) */
le1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  le1_Vbi_ei_Vbi_ei=0.0;
  le1_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
le1_Vtnode_GND=0.0;
#endif
#endif
le1=1;
EXIT_IF_ISNAN(1)
}
{
double m00_limexp(d00_limexp0,arg1)
#if defined(_DERIVATEFORDDX)
double m10_limexp(d10_limexp0,d00_limexp0,arg1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ei)V(tnode,GND) ddxprobe=V(s,GND)V(ei,GND)V(ci,GND)V(bi,GND) */
le1_Vbi_ei=((le1_Vbi_ei*d00_limexp0)+(le1*arg1_Vbi_ei*d10_limexp0));
#if defined(_DERIVATE2)
  le1_Vbi_ei_Vbi_ei=(+le1_Vbi_ei_Vbi_ei*d00_limexp0+le1_Vbi_ei*arg1_Vbi_ei*d10_limexp0+le1_Vbi_ei*arg1_Vbi_ei*d10_limexp0+le1*(m20_limexp(arg1)*arg1_Vbi_ei*arg1_Vbi_ei+d10_limexp0*arg1_Vbi_ei_Vbi_ei));
  le1_Vbi_ei_Vtnode_GND=(+le1_Vbi_ei_Vtnode_GND*d00_limexp0+le1_Vbi_ei*arg1_Vtnode_GND*d10_limexp0+le1_Vtnode_GND*arg1_Vbi_ei*d10_limexp0+le1*(m20_limexp(arg1)*arg1_Vtnode_GND*arg1_Vbi_ei+d10_limexp0*arg1_Vbi_ei_Vtnode_GND));
#endif
#if defined(_DERIVATE)
le1_Vtnode_GND=((le1_Vtnode_GND*d00_limexp0)+(le1*arg1_Vtnode_GND*d10_limexp0));
#endif
#endif
le1=(le1*d00_limexp0);
EXIT_IF_ISNAN((le1*d00_limexp0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND)V(ci,GND)V(ei,GND)V(s,GND) */
#if defined(_DERIVATE)
itfi_Vtnode_GND=((is_t_Vtnode_GND*le1)+(is_t*le1_Vtnode_GND));
#endif
itfi_Vbi_ei=(is_t*le1_Vbi_ei);
#if defined(_DERIVATE2)
  itfi_Vbi_ei_Vtnode_GND=(+0.0*le1+0.0*le1_Vtnode_GND+is_t_Vtnode_GND*le1_Vbi_ei+is_t*le1_Vbi_ei_Vtnode_GND);
  itfi_Vbi_ei_Vbi_ei=(+0.0*le1+0.0*le1_Vbi_ei+0.0*le1_Vbi_ei+is_t*le1_Vbi_ei_Vbi_ei);
#endif
#endif
itfi=(is_t*le1);
EXIT_IF_ISNAN((is_t*le1))
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ci)V(tnode,GND) ddxprobe=V(s,GND)V(ei,GND)V(bi,GND)V(ci,GND) */
arg2_Vbi_ci=(Vbici_Vbi_ci/(pModel->mcr*VT));
#if defined(_DERIVATE2)
  arg2_Vbi_ci_Vbi_ci=(Vbici_Vbi_ci_Vbi_ci/(pModel->mcr*VT)-(Vbici_Vbi_ci*(0.0)+Vbici_Vbi_ci*0.0+Vbici*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mcr*0.0))/(pModel->mcr*VT)/(pModel->mcr*VT)+2*Vbici*0.0*(0.0)/(pModel->mcr*VT)/(pModel->mcr*VT)/(pModel->mcr*VT));
  arg2_Vbi_ci_Vtnode_GND=(0.0/(pModel->mcr*VT)-(Vbici_Vbi_ci*((pModel->mcr*VT_Vtnode_GND))+0.0*0.0+Vbici*(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+pModel->mcr*0.0))/(pModel->mcr*VT)/(pModel->mcr*VT)+2*Vbici*0.0*((pModel->mcr*VT_Vtnode_GND))/(pModel->mcr*VT)/(pModel->mcr*VT)/(pModel->mcr*VT));
#endif
#if defined(_DERIVATE)
arg2_Vtnode_GND=(-Vbici*(pModel->mcr*VT_Vtnode_GND)/(pModel->mcr*VT)/(pModel->mcr*VT));
#endif
#endif
arg2=(Vbici/(pModel->mcr*VT));
EXIT_IF_ISNAN((Vbici/(pModel->mcr*VT)))
if
((arg2>80))
{
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
le2_Vbi_ci=arg2_Vbi_ci;
#if defined(_DERIVATE2)
  le2_Vbi_ci_Vbi_ci=(+0.0+(+arg2_Vbi_ci_Vbi_ci-0.0));
  le2_Vbi_ci_Vtnode_GND=(+0.0+(+arg2_Vbi_ci_Vtnode_GND-0.0));
#endif
#if defined(_DERIVATE)
le2_Vtnode_GND=arg2_Vtnode_GND;
#endif
#endif
le2=(1+(arg2-80));
EXIT_IF_ISNAN((1+(arg2-80)))
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ci)V(tnode,GND) ddxprobe=V(s,GND)V(ei,GND)V(bi,GND)V(ci,GND) */
arg2_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  arg2_Vbi_ci_Vbi_ci=0.0;
  arg2_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
arg2_Vtnode_GND=0.0;
#endif
#endif
arg2=80;
EXIT_IF_ISNAN(80)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
le2_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le2_Vbi_ci_Vbi_ci=0.0;
  le2_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
le2_Vtnode_GND=0.0;
#endif
#endif
le2=1;
EXIT_IF_ISNAN(1)
}
{
double m00_limexp(d00_limexp0,arg2)
#if defined(_DERIVATEFORDDX)
double m10_limexp(d10_limexp0,d00_limexp0,arg2)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
le2_Vbi_ci=((le2_Vbi_ci*d00_limexp0)+(le2*arg2_Vbi_ci*d10_limexp0));
#if defined(_DERIVATE2)
  le2_Vbi_ci_Vbi_ci=(+le2_Vbi_ci_Vbi_ci*d00_limexp0+le2_Vbi_ci*arg2_Vbi_ci*d10_limexp0+le2_Vbi_ci*arg2_Vbi_ci*d10_limexp0+le2*(m20_limexp(arg2)*arg2_Vbi_ci*arg2_Vbi_ci+d10_limexp0*arg2_Vbi_ci_Vbi_ci));
  le2_Vbi_ci_Vtnode_GND=(+le2_Vbi_ci_Vtnode_GND*d00_limexp0+le2_Vbi_ci*arg2_Vtnode_GND*d10_limexp0+le2_Vtnode_GND*arg2_Vbi_ci*d10_limexp0+le2*(m20_limexp(arg2)*arg2_Vtnode_GND*arg2_Vbi_ci+d10_limexp0*arg2_Vbi_ci_Vtnode_GND));
#endif
#if defined(_DERIVATE)
le2_Vtnode_GND=((le2_Vtnode_GND*d00_limexp0)+(le2*arg2_Vtnode_GND*d10_limexp0));
#endif
#endif
le2=(le2*d00_limexp0);
EXIT_IF_ISNAN((le2*d00_limexp0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci) ddxprobe=V(s,GND)V(ei,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
itri_Vtnode_GND=((is_t_Vtnode_GND*le2)+(is_t*le2_Vtnode_GND));
#endif
itri_Vbi_ci=(is_t*le2_Vbi_ci);
#if defined(_DERIVATE2)
  itri_Vbi_ci_Vtnode_GND=(+0.0*le2+0.0*le2_Vtnode_GND+is_t_Vtnode_GND*le2_Vbi_ci+is_t*le2_Vbi_ci_Vtnode_GND);
  itri_Vbi_ci_Vbi_ci=(+0.0*le2+0.0*le2_Vbi_ci+0.0*le2_Vbi_ci+is_t*le2_Vbi_ci_Vbi_ci);
#endif
#endif
itri=(is_t*le2);
EXIT_IF_ISNAN((is_t*le2))
if
((pModel->tfh!=0))
{
{
double m00_logE(d00_logE0,((itfi*(itfi/ick))*(tfh_t/iqfh_t)))
double m00_exp(d00_exp1,(0.6666*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((itfi*(itfi/ick))*(tfh_t/iqfh_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qml_Vtnode_GND=((((itfi_Vtnode_GND*ickf-itfi*ickf_Vtnode_GND)/ickf/ickf)+(itri_Vtnode_GND/ickr))+(0.6666*((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)))*d10_logE0)*d10_exp1);
#endif
qml_Vbi_ei=((itfi_Vbi_ei/ickf)+(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  qml_Vbi_ei_Vtnode_GND=(+(+(itfi_Vbi_ei_Vtnode_GND/ickf-(itfi_Vbi_ei*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+itfi_Vbi_ei_Vtnode_GND*(itfi/ick)+itfi_Vbi_ei*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)+itfi_Vtnode_GND*(itfi_Vbi_ei/ick)+itfi*(itfi_Vbi_ei_Vtnode_GND/ick-(itfi_Vbi_ei*ick_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*ick_Vtnode_GND/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)+(((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+tfh_t_Vtnode_GND*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vbi_ei_Vbi_ei=(+(+(itfi_Vbi_ei_Vbi_ei/ickf-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+itfi_Vbi_ei_Vbi_ei*(itfi/ick)+itfi_Vbi_ei*(itfi_Vbi_ei/ick)+itfi_Vbi_ei*(itfi_Vbi_ei/ick)+itfi*(itfi_Vbi_ei_Vbi_ei/ick-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vbi_ei_Vb_ci=(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*0.0+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vbi_ei_Vbi_ci=(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*0.0+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vbi_ei_Vci_ei=(+(+(0.0/ickf-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*(-itfi*ick_Vci_ei/ick/ick)+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*ick_Vci_ei+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*ick_Vci_ei/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+((itfi*(-itfi*ick_Vci_ei/ick/ick)))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
#endif
qml_Vb_ci=(-itfi*ickf_Vb_ci/ickf/ickf);
#if defined(_DERIVATE2)
  qml_Vb_ci_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vb_ci+itfi*ickf_Vb_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vb_ci_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vb_ci_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vb_ci_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vb_ci_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
#endif
qml_Vbi_ci=((-itfi*ickf_Vbi_ci/ickf/ickf)+(itri_Vbi_ci/ickr));
#if defined(_DERIVATE2)
  qml_Vbi_ci_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(itri_Vbi_ci_Vtnode_GND/ickr-(itri_Vbi_ci*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vbi_ci_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vbi_ci_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vbi_ci_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(itri_Vbi_ci_Vbi_ci/ickr-(itri_Vbi_ci*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
  qml_Vbi_ci_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+0.0);
#endif
qml_Vci_ei=(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  qml_Vci_ei_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)+itfi_Vtnode_GND*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*ick_Vtnode_GND+itfi_Vtnode_GND*ick_Vci_ei+itfi*ick_Vci_ei_Vtnode_GND)/ick/ick+2*itfi*ick_Vci_ei*ick_Vtnode_GND/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)+(((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+tfh_t_Vtnode_GND*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vci_ei_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*(itfi_Vbi_ei/ick)+itfi_Vbi_ei*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+itfi_Vbi_ei*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vci_ei_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*0.0+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+0.0*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vci_ei_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*0.0+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+0.0*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qml_Vci_ei_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(m20_exp((0.6666*d00_logE0))*((0.6666*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*(-itfi*ick_Vci_ei/ick/ick)+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*ick_Vci_ei+0.0*ick_Vci_ei+itfi*ick_Vci_ei_Vci_ei)/ick/ick+2*itfi*ick_Vci_ei*ick_Vci_ei/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+((itfi*(-itfi*ick_Vci_ei/ick/ick)))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
#endif
#endif
qml=(((itfi/ickf)+(itri/ickr))+d00_exp1);
EXIT_IF_ISNAN((((itfi/ickf)+(itri/ickr))+d00_exp1))
}
{
double m00_logE(d00_logE0,((itfi*(itfi/ick))*(tfh_t/iqfh_t)))
double m00_exp(d00_exp1,(0.6666*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((itfi*(itfi/ick))*(tfh_t/iqfh_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qmh_Vtnode_GND=(((((itfi_Vtnode_GND*ickf-itfi*ickf_Vtnode_GND)/ickf/ickf)+(itri_Vtnode_GND/ickr))+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))+(0.6666*((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)))*d10_logE0)*d10_exp1);
#endif
qmh_Vbi_ei=(((itfi_Vbi_ei/ickf)+(itfi_Vbi_ei/iqfh_t))+(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  qmh_Vbi_ei_Vtnode_GND=(+(+(+(itfi_Vbi_ei_Vtnode_GND/ickf-(itfi_Vbi_ei*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(itfi_Vbi_ei_Vtnode_GND/iqfh_t-(itfi_Vbi_ei*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+itfi_Vbi_ei_Vtnode_GND*(itfi/ick)+itfi_Vbi_ei*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)+itfi_Vtnode_GND*(itfi_Vbi_ei/ick)+itfi*(itfi_Vbi_ei_Vtnode_GND/ick-(itfi_Vbi_ei*ick_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*ick_Vtnode_GND/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)+(((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+tfh_t_Vtnode_GND*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vbi_ei_Vbi_ei=(+(+(+(itfi_Vbi_ei_Vbi_ei/ickf-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(itfi_Vbi_ei_Vbi_ei/iqfh_t-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+itfi_Vbi_ei_Vbi_ei*(itfi/ick)+itfi_Vbi_ei*(itfi_Vbi_ei/ick)+itfi_Vbi_ei*(itfi_Vbi_ei/ick)+itfi*(itfi_Vbi_ei_Vbi_ei/ick-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vbi_ei_Vb_ci=(+(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*0.0+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vbi_ei_Vbi_ci=(+(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*0.0+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vbi_ei_Vci_ei=(+(+(+(0.0/ickf-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*(-itfi*ick_Vci_ei/ick/ick)+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*ick_Vci_ei+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*ick_Vci_ei/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+((itfi*(-itfi*ick_Vci_ei/ick/ick)))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
#endif
qmh_Vb_ci=(-itfi*ickf_Vb_ci/ickf/ickf);
#if defined(_DERIVATE2)
  qmh_Vb_ci_Vtnode_GND=(+(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vb_ci+itfi*ickf_Vb_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vb_ci_Vbi_ei=(+(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vb_ci_Vb_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vb_ci_Vbi_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vb_ci_Vci_ei=(+(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
#endif
qmh_Vbi_ci=((-itfi*ickf_Vbi_ci/ickf/ickf)+(itri_Vbi_ci/ickr));
#if defined(_DERIVATE2)
  qmh_Vbi_ci_Vtnode_GND=(+(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(itri_Vbi_ci_Vtnode_GND/ickr-(itri_Vbi_ci*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vbi_ci_Vbi_ei=(+(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vbi_ci_Vb_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vbi_ci_Vbi_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(itri_Vbi_ci_Vbi_ci/ickr-(itri_Vbi_ci*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
  qmh_Vbi_ci_Vci_ei=(+(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+0.0);
#endif
qmh_Vci_ei=(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  qmh_Vci_ei_Vtnode_GND=(+(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)+itfi_Vtnode_GND*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*ick_Vtnode_GND+itfi_Vtnode_GND*ick_Vci_ei+itfi*ick_Vci_ei_Vtnode_GND)/ick/ick+2*itfi*ick_Vci_ei*ick_Vtnode_GND/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)+(((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+tfh_t_Vtnode_GND*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vci_ei_Vbi_ei=(+(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*(itfi_Vbi_ei/ick)+itfi_Vbi_ei*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+itfi_Vbi_ei*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vci_ei_Vb_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*0.0+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+0.0*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vci_ei_Vbi_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*0.0+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+0.0*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qmh_Vci_ei_Vci_ei=(+(+(+(0.0/ickf-(0.0*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))+(m20_exp((0.6666*d00_logE0))*((0.6666*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*(-itfi*ick_Vci_ei/ick/ick)+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*ick_Vci_ei+0.0*ick_Vci_ei+itfi*ick_Vci_ei_Vci_ei)/ick/ick+2*itfi*ick_Vci_ei*ick_Vci_ei/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+((itfi*(-itfi*ick_Vci_ei/ick/ick)))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
#endif
#endif
qmh=((((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t))+d00_exp1);
EXIT_IF_ISNAN(((((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t))+d00_exp1))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qml_Vtnode_GND=(((itfi_Vtnode_GND*ickf-itfi*ickf_Vtnode_GND)/ickf/ickf)+(itri_Vtnode_GND/ickr));
#endif
qml_Vbi_ei=(itfi_Vbi_ei/ickf);
#if defined(_DERIVATE2)
  qml_Vbi_ei_Vtnode_GND=(+(itfi_Vbi_ei_Vtnode_GND/ickf-(itfi_Vbi_ei*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ei_Vbi_ei=(+(itfi_Vbi_ei_Vbi_ei/ickf-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ei_Vb_ci=(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ei_Vbi_ci=(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ei_Vci_ei=(+(0.0/ickf-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
#endif
qml_Vb_ci=(-itfi*ickf_Vb_ci/ickf/ickf);
#if defined(_DERIVATE2)
  qml_Vb_ci_Vtnode_GND=(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vb_ci+itfi*ickf_Vb_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vb_ci_Vbi_ei=(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vb_ci_Vb_ci=(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vb_ci_Vbi_ci=(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vb_ci_Vci_ei=(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
#endif
qml_Vbi_ci=((-itfi*ickf_Vbi_ci/ickf/ickf)+(itri_Vbi_ci/ickr));
#if defined(_DERIVATE2)
  qml_Vbi_ci_Vtnode_GND=(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(itri_Vbi_ci_Vtnode_GND/ickr-(itri_Vbi_ci*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ci_Vbi_ei=(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ci_Vb_ci=(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ci_Vbi_ci=(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(itri_Vbi_ci_Vbi_ci/ickr-(itri_Vbi_ci*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
  qml_Vbi_ci_Vci_ei=(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr));
#endif
qml_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qml_Vci_ei_Vtnode_GND=0.0;
  qml_Vci_ei_Vbi_ei=0.0;
  qml_Vci_ei_Vb_ci=0.0;
  qml_Vci_ei_Vbi_ci=0.0;
  qml_Vci_ei_Vci_ei=0.0;
#endif
#endif
qml=((itfi/ickf)+(itri/ickr));
EXIT_IF_ISNAN(((itfi/ickf)+(itri/ickr)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qmh_Vtnode_GND=((((itfi_Vtnode_GND*ickf-itfi*ickf_Vtnode_GND)/ickf/ickf)+(itri_Vtnode_GND/ickr))+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t));
#endif
qmh_Vbi_ei=((itfi_Vbi_ei/ickf)+(itfi_Vbi_ei/iqfh_t));
#if defined(_DERIVATE2)
  qmh_Vbi_ei_Vtnode_GND=(+(+(itfi_Vbi_ei_Vtnode_GND/ickf-(itfi_Vbi_ei*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(itfi_Vbi_ei_Vtnode_GND/iqfh_t-(itfi_Vbi_ei*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ei_Vbi_ei=(+(+(itfi_Vbi_ei_Vbi_ei/ickf-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(itfi_Vbi_ei_Vbi_ei/iqfh_t-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ei_Vb_ci=(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ei_Vbi_ci=(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ei_Vci_ei=(+(+(0.0/ickf-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
#endif
qmh_Vb_ci=(-itfi*ickf_Vb_ci/ickf/ickf);
#if defined(_DERIVATE2)
  qmh_Vb_ci_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vb_ci+itfi*ickf_Vb_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vb_ci_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vb_ci_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vb_ci_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vb_ci_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
#endif
qmh_Vbi_ci=((-itfi*ickf_Vbi_ci/ickf/ickf)+(itri_Vbi_ci/ickr));
#if defined(_DERIVATE2)
  qmh_Vbi_ci_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(itri_Vbi_ci_Vtnode_GND/ickr-(itri_Vbi_ci*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ci_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ci_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ci_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(itri_Vbi_ci_Vbi_ci/ickr-(itri_Vbi_ci*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
  qmh_Vbi_ci_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t));
#endif
qmh_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qmh_Vci_ei_Vtnode_GND=0.0;
  qmh_Vci_ei_Vbi_ei=0.0;
  qmh_Vci_ei_Vb_ci=0.0;
  qmh_Vci_ei_Vbi_ci=0.0;
  qmh_Vci_ei_Vci_ei=0.0;
#endif
#endif
qmh=(((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t));
EXIT_IF_ISNAN((((itfi/ickf)+(itri/ickr))+(itfi/iqfh_t)))
}
{
double m00_sqrt(d00_sqrt0,((qj_2*qj_2)+qml))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((qj_2*qj_2)+qml))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qpt_l_Vb_ci=(qj_2_Vb_ci+(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qml_Vb_ci)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_l_Vb_ci_Vb_ci=(+qj_2_Vb_ci_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qml_Vb_ci)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qml_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vb_ci*qj_2+qj_2_Vb_ci*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vb_ci)+qml_Vb_ci_Vb_ci)));
  qpt_l_Vb_ci_Vtnode_GND=(+qj_2_Vb_ci_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qml_Vtnode_GND)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qml_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vtnode_GND*qj_2+qj_2_Vb_ci*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vtnode_GND)+qml_Vb_ci_Vtnode_GND)));
  qpt_l_Vb_ci_Vbi_ci=(+qj_2_Vb_ci_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qml_Vbi_ci)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qml_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vbi_ci*qj_2+qj_2_Vb_ci*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vbi_ci)+qml_Vb_ci_Vbi_ci)));
  qpt_l_Vb_ci_Vbi_ei=(+qj_2_Vb_ci_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qml_Vbi_ei)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qml_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vbi_ei*qj_2+qj_2_Vb_ci*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vbi_ei)+qml_Vb_ci_Vbi_ei)));
  qpt_l_Vb_ci_Vci_ei=(+qj_2_Vb_ci_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qml_Vci_ei)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qml_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vci_ei*qj_2+qj_2_Vb_ci*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vci_ei)+qml_Vb_ci_Vci_ei)));
#endif
#if defined(_DERIVATE)
qpt_l_Vtnode_GND=(qj_2_Vtnode_GND+(((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND))+qml_Vtnode_GND)*d10_sqrt0);
#endif
qpt_l_Vbi_ci=(qj_2_Vbi_ci+(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qml_Vbi_ci)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_l_Vbi_ci_Vb_ci=(+qj_2_Vbi_ci_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qml_Vb_ci)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qml_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vb_ci*qj_2+qj_2_Vbi_ci*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vb_ci)+qml_Vbi_ci_Vb_ci)));
  qpt_l_Vbi_ci_Vtnode_GND=(+qj_2_Vbi_ci_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qml_Vtnode_GND)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qml_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vtnode_GND*qj_2+qj_2_Vbi_ci*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vtnode_GND)+qml_Vbi_ci_Vtnode_GND)));
  qpt_l_Vbi_ci_Vbi_ci=(+qj_2_Vbi_ci_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qml_Vbi_ci)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qml_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vbi_ci*qj_2+qj_2_Vbi_ci*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vbi_ci)+qml_Vbi_ci_Vbi_ci)));
  qpt_l_Vbi_ci_Vbi_ei=(+qj_2_Vbi_ci_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qml_Vbi_ei)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qml_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vbi_ei*qj_2+qj_2_Vbi_ci*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vbi_ei)+qml_Vbi_ci_Vbi_ei)));
  qpt_l_Vbi_ci_Vci_ei=(+qj_2_Vbi_ci_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qml_Vci_ei)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qml_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vci_ei*qj_2+qj_2_Vbi_ci*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vci_ei)+qml_Vbi_ci_Vci_ei)));
#endif
qpt_l_Vbi_ei=(qj_2_Vbi_ei+(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qml_Vbi_ei)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_l_Vbi_ei_Vb_ci=(+qj_2_Vbi_ei_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qml_Vb_ci)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qml_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vb_ci*qj_2+qj_2_Vbi_ei*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vb_ci)+qml_Vbi_ei_Vb_ci)));
  qpt_l_Vbi_ei_Vtnode_GND=(+qj_2_Vbi_ei_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qml_Vtnode_GND)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qml_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vtnode_GND*qj_2+qj_2_Vbi_ei*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vtnode_GND)+qml_Vbi_ei_Vtnode_GND)));
  qpt_l_Vbi_ei_Vbi_ci=(+qj_2_Vbi_ei_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qml_Vbi_ci)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qml_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vbi_ci*qj_2+qj_2_Vbi_ei*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vbi_ci)+qml_Vbi_ei_Vbi_ci)));
  qpt_l_Vbi_ei_Vbi_ei=(+qj_2_Vbi_ei_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qml_Vbi_ei)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qml_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vbi_ei*qj_2+qj_2_Vbi_ei*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vbi_ei)+qml_Vbi_ei_Vbi_ei)));
  qpt_l_Vbi_ei_Vci_ei=(+qj_2_Vbi_ei_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qml_Vci_ei)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qml_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vci_ei*qj_2+qj_2_Vbi_ei*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vci_ei)+qml_Vbi_ei_Vci_ei)));
#endif
qpt_l_Vci_ei=(qj_2_Vci_ei+(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qml_Vci_ei)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_l_Vci_ei_Vb_ci=(+qj_2_Vci_ei_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qml_Vb_ci)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qml_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vb_ci*qj_2+qj_2_Vci_ei*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vb_ci)+qml_Vci_ei_Vb_ci)));
  qpt_l_Vci_ei_Vtnode_GND=(+qj_2_Vci_ei_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qml_Vtnode_GND)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qml_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vtnode_GND*qj_2+qj_2_Vci_ei*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vtnode_GND)+qml_Vci_ei_Vtnode_GND)));
  qpt_l_Vci_ei_Vbi_ci=(+qj_2_Vci_ei_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qml_Vbi_ci)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qml_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vbi_ci*qj_2+qj_2_Vci_ei*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vbi_ci)+qml_Vci_ei_Vbi_ci)));
  qpt_l_Vci_ei_Vbi_ei=(+qj_2_Vci_ei_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qml_Vbi_ei)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qml_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vbi_ei*qj_2+qj_2_Vci_ei*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vbi_ei)+qml_Vci_ei_Vbi_ei)));
  qpt_l_Vci_ei_Vci_ei=(+qj_2_Vci_ei_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qml))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qml_Vci_ei)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qml_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vci_ei*qj_2+qj_2_Vci_ei*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vci_ei)+qml_Vci_ei_Vci_ei)));
#endif
#endif
qpt_l=(qj_2+d00_sqrt0);
EXIT_IF_ISNAN((qj_2+d00_sqrt0))
}
{
double m00_sqrt(d00_sqrt0,((qj_2*qj_2)+qmh))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((qj_2*qj_2)+qmh))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qpt_h_Vb_ci=(qj_2_Vb_ci+(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qmh_Vb_ci)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_h_Vb_ci_Vb_ci=(+qj_2_Vb_ci_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qmh_Vb_ci)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qmh_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vb_ci*qj_2+qj_2_Vb_ci*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vb_ci)+qmh_Vb_ci_Vb_ci)));
  qpt_h_Vb_ci_Vtnode_GND=(+qj_2_Vb_ci_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qmh_Vtnode_GND)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qmh_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vtnode_GND*qj_2+qj_2_Vb_ci*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vtnode_GND)+qmh_Vb_ci_Vtnode_GND)));
  qpt_h_Vb_ci_Vbi_ci=(+qj_2_Vb_ci_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qmh_Vbi_ci)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qmh_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vbi_ci*qj_2+qj_2_Vb_ci*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vbi_ci)+qmh_Vb_ci_Vbi_ci)));
  qpt_h_Vb_ci_Vbi_ei=(+qj_2_Vb_ci_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qmh_Vbi_ei)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qmh_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vbi_ei*qj_2+qj_2_Vb_ci*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vbi_ei)+qmh_Vb_ci_Vbi_ei)));
  qpt_h_Vb_ci_Vci_ei=(+qj_2_Vb_ci_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qmh_Vci_ei)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qmh_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vci_ei*qj_2+qj_2_Vb_ci*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vci_ei)+qmh_Vb_ci_Vci_ei)));
#endif
#if defined(_DERIVATE)
qpt_h_Vtnode_GND=(qj_2_Vtnode_GND+(((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND))+qmh_Vtnode_GND)*d10_sqrt0);
#endif
qpt_h_Vbi_ci=(qj_2_Vbi_ci+(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qmh_Vbi_ci)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_h_Vbi_ci_Vb_ci=(+qj_2_Vbi_ci_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qmh_Vb_ci)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qmh_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vb_ci*qj_2+qj_2_Vbi_ci*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vb_ci)+qmh_Vbi_ci_Vb_ci)));
  qpt_h_Vbi_ci_Vtnode_GND=(+qj_2_Vbi_ci_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qmh_Vtnode_GND)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qmh_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vtnode_GND*qj_2+qj_2_Vbi_ci*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vtnode_GND)+qmh_Vbi_ci_Vtnode_GND)));
  qpt_h_Vbi_ci_Vbi_ci=(+qj_2_Vbi_ci_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qmh_Vbi_ci)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qmh_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vbi_ci*qj_2+qj_2_Vbi_ci*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vbi_ci)+qmh_Vbi_ci_Vbi_ci)));
  qpt_h_Vbi_ci_Vbi_ei=(+qj_2_Vbi_ci_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qmh_Vbi_ei)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qmh_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vbi_ei*qj_2+qj_2_Vbi_ci*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vbi_ei)+qmh_Vbi_ci_Vbi_ei)));
  qpt_h_Vbi_ci_Vci_ei=(+qj_2_Vbi_ci_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qmh_Vci_ei)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qmh_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vci_ei*qj_2+qj_2_Vbi_ci*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vci_ei)+qmh_Vbi_ci_Vci_ei)));
#endif
qpt_h_Vbi_ei=(qj_2_Vbi_ei+(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qmh_Vbi_ei)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_h_Vbi_ei_Vb_ci=(+qj_2_Vbi_ei_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qmh_Vb_ci)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qmh_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vb_ci*qj_2+qj_2_Vbi_ei*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vb_ci)+qmh_Vbi_ei_Vb_ci)));
  qpt_h_Vbi_ei_Vtnode_GND=(+qj_2_Vbi_ei_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qmh_Vtnode_GND)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qmh_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vtnode_GND*qj_2+qj_2_Vbi_ei*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vtnode_GND)+qmh_Vbi_ei_Vtnode_GND)));
  qpt_h_Vbi_ei_Vbi_ci=(+qj_2_Vbi_ei_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qmh_Vbi_ci)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qmh_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vbi_ci*qj_2+qj_2_Vbi_ei*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vbi_ci)+qmh_Vbi_ei_Vbi_ci)));
  qpt_h_Vbi_ei_Vbi_ei=(+qj_2_Vbi_ei_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qmh_Vbi_ei)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qmh_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vbi_ei*qj_2+qj_2_Vbi_ei*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vbi_ei)+qmh_Vbi_ei_Vbi_ei)));
  qpt_h_Vbi_ei_Vci_ei=(+qj_2_Vbi_ei_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qmh_Vci_ei)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qmh_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vci_ei*qj_2+qj_2_Vbi_ei*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vci_ei)+qmh_Vbi_ei_Vci_ei)));
#endif
qpt_h_Vci_ei=(qj_2_Vci_ei+(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qmh_Vci_ei)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_h_Vci_ei_Vb_ci=(+qj_2_Vci_ei_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qmh_Vb_ci)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qmh_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vb_ci*qj_2+qj_2_Vci_ei*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vb_ci)+qmh_Vci_ei_Vb_ci)));
  qpt_h_Vci_ei_Vtnode_GND=(+qj_2_Vci_ei_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qmh_Vtnode_GND)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qmh_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vtnode_GND*qj_2+qj_2_Vci_ei*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vtnode_GND)+qmh_Vci_ei_Vtnode_GND)));
  qpt_h_Vci_ei_Vbi_ci=(+qj_2_Vci_ei_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qmh_Vbi_ci)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qmh_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vbi_ci*qj_2+qj_2_Vci_ei*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vbi_ci)+qmh_Vci_ei_Vbi_ci)));
  qpt_h_Vci_ei_Vbi_ei=(+qj_2_Vci_ei_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qmh_Vbi_ei)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qmh_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vbi_ei*qj_2+qj_2_Vci_ei*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vbi_ei)+qmh_Vci_ei_Vbi_ei)));
  qpt_h_Vci_ei_Vci_ei=(+qj_2_Vci_ei_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qmh))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qmh_Vci_ei)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qmh_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vci_ei*qj_2+qj_2_Vci_ei*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vci_ei)+qmh_Vci_ei_Vci_ei)));
#endif
#endif
qpt_h=(qj_2+d00_sqrt0);
EXIT_IF_ISNAN((qj_2+d00_sqrt0))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
diff_q_Vtnode_GND=(qmh_Vtnode_GND-qml_Vtnode_GND);
diff_q_Vbi_ei=(qmh_Vbi_ei-qml_Vbi_ei);
diff_q_Vb_ci=(qmh_Vb_ci-qml_Vb_ci);
diff_q_Vbi_ci=(qmh_Vbi_ci-qml_Vbi_ci);
diff_q_Vci_ei=(qmh_Vci_ei-qml_Vci_ei);
#endif
diff_q=(qmh-qml);
EXIT_IF_ISNAN((qmh-qml))
{
double m00_fabs(d00_fabs0,diff_q)
if
((d00_fabs0>1e-8))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
a1_Vtnode_GND=(-(((((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*qpt_l)+(((ick/(1+ahq_t))/itfi)*qpt_l_Vtnode_GND)));
#endif
a1_Vci_ei=(-((((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l)+(((ick/(1+ahq_t))/itfi)*qpt_l_Vci_ei)));
#if defined(_DERIVATE2)
  a1_Vci_ei_Vtnode_GND=(+0.0-(+((ick_Vci_ei_Vtnode_GND/(1+ahq_t)-(ick_Vci_ei*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vtnode_GND/itfi/itfi/itfi)*qpt_l+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vtnode_GND+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*qpt_l_Vci_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vci_ei_Vtnode_GND));
  a1_Vci_ei_Vci_ei=(+0.0-(+((ick_Vci_ei_Vci_ei/(1+ahq_t)-(ick_Vci_ei*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*0.0+(ick_Vci_ei/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vci_ei+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vci_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vci_ei_Vci_ei));
  a1_Vci_ei_Vbi_ei=(+0.0-(+((0.0/(1+ahq_t)-(ick_Vci_ei*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*itfi_Vbi_ei+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vbi_ei/itfi/itfi/itfi)*qpt_l+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vbi_ei+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vci_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vci_ei_Vbi_ei));
  a1_Vci_ei_Vb_ci=(+0.0-(+((0.0/(1+ahq_t)-(ick_Vci_ei*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vb_ci+0.0*qpt_l_Vci_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vci_ei_Vb_ci));
  a1_Vci_ei_Vbi_ci=(+0.0-(+((0.0/(1+ahq_t)-(ick_Vci_ei*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vbi_ci+0.0*qpt_l_Vci_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vci_ei_Vbi_ci));
#endif
a1_Vbi_ei=(-(((-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l)+(((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ei)));
#if defined(_DERIVATE2)
  a1_Vbi_ei_Vtnode_GND=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*itfi_Vbi_ei+(ick/(1+ahq_t))*itfi_Vbi_ei_Vtnode_GND)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*itfi_Vtnode_GND/itfi/itfi/itfi)*qpt_l+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vtnode_GND+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*qpt_l_Vbi_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ei_Vtnode_GND));
  a1_Vbi_ei_Vci_ei=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+(ick_Vci_ei/(1+ahq_t))*itfi_Vbi_ei+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*0.0/itfi/itfi/itfi)*qpt_l+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vci_ei+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vbi_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ei_Vci_ei));
  a1_Vbi_ei_Vbi_ei=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vbi_ei+0.0*itfi_Vbi_ei+(ick/(1+ahq_t))*itfi_Vbi_ei_Vbi_ei)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*itfi_Vbi_ei/itfi/itfi/itfi)*qpt_l+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vbi_ei+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vbi_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ei_Vbi_ei));
  a1_Vbi_ei_Vb_ci=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*itfi_Vbi_ei+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*0.0/itfi/itfi/itfi)*qpt_l+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vb_ci+0.0*qpt_l_Vbi_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ei_Vb_ci));
  a1_Vbi_ei_Vbi_ci=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*itfi_Vbi_ei+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*0.0/itfi/itfi/itfi)*qpt_l+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vbi_ci+0.0*qpt_l_Vbi_ei+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ei_Vbi_ci));
#endif
a1_Vb_ci=(-(((ick/(1+ahq_t))/itfi)*qpt_l_Vb_ci));
#if defined(_DERIVATE2)
  a1_Vb_ci_Vtnode_GND=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vtnode_GND/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vtnode_GND+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*qpt_l_Vb_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vb_ci_Vtnode_GND));
  a1_Vb_ci_Vci_ei=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+(ick_Vci_ei/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vci_ei+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vb_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vb_ci_Vci_ei));
  a1_Vb_ci_Vbi_ei=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vbi_ei+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vbi_ei/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vbi_ei+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vb_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vb_ci_Vbi_ei));
  a1_Vb_ci_Vb_ci=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vb_ci+0.0*qpt_l_Vb_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vb_ci_Vb_ci));
  a1_Vb_ci_Vbi_ci=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vbi_ci+0.0*qpt_l_Vb_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vb_ci_Vbi_ci));
#endif
a1_Vbi_ci=(-(((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ci));
#if defined(_DERIVATE2)
  a1_Vbi_ci_Vtnode_GND=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vtnode_GND/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vtnode_GND+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*qpt_l_Vbi_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ci_Vtnode_GND));
  a1_Vbi_ci_Vci_ei=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+(ick_Vci_ei/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vci_ei+((ick_Vci_ei/(1+ahq_t))/itfi)*qpt_l_Vbi_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ci_Vci_ei));
  a1_Vbi_ci_Vbi_ei=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vbi_ei+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vbi_ei/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vbi_ei+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*qpt_l_Vbi_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ci_Vbi_ei));
  a1_Vbi_ci_Vb_ci=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vb_ci+0.0*qpt_l_Vbi_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ci_Vb_ci));
  a1_Vbi_ci_Vbi_ci=(+0.0-(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*qpt_l+0.0*qpt_l_Vbi_ci+0.0*qpt_l_Vbi_ci+((ick/(1+ahq_t))/itfi)*qpt_l_Vbi_ci_Vbi_ci));
#endif
#endif
a1=(1-(((ick/(1+ahq_t))/itfi)*qpt_l));
EXIT_IF_ISNAN((1-(((ick/(1+ahq_t))/itfi)*qpt_l)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
a2_Vtnode_GND=(((((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*(qpt_h-qpt_l))+(((ick/(1+ahq_t))/itfi)*(qpt_h_Vtnode_GND-qpt_l_Vtnode_GND)));
#endif
a2_Vci_ei=((((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h-qpt_l))+(((ick/(1+ahq_t))/itfi)*(qpt_h_Vci_ei-qpt_l_Vci_ei)));
#if defined(_DERIVATE2)
  a2_Vci_ei_Vtnode_GND=(+0.0+(+((ick_Vci_ei_Vtnode_GND/(1+ahq_t)-(ick_Vci_ei*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vtnode_GND/itfi/itfi/itfi)*(qpt_h-qpt_l)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vtnode_GND-qpt_l_Vtnode_GND)+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vci_ei_Vtnode_GND-qpt_l_Vci_ei_Vtnode_GND)));
  a2_Vci_ei_Vci_ei=(+0.0+(+((ick_Vci_ei_Vci_ei/(1+ahq_t)-(ick_Vci_ei*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*0.0+(ick_Vci_ei/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vci_ei_Vci_ei-qpt_l_Vci_ei_Vci_ei)));
  a2_Vci_ei_Vbi_ei=(+0.0+(+((0.0/(1+ahq_t)-(ick_Vci_ei*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*itfi_Vbi_ei+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vbi_ei/itfi/itfi/itfi)*(qpt_h-qpt_l)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vci_ei_Vbi_ei-qpt_l_Vci_ei_Vbi_ei)));
  a2_Vci_ei_Vb_ci=(+0.0+(+((0.0/(1+ahq_t)-(ick_Vci_ei*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vb_ci-qpt_l_Vb_ci)+0.0*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vci_ei_Vb_ci-qpt_l_Vci_ei_Vb_ci)));
  a2_Vci_ei_Vbi_ci=(+0.0+(+((0.0/(1+ahq_t)-(ick_Vci_ei*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-((ick_Vci_ei/(1+ahq_t))*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+0.0*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vci_ei_Vbi_ci-qpt_l_Vci_ei_Vbi_ci)));
#endif
a2_Vbi_ei=(((-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h-qpt_l))+(((ick/(1+ahq_t))/itfi)*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)));
#if defined(_DERIVATE2)
  a2_Vbi_ei_Vtnode_GND=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*itfi_Vbi_ei+(ick/(1+ahq_t))*itfi_Vbi_ei_Vtnode_GND)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*itfi_Vtnode_GND/itfi/itfi/itfi)*(qpt_h-qpt_l)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vtnode_GND-qpt_l_Vtnode_GND)+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ei_Vtnode_GND-qpt_l_Vbi_ei_Vtnode_GND)));
  a2_Vbi_ei_Vci_ei=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+(ick_Vci_ei/(1+ahq_t))*itfi_Vbi_ei+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ei_Vci_ei-qpt_l_Vbi_ei_Vci_ei)));
  a2_Vbi_ei_Vbi_ei=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vbi_ei+0.0*itfi_Vbi_ei+(ick/(1+ahq_t))*itfi_Vbi_ei_Vbi_ei)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*itfi_Vbi_ei/itfi/itfi/itfi)*(qpt_h-qpt_l)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ei_Vbi_ei-qpt_l_Vbi_ei_Vbi_ei)));
  a2_Vbi_ei_Vb_ci=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*itfi_Vbi_ei+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vb_ci-qpt_l_Vb_ci)+0.0*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ei_Vb_ci-qpt_l_Vbi_ei_Vb_ci)));
  a2_Vbi_ei_Vbi_ci=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*itfi_Vbi_ei+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*itfi_Vbi_ei*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+0.0*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ei_Vbi_ci-qpt_l_Vbi_ei_Vbi_ci)));
#endif
a2_Vb_ci=(((ick/(1+ahq_t))/itfi)*(qpt_h_Vb_ci-qpt_l_Vb_ci));
#if defined(_DERIVATE2)
  a2_Vb_ci_Vtnode_GND=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vtnode_GND/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vtnode_GND-qpt_l_Vtnode_GND)+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*(qpt_h_Vb_ci-qpt_l_Vb_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vb_ci_Vtnode_GND-qpt_l_Vb_ci_Vtnode_GND)));
  a2_Vb_ci_Vci_ei=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+(ick_Vci_ei/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vb_ci-qpt_l_Vb_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vb_ci_Vci_ei-qpt_l_Vb_ci_Vci_ei)));
  a2_Vb_ci_Vbi_ei=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vbi_ei+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vbi_ei/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vb_ci-qpt_l_Vb_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vb_ci_Vbi_ei-qpt_l_Vb_ci_Vbi_ei)));
  a2_Vb_ci_Vb_ci=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vb_ci-qpt_l_Vb_ci)+0.0*(qpt_h_Vb_ci-qpt_l_Vb_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vb_ci_Vb_ci-qpt_l_Vb_ci_Vb_ci)));
  a2_Vb_ci_Vbi_ci=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+0.0*(qpt_h_Vb_ci-qpt_l_Vb_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vb_ci_Vbi_ci-qpt_l_Vb_ci_Vbi_ci)));
#endif
a2_Vbi_ci=(((ick/(1+ahq_t))/itfi)*(qpt_h_Vbi_ci-qpt_l_Vbi_ci));
#if defined(_DERIVATE2)
  a2_Vbi_ci_Vtnode_GND=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vtnode_GND*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vtnode_GND+(ick_Vtnode_GND/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vtnode_GND/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vtnode_GND-qpt_l_Vtnode_GND)+(((ick_Vtnode_GND/(1+ahq_t))*itfi-(ick/(1+ahq_t))*itfi_Vtnode_GND)/itfi/itfi)*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ci_Vtnode_GND-qpt_l_Vbi_ci_Vtnode_GND)));
  a2_Vbi_ci_Vci_ei=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+ick_Vci_ei*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+(ick_Vci_ei/(1+ahq_t))*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vci_ei-qpt_l_Vci_ei)+((ick_Vci_ei/(1+ahq_t))/itfi)*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ci_Vci_ei-qpt_l_Vbi_ci_Vci_ei)));
  a2_Vbi_ci_Vbi_ei=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*itfi_Vbi_ei+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*itfi_Vbi_ei/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vbi_ei-qpt_l_Vbi_ei)+(-(ick/(1+ahq_t))*itfi_Vbi_ei/itfi/itfi)*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ci_Vbi_ei-qpt_l_Vbi_ci_Vbi_ei)));
  a2_Vbi_ci_Vb_ci=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vb_ci-qpt_l_Vb_ci)+0.0*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ci_Vb_ci-qpt_l_Vbi_ci_Vb_ci)));
  a2_Vbi_ci_Vbi_ci=(+0.0+(+((0.0/(1+ahq_t)-(0.0*0.0+0.0*0.0+ick*(+0.0+0.0))/(1+ahq_t)/(1+ahq_t)+2*ick*0.0*0.0/(1+ahq_t)/(1+ahq_t)/(1+ahq_t))/itfi-(0.0*0.0+0.0*0.0+(ick/(1+ahq_t))*0.0)/itfi/itfi+2*(ick/(1+ahq_t))*0.0*0.0/itfi/itfi/itfi)*(qpt_h-qpt_l)+0.0*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+0.0*(qpt_h_Vbi_ci-qpt_l_Vbi_ci)+((ick/(1+ahq_t))/itfi)*(+qpt_h_Vbi_ci_Vbi_ci-qpt_l_Vbi_ci_Vbi_ci)));
#endif
#endif
a2=(1+(((ick/(1+ahq_t))/itfi)*(qpt_h-qpt_l)));
EXIT_IF_ISNAN((1+(((ick/(1+ahq_t))/itfi)*(qpt_h-qpt_l))))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
aa_Vtnode_GND=((a1_Vtnode_GND*a2-a1*a2_Vtnode_GND)/a2/a2);
#endif
aa_Vci_ei=((a1_Vci_ei*a2-a1*a2_Vci_ei)/a2/a2);
#if defined(_DERIVATE2)
  aa_Vci_ei_Vtnode_GND=(a1_Vci_ei_Vtnode_GND/a2-(a1_Vci_ei*a2_Vtnode_GND+a1_Vtnode_GND*a2_Vci_ei+a1*a2_Vci_ei_Vtnode_GND)/a2/a2+2*a1*a2_Vci_ei*a2_Vtnode_GND/a2/a2/a2);
  aa_Vci_ei_Vci_ei=(a1_Vci_ei_Vci_ei/a2-(a1_Vci_ei*a2_Vci_ei+a1_Vci_ei*a2_Vci_ei+a1*a2_Vci_ei_Vci_ei)/a2/a2+2*a1*a2_Vci_ei*a2_Vci_ei/a2/a2/a2);
  aa_Vci_ei_Vbi_ei=(a1_Vci_ei_Vbi_ei/a2-(a1_Vci_ei*a2_Vbi_ei+a1_Vbi_ei*a2_Vci_ei+a1*a2_Vci_ei_Vbi_ei)/a2/a2+2*a1*a2_Vci_ei*a2_Vbi_ei/a2/a2/a2);
  aa_Vci_ei_Vb_ci=(a1_Vci_ei_Vb_ci/a2-(a1_Vci_ei*a2_Vb_ci+a1_Vb_ci*a2_Vci_ei+a1*a2_Vci_ei_Vb_ci)/a2/a2+2*a1*a2_Vci_ei*a2_Vb_ci/a2/a2/a2);
  aa_Vci_ei_Vbi_ci=(a1_Vci_ei_Vbi_ci/a2-(a1_Vci_ei*a2_Vbi_ci+a1_Vbi_ci*a2_Vci_ei+a1*a2_Vci_ei_Vbi_ci)/a2/a2+2*a1*a2_Vci_ei*a2_Vbi_ci/a2/a2/a2);
#endif
aa_Vbi_ei=((a1_Vbi_ei*a2-a1*a2_Vbi_ei)/a2/a2);
#if defined(_DERIVATE2)
  aa_Vbi_ei_Vtnode_GND=(a1_Vbi_ei_Vtnode_GND/a2-(a1_Vbi_ei*a2_Vtnode_GND+a1_Vtnode_GND*a2_Vbi_ei+a1*a2_Vbi_ei_Vtnode_GND)/a2/a2+2*a1*a2_Vbi_ei*a2_Vtnode_GND/a2/a2/a2);
  aa_Vbi_ei_Vci_ei=(a1_Vbi_ei_Vci_ei/a2-(a1_Vbi_ei*a2_Vci_ei+a1_Vci_ei*a2_Vbi_ei+a1*a2_Vbi_ei_Vci_ei)/a2/a2+2*a1*a2_Vbi_ei*a2_Vci_ei/a2/a2/a2);
  aa_Vbi_ei_Vbi_ei=(a1_Vbi_ei_Vbi_ei/a2-(a1_Vbi_ei*a2_Vbi_ei+a1_Vbi_ei*a2_Vbi_ei+a1*a2_Vbi_ei_Vbi_ei)/a2/a2+2*a1*a2_Vbi_ei*a2_Vbi_ei/a2/a2/a2);
  aa_Vbi_ei_Vb_ci=(a1_Vbi_ei_Vb_ci/a2-(a1_Vbi_ei*a2_Vb_ci+a1_Vb_ci*a2_Vbi_ei+a1*a2_Vbi_ei_Vb_ci)/a2/a2+2*a1*a2_Vbi_ei*a2_Vb_ci/a2/a2/a2);
  aa_Vbi_ei_Vbi_ci=(a1_Vbi_ei_Vbi_ci/a2-(a1_Vbi_ei*a2_Vbi_ci+a1_Vbi_ci*a2_Vbi_ei+a1*a2_Vbi_ei_Vbi_ci)/a2/a2+2*a1*a2_Vbi_ei*a2_Vbi_ci/a2/a2/a2);
#endif
aa_Vb_ci=((a1_Vb_ci*a2-a1*a2_Vb_ci)/a2/a2);
#if defined(_DERIVATE2)
  aa_Vb_ci_Vtnode_GND=(a1_Vb_ci_Vtnode_GND/a2-(a1_Vb_ci*a2_Vtnode_GND+a1_Vtnode_GND*a2_Vb_ci+a1*a2_Vb_ci_Vtnode_GND)/a2/a2+2*a1*a2_Vb_ci*a2_Vtnode_GND/a2/a2/a2);
  aa_Vb_ci_Vci_ei=(a1_Vb_ci_Vci_ei/a2-(a1_Vb_ci*a2_Vci_ei+a1_Vci_ei*a2_Vb_ci+a1*a2_Vb_ci_Vci_ei)/a2/a2+2*a1*a2_Vb_ci*a2_Vci_ei/a2/a2/a2);
  aa_Vb_ci_Vbi_ei=(a1_Vb_ci_Vbi_ei/a2-(a1_Vb_ci*a2_Vbi_ei+a1_Vbi_ei*a2_Vb_ci+a1*a2_Vb_ci_Vbi_ei)/a2/a2+2*a1*a2_Vb_ci*a2_Vbi_ei/a2/a2/a2);
  aa_Vb_ci_Vb_ci=(a1_Vb_ci_Vb_ci/a2-(a1_Vb_ci*a2_Vb_ci+a1_Vb_ci*a2_Vb_ci+a1*a2_Vb_ci_Vb_ci)/a2/a2+2*a1*a2_Vb_ci*a2_Vb_ci/a2/a2/a2);
  aa_Vb_ci_Vbi_ci=(a1_Vb_ci_Vbi_ci/a2-(a1_Vb_ci*a2_Vbi_ci+a1_Vbi_ci*a2_Vb_ci+a1*a2_Vb_ci_Vbi_ci)/a2/a2+2*a1*a2_Vb_ci*a2_Vbi_ci/a2/a2/a2);
#endif
aa_Vbi_ci=((a1_Vbi_ci*a2-a1*a2_Vbi_ci)/a2/a2);
#if defined(_DERIVATE2)
  aa_Vbi_ci_Vtnode_GND=(a1_Vbi_ci_Vtnode_GND/a2-(a1_Vbi_ci*a2_Vtnode_GND+a1_Vtnode_GND*a2_Vbi_ci+a1*a2_Vbi_ci_Vtnode_GND)/a2/a2+2*a1*a2_Vbi_ci*a2_Vtnode_GND/a2/a2/a2);
  aa_Vbi_ci_Vci_ei=(a1_Vbi_ci_Vci_ei/a2-(a1_Vbi_ci*a2_Vci_ei+a1_Vci_ei*a2_Vbi_ci+a1*a2_Vbi_ci_Vci_ei)/a2/a2+2*a1*a2_Vbi_ci*a2_Vci_ei/a2/a2/a2);
  aa_Vbi_ci_Vbi_ei=(a1_Vbi_ci_Vbi_ei/a2-(a1_Vbi_ci*a2_Vbi_ei+a1_Vbi_ei*a2_Vbi_ci+a1*a2_Vbi_ci_Vbi_ei)/a2/a2+2*a1*a2_Vbi_ci*a2_Vbi_ei/a2/a2/a2);
  aa_Vbi_ci_Vb_ci=(a1_Vbi_ci_Vb_ci/a2-(a1_Vbi_ci*a2_Vb_ci+a1_Vb_ci*a2_Vbi_ci+a1*a2_Vbi_ci_Vb_ci)/a2/a2+2*a1*a2_Vbi_ci*a2_Vb_ci/a2/a2/a2);
  aa_Vbi_ci_Vbi_ci=(a1_Vbi_ci_Vbi_ci/a2-(a1_Vbi_ci*a2_Vbi_ci+a1_Vbi_ci*a2_Vbi_ci+a1*a2_Vbi_ci_Vbi_ci)/a2/a2+2*a1*a2_Vbi_ci*a2_Vbi_ci/a2/a2/a2);
#endif
#endif
aa=(a1/a2);
EXIT_IF_ISNAN((a1/a2))
{
double m00_sqrt(d00_sqrt0,((aa*aa)+0.01))
double m00_sqrt(d00_sqrt1,(1+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((aa*aa)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
wdc_Vtnode_GND=((((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND))*d10_sqrt0+aa_Vtnode_GND)/(1+d00_sqrt1));
#endif
wdc_Vci_ei=((((aa_Vci_ei*aa)+(aa*aa_Vci_ei))*d10_sqrt0+aa_Vci_ei)/(1+d00_sqrt1));
#if defined(_DERIVATE2)
  wdc_Vci_ei_Vtnode_GND=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*((aa_Vci_ei*aa)+(aa*aa_Vci_ei))+d10_sqrt0*(+(+aa_Vci_ei_Vtnode_GND*aa+aa_Vci_ei*aa_Vtnode_GND+aa_Vtnode_GND*aa_Vci_ei+aa*aa_Vci_ei_Vtnode_GND)+0.0))+aa_Vci_ei_Vtnode_GND)/(1+d00_sqrt1)-((((aa_Vci_ei*aa)+(aa*aa_Vci_ei))*d10_sqrt0+aa_Vci_ei)*0.0+((((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*d10_sqrt0+aa_Vtnode_GND)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vci_ei_Vci_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*((aa_Vci_ei*aa)+(aa*aa_Vci_ei))+d10_sqrt0*(+(+aa_Vci_ei_Vci_ei*aa+aa_Vci_ei*aa_Vci_ei+aa_Vci_ei*aa_Vci_ei+aa*aa_Vci_ei_Vci_ei)+0.0))+aa_Vci_ei_Vci_ei)/(1+d00_sqrt1)-((((aa_Vci_ei*aa)+(aa*aa_Vci_ei))*d10_sqrt0+aa_Vci_ei)*0.0+((((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*d10_sqrt0+aa_Vci_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vci_ei_Vbi_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*((aa_Vci_ei*aa)+(aa*aa_Vci_ei))+d10_sqrt0*(+(+aa_Vci_ei_Vbi_ei*aa+aa_Vci_ei*aa_Vbi_ei+aa_Vbi_ei*aa_Vci_ei+aa*aa_Vci_ei_Vbi_ei)+0.0))+aa_Vci_ei_Vbi_ei)/(1+d00_sqrt1)-((((aa_Vci_ei*aa)+(aa*aa_Vci_ei))*d10_sqrt0+aa_Vci_ei)*0.0+((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*d10_sqrt0+aa_Vbi_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vci_ei_Vb_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*((aa_Vci_ei*aa)+(aa*aa_Vci_ei))+d10_sqrt0*(+(+aa_Vci_ei_Vb_ci*aa+aa_Vci_ei*aa_Vb_ci+aa_Vb_ci*aa_Vci_ei+aa*aa_Vci_ei_Vb_ci)+0.0))+aa_Vci_ei_Vb_ci)/(1+d00_sqrt1)-((((aa_Vci_ei*aa)+(aa*aa_Vci_ei))*d10_sqrt0+aa_Vci_ei)*0.0+((((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*d10_sqrt0+aa_Vb_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vci_ei_Vbi_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*((aa_Vci_ei*aa)+(aa*aa_Vci_ei))+d10_sqrt0*(+(+aa_Vci_ei_Vbi_ci*aa+aa_Vci_ei*aa_Vbi_ci+aa_Vbi_ci*aa_Vci_ei+aa*aa_Vci_ei_Vbi_ci)+0.0))+aa_Vci_ei_Vbi_ci)/(1+d00_sqrt1)-((((aa_Vci_ei*aa)+(aa*aa_Vci_ei))*d10_sqrt0+aa_Vci_ei)*0.0+((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*d10_sqrt0+aa_Vbi_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
#endif
wdc_Vbi_ei=((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))*d10_sqrt0+aa_Vbi_ei)/(1+d00_sqrt1));
#if defined(_DERIVATE2)
  wdc_Vbi_ei_Vtnode_GND=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))+d10_sqrt0*(+(+aa_Vbi_ei_Vtnode_GND*aa+aa_Vbi_ei*aa_Vtnode_GND+aa_Vtnode_GND*aa_Vbi_ei+aa*aa_Vbi_ei_Vtnode_GND)+0.0))+aa_Vbi_ei_Vtnode_GND)/(1+d00_sqrt1)-((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))*d10_sqrt0+aa_Vbi_ei)*0.0+((((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*d10_sqrt0+aa_Vtnode_GND)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ei_Vci_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))+d10_sqrt0*(+(+aa_Vbi_ei_Vci_ei*aa+aa_Vbi_ei*aa_Vci_ei+aa_Vci_ei*aa_Vbi_ei+aa*aa_Vbi_ei_Vci_ei)+0.0))+aa_Vbi_ei_Vci_ei)/(1+d00_sqrt1)-((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))*d10_sqrt0+aa_Vbi_ei)*0.0+((((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*d10_sqrt0+aa_Vci_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ei_Vbi_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))+d10_sqrt0*(+(+aa_Vbi_ei_Vbi_ei*aa+aa_Vbi_ei*aa_Vbi_ei+aa_Vbi_ei*aa_Vbi_ei+aa*aa_Vbi_ei_Vbi_ei)+0.0))+aa_Vbi_ei_Vbi_ei)/(1+d00_sqrt1)-((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))*d10_sqrt0+aa_Vbi_ei)*0.0+((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*d10_sqrt0+aa_Vbi_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ei_Vb_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))+d10_sqrt0*(+(+aa_Vbi_ei_Vb_ci*aa+aa_Vbi_ei*aa_Vb_ci+aa_Vb_ci*aa_Vbi_ei+aa*aa_Vbi_ei_Vb_ci)+0.0))+aa_Vbi_ei_Vb_ci)/(1+d00_sqrt1)-((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))*d10_sqrt0+aa_Vbi_ei)*0.0+((((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*d10_sqrt0+aa_Vb_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ei_Vbi_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))+d10_sqrt0*(+(+aa_Vbi_ei_Vbi_ci*aa+aa_Vbi_ei*aa_Vbi_ci+aa_Vbi_ci*aa_Vbi_ei+aa*aa_Vbi_ei_Vbi_ci)+0.0))+aa_Vbi_ei_Vbi_ci)/(1+d00_sqrt1)-((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei))*d10_sqrt0+aa_Vbi_ei)*0.0+((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*d10_sqrt0+aa_Vbi_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
#endif
wdc_Vb_ci=((((aa_Vb_ci*aa)+(aa*aa_Vb_ci))*d10_sqrt0+aa_Vb_ci)/(1+d00_sqrt1));
#if defined(_DERIVATE2)
  wdc_Vb_ci_Vtnode_GND=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*((aa_Vb_ci*aa)+(aa*aa_Vb_ci))+d10_sqrt0*(+(+aa_Vb_ci_Vtnode_GND*aa+aa_Vb_ci*aa_Vtnode_GND+aa_Vtnode_GND*aa_Vb_ci+aa*aa_Vb_ci_Vtnode_GND)+0.0))+aa_Vb_ci_Vtnode_GND)/(1+d00_sqrt1)-((((aa_Vb_ci*aa)+(aa*aa_Vb_ci))*d10_sqrt0+aa_Vb_ci)*0.0+((((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*d10_sqrt0+aa_Vtnode_GND)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vb_ci_Vci_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*((aa_Vb_ci*aa)+(aa*aa_Vb_ci))+d10_sqrt0*(+(+aa_Vb_ci_Vci_ei*aa+aa_Vb_ci*aa_Vci_ei+aa_Vci_ei*aa_Vb_ci+aa*aa_Vb_ci_Vci_ei)+0.0))+aa_Vb_ci_Vci_ei)/(1+d00_sqrt1)-((((aa_Vb_ci*aa)+(aa*aa_Vb_ci))*d10_sqrt0+aa_Vb_ci)*0.0+((((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*d10_sqrt0+aa_Vci_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vb_ci_Vbi_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*((aa_Vb_ci*aa)+(aa*aa_Vb_ci))+d10_sqrt0*(+(+aa_Vb_ci_Vbi_ei*aa+aa_Vb_ci*aa_Vbi_ei+aa_Vbi_ei*aa_Vb_ci+aa*aa_Vb_ci_Vbi_ei)+0.0))+aa_Vb_ci_Vbi_ei)/(1+d00_sqrt1)-((((aa_Vb_ci*aa)+(aa*aa_Vb_ci))*d10_sqrt0+aa_Vb_ci)*0.0+((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*d10_sqrt0+aa_Vbi_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vb_ci_Vb_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*((aa_Vb_ci*aa)+(aa*aa_Vb_ci))+d10_sqrt0*(+(+aa_Vb_ci_Vb_ci*aa+aa_Vb_ci*aa_Vb_ci+aa_Vb_ci*aa_Vb_ci+aa*aa_Vb_ci_Vb_ci)+0.0))+aa_Vb_ci_Vb_ci)/(1+d00_sqrt1)-((((aa_Vb_ci*aa)+(aa*aa_Vb_ci))*d10_sqrt0+aa_Vb_ci)*0.0+((((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*d10_sqrt0+aa_Vb_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vb_ci_Vbi_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*((aa_Vb_ci*aa)+(aa*aa_Vb_ci))+d10_sqrt0*(+(+aa_Vb_ci_Vbi_ci*aa+aa_Vb_ci*aa_Vbi_ci+aa_Vbi_ci*aa_Vb_ci+aa*aa_Vb_ci_Vbi_ci)+0.0))+aa_Vb_ci_Vbi_ci)/(1+d00_sqrt1)-((((aa_Vb_ci*aa)+(aa*aa_Vb_ci))*d10_sqrt0+aa_Vb_ci)*0.0+((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*d10_sqrt0+aa_Vbi_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
#endif
wdc_Vbi_ci=((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))*d10_sqrt0+aa_Vbi_ci)/(1+d00_sqrt1));
#if defined(_DERIVATE2)
  wdc_Vbi_ci_Vtnode_GND=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))+d10_sqrt0*(+(+aa_Vbi_ci_Vtnode_GND*aa+aa_Vbi_ci*aa_Vtnode_GND+aa_Vtnode_GND*aa_Vbi_ci+aa*aa_Vbi_ci_Vtnode_GND)+0.0))+aa_Vbi_ci_Vtnode_GND)/(1+d00_sqrt1)-((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))*d10_sqrt0+aa_Vbi_ci)*0.0+((((aa_Vtnode_GND*aa)+(aa*aa_Vtnode_GND)))*d10_sqrt0+aa_Vtnode_GND)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ci_Vci_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))+d10_sqrt0*(+(+aa_Vbi_ci_Vci_ei*aa+aa_Vbi_ci*aa_Vci_ei+aa_Vci_ei*aa_Vbi_ci+aa*aa_Vbi_ci_Vci_ei)+0.0))+aa_Vbi_ci_Vci_ei)/(1+d00_sqrt1)-((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))*d10_sqrt0+aa_Vbi_ci)*0.0+((((aa_Vci_ei*aa)+(aa*aa_Vci_ei)))*d10_sqrt0+aa_Vci_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ci_Vbi_ei=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))+d10_sqrt0*(+(+aa_Vbi_ci_Vbi_ei*aa+aa_Vbi_ci*aa_Vbi_ei+aa_Vbi_ei*aa_Vbi_ci+aa*aa_Vbi_ci_Vbi_ei)+0.0))+aa_Vbi_ci_Vbi_ei)/(1+d00_sqrt1)-((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))*d10_sqrt0+aa_Vbi_ci)*0.0+((((aa_Vbi_ei*aa)+(aa*aa_Vbi_ei)))*d10_sqrt0+aa_Vbi_ei)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ci_Vb_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))+d10_sqrt0*(+(+aa_Vbi_ci_Vb_ci*aa+aa_Vbi_ci*aa_Vb_ci+aa_Vb_ci*aa_Vbi_ci+aa*aa_Vbi_ci_Vb_ci)+0.0))+aa_Vbi_ci_Vb_ci)/(1+d00_sqrt1)-((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))*d10_sqrt0+aa_Vbi_ci)*0.0+((((aa_Vb_ci*aa)+(aa*aa_Vb_ci)))*d10_sqrt0+aa_Vb_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
  wdc_Vbi_ci_Vbi_ci=((+(m20_sqrt(((aa*aa)+0.01))*(((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))+d10_sqrt0*(+(+aa_Vbi_ci_Vbi_ci*aa+aa_Vbi_ci*aa_Vbi_ci+aa_Vbi_ci*aa_Vbi_ci+aa*aa_Vbi_ci_Vbi_ci)+0.0))+aa_Vbi_ci_Vbi_ci)/(1+d00_sqrt1)-((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci))*d10_sqrt0+aa_Vbi_ci)*0.0+((((aa_Vbi_ci*aa)+(aa*aa_Vbi_ci)))*d10_sqrt0+aa_Vbi_ci)*0.0+(d00_sqrt0+aa)*(+0.0+0.0))/(1+d00_sqrt1)/(1+d00_sqrt1)+2*(d00_sqrt0+aa)*0.0*0.0/(1+d00_sqrt1)/(1+d00_sqrt1)/(1+d00_sqrt1));
#endif
#endif
wdc=((d00_sqrt0+aa)/(1+d00_sqrt1));
EXIT_IF_ISNAN(((d00_sqrt0+aa)/(1+d00_sqrt1)))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
wdc_Vtnode_GND=0.0;
#endif
wdc_Vci_ei=0.0;
#if defined(_DERIVATE2)
  wdc_Vci_ei_Vtnode_GND=0.0;
  wdc_Vci_ei_Vci_ei=0.0;
  wdc_Vci_ei_Vbi_ei=0.0;
  wdc_Vci_ei_Vb_ci=0.0;
  wdc_Vci_ei_Vbi_ci=0.0;
#endif
wdc_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  wdc_Vbi_ei_Vtnode_GND=0.0;
  wdc_Vbi_ei_Vci_ei=0.0;
  wdc_Vbi_ei_Vbi_ei=0.0;
  wdc_Vbi_ei_Vb_ci=0.0;
  wdc_Vbi_ei_Vbi_ci=0.0;
#endif
wdc_Vb_ci=0.0;
#if defined(_DERIVATE2)
  wdc_Vb_ci_Vtnode_GND=0.0;
  wdc_Vb_ci_Vci_ei=0.0;
  wdc_Vb_ci_Vbi_ei=0.0;
  wdc_Vb_ci_Vb_ci=0.0;
  wdc_Vb_ci_Vbi_ci=0.0;
#endif
wdc_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  wdc_Vbi_ci_Vtnode_GND=0.0;
  wdc_Vbi_ci_Vci_ei=0.0;
  wdc_Vbi_ci_Vbi_ei=0.0;
  wdc_Vbi_ci_Vb_ci=0.0;
  wdc_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
wdc=0;
EXIT_IF_ISNAN(0)
}
}
if
((pModel->it_mod==0))
{
if
((pModel->tfh!=0))
{
{
double m00_logE(d00_logE0,((itfi*(itfi/ick))*(tfh_t/iqfh_t)))
double m00_exp(d00_exp1,(0.6666*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((itfi*(itfi/ick))*(tfh_t/iqfh_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qm_Vtnode_GND=(((((itfi_Vtnode_GND*ickf-itfi*ickf_Vtnode_GND)/ickf/ickf)+(itri_Vtnode_GND/ickr))+((((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND))*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vtnode_GND)))+(0.6666*((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)))*d10_logE0)*d10_exp1);
#endif
qm_Vbi_ei=(((itfi_Vbi_ei/ickf)+(((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vbi_ei)))+(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  qm_Vbi_ei_Vtnode_GND=(+(+(+(itfi_Vbi_ei_Vtnode_GND/ickf-(itfi_Vbi_ei*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(itfi_Vbi_ei_Vtnode_GND/iqfh_t-(itfi_Vbi_ei*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vtnode_GND)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vtnode_GND))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+itfi_Vbi_ei_Vtnode_GND*(itfi/ick)+itfi_Vbi_ei*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)+itfi_Vtnode_GND*(itfi_Vbi_ei/ick)+itfi*(itfi_Vbi_ei_Vtnode_GND/ick-(itfi_Vbi_ei*ick_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*ick_Vtnode_GND/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)+(((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+tfh_t_Vtnode_GND*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vbi_ei_Vbi_ei=(+(+(+(itfi_Vbi_ei_Vbi_ei/ickf-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(itfi_Vbi_ei_Vbi_ei/iqfh_t-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vbi_ei)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vbi_ei))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+itfi_Vbi_ei_Vbi_ei*(itfi/ick)+itfi_Vbi_ei*(itfi_Vbi_ei/ick)+itfi_Vbi_ei*(itfi_Vbi_ei/ick)+itfi*(itfi_Vbi_ei_Vbi_ei/ick-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vbi_ei_Vb_ci=(+(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vb_ci+0.0*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vb_ci)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vb_ci))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*0.0+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vbi_ei_Vbi_ci=(+(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ci+0.0*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vbi_ci)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vbi_ci))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*0.0+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vbi_ei_Vci_ei=(+(+(+(0.0/ickf-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vci_ei+0.0*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vci_ei)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vci_ei))+(m20_exp((0.6666*d00_logE0))*((0.6666*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0+0.0*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+itfi_Vbi_ei*(-itfi*ick_Vci_ei/ick/ick)+0.0*(itfi_Vbi_ei/ick)+itfi*(0.0/ick-(itfi_Vbi_ei*ick_Vci_ei+0.0*0.0+itfi*0.0)/ick/ick+2*itfi*0.0*ick_Vci_ei/ick/ick/ick))*(tfh_t/iqfh_t)+((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick)))*0.0+((itfi*(-itfi*ick_Vci_ei/ick/ick)))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
#endif
qm_Vb_ci=((-itfi*ickf_Vb_ci/ickf/ickf)+((((itfi/iqfh_t)*wdc_Vb_ci)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vb_ci)));
#if defined(_DERIVATE2)
  qm_Vb_ci_Vtnode_GND=(+(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vb_ci+itfi*ickf_Vb_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vtnode_GND)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vtnode_GND))+0.0);
  qm_Vb_ci_Vbi_ei=(+(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vbi_ei)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vbi_ei))+0.0);
  qm_Vb_ci_Vb_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vb_ci+0.0*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vb_ci)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vb_ci))+0.0);
  qm_Vb_ci_Vbi_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ci+0.0*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vbi_ci)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vbi_ci))+0.0);
  qm_Vb_ci_Vci_ei=(+(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vci_ei+0.0*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vci_ei)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vci_ei))+0.0);
#endif
qm_Vbi_ci=(((-itfi*ickf_Vbi_ci/ickf/ickf)+(itri_Vbi_ci/ickr))+((((itfi/iqfh_t)*wdc_Vbi_ci)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vbi_ci)));
#if defined(_DERIVATE2)
  qm_Vbi_ci_Vtnode_GND=(+(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(itri_Vbi_ci_Vtnode_GND/ickr-(itri_Vbi_ci*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vtnode_GND)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vtnode_GND))+0.0);
  qm_Vbi_ci_Vbi_ei=(+(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vbi_ei)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vbi_ei))+0.0);
  qm_Vbi_ci_Vb_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vb_ci+0.0*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vb_ci)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vb_ci))+0.0);
  qm_Vbi_ci_Vbi_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(itri_Vbi_ci_Vbi_ci/ickr-(itri_Vbi_ci*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ci+0.0*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vbi_ci)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vbi_ci))+0.0);
  qm_Vbi_ci_Vci_ei=(+(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vci_ei+0.0*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vci_ei)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vci_ei))+0.0);
#endif
qm_Vci_ei=(((((itfi/iqfh_t)*wdc_Vci_ei)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vci_ei))+(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  qm_Vci_ei_Vtnode_GND=(+(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vtnode_GND)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vtnode_GND))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*(tfh_t/iqfh_t))+((itfi*(itfi/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t))))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick)+itfi_Vtnode_GND*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*ick_Vtnode_GND+itfi_Vtnode_GND*ick_Vci_ei+itfi*ick_Vci_ei_Vtnode_GND)/ick/ick+2*itfi*ick_Vci_ei*ick_Vtnode_GND/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*((tfh_t_Vtnode_GND*iqfh_t-tfh_t*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)+(((itfi_Vtnode_GND*(itfi/ick))+(itfi*((itfi_Vtnode_GND*ick-itfi*ick_Vtnode_GND)/ick/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+tfh_t_Vtnode_GND*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vci_ei_Vbi_ei=(+(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vbi_ei)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vbi_ei))+(m20_exp((0.6666*d00_logE0))*((0.6666*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*(itfi_Vbi_ei/ick)+itfi_Vbi_ei*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+itfi_Vbi_ei*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(((itfi_Vbi_ei*(itfi/ick))+(itfi*(itfi_Vbi_ei/ick))))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vci_ei_Vb_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vb_ci+0.0*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vb_ci)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vb_ci))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*0.0+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+0.0*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vci_ei_Vbi_ci=(+(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ci+0.0*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vbi_ci)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vbi_ci))+(m20_exp((0.6666*d00_logE0))*((0.6666*((0.0)*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((0.0)*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*((0.0)*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*0.0+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*0.0+0.0*ick_Vci_ei+itfi*0.0)/ick/ick+2*itfi*ick_Vci_ei*0.0/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+(0.0)*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
  qm_Vci_ei_Vci_ei=(+(+(+(0.0/ickf-(0.0*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vci_ei+0.0*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vci_ei)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vci_ei))+(m20_exp((0.6666*d00_logE0))*((0.6666*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0))*(0.6666*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*d10_logE0+0.0*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)*d10_logE0+0.6666*(m20_logE(((itfi*(itfi/ick))*(tfh_t/iqfh_t)))*(((itfi*(-itfi*ick_Vci_ei/ick/ick)))*(tfh_t/iqfh_t))*(itfi*(-itfi*ick_Vci_ei/ick/ick))*(tfh_t/iqfh_t)+d10_logE0*(+(+0.0*(itfi/ick)+0.0*(-itfi*ick_Vci_ei/ick/ick)+0.0*(-itfi*ick_Vci_ei/ick/ick)+itfi*(0.0/ick-(0.0*ick_Vci_ei+0.0*ick_Vci_ei+itfi*ick_Vci_ei_Vci_ei)/ick/ick+2*itfi*ick_Vci_ei*ick_Vci_ei/ick/ick/ick))*(tfh_t/iqfh_t)+(itfi*(-itfi*ick_Vci_ei/ick/ick))*0.0+((itfi*(-itfi*ick_Vci_ei/ick/ick)))*0.0+(itfi*(itfi/ick))*(0.0/iqfh_t-(0.0*0.0+0.0*0.0+tfh_t*0.0)/iqfh_t/iqfh_t+2*tfh_t*0.0*0.0/iqfh_t/iqfh_t/iqfh_t))))));
#endif
#endif
qm=((((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc))+d00_exp1);
EXIT_IF_ISNAN(((((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc))+d00_exp1))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qm_Vtnode_GND=((((itfi_Vtnode_GND*ickf-itfi*ickf_Vtnode_GND)/ickf/ickf)+(itri_Vtnode_GND/ickr))+((((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND))*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vtnode_GND)));
#endif
qm_Vbi_ei=((itfi_Vbi_ei/ickf)+(((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vbi_ei)));
#if defined(_DERIVATE2)
  qm_Vbi_ei_Vtnode_GND=(+(+(itfi_Vbi_ei_Vtnode_GND/ickf-(itfi_Vbi_ei*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(itfi_Vbi_ei_Vtnode_GND/iqfh_t-(itfi_Vbi_ei*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vtnode_GND)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vtnode_GND));
  qm_Vbi_ei_Vbi_ei=(+(+(itfi_Vbi_ei_Vbi_ei/ickf-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(itfi_Vbi_ei_Vbi_ei/iqfh_t-(itfi_Vbi_ei*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vbi_ei)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vbi_ei));
  qm_Vbi_ei_Vb_ci=(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vb_ci+0.0*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vb_ci)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vb_ci));
  qm_Vbi_ei_Vbi_ci=(+(+(0.0/ickf-(itfi_Vbi_ei*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ci+0.0*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vbi_ci)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vbi_ci));
  qm_Vbi_ei_Vci_ei=(+(+(0.0/ickf-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(itfi_Vbi_ei*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+(itfi_Vbi_ei/iqfh_t)*wdc_Vci_ei+0.0*wdc_Vbi_ei+(itfi/iqfh_t)*wdc_Vbi_ei_Vci_ei)*wdc+(((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vbi_ei+((itfi/iqfh_t)*wdc)*wdc_Vbi_ei_Vci_ei));
#endif
qm_Vb_ci=((-itfi*ickf_Vb_ci/ickf/ickf)+((((itfi/iqfh_t)*wdc_Vb_ci)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vb_ci)));
#if defined(_DERIVATE2)
  qm_Vb_ci_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vb_ci+itfi*ickf_Vb_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vtnode_GND)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vtnode_GND));
  qm_Vb_ci_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vbi_ei)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vbi_ei));
  qm_Vb_ci_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vb_ci+0.0*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vb_ci)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vb_ci));
  qm_Vb_ci_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vb_ci+itfi*ickf_Vb_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vb_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ci+0.0*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vbi_ci)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vbi_ci));
  qm_Vb_ci_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vb_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vb_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vci_ei+0.0*wdc_Vb_ci+(itfi/iqfh_t)*wdc_Vb_ci_Vci_ei)*wdc+((itfi/iqfh_t)*wdc_Vb_ci)*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vb_ci+((itfi/iqfh_t)*wdc)*wdc_Vb_ci_Vci_ei));
#endif
qm_Vbi_ci=(((-itfi*ickf_Vbi_ci/ickf/ickf)+(itri_Vbi_ci/ickr))+((((itfi/iqfh_t)*wdc_Vbi_ci)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vbi_ci)));
#if defined(_DERIVATE2)
  qm_Vbi_ci_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vtnode_GND)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vtnode_GND/ickf/ickf/ickf)+(itri_Vbi_ci_Vtnode_GND/ickr-(itri_Vbi_ci*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vtnode_GND)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vtnode_GND));
  qm_Vbi_ci_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vbi_ei)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vbi_ei));
  qm_Vbi_ci_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vb_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vb_ci+0.0*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vb_ci)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vb_ci));
  qm_Vbi_ci_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*ickf_Vbi_ci+itfi*ickf_Vbi_ci_Vbi_ci)/ickf/ickf+2*itfi*ickf_Vbi_ci*ickf_Vbi_ci/ickf/ickf/ickf)+(itri_Vbi_ci_Vbi_ci/ickr-(itri_Vbi_ci*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ci+0.0*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vbi_ci)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vbi_ci));
  qm_Vbi_ci_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*ickf_Vbi_ci+itfi*0.0)/ickf/ickf+2*itfi*ickf_Vbi_ci*0.0/ickf/ickf/ickf)+(0.0/ickr-(itri_Vbi_ci*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vci_ei+0.0*wdc_Vbi_ci+(itfi/iqfh_t)*wdc_Vbi_ci_Vci_ei)*wdc+((itfi/iqfh_t)*wdc_Vbi_ci)*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vbi_ci+((itfi/iqfh_t)*wdc)*wdc_Vbi_ci_Vci_ei));
#endif
qm_Vci_ei=((((itfi/iqfh_t)*wdc_Vci_ei)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vci_ei));
#if defined(_DERIVATE2)
  qm_Vci_ei_Vtnode_GND=(+(+(0.0/ickf-(0.0*ickf_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vtnode_GND/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vtnode_GND*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*iqfh_t_Vtnode_GND+itfi_Vtnode_GND*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vtnode_GND+((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vtnode_GND)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vtnode_GND+(((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND)))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vtnode_GND));
  qm_Vci_ei_Vbi_ei=(+(+(0.0/ickf-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+itfi_Vbi_ei*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ei+(itfi_Vbi_ei/iqfh_t)*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vbi_ei)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vbi_ei+((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei)))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vbi_ei));
  qm_Vci_ei_Vb_ci=(+(+(0.0/ickf-(0.0*ickf_Vb_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vb_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vb_ci+0.0*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vb_ci)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vb_ci+(((itfi/iqfh_t)*wdc_Vb_ci))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vb_ci));
  qm_Vci_ei_Vbi_ci=(+(+(0.0/ickf-(0.0*ickf_Vbi_ci+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*ickf_Vbi_ci/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+itri_Vbi_ci*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vbi_ci+0.0*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vbi_ci)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vbi_ci+(((itfi/iqfh_t)*wdc_Vbi_ci))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vbi_ci));
  qm_Vci_ei_Vci_ei=(+(+(0.0/ickf-(0.0*0.0+0.0*0.0+itfi*0.0)/ickf/ickf+2*itfi*0.0*0.0/ickf/ickf/ickf)+(0.0/ickr-(0.0*0.0+0.0*0.0+itri*0.0)/ickr/ickr+2*itri*0.0*0.0/ickr/ickr/ickr))+(+(+(0.0/iqfh_t-(0.0*0.0+0.0*0.0+itfi*0.0)/iqfh_t/iqfh_t+2*itfi*0.0*0.0/iqfh_t/iqfh_t/iqfh_t)*wdc+0.0*wdc_Vci_ei+0.0*wdc_Vci_ei+(itfi/iqfh_t)*wdc_Vci_ei_Vci_ei)*wdc+((itfi/iqfh_t)*wdc_Vci_ei)*wdc_Vci_ei+(((itfi/iqfh_t)*wdc_Vci_ei))*wdc_Vci_ei+((itfi/iqfh_t)*wdc)*wdc_Vci_ei_Vci_ei));
#endif
#endif
qm=(((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc));
EXIT_IF_ISNAN((((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc)))
}
{
double m00_sqrt(d00_sqrt0,((qj_2*qj_2)+qm))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((qj_2*qj_2)+qm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qpt_Vb_ci=(qj_2_Vb_ci+(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qm_Vb_ci)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_Vb_ci_Vb_ci=(+qj_2_Vb_ci_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qm_Vb_ci)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qm_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vb_ci*qj_2+qj_2_Vb_ci*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vb_ci)+qm_Vb_ci_Vb_ci)));
  qpt_Vb_ci_Vtnode_GND=(+qj_2_Vb_ci_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qm_Vtnode_GND)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qm_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vtnode_GND*qj_2+qj_2_Vb_ci*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vtnode_GND)+qm_Vb_ci_Vtnode_GND)));
  qpt_Vb_ci_Vbi_ci=(+qj_2_Vb_ci_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qm_Vbi_ci)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qm_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vbi_ci*qj_2+qj_2_Vb_ci*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vbi_ci)+qm_Vb_ci_Vbi_ci)));
  qpt_Vb_ci_Vbi_ei=(+qj_2_Vb_ci_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qm_Vbi_ei)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qm_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vbi_ei*qj_2+qj_2_Vb_ci*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vbi_ei)+qm_Vb_ci_Vbi_ei)));
  qpt_Vb_ci_Vci_ei=(+qj_2_Vb_ci_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qm_Vci_ei)*(((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci))+qm_Vb_ci)+d10_sqrt0*(+(+qj_2_Vb_ci_Vci_ei*qj_2+qj_2_Vb_ci*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vb_ci+qj_2*qj_2_Vb_ci_Vci_ei)+qm_Vb_ci_Vci_ei)));
#endif
#if defined(_DERIVATE)
qpt_Vtnode_GND=(qj_2_Vtnode_GND+(((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND))+qm_Vtnode_GND)*d10_sqrt0);
#endif
qpt_Vbi_ci=(qj_2_Vbi_ci+(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qm_Vbi_ci)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_Vbi_ci_Vb_ci=(+qj_2_Vbi_ci_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qm_Vb_ci)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qm_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vb_ci*qj_2+qj_2_Vbi_ci*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vb_ci)+qm_Vbi_ci_Vb_ci)));
  qpt_Vbi_ci_Vtnode_GND=(+qj_2_Vbi_ci_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qm_Vtnode_GND)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qm_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vtnode_GND*qj_2+qj_2_Vbi_ci*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vtnode_GND)+qm_Vbi_ci_Vtnode_GND)));
  qpt_Vbi_ci_Vbi_ci=(+qj_2_Vbi_ci_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qm_Vbi_ci)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qm_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vbi_ci*qj_2+qj_2_Vbi_ci*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vbi_ci)+qm_Vbi_ci_Vbi_ci)));
  qpt_Vbi_ci_Vbi_ei=(+qj_2_Vbi_ci_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qm_Vbi_ei)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qm_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vbi_ei*qj_2+qj_2_Vbi_ci*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vbi_ei)+qm_Vbi_ci_Vbi_ei)));
  qpt_Vbi_ci_Vci_ei=(+qj_2_Vbi_ci_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qm_Vci_ei)*(((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci))+qm_Vbi_ci)+d10_sqrt0*(+(+qj_2_Vbi_ci_Vci_ei*qj_2+qj_2_Vbi_ci*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vbi_ci+qj_2*qj_2_Vbi_ci_Vci_ei)+qm_Vbi_ci_Vci_ei)));
#endif
qpt_Vbi_ei=(qj_2_Vbi_ei+(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qm_Vbi_ei)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_Vbi_ei_Vb_ci=(+qj_2_Vbi_ei_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qm_Vb_ci)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qm_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vb_ci*qj_2+qj_2_Vbi_ei*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vb_ci)+qm_Vbi_ei_Vb_ci)));
  qpt_Vbi_ei_Vtnode_GND=(+qj_2_Vbi_ei_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qm_Vtnode_GND)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qm_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vtnode_GND*qj_2+qj_2_Vbi_ei*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vtnode_GND)+qm_Vbi_ei_Vtnode_GND)));
  qpt_Vbi_ei_Vbi_ci=(+qj_2_Vbi_ei_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qm_Vbi_ci)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qm_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vbi_ci*qj_2+qj_2_Vbi_ei*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vbi_ci)+qm_Vbi_ei_Vbi_ci)));
  qpt_Vbi_ei_Vbi_ei=(+qj_2_Vbi_ei_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qm_Vbi_ei)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qm_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vbi_ei*qj_2+qj_2_Vbi_ei*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vbi_ei)+qm_Vbi_ei_Vbi_ei)));
  qpt_Vbi_ei_Vci_ei=(+qj_2_Vbi_ei_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qm_Vci_ei)*(((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei))+qm_Vbi_ei)+d10_sqrt0*(+(+qj_2_Vbi_ei_Vci_ei*qj_2+qj_2_Vbi_ei*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vbi_ei+qj_2*qj_2_Vbi_ei_Vci_ei)+qm_Vbi_ei_Vci_ei)));
#endif
qpt_Vci_ei=(qj_2_Vci_ei+(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qm_Vci_ei)*d10_sqrt0);
#if defined(_DERIVATE2)
  qpt_Vci_ei_Vb_ci=(+qj_2_Vci_ei_Vb_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vb_ci*qj_2)+(qj_2*qj_2_Vb_ci)))+qm_Vb_ci)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qm_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vb_ci*qj_2+qj_2_Vci_ei*qj_2_Vb_ci+qj_2_Vb_ci*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vb_ci)+qm_Vci_ei_Vb_ci)));
  qpt_Vci_ei_Vtnode_GND=(+qj_2_Vci_ei_Vtnode_GND+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vtnode_GND*qj_2)+(qj_2*qj_2_Vtnode_GND)))+qm_Vtnode_GND)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qm_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vtnode_GND*qj_2+qj_2_Vci_ei*qj_2_Vtnode_GND+qj_2_Vtnode_GND*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vtnode_GND)+qm_Vci_ei_Vtnode_GND)));
  qpt_Vci_ei_Vbi_ci=(+qj_2_Vci_ei_Vbi_ci+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ci*qj_2)+(qj_2*qj_2_Vbi_ci)))+qm_Vbi_ci)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qm_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vbi_ci*qj_2+qj_2_Vci_ei*qj_2_Vbi_ci+qj_2_Vbi_ci*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vbi_ci)+qm_Vci_ei_Vbi_ci)));
  qpt_Vci_ei_Vbi_ei=(+qj_2_Vci_ei_Vbi_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vbi_ei*qj_2)+(qj_2*qj_2_Vbi_ei)))+qm_Vbi_ei)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qm_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vbi_ei*qj_2+qj_2_Vci_ei*qj_2_Vbi_ei+qj_2_Vbi_ei*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vbi_ei)+qm_Vci_ei_Vbi_ei)));
  qpt_Vci_ei_Vci_ei=(+qj_2_Vci_ei_Vci_ei+(m20_sqrt(((qj_2*qj_2)+qm))*((((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei)))+qm_Vci_ei)*(((qj_2_Vci_ei*qj_2)+(qj_2*qj_2_Vci_ei))+qm_Vci_ei)+d10_sqrt0*(+(+qj_2_Vci_ei_Vci_ei*qj_2+qj_2_Vci_ei*qj_2_Vci_ei+qj_2_Vci_ei*qj_2_Vci_ei+qj_2*qj_2_Vci_ei_Vci_ei)+qm_Vci_ei_Vci_ei)));
#endif
#endif
qpt=(qj_2+d00_sqrt0);
EXIT_IF_ISNAN((qj_2+d00_sqrt0))
}
}
else
{
o3=(1.0/3);
EXIT_IF_ISNAN((1.0/3))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
p2_a_Vb_ci=((-2)*qj_2_Vb_ci);
#if defined(_DERIVATE2)
  p2_a_Vb_ci_Vb_ci=(+0.0*qj_2+0.0*qj_2_Vb_ci+0.0*qj_2_Vb_ci+(-2)*qj_2_Vb_ci_Vb_ci);
  p2_a_Vb_ci_Vtnode_GND=(+0.0*qj_2+0.0*qj_2_Vtnode_GND+0.0*qj_2_Vb_ci+(-2)*qj_2_Vb_ci_Vtnode_GND);
  p2_a_Vb_ci_Vbi_ci=(+0.0*qj_2+0.0*qj_2_Vbi_ci+0.0*qj_2_Vb_ci+(-2)*qj_2_Vb_ci_Vbi_ci);
  p2_a_Vb_ci_Vbi_ei=(+0.0*qj_2+0.0*qj_2_Vbi_ei+0.0*qj_2_Vb_ci+(-2)*qj_2_Vb_ci_Vbi_ei);
  p2_a_Vb_ci_Vci_ei=(+0.0*qj_2+0.0*qj_2_Vci_ei+0.0*qj_2_Vb_ci+(-2)*qj_2_Vb_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
p2_a_Vtnode_GND=((-2)*qj_2_Vtnode_GND);
#endif
p2_a_Vbi_ci=((-2)*qj_2_Vbi_ci);
#if defined(_DERIVATE2)
  p2_a_Vbi_ci_Vb_ci=(+0.0*qj_2+0.0*qj_2_Vb_ci+0.0*qj_2_Vbi_ci+(-2)*qj_2_Vbi_ci_Vb_ci);
  p2_a_Vbi_ci_Vtnode_GND=(+0.0*qj_2+0.0*qj_2_Vtnode_GND+0.0*qj_2_Vbi_ci+(-2)*qj_2_Vbi_ci_Vtnode_GND);
  p2_a_Vbi_ci_Vbi_ci=(+0.0*qj_2+0.0*qj_2_Vbi_ci+0.0*qj_2_Vbi_ci+(-2)*qj_2_Vbi_ci_Vbi_ci);
  p2_a_Vbi_ci_Vbi_ei=(+0.0*qj_2+0.0*qj_2_Vbi_ei+0.0*qj_2_Vbi_ci+(-2)*qj_2_Vbi_ci_Vbi_ei);
  p2_a_Vbi_ci_Vci_ei=(+0.0*qj_2+0.0*qj_2_Vci_ei+0.0*qj_2_Vbi_ci+(-2)*qj_2_Vbi_ci_Vci_ei);
#endif
p2_a_Vbi_ei=((-2)*qj_2_Vbi_ei);
#if defined(_DERIVATE2)
  p2_a_Vbi_ei_Vb_ci=(+0.0*qj_2+0.0*qj_2_Vb_ci+0.0*qj_2_Vbi_ei+(-2)*qj_2_Vbi_ei_Vb_ci);
  p2_a_Vbi_ei_Vtnode_GND=(+0.0*qj_2+0.0*qj_2_Vtnode_GND+0.0*qj_2_Vbi_ei+(-2)*qj_2_Vbi_ei_Vtnode_GND);
  p2_a_Vbi_ei_Vbi_ci=(+0.0*qj_2+0.0*qj_2_Vbi_ci+0.0*qj_2_Vbi_ei+(-2)*qj_2_Vbi_ei_Vbi_ci);
  p2_a_Vbi_ei_Vbi_ei=(+0.0*qj_2+0.0*qj_2_Vbi_ei+0.0*qj_2_Vbi_ei+(-2)*qj_2_Vbi_ei_Vbi_ei);
  p2_a_Vbi_ei_Vci_ei=(+0.0*qj_2+0.0*qj_2_Vci_ei+0.0*qj_2_Vbi_ei+(-2)*qj_2_Vbi_ei_Vci_ei);
#endif
p2_a_Vci_ei=((-2)*qj_2_Vci_ei);
#if defined(_DERIVATE2)
  p2_a_Vci_ei_Vb_ci=(+0.0*qj_2+0.0*qj_2_Vb_ci+0.0*qj_2_Vci_ei+(-2)*qj_2_Vci_ei_Vb_ci);
  p2_a_Vci_ei_Vtnode_GND=(+0.0*qj_2+0.0*qj_2_Vtnode_GND+0.0*qj_2_Vci_ei+(-2)*qj_2_Vci_ei_Vtnode_GND);
  p2_a_Vci_ei_Vbi_ci=(+0.0*qj_2+0.0*qj_2_Vbi_ci+0.0*qj_2_Vci_ei+(-2)*qj_2_Vci_ei_Vbi_ci);
  p2_a_Vci_ei_Vbi_ei=(+0.0*qj_2+0.0*qj_2_Vbi_ei+0.0*qj_2_Vci_ei+(-2)*qj_2_Vci_ei_Vbi_ei);
  p2_a_Vci_ei_Vci_ei=(+0.0*qj_2+0.0*qj_2_Vci_ei+0.0*qj_2_Vci_ei+(-2)*qj_2_Vci_ei_Vci_ei);
#endif
#endif
p2_a=((-2)*qj_2);
EXIT_IF_ISNAN(((-2)*qj_2))
if
(((pModel->iqf==1.0e6)&&(pModel->iqfh==1.0e6)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
p2_b_Vtnode_GND=0.0;
#endif
p2_b_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  p2_b_Vbi_ei_Vtnode_GND=0.0;
  p2_b_Vbi_ei_Vbi_ei=0.0;
  p2_b_Vbi_ei_Vb_ci=0.0;
  p2_b_Vbi_ei_Vbi_ci=0.0;
  p2_b_Vbi_ei_Vci_ei=0.0;
#endif
p2_b_Vb_ci=0.0;
#if defined(_DERIVATE2)
  p2_b_Vb_ci_Vtnode_GND=0.0;
  p2_b_Vb_ci_Vbi_ei=0.0;
  p2_b_Vb_ci_Vb_ci=0.0;
  p2_b_Vb_ci_Vbi_ci=0.0;
  p2_b_Vb_ci_Vci_ei=0.0;
#endif
p2_b_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  p2_b_Vbi_ci_Vtnode_GND=0.0;
  p2_b_Vbi_ci_Vbi_ei=0.0;
  p2_b_Vbi_ci_Vb_ci=0.0;
  p2_b_Vbi_ci_Vbi_ci=0.0;
  p2_b_Vbi_ci_Vci_ei=0.0;
#endif
p2_b_Vci_ei=0.0;
#if defined(_DERIVATE2)
  p2_b_Vci_ei_Vtnode_GND=0.0;
  p2_b_Vci_ei_Vbi_ei=0.0;
  p2_b_Vci_ei_Vb_ci=0.0;
  p2_b_Vci_ei_Vbi_ci=0.0;
  p2_b_Vci_ei_Vci_ei=0.0;
#endif
#endif
p2_b=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
p2_b_Vtnode_GND=(-((((itfi_Vtnode_GND*ickf-itfi*ickf_Vtnode_GND)/ickf/ickf)+(itri_Vtnode_GND/ickr))+((((((itfi_Vtnode_GND*iqfh_t-itfi*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vtnode_GND))*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vtnode_GND))));
#endif
p2_b_Vbi_ei=(-((itfi_Vbi_ei/ickf)+(((((itfi_Vbi_ei/iqfh_t)*wdc)+((itfi/iqfh_t)*wdc_Vbi_ei))*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vbi_ei))));
#if defined(_DERIVATE2)
  p2_b_Vbi_ei_Vtnode_GND=0.0;
  p2_b_Vbi_ei_Vbi_ei=0.0;
  p2_b_Vbi_ei_Vb_ci=0.0;
  p2_b_Vbi_ei_Vbi_ci=0.0;
  p2_b_Vbi_ei_Vci_ei=0.0;
#endif
p2_b_Vb_ci=(-((-itfi*ickf_Vb_ci/ickf/ickf)+((((itfi/iqfh_t)*wdc_Vb_ci)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vb_ci))));
#if defined(_DERIVATE2)
  p2_b_Vb_ci_Vtnode_GND=0.0;
  p2_b_Vb_ci_Vbi_ei=0.0;
  p2_b_Vb_ci_Vb_ci=0.0;
  p2_b_Vb_ci_Vbi_ci=0.0;
  p2_b_Vb_ci_Vci_ei=0.0;
#endif
p2_b_Vbi_ci=(-(((-itfi*ickf_Vbi_ci/ickf/ickf)+(itri_Vbi_ci/ickr))+((((itfi/iqfh_t)*wdc_Vbi_ci)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vbi_ci))));
#if defined(_DERIVATE2)
  p2_b_Vbi_ci_Vtnode_GND=0.0;
  p2_b_Vbi_ci_Vbi_ei=0.0;
  p2_b_Vbi_ci_Vb_ci=0.0;
  p2_b_Vbi_ci_Vbi_ci=0.0;
  p2_b_Vbi_ci_Vci_ei=0.0;
#endif
p2_b_Vci_ei=(-((((itfi/iqfh_t)*wdc_Vci_ei)*wdc)+(((itfi/iqfh_t)*wdc)*wdc_Vci_ei)));
#if defined(_DERIVATE2)
  p2_b_Vci_ei_Vtnode_GND=0.0;
  p2_b_Vci_ei_Vbi_ei=0.0;
  p2_b_Vci_ei_Vb_ci=0.0;
  p2_b_Vci_ei_Vbi_ci=0.0;
  p2_b_Vci_ei_Vci_ei=0.0;
#endif
#endif
p2_b=(-(((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc)));
EXIT_IF_ISNAN((-(((itfi/ickf)+(itri/ickr))+(((itfi/iqfh_t)*wdc)*wdc))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
#if defined(_DERIVATE)
p2_c_Vtnode_GND=(((((((((-itfi_Vtnode_GND)*itfi)+((-itfi)*itfi_Vtnode_GND))*ick-((-itfi)*itfi)*ick_Vtnode_GND)/ick/ick)*tfh_t)+((((-itfi)*itfi)/ick)*tfh_t_Vtnode_GND))*iqfh_t-((((-itfi)*itfi)/ick)*tfh_t)*iqfh_t_Vtnode_GND)/iqfh_t/iqfh_t);
#endif
p2_c_Vbi_ei=(((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))/ick)*tfh_t/iqfh_t);
#if defined(_DERIVATE2)
  p2_c_Vbi_ei_Vtnode_GND=((+((+0.0*itfi+(-itfi_Vbi_ei)*itfi_Vtnode_GND+(-itfi_Vtnode_GND)*itfi_Vbi_ei+(-itfi)*itfi_Vbi_ei_Vtnode_GND)/ick-((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))*ick_Vtnode_GND+((((-itfi_Vtnode_GND)*itfi)+((-itfi)*itfi_Vtnode_GND)))*0.0+((-itfi)*itfi)*0.0)/ick/ick+2*((-itfi)*itfi)*0.0*ick_Vtnode_GND/ick/ick/ick)*tfh_t+((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))/ick)*tfh_t_Vtnode_GND+((((((-itfi_Vtnode_GND)*itfi)+((-itfi)*itfi_Vtnode_GND)))*ick-((-itfi)*itfi)*ick_Vtnode_GND)/ick/ick)*0.0+(((-itfi)*itfi)/ick)*0.0)/iqfh_t-(((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))/ick)*tfh_t*iqfh_t_Vtnode_GND+(((((((((-itfi_Vtnode_GND)*itfi)+((-itfi)*itfi_Vtnode_GND)))*ick-((-itfi)*itfi)*ick_Vtnode_GND)/ick/ick)*tfh_t)+((((-itfi)*itfi)/ick)*tfh_t_Vtnode_GND)))*0.0+((((-itfi)*itfi)/ick)*tfh_t)*0.0)/iqfh_t/iqfh_t+2*((((-itfi)*itfi)/ick)*tfh_t)*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t);
  p2_c_Vbi_ei_Vbi_ei=((+((+0.0*itfi+(-itfi_Vbi_ei)*itfi_Vbi_ei+(-itfi_Vbi_ei)*itfi_Vbi_ei+(-itfi)*itfi_Vbi_ei_Vbi_ei)/ick-((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))*0.0+((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei)))*0.0+((-itfi)*itfi)*0.0)/ick/ick+2*((-itfi)*itfi)*0.0*0.0/ick/ick/ick)*tfh_t+((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))/ick)*0.0+(((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei)))/ick)*0.0+(((-itfi)*itfi)/ick)*0.0)/iqfh_t-(((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))/ick)*tfh_t*0.0+((((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei)))/ick)*tfh_t)*0.0+((((-itfi)*itfi)/ick)*tfh_t)*0.0)/iqfh_t/iqfh_t+2*((((-itfi)*itfi)/ick)*tfh_t)*0.0*0.0/iqfh_t/iqfh_t/iqfh_t);
  p2_c_Vbi_ei_Vci_ei=((+((+0.0*itfi+(-itfi_Vbi_ei)*0.0+0.0*itfi_Vbi_ei+(-itfi)*0.0)/ick-((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))*ick_Vci_ei+(0.0)*0.0+((-itfi)*itfi)*0.0)/ick/ick+2*((-itfi)*itfi)*0.0*ick_Vci_ei/ick/ick/ick)*tfh_t+((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))/ick)*0.0+(((0.0)*ick-((-itfi)*itfi)*ick_Vci_ei)/ick/ick)*0.0+(((-itfi)*itfi)/ick)*0.0)/iqfh_t-(((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei))/ick)*tfh_t*0.0+((((0.0)*ick-((-itfi)*itfi)*ick_Vci_ei)/ick/ick)*tfh_t)*0.0+((((-itfi)*itfi)/ick)*tfh_t)*0.0)/iqfh_t/iqfh_t+2*((((-itfi)*itfi)/ick)*tfh_t)*0.0*0.0/iqfh_t/iqfh_t/iqfh_t);
#endif
p2_c_Vci_ei=((-((-itfi)*itfi)*ick_Vci_ei/ick/ick)*tfh_t/iqfh_t);
#if defined(_DERIVATE2)
  p2_c_Vci_ei_Vtnode_GND=((+((+0.0*itfi+0.0*itfi_Vtnode_GND+(-itfi_Vtnode_GND)*0.0+(-itfi)*0.0)/ick-(0.0*ick_Vtnode_GND+((((-itfi_Vtnode_GND)*itfi)+((-itfi)*itfi_Vtnode_GND)))*ick_Vci_ei+((-itfi)*itfi)*ick_Vci_ei_Vtnode_GND)/ick/ick+2*((-itfi)*itfi)*ick_Vci_ei*ick_Vtnode_GND/ick/ick/ick)*tfh_t+(-((-itfi)*itfi)*ick_Vci_ei/ick/ick)*tfh_t_Vtnode_GND+((((((-itfi_Vtnode_GND)*itfi)+((-itfi)*itfi_Vtnode_GND)))*ick-((-itfi)*itfi)*ick_Vtnode_GND)/ick/ick)*0.0+(((-itfi)*itfi)/ick)*0.0)/iqfh_t-((-((-itfi)*itfi)*ick_Vci_ei/ick/ick)*tfh_t*iqfh_t_Vtnode_GND+(((((((((-itfi_Vtnode_GND)*itfi)+((-itfi)*itfi_Vtnode_GND)))*ick-((-itfi)*itfi)*ick_Vtnode_GND)/ick/ick)*tfh_t)+((((-itfi)*itfi)/ick)*tfh_t_Vtnode_GND)))*0.0+((((-itfi)*itfi)/ick)*tfh_t)*0.0)/iqfh_t/iqfh_t+2*((((-itfi)*itfi)/ick)*tfh_t)*0.0*iqfh_t_Vtnode_GND/iqfh_t/iqfh_t/iqfh_t);
  p2_c_Vci_ei_Vbi_ei=((+((+0.0*itfi+0.0*itfi_Vbi_ei+(-itfi_Vbi_ei)*0.0+(-itfi)*0.0)/ick-(0.0*0.0+((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei)))*ick_Vci_ei+((-itfi)*itfi)*0.0)/ick/ick+2*((-itfi)*itfi)*ick_Vci_ei*0.0/ick/ick/ick)*tfh_t+(-((-itfi)*itfi)*ick_Vci_ei/ick/ick)*0.0+(((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei)))/ick)*0.0+(((-itfi)*itfi)/ick)*0.0)/iqfh_t-((-((-itfi)*itfi)*ick_Vci_ei/ick/ick)*tfh_t*0.0+((((((-itfi_Vbi_ei)*itfi)+((-itfi)*itfi_Vbi_ei)))/ick)*tfh_t)*0.0+((((-itfi)*itfi)/ick)*tfh_t)*0.0)/iqfh_t/iqfh_t+2*((((-itfi)*itfi)/ick)*tfh_t)*0.0*0.0/iqfh_t/iqfh_t/iqfh_t);
  p2_c_Vci_ei_Vci_ei=((+((+0.0*itfi+0.0*0.0+0.0*0.0+(-itfi)*0.0)/ick-(0.0*ick_Vci_ei+(0.0)*ick_Vci_ei+((-itfi)*itfi)*ick_Vci_ei_Vci_ei)/ick/ick+2*((-itfi)*itfi)*ick_Vci_ei*ick_Vci_ei/ick/ick/ick)*tfh_t+(-((-itfi)*itfi)*ick_Vci_ei/ick/ick)*0.0+(((0.0)*ick-((-itfi)*itfi)*ick_Vci_ei)/ick/ick)*0.0+(((-itfi)*itfi)/ick)*0.0)/iqfh_t-((-((-itfi)*itfi)*ick_Vci_ei/ick/ick)*tfh_t*0.0+((((0.0)*ick-((-itfi)*itfi)*ick_Vci_ei)/ick/ick)*tfh_t)*0.0+((((-itfi)*itfi)/ick)*tfh_t)*0.0)/iqfh_t/iqfh_t+2*((((-itfi)*itfi)/ick)*tfh_t)*0.0*0.0/iqfh_t/iqfh_t/iqfh_t);
#endif
#endif
p2_c=(((((-itfi)*itfi)/ick)*tfh_t)/iqfh_t);
EXIT_IF_ISNAN((((((-itfi)*itfi)/ick)*tfh_t)/iqfh_t))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
tmp_Vb_ci=((p2_a_Vb_ci*p2_a)+(p2_a*p2_a_Vb_ci));
#if defined(_DERIVATE2)
  tmp_Vb_ci_Vb_ci=(+p2_a_Vb_ci_Vb_ci*p2_a+p2_a_Vb_ci*p2_a_Vb_ci+p2_a_Vb_ci*p2_a_Vb_ci+p2_a*p2_a_Vb_ci_Vb_ci);
  tmp_Vb_ci_Vtnode_GND=(+p2_a_Vb_ci_Vtnode_GND*p2_a+p2_a_Vb_ci*p2_a_Vtnode_GND+p2_a_Vtnode_GND*p2_a_Vb_ci+p2_a*p2_a_Vb_ci_Vtnode_GND);
  tmp_Vb_ci_Vbi_ci=(+p2_a_Vb_ci_Vbi_ci*p2_a+p2_a_Vb_ci*p2_a_Vbi_ci+p2_a_Vbi_ci*p2_a_Vb_ci+p2_a*p2_a_Vb_ci_Vbi_ci);
  tmp_Vb_ci_Vbi_ei=(+p2_a_Vb_ci_Vbi_ei*p2_a+p2_a_Vb_ci*p2_a_Vbi_ei+p2_a_Vbi_ei*p2_a_Vb_ci+p2_a*p2_a_Vb_ci_Vbi_ei);
  tmp_Vb_ci_Vci_ei=(+p2_a_Vb_ci_Vci_ei*p2_a+p2_a_Vb_ci*p2_a_Vci_ei+p2_a_Vci_ei*p2_a_Vb_ci+p2_a*p2_a_Vb_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
tmp_Vtnode_GND=((p2_a_Vtnode_GND*p2_a)+(p2_a*p2_a_Vtnode_GND));
#endif
tmp_Vbi_ci=((p2_a_Vbi_ci*p2_a)+(p2_a*p2_a_Vbi_ci));
#if defined(_DERIVATE2)
  tmp_Vbi_ci_Vb_ci=(+p2_a_Vbi_ci_Vb_ci*p2_a+p2_a_Vbi_ci*p2_a_Vb_ci+p2_a_Vb_ci*p2_a_Vbi_ci+p2_a*p2_a_Vbi_ci_Vb_ci);
  tmp_Vbi_ci_Vtnode_GND=(+p2_a_Vbi_ci_Vtnode_GND*p2_a+p2_a_Vbi_ci*p2_a_Vtnode_GND+p2_a_Vtnode_GND*p2_a_Vbi_ci+p2_a*p2_a_Vbi_ci_Vtnode_GND);
  tmp_Vbi_ci_Vbi_ci=(+p2_a_Vbi_ci_Vbi_ci*p2_a+p2_a_Vbi_ci*p2_a_Vbi_ci+p2_a_Vbi_ci*p2_a_Vbi_ci+p2_a*p2_a_Vbi_ci_Vbi_ci);
  tmp_Vbi_ci_Vbi_ei=(+p2_a_Vbi_ci_Vbi_ei*p2_a+p2_a_Vbi_ci*p2_a_Vbi_ei+p2_a_Vbi_ei*p2_a_Vbi_ci+p2_a*p2_a_Vbi_ci_Vbi_ei);
  tmp_Vbi_ci_Vci_ei=(+p2_a_Vbi_ci_Vci_ei*p2_a+p2_a_Vbi_ci*p2_a_Vci_ei+p2_a_Vci_ei*p2_a_Vbi_ci+p2_a*p2_a_Vbi_ci_Vci_ei);
#endif
tmp_Vbi_ei=((p2_a_Vbi_ei*p2_a)+(p2_a*p2_a_Vbi_ei));
#if defined(_DERIVATE2)
  tmp_Vbi_ei_Vb_ci=(+p2_a_Vbi_ei_Vb_ci*p2_a+p2_a_Vbi_ei*p2_a_Vb_ci+p2_a_Vb_ci*p2_a_Vbi_ei+p2_a*p2_a_Vbi_ei_Vb_ci);
  tmp_Vbi_ei_Vtnode_GND=(+p2_a_Vbi_ei_Vtnode_GND*p2_a+p2_a_Vbi_ei*p2_a_Vtnode_GND+p2_a_Vtnode_GND*p2_a_Vbi_ei+p2_a*p2_a_Vbi_ei_Vtnode_GND);
  tmp_Vbi_ei_Vbi_ci=(+p2_a_Vbi_ei_Vbi_ci*p2_a+p2_a_Vbi_ei*p2_a_Vbi_ci+p2_a_Vbi_ci*p2_a_Vbi_ei+p2_a*p2_a_Vbi_ei_Vbi_ci);
  tmp_Vbi_ei_Vbi_ei=(+p2_a_Vbi_ei_Vbi_ei*p2_a+p2_a_Vbi_ei*p2_a_Vbi_ei+p2_a_Vbi_ei*p2_a_Vbi_ei+p2_a*p2_a_Vbi_ei_Vbi_ei);
  tmp_Vbi_ei_Vci_ei=(+p2_a_Vbi_ei_Vci_ei*p2_a+p2_a_Vbi_ei*p2_a_Vci_ei+p2_a_Vci_ei*p2_a_Vbi_ei+p2_a*p2_a_Vbi_ei_Vci_ei);
#endif
tmp_Vci_ei=((p2_a_Vci_ei*p2_a)+(p2_a*p2_a_Vci_ei));
#if defined(_DERIVATE2)
  tmp_Vci_ei_Vb_ci=(+p2_a_Vci_ei_Vb_ci*p2_a+p2_a_Vci_ei*p2_a_Vb_ci+p2_a_Vb_ci*p2_a_Vci_ei+p2_a*p2_a_Vci_ei_Vb_ci);
  tmp_Vci_ei_Vtnode_GND=(+p2_a_Vci_ei_Vtnode_GND*p2_a+p2_a_Vci_ei*p2_a_Vtnode_GND+p2_a_Vtnode_GND*p2_a_Vci_ei+p2_a*p2_a_Vci_ei_Vtnode_GND);
  tmp_Vci_ei_Vbi_ci=(+p2_a_Vci_ei_Vbi_ci*p2_a+p2_a_Vci_ei*p2_a_Vbi_ci+p2_a_Vbi_ci*p2_a_Vci_ei+p2_a*p2_a_Vci_ei_Vbi_ci);
  tmp_Vci_ei_Vbi_ei=(+p2_a_Vci_ei_Vbi_ei*p2_a+p2_a_Vci_ei*p2_a_Vbi_ei+p2_a_Vbi_ei*p2_a_Vci_ei+p2_a*p2_a_Vci_ei_Vbi_ei);
  tmp_Vci_ei_Vci_ei=(+p2_a_Vci_ei_Vci_ei*p2_a+p2_a_Vci_ei*p2_a_Vci_ei+p2_a_Vci_ei*p2_a_Vci_ei+p2_a*p2_a_Vci_ei_Vci_ei);
#endif
#endif
tmp=(p2_a*p2_a);
EXIT_IF_ISNAN((p2_a*p2_a))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
p2_p_Vtnode_GND=(p2_b_Vtnode_GND-tmp_Vtnode_GND*o3);
#endif
p2_p_Vbi_ei=(p2_b_Vbi_ei-tmp_Vbi_ei*o3);
#if defined(_DERIVATE2)
  p2_p_Vbi_ei_Vtnode_GND=(+p2_b_Vbi_ei_Vtnode_GND-(+tmp_Vbi_ei_Vtnode_GND*o3+tmp_Vbi_ei*0.0+tmp_Vtnode_GND*0.0+tmp*0.0));
  p2_p_Vbi_ei_Vbi_ei=(+p2_b_Vbi_ei_Vbi_ei-(+tmp_Vbi_ei_Vbi_ei*o3+tmp_Vbi_ei*0.0+tmp_Vbi_ei*0.0+tmp*0.0));
  p2_p_Vbi_ei_Vb_ci=(+p2_b_Vbi_ei_Vb_ci-(+tmp_Vbi_ei_Vb_ci*o3+tmp_Vbi_ei*0.0+tmp_Vb_ci*0.0+tmp*0.0));
  p2_p_Vbi_ei_Vbi_ci=(+p2_b_Vbi_ei_Vbi_ci-(+tmp_Vbi_ei_Vbi_ci*o3+tmp_Vbi_ei*0.0+tmp_Vbi_ci*0.0+tmp*0.0));
  p2_p_Vbi_ei_Vci_ei=(+p2_b_Vbi_ei_Vci_ei-(+tmp_Vbi_ei_Vci_ei*o3+tmp_Vbi_ei*0.0+tmp_Vci_ei*0.0+tmp*0.0));
#endif
p2_p_Vb_ci=(p2_b_Vb_ci-tmp_Vb_ci*o3);
#if defined(_DERIVATE2)
  p2_p_Vb_ci_Vtnode_GND=(+p2_b_Vb_ci_Vtnode_GND-(+tmp_Vb_ci_Vtnode_GND*o3+tmp_Vb_ci*0.0+tmp_Vtnode_GND*0.0+tmp*0.0));
  p2_p_Vb_ci_Vbi_ei=(+p2_b_Vb_ci_Vbi_ei-(+tmp_Vb_ci_Vbi_ei*o3+tmp_Vb_ci*0.0+tmp_Vbi_ei*0.0+tmp*0.0));
  p2_p_Vb_ci_Vb_ci=(+p2_b_Vb_ci_Vb_ci-(+tmp_Vb_ci_Vb_ci*o3+tmp_Vb_ci*0.0+tmp_Vb_ci*0.0+tmp*0.0));
  p2_p_Vb_ci_Vbi_ci=(+p2_b_Vb_ci_Vbi_ci-(+tmp_Vb_ci_Vbi_ci*o3+tmp_Vb_ci*0.0+tmp_Vbi_ci*0.0+tmp*0.0));
  p2_p_Vb_ci_Vci_ei=(+p2_b_Vb_ci_Vci_ei-(+tmp_Vb_ci_Vci_ei*o3+tmp_Vb_ci*0.0+tmp_Vci_ei*0.0+tmp*0.0));
#endif
p2_p_Vbi_ci=(p2_b_Vbi_ci-tmp_Vbi_ci*o3);
#if defined(_DERIVATE2)
  p2_p_Vbi_ci_Vtnode_GND=(+p2_b_Vbi_ci_Vtnode_GND-(+tmp_Vbi_ci_Vtnode_GND*o3+tmp_Vbi_ci*0.0+tmp_Vtnode_GND*0.0+tmp*0.0));
  p2_p_Vbi_ci_Vbi_ei=(+p2_b_Vbi_ci_Vbi_ei-(+tmp_Vbi_ci_Vbi_ei*o3+tmp_Vbi_ci*0.0+tmp_Vbi_ei*0.0+tmp*0.0));
  p2_p_Vbi_ci_Vb_ci=(+p2_b_Vbi_ci_Vb_ci-(+tmp_Vbi_ci_Vb_ci*o3+tmp_Vbi_ci*0.0+tmp_Vb_ci*0.0+tmp*0.0));
  p2_p_Vbi_ci_Vbi_ci=(+p2_b_Vbi_ci_Vbi_ci-(+tmp_Vbi_ci_Vbi_ci*o3+tmp_Vbi_ci*0.0+tmp_Vbi_ci*0.0+tmp*0.0));
  p2_p_Vbi_ci_Vci_ei=(+p2_b_Vbi_ci_Vci_ei-(+tmp_Vbi_ci_Vci_ei*o3+tmp_Vbi_ci*0.0+tmp_Vci_ei*0.0+tmp*0.0));
#endif
p2_p_Vci_ei=(p2_b_Vci_ei-tmp_Vci_ei*o3);
#if defined(_DERIVATE2)
  p2_p_Vci_ei_Vtnode_GND=(+p2_b_Vci_ei_Vtnode_GND-(+tmp_Vci_ei_Vtnode_GND*o3+tmp_Vci_ei*0.0+tmp_Vtnode_GND*0.0+tmp*0.0));
  p2_p_Vci_ei_Vbi_ei=(+p2_b_Vci_ei_Vbi_ei-(+tmp_Vci_ei_Vbi_ei*o3+tmp_Vci_ei*0.0+tmp_Vbi_ei*0.0+tmp*0.0));
  p2_p_Vci_ei_Vb_ci=(+p2_b_Vci_ei_Vb_ci-(+tmp_Vci_ei_Vb_ci*o3+tmp_Vci_ei*0.0+tmp_Vb_ci*0.0+tmp*0.0));
  p2_p_Vci_ei_Vbi_ci=(+p2_b_Vci_ei_Vbi_ci-(+tmp_Vci_ei_Vbi_ci*o3+tmp_Vci_ei*0.0+tmp_Vbi_ci*0.0+tmp*0.0));
  p2_p_Vci_ei_Vci_ei=(+p2_b_Vci_ei_Vci_ei-(+tmp_Vci_ei_Vci_ei*o3+tmp_Vci_ei*0.0+tmp_Vci_ei*0.0+tmp*0.0));
#endif
#endif
p2_p=(p2_b-(tmp*o3));
EXIT_IF_ISNAN((p2_b-(tmp*o3)))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
p2_q_Vb_ci=(((((2*p2_a_Vb_ci)*tmp)+((2*p2_a)*tmp_Vb_ci))/27)-((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci))*o3);
#if defined(_DERIVATE2)
  p2_q_Vb_ci_Vb_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vb_ci+0.0*p2_a_Vb_ci+2*p2_a_Vb_ci_Vb_ci)*tmp+(2*p2_a_Vb_ci)*tmp_Vb_ci+((2*p2_a_Vb_ci))*tmp_Vb_ci+(2*p2_a)*tmp_Vb_ci_Vb_ci)/27-((((2*p2_a_Vb_ci)*tmp)+((2*p2_a)*tmp_Vb_ci))*0.0+(((((2*p2_a_Vb_ci))*tmp)+((2*p2_a)*tmp_Vb_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vb_ci_Vb_ci*p2_b+p2_a_Vb_ci*p2_b_Vb_ci+p2_a_Vb_ci*p2_b_Vb_ci+p2_a*p2_b_Vb_ci_Vb_ci)*o3+((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci))*0.0+(((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vb_ci_Vtnode_GND=(+(+((+(+0.0*p2_a+0.0*p2_a_Vtnode_GND+0.0*p2_a_Vb_ci+2*p2_a_Vb_ci_Vtnode_GND)*tmp+(2*p2_a_Vb_ci)*tmp_Vtnode_GND+((2*p2_a_Vtnode_GND))*tmp_Vb_ci+(2*p2_a)*tmp_Vb_ci_Vtnode_GND)/27-((((2*p2_a_Vb_ci)*tmp)+((2*p2_a)*tmp_Vb_ci))*0.0+(((((2*p2_a_Vtnode_GND))*tmp)+((2*p2_a)*tmp_Vtnode_GND)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vb_ci_Vtnode_GND*p2_b+p2_a_Vb_ci*p2_b_Vtnode_GND+p2_a_Vtnode_GND*p2_b_Vb_ci+p2_a*p2_b_Vb_ci_Vtnode_GND)*o3+((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci))*0.0+(((p2_a_Vtnode_GND*p2_b)+(p2_a*p2_b_Vtnode_GND)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vb_ci_Vbi_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ci+0.0*p2_a_Vb_ci+2*p2_a_Vb_ci_Vbi_ci)*tmp+(2*p2_a_Vb_ci)*tmp_Vbi_ci+((2*p2_a_Vbi_ci))*tmp_Vb_ci+(2*p2_a)*tmp_Vb_ci_Vbi_ci)/27-((((2*p2_a_Vb_ci)*tmp)+((2*p2_a)*tmp_Vb_ci))*0.0+(((((2*p2_a_Vbi_ci))*tmp)+((2*p2_a)*tmp_Vbi_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vb_ci_Vbi_ci*p2_b+p2_a_Vb_ci*p2_b_Vbi_ci+p2_a_Vbi_ci*p2_b_Vb_ci+p2_a*p2_b_Vb_ci_Vbi_ci)*o3+((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci))*0.0+(((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vb_ci_Vbi_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ei+0.0*p2_a_Vb_ci+2*p2_a_Vb_ci_Vbi_ei)*tmp+(2*p2_a_Vb_ci)*tmp_Vbi_ei+((2*p2_a_Vbi_ei))*tmp_Vb_ci+(2*p2_a)*tmp_Vb_ci_Vbi_ei)/27-((((2*p2_a_Vb_ci)*tmp)+((2*p2_a)*tmp_Vb_ci))*0.0+(((((2*p2_a_Vbi_ei))*tmp)+((2*p2_a)*tmp_Vbi_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vb_ci_Vbi_ei*p2_b+p2_a_Vb_ci*p2_b_Vbi_ei+p2_a_Vbi_ei*p2_b_Vb_ci+p2_a*p2_b_Vb_ci_Vbi_ei)*o3+((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci))*0.0+(((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vb_ci_Vci_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vci_ei+0.0*p2_a_Vb_ci+2*p2_a_Vb_ci_Vci_ei)*tmp+(2*p2_a_Vb_ci)*tmp_Vci_ei+((2*p2_a_Vci_ei))*tmp_Vb_ci+(2*p2_a)*tmp_Vb_ci_Vci_ei)/27-((((2*p2_a_Vb_ci)*tmp)+((2*p2_a)*tmp_Vb_ci))*0.0+(((((2*p2_a_Vci_ei))*tmp)+((2*p2_a)*tmp_Vci_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vb_ci_Vci_ei*p2_b+p2_a_Vb_ci*p2_b_Vci_ei+p2_a_Vci_ei*p2_b_Vb_ci+p2_a*p2_b_Vb_ci_Vci_ei)*o3+((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci))*0.0+(((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei)))*0.0+(p2_a*p2_b)*0.0))+0.0);
#endif
#if defined(_DERIVATE)
p2_q_Vtnode_GND=((((((2*p2_a_Vtnode_GND)*tmp)+((2*p2_a)*tmp_Vtnode_GND))/27)-((p2_a_Vtnode_GND*p2_b)+(p2_a*p2_b_Vtnode_GND))*o3)+p2_c_Vtnode_GND);
#endif
p2_q_Vbi_ci=(((((2*p2_a_Vbi_ci)*tmp)+((2*p2_a)*tmp_Vbi_ci))/27)-((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci))*o3);
#if defined(_DERIVATE2)
  p2_q_Vbi_ci_Vb_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vb_ci+0.0*p2_a_Vbi_ci+2*p2_a_Vbi_ci_Vb_ci)*tmp+(2*p2_a_Vbi_ci)*tmp_Vb_ci+((2*p2_a_Vb_ci))*tmp_Vbi_ci+(2*p2_a)*tmp_Vbi_ci_Vb_ci)/27-((((2*p2_a_Vbi_ci)*tmp)+((2*p2_a)*tmp_Vbi_ci))*0.0+(((((2*p2_a_Vb_ci))*tmp)+((2*p2_a)*tmp_Vb_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ci_Vb_ci*p2_b+p2_a_Vbi_ci*p2_b_Vb_ci+p2_a_Vb_ci*p2_b_Vbi_ci+p2_a*p2_b_Vbi_ci_Vb_ci)*o3+((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci))*0.0+(((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vbi_ci_Vtnode_GND=(+(+((+(+0.0*p2_a+0.0*p2_a_Vtnode_GND+0.0*p2_a_Vbi_ci+2*p2_a_Vbi_ci_Vtnode_GND)*tmp+(2*p2_a_Vbi_ci)*tmp_Vtnode_GND+((2*p2_a_Vtnode_GND))*tmp_Vbi_ci+(2*p2_a)*tmp_Vbi_ci_Vtnode_GND)/27-((((2*p2_a_Vbi_ci)*tmp)+((2*p2_a)*tmp_Vbi_ci))*0.0+(((((2*p2_a_Vtnode_GND))*tmp)+((2*p2_a)*tmp_Vtnode_GND)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ci_Vtnode_GND*p2_b+p2_a_Vbi_ci*p2_b_Vtnode_GND+p2_a_Vtnode_GND*p2_b_Vbi_ci+p2_a*p2_b_Vbi_ci_Vtnode_GND)*o3+((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci))*0.0+(((p2_a_Vtnode_GND*p2_b)+(p2_a*p2_b_Vtnode_GND)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vbi_ci_Vbi_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ci+0.0*p2_a_Vbi_ci+2*p2_a_Vbi_ci_Vbi_ci)*tmp+(2*p2_a_Vbi_ci)*tmp_Vbi_ci+((2*p2_a_Vbi_ci))*tmp_Vbi_ci+(2*p2_a)*tmp_Vbi_ci_Vbi_ci)/27-((((2*p2_a_Vbi_ci)*tmp)+((2*p2_a)*tmp_Vbi_ci))*0.0+(((((2*p2_a_Vbi_ci))*tmp)+((2*p2_a)*tmp_Vbi_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ci_Vbi_ci*p2_b+p2_a_Vbi_ci*p2_b_Vbi_ci+p2_a_Vbi_ci*p2_b_Vbi_ci+p2_a*p2_b_Vbi_ci_Vbi_ci)*o3+((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci))*0.0+(((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vbi_ci_Vbi_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ei+0.0*p2_a_Vbi_ci+2*p2_a_Vbi_ci_Vbi_ei)*tmp+(2*p2_a_Vbi_ci)*tmp_Vbi_ei+((2*p2_a_Vbi_ei))*tmp_Vbi_ci+(2*p2_a)*tmp_Vbi_ci_Vbi_ei)/27-((((2*p2_a_Vbi_ci)*tmp)+((2*p2_a)*tmp_Vbi_ci))*0.0+(((((2*p2_a_Vbi_ei))*tmp)+((2*p2_a)*tmp_Vbi_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ci_Vbi_ei*p2_b+p2_a_Vbi_ci*p2_b_Vbi_ei+p2_a_Vbi_ei*p2_b_Vbi_ci+p2_a*p2_b_Vbi_ci_Vbi_ei)*o3+((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci))*0.0+(((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vbi_ci_Vci_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vci_ei+0.0*p2_a_Vbi_ci+2*p2_a_Vbi_ci_Vci_ei)*tmp+(2*p2_a_Vbi_ci)*tmp_Vci_ei+((2*p2_a_Vci_ei))*tmp_Vbi_ci+(2*p2_a)*tmp_Vbi_ci_Vci_ei)/27-((((2*p2_a_Vbi_ci)*tmp)+((2*p2_a)*tmp_Vbi_ci))*0.0+(((((2*p2_a_Vci_ei))*tmp)+((2*p2_a)*tmp_Vci_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ci_Vci_ei*p2_b+p2_a_Vbi_ci*p2_b_Vci_ei+p2_a_Vci_ei*p2_b_Vbi_ci+p2_a*p2_b_Vbi_ci_Vci_ei)*o3+((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci))*0.0+(((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei)))*0.0+(p2_a*p2_b)*0.0))+0.0);
#endif
p2_q_Vbi_ei=((((((2*p2_a_Vbi_ei)*tmp)+((2*p2_a)*tmp_Vbi_ei))/27)-((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei))*o3)+p2_c_Vbi_ei);
#if defined(_DERIVATE2)
  p2_q_Vbi_ei_Vb_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vb_ci+0.0*p2_a_Vbi_ei+2*p2_a_Vbi_ei_Vb_ci)*tmp+(2*p2_a_Vbi_ei)*tmp_Vb_ci+((2*p2_a_Vb_ci))*tmp_Vbi_ei+(2*p2_a)*tmp_Vbi_ei_Vb_ci)/27-((((2*p2_a_Vbi_ei)*tmp)+((2*p2_a)*tmp_Vbi_ei))*0.0+(((((2*p2_a_Vb_ci))*tmp)+((2*p2_a)*tmp_Vb_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ei_Vb_ci*p2_b+p2_a_Vbi_ei*p2_b_Vb_ci+p2_a_Vb_ci*p2_b_Vbi_ei+p2_a*p2_b_Vbi_ei_Vb_ci)*o3+((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei))*0.0+(((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vbi_ei_Vtnode_GND=(+(+((+(+0.0*p2_a+0.0*p2_a_Vtnode_GND+0.0*p2_a_Vbi_ei+2*p2_a_Vbi_ei_Vtnode_GND)*tmp+(2*p2_a_Vbi_ei)*tmp_Vtnode_GND+((2*p2_a_Vtnode_GND))*tmp_Vbi_ei+(2*p2_a)*tmp_Vbi_ei_Vtnode_GND)/27-((((2*p2_a_Vbi_ei)*tmp)+((2*p2_a)*tmp_Vbi_ei))*0.0+(((((2*p2_a_Vtnode_GND))*tmp)+((2*p2_a)*tmp_Vtnode_GND)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ei_Vtnode_GND*p2_b+p2_a_Vbi_ei*p2_b_Vtnode_GND+p2_a_Vtnode_GND*p2_b_Vbi_ei+p2_a*p2_b_Vbi_ei_Vtnode_GND)*o3+((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei))*0.0+(((p2_a_Vtnode_GND*p2_b)+(p2_a*p2_b_Vtnode_GND)))*0.0+(p2_a*p2_b)*0.0))+p2_c_Vbi_ei_Vtnode_GND);
  p2_q_Vbi_ei_Vbi_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ci+0.0*p2_a_Vbi_ei+2*p2_a_Vbi_ei_Vbi_ci)*tmp+(2*p2_a_Vbi_ei)*tmp_Vbi_ci+((2*p2_a_Vbi_ci))*tmp_Vbi_ei+(2*p2_a)*tmp_Vbi_ei_Vbi_ci)/27-((((2*p2_a_Vbi_ei)*tmp)+((2*p2_a)*tmp_Vbi_ei))*0.0+(((((2*p2_a_Vbi_ci))*tmp)+((2*p2_a)*tmp_Vbi_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ei_Vbi_ci*p2_b+p2_a_Vbi_ei*p2_b_Vbi_ci+p2_a_Vbi_ci*p2_b_Vbi_ei+p2_a*p2_b_Vbi_ei_Vbi_ci)*o3+((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei))*0.0+(((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vbi_ei_Vbi_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ei+0.0*p2_a_Vbi_ei+2*p2_a_Vbi_ei_Vbi_ei)*tmp+(2*p2_a_Vbi_ei)*tmp_Vbi_ei+((2*p2_a_Vbi_ei))*tmp_Vbi_ei+(2*p2_a)*tmp_Vbi_ei_Vbi_ei)/27-((((2*p2_a_Vbi_ei)*tmp)+((2*p2_a)*tmp_Vbi_ei))*0.0+(((((2*p2_a_Vbi_ei))*tmp)+((2*p2_a)*tmp_Vbi_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ei_Vbi_ei*p2_b+p2_a_Vbi_ei*p2_b_Vbi_ei+p2_a_Vbi_ei*p2_b_Vbi_ei+p2_a*p2_b_Vbi_ei_Vbi_ei)*o3+((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei))*0.0+(((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei)))*0.0+(p2_a*p2_b)*0.0))+p2_c_Vbi_ei_Vbi_ei);
  p2_q_Vbi_ei_Vci_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vci_ei+0.0*p2_a_Vbi_ei+2*p2_a_Vbi_ei_Vci_ei)*tmp+(2*p2_a_Vbi_ei)*tmp_Vci_ei+((2*p2_a_Vci_ei))*tmp_Vbi_ei+(2*p2_a)*tmp_Vbi_ei_Vci_ei)/27-((((2*p2_a_Vbi_ei)*tmp)+((2*p2_a)*tmp_Vbi_ei))*0.0+(((((2*p2_a_Vci_ei))*tmp)+((2*p2_a)*tmp_Vci_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vbi_ei_Vci_ei*p2_b+p2_a_Vbi_ei*p2_b_Vci_ei+p2_a_Vci_ei*p2_b_Vbi_ei+p2_a*p2_b_Vbi_ei_Vci_ei)*o3+((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei))*0.0+(((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei)))*0.0+(p2_a*p2_b)*0.0))+p2_c_Vbi_ei_Vci_ei);
#endif
p2_q_Vci_ei=((((((2*p2_a_Vci_ei)*tmp)+((2*p2_a)*tmp_Vci_ei))/27)-((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei))*o3)+p2_c_Vci_ei);
#if defined(_DERIVATE2)
  p2_q_Vci_ei_Vb_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vb_ci+0.0*p2_a_Vci_ei+2*p2_a_Vci_ei_Vb_ci)*tmp+(2*p2_a_Vci_ei)*tmp_Vb_ci+((2*p2_a_Vb_ci))*tmp_Vci_ei+(2*p2_a)*tmp_Vci_ei_Vb_ci)/27-((((2*p2_a_Vci_ei)*tmp)+((2*p2_a)*tmp_Vci_ei))*0.0+(((((2*p2_a_Vb_ci))*tmp)+((2*p2_a)*tmp_Vb_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vci_ei_Vb_ci*p2_b+p2_a_Vci_ei*p2_b_Vb_ci+p2_a_Vb_ci*p2_b_Vci_ei+p2_a*p2_b_Vci_ei_Vb_ci)*o3+((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei))*0.0+(((p2_a_Vb_ci*p2_b)+(p2_a*p2_b_Vb_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vci_ei_Vtnode_GND=(+(+((+(+0.0*p2_a+0.0*p2_a_Vtnode_GND+0.0*p2_a_Vci_ei+2*p2_a_Vci_ei_Vtnode_GND)*tmp+(2*p2_a_Vci_ei)*tmp_Vtnode_GND+((2*p2_a_Vtnode_GND))*tmp_Vci_ei+(2*p2_a)*tmp_Vci_ei_Vtnode_GND)/27-((((2*p2_a_Vci_ei)*tmp)+((2*p2_a)*tmp_Vci_ei))*0.0+(((((2*p2_a_Vtnode_GND))*tmp)+((2*p2_a)*tmp_Vtnode_GND)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vci_ei_Vtnode_GND*p2_b+p2_a_Vci_ei*p2_b_Vtnode_GND+p2_a_Vtnode_GND*p2_b_Vci_ei+p2_a*p2_b_Vci_ei_Vtnode_GND)*o3+((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei))*0.0+(((p2_a_Vtnode_GND*p2_b)+(p2_a*p2_b_Vtnode_GND)))*0.0+(p2_a*p2_b)*0.0))+p2_c_Vci_ei_Vtnode_GND);
  p2_q_Vci_ei_Vbi_ci=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ci+0.0*p2_a_Vci_ei+2*p2_a_Vci_ei_Vbi_ci)*tmp+(2*p2_a_Vci_ei)*tmp_Vbi_ci+((2*p2_a_Vbi_ci))*tmp_Vci_ei+(2*p2_a)*tmp_Vci_ei_Vbi_ci)/27-((((2*p2_a_Vci_ei)*tmp)+((2*p2_a)*tmp_Vci_ei))*0.0+(((((2*p2_a_Vbi_ci))*tmp)+((2*p2_a)*tmp_Vbi_ci)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vci_ei_Vbi_ci*p2_b+p2_a_Vci_ei*p2_b_Vbi_ci+p2_a_Vbi_ci*p2_b_Vci_ei+p2_a*p2_b_Vci_ei_Vbi_ci)*o3+((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei))*0.0+(((p2_a_Vbi_ci*p2_b)+(p2_a*p2_b_Vbi_ci)))*0.0+(p2_a*p2_b)*0.0))+0.0);
  p2_q_Vci_ei_Vbi_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vbi_ei+0.0*p2_a_Vci_ei+2*p2_a_Vci_ei_Vbi_ei)*tmp+(2*p2_a_Vci_ei)*tmp_Vbi_ei+((2*p2_a_Vbi_ei))*tmp_Vci_ei+(2*p2_a)*tmp_Vci_ei_Vbi_ei)/27-((((2*p2_a_Vci_ei)*tmp)+((2*p2_a)*tmp_Vci_ei))*0.0+(((((2*p2_a_Vbi_ei))*tmp)+((2*p2_a)*tmp_Vbi_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vci_ei_Vbi_ei*p2_b+p2_a_Vci_ei*p2_b_Vbi_ei+p2_a_Vbi_ei*p2_b_Vci_ei+p2_a*p2_b_Vci_ei_Vbi_ei)*o3+((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei))*0.0+(((p2_a_Vbi_ei*p2_b)+(p2_a*p2_b_Vbi_ei)))*0.0+(p2_a*p2_b)*0.0))+p2_c_Vci_ei_Vbi_ei);
  p2_q_Vci_ei_Vci_ei=(+(+((+(+0.0*p2_a+0.0*p2_a_Vci_ei+0.0*p2_a_Vci_ei+2*p2_a_Vci_ei_Vci_ei)*tmp+(2*p2_a_Vci_ei)*tmp_Vci_ei+((2*p2_a_Vci_ei))*tmp_Vci_ei+(2*p2_a)*tmp_Vci_ei_Vci_ei)/27-((((2*p2_a_Vci_ei)*tmp)+((2*p2_a)*tmp_Vci_ei))*0.0+(((((2*p2_a_Vci_ei))*tmp)+((2*p2_a)*tmp_Vci_ei)))*0.0+((2*p2_a)*tmp)*0.0)/27/27+2*((2*p2_a)*tmp)*0.0*0.0/27/27/27)-(+(+p2_a_Vci_ei_Vci_ei*p2_b+p2_a_Vci_ei*p2_b_Vci_ei+p2_a_Vci_ei*p2_b_Vci_ei+p2_a*p2_b_Vci_ei_Vci_ei)*o3+((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei))*0.0+(((p2_a_Vci_ei*p2_b)+(p2_a*p2_b_Vci_ei)))*0.0+(p2_a*p2_b)*0.0))+p2_c_Vci_ei_Vci_ei);
#endif
#endif
p2_q=(((((2*p2_a)*tmp)/27)-((p2_a*p2_b)*o3))+p2_c);
EXIT_IF_ISNAN((((((2*p2_a)*tmp)/27)-((p2_a*p2_b)*o3))+p2_c))
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
p2_D_Vb_ci=(((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci))*0.25+(((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/27));
#if defined(_DERIVATE2)
  p2_D_Vb_ci_Vb_ci=(+(+(+p2_q_Vb_ci_Vb_ci*p2_q+p2_q_Vb_ci*p2_q_Vb_ci+p2_q_Vb_ci*p2_q_Vb_ci+p2_q*p2_q_Vb_ci_Vb_ci)*0.25+((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci))*0.0+(((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vb_ci_Vb_ci*p2_p+p2_p_Vb_ci*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vb_ci)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vb_ci)/27-(((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*0.0+((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vb_ci_Vtnode_GND=(+(+(+p2_q_Vb_ci_Vtnode_GND*p2_q+p2_q_Vb_ci*p2_q_Vtnode_GND+p2_q_Vtnode_GND*p2_q_Vb_ci+p2_q*p2_q_Vb_ci_Vtnode_GND)*0.25+((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci))*0.0+(((p2_q_Vtnode_GND*p2_q)+(p2_q*p2_q_Vtnode_GND)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vb_ci_Vtnode_GND*p2_p+p2_p_Vb_ci*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vtnode_GND)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vtnode_GND)/27-(((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*0.0+((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vb_ci_Vbi_ci=(+(+(+p2_q_Vb_ci_Vbi_ci*p2_q+p2_q_Vb_ci*p2_q_Vbi_ci+p2_q_Vbi_ci*p2_q_Vb_ci+p2_q*p2_q_Vb_ci_Vbi_ci)*0.25+((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci))*0.0+(((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vb_ci_Vbi_ci*p2_p+p2_p_Vb_ci*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vbi_ci)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vbi_ci)/27-(((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*0.0+((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vb_ci_Vbi_ei=(+(+(+p2_q_Vb_ci_Vbi_ei*p2_q+p2_q_Vb_ci*p2_q_Vbi_ei+p2_q_Vbi_ei*p2_q_Vb_ci+p2_q*p2_q_Vb_ci_Vbi_ei)*0.25+((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci))*0.0+(((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vb_ci_Vbi_ei*p2_p+p2_p_Vb_ci*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vbi_ei)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vbi_ei)/27-(((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*0.0+((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vb_ci_Vci_ei=(+(+(+p2_q_Vb_ci_Vci_ei*p2_q+p2_q_Vb_ci*p2_q_Vci_ei+p2_q_Vci_ei*p2_q_Vb_ci+p2_q*p2_q_Vb_ci_Vci_ei)*0.25+((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci))*0.0+(((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vb_ci_Vci_ei*p2_p+p2_p_Vb_ci*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vci_ei)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vci_ei)/27-(((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*0.0+((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
#endif
#if defined(_DERIVATE)
p2_D_Vtnode_GND=(((p2_q_Vtnode_GND*p2_q)+(p2_q*p2_q_Vtnode_GND))*0.25+(((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND))/27));
#endif
p2_D_Vbi_ci=(((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci))*0.25+(((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/27));
#if defined(_DERIVATE2)
  p2_D_Vbi_ci_Vb_ci=(+(+(+p2_q_Vbi_ci_Vb_ci*p2_q+p2_q_Vbi_ci*p2_q_Vb_ci+p2_q_Vb_ci*p2_q_Vbi_ci+p2_q*p2_q_Vbi_ci_Vb_ci)*0.25+((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci))*0.0+(((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ci_Vb_ci*p2_p+p2_p_Vbi_ci*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vb_ci)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vb_ci)/27-(((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*0.0+((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ci_Vtnode_GND=(+(+(+p2_q_Vbi_ci_Vtnode_GND*p2_q+p2_q_Vbi_ci*p2_q_Vtnode_GND+p2_q_Vtnode_GND*p2_q_Vbi_ci+p2_q*p2_q_Vbi_ci_Vtnode_GND)*0.25+((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci))*0.0+(((p2_q_Vtnode_GND*p2_q)+(p2_q*p2_q_Vtnode_GND)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ci_Vtnode_GND*p2_p+p2_p_Vbi_ci*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vtnode_GND)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vtnode_GND)/27-(((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*0.0+((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ci_Vbi_ci=(+(+(+p2_q_Vbi_ci_Vbi_ci*p2_q+p2_q_Vbi_ci*p2_q_Vbi_ci+p2_q_Vbi_ci*p2_q_Vbi_ci+p2_q*p2_q_Vbi_ci_Vbi_ci)*0.25+((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci))*0.0+(((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ci_Vbi_ci*p2_p+p2_p_Vbi_ci*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vbi_ci)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vbi_ci)/27-(((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*0.0+((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ci_Vbi_ei=(+(+(+p2_q_Vbi_ci_Vbi_ei*p2_q+p2_q_Vbi_ci*p2_q_Vbi_ei+p2_q_Vbi_ei*p2_q_Vbi_ci+p2_q*p2_q_Vbi_ci_Vbi_ei)*0.25+((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci))*0.0+(((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ci_Vbi_ei*p2_p+p2_p_Vbi_ci*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vbi_ei)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vbi_ei)/27-(((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*0.0+((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ci_Vci_ei=(+(+(+p2_q_Vbi_ci_Vci_ei*p2_q+p2_q_Vbi_ci*p2_q_Vci_ei+p2_q_Vci_ei*p2_q_Vbi_ci+p2_q*p2_q_Vbi_ci_Vci_ei)*0.25+((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci))*0.0+(((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ci_Vci_ei*p2_p+p2_p_Vbi_ci*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vci_ei)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vci_ei)/27-(((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*0.0+((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
#endif
p2_D_Vbi_ei=(((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei))*0.25+(((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/27));
#if defined(_DERIVATE2)
  p2_D_Vbi_ei_Vb_ci=(+(+(+p2_q_Vbi_ei_Vb_ci*p2_q+p2_q_Vbi_ei*p2_q_Vb_ci+p2_q_Vb_ci*p2_q_Vbi_ei+p2_q*p2_q_Vbi_ei_Vb_ci)*0.25+((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei))*0.0+(((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ei_Vb_ci*p2_p+p2_p_Vbi_ei*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vb_ci)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vb_ci)/27-(((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*0.0+((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ei_Vtnode_GND=(+(+(+p2_q_Vbi_ei_Vtnode_GND*p2_q+p2_q_Vbi_ei*p2_q_Vtnode_GND+p2_q_Vtnode_GND*p2_q_Vbi_ei+p2_q*p2_q_Vbi_ei_Vtnode_GND)*0.25+((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei))*0.0+(((p2_q_Vtnode_GND*p2_q)+(p2_q*p2_q_Vtnode_GND)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ei_Vtnode_GND*p2_p+p2_p_Vbi_ei*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vtnode_GND)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vtnode_GND)/27-(((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*0.0+((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ei_Vbi_ci=(+(+(+p2_q_Vbi_ei_Vbi_ci*p2_q+p2_q_Vbi_ei*p2_q_Vbi_ci+p2_q_Vbi_ci*p2_q_Vbi_ei+p2_q*p2_q_Vbi_ei_Vbi_ci)*0.25+((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei))*0.0+(((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ei_Vbi_ci*p2_p+p2_p_Vbi_ei*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vbi_ci)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vbi_ci)/27-(((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*0.0+((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ei_Vbi_ei=(+(+(+p2_q_Vbi_ei_Vbi_ei*p2_q+p2_q_Vbi_ei*p2_q_Vbi_ei+p2_q_Vbi_ei*p2_q_Vbi_ei+p2_q*p2_q_Vbi_ei_Vbi_ei)*0.25+((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei))*0.0+(((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ei_Vbi_ei*p2_p+p2_p_Vbi_ei*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vbi_ei)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vbi_ei)/27-(((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*0.0+((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vbi_ei_Vci_ei=(+(+(+p2_q_Vbi_ei_Vci_ei*p2_q+p2_q_Vbi_ei*p2_q_Vci_ei+p2_q_Vci_ei*p2_q_Vbi_ei+p2_q*p2_q_Vbi_ei_Vci_ei)*0.25+((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei))*0.0+(((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vbi_ei_Vci_ei*p2_p+p2_p_Vbi_ei*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vci_ei)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vci_ei)/27-(((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*0.0+((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
#endif
p2_D_Vci_ei=(((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei))*0.25+(((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/27));
#if defined(_DERIVATE2)
  p2_D_Vci_ei_Vb_ci=(+(+(+p2_q_Vci_ei_Vb_ci*p2_q+p2_q_Vci_ei*p2_q_Vb_ci+p2_q_Vb_ci*p2_q_Vci_ei+p2_q*p2_q_Vci_ei_Vb_ci)*0.25+((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei))*0.0+(((p2_q_Vb_ci*p2_q)+(p2_q*p2_q_Vb_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vci_ei_Vb_ci*p2_p+p2_p_Vci_ei*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vb_ci)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vb_ci)/27-(((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*0.0+((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vci_ei_Vtnode_GND=(+(+(+p2_q_Vci_ei_Vtnode_GND*p2_q+p2_q_Vci_ei*p2_q_Vtnode_GND+p2_q_Vtnode_GND*p2_q_Vci_ei+p2_q*p2_q_Vci_ei_Vtnode_GND)*0.25+((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei))*0.0+(((p2_q_Vtnode_GND*p2_q)+(p2_q*p2_q_Vtnode_GND)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vci_ei_Vtnode_GND*p2_p+p2_p_Vci_ei*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vtnode_GND)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vtnode_GND)/27-(((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*0.0+((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vci_ei_Vbi_ci=(+(+(+p2_q_Vci_ei_Vbi_ci*p2_q+p2_q_Vci_ei*p2_q_Vbi_ci+p2_q_Vbi_ci*p2_q_Vci_ei+p2_q*p2_q_Vci_ei_Vbi_ci)*0.25+((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei))*0.0+(((p2_q_Vbi_ci*p2_q)+(p2_q*p2_q_Vbi_ci)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vci_ei_Vbi_ci*p2_p+p2_p_Vci_ei*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vbi_ci)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vbi_ci)/27-(((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*0.0+((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vci_ei_Vbi_ei=(+(+(+p2_q_Vci_ei_Vbi_ei*p2_q+p2_q_Vci_ei*p2_q_Vbi_ei+p2_q_Vbi_ei*p2_q_Vci_ei+p2_q*p2_q_Vci_ei_Vbi_ei)*0.25+((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei))*0.0+(((p2_q_Vbi_ei*p2_q)+(p2_q*p2_q_Vbi_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vci_ei_Vbi_ei*p2_p+p2_p_Vci_ei*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vbi_ei)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vbi_ei)/27-(((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*0.0+((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
  p2_D_Vci_ei_Vci_ei=(+(+(+p2_q_Vci_ei_Vci_ei*p2_q+p2_q_Vci_ei*p2_q_Vci_ei+p2_q_Vci_ei*p2_q_Vci_ei+p2_q*p2_q_Vci_ei_Vci_ei)*0.25+((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei))*0.0+(((p2_q_Vci_ei*p2_q)+(p2_q*p2_q_Vci_ei)))*0.0+(p2_q*p2_q)*0.0)+((+(+p2_p_Vci_ei_Vci_ei*p2_p+p2_p_Vci_ei*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vci_ei)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vci_ei)/27-(((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*0.0+((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))*0.0+((p2_p*p2_p)*p2_p)*0.0)/27/27+2*((p2_p*p2_p)*p2_p)*0.0*0.0/27/27/27));
#endif
#endif
p2_D=(((p2_q*p2_q)*0.25)+(((p2_p*p2_p)*p2_p)/27));
EXIT_IF_ISNAN((((p2_q*p2_q)*0.25)+(((p2_p*p2_p)*p2_p)/27)))
{
double m00_fabs(d00_fabs0,p2_D)
if
((d00_fabs0<1e-10))
{
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
q_p3_Vb_ci=((((3*p2_q_Vb_ci)*p2_p-(3*p2_q)*p2_p_Vb_ci)/p2_p/p2_p)-p2_a_Vb_ci*o3);
#if defined(_DERIVATE2)
  q_p3_Vb_ci_Vb_ci=(+((+0.0*p2_q+0.0*p2_q_Vb_ci+0.0*p2_q_Vb_ci+3*p2_q_Vb_ci_Vb_ci)/p2_p-((3*p2_q_Vb_ci)*p2_p_Vb_ci+((3*p2_q_Vb_ci))*p2_p_Vb_ci+(3*p2_q)*p2_p_Vb_ci_Vb_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vb_ci*p2_p_Vb_ci/p2_p/p2_p/p2_p)-(+p2_a_Vb_ci_Vb_ci*o3+p2_a_Vb_ci*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vtnode_GND=(+((+0.0*p2_q+0.0*p2_q_Vtnode_GND+0.0*p2_q_Vb_ci+3*p2_q_Vb_ci_Vtnode_GND)/p2_p-((3*p2_q_Vb_ci)*p2_p_Vtnode_GND+((3*p2_q_Vtnode_GND))*p2_p_Vb_ci+(3*p2_q)*p2_p_Vb_ci_Vtnode_GND)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vb_ci*p2_p_Vtnode_GND/p2_p/p2_p/p2_p)-(+p2_a_Vb_ci_Vtnode_GND*o3+p2_a_Vb_ci*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vbi_ci=(+((+0.0*p2_q+0.0*p2_q_Vbi_ci+0.0*p2_q_Vb_ci+3*p2_q_Vb_ci_Vbi_ci)/p2_p-((3*p2_q_Vb_ci)*p2_p_Vbi_ci+((3*p2_q_Vbi_ci))*p2_p_Vb_ci+(3*p2_q)*p2_p_Vb_ci_Vbi_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vb_ci*p2_p_Vbi_ci/p2_p/p2_p/p2_p)-(+p2_a_Vb_ci_Vbi_ci*o3+p2_a_Vb_ci*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vbi_ei=(+((+0.0*p2_q+0.0*p2_q_Vbi_ei+0.0*p2_q_Vb_ci+3*p2_q_Vb_ci_Vbi_ei)/p2_p-((3*p2_q_Vb_ci)*p2_p_Vbi_ei+((3*p2_q_Vbi_ei))*p2_p_Vb_ci+(3*p2_q)*p2_p_Vb_ci_Vbi_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vb_ci*p2_p_Vbi_ei/p2_p/p2_p/p2_p)-(+p2_a_Vb_ci_Vbi_ei*o3+p2_a_Vb_ci*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vci_ei=(+((+0.0*p2_q+0.0*p2_q_Vci_ei+0.0*p2_q_Vb_ci+3*p2_q_Vb_ci_Vci_ei)/p2_p-((3*p2_q_Vb_ci)*p2_p_Vci_ei+((3*p2_q_Vci_ei))*p2_p_Vb_ci+(3*p2_q)*p2_p_Vb_ci_Vci_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vb_ci*p2_p_Vci_ei/p2_p/p2_p/p2_p)-(+p2_a_Vb_ci_Vci_ei*o3+p2_a_Vb_ci*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
#if defined(_DERIVATE)
q_p3_Vtnode_GND=((((3*p2_q_Vtnode_GND)*p2_p-(3*p2_q)*p2_p_Vtnode_GND)/p2_p/p2_p)-p2_a_Vtnode_GND*o3);
#endif
q_p3_Vbi_ci=((((3*p2_q_Vbi_ci)*p2_p-(3*p2_q)*p2_p_Vbi_ci)/p2_p/p2_p)-p2_a_Vbi_ci*o3);
#if defined(_DERIVATE2)
  q_p3_Vbi_ci_Vb_ci=(+((+0.0*p2_q+0.0*p2_q_Vb_ci+0.0*p2_q_Vbi_ci+3*p2_q_Vbi_ci_Vb_ci)/p2_p-((3*p2_q_Vbi_ci)*p2_p_Vb_ci+((3*p2_q_Vb_ci))*p2_p_Vbi_ci+(3*p2_q)*p2_p_Vbi_ci_Vb_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ci*p2_p_Vb_ci/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ci_Vb_ci*o3+p2_a_Vbi_ci*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vtnode_GND=(+((+0.0*p2_q+0.0*p2_q_Vtnode_GND+0.0*p2_q_Vbi_ci+3*p2_q_Vbi_ci_Vtnode_GND)/p2_p-((3*p2_q_Vbi_ci)*p2_p_Vtnode_GND+((3*p2_q_Vtnode_GND))*p2_p_Vbi_ci+(3*p2_q)*p2_p_Vbi_ci_Vtnode_GND)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ci*p2_p_Vtnode_GND/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ci_Vtnode_GND*o3+p2_a_Vbi_ci*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vbi_ci=(+((+0.0*p2_q+0.0*p2_q_Vbi_ci+0.0*p2_q_Vbi_ci+3*p2_q_Vbi_ci_Vbi_ci)/p2_p-((3*p2_q_Vbi_ci)*p2_p_Vbi_ci+((3*p2_q_Vbi_ci))*p2_p_Vbi_ci+(3*p2_q)*p2_p_Vbi_ci_Vbi_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ci*p2_p_Vbi_ci/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ci_Vbi_ci*o3+p2_a_Vbi_ci*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vbi_ei=(+((+0.0*p2_q+0.0*p2_q_Vbi_ei+0.0*p2_q_Vbi_ci+3*p2_q_Vbi_ci_Vbi_ei)/p2_p-((3*p2_q_Vbi_ci)*p2_p_Vbi_ei+((3*p2_q_Vbi_ei))*p2_p_Vbi_ci+(3*p2_q)*p2_p_Vbi_ci_Vbi_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ci*p2_p_Vbi_ei/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ci_Vbi_ei*o3+p2_a_Vbi_ci*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vci_ei=(+((+0.0*p2_q+0.0*p2_q_Vci_ei+0.0*p2_q_Vbi_ci+3*p2_q_Vbi_ci_Vci_ei)/p2_p-((3*p2_q_Vbi_ci)*p2_p_Vci_ei+((3*p2_q_Vci_ei))*p2_p_Vbi_ci+(3*p2_q)*p2_p_Vbi_ci_Vci_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ci*p2_p_Vci_ei/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ci_Vci_ei*o3+p2_a_Vbi_ci*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
q_p3_Vbi_ei=((((3*p2_q_Vbi_ei)*p2_p-(3*p2_q)*p2_p_Vbi_ei)/p2_p/p2_p)-p2_a_Vbi_ei*o3);
#if defined(_DERIVATE2)
  q_p3_Vbi_ei_Vb_ci=(+((+0.0*p2_q+0.0*p2_q_Vb_ci+0.0*p2_q_Vbi_ei+3*p2_q_Vbi_ei_Vb_ci)/p2_p-((3*p2_q_Vbi_ei)*p2_p_Vb_ci+((3*p2_q_Vb_ci))*p2_p_Vbi_ei+(3*p2_q)*p2_p_Vbi_ei_Vb_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ei*p2_p_Vb_ci/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ei_Vb_ci*o3+p2_a_Vbi_ei*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vtnode_GND=(+((+0.0*p2_q+0.0*p2_q_Vtnode_GND+0.0*p2_q_Vbi_ei+3*p2_q_Vbi_ei_Vtnode_GND)/p2_p-((3*p2_q_Vbi_ei)*p2_p_Vtnode_GND+((3*p2_q_Vtnode_GND))*p2_p_Vbi_ei+(3*p2_q)*p2_p_Vbi_ei_Vtnode_GND)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ei*p2_p_Vtnode_GND/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ei_Vtnode_GND*o3+p2_a_Vbi_ei*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vbi_ci=(+((+0.0*p2_q+0.0*p2_q_Vbi_ci+0.0*p2_q_Vbi_ei+3*p2_q_Vbi_ei_Vbi_ci)/p2_p-((3*p2_q_Vbi_ei)*p2_p_Vbi_ci+((3*p2_q_Vbi_ci))*p2_p_Vbi_ei+(3*p2_q)*p2_p_Vbi_ei_Vbi_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ei*p2_p_Vbi_ci/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ei_Vbi_ci*o3+p2_a_Vbi_ei*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vbi_ei=(+((+0.0*p2_q+0.0*p2_q_Vbi_ei+0.0*p2_q_Vbi_ei+3*p2_q_Vbi_ei_Vbi_ei)/p2_p-((3*p2_q_Vbi_ei)*p2_p_Vbi_ei+((3*p2_q_Vbi_ei))*p2_p_Vbi_ei+(3*p2_q)*p2_p_Vbi_ei_Vbi_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ei*p2_p_Vbi_ei/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ei_Vbi_ei*o3+p2_a_Vbi_ei*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vci_ei=(+((+0.0*p2_q+0.0*p2_q_Vci_ei+0.0*p2_q_Vbi_ei+3*p2_q_Vbi_ei_Vci_ei)/p2_p-((3*p2_q_Vbi_ei)*p2_p_Vci_ei+((3*p2_q_Vci_ei))*p2_p_Vbi_ei+(3*p2_q)*p2_p_Vbi_ei_Vci_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vbi_ei*p2_p_Vci_ei/p2_p/p2_p/p2_p)-(+p2_a_Vbi_ei_Vci_ei*o3+p2_a_Vbi_ei*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
q_p3_Vci_ei=((((3*p2_q_Vci_ei)*p2_p-(3*p2_q)*p2_p_Vci_ei)/p2_p/p2_p)-p2_a_Vci_ei*o3);
#if defined(_DERIVATE2)
  q_p3_Vci_ei_Vb_ci=(+((+0.0*p2_q+0.0*p2_q_Vb_ci+0.0*p2_q_Vci_ei+3*p2_q_Vci_ei_Vb_ci)/p2_p-((3*p2_q_Vci_ei)*p2_p_Vb_ci+((3*p2_q_Vb_ci))*p2_p_Vci_ei+(3*p2_q)*p2_p_Vci_ei_Vb_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vci_ei*p2_p_Vb_ci/p2_p/p2_p/p2_p)-(+p2_a_Vci_ei_Vb_ci*o3+p2_a_Vci_ei*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vtnode_GND=(+((+0.0*p2_q+0.0*p2_q_Vtnode_GND+0.0*p2_q_Vci_ei+3*p2_q_Vci_ei_Vtnode_GND)/p2_p-((3*p2_q_Vci_ei)*p2_p_Vtnode_GND+((3*p2_q_Vtnode_GND))*p2_p_Vci_ei+(3*p2_q)*p2_p_Vci_ei_Vtnode_GND)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vci_ei*p2_p_Vtnode_GND/p2_p/p2_p/p2_p)-(+p2_a_Vci_ei_Vtnode_GND*o3+p2_a_Vci_ei*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vbi_ci=(+((+0.0*p2_q+0.0*p2_q_Vbi_ci+0.0*p2_q_Vci_ei+3*p2_q_Vci_ei_Vbi_ci)/p2_p-((3*p2_q_Vci_ei)*p2_p_Vbi_ci+((3*p2_q_Vbi_ci))*p2_p_Vci_ei+(3*p2_q)*p2_p_Vci_ei_Vbi_ci)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vci_ei*p2_p_Vbi_ci/p2_p/p2_p/p2_p)-(+p2_a_Vci_ei_Vbi_ci*o3+p2_a_Vci_ei*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vbi_ei=(+((+0.0*p2_q+0.0*p2_q_Vbi_ei+0.0*p2_q_Vci_ei+3*p2_q_Vci_ei_Vbi_ei)/p2_p-((3*p2_q_Vci_ei)*p2_p_Vbi_ei+((3*p2_q_Vbi_ei))*p2_p_Vci_ei+(3*p2_q)*p2_p_Vci_ei_Vbi_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vci_ei*p2_p_Vbi_ei/p2_p/p2_p/p2_p)-(+p2_a_Vci_ei_Vbi_ei*o3+p2_a_Vci_ei*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vci_ei=(+((+0.0*p2_q+0.0*p2_q_Vci_ei+0.0*p2_q_Vci_ei+3*p2_q_Vci_ei_Vci_ei)/p2_p-((3*p2_q_Vci_ei)*p2_p_Vci_ei+((3*p2_q_Vci_ei))*p2_p_Vci_ei+(3*p2_q)*p2_p_Vci_ei_Vci_ei)/p2_p/p2_p+2*(3*p2_q)*p2_p_Vci_ei*p2_p_Vci_ei/p2_p/p2_p/p2_p)-(+p2_a_Vci_ei_Vci_ei*o3+p2_a_Vci_ei*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
#endif
q_p3=(((3*p2_q)/p2_p)-(p2_a*o3));
EXIT_IF_ISNAN((((3*p2_q)/p2_p)-(p2_a*o3)))
}
else
{
if
((p2_D>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
tmp2_Vb_ci=(-p2_q_Vb_ci)*0.5;
#if defined(_DERIVATE2)
  tmp2_Vb_ci_Vb_ci=(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vb_ci_Vtnode_GND=(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0);
  tmp2_Vb_ci_Vbi_ci=(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vb_ci_Vbi_ei=(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0);
  tmp2_Vb_ci_Vci_ei=(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0);
#endif
#if defined(_DERIVATE)
tmp2_Vtnode_GND=(-p2_q_Vtnode_GND)*0.5;
#endif
tmp2_Vbi_ci=(-p2_q_Vbi_ci)*0.5;
#if defined(_DERIVATE2)
  tmp2_Vbi_ci_Vb_ci=(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ci_Vtnode_GND=(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ci_Vbi_ci=(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ci_Vbi_ei=(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ci_Vci_ei=(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0);
#endif
tmp2_Vbi_ei=(-p2_q_Vbi_ei)*0.5;
#if defined(_DERIVATE2)
  tmp2_Vbi_ei_Vb_ci=(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ei_Vtnode_GND=(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ei_Vbi_ci=(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ei_Vbi_ei=(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0);
  tmp2_Vbi_ei_Vci_ei=(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0);
#endif
tmp2_Vci_ei=(-p2_q_Vci_ei)*0.5;
#if defined(_DERIVATE2)
  tmp2_Vci_ei_Vb_ci=(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vci_ei_Vtnode_GND=(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0);
  tmp2_Vci_ei_Vbi_ci=(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0);
  tmp2_Vci_ei_Vbi_ei=(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0);
  tmp2_Vci_ei_Vci_ei=(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0);
#endif
#endif
tmp2=((-p2_q)*0.5);
EXIT_IF_ISNAN(((-p2_q)*0.5))
{
double m00_sqrt(d00_sqrt0,p2_D)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,p2_D)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
tmp3_Vb_ci=p2_D_Vb_ci*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp3_Vb_ci_Vb_ci=(m20_sqrt(p2_D)*p2_D_Vb_ci*p2_D_Vb_ci+d10_sqrt0*p2_D_Vb_ci_Vb_ci);
  tmp3_Vb_ci_Vtnode_GND=(m20_sqrt(p2_D)*p2_D_Vtnode_GND*p2_D_Vb_ci+d10_sqrt0*p2_D_Vb_ci_Vtnode_GND);
  tmp3_Vb_ci_Vbi_ci=(m20_sqrt(p2_D)*p2_D_Vbi_ci*p2_D_Vb_ci+d10_sqrt0*p2_D_Vb_ci_Vbi_ci);
  tmp3_Vb_ci_Vbi_ei=(m20_sqrt(p2_D)*p2_D_Vbi_ei*p2_D_Vb_ci+d10_sqrt0*p2_D_Vb_ci_Vbi_ei);
  tmp3_Vb_ci_Vci_ei=(m20_sqrt(p2_D)*p2_D_Vci_ei*p2_D_Vb_ci+d10_sqrt0*p2_D_Vb_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
tmp3_Vtnode_GND=p2_D_Vtnode_GND*d10_sqrt0;
#endif
tmp3_Vbi_ci=p2_D_Vbi_ci*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp3_Vbi_ci_Vb_ci=(m20_sqrt(p2_D)*p2_D_Vb_ci*p2_D_Vbi_ci+d10_sqrt0*p2_D_Vbi_ci_Vb_ci);
  tmp3_Vbi_ci_Vtnode_GND=(m20_sqrt(p2_D)*p2_D_Vtnode_GND*p2_D_Vbi_ci+d10_sqrt0*p2_D_Vbi_ci_Vtnode_GND);
  tmp3_Vbi_ci_Vbi_ci=(m20_sqrt(p2_D)*p2_D_Vbi_ci*p2_D_Vbi_ci+d10_sqrt0*p2_D_Vbi_ci_Vbi_ci);
  tmp3_Vbi_ci_Vbi_ei=(m20_sqrt(p2_D)*p2_D_Vbi_ei*p2_D_Vbi_ci+d10_sqrt0*p2_D_Vbi_ci_Vbi_ei);
  tmp3_Vbi_ci_Vci_ei=(m20_sqrt(p2_D)*p2_D_Vci_ei*p2_D_Vbi_ci+d10_sqrt0*p2_D_Vbi_ci_Vci_ei);
#endif
tmp3_Vbi_ei=p2_D_Vbi_ei*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp3_Vbi_ei_Vb_ci=(m20_sqrt(p2_D)*p2_D_Vb_ci*p2_D_Vbi_ei+d10_sqrt0*p2_D_Vbi_ei_Vb_ci);
  tmp3_Vbi_ei_Vtnode_GND=(m20_sqrt(p2_D)*p2_D_Vtnode_GND*p2_D_Vbi_ei+d10_sqrt0*p2_D_Vbi_ei_Vtnode_GND);
  tmp3_Vbi_ei_Vbi_ci=(m20_sqrt(p2_D)*p2_D_Vbi_ci*p2_D_Vbi_ei+d10_sqrt0*p2_D_Vbi_ei_Vbi_ci);
  tmp3_Vbi_ei_Vbi_ei=(m20_sqrt(p2_D)*p2_D_Vbi_ei*p2_D_Vbi_ei+d10_sqrt0*p2_D_Vbi_ei_Vbi_ei);
  tmp3_Vbi_ei_Vci_ei=(m20_sqrt(p2_D)*p2_D_Vci_ei*p2_D_Vbi_ei+d10_sqrt0*p2_D_Vbi_ei_Vci_ei);
#endif
tmp3_Vci_ei=p2_D_Vci_ei*d10_sqrt0;
#if defined(_DERIVATE2)
  tmp3_Vci_ei_Vb_ci=(m20_sqrt(p2_D)*p2_D_Vb_ci*p2_D_Vci_ei+d10_sqrt0*p2_D_Vci_ei_Vb_ci);
  tmp3_Vci_ei_Vtnode_GND=(m20_sqrt(p2_D)*p2_D_Vtnode_GND*p2_D_Vci_ei+d10_sqrt0*p2_D_Vci_ei_Vtnode_GND);
  tmp3_Vci_ei_Vbi_ci=(m20_sqrt(p2_D)*p2_D_Vbi_ci*p2_D_Vci_ei+d10_sqrt0*p2_D_Vci_ei_Vbi_ci);
  tmp3_Vci_ei_Vbi_ei=(m20_sqrt(p2_D)*p2_D_Vbi_ei*p2_D_Vci_ei+d10_sqrt0*p2_D_Vci_ei_Vbi_ei);
  tmp3_Vci_ei_Vci_ei=(m20_sqrt(p2_D)*p2_D_Vci_ei*p2_D_Vci_ei+d10_sqrt0*p2_D_Vci_ei_Vci_ei);
#endif
#endif
tmp3=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
tmp_Vb_ci=(tmp2_Vb_ci+tmp3_Vb_ci);
#if defined(_DERIVATE2)
  tmp_Vb_ci_Vb_ci=(+tmp2_Vb_ci_Vb_ci+tmp3_Vb_ci_Vb_ci);
  tmp_Vb_ci_Vtnode_GND=(+tmp2_Vb_ci_Vtnode_GND+tmp3_Vb_ci_Vtnode_GND);
  tmp_Vb_ci_Vbi_ci=(+tmp2_Vb_ci_Vbi_ci+tmp3_Vb_ci_Vbi_ci);
  tmp_Vb_ci_Vbi_ei=(+tmp2_Vb_ci_Vbi_ei+tmp3_Vb_ci_Vbi_ei);
  tmp_Vb_ci_Vci_ei=(+tmp2_Vb_ci_Vci_ei+tmp3_Vb_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
tmp_Vtnode_GND=(tmp2_Vtnode_GND+tmp3_Vtnode_GND);
#endif
tmp_Vbi_ci=(tmp2_Vbi_ci+tmp3_Vbi_ci);
#if defined(_DERIVATE2)
  tmp_Vbi_ci_Vb_ci=(+tmp2_Vbi_ci_Vb_ci+tmp3_Vbi_ci_Vb_ci);
  tmp_Vbi_ci_Vtnode_GND=(+tmp2_Vbi_ci_Vtnode_GND+tmp3_Vbi_ci_Vtnode_GND);
  tmp_Vbi_ci_Vbi_ci=(+tmp2_Vbi_ci_Vbi_ci+tmp3_Vbi_ci_Vbi_ci);
  tmp_Vbi_ci_Vbi_ei=(+tmp2_Vbi_ci_Vbi_ei+tmp3_Vbi_ci_Vbi_ei);
  tmp_Vbi_ci_Vci_ei=(+tmp2_Vbi_ci_Vci_ei+tmp3_Vbi_ci_Vci_ei);
#endif
tmp_Vbi_ei=(tmp2_Vbi_ei+tmp3_Vbi_ei);
#if defined(_DERIVATE2)
  tmp_Vbi_ei_Vb_ci=(+tmp2_Vbi_ei_Vb_ci+tmp3_Vbi_ei_Vb_ci);
  tmp_Vbi_ei_Vtnode_GND=(+tmp2_Vbi_ei_Vtnode_GND+tmp3_Vbi_ei_Vtnode_GND);
  tmp_Vbi_ei_Vbi_ci=(+tmp2_Vbi_ei_Vbi_ci+tmp3_Vbi_ei_Vbi_ci);
  tmp_Vbi_ei_Vbi_ei=(+tmp2_Vbi_ei_Vbi_ei+tmp3_Vbi_ei_Vbi_ei);
  tmp_Vbi_ei_Vci_ei=(+tmp2_Vbi_ei_Vci_ei+tmp3_Vbi_ei_Vci_ei);
#endif
tmp_Vci_ei=(tmp2_Vci_ei+tmp3_Vci_ei);
#if defined(_DERIVATE2)
  tmp_Vci_ei_Vb_ci=(+tmp2_Vci_ei_Vb_ci+tmp3_Vci_ei_Vb_ci);
  tmp_Vci_ei_Vtnode_GND=(+tmp2_Vci_ei_Vtnode_GND+tmp3_Vci_ei_Vtnode_GND);
  tmp_Vci_ei_Vbi_ci=(+tmp2_Vci_ei_Vbi_ci+tmp3_Vci_ei_Vbi_ci);
  tmp_Vci_ei_Vbi_ei=(+tmp2_Vci_ei_Vbi_ei+tmp3_Vci_ei_Vbi_ei);
  tmp_Vci_ei_Vci_ei=(+tmp2_Vci_ei_Vci_ei+tmp3_Vci_ei_Vci_ei);
#endif
#endif
tmp=(tmp2+tmp3);
EXIT_IF_ISNAN((tmp2+tmp3))
if
((tmp>0))
{
{
double m00_logE(d00_logE0,tmp)
double m00_exp(d00_exp1,(o3*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,tmp)
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
p2_u_Vb_ci=(o3*tmp_Vb_ci*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_u_Vb_ci_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vb_ci)));
  p2_u_Vb_ci_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vtnode_GND)));
  p2_u_Vb_ci_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vbi_ci)));
  p2_u_Vb_ci_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vbi_ei)));
  p2_u_Vb_ci_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vci_ei)));
#endif
#if defined(_DERIVATE)
p2_u_Vtnode_GND=(o3*tmp_Vtnode_GND*d10_logE0)*d10_exp1;
#endif
p2_u_Vbi_ci=(o3*tmp_Vbi_ci*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_u_Vbi_ci_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vb_ci)));
  p2_u_Vbi_ci_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vtnode_GND)));
  p2_u_Vbi_ci_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vbi_ci)));
  p2_u_Vbi_ci_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vbi_ei)));
  p2_u_Vbi_ci_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vci_ei)));
#endif
p2_u_Vbi_ei=(o3*tmp_Vbi_ei*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_u_Vbi_ei_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vb_ci)));
  p2_u_Vbi_ei_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vtnode_GND)));
  p2_u_Vbi_ei_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vbi_ci)));
  p2_u_Vbi_ei_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vbi_ei)));
  p2_u_Vbi_ei_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vci_ei)));
#endif
p2_u_Vci_ei=(o3*tmp_Vci_ei*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_u_Vci_ei_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vb_ci)));
  p2_u_Vci_ei_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vtnode_GND)));
  p2_u_Vci_ei_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vbi_ci)));
  p2_u_Vci_ei_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vbi_ei)));
  p2_u_Vci_ei_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vci_ei)));
#endif
#endif
p2_u=d00_exp1;
EXIT_IF_ISNAN(d00_exp1)
}
}
else
{
{
double m00_logE(d00_logE0,(-tmp))
double m00_exp(d00_exp1,(o3*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(-tmp))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
p2_u_Vb_ci=(-(o3*(-tmp_Vb_ci)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_u_Vb_ci_Vb_ci=0.0;
  p2_u_Vb_ci_Vtnode_GND=0.0;
  p2_u_Vb_ci_Vbi_ci=0.0;
  p2_u_Vb_ci_Vbi_ei=0.0;
  p2_u_Vb_ci_Vci_ei=0.0;
#endif
#if defined(_DERIVATE)
p2_u_Vtnode_GND=(-(o3*(-tmp_Vtnode_GND)*d10_logE0)*d10_exp1);
#endif
p2_u_Vbi_ci=(-(o3*(-tmp_Vbi_ci)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_u_Vbi_ci_Vb_ci=0.0;
  p2_u_Vbi_ci_Vtnode_GND=0.0;
  p2_u_Vbi_ci_Vbi_ci=0.0;
  p2_u_Vbi_ci_Vbi_ei=0.0;
  p2_u_Vbi_ci_Vci_ei=0.0;
#endif
p2_u_Vbi_ei=(-(o3*(-tmp_Vbi_ei)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_u_Vbi_ei_Vb_ci=0.0;
  p2_u_Vbi_ei_Vtnode_GND=0.0;
  p2_u_Vbi_ei_Vbi_ci=0.0;
  p2_u_Vbi_ei_Vbi_ei=0.0;
  p2_u_Vbi_ei_Vci_ei=0.0;
#endif
p2_u_Vci_ei=(-(o3*(-tmp_Vci_ei)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_u_Vci_ei_Vb_ci=0.0;
  p2_u_Vci_ei_Vtnode_GND=0.0;
  p2_u_Vci_ei_Vbi_ci=0.0;
  p2_u_Vci_ei_Vbi_ei=0.0;
  p2_u_Vci_ei_Vci_ei=0.0;
#endif
#endif
p2_u=(-d00_exp1);
EXIT_IF_ISNAN((-d00_exp1))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
tmp_Vb_ci=(tmp2_Vb_ci-tmp3_Vb_ci);
#if defined(_DERIVATE2)
  tmp_Vb_ci_Vb_ci=(+tmp2_Vb_ci_Vb_ci-tmp3_Vb_ci_Vb_ci);
  tmp_Vb_ci_Vtnode_GND=(+tmp2_Vb_ci_Vtnode_GND-tmp3_Vb_ci_Vtnode_GND);
  tmp_Vb_ci_Vbi_ci=(+tmp2_Vb_ci_Vbi_ci-tmp3_Vb_ci_Vbi_ci);
  tmp_Vb_ci_Vbi_ei=(+tmp2_Vb_ci_Vbi_ei-tmp3_Vb_ci_Vbi_ei);
  tmp_Vb_ci_Vci_ei=(+tmp2_Vb_ci_Vci_ei-tmp3_Vb_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
tmp_Vtnode_GND=(tmp2_Vtnode_GND-tmp3_Vtnode_GND);
#endif
tmp_Vbi_ci=(tmp2_Vbi_ci-tmp3_Vbi_ci);
#if defined(_DERIVATE2)
  tmp_Vbi_ci_Vb_ci=(+tmp2_Vbi_ci_Vb_ci-tmp3_Vbi_ci_Vb_ci);
  tmp_Vbi_ci_Vtnode_GND=(+tmp2_Vbi_ci_Vtnode_GND-tmp3_Vbi_ci_Vtnode_GND);
  tmp_Vbi_ci_Vbi_ci=(+tmp2_Vbi_ci_Vbi_ci-tmp3_Vbi_ci_Vbi_ci);
  tmp_Vbi_ci_Vbi_ei=(+tmp2_Vbi_ci_Vbi_ei-tmp3_Vbi_ci_Vbi_ei);
  tmp_Vbi_ci_Vci_ei=(+tmp2_Vbi_ci_Vci_ei-tmp3_Vbi_ci_Vci_ei);
#endif
tmp_Vbi_ei=(tmp2_Vbi_ei-tmp3_Vbi_ei);
#if defined(_DERIVATE2)
  tmp_Vbi_ei_Vb_ci=(+tmp2_Vbi_ei_Vb_ci-tmp3_Vbi_ei_Vb_ci);
  tmp_Vbi_ei_Vtnode_GND=(+tmp2_Vbi_ei_Vtnode_GND-tmp3_Vbi_ei_Vtnode_GND);
  tmp_Vbi_ei_Vbi_ci=(+tmp2_Vbi_ei_Vbi_ci-tmp3_Vbi_ei_Vbi_ci);
  tmp_Vbi_ei_Vbi_ei=(+tmp2_Vbi_ei_Vbi_ei-tmp3_Vbi_ei_Vbi_ei);
  tmp_Vbi_ei_Vci_ei=(+tmp2_Vbi_ei_Vci_ei-tmp3_Vbi_ei_Vci_ei);
#endif
tmp_Vci_ei=(tmp2_Vci_ei-tmp3_Vci_ei);
#if defined(_DERIVATE2)
  tmp_Vci_ei_Vb_ci=(+tmp2_Vci_ei_Vb_ci-tmp3_Vci_ei_Vb_ci);
  tmp_Vci_ei_Vtnode_GND=(+tmp2_Vci_ei_Vtnode_GND-tmp3_Vci_ei_Vtnode_GND);
  tmp_Vci_ei_Vbi_ci=(+tmp2_Vci_ei_Vbi_ci-tmp3_Vci_ei_Vbi_ci);
  tmp_Vci_ei_Vbi_ei=(+tmp2_Vci_ei_Vbi_ei-tmp3_Vci_ei_Vbi_ei);
  tmp_Vci_ei_Vci_ei=(+tmp2_Vci_ei_Vci_ei-tmp3_Vci_ei_Vci_ei);
#endif
#endif
tmp=(tmp2-tmp3);
EXIT_IF_ISNAN((tmp2-tmp3))
if
((tmp>0))
{
{
double m00_logE(d00_logE0,tmp)
double m00_exp(d00_exp1,(o3*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,tmp)
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
p2_v_Vb_ci=(o3*tmp_Vb_ci*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_v_Vb_ci_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vb_ci)));
  p2_v_Vb_ci_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vtnode_GND)));
  p2_v_Vb_ci_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vbi_ci)));
  p2_v_Vb_ci_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vbi_ei)));
  p2_v_Vb_ci_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vb_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vb_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vb_ci+d10_logE0*tmp_Vb_ci_Vci_ei)));
#endif
#if defined(_DERIVATE)
p2_v_Vtnode_GND=(o3*tmp_Vtnode_GND*d10_logE0)*d10_exp1;
#endif
p2_v_Vbi_ci=(o3*tmp_Vbi_ci*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_v_Vbi_ci_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vb_ci)));
  p2_v_Vbi_ci_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vtnode_GND)));
  p2_v_Vbi_ci_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vbi_ci)));
  p2_v_Vbi_ci_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vbi_ei)));
  p2_v_Vbi_ci_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vbi_ci*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vbi_ci*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vbi_ci+d10_logE0*tmp_Vbi_ci_Vci_ei)));
#endif
p2_v_Vbi_ei=(o3*tmp_Vbi_ei*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_v_Vbi_ei_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vb_ci)));
  p2_v_Vbi_ei_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vtnode_GND)));
  p2_v_Vbi_ei_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vbi_ci)));
  p2_v_Vbi_ei_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vbi_ei)));
  p2_v_Vbi_ei_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vbi_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vbi_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vbi_ei+d10_logE0*tmp_Vbi_ei_Vci_ei)));
#endif
p2_v_Vci_ei=(o3*tmp_Vci_ei*d10_logE0)*d10_exp1;
#if defined(_DERIVATE2)
  p2_v_Vci_ei_Vb_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vb_ci*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vb_ci*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vb_ci*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vb_ci)));
  p2_v_Vci_ei_Vtnode_GND=(m20_exp((o3*d00_logE0))*((o3*tmp_Vtnode_GND*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vtnode_GND*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vtnode_GND*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vtnode_GND)));
  p2_v_Vci_ei_Vbi_ci=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ci*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ci*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ci*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vbi_ci)));
  p2_v_Vci_ei_Vbi_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vbi_ei*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vbi_ei*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vbi_ei*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vbi_ei)));
  p2_v_Vci_ei_Vci_ei=(m20_exp((o3*d00_logE0))*((o3*tmp_Vci_ei*d10_logE0))*(o3*tmp_Vci_ei*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*tmp_Vci_ei*d10_logE0+0.0*tmp_Vci_ei*d10_logE0+o3*(m20_logE(tmp)*tmp_Vci_ei*tmp_Vci_ei+d10_logE0*tmp_Vci_ei_Vci_ei)));
#endif
#endif
p2_v=d00_exp1;
EXIT_IF_ISNAN(d00_exp1)
}
}
else
{
{
double m00_logE(d00_logE0,(-tmp))
double m00_exp(d00_exp1,(o3*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(-tmp))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
p2_v_Vb_ci=(-(o3*(-tmp_Vb_ci)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_v_Vb_ci_Vb_ci=0.0;
  p2_v_Vb_ci_Vtnode_GND=0.0;
  p2_v_Vb_ci_Vbi_ci=0.0;
  p2_v_Vb_ci_Vbi_ei=0.0;
  p2_v_Vb_ci_Vci_ei=0.0;
#endif
#if defined(_DERIVATE)
p2_v_Vtnode_GND=(-(o3*(-tmp_Vtnode_GND)*d10_logE0)*d10_exp1);
#endif
p2_v_Vbi_ci=(-(o3*(-tmp_Vbi_ci)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_v_Vbi_ci_Vb_ci=0.0;
  p2_v_Vbi_ci_Vtnode_GND=0.0;
  p2_v_Vbi_ci_Vbi_ci=0.0;
  p2_v_Vbi_ci_Vbi_ei=0.0;
  p2_v_Vbi_ci_Vci_ei=0.0;
#endif
p2_v_Vbi_ei=(-(o3*(-tmp_Vbi_ei)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_v_Vbi_ei_Vb_ci=0.0;
  p2_v_Vbi_ei_Vtnode_GND=0.0;
  p2_v_Vbi_ei_Vbi_ci=0.0;
  p2_v_Vbi_ei_Vbi_ei=0.0;
  p2_v_Vbi_ei_Vci_ei=0.0;
#endif
p2_v_Vci_ei=(-(o3*(-tmp_Vci_ei)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  p2_v_Vci_ei_Vb_ci=0.0;
  p2_v_Vci_ei_Vtnode_GND=0.0;
  p2_v_Vci_ei_Vbi_ci=0.0;
  p2_v_Vci_ei_Vbi_ei=0.0;
  p2_v_Vci_ei_Vci_ei=0.0;
#endif
#endif
p2_v=(-d00_exp1);
EXIT_IF_ISNAN((-d00_exp1))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
q_p3_Vb_ci=((p2_u_Vb_ci+p2_v_Vb_ci)-p2_a_Vb_ci*o3);
#if defined(_DERIVATE2)
  q_p3_Vb_ci_Vb_ci=(+(+p2_u_Vb_ci_Vb_ci+p2_v_Vb_ci_Vb_ci)-(+p2_a_Vb_ci_Vb_ci*o3+p2_a_Vb_ci*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vtnode_GND=(+(+p2_u_Vb_ci_Vtnode_GND+p2_v_Vb_ci_Vtnode_GND)-(+p2_a_Vb_ci_Vtnode_GND*o3+p2_a_Vb_ci*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vbi_ci=(+(+p2_u_Vb_ci_Vbi_ci+p2_v_Vb_ci_Vbi_ci)-(+p2_a_Vb_ci_Vbi_ci*o3+p2_a_Vb_ci*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vbi_ei=(+(+p2_u_Vb_ci_Vbi_ei+p2_v_Vb_ci_Vbi_ei)-(+p2_a_Vb_ci_Vbi_ei*o3+p2_a_Vb_ci*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vb_ci_Vci_ei=(+(+p2_u_Vb_ci_Vci_ei+p2_v_Vb_ci_Vci_ei)-(+p2_a_Vb_ci_Vci_ei*o3+p2_a_Vb_ci*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
#if defined(_DERIVATE)
q_p3_Vtnode_GND=((p2_u_Vtnode_GND+p2_v_Vtnode_GND)-p2_a_Vtnode_GND*o3);
#endif
q_p3_Vbi_ci=((p2_u_Vbi_ci+p2_v_Vbi_ci)-p2_a_Vbi_ci*o3);
#if defined(_DERIVATE2)
  q_p3_Vbi_ci_Vb_ci=(+(+p2_u_Vbi_ci_Vb_ci+p2_v_Vbi_ci_Vb_ci)-(+p2_a_Vbi_ci_Vb_ci*o3+p2_a_Vbi_ci*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vtnode_GND=(+(+p2_u_Vbi_ci_Vtnode_GND+p2_v_Vbi_ci_Vtnode_GND)-(+p2_a_Vbi_ci_Vtnode_GND*o3+p2_a_Vbi_ci*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vbi_ci=(+(+p2_u_Vbi_ci_Vbi_ci+p2_v_Vbi_ci_Vbi_ci)-(+p2_a_Vbi_ci_Vbi_ci*o3+p2_a_Vbi_ci*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vbi_ei=(+(+p2_u_Vbi_ci_Vbi_ei+p2_v_Vbi_ci_Vbi_ei)-(+p2_a_Vbi_ci_Vbi_ei*o3+p2_a_Vbi_ci*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vbi_ci_Vci_ei=(+(+p2_u_Vbi_ci_Vci_ei+p2_v_Vbi_ci_Vci_ei)-(+p2_a_Vbi_ci_Vci_ei*o3+p2_a_Vbi_ci*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
q_p3_Vbi_ei=((p2_u_Vbi_ei+p2_v_Vbi_ei)-p2_a_Vbi_ei*o3);
#if defined(_DERIVATE2)
  q_p3_Vbi_ei_Vb_ci=(+(+p2_u_Vbi_ei_Vb_ci+p2_v_Vbi_ei_Vb_ci)-(+p2_a_Vbi_ei_Vb_ci*o3+p2_a_Vbi_ei*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vtnode_GND=(+(+p2_u_Vbi_ei_Vtnode_GND+p2_v_Vbi_ei_Vtnode_GND)-(+p2_a_Vbi_ei_Vtnode_GND*o3+p2_a_Vbi_ei*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vbi_ci=(+(+p2_u_Vbi_ei_Vbi_ci+p2_v_Vbi_ei_Vbi_ci)-(+p2_a_Vbi_ei_Vbi_ci*o3+p2_a_Vbi_ei*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vbi_ei=(+(+p2_u_Vbi_ei_Vbi_ei+p2_v_Vbi_ei_Vbi_ei)-(+p2_a_Vbi_ei_Vbi_ei*o3+p2_a_Vbi_ei*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vbi_ei_Vci_ei=(+(+p2_u_Vbi_ei_Vci_ei+p2_v_Vbi_ei_Vci_ei)-(+p2_a_Vbi_ei_Vci_ei*o3+p2_a_Vbi_ei*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
q_p3_Vci_ei=((p2_u_Vci_ei+p2_v_Vci_ei)-p2_a_Vci_ei*o3);
#if defined(_DERIVATE2)
  q_p3_Vci_ei_Vb_ci=(+(+p2_u_Vci_ei_Vb_ci+p2_v_Vci_ei_Vb_ci)-(+p2_a_Vci_ei_Vb_ci*o3+p2_a_Vci_ei*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vtnode_GND=(+(+p2_u_Vci_ei_Vtnode_GND+p2_v_Vci_ei_Vtnode_GND)-(+p2_a_Vci_ei_Vtnode_GND*o3+p2_a_Vci_ei*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vbi_ci=(+(+p2_u_Vci_ei_Vbi_ci+p2_v_Vci_ei_Vbi_ci)-(+p2_a_Vci_ei_Vbi_ci*o3+p2_a_Vci_ei*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vbi_ei=(+(+p2_u_Vci_ei_Vbi_ei+p2_v_Vci_ei_Vbi_ei)-(+p2_a_Vci_ei_Vbi_ei*o3+p2_a_Vci_ei*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  q_p3_Vci_ei_Vci_ei=(+(+p2_u_Vci_ei_Vci_ei+p2_v_Vci_ei_Vci_ei)-(+p2_a_Vci_ei_Vci_ei*o3+p2_a_Vci_ei*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
#endif
q_p3=((p2_u+p2_v)-(p2_a*o3));
EXIT_IF_ISNAN(((p2_u+p2_v)-(p2_a*o3)))
}
else
{
{
double m00_sqrt(d00_sqrt0,((-27.0)/((p2_p*p2_p)*p2_p)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((-27.0)/((p2_p*p2_p)*p2_p)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
tmp_Vb_ci=(((-p2_q_Vb_ci)*0.5*d00_sqrt0)+(((-p2_q)*0.5)*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0));
#if defined(_DERIVATE2)
  tmp_Vb_ci_Vb_ci=(+(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vb_ci)*0.5*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vb_ci)*0.5)*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))+0.0*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))+(-27.0)*(+(+p2_p_Vb_ci_Vb_ci*p2_p+p2_p_Vb_ci*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vb_ci)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vb_ci_Vtnode_GND=(+(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vb_ci)*0.5*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vtnode_GND)*0.5)*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))+0.0*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))+(-27.0)*(+(+p2_p_Vb_ci_Vtnode_GND*p2_p+p2_p_Vb_ci*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vtnode_GND)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vtnode_GND))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vb_ci_Vbi_ci=(+(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vb_ci)*0.5*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ci)*0.5)*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))+0.0*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))+(-27.0)*(+(+p2_p_Vb_ci_Vbi_ci*p2_p+p2_p_Vb_ci*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vbi_ci)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vb_ci_Vbi_ei=(+(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vb_ci)*0.5*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ei)*0.5)*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))+0.0*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))+(-27.0)*(+(+p2_p_Vb_ci_Vbi_ei*p2_p+p2_p_Vb_ci*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vbi_ei)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vb_ci_Vci_ei=(+(+0.0*0.5+(-p2_q_Vb_ci)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vb_ci)*0.5*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vci_ei)*0.5)*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))+0.0*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))+(-27.0)*(+(+p2_p_Vb_ci_Vci_ei*p2_p+p2_p_Vb_ci*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vb_ci+p2_p*p2_p_Vb_ci_Vci_ei)*p2_p+((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vb_ci+(p2_p*p2_p)*p2_p_Vb_ci_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci))*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
#endif
#if defined(_DERIVATE)
tmp_Vtnode_GND=(((-p2_q_Vtnode_GND)*0.5*d00_sqrt0)+(((-p2_q)*0.5)*(-(-27.0)*((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0));
#endif
tmp_Vbi_ci=(((-p2_q_Vbi_ci)*0.5*d00_sqrt0)+(((-p2_q)*0.5)*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0));
#if defined(_DERIVATE2)
  tmp_Vbi_ci_Vb_ci=(+(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ci)*0.5*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vb_ci)*0.5)*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))+0.0*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))+(-27.0)*(+(+p2_p_Vbi_ci_Vb_ci*p2_p+p2_p_Vbi_ci*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vb_ci)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ci_Vtnode_GND=(+(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ci)*0.5*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vtnode_GND)*0.5)*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))+0.0*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))+(-27.0)*(+(+p2_p_Vbi_ci_Vtnode_GND*p2_p+p2_p_Vbi_ci*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vtnode_GND)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vtnode_GND))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ci_Vbi_ci=(+(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ci)*0.5*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ci)*0.5)*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))+0.0*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))+(-27.0)*(+(+p2_p_Vbi_ci_Vbi_ci*p2_p+p2_p_Vbi_ci*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vbi_ci)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ci_Vbi_ei=(+(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ci)*0.5*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ei)*0.5)*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))+0.0*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))+(-27.0)*(+(+p2_p_Vbi_ci_Vbi_ei*p2_p+p2_p_Vbi_ci*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vbi_ei)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ci_Vci_ei=(+(+0.0*0.5+(-p2_q_Vbi_ci)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ci)*0.5*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vci_ei)*0.5)*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))+0.0*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))+(-27.0)*(+(+p2_p_Vbi_ci_Vci_ei*p2_p+p2_p_Vbi_ci*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vbi_ci+p2_p*p2_p_Vbi_ci_Vci_ei)*p2_p+((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vbi_ci+(p2_p*p2_p)*p2_p_Vbi_ci_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci))*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
#endif
tmp_Vbi_ei=(((-p2_q_Vbi_ei)*0.5*d00_sqrt0)+(((-p2_q)*0.5)*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0));
#if defined(_DERIVATE2)
  tmp_Vbi_ei_Vb_ci=(+(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ei)*0.5*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vb_ci)*0.5)*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))+0.0*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))+(-27.0)*(+(+p2_p_Vbi_ei_Vb_ci*p2_p+p2_p_Vbi_ei*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vb_ci)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ei_Vtnode_GND=(+(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ei)*0.5*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vtnode_GND)*0.5)*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))+0.0*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))+(-27.0)*(+(+p2_p_Vbi_ei_Vtnode_GND*p2_p+p2_p_Vbi_ei*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vtnode_GND)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vtnode_GND))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ei_Vbi_ci=(+(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ei)*0.5*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ci)*0.5)*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))+0.0*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))+(-27.0)*(+(+p2_p_Vbi_ei_Vbi_ci*p2_p+p2_p_Vbi_ei*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vbi_ci)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ei_Vbi_ei=(+(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ei)*0.5*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ei)*0.5)*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))+0.0*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))+(-27.0)*(+(+p2_p_Vbi_ei_Vbi_ei*p2_p+p2_p_Vbi_ei*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vbi_ei)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vbi_ei_Vci_ei=(+(+0.0*0.5+(-p2_q_Vbi_ei)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vbi_ei)*0.5*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vci_ei)*0.5)*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))+0.0*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))+(-27.0)*(+(+p2_p_Vbi_ei_Vci_ei*p2_p+p2_p_Vbi_ei*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vbi_ei+p2_p*p2_p_Vbi_ei_Vci_ei)*p2_p+((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vbi_ei+(p2_p*p2_p)*p2_p_Vbi_ei_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei))*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
#endif
tmp_Vci_ei=(((-p2_q_Vci_ei)*0.5*d00_sqrt0)+(((-p2_q)*0.5)*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0));
#if defined(_DERIVATE2)
  tmp_Vci_ei_Vb_ci=(+(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vb_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vci_ei)*0.5*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vb_ci)*0.5)*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))+0.0*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))+(-27.0)*(+(+p2_p_Vci_ei_Vb_ci*p2_p+p2_p_Vci_ei*p2_p_Vb_ci+p2_p_Vb_ci*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vb_ci)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vb_ci+(((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vb_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*((((((p2_p_Vb_ci*p2_p)+(p2_p*p2_p_Vb_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vb_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vci_ei_Vtnode_GND=(+(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vtnode_GND)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vci_ei)*0.5*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vtnode_GND)*0.5)*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))+0.0*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))+(-27.0)*(+(+p2_p_Vci_ei_Vtnode_GND*p2_p+p2_p_Vci_ei*p2_p_Vtnode_GND+p2_p_Vtnode_GND*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vtnode_GND)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vtnode_GND+(((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vtnode_GND))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*((((((p2_p_Vtnode_GND*p2_p)+(p2_p*p2_p_Vtnode_GND)))*p2_p)+((p2_p*p2_p)*p2_p_Vtnode_GND)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vci_ei_Vbi_ci=(+(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vbi_ci)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vci_ei)*0.5*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ci)*0.5)*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))+0.0*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))+(-27.0)*(+(+p2_p_Vci_ei_Vbi_ci*p2_p+p2_p_Vci_ei*p2_p_Vbi_ci+p2_p_Vbi_ci*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vbi_ci)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vbi_ci+(((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vbi_ci))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*((((((p2_p_Vbi_ci*p2_p)+(p2_p*p2_p_Vbi_ci)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ci)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vci_ei_Vbi_ei=(+(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vbi_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vci_ei)*0.5*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vbi_ei)*0.5)*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))+0.0*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))+(-27.0)*(+(+p2_p_Vci_ei_Vbi_ei*p2_p+p2_p_Vci_ei*p2_p_Vbi_ei+p2_p_Vbi_ei*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vbi_ei)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vbi_ei+(((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vbi_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*((((((p2_p_Vbi_ei*p2_p)+(p2_p*p2_p_Vbi_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vbi_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
  tmp_Vci_ei_Vci_ei=(+(+0.0*0.5+(-p2_q_Vci_ei)*0.0+(-p2_q_Vci_ei)*0.0+(-p2_q)*0.0)*d00_sqrt0+(-p2_q_Vci_ei)*0.5*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q_Vci_ei)*0.5)*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*d10_sqrt0+((-p2_q)*0.5)*(m20_sqrt(((-27.0)/((p2_p*p2_p)*p2_p)))*(-(-27.0)*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))*(-(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))+d10_sqrt0*(0.0/((p2_p*p2_p)*p2_p)-(0.0*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))+0.0*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))+(-27.0)*(+(+p2_p_Vci_ei_Vci_ei*p2_p+p2_p_Vci_ei*p2_p_Vci_ei+p2_p_Vci_ei*p2_p_Vci_ei+p2_p*p2_p_Vci_ei_Vci_ei)*p2_p+((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p_Vci_ei+(((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p_Vci_ei+(p2_p*p2_p)*p2_p_Vci_ei_Vci_ei))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)+2*(-27.0)*((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei))*((((((p2_p_Vci_ei*p2_p)+(p2_p*p2_p_Vci_ei)))*p2_p)+((p2_p*p2_p)*p2_p_Vci_ei)))/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p)/((p2_p*p2_p)*p2_p))));
#endif
#endif
tmp=(((-p2_q)*0.5)*d00_sqrt0);
EXIT_IF_ISNAN((((-p2_q)*0.5)*d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
tmp2_Vb_ci=((tmp_Vb_ci*tmp)+(tmp*tmp_Vb_ci));
#if defined(_DERIVATE2)
  tmp2_Vb_ci_Vb_ci=(+tmp_Vb_ci_Vb_ci*tmp+tmp_Vb_ci*tmp_Vb_ci+tmp_Vb_ci*tmp_Vb_ci+tmp*tmp_Vb_ci_Vb_ci);
  tmp2_Vb_ci_Vtnode_GND=(+tmp_Vb_ci_Vtnode_GND*tmp+tmp_Vb_ci*tmp_Vtnode_GND+tmp_Vtnode_GND*tmp_Vb_ci+tmp*tmp_Vb_ci_Vtnode_GND);
  tmp2_Vb_ci_Vbi_ci=(+tmp_Vb_ci_Vbi_ci*tmp+tmp_Vb_ci*tmp_Vbi_ci+tmp_Vbi_ci*tmp_Vb_ci+tmp*tmp_Vb_ci_Vbi_ci);
  tmp2_Vb_ci_Vbi_ei=(+tmp_Vb_ci_Vbi_ei*tmp+tmp_Vb_ci*tmp_Vbi_ei+tmp_Vbi_ei*tmp_Vb_ci+tmp*tmp_Vb_ci_Vbi_ei);
  tmp2_Vb_ci_Vci_ei=(+tmp_Vb_ci_Vci_ei*tmp+tmp_Vb_ci*tmp_Vci_ei+tmp_Vci_ei*tmp_Vb_ci+tmp*tmp_Vb_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
tmp2_Vtnode_GND=((tmp_Vtnode_GND*tmp)+(tmp*tmp_Vtnode_GND));
#endif
tmp2_Vbi_ci=((tmp_Vbi_ci*tmp)+(tmp*tmp_Vbi_ci));
#if defined(_DERIVATE2)
  tmp2_Vbi_ci_Vb_ci=(+tmp_Vbi_ci_Vb_ci*tmp+tmp_Vbi_ci*tmp_Vb_ci+tmp_Vb_ci*tmp_Vbi_ci+tmp*tmp_Vbi_ci_Vb_ci);
  tmp2_Vbi_ci_Vtnode_GND=(+tmp_Vbi_ci_Vtnode_GND*tmp+tmp_Vbi_ci*tmp_Vtnode_GND+tmp_Vtnode_GND*tmp_Vbi_ci+tmp*tmp_Vbi_ci_Vtnode_GND);
  tmp2_Vbi_ci_Vbi_ci=(+tmp_Vbi_ci_Vbi_ci*tmp+tmp_Vbi_ci*tmp_Vbi_ci+tmp_Vbi_ci*tmp_Vbi_ci+tmp*tmp_Vbi_ci_Vbi_ci);
  tmp2_Vbi_ci_Vbi_ei=(+tmp_Vbi_ci_Vbi_ei*tmp+tmp_Vbi_ci*tmp_Vbi_ei+tmp_Vbi_ei*tmp_Vbi_ci+tmp*tmp_Vbi_ci_Vbi_ei);
  tmp2_Vbi_ci_Vci_ei=(+tmp_Vbi_ci_Vci_ei*tmp+tmp_Vbi_ci*tmp_Vci_ei+tmp_Vci_ei*tmp_Vbi_ci+tmp*tmp_Vbi_ci_Vci_ei);
#endif
tmp2_Vbi_ei=((tmp_Vbi_ei*tmp)+(tmp*tmp_Vbi_ei));
#if defined(_DERIVATE2)
  tmp2_Vbi_ei_Vb_ci=(+tmp_Vbi_ei_Vb_ci*tmp+tmp_Vbi_ei*tmp_Vb_ci+tmp_Vb_ci*tmp_Vbi_ei+tmp*tmp_Vbi_ei_Vb_ci);
  tmp2_Vbi_ei_Vtnode_GND=(+tmp_Vbi_ei_Vtnode_GND*tmp+tmp_Vbi_ei*tmp_Vtnode_GND+tmp_Vtnode_GND*tmp_Vbi_ei+tmp*tmp_Vbi_ei_Vtnode_GND);
  tmp2_Vbi_ei_Vbi_ci=(+tmp_Vbi_ei_Vbi_ci*tmp+tmp_Vbi_ei*tmp_Vbi_ci+tmp_Vbi_ci*tmp_Vbi_ei+tmp*tmp_Vbi_ei_Vbi_ci);
  tmp2_Vbi_ei_Vbi_ei=(+tmp_Vbi_ei_Vbi_ei*tmp+tmp_Vbi_ei*tmp_Vbi_ei+tmp_Vbi_ei*tmp_Vbi_ei+tmp*tmp_Vbi_ei_Vbi_ei);
  tmp2_Vbi_ei_Vci_ei=(+tmp_Vbi_ei_Vci_ei*tmp+tmp_Vbi_ei*tmp_Vci_ei+tmp_Vci_ei*tmp_Vbi_ei+tmp*tmp_Vbi_ei_Vci_ei);
#endif
tmp2_Vci_ei=((tmp_Vci_ei*tmp)+(tmp*tmp_Vci_ei));
#if defined(_DERIVATE2)
  tmp2_Vci_ei_Vb_ci=(+tmp_Vci_ei_Vb_ci*tmp+tmp_Vci_ei*tmp_Vb_ci+tmp_Vb_ci*tmp_Vci_ei+tmp*tmp_Vci_ei_Vb_ci);
  tmp2_Vci_ei_Vtnode_GND=(+tmp_Vci_ei_Vtnode_GND*tmp+tmp_Vci_ei*tmp_Vtnode_GND+tmp_Vtnode_GND*tmp_Vci_ei+tmp*tmp_Vci_ei_Vtnode_GND);
  tmp2_Vci_ei_Vbi_ci=(+tmp_Vci_ei_Vbi_ci*tmp+tmp_Vci_ei*tmp_Vbi_ci+tmp_Vbi_ci*tmp_Vci_ei+tmp*tmp_Vci_ei_Vbi_ci);
  tmp2_Vci_ei_Vbi_ei=(+tmp_Vci_ei_Vbi_ei*tmp+tmp_Vci_ei*tmp_Vbi_ei+tmp_Vbi_ei*tmp_Vci_ei+tmp*tmp_Vci_ei_Vbi_ei);
  tmp2_Vci_ei_Vci_ei=(+tmp_Vci_ei_Vci_ei*tmp+tmp_Vci_ei*tmp_Vci_ei+tmp_Vci_ei*tmp_Vci_ei+tmp*tmp_Vci_ei_Vci_ei);
#endif
#endif
tmp2=(tmp*tmp);
EXIT_IF_ISNAN((tmp*tmp))
if
((tmp>=0))
{
{
double m00_sqrt(d00_sqrt0,(tmp2/(1-tmp2)))
double m00_atan(d00_atan1,d00_sqrt0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(tmp2/(1-tmp2)))
double m10_atan(d10_atan1,d00_atan1,d00_sqrt0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
tmp_Vb_ci=(-((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1);
#if defined(_DERIVATE2)
  tmp_Vb_ci_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vb_ci/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vtnode_GND/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vbi_ci/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vbi_ei/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vci_ei/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
#if defined(_DERIVATE)
tmp_Vtnode_GND=(-((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1);
#endif
tmp_Vbi_ci=(-((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1);
#if defined(_DERIVATE2)
  tmp_Vbi_ci_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vb_ci/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vtnode_GND/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vbi_ci/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vbi_ei/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vci_ei/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
tmp_Vbi_ei=(-((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1);
#if defined(_DERIVATE2)
  tmp_Vbi_ei_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vb_ci/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vtnode_GND/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vbi_ci/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vbi_ei/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vci_ei/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
tmp_Vci_ei=(-((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1);
#if defined(_DERIVATE2)
  tmp_Vci_ei_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vb_ci/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vtnode_GND/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vbi_ci/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vbi_ei/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)-(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vci_ei/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
#endif
tmp=((3.14159265358979323846/2)-d00_atan1);
EXIT_IF_ISNAN(((3.14159265358979323846/2)-d00_atan1))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(tmp2/(1-tmp2)))
double m00_atan(d00_atan1,d00_sqrt0)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(tmp2/(1-tmp2)))
double m10_atan(d10_atan1,d00_atan1,d00_sqrt0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
tmp_Vb_ci=((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1;
#if defined(_DERIVATE2)
  tmp_Vb_ci_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vb_ci/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vtnode_GND/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vbi_ci/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vbi_ei/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vb_ci_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vb_ci_Vci_ei/(1-tmp2)-(tmp2_Vb_ci*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vb_ci)+tmp2*(+0.0-tmp2_Vb_ci_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vb_ci)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
#if defined(_DERIVATE)
tmp_Vtnode_GND=((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1;
#endif
tmp_Vbi_ci=((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1;
#if defined(_DERIVATE2)
  tmp_Vbi_ci_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vb_ci/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vtnode_GND/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vbi_ci/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vbi_ei/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ci_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ci_Vci_ei/(1-tmp2)-(tmp2_Vbi_ci*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vbi_ci)+tmp2*(+0.0-tmp2_Vbi_ci_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ci)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
tmp_Vbi_ei=((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1;
#if defined(_DERIVATE2)
  tmp_Vbi_ei_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vb_ci/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vtnode_GND/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vbi_ci/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vbi_ei/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vbi_ei_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vbi_ei_Vci_ei/(1-tmp2)-(tmp2_Vbi_ei*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vbi_ei)+tmp2*(+0.0-tmp2_Vbi_ei_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vbi_ei)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
tmp_Vci_ei=((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*d10_atan1;
#if defined(_DERIVATE2)
  tmp_Vci_ei_Vb_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vb_ci*(1-tmp2)-tmp2*(-tmp2_Vb_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vb_ci/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vb_ci)+tmp2_Vb_ci*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vb_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vb_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vtnode_GND=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vtnode_GND*(1-tmp2)-tmp2*(-tmp2_Vtnode_GND))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vtnode_GND/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vtnode_GND)+tmp2_Vtnode_GND*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vtnode_GND))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vtnode_GND)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vbi_ci=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ci*(1-tmp2)-tmp2*(-tmp2_Vbi_ci))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vbi_ci/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vbi_ci)+tmp2_Vbi_ci*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vbi_ci))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vbi_ci)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vbi_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vbi_ei*(1-tmp2)-tmp2*(-tmp2_Vbi_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vbi_ei/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vbi_ei)+tmp2_Vbi_ei*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vbi_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vbi_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
  tmp_Vci_ei_Vci_ei=(+(0.0/2-(0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)/2/2+2*3.14159265358979323846*0.0*0.0/2/2/2)+(m20_atan(d00_sqrt0)*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*d10_sqrt0+d10_atan1*(m20_sqrt((tmp2/(1-tmp2)))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))*((tmp2_Vci_ei*(1-tmp2)-tmp2*(-tmp2_Vci_ei))/(1-tmp2)/(1-tmp2))+d10_sqrt0*(tmp2_Vci_ei_Vci_ei/(1-tmp2)-(tmp2_Vci_ei*(-tmp2_Vci_ei)+tmp2_Vci_ei*(-tmp2_Vci_ei)+tmp2*(+0.0-tmp2_Vci_ei_Vci_ei))/(1-tmp2)/(1-tmp2)+2*tmp2*(-tmp2_Vci_ei)*(-tmp2_Vci_ei)/(1-tmp2)/(1-tmp2)/(1-tmp2)))));
#endif
#endif
tmp=((3.14159265358979323846/2)+d00_atan1);
EXIT_IF_ISNAN(((3.14159265358979323846/2)+d00_atan1))
}
}
{
double m00_sqrt(d00_sqrt0,(((-4)*p2_p)*o3))
double m00_cos(d00_cos1,(o3*tmp))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((-4)*p2_p)*o3))
double m10_cos(d10_cos1,d00_cos1,(o3*tmp))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
tmp_Vb_ci=(((((-4)*p2_p_Vb_ci)*o3*d10_sqrt0*d00_cos1)+(d00_sqrt0*(o3*tmp_Vb_ci)*d10_cos1))-p2_a_Vb_ci*o3);
#if defined(_DERIVATE2)
  tmp_Vb_ci_Vb_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vb_ci))*o3)*((-4)*p2_p_Vb_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vb_ci+0.0*p2_p_Vb_ci+(-4)*p2_p_Vb_ci_Vb_ci)*o3+((-4)*p2_p_Vb_ci)*0.0+(((-4)*p2_p_Vb_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vb_ci)*o3*d10_sqrt0*((o3*tmp_Vb_ci))*d10_cos1+((((-4)*p2_p_Vb_ci))*o3)*d10_sqrt0*(o3*tmp_Vb_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vb_ci))*(o3*tmp_Vb_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vb_ci+0.0*tmp_Vb_ci+o3*tmp_Vb_ci_Vb_ci)))-(+p2_a_Vb_ci_Vb_ci*o3+p2_a_Vb_ci*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  tmp_Vb_ci_Vtnode_GND=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vtnode_GND))*o3)*((-4)*p2_p_Vb_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vtnode_GND+0.0*p2_p_Vb_ci+(-4)*p2_p_Vb_ci_Vtnode_GND)*o3+((-4)*p2_p_Vb_ci)*0.0+(((-4)*p2_p_Vtnode_GND))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vb_ci)*o3*d10_sqrt0*((o3*tmp_Vtnode_GND))*d10_cos1+((((-4)*p2_p_Vtnode_GND))*o3)*d10_sqrt0*(o3*tmp_Vb_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vtnode_GND))*(o3*tmp_Vb_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vtnode_GND+0.0*tmp_Vb_ci+o3*tmp_Vb_ci_Vtnode_GND)))-(+p2_a_Vb_ci_Vtnode_GND*o3+p2_a_Vb_ci*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  tmp_Vb_ci_Vbi_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ci))*o3)*((-4)*p2_p_Vb_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ci+0.0*p2_p_Vb_ci+(-4)*p2_p_Vb_ci_Vbi_ci)*o3+((-4)*p2_p_Vb_ci)*0.0+(((-4)*p2_p_Vbi_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vb_ci)*o3*d10_sqrt0*((o3*tmp_Vbi_ci))*d10_cos1+((((-4)*p2_p_Vbi_ci))*o3)*d10_sqrt0*(o3*tmp_Vb_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ci))*(o3*tmp_Vb_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ci+0.0*tmp_Vb_ci+o3*tmp_Vb_ci_Vbi_ci)))-(+p2_a_Vb_ci_Vbi_ci*o3+p2_a_Vb_ci*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  tmp_Vb_ci_Vbi_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ei))*o3)*((-4)*p2_p_Vb_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ei+0.0*p2_p_Vb_ci+(-4)*p2_p_Vb_ci_Vbi_ei)*o3+((-4)*p2_p_Vb_ci)*0.0+(((-4)*p2_p_Vbi_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vb_ci)*o3*d10_sqrt0*((o3*tmp_Vbi_ei))*d10_cos1+((((-4)*p2_p_Vbi_ei))*o3)*d10_sqrt0*(o3*tmp_Vb_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ei))*(o3*tmp_Vb_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ei+0.0*tmp_Vb_ci+o3*tmp_Vb_ci_Vbi_ei)))-(+p2_a_Vb_ci_Vbi_ei*o3+p2_a_Vb_ci*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  tmp_Vb_ci_Vci_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vci_ei))*o3)*((-4)*p2_p_Vb_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vci_ei+0.0*p2_p_Vb_ci+(-4)*p2_p_Vb_ci_Vci_ei)*o3+((-4)*p2_p_Vb_ci)*0.0+(((-4)*p2_p_Vci_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vb_ci)*o3*d10_sqrt0*((o3*tmp_Vci_ei))*d10_cos1+((((-4)*p2_p_Vci_ei))*o3)*d10_sqrt0*(o3*tmp_Vb_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vci_ei))*(o3*tmp_Vb_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vci_ei+0.0*tmp_Vb_ci+o3*tmp_Vb_ci_Vci_ei)))-(+p2_a_Vb_ci_Vci_ei*o3+p2_a_Vb_ci*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
#if defined(_DERIVATE)
tmp_Vtnode_GND=(((((-4)*p2_p_Vtnode_GND)*o3*d10_sqrt0*d00_cos1)+(d00_sqrt0*(o3*tmp_Vtnode_GND)*d10_cos1))-p2_a_Vtnode_GND*o3);
#endif
tmp_Vbi_ci=(((((-4)*p2_p_Vbi_ci)*o3*d10_sqrt0*d00_cos1)+(d00_sqrt0*(o3*tmp_Vbi_ci)*d10_cos1))-p2_a_Vbi_ci*o3);
#if defined(_DERIVATE2)
  tmp_Vbi_ci_Vb_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vb_ci))*o3)*((-4)*p2_p_Vbi_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vb_ci+0.0*p2_p_Vbi_ci+(-4)*p2_p_Vbi_ci_Vb_ci)*o3+((-4)*p2_p_Vbi_ci)*0.0+(((-4)*p2_p_Vb_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ci)*o3*d10_sqrt0*((o3*tmp_Vb_ci))*d10_cos1+((((-4)*p2_p_Vb_ci))*o3)*d10_sqrt0*(o3*tmp_Vbi_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vb_ci))*(o3*tmp_Vbi_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vb_ci+0.0*tmp_Vbi_ci+o3*tmp_Vbi_ci_Vb_ci)))-(+p2_a_Vbi_ci_Vb_ci*o3+p2_a_Vbi_ci*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  tmp_Vbi_ci_Vtnode_GND=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vtnode_GND))*o3)*((-4)*p2_p_Vbi_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vtnode_GND+0.0*p2_p_Vbi_ci+(-4)*p2_p_Vbi_ci_Vtnode_GND)*o3+((-4)*p2_p_Vbi_ci)*0.0+(((-4)*p2_p_Vtnode_GND))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ci)*o3*d10_sqrt0*((o3*tmp_Vtnode_GND))*d10_cos1+((((-4)*p2_p_Vtnode_GND))*o3)*d10_sqrt0*(o3*tmp_Vbi_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vtnode_GND))*(o3*tmp_Vbi_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vtnode_GND+0.0*tmp_Vbi_ci+o3*tmp_Vbi_ci_Vtnode_GND)))-(+p2_a_Vbi_ci_Vtnode_GND*o3+p2_a_Vbi_ci*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  tmp_Vbi_ci_Vbi_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ci))*o3)*((-4)*p2_p_Vbi_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ci+0.0*p2_p_Vbi_ci+(-4)*p2_p_Vbi_ci_Vbi_ci)*o3+((-4)*p2_p_Vbi_ci)*0.0+(((-4)*p2_p_Vbi_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ci)*o3*d10_sqrt0*((o3*tmp_Vbi_ci))*d10_cos1+((((-4)*p2_p_Vbi_ci))*o3)*d10_sqrt0*(o3*tmp_Vbi_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ci))*(o3*tmp_Vbi_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ci+0.0*tmp_Vbi_ci+o3*tmp_Vbi_ci_Vbi_ci)))-(+p2_a_Vbi_ci_Vbi_ci*o3+p2_a_Vbi_ci*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  tmp_Vbi_ci_Vbi_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ei))*o3)*((-4)*p2_p_Vbi_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ei+0.0*p2_p_Vbi_ci+(-4)*p2_p_Vbi_ci_Vbi_ei)*o3+((-4)*p2_p_Vbi_ci)*0.0+(((-4)*p2_p_Vbi_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ci)*o3*d10_sqrt0*((o3*tmp_Vbi_ei))*d10_cos1+((((-4)*p2_p_Vbi_ei))*o3)*d10_sqrt0*(o3*tmp_Vbi_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ei))*(o3*tmp_Vbi_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ei+0.0*tmp_Vbi_ci+o3*tmp_Vbi_ci_Vbi_ei)))-(+p2_a_Vbi_ci_Vbi_ei*o3+p2_a_Vbi_ci*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  tmp_Vbi_ci_Vci_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vci_ei))*o3)*((-4)*p2_p_Vbi_ci)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vci_ei+0.0*p2_p_Vbi_ci+(-4)*p2_p_Vbi_ci_Vci_ei)*o3+((-4)*p2_p_Vbi_ci)*0.0+(((-4)*p2_p_Vci_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ci)*o3*d10_sqrt0*((o3*tmp_Vci_ei))*d10_cos1+((((-4)*p2_p_Vci_ei))*o3)*d10_sqrt0*(o3*tmp_Vbi_ci)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vci_ei))*(o3*tmp_Vbi_ci)+d10_cos1*(+0.0*tmp+0.0*tmp_Vci_ei+0.0*tmp_Vbi_ci+o3*tmp_Vbi_ci_Vci_ei)))-(+p2_a_Vbi_ci_Vci_ei*o3+p2_a_Vbi_ci*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
tmp_Vbi_ei=(((((-4)*p2_p_Vbi_ei)*o3*d10_sqrt0*d00_cos1)+(d00_sqrt0*(o3*tmp_Vbi_ei)*d10_cos1))-p2_a_Vbi_ei*o3);
#if defined(_DERIVATE2)
  tmp_Vbi_ei_Vb_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vb_ci))*o3)*((-4)*p2_p_Vbi_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vb_ci+0.0*p2_p_Vbi_ei+(-4)*p2_p_Vbi_ei_Vb_ci)*o3+((-4)*p2_p_Vbi_ei)*0.0+(((-4)*p2_p_Vb_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ei)*o3*d10_sqrt0*((o3*tmp_Vb_ci))*d10_cos1+((((-4)*p2_p_Vb_ci))*o3)*d10_sqrt0*(o3*tmp_Vbi_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vb_ci))*(o3*tmp_Vbi_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vb_ci+0.0*tmp_Vbi_ei+o3*tmp_Vbi_ei_Vb_ci)))-(+p2_a_Vbi_ei_Vb_ci*o3+p2_a_Vbi_ei*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  tmp_Vbi_ei_Vtnode_GND=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vtnode_GND))*o3)*((-4)*p2_p_Vbi_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vtnode_GND+0.0*p2_p_Vbi_ei+(-4)*p2_p_Vbi_ei_Vtnode_GND)*o3+((-4)*p2_p_Vbi_ei)*0.0+(((-4)*p2_p_Vtnode_GND))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ei)*o3*d10_sqrt0*((o3*tmp_Vtnode_GND))*d10_cos1+((((-4)*p2_p_Vtnode_GND))*o3)*d10_sqrt0*(o3*tmp_Vbi_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vtnode_GND))*(o3*tmp_Vbi_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vtnode_GND+0.0*tmp_Vbi_ei+o3*tmp_Vbi_ei_Vtnode_GND)))-(+p2_a_Vbi_ei_Vtnode_GND*o3+p2_a_Vbi_ei*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  tmp_Vbi_ei_Vbi_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ci))*o3)*((-4)*p2_p_Vbi_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ci+0.0*p2_p_Vbi_ei+(-4)*p2_p_Vbi_ei_Vbi_ci)*o3+((-4)*p2_p_Vbi_ei)*0.0+(((-4)*p2_p_Vbi_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ei)*o3*d10_sqrt0*((o3*tmp_Vbi_ci))*d10_cos1+((((-4)*p2_p_Vbi_ci))*o3)*d10_sqrt0*(o3*tmp_Vbi_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ci))*(o3*tmp_Vbi_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ci+0.0*tmp_Vbi_ei+o3*tmp_Vbi_ei_Vbi_ci)))-(+p2_a_Vbi_ei_Vbi_ci*o3+p2_a_Vbi_ei*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  tmp_Vbi_ei_Vbi_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ei))*o3)*((-4)*p2_p_Vbi_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ei+0.0*p2_p_Vbi_ei+(-4)*p2_p_Vbi_ei_Vbi_ei)*o3+((-4)*p2_p_Vbi_ei)*0.0+(((-4)*p2_p_Vbi_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ei)*o3*d10_sqrt0*((o3*tmp_Vbi_ei))*d10_cos1+((((-4)*p2_p_Vbi_ei))*o3)*d10_sqrt0*(o3*tmp_Vbi_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ei))*(o3*tmp_Vbi_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ei+0.0*tmp_Vbi_ei+o3*tmp_Vbi_ei_Vbi_ei)))-(+p2_a_Vbi_ei_Vbi_ei*o3+p2_a_Vbi_ei*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  tmp_Vbi_ei_Vci_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vci_ei))*o3)*((-4)*p2_p_Vbi_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vci_ei+0.0*p2_p_Vbi_ei+(-4)*p2_p_Vbi_ei_Vci_ei)*o3+((-4)*p2_p_Vbi_ei)*0.0+(((-4)*p2_p_Vci_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vbi_ei)*o3*d10_sqrt0*((o3*tmp_Vci_ei))*d10_cos1+((((-4)*p2_p_Vci_ei))*o3)*d10_sqrt0*(o3*tmp_Vbi_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vci_ei))*(o3*tmp_Vbi_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vci_ei+0.0*tmp_Vbi_ei+o3*tmp_Vbi_ei_Vci_ei)))-(+p2_a_Vbi_ei_Vci_ei*o3+p2_a_Vbi_ei*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
tmp_Vci_ei=(((((-4)*p2_p_Vci_ei)*o3*d10_sqrt0*d00_cos1)+(d00_sqrt0*(o3*tmp_Vci_ei)*d10_cos1))-p2_a_Vci_ei*o3);
#if defined(_DERIVATE2)
  tmp_Vci_ei_Vb_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vb_ci))*o3)*((-4)*p2_p_Vci_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vb_ci+0.0*p2_p_Vci_ei+(-4)*p2_p_Vci_ei_Vb_ci)*o3+((-4)*p2_p_Vci_ei)*0.0+(((-4)*p2_p_Vb_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vci_ei)*o3*d10_sqrt0*((o3*tmp_Vb_ci))*d10_cos1+((((-4)*p2_p_Vb_ci))*o3)*d10_sqrt0*(o3*tmp_Vci_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vb_ci))*(o3*tmp_Vci_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vb_ci+0.0*tmp_Vci_ei+o3*tmp_Vci_ei_Vb_ci)))-(+p2_a_Vci_ei_Vb_ci*o3+p2_a_Vci_ei*0.0+p2_a_Vb_ci*0.0+p2_a*0.0));
  tmp_Vci_ei_Vtnode_GND=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vtnode_GND))*o3)*((-4)*p2_p_Vci_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vtnode_GND+0.0*p2_p_Vci_ei+(-4)*p2_p_Vci_ei_Vtnode_GND)*o3+((-4)*p2_p_Vci_ei)*0.0+(((-4)*p2_p_Vtnode_GND))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vci_ei)*o3*d10_sqrt0*((o3*tmp_Vtnode_GND))*d10_cos1+((((-4)*p2_p_Vtnode_GND))*o3)*d10_sqrt0*(o3*tmp_Vci_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vtnode_GND))*(o3*tmp_Vci_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vtnode_GND+0.0*tmp_Vci_ei+o3*tmp_Vci_ei_Vtnode_GND)))-(+p2_a_Vci_ei_Vtnode_GND*o3+p2_a_Vci_ei*0.0+p2_a_Vtnode_GND*0.0+p2_a*0.0));
  tmp_Vci_ei_Vbi_ci=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ci))*o3)*((-4)*p2_p_Vci_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ci+0.0*p2_p_Vci_ei+(-4)*p2_p_Vci_ei_Vbi_ci)*o3+((-4)*p2_p_Vci_ei)*0.0+(((-4)*p2_p_Vbi_ci))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vci_ei)*o3*d10_sqrt0*((o3*tmp_Vbi_ci))*d10_cos1+((((-4)*p2_p_Vbi_ci))*o3)*d10_sqrt0*(o3*tmp_Vci_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ci))*(o3*tmp_Vci_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ci+0.0*tmp_Vci_ei+o3*tmp_Vci_ei_Vbi_ci)))-(+p2_a_Vci_ei_Vbi_ci*o3+p2_a_Vci_ei*0.0+p2_a_Vbi_ci*0.0+p2_a*0.0));
  tmp_Vci_ei_Vbi_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vbi_ei))*o3)*((-4)*p2_p_Vci_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vbi_ei+0.0*p2_p_Vci_ei+(-4)*p2_p_Vci_ei_Vbi_ei)*o3+((-4)*p2_p_Vci_ei)*0.0+(((-4)*p2_p_Vbi_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vci_ei)*o3*d10_sqrt0*((o3*tmp_Vbi_ei))*d10_cos1+((((-4)*p2_p_Vbi_ei))*o3)*d10_sqrt0*(o3*tmp_Vci_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vbi_ei))*(o3*tmp_Vci_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vbi_ei+0.0*tmp_Vci_ei+o3*tmp_Vci_ei_Vbi_ei)))-(+p2_a_Vci_ei_Vbi_ei*o3+p2_a_Vci_ei*0.0+p2_a_Vbi_ei*0.0+p2_a*0.0));
  tmp_Vci_ei_Vci_ei=(+(+(m20_sqrt((((-4)*p2_p)*o3))*((((-4)*p2_p_Vci_ei))*o3)*((-4)*p2_p_Vci_ei)*o3+d10_sqrt0*(+(+0.0*p2_p+0.0*p2_p_Vci_ei+0.0*p2_p_Vci_ei+(-4)*p2_p_Vci_ei_Vci_ei)*o3+((-4)*p2_p_Vci_ei)*0.0+(((-4)*p2_p_Vci_ei))*0.0+((-4)*p2_p)*0.0))*d00_cos1+((-4)*p2_p_Vci_ei)*o3*d10_sqrt0*((o3*tmp_Vci_ei))*d10_cos1+((((-4)*p2_p_Vci_ei))*o3)*d10_sqrt0*(o3*tmp_Vci_ei)*d10_cos1+d00_sqrt0*(m20_cos((o3*tmp))*((o3*tmp_Vci_ei))*(o3*tmp_Vci_ei)+d10_cos1*(+0.0*tmp+0.0*tmp_Vci_ei+0.0*tmp_Vci_ei+o3*tmp_Vci_ei_Vci_ei)))-(+p2_a_Vci_ei_Vci_ei*o3+p2_a_Vci_ei*0.0+p2_a_Vci_ei*0.0+p2_a*0.0));
#endif
#endif
tmp=((d00_sqrt0*d00_cos1)-(p2_a*o3));
EXIT_IF_ISNAN(((d00_sqrt0*d00_cos1)-(p2_a*o3)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
q_p3_Vb_ci=tmp_Vb_ci;
#if defined(_DERIVATE2)
  q_p3_Vb_ci_Vb_ci=tmp_Vb_ci_Vb_ci;
  q_p3_Vb_ci_Vtnode_GND=tmp_Vb_ci_Vtnode_GND;
  q_p3_Vb_ci_Vbi_ci=tmp_Vb_ci_Vbi_ci;
  q_p3_Vb_ci_Vbi_ei=tmp_Vb_ci_Vbi_ei;
  q_p3_Vb_ci_Vci_ei=tmp_Vb_ci_Vci_ei;
#endif
#if defined(_DERIVATE)
q_p3_Vtnode_GND=tmp_Vtnode_GND;
#endif
q_p3_Vbi_ci=tmp_Vbi_ci;
#if defined(_DERIVATE2)
  q_p3_Vbi_ci_Vb_ci=tmp_Vbi_ci_Vb_ci;
  q_p3_Vbi_ci_Vtnode_GND=tmp_Vbi_ci_Vtnode_GND;
  q_p3_Vbi_ci_Vbi_ci=tmp_Vbi_ci_Vbi_ci;
  q_p3_Vbi_ci_Vbi_ei=tmp_Vbi_ci_Vbi_ei;
  q_p3_Vbi_ci_Vci_ei=tmp_Vbi_ci_Vci_ei;
#endif
q_p3_Vbi_ei=tmp_Vbi_ei;
#if defined(_DERIVATE2)
  q_p3_Vbi_ei_Vb_ci=tmp_Vbi_ei_Vb_ci;
  q_p3_Vbi_ei_Vtnode_GND=tmp_Vbi_ei_Vtnode_GND;
  q_p3_Vbi_ei_Vbi_ci=tmp_Vbi_ei_Vbi_ci;
  q_p3_Vbi_ei_Vbi_ei=tmp_Vbi_ei_Vbi_ei;
  q_p3_Vbi_ei_Vci_ei=tmp_Vbi_ei_Vci_ei;
#endif
q_p3_Vci_ei=tmp_Vci_ei;
#if defined(_DERIVATE2)
  q_p3_Vci_ei_Vb_ci=tmp_Vci_ei_Vb_ci;
  q_p3_Vci_ei_Vtnode_GND=tmp_Vci_ei_Vtnode_GND;
  q_p3_Vci_ei_Vbi_ci=tmp_Vci_ei_Vbi_ci;
  q_p3_Vci_ei_Vbi_ei=tmp_Vci_ei_Vbi_ei;
  q_p3_Vci_ei_Vci_ei=tmp_Vci_ei_Vci_ei;
#endif
#endif
q_p3=tmp;
EXIT_IF_ISNAN(tmp)
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qpt_Vb_ci=q_p3_Vb_ci;
#if defined(_DERIVATE2)
  qpt_Vb_ci_Vb_ci=q_p3_Vb_ci_Vb_ci;
  qpt_Vb_ci_Vtnode_GND=q_p3_Vb_ci_Vtnode_GND;
  qpt_Vb_ci_Vbi_ci=q_p3_Vb_ci_Vbi_ci;
  qpt_Vb_ci_Vbi_ei=q_p3_Vb_ci_Vbi_ei;
  qpt_Vb_ci_Vci_ei=q_p3_Vb_ci_Vci_ei;
#endif
#if defined(_DERIVATE)
qpt_Vtnode_GND=q_p3_Vtnode_GND;
#endif
qpt_Vbi_ci=q_p3_Vbi_ci;
#if defined(_DERIVATE2)
  qpt_Vbi_ci_Vb_ci=q_p3_Vbi_ci_Vb_ci;
  qpt_Vbi_ci_Vtnode_GND=q_p3_Vbi_ci_Vtnode_GND;
  qpt_Vbi_ci_Vbi_ci=q_p3_Vbi_ci_Vbi_ci;
  qpt_Vbi_ci_Vbi_ei=q_p3_Vbi_ci_Vbi_ei;
  qpt_Vbi_ci_Vci_ei=q_p3_Vbi_ci_Vci_ei;
#endif
qpt_Vbi_ei=q_p3_Vbi_ei;
#if defined(_DERIVATE2)
  qpt_Vbi_ei_Vb_ci=q_p3_Vbi_ei_Vb_ci;
  qpt_Vbi_ei_Vtnode_GND=q_p3_Vbi_ei_Vtnode_GND;
  qpt_Vbi_ei_Vbi_ci=q_p3_Vbi_ei_Vbi_ci;
  qpt_Vbi_ei_Vbi_ei=q_p3_Vbi_ei_Vbi_ei;
  qpt_Vbi_ei_Vci_ei=q_p3_Vbi_ei_Vci_ei;
#endif
qpt_Vci_ei=q_p3_Vci_ei;
#if defined(_DERIVATE2)
  qpt_Vci_ei_Vb_ci=q_p3_Vci_ei_Vb_ci;
  qpt_Vci_ei_Vtnode_GND=q_p3_Vci_ei_Vtnode_GND;
  qpt_Vci_ei_Vbi_ci=q_p3_Vci_ei_Vbi_ci;
  qpt_Vci_ei_Vbi_ei=q_p3_Vci_ei_Vbi_ei;
  qpt_Vci_ei_Vci_ei=q_p3_Vci_ei_Vci_ei;
#endif
#endif
qpt=q_p3;
EXIT_IF_ISNAN(q_p3)
}
if
((qpt<=1e-20))
{
#if defined(_DERIVATEFORDDX) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND)V(s,GND)V(bi,GND)V(ci,GND) */
qpt_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qpt_Vb_ci_Vb_ci=0.0;
  qpt_Vb_ci_Vtnode_GND=0.0;
  qpt_Vb_ci_Vbi_ci=0.0;
  qpt_Vb_ci_Vbi_ei=0.0;
  qpt_Vb_ci_Vci_ei=0.0;
#endif
#if defined(_DERIVATE)
qpt_Vtnode_GND=0.0;
#endif
qpt_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qpt_Vbi_ci_Vb_ci=0.0;
  qpt_Vbi_ci_Vtnode_GND=0.0;
  qpt_Vbi_ci_Vbi_ci=0.0;
  qpt_Vbi_ci_Vbi_ei=0.0;
  qpt_Vbi_ci_Vci_ei=0.0;
#endif
qpt_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qpt_Vbi_ei_Vb_ci=0.0;
  qpt_Vbi_ei_Vtnode_GND=0.0;
  qpt_Vbi_ei_Vbi_ci=0.0;
  qpt_Vbi_ei_Vbi_ei=0.0;
  qpt_Vbi_ei_Vci_ei=0.0;
#endif
qpt_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qpt_Vci_ei_Vb_ci=0.0;
  qpt_Vci_ei_Vtnode_GND=0.0;
  qpt_Vci_ei_Vbi_ci=0.0;
  qpt_Vci_ei_Vbi_ei=0.0;
  qpt_Vci_ei_Vci_ei=0.0;
#endif
#endif
qpt=1e-20;
EXIT_IF_ISNAN(1e-20)
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(s,GND)V(ei,GND)V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
itf_Vtnode_GND=((itfi_Vtnode_GND*qpt-itfi*qpt_Vtnode_GND)/qpt/qpt);
#endif
itf_Vbi_ei=((itfi_Vbi_ei*qpt-itfi*qpt_Vbi_ei)/qpt/qpt);
#if defined(_DERIVATE2)
  itf_Vbi_ei_Vtnode_GND=(itfi_Vbi_ei_Vtnode_GND/qpt-(itfi_Vbi_ei*qpt_Vtnode_GND+itfi_Vtnode_GND*qpt_Vbi_ei+itfi*qpt_Vbi_ei_Vtnode_GND)/qpt/qpt+2*itfi*qpt_Vbi_ei*qpt_Vtnode_GND/qpt/qpt/qpt);
  itf_Vbi_ei_Vbi_ei=(itfi_Vbi_ei_Vbi_ei/qpt-(itfi_Vbi_ei*qpt_Vbi_ei+itfi_Vbi_ei*qpt_Vbi_ei+itfi*qpt_Vbi_ei_Vbi_ei)/qpt/qpt+2*itfi*qpt_Vbi_ei*qpt_Vbi_ei/qpt/qpt/qpt);
  itf_Vbi_ei_Vb_ci=(0.0/qpt-(itfi_Vbi_ei*qpt_Vb_ci+0.0*qpt_Vbi_ei+itfi*qpt_Vbi_ei_Vb_ci)/qpt/qpt+2*itfi*qpt_Vbi_ei*qpt_Vb_ci/qpt/qpt/qpt);
  itf_Vbi_ei_Vbi_ci=(0.0/qpt-(itfi_Vbi_ei*qpt_Vbi_ci+0.0*qpt_Vbi_ei+itfi*qpt_Vbi_ei_Vbi_ci)/qpt/qpt+2*itfi*qpt_Vbi_ei*qpt_Vbi_ci/qpt/qpt/qpt);
  itf_Vbi_ei_Vci_ei=(0.0/qpt-(itfi_Vbi_ei*qpt_Vci_ei+0.0*qpt_Vbi_ei+itfi*qpt_Vbi_ei_Vci_ei)/qpt/qpt+2*itfi*qpt_Vbi_ei*qpt_Vci_ei/qpt/qpt/qpt);
#endif
itf_Vb_ci=(-itfi*qpt_Vb_ci/qpt/qpt);
#if defined(_DERIVATE2)
  itf_Vb_ci_Vtnode_GND=(0.0/qpt-(0.0*qpt_Vtnode_GND+itfi_Vtnode_GND*qpt_Vb_ci+itfi*qpt_Vb_ci_Vtnode_GND)/qpt/qpt+2*itfi*qpt_Vb_ci*qpt_Vtnode_GND/qpt/qpt/qpt);
  itf_Vb_ci_Vbi_ei=(0.0/qpt-(0.0*qpt_Vbi_ei+itfi_Vbi_ei*qpt_Vb_ci+itfi*qpt_Vb_ci_Vbi_ei)/qpt/qpt+2*itfi*qpt_Vb_ci*qpt_Vbi_ei/qpt/qpt/qpt);
  itf_Vb_ci_Vb_ci=(0.0/qpt-(0.0*qpt_Vb_ci+0.0*qpt_Vb_ci+itfi*qpt_Vb_ci_Vb_ci)/qpt/qpt+2*itfi*qpt_Vb_ci*qpt_Vb_ci/qpt/qpt/qpt);
  itf_Vb_ci_Vbi_ci=(0.0/qpt-(0.0*qpt_Vbi_ci+0.0*qpt_Vb_ci+itfi*qpt_Vb_ci_Vbi_ci)/qpt/qpt+2*itfi*qpt_Vb_ci*qpt_Vbi_ci/qpt/qpt/qpt);
  itf_Vb_ci_Vci_ei=(0.0/qpt-(0.0*qpt_Vci_ei+0.0*qpt_Vb_ci+itfi*qpt_Vb_ci_Vci_ei)/qpt/qpt+2*itfi*qpt_Vb_ci*qpt_Vci_ei/qpt/qpt/qpt);
#endif
itf_Vbi_ci=(-itfi*qpt_Vbi_ci/qpt/qpt);
#if defined(_DERIVATE2)
  itf_Vbi_ci_Vtnode_GND=(0.0/qpt-(0.0*qpt_Vtnode_GND+itfi_Vtnode_GND*qpt_Vbi_ci+itfi*qpt_Vbi_ci_Vtnode_GND)/qpt/qpt+2*itfi*qpt_Vbi_ci*qpt_Vtnode_GND/qpt/qpt/qpt);
  itf_Vbi_ci_Vbi_ei=(0.0/qpt-(0.0*qpt_Vbi_ei+itfi_Vbi_ei*qpt_Vbi_ci+itfi*qpt_Vbi_ci_Vbi_ei)/qpt/qpt+2*itfi*qpt_Vbi_ci*qpt_Vbi_ei/qpt/qpt/qpt);
  itf_Vbi_ci_Vb_ci=(0.0/qpt-(0.0*qpt_Vb_ci+0.0*qpt_Vbi_ci+itfi*qpt_Vbi_ci_Vb_ci)/qpt/qpt+2*itfi*qpt_Vbi_ci*qpt_Vb_ci/qpt/qpt/qpt);
  itf_Vbi_ci_Vbi_ci=(0.0/qpt-(0.0*qpt_Vbi_ci+0.0*qpt_Vbi_ci+itfi*qpt_Vbi_ci_Vbi_ci)/qpt/qpt+2*itfi*qpt_Vbi_ci*qpt_Vbi_ci/qpt/qpt/qpt);
  itf_Vbi_ci_Vci_ei=(0.0/qpt-(0.0*qpt_Vci_ei+0.0*qpt_Vbi_ci+itfi*qpt_Vbi_ci_Vci_ei)/qpt/qpt+2*itfi*qpt_Vbi_ci*qpt_Vci_ei/qpt/qpt/qpt);
#endif
itf_Vci_ei=(-itfi*qpt_Vci_ei/qpt/qpt);
#if defined(_DERIVATE2)
  itf_Vci_ei_Vtnode_GND=(0.0/qpt-(0.0*qpt_Vtnode_GND+itfi_Vtnode_GND*qpt_Vci_ei+itfi*qpt_Vci_ei_Vtnode_GND)/qpt/qpt+2*itfi*qpt_Vci_ei*qpt_Vtnode_GND/qpt/qpt/qpt);
  itf_Vci_ei_Vbi_ei=(0.0/qpt-(0.0*qpt_Vbi_ei+itfi_Vbi_ei*qpt_Vci_ei+itfi*qpt_Vci_ei_Vbi_ei)/qpt/qpt+2*itfi*qpt_Vci_ei*qpt_Vbi_ei/qpt/qpt/qpt);
  itf_Vci_ei_Vb_ci=(0.0/qpt-(0.0*qpt_Vb_ci+0.0*qpt_Vci_ei+itfi*qpt_Vci_ei_Vb_ci)/qpt/qpt+2*itfi*qpt_Vci_ei*qpt_Vb_ci/qpt/qpt/qpt);
  itf_Vci_ei_Vbi_ci=(0.0/qpt-(0.0*qpt_Vbi_ci+0.0*qpt_Vci_ei+itfi*qpt_Vci_ei_Vbi_ci)/qpt/qpt+2*itfi*qpt_Vci_ei*qpt_Vbi_ci/qpt/qpt/qpt);
  itf_Vci_ei_Vci_ei=(0.0/qpt-(0.0*qpt_Vci_ei+0.0*qpt_Vci_ei+itfi*qpt_Vci_ei_Vci_ei)/qpt/qpt+2*itfi*qpt_Vci_ei*qpt_Vci_ei/qpt/qpt/qpt);
#endif
#endif
itf=(itfi/qpt);
EXIT_IF_ISNAN((itfi/qpt))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci)V(b,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
itr_Vtnode_GND=((itri_Vtnode_GND*qpt-itri*qpt_Vtnode_GND)/qpt/qpt);
#endif
itr_Vbi_ci=((itri_Vbi_ci*qpt-itri*qpt_Vbi_ci)/qpt/qpt);
#if defined(_DERIVATE2)
  itr_Vbi_ci_Vtnode_GND=(itri_Vbi_ci_Vtnode_GND/qpt-(itri_Vbi_ci*qpt_Vtnode_GND+itri_Vtnode_GND*qpt_Vbi_ci+itri*qpt_Vbi_ci_Vtnode_GND)/qpt/qpt+2*itri*qpt_Vbi_ci*qpt_Vtnode_GND/qpt/qpt/qpt);
  itr_Vbi_ci_Vbi_ci=(itri_Vbi_ci_Vbi_ci/qpt-(itri_Vbi_ci*qpt_Vbi_ci+itri_Vbi_ci*qpt_Vbi_ci+itri*qpt_Vbi_ci_Vbi_ci)/qpt/qpt+2*itri*qpt_Vbi_ci*qpt_Vbi_ci/qpt/qpt/qpt);
  itr_Vbi_ci_Vb_ci=(0.0/qpt-(itri_Vbi_ci*qpt_Vb_ci+0.0*qpt_Vbi_ci+itri*qpt_Vbi_ci_Vb_ci)/qpt/qpt+2*itri*qpt_Vbi_ci*qpt_Vb_ci/qpt/qpt/qpt);
  itr_Vbi_ci_Vbi_ei=(0.0/qpt-(itri_Vbi_ci*qpt_Vbi_ei+0.0*qpt_Vbi_ci+itri*qpt_Vbi_ci_Vbi_ei)/qpt/qpt+2*itri*qpt_Vbi_ci*qpt_Vbi_ei/qpt/qpt/qpt);
  itr_Vbi_ci_Vci_ei=(0.0/qpt-(itri_Vbi_ci*qpt_Vci_ei+0.0*qpt_Vbi_ci+itri*qpt_Vbi_ci_Vci_ei)/qpt/qpt+2*itri*qpt_Vbi_ci*qpt_Vci_ei/qpt/qpt/qpt);
#endif
itr_Vb_ci=(-itri*qpt_Vb_ci/qpt/qpt);
#if defined(_DERIVATE2)
  itr_Vb_ci_Vtnode_GND=(0.0/qpt-(0.0*qpt_Vtnode_GND+itri_Vtnode_GND*qpt_Vb_ci+itri*qpt_Vb_ci_Vtnode_GND)/qpt/qpt+2*itri*qpt_Vb_ci*qpt_Vtnode_GND/qpt/qpt/qpt);
  itr_Vb_ci_Vbi_ci=(0.0/qpt-(0.0*qpt_Vbi_ci+itri_Vbi_ci*qpt_Vb_ci+itri*qpt_Vb_ci_Vbi_ci)/qpt/qpt+2*itri*qpt_Vb_ci*qpt_Vbi_ci/qpt/qpt/qpt);
  itr_Vb_ci_Vb_ci=(0.0/qpt-(0.0*qpt_Vb_ci+0.0*qpt_Vb_ci+itri*qpt_Vb_ci_Vb_ci)/qpt/qpt+2*itri*qpt_Vb_ci*qpt_Vb_ci/qpt/qpt/qpt);
  itr_Vb_ci_Vbi_ei=(0.0/qpt-(0.0*qpt_Vbi_ei+0.0*qpt_Vb_ci+itri*qpt_Vb_ci_Vbi_ei)/qpt/qpt+2*itri*qpt_Vb_ci*qpt_Vbi_ei/qpt/qpt/qpt);
  itr_Vb_ci_Vci_ei=(0.0/qpt-(0.0*qpt_Vci_ei+0.0*qpt_Vb_ci+itri*qpt_Vb_ci_Vci_ei)/qpt/qpt+2*itri*qpt_Vb_ci*qpt_Vci_ei/qpt/qpt/qpt);
#endif
itr_Vbi_ei=(-itri*qpt_Vbi_ei/qpt/qpt);
#if defined(_DERIVATE2)
  itr_Vbi_ei_Vtnode_GND=(0.0/qpt-(0.0*qpt_Vtnode_GND+itri_Vtnode_GND*qpt_Vbi_ei+itri*qpt_Vbi_ei_Vtnode_GND)/qpt/qpt+2*itri*qpt_Vbi_ei*qpt_Vtnode_GND/qpt/qpt/qpt);
  itr_Vbi_ei_Vbi_ci=(0.0/qpt-(0.0*qpt_Vbi_ci+itri_Vbi_ci*qpt_Vbi_ei+itri*qpt_Vbi_ei_Vbi_ci)/qpt/qpt+2*itri*qpt_Vbi_ei*qpt_Vbi_ci/qpt/qpt/qpt);
  itr_Vbi_ei_Vb_ci=(0.0/qpt-(0.0*qpt_Vb_ci+0.0*qpt_Vbi_ei+itri*qpt_Vbi_ei_Vb_ci)/qpt/qpt+2*itri*qpt_Vbi_ei*qpt_Vb_ci/qpt/qpt/qpt);
  itr_Vbi_ei_Vbi_ei=(0.0/qpt-(0.0*qpt_Vbi_ei+0.0*qpt_Vbi_ei+itri*qpt_Vbi_ei_Vbi_ei)/qpt/qpt+2*itri*qpt_Vbi_ei*qpt_Vbi_ei/qpt/qpt/qpt);
  itr_Vbi_ei_Vci_ei=(0.0/qpt-(0.0*qpt_Vci_ei+0.0*qpt_Vbi_ei+itri*qpt_Vbi_ei_Vci_ei)/qpt/qpt+2*itri*qpt_Vbi_ei*qpt_Vci_ei/qpt/qpt/qpt);
#endif
itr_Vci_ei=(-itri*qpt_Vci_ei/qpt/qpt);
#if defined(_DERIVATE2)
  itr_Vci_ei_Vtnode_GND=(0.0/qpt-(0.0*qpt_Vtnode_GND+itri_Vtnode_GND*qpt_Vci_ei+itri*qpt_Vci_ei_Vtnode_GND)/qpt/qpt+2*itri*qpt_Vci_ei*qpt_Vtnode_GND/qpt/qpt/qpt);
  itr_Vci_ei_Vbi_ci=(0.0/qpt-(0.0*qpt_Vbi_ci+itri_Vbi_ci*qpt_Vci_ei+itri*qpt_Vci_ei_Vbi_ci)/qpt/qpt+2*itri*qpt_Vci_ei*qpt_Vbi_ci/qpt/qpt/qpt);
  itr_Vci_ei_Vb_ci=(0.0/qpt-(0.0*qpt_Vb_ci+0.0*qpt_Vci_ei+itri*qpt_Vci_ei_Vb_ci)/qpt/qpt+2*itri*qpt_Vci_ei*qpt_Vb_ci/qpt/qpt/qpt);
  itr_Vci_ei_Vbi_ei=(0.0/qpt-(0.0*qpt_Vbi_ei+0.0*qpt_Vci_ei+itri*qpt_Vci_ei_Vbi_ei)/qpt/qpt+2*itri*qpt_Vci_ei*qpt_Vbi_ei/qpt/qpt/qpt);
  itr_Vci_ei_Vci_ei=(0.0/qpt-(0.0*qpt_Vci_ei+0.0*qpt_Vci_ei+itri*qpt_Vci_ei_Vci_ei)/qpt/qpt+2*itri*qpt_Vci_ei*qpt_Vci_ei/qpt/qpt/qpt);
#endif
#endif
itr=(itri/qpt);
EXIT_IF_ISNAN((itri/qpt))
if
((itf<=1e-20))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(s,GND)V(ei,GND)V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
itf_Vtnode_GND=0.0;
#endif
itf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  itf_Vbi_ei_Vtnode_GND=0.0;
  itf_Vbi_ei_Vbi_ei=0.0;
  itf_Vbi_ei_Vb_ci=0.0;
  itf_Vbi_ei_Vbi_ci=0.0;
  itf_Vbi_ei_Vci_ei=0.0;
#endif
itf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  itf_Vb_ci_Vtnode_GND=0.0;
  itf_Vb_ci_Vbi_ei=0.0;
  itf_Vb_ci_Vb_ci=0.0;
  itf_Vb_ci_Vbi_ci=0.0;
  itf_Vb_ci_Vci_ei=0.0;
#endif
itf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  itf_Vbi_ci_Vtnode_GND=0.0;
  itf_Vbi_ci_Vbi_ei=0.0;
  itf_Vbi_ci_Vb_ci=0.0;
  itf_Vbi_ci_Vbi_ci=0.0;
  itf_Vbi_ci_Vci_ei=0.0;
#endif
itf_Vci_ei=0.0;
#if defined(_DERIVATE2)
  itf_Vci_ei_Vtnode_GND=0.0;
  itf_Vci_ei_Vbi_ei=0.0;
  itf_Vci_ei_Vb_ci=0.0;
  itf_Vci_ei_Vbi_ci=0.0;
  itf_Vci_ei_Vci_ei=0.0;
#endif
#endif
itf=1e-20;
EXIT_IF_ISNAN(1e-20)
}
#if defined(_DERIVATEFORDDX) /* probe=V(xf2,GND)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
it_Vxf2_GND=0.0;
#endif
#if defined(_DERIVATE)
it_Vtnode_GND=(itf_Vtnode_GND-itr_Vtnode_GND);
#endif
it_Vbi_ei=(itf_Vbi_ei-itr_Vbi_ei);
#if defined(_DERIVATE2)
  it_Vbi_ei_Vxf2_GND=(+0.0-0.0);
  it_Vbi_ei_Vtnode_GND=(+itf_Vbi_ei_Vtnode_GND-itr_Vbi_ei_Vtnode_GND);
  it_Vbi_ei_Vbi_ei=(+itf_Vbi_ei_Vbi_ei-itr_Vbi_ei_Vbi_ei);
  it_Vbi_ei_Vb_ci=(+itf_Vbi_ei_Vb_ci-itr_Vbi_ei_Vb_ci);
  it_Vbi_ei_Vbi_ci=(+itf_Vbi_ei_Vbi_ci-itr_Vbi_ei_Vbi_ci);
  it_Vbi_ei_Vci_ei=(+itf_Vbi_ei_Vci_ei-itr_Vbi_ei_Vci_ei);
#endif
it_Vb_ci=(itf_Vb_ci-itr_Vb_ci);
#if defined(_DERIVATE2)
  it_Vb_ci_Vxf2_GND=(+0.0-0.0);
  it_Vb_ci_Vtnode_GND=(+itf_Vb_ci_Vtnode_GND-itr_Vb_ci_Vtnode_GND);
  it_Vb_ci_Vbi_ei=(+itf_Vb_ci_Vbi_ei-itr_Vb_ci_Vbi_ei);
  it_Vb_ci_Vb_ci=(+itf_Vb_ci_Vb_ci-itr_Vb_ci_Vb_ci);
  it_Vb_ci_Vbi_ci=(+itf_Vb_ci_Vbi_ci-itr_Vb_ci_Vbi_ci);
  it_Vb_ci_Vci_ei=(+itf_Vb_ci_Vci_ei-itr_Vb_ci_Vci_ei);
#endif
it_Vbi_ci=(itf_Vbi_ci-itr_Vbi_ci);
#if defined(_DERIVATE2)
  it_Vbi_ci_Vxf2_GND=(+0.0-0.0);
  it_Vbi_ci_Vtnode_GND=(+itf_Vbi_ci_Vtnode_GND-itr_Vbi_ci_Vtnode_GND);
  it_Vbi_ci_Vbi_ei=(+itf_Vbi_ci_Vbi_ei-itr_Vbi_ci_Vbi_ei);
  it_Vbi_ci_Vb_ci=(+itf_Vbi_ci_Vb_ci-itr_Vbi_ci_Vb_ci);
  it_Vbi_ci_Vbi_ci=(+itf_Vbi_ci_Vbi_ci-itr_Vbi_ci_Vbi_ci);
  it_Vbi_ci_Vci_ei=(+itf_Vbi_ci_Vci_ei-itr_Vbi_ci_Vci_ei);
#endif
it_Vci_ei=(itf_Vci_ei-itr_Vci_ei);
#if defined(_DERIVATE2)
  it_Vci_ei_Vxf2_GND=(+0.0-0.0);
  it_Vci_ei_Vtnode_GND=(+itf_Vci_ei_Vtnode_GND-itr_Vci_ei_Vtnode_GND);
  it_Vci_ei_Vbi_ei=(+itf_Vci_ei_Vbi_ei-itr_Vci_ei_Vbi_ei);
  it_Vci_ei_Vb_ci=(+itf_Vci_ei_Vb_ci-itr_Vci_ei_Vb_ci);
  it_Vci_ei_Vbi_ci=(+itf_Vci_ei_Vbi_ci-itr_Vci_ei_Vbi_ci);
  it_Vci_ei_Vci_ei=(+itf_Vci_ei_Vci_ei-itr_Vci_ei_Vci_ei);
#endif
#endif
pInst->it=(itf-itr);
EXIT_IF_ISNAN((itf-itr))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND) */
#if defined(_DERIVATE)
qf0_Vtnode_GND=((tf0_Vtnode_GND*itf)+(tf0*itf_Vtnode_GND));
#endif
#if defined(_DERIVATE)
qf0_Vb_ci=((tf0_Vb_ci*itf)+(tf0*itf_Vb_ci));
#endif
#if defined(_DERIVATE)
qf0_Vbi_ci=((tf0_Vbi_ci*itf)+(tf0*itf_Vbi_ci));
#endif
qf0_Vbi_ei=(tf0*itf_Vbi_ei);
#if defined(_DERIVATE2)
  qf0_Vbi_ei_Vtnode_GND=(+0.0*itf+0.0*itf_Vtnode_GND+tf0_Vtnode_GND*itf_Vbi_ei+tf0*itf_Vbi_ei_Vtnode_GND);
  qf0_Vbi_ei_Vb_ci=(+0.0*itf+0.0*itf_Vb_ci+tf0_Vb_ci*itf_Vbi_ei+tf0*itf_Vbi_ei_Vb_ci);
  qf0_Vbi_ei_Vbi_ci=(+0.0*itf+0.0*itf_Vbi_ci+tf0_Vbi_ci*itf_Vbi_ei+tf0*itf_Vbi_ei_Vbi_ci);
  qf0_Vbi_ei_Vbi_ei=(+0.0*itf+0.0*itf_Vbi_ei+0.0*itf_Vbi_ei+tf0*itf_Vbi_ei_Vbi_ei);
  qf0_Vbi_ei_Vci_ei=(+0.0*itf+0.0*itf_Vci_ei+0.0*itf_Vbi_ei+tf0*itf_Vbi_ei_Vci_ei);
#endif
qf0_Vci_ei=(tf0*itf_Vci_ei);
#if defined(_DERIVATE2)
  qf0_Vci_ei_Vtnode_GND=(+0.0*itf+0.0*itf_Vtnode_GND+tf0_Vtnode_GND*itf_Vci_ei+tf0*itf_Vci_ei_Vtnode_GND);
  qf0_Vci_ei_Vb_ci=(+0.0*itf+0.0*itf_Vb_ci+tf0_Vb_ci*itf_Vci_ei+tf0*itf_Vci_ei_Vb_ci);
  qf0_Vci_ei_Vbi_ci=(+0.0*itf+0.0*itf_Vbi_ci+tf0_Vbi_ci*itf_Vci_ei+tf0*itf_Vci_ei_Vbi_ci);
  qf0_Vci_ei_Vbi_ei=(+0.0*itf+0.0*itf_Vbi_ei+0.0*itf_Vci_ei+tf0*itf_Vci_ei_Vbi_ei);
  qf0_Vci_ei_Vci_ei=(+0.0*itf+0.0*itf_Vci_ei+0.0*itf_Vci_ei+tf0*itf_Vci_ei_Vci_ei);
#endif
#endif
qf0=(tf0*itf);
EXIT_IF_ISNAN((tf0*itf))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=(-((ick_Vci_ei*itf-ick*itf_Vci_ei)/itf/itf));
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=(+0.0-(ick_Vci_ei_Vci_ei/itf-(ick_Vci_ei*itf_Vci_ei+ick_Vci_ei*itf_Vci_ei+ick*itf_Vci_ei_Vci_ei)/itf/itf+2*ick*itf_Vci_ei*itf_Vci_ei/itf/itf/itf));
  a_Vci_ei_Vbi_ei=(+0.0-(0.0/itf-(ick_Vci_ei*itf_Vbi_ei+0.0*itf_Vci_ei+ick*itf_Vci_ei_Vbi_ei)/itf/itf+2*ick*itf_Vci_ei*itf_Vbi_ei/itf/itf/itf));
  a_Vci_ei_Vb_ci=(+0.0-(0.0/itf-(ick_Vci_ei*itf_Vb_ci+0.0*itf_Vci_ei+ick*itf_Vci_ei_Vb_ci)/itf/itf+2*ick*itf_Vci_ei*itf_Vb_ci/itf/itf/itf));
  a_Vci_ei_Vbi_ci=(+0.0-(0.0/itf-(ick_Vci_ei*itf_Vbi_ci+0.0*itf_Vci_ei+ick*itf_Vci_ei_Vbi_ci)/itf/itf+2*ick*itf_Vci_ei*itf_Vbi_ci/itf/itf/itf));
  a_Vci_ei_Vtnode_GND=(+0.0-(ick_Vci_ei_Vtnode_GND/itf-(ick_Vci_ei*itf_Vtnode_GND+ick_Vtnode_GND*itf_Vci_ei+ick*itf_Vci_ei_Vtnode_GND)/itf/itf+2*ick*itf_Vci_ei*itf_Vtnode_GND/itf/itf/itf));
#endif
a_Vbi_ei=(-(-ick*itf_Vbi_ei/itf/itf));
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=(+0.0-(0.0/itf-(0.0*itf_Vci_ei+ick_Vci_ei*itf_Vbi_ei+ick*itf_Vbi_ei_Vci_ei)/itf/itf+2*ick*itf_Vbi_ei*itf_Vci_ei/itf/itf/itf));
  a_Vbi_ei_Vbi_ei=(+0.0-(0.0/itf-(0.0*itf_Vbi_ei+0.0*itf_Vbi_ei+ick*itf_Vbi_ei_Vbi_ei)/itf/itf+2*ick*itf_Vbi_ei*itf_Vbi_ei/itf/itf/itf));
  a_Vbi_ei_Vb_ci=(+0.0-(0.0/itf-(0.0*itf_Vb_ci+0.0*itf_Vbi_ei+ick*itf_Vbi_ei_Vb_ci)/itf/itf+2*ick*itf_Vbi_ei*itf_Vb_ci/itf/itf/itf));
  a_Vbi_ei_Vbi_ci=(+0.0-(0.0/itf-(0.0*itf_Vbi_ci+0.0*itf_Vbi_ei+ick*itf_Vbi_ei_Vbi_ci)/itf/itf+2*ick*itf_Vbi_ei*itf_Vbi_ci/itf/itf/itf));
  a_Vbi_ei_Vtnode_GND=(+0.0-(0.0/itf-(0.0*itf_Vtnode_GND+ick_Vtnode_GND*itf_Vbi_ei+ick*itf_Vbi_ei_Vtnode_GND)/itf/itf+2*ick*itf_Vbi_ei*itf_Vtnode_GND/itf/itf/itf));
#endif
a_Vb_ci=(-(-ick*itf_Vb_ci/itf/itf));
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=(+0.0-(0.0/itf-(0.0*itf_Vci_ei+ick_Vci_ei*itf_Vb_ci+ick*itf_Vb_ci_Vci_ei)/itf/itf+2*ick*itf_Vb_ci*itf_Vci_ei/itf/itf/itf));
  a_Vb_ci_Vbi_ei=(+0.0-(0.0/itf-(0.0*itf_Vbi_ei+0.0*itf_Vb_ci+ick*itf_Vb_ci_Vbi_ei)/itf/itf+2*ick*itf_Vb_ci*itf_Vbi_ei/itf/itf/itf));
  a_Vb_ci_Vb_ci=(+0.0-(0.0/itf-(0.0*itf_Vb_ci+0.0*itf_Vb_ci+ick*itf_Vb_ci_Vb_ci)/itf/itf+2*ick*itf_Vb_ci*itf_Vb_ci/itf/itf/itf));
  a_Vb_ci_Vbi_ci=(+0.0-(0.0/itf-(0.0*itf_Vbi_ci+0.0*itf_Vb_ci+ick*itf_Vb_ci_Vbi_ci)/itf/itf+2*ick*itf_Vb_ci*itf_Vbi_ci/itf/itf/itf));
  a_Vb_ci_Vtnode_GND=(+0.0-(0.0/itf-(0.0*itf_Vtnode_GND+ick_Vtnode_GND*itf_Vb_ci+ick*itf_Vb_ci_Vtnode_GND)/itf/itf+2*ick*itf_Vb_ci*itf_Vtnode_GND/itf/itf/itf));
#endif
a_Vbi_ci=(-(-ick*itf_Vbi_ci/itf/itf));
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=(+0.0-(0.0/itf-(0.0*itf_Vci_ei+ick_Vci_ei*itf_Vbi_ci+ick*itf_Vbi_ci_Vci_ei)/itf/itf+2*ick*itf_Vbi_ci*itf_Vci_ei/itf/itf/itf));
  a_Vbi_ci_Vbi_ei=(+0.0-(0.0/itf-(0.0*itf_Vbi_ei+0.0*itf_Vbi_ci+ick*itf_Vbi_ci_Vbi_ei)/itf/itf+2*ick*itf_Vbi_ci*itf_Vbi_ei/itf/itf/itf));
  a_Vbi_ci_Vb_ci=(+0.0-(0.0/itf-(0.0*itf_Vb_ci+0.0*itf_Vbi_ci+ick*itf_Vbi_ci_Vb_ci)/itf/itf+2*ick*itf_Vbi_ci*itf_Vb_ci/itf/itf/itf));
  a_Vbi_ci_Vbi_ci=(+0.0-(0.0/itf-(0.0*itf_Vbi_ci+0.0*itf_Vbi_ci+ick*itf_Vbi_ci_Vbi_ci)/itf/itf+2*ick*itf_Vbi_ci*itf_Vbi_ci/itf/itf/itf));
  a_Vbi_ci_Vtnode_GND=(+0.0-(0.0/itf-(0.0*itf_Vtnode_GND+ick_Vtnode_GND*itf_Vbi_ci+ick*itf_Vbi_ci_Vtnode_GND)/itf/itf+2*ick*itf_Vbi_ci*itf_Vtnode_GND/itf/itf/itf));
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=(-((ick_Vtnode_GND*itf-ick*itf_Vtnode_GND)/itf/itf));
#endif
#endif
a=(1-(ick/itf));
EXIT_IF_ISNAN((1-(ick/itf)))
{
double m00_sqrt(d00_sqrt0,((a*a)+pModel->ahc))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((a*a)+pModel->ahc))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ei,GND) */
s3_Vci_ei=((a_Vci_ei*a)+(a*a_Vci_ei))*d10_sqrt0;
#if defined(_DERIVATE2)
  s3_Vci_ei_Vci_ei=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vci_ei*a)+(a*a_Vci_ei)))*((a_Vci_ei*a)+(a*a_Vci_ei))+d10_sqrt0*(+(+a_Vci_ei_Vci_ei*a+a_Vci_ei*a_Vci_ei+a_Vci_ei*a_Vci_ei+a*a_Vci_ei_Vci_ei)+0.0));
  s3_Vci_ei_Vbi_ei=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vbi_ei*a)+(a*a_Vbi_ei)))*((a_Vci_ei*a)+(a*a_Vci_ei))+d10_sqrt0*(+(+a_Vci_ei_Vbi_ei*a+a_Vci_ei*a_Vbi_ei+a_Vbi_ei*a_Vci_ei+a*a_Vci_ei_Vbi_ei)+0.0));
  s3_Vci_ei_Vb_ci=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vb_ci*a)+(a*a_Vb_ci)))*((a_Vci_ei*a)+(a*a_Vci_ei))+d10_sqrt0*(+(+a_Vci_ei_Vb_ci*a+a_Vci_ei*a_Vb_ci+a_Vb_ci*a_Vci_ei+a*a_Vci_ei_Vb_ci)+0.0));
  s3_Vci_ei_Vbi_ci=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vbi_ci*a)+(a*a_Vbi_ci)))*((a_Vci_ei*a)+(a*a_Vci_ei))+d10_sqrt0*(+(+a_Vci_ei_Vbi_ci*a+a_Vci_ei*a_Vbi_ci+a_Vbi_ci*a_Vci_ei+a*a_Vci_ei_Vbi_ci)+0.0));
  s3_Vci_ei_Vtnode_GND=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vtnode_GND*a)+(a*a_Vtnode_GND)))*((a_Vci_ei*a)+(a*a_Vci_ei))+d10_sqrt0*(+(+a_Vci_ei_Vtnode_GND*a+a_Vci_ei*a_Vtnode_GND+a_Vtnode_GND*a_Vci_ei+a*a_Vci_ei_Vtnode_GND)+0.0));
#endif
s3_Vbi_ei=((a_Vbi_ei*a)+(a*a_Vbi_ei))*d10_sqrt0;
#if defined(_DERIVATE2)
  s3_Vbi_ei_Vci_ei=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vci_ei*a)+(a*a_Vci_ei)))*((a_Vbi_ei*a)+(a*a_Vbi_ei))+d10_sqrt0*(+(+a_Vbi_ei_Vci_ei*a+a_Vbi_ei*a_Vci_ei+a_Vci_ei*a_Vbi_ei+a*a_Vbi_ei_Vci_ei)+0.0));
  s3_Vbi_ei_Vbi_ei=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vbi_ei*a)+(a*a_Vbi_ei)))*((a_Vbi_ei*a)+(a*a_Vbi_ei))+d10_sqrt0*(+(+a_Vbi_ei_Vbi_ei*a+a_Vbi_ei*a_Vbi_ei+a_Vbi_ei*a_Vbi_ei+a*a_Vbi_ei_Vbi_ei)+0.0));
  s3_Vbi_ei_Vb_ci=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vb_ci*a)+(a*a_Vb_ci)))*((a_Vbi_ei*a)+(a*a_Vbi_ei))+d10_sqrt0*(+(+a_Vbi_ei_Vb_ci*a+a_Vbi_ei*a_Vb_ci+a_Vb_ci*a_Vbi_ei+a*a_Vbi_ei_Vb_ci)+0.0));
  s3_Vbi_ei_Vbi_ci=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vbi_ci*a)+(a*a_Vbi_ci)))*((a_Vbi_ei*a)+(a*a_Vbi_ei))+d10_sqrt0*(+(+a_Vbi_ei_Vbi_ci*a+a_Vbi_ei*a_Vbi_ci+a_Vbi_ci*a_Vbi_ei+a*a_Vbi_ei_Vbi_ci)+0.0));
  s3_Vbi_ei_Vtnode_GND=(m20_sqrt(((a*a)+pModel->ahc))*(((a_Vtnode_GND*a)+(a*a_Vtnode_GND)))*((a_Vbi_ei*a)+(a*a_Vbi_ei))+d10_sqrt0*(+(+a_Vbi_ei_Vtnode_GND*a+a_Vbi_ei*a_Vtnode_GND+a_Vtnode_GND*a_Vbi_ei+a*a_Vbi_ei_Vtnode_GND)+0.0));
#endif
#if defined(_DERIVATE)
s3_Vb_ci=((a_Vb_ci*a)+(a*a_Vb_ci))*d10_sqrt0;
#endif
#if defined(_DERIVATE)
s3_Vbi_ci=((a_Vbi_ci*a)+(a*a_Vbi_ci))*d10_sqrt0;
#endif
#if defined(_DERIVATE)
s3_Vtnode_GND=((a_Vtnode_GND*a)+(a*a_Vtnode_GND))*d10_sqrt0;
#endif
#endif
s3=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_sqrt(d00_sqrt0,(1+pModel->ahc))
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ei,GND) */
w_Vci_ei=((a_Vci_ei+s3_Vci_ei)/(1+d00_sqrt0));
#if defined(_DERIVATE2)
  w_Vci_ei_Vci_ei=((+a_Vci_ei_Vci_ei+s3_Vci_ei_Vci_ei)/(1+d00_sqrt0)-((a_Vci_ei+s3_Vci_ei)*0.0+(a_Vci_ei+s3_Vci_ei)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vci_ei_Vbi_ei=((+a_Vci_ei_Vbi_ei+s3_Vci_ei_Vbi_ei)/(1+d00_sqrt0)-((a_Vci_ei+s3_Vci_ei)*0.0+(a_Vbi_ei+s3_Vbi_ei)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vci_ei_Vb_ci=((+a_Vci_ei_Vb_ci+s3_Vci_ei_Vb_ci)/(1+d00_sqrt0)-((a_Vci_ei+s3_Vci_ei)*0.0+(a_Vb_ci+s3_Vb_ci)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vci_ei_Vbi_ci=((+a_Vci_ei_Vbi_ci+s3_Vci_ei_Vbi_ci)/(1+d00_sqrt0)-((a_Vci_ei+s3_Vci_ei)*0.0+(a_Vbi_ci+s3_Vbi_ci)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vci_ei_Vtnode_GND=((+a_Vci_ei_Vtnode_GND+s3_Vci_ei_Vtnode_GND)/(1+d00_sqrt0)-((a_Vci_ei+s3_Vci_ei)*0.0+(a_Vtnode_GND+s3_Vtnode_GND)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
#endif
w_Vbi_ei=((a_Vbi_ei+s3_Vbi_ei)/(1+d00_sqrt0));
#if defined(_DERIVATE2)
  w_Vbi_ei_Vci_ei=((+a_Vbi_ei_Vci_ei+s3_Vbi_ei_Vci_ei)/(1+d00_sqrt0)-((a_Vbi_ei+s3_Vbi_ei)*0.0+(a_Vci_ei+s3_Vci_ei)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vbi_ei_Vbi_ei=((+a_Vbi_ei_Vbi_ei+s3_Vbi_ei_Vbi_ei)/(1+d00_sqrt0)-((a_Vbi_ei+s3_Vbi_ei)*0.0+(a_Vbi_ei+s3_Vbi_ei)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vbi_ei_Vb_ci=((+a_Vbi_ei_Vb_ci+s3_Vbi_ei_Vb_ci)/(1+d00_sqrt0)-((a_Vbi_ei+s3_Vbi_ei)*0.0+(a_Vb_ci+s3_Vb_ci)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vbi_ei_Vbi_ci=((+a_Vbi_ei_Vbi_ci+s3_Vbi_ei_Vbi_ci)/(1+d00_sqrt0)-((a_Vbi_ei+s3_Vbi_ei)*0.0+(a_Vbi_ci+s3_Vbi_ci)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
  w_Vbi_ei_Vtnode_GND=((+a_Vbi_ei_Vtnode_GND+s3_Vbi_ei_Vtnode_GND)/(1+d00_sqrt0)-((a_Vbi_ei+s3_Vbi_ei)*0.0+(a_Vtnode_GND+s3_Vtnode_GND)*0.0+(a+s3)*(+0.0+0.0))/(1+d00_sqrt0)/(1+d00_sqrt0)+2*(a+s3)*0.0*0.0/(1+d00_sqrt0)/(1+d00_sqrt0)/(1+d00_sqrt0));
#endif
#if defined(_DERIVATE)
w_Vb_ci=((a_Vb_ci+s3_Vb_ci)/(1+d00_sqrt0));
#endif
#if defined(_DERIVATE)
w_Vbi_ci=((a_Vbi_ci+s3_Vbi_ci)/(1+d00_sqrt0));
#endif
#if defined(_DERIVATE)
w_Vtnode_GND=((a_Vtnode_GND+s3_Vtnode_GND)/(1+d00_sqrt0));
#endif
#endif
w=((a+s3)/(1+d00_sqrt0));
EXIT_IF_ISNAN(((a+s3)/(1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND) */
#if defined(_DERIVATE)
tww_Vtnode_GND=((((thcs_t_Vtnode_GND*w)+(thcs_t*w_Vtnode_GND))*w)+((thcs_t*w)*w_Vtnode_GND));
#endif
tww_Vci_ei=(((thcs_t*w_Vci_ei)*w)+((thcs_t*w)*w_Vci_ei));
#if defined(_DERIVATE2)
  tww_Vci_ei_Vtnode_GND=(+(+0.0*w+0.0*w_Vtnode_GND+thcs_t_Vtnode_GND*w_Vci_ei+thcs_t*w_Vci_ei_Vtnode_GND)*w+(thcs_t*w_Vci_ei)*w_Vtnode_GND+(((thcs_t_Vtnode_GND*w)+(thcs_t*w_Vtnode_GND)))*w_Vci_ei+(thcs_t*w)*w_Vci_ei_Vtnode_GND);
  tww_Vci_ei_Vci_ei=(+(+0.0*w+0.0*w_Vci_ei+0.0*w_Vci_ei+thcs_t*w_Vci_ei_Vci_ei)*w+(thcs_t*w_Vci_ei)*w_Vci_ei+((thcs_t*w_Vci_ei))*w_Vci_ei+(thcs_t*w)*w_Vci_ei_Vci_ei);
  tww_Vci_ei_Vbi_ei=(+(+0.0*w+0.0*w_Vbi_ei+0.0*w_Vci_ei+thcs_t*w_Vci_ei_Vbi_ei)*w+(thcs_t*w_Vci_ei)*w_Vbi_ei+((thcs_t*w_Vbi_ei))*w_Vci_ei+(thcs_t*w)*w_Vci_ei_Vbi_ei);
  tww_Vci_ei_Vb_ci=(+(+0.0*w+0.0*w_Vb_ci+0.0*w_Vci_ei+thcs_t*w_Vci_ei_Vb_ci)*w+(thcs_t*w_Vci_ei)*w_Vb_ci+((thcs_t*w_Vb_ci))*w_Vci_ei+(thcs_t*w)*w_Vci_ei_Vb_ci);
  tww_Vci_ei_Vbi_ci=(+(+0.0*w+0.0*w_Vbi_ci+0.0*w_Vci_ei+thcs_t*w_Vci_ei_Vbi_ci)*w+(thcs_t*w_Vci_ei)*w_Vbi_ci+((thcs_t*w_Vbi_ci))*w_Vci_ei+(thcs_t*w)*w_Vci_ei_Vbi_ci);
#endif
tww_Vbi_ei=(((thcs_t*w_Vbi_ei)*w)+((thcs_t*w)*w_Vbi_ei));
#if defined(_DERIVATE2)
  tww_Vbi_ei_Vtnode_GND=(+(+0.0*w+0.0*w_Vtnode_GND+thcs_t_Vtnode_GND*w_Vbi_ei+thcs_t*w_Vbi_ei_Vtnode_GND)*w+(thcs_t*w_Vbi_ei)*w_Vtnode_GND+(((thcs_t_Vtnode_GND*w)+(thcs_t*w_Vtnode_GND)))*w_Vbi_ei+(thcs_t*w)*w_Vbi_ei_Vtnode_GND);
  tww_Vbi_ei_Vci_ei=(+(+0.0*w+0.0*w_Vci_ei+0.0*w_Vbi_ei+thcs_t*w_Vbi_ei_Vci_ei)*w+(thcs_t*w_Vbi_ei)*w_Vci_ei+((thcs_t*w_Vci_ei))*w_Vbi_ei+(thcs_t*w)*w_Vbi_ei_Vci_ei);
  tww_Vbi_ei_Vbi_ei=(+(+0.0*w+0.0*w_Vbi_ei+0.0*w_Vbi_ei+thcs_t*w_Vbi_ei_Vbi_ei)*w+(thcs_t*w_Vbi_ei)*w_Vbi_ei+((thcs_t*w_Vbi_ei))*w_Vbi_ei+(thcs_t*w)*w_Vbi_ei_Vbi_ei);
  tww_Vbi_ei_Vb_ci=(+(+0.0*w+0.0*w_Vb_ci+0.0*w_Vbi_ei+thcs_t*w_Vbi_ei_Vb_ci)*w+(thcs_t*w_Vbi_ei)*w_Vb_ci+((thcs_t*w_Vb_ci))*w_Vbi_ei+(thcs_t*w)*w_Vbi_ei_Vb_ci);
  tww_Vbi_ei_Vbi_ci=(+(+0.0*w+0.0*w_Vbi_ci+0.0*w_Vbi_ei+thcs_t*w_Vbi_ei_Vbi_ci)*w+(thcs_t*w_Vbi_ei)*w_Vbi_ci+((thcs_t*w_Vbi_ci))*w_Vbi_ei+(thcs_t*w)*w_Vbi_ei_Vbi_ci);
#endif
#if defined(_DERIVATE)
tww_Vb_ci=(((thcs_t*w_Vb_ci)*w)+((thcs_t*w)*w_Vb_ci));
#endif
#if defined(_DERIVATE)
tww_Vbi_ci=(((thcs_t*w_Vbi_ci)*w)+((thcs_t*w)*w_Vbi_ci));
#endif
#endif
tww=((thcs_t*w)*w);
EXIT_IF_ISNAN(((thcs_t*w)*w))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND) */
#if defined(_DERIVATE)
dqfh_Vtnode_GND=((tww_Vtnode_GND*itf)+(tww*itf_Vtnode_GND));
#endif
dqfh_Vci_ei=((tww_Vci_ei*itf)+(tww*itf_Vci_ei));
#if defined(_DERIVATE2)
  dqfh_Vci_ei_Vtnode_GND=(+tww_Vci_ei_Vtnode_GND*itf+tww_Vci_ei*itf_Vtnode_GND+tww_Vtnode_GND*itf_Vci_ei+tww*itf_Vci_ei_Vtnode_GND);
  dqfh_Vci_ei_Vci_ei=(+tww_Vci_ei_Vci_ei*itf+tww_Vci_ei*itf_Vci_ei+tww_Vci_ei*itf_Vci_ei+tww*itf_Vci_ei_Vci_ei);
  dqfh_Vci_ei_Vbi_ei=(+tww_Vci_ei_Vbi_ei*itf+tww_Vci_ei*itf_Vbi_ei+tww_Vbi_ei*itf_Vci_ei+tww*itf_Vci_ei_Vbi_ei);
  dqfh_Vci_ei_Vb_ci=(+tww_Vci_ei_Vb_ci*itf+tww_Vci_ei*itf_Vb_ci+tww_Vb_ci*itf_Vci_ei+tww*itf_Vci_ei_Vb_ci);
  dqfh_Vci_ei_Vbi_ci=(+tww_Vci_ei_Vbi_ci*itf+tww_Vci_ei*itf_Vbi_ci+tww_Vbi_ci*itf_Vci_ei+tww*itf_Vci_ei_Vbi_ci);
#endif
dqfh_Vbi_ei=((tww_Vbi_ei*itf)+(tww*itf_Vbi_ei));
#if defined(_DERIVATE2)
  dqfh_Vbi_ei_Vtnode_GND=(+tww_Vbi_ei_Vtnode_GND*itf+tww_Vbi_ei*itf_Vtnode_GND+tww_Vtnode_GND*itf_Vbi_ei+tww*itf_Vbi_ei_Vtnode_GND);
  dqfh_Vbi_ei_Vci_ei=(+tww_Vbi_ei_Vci_ei*itf+tww_Vbi_ei*itf_Vci_ei+tww_Vci_ei*itf_Vbi_ei+tww*itf_Vbi_ei_Vci_ei);
  dqfh_Vbi_ei_Vbi_ei=(+tww_Vbi_ei_Vbi_ei*itf+tww_Vbi_ei*itf_Vbi_ei+tww_Vbi_ei*itf_Vbi_ei+tww*itf_Vbi_ei_Vbi_ei);
  dqfh_Vbi_ei_Vb_ci=(+tww_Vbi_ei_Vb_ci*itf+tww_Vbi_ei*itf_Vb_ci+tww_Vb_ci*itf_Vbi_ei+tww*itf_Vbi_ei_Vb_ci);
  dqfh_Vbi_ei_Vbi_ci=(+tww_Vbi_ei_Vbi_ci*itf+tww_Vbi_ei*itf_Vbi_ci+tww_Vbi_ci*itf_Vbi_ei+tww*itf_Vbi_ei_Vbi_ci);
#endif
#if defined(_DERIVATE)
dqfh_Vb_ci=((tww_Vb_ci*itf)+(tww*itf_Vb_ci));
#endif
#if defined(_DERIVATE)
dqfh_Vbi_ci=((tww_Vbi_ci*itf)+(tww*itf_Vbi_ci));
#endif
#endif
dqfh=(tww*itf);
EXIT_IF_ISNAN((tww*itf))
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe= */
dtfh_Vtnode_GND=((tww_Vtnode_GND*(1+(((2*ick)/itf)/s3)))+(tww*(((((2*ick_Vtnode_GND)*itf-(2*ick)*itf_Vtnode_GND)/itf/itf)*s3-((2*ick)/itf)*s3_Vtnode_GND)/s3/s3)));
dtfh_Vci_ei=((tww_Vci_ei*(1+(((2*ick)/itf)/s3)))+(tww*(((((2*ick_Vci_ei)*itf-(2*ick)*itf_Vci_ei)/itf/itf)*s3-((2*ick)/itf)*s3_Vci_ei)/s3/s3)));
dtfh_Vbi_ei=((tww_Vbi_ei*(1+(((2*ick)/itf)/s3)))+(tww*(((-(2*ick)*itf_Vbi_ei/itf/itf)*s3-((2*ick)/itf)*s3_Vbi_ei)/s3/s3)));
dtfh_Vb_ci=((tww_Vb_ci*(1+(((2*ick)/itf)/s3)))+(tww*(((-(2*ick)*itf_Vb_ci/itf/itf)*s3-((2*ick)/itf)*s3_Vb_ci)/s3/s3)));
dtfh_Vbi_ci=((tww_Vbi_ci*(1+(((2*ick)/itf)/s3)))+(tww*(((-(2*ick)*itf_Vbi_ci/itf/itf)*s3-((2*ick)/itf)*s3_Vbi_ci)/s3/s3)));
#endif
dtfh=(tww*(1+(((2*ick)/itf)/s3)));
EXIT_IF_ISNAN((tww*(1+(((2*ick)/itf)/s3))))
{
double m00_logE(d00_logE0,(itf/ick))
double m00_exp(d00_exp1,(pModel->gte*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(itf/ick))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ei,GND) */
#if defined(_DERIVATE)
dtef_Vtnode_GND=((tef0_t_Vtnode_GND*d00_exp1)+(tef0_t*(pModel->gte*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*d10_logE0)*d10_exp1));
#endif
dtef_Vbi_ei=(tef0_t*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  dtef_Vbi_ei_Vtnode_GND=(+0.0*d00_exp1+0.0*((pModel->gte*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*d10_logE0))*d10_exp1+tef0_t_Vtnode_GND*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*d10_logE0))*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*d10_logE0+0.0*(itf_Vbi_ei/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*(itf_Vbi_ei/ick)+d10_logE0*(itf_Vbi_ei_Vtnode_GND/ick-(itf_Vbi_ei*ick_Vtnode_GND+itf_Vtnode_GND*0.0+itf*0.0)/ick/ick+2*itf*0.0*ick_Vtnode_GND/ick/ick/ick)))));
  dtef_Vbi_ei_Vbi_ei=(+0.0*d00_exp1+0.0*((pModel->gte*(itf_Vbi_ei/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*(itf_Vbi_ei/ick)*d10_logE0))*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(itf_Vbi_ei/ick)*d10_logE0+0.0*(itf_Vbi_ei/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*(itf_Vbi_ei/ick)*(itf_Vbi_ei/ick)+d10_logE0*(itf_Vbi_ei_Vbi_ei/ick-(itf_Vbi_ei*0.0+itf_Vbi_ei*0.0+itf*0.0)/ick/ick+2*itf*0.0*0.0/ick/ick/ick)))));
  dtef_Vbi_ei_Vb_ci=(+0.0*d00_exp1+0.0*((pModel->gte*(itf_Vb_ci/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*(itf_Vb_ci/ick)*d10_logE0))*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(itf_Vb_ci/ick)*d10_logE0+0.0*(itf_Vbi_ei/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*(itf_Vb_ci/ick)*(itf_Vbi_ei/ick)+d10_logE0*(itf_Vbi_ei_Vb_ci/ick-(itf_Vbi_ei*0.0+itf_Vb_ci*0.0+itf*0.0)/ick/ick+2*itf*0.0*0.0/ick/ick/ick)))));
  dtef_Vbi_ei_Vbi_ci=(+0.0*d00_exp1+0.0*((pModel->gte*(itf_Vbi_ci/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*(itf_Vbi_ci/ick)*d10_logE0))*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(itf_Vbi_ci/ick)*d10_logE0+0.0*(itf_Vbi_ei/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*(itf_Vbi_ci/ick)*(itf_Vbi_ei/ick)+d10_logE0*(itf_Vbi_ei_Vbi_ci/ick-(itf_Vbi_ei*0.0+itf_Vbi_ci*0.0+itf*0.0)/ick/ick+2*itf*0.0*0.0/ick/ick/ick)))));
  dtef_Vbi_ei_Vci_ei=(+0.0*d00_exp1+0.0*((pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0))*(pModel->gte*(itf_Vbi_ei/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0+0.0*(itf_Vbi_ei/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*(itf_Vbi_ei/ick)+d10_logE0*(itf_Vbi_ei_Vci_ei/ick-(itf_Vbi_ei*ick_Vci_ei+itf_Vci_ei*0.0+itf*0.0)/ick/ick+2*itf*0.0*ick_Vci_ei/ick/ick/ick)))));
#endif
#if defined(_DERIVATE)
dtef_Vb_ci=(tef0_t*(pModel->gte*(itf_Vb_ci/ick)*d10_logE0)*d10_exp1);
#endif
#if defined(_DERIVATE)
dtef_Vbi_ci=(tef0_t*(pModel->gte*(itf_Vbi_ci/ick)*d10_logE0)*d10_exp1);
#endif
dtef_Vci_ei=(tef0_t*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  dtef_Vci_ei_Vtnode_GND=(+0.0*d00_exp1+0.0*((pModel->gte*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*d10_logE0))*d10_exp1+tef0_t_Vtnode_GND*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*d10_logE0))*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*d10_logE0+0.0*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*((itf_Vtnode_GND*ick-itf*ick_Vtnode_GND)/ick/ick)*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)+d10_logE0*(itf_Vci_ei_Vtnode_GND/ick-(itf_Vci_ei*ick_Vtnode_GND+itf_Vtnode_GND*ick_Vci_ei+itf*ick_Vci_ei_Vtnode_GND)/ick/ick+2*itf*ick_Vci_ei*ick_Vtnode_GND/ick/ick/ick)))));
  dtef_Vci_ei_Vbi_ei=(+0.0*d00_exp1+0.0*((pModel->gte*(itf_Vbi_ei/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*(itf_Vbi_ei/ick)*d10_logE0))*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(itf_Vbi_ei/ick)*d10_logE0+0.0*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*(itf_Vbi_ei/ick)*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)+d10_logE0*(itf_Vci_ei_Vbi_ei/ick-(itf_Vci_ei*0.0+itf_Vbi_ei*ick_Vci_ei+itf*0.0)/ick/ick+2*itf*ick_Vci_ei*0.0/ick/ick/ick)))));
  dtef_Vci_ei_Vb_ci=(+0.0*d00_exp1+0.0*((pModel->gte*(itf_Vb_ci/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*(itf_Vb_ci/ick)*d10_logE0))*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(itf_Vb_ci/ick)*d10_logE0+0.0*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*(itf_Vb_ci/ick)*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)+d10_logE0*(itf_Vci_ei_Vb_ci/ick-(itf_Vci_ei*0.0+itf_Vb_ci*ick_Vci_ei+itf*0.0)/ick/ick+2*itf*ick_Vci_ei*0.0/ick/ick/ick)))));
  dtef_Vci_ei_Vbi_ci=(+0.0*d00_exp1+0.0*((pModel->gte*(itf_Vbi_ci/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*(itf_Vbi_ci/ick)*d10_logE0))*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(itf_Vbi_ci/ick)*d10_logE0+0.0*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*(itf_Vbi_ci/ick)*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)+d10_logE0*(itf_Vci_ei_Vbi_ci/ick-(itf_Vci_ei*0.0+itf_Vbi_ci*ick_Vci_ei+itf*0.0)/ick/ick+2*itf*ick_Vci_ei*0.0/ick/ick/ick)))));
  dtef_Vci_ei_Vci_ei=(+0.0*d00_exp1+0.0*((pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0))*d10_exp1+0.0*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)*d10_exp1+tef0_t*(m20_exp((pModel->gte*d00_logE0))*((pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0))*(pModel->gte*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0+0.0*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*d10_logE0+pModel->gte*(m20_logE((itf/ick))*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)*((itf_Vci_ei*ick-itf*ick_Vci_ei)/ick/ick)+d10_logE0*(itf_Vci_ei_Vci_ei/ick-(itf_Vci_ei*ick_Vci_ei+itf_Vci_ei*ick_Vci_ei+itf*ick_Vci_ei_Vci_ei)/ick/ick+2*itf*ick_Vci_ei*ick_Vci_ei/ick/ick/ick)))));
#endif
#endif
dtef=(tef0_t*d00_exp1);
EXIT_IF_ISNAN((tef0_t*d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ei,GND) */
#if defined(_DERIVATE)
dqef_Vtnode_GND=(((dtef_Vtnode_GND*itf)+(dtef*itf_Vtnode_GND))/(pModel->gte+1.0));
#endif
dqef_Vbi_ei=(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei))/(pModel->gte+1.0));
#if defined(_DERIVATE2)
  dqef_Vbi_ei_Vtnode_GND=((+dtef_Vbi_ei_Vtnode_GND*itf+dtef_Vbi_ei*itf_Vtnode_GND+dtef_Vtnode_GND*itf_Vbi_ei+dtef*itf_Vbi_ei_Vtnode_GND)/(pModel->gte+1.0)-(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei))*0.0+(((dtef_Vtnode_GND*itf)+(dtef*itf_Vtnode_GND)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vbi_ei_Vbi_ei=((+dtef_Vbi_ei_Vbi_ei*itf+dtef_Vbi_ei*itf_Vbi_ei+dtef_Vbi_ei*itf_Vbi_ei+dtef*itf_Vbi_ei_Vbi_ei)/(pModel->gte+1.0)-(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei))*0.0+(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vbi_ei_Vb_ci=((+dtef_Vbi_ei_Vb_ci*itf+dtef_Vbi_ei*itf_Vb_ci+dtef_Vb_ci*itf_Vbi_ei+dtef*itf_Vbi_ei_Vb_ci)/(pModel->gte+1.0)-(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei))*0.0+(((dtef_Vb_ci*itf)+(dtef*itf_Vb_ci)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vbi_ei_Vbi_ci=((+dtef_Vbi_ei_Vbi_ci*itf+dtef_Vbi_ei*itf_Vbi_ci+dtef_Vbi_ci*itf_Vbi_ei+dtef*itf_Vbi_ei_Vbi_ci)/(pModel->gte+1.0)-(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei))*0.0+(((dtef_Vbi_ci*itf)+(dtef*itf_Vbi_ci)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vbi_ei_Vci_ei=((+dtef_Vbi_ei_Vci_ei*itf+dtef_Vbi_ei*itf_Vci_ei+dtef_Vci_ei*itf_Vbi_ei+dtef*itf_Vbi_ei_Vci_ei)/(pModel->gte+1.0)-(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei))*0.0+(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
#endif
#if defined(_DERIVATE)
dqef_Vb_ci=(((dtef_Vb_ci*itf)+(dtef*itf_Vb_ci))/(pModel->gte+1.0));
#endif
#if defined(_DERIVATE)
dqef_Vbi_ci=(((dtef_Vbi_ci*itf)+(dtef*itf_Vbi_ci))/(pModel->gte+1.0));
#endif
dqef_Vci_ei=(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei))/(pModel->gte+1.0));
#if defined(_DERIVATE2)
  dqef_Vci_ei_Vtnode_GND=((+dtef_Vci_ei_Vtnode_GND*itf+dtef_Vci_ei*itf_Vtnode_GND+dtef_Vtnode_GND*itf_Vci_ei+dtef*itf_Vci_ei_Vtnode_GND)/(pModel->gte+1.0)-(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei))*0.0+(((dtef_Vtnode_GND*itf)+(dtef*itf_Vtnode_GND)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vci_ei_Vbi_ei=((+dtef_Vci_ei_Vbi_ei*itf+dtef_Vci_ei*itf_Vbi_ei+dtef_Vbi_ei*itf_Vci_ei+dtef*itf_Vci_ei_Vbi_ei)/(pModel->gte+1.0)-(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei))*0.0+(((dtef_Vbi_ei*itf)+(dtef*itf_Vbi_ei)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vci_ei_Vb_ci=((+dtef_Vci_ei_Vb_ci*itf+dtef_Vci_ei*itf_Vb_ci+dtef_Vb_ci*itf_Vci_ei+dtef*itf_Vci_ei_Vb_ci)/(pModel->gte+1.0)-(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei))*0.0+(((dtef_Vb_ci*itf)+(dtef*itf_Vb_ci)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vci_ei_Vbi_ci=((+dtef_Vci_ei_Vbi_ci*itf+dtef_Vci_ei*itf_Vbi_ci+dtef_Vbi_ci*itf_Vci_ei+dtef*itf_Vci_ei_Vbi_ci)/(pModel->gte+1.0)-(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei))*0.0+(((dtef_Vbi_ci*itf)+(dtef*itf_Vbi_ci)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
  dqef_Vci_ei_Vci_ei=((+dtef_Vci_ei_Vci_ei*itf+dtef_Vci_ei*itf_Vci_ei+dtef_Vci_ei*itf_Vci_ei+dtef*itf_Vci_ei_Vci_ei)/(pModel->gte+1.0)-(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei))*0.0+(((dtef_Vci_ei*itf)+(dtef*itf_Vci_ei)))*0.0+(dtef*itf)*(+0.0+0.0))/(pModel->gte+1.0)/(pModel->gte+1.0)+2*(dtef*itf)*0.0*0.0/(pModel->gte+1.0)/(pModel->gte+1.0)/(pModel->gte+1.0));
#endif
#endif
dqef=((dtef*itf)/(pModel->gte+1.0));
EXIT_IF_ISNAN(((dtef*itf)/(pModel->gte+1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ei,GND) */
#if defined(_DERIVATE)
qf_Vtnode_GND=((qf0_Vtnode_GND+dqef_Vtnode_GND)+dqfh_Vtnode_GND);
#endif
#if defined(_DERIVATE)
qf_Vb_ci=((qf0_Vb_ci+dqef_Vb_ci)+dqfh_Vb_ci);
#endif
#if defined(_DERIVATE)
qf_Vbi_ci=((qf0_Vbi_ci+dqef_Vbi_ci)+dqfh_Vbi_ci);
#endif
qf_Vbi_ei=((qf0_Vbi_ei+dqef_Vbi_ei)+dqfh_Vbi_ei);
#if defined(_DERIVATE2)
  qf_Vbi_ei_Vtnode_GND=(+(+qf0_Vbi_ei_Vtnode_GND+dqef_Vbi_ei_Vtnode_GND)+dqfh_Vbi_ei_Vtnode_GND);
  qf_Vbi_ei_Vb_ci=(+(+qf0_Vbi_ei_Vb_ci+dqef_Vbi_ei_Vb_ci)+dqfh_Vbi_ei_Vb_ci);
  qf_Vbi_ei_Vbi_ci=(+(+qf0_Vbi_ei_Vbi_ci+dqef_Vbi_ei_Vbi_ci)+dqfh_Vbi_ei_Vbi_ci);
  qf_Vbi_ei_Vbi_ei=(+(+qf0_Vbi_ei_Vbi_ei+dqef_Vbi_ei_Vbi_ei)+dqfh_Vbi_ei_Vbi_ei);
  qf_Vbi_ei_Vci_ei=(+(+qf0_Vbi_ei_Vci_ei+dqef_Vbi_ei_Vci_ei)+dqfh_Vbi_ei_Vci_ei);
#endif
qf_Vci_ei=((qf0_Vci_ei+dqef_Vci_ei)+dqfh_Vci_ei);
#if defined(_DERIVATE2)
  qf_Vci_ei_Vtnode_GND=(+(+qf0_Vci_ei_Vtnode_GND+dqef_Vci_ei_Vtnode_GND)+dqfh_Vci_ei_Vtnode_GND);
  qf_Vci_ei_Vb_ci=(+(+qf0_Vci_ei_Vb_ci+dqef_Vci_ei_Vb_ci)+dqfh_Vci_ei_Vb_ci);
  qf_Vci_ei_Vbi_ci=(+(+qf0_Vci_ei_Vbi_ci+dqef_Vci_ei_Vbi_ci)+dqfh_Vci_ei_Vbi_ci);
  qf_Vci_ei_Vbi_ei=(+(+qf0_Vci_ei_Vbi_ei+dqef_Vci_ei_Vbi_ei)+dqfh_Vci_ei_Vbi_ei);
  qf_Vci_ei_Vci_ei=(+(+qf0_Vci_ei_Vci_ei+dqef_Vci_ei_Vci_ei)+dqfh_Vci_ei_Vci_ei);
#endif
#endif
qf=((qf0+dqef)+dqfh);
EXIT_IF_ISNAN(((qf0+dqef)+dqfh))
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(b,ci)V(bi,ci)V(ci,ei)V(bi,ei) ddxprobe= */
tf_Vtnode_GND=((tf0_Vtnode_GND+dtfh_Vtnode_GND)+dtef_Vtnode_GND);
tf_Vb_ci=((tf0_Vb_ci+dtfh_Vb_ci)+dtef_Vb_ci);
tf_Vbi_ci=((tf0_Vbi_ci+dtfh_Vbi_ci)+dtef_Vbi_ci);
tf_Vci_ei=(dtfh_Vci_ei+dtef_Vci_ei);
tf_Vbi_ei=(dtfh_Vbi_ei+dtef_Vbi_ei);
#endif
tf=((tf0+dtfh)+dtef);
EXIT_IF_ISNAN(((tf0+dtfh)+dtef))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci)V(b,ci)V(bi,ei)V(ci,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
qr_Vtnode_GND=(pModel->tr*itr_Vtnode_GND);
#endif
qr_Vbi_ci=(pModel->tr*itr_Vbi_ci);
#if defined(_DERIVATE2)
  qr_Vbi_ci_Vtnode_GND=(+0.0*itr+0.0*itr_Vtnode_GND+0.0*itr_Vbi_ci+pModel->tr*itr_Vbi_ci_Vtnode_GND);
  qr_Vbi_ci_Vbi_ci=(+0.0*itr+0.0*itr_Vbi_ci+0.0*itr_Vbi_ci+pModel->tr*itr_Vbi_ci_Vbi_ci);
  qr_Vbi_ci_Vb_ci=(+0.0*itr+0.0*itr_Vb_ci+0.0*itr_Vbi_ci+pModel->tr*itr_Vbi_ci_Vb_ci);
  qr_Vbi_ci_Vbi_ei=(+0.0*itr+0.0*itr_Vbi_ei+0.0*itr_Vbi_ci+pModel->tr*itr_Vbi_ci_Vbi_ei);
  qr_Vbi_ci_Vci_ei=(+0.0*itr+0.0*itr_Vci_ei+0.0*itr_Vbi_ci+pModel->tr*itr_Vbi_ci_Vci_ei);
#endif
qr_Vb_ci=(pModel->tr*itr_Vb_ci);
#if defined(_DERIVATE2)
  qr_Vb_ci_Vtnode_GND=(+0.0*itr+0.0*itr_Vtnode_GND+0.0*itr_Vb_ci+pModel->tr*itr_Vb_ci_Vtnode_GND);
  qr_Vb_ci_Vbi_ci=(+0.0*itr+0.0*itr_Vbi_ci+0.0*itr_Vb_ci+pModel->tr*itr_Vb_ci_Vbi_ci);
  qr_Vb_ci_Vb_ci=(+0.0*itr+0.0*itr_Vb_ci+0.0*itr_Vb_ci+pModel->tr*itr_Vb_ci_Vb_ci);
  qr_Vb_ci_Vbi_ei=(+0.0*itr+0.0*itr_Vbi_ei+0.0*itr_Vb_ci+pModel->tr*itr_Vb_ci_Vbi_ei);
  qr_Vb_ci_Vci_ei=(+0.0*itr+0.0*itr_Vci_ei+0.0*itr_Vb_ci+pModel->tr*itr_Vb_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
qr_Vbi_ei=(pModel->tr*itr_Vbi_ei);
#endif
qr_Vci_ei=(pModel->tr*itr_Vci_ei);
#if defined(_DERIVATE2)
  qr_Vci_ei_Vtnode_GND=(+0.0*itr+0.0*itr_Vtnode_GND+0.0*itr_Vci_ei+pModel->tr*itr_Vci_ei_Vtnode_GND);
  qr_Vci_ei_Vbi_ci=(+0.0*itr+0.0*itr_Vbi_ci+0.0*itr_Vci_ei+pModel->tr*itr_Vci_ei_Vbi_ci);
  qr_Vci_ei_Vb_ci=(+0.0*itr+0.0*itr_Vb_ci+0.0*itr_Vci_ei+pModel->tr*itr_Vci_ei_Vb_ci);
  qr_Vci_ei_Vbi_ei=(+0.0*itr+0.0*itr_Vbi_ei+0.0*itr_Vci_ei+pModel->tr*itr_Vci_ei_Vbi_ei);
  qr_Vci_ei_Vci_ei=(+0.0*itr+0.0*itr_Vci_ei+0.0*itr_Vci_ei+pModel->tr*itr_Vci_ei_Vci_ei);
#endif
#endif
qr=(pModel->tr*itr);
EXIT_IF_ISNAN((pModel->tr*itr))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=0.0;
  DIOY_Vs_ci_Vbi_ci=0.0;
  DIOY_Vs_ci_Vbi_ei=0.0;
  DIOY_Vs_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=0.0;
  DIOY_Vbi_ci_Vbi_ci=0.0;
  DIOY_Vbi_ci_Vbi_ei=0.0;
  DIOY_Vbi_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ei=(Vbiei_Vbi_ei/(pModel->mbe*VT));
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=(0.0/(pModel->mbe*VT)-(Vbiei_Vbi_ei*(0.0)+0.0*0.0+Vbiei*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mbe*0.0))/(pModel->mbe*VT)/(pModel->mbe*VT)+2*Vbiei*0.0*(0.0)/(pModel->mbe*VT)/(pModel->mbe*VT)/(pModel->mbe*VT));
  DIOY_Vbi_ei_Vbi_ci=(0.0/(pModel->mbe*VT)-(Vbiei_Vbi_ei*(0.0)+0.0*0.0+Vbiei*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mbe*0.0))/(pModel->mbe*VT)/(pModel->mbe*VT)+2*Vbiei*0.0*(0.0)/(pModel->mbe*VT)/(pModel->mbe*VT)/(pModel->mbe*VT));
  DIOY_Vbi_ei_Vbi_ei=(Vbiei_Vbi_ei_Vbi_ei/(pModel->mbe*VT)-(Vbiei_Vbi_ei*(0.0)+Vbiei_Vbi_ei*0.0+Vbiei*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mbe*0.0))/(pModel->mbe*VT)/(pModel->mbe*VT)+2*Vbiei*0.0*(0.0)/(pModel->mbe*VT)/(pModel->mbe*VT)/(pModel->mbe*VT));
  DIOY_Vbi_ei_Vtnode_GND=(0.0/(pModel->mbe*VT)-(Vbiei_Vbi_ei*((pModel->mbe*VT_Vtnode_GND))+0.0*0.0+Vbiei*(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+pModel->mbe*0.0))/(pModel->mbe*VT)/(pModel->mbe*VT)+2*Vbiei*0.0*((pModel->mbe*VT_Vtnode_GND))/(pModel->mbe*VT)/(pModel->mbe*VT)/(pModel->mbe*VT));
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=(-Vbiei*(pModel->mbe*VT_Vtnode_GND)/(pModel->mbe*VT)/(pModel->mbe*VT));
#endif
#endif
DIOY=(Vbiei/(pModel->mbe*VT));
EXIT_IF_ISNAN((Vbiei/(pModel->mbe*VT)))
if
((pModel->ibes>0.0))
{
if
((DIOY>80))
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=DIOY_Vbi_ei;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+0.0+(+DIOY_Vbi_ei_Vs_ci-0.0));
  le_Vbi_ei_Vbi_ci=(+0.0+(+DIOY_Vbi_ei_Vbi_ci-0.0));
  le_Vbi_ei_Vbi_ei=(+0.0+(+DIOY_Vbi_ei_Vbi_ei-0.0));
  le_Vbi_ei_Vtnode_GND=(+0.0+(+DIOY_Vbi_ei_Vtnode_GND-0.0));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=DIOY_Vtnode_GND;
#endif
#endif
le=(1+(DIOY-80));
EXIT_IF_ISNAN((1+(DIOY-80)))
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=0.0;
  DIOY_Vs_ci_Vbi_ci=0.0;
  DIOY_Vs_ci_Vbi_ei=0.0;
  DIOY_Vs_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=0.0;
  DIOY_Vbi_ci_Vbi_ci=0.0;
  DIOY_Vbi_ci_Vbi_ei=0.0;
  DIOY_Vbi_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=0.0;
  DIOY_Vbi_ei_Vbi_ci=0.0;
  DIOY_Vbi_ei_Vbi_ei=0.0;
  DIOY_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=0.0;
#endif
#endif
DIOY=80;
EXIT_IF_ISNAN(80)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=0.0;
  le_Vbi_ei_Vbi_ci=0.0;
  le_Vbi_ei_Vbi_ei=0.0;
  le_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=0.0;
#endif
#endif
le=1;
EXIT_IF_ISNAN(1)
}
{
double m00_limexp(d00_limexp0,DIOY)
#if defined(_DERIVATEFORDDX)
double m10_limexp(d10_limexp0,d00_limexp0,DIOY)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=((le_Vbi_ei*d00_limexp0)+(le*DIOY_Vbi_ei*d10_limexp0));
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+le_Vbi_ei_Vs_ci*d00_limexp0+le_Vbi_ei*DIOY_Vs_ci*d10_limexp0+le_Vs_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vs_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vs_ci));
  le_Vbi_ei_Vbi_ci=(+le_Vbi_ei_Vbi_ci*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ci*d10_limexp0+le_Vbi_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ci));
  le_Vbi_ei_Vbi_ei=(+le_Vbi_ei_Vbi_ei*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ei*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ei));
  le_Vbi_ei_Vtnode_GND=(+le_Vbi_ei_Vtnode_GND*d00_limexp0+le_Vbi_ei*DIOY_Vtnode_GND*d10_limexp0+le_Vtnode_GND*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vtnode_GND*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vtnode_GND));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=((le_Vtnode_GND*d00_limexp0)+(le*DIOY_Vtnode_GND*d10_limexp0));
#endif
#endif
le=(le*d00_limexp0);
EXIT_IF_ISNAN((le*d00_limexp0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ibe_Vtnode_GND=((ibes_t_Vtnode_GND*(le-1.0))+(ibes_t*le_Vtnode_GND));
#endif
ibe_Vbi_ei=(ibes_t*le_Vbi_ei);
#if defined(_DERIVATE2)
  ibe_Vbi_ei_Vtnode_GND=(+0.0*(le-1.0)+0.0*le_Vtnode_GND+ibes_t_Vtnode_GND*le_Vbi_ei+ibes_t*(+le_Vbi_ei_Vtnode_GND-0.0));
  ibe_Vbi_ei_Vbi_ei=(+0.0*(le-1.0)+0.0*le_Vbi_ei+0.0*le_Vbi_ei+ibes_t*(+le_Vbi_ei_Vbi_ei-0.0));
#endif
#endif
ibe=(ibes_t*(le-1.0));
EXIT_IF_ISNAN((ibes_t*(le-1.0)))
if
((DIOY<=(-14.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ibe_Vtnode_GND=(-ibes_t_Vtnode_GND);
#endif
ibe_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ibe_Vbi_ei_Vtnode_GND=0.0;
  ibe_Vbi_ei_Vbi_ei=0.0;
#endif
#endif
ibe=(-ibes_t);
EXIT_IF_ISNAN((-ibes_t))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ibe_Vtnode_GND=0.0;
#endif
ibe_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ibe_Vbi_ei_Vtnode_GND=0.0;
  ibe_Vbi_ei_Vbi_ei=0.0;
#endif
#endif
ibe=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=0.0;
  DIOY_Vs_ci_Vbi_ci=0.0;
  DIOY_Vs_ci_Vbi_ei=0.0;
  DIOY_Vs_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=0.0;
  DIOY_Vbi_ci_Vbi_ci=0.0;
  DIOY_Vbi_ci_Vbi_ei=0.0;
  DIOY_Vbi_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ei=(Vbiei_Vbi_ei/(pModel->mre*VT));
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=(0.0/(pModel->mre*VT)-(Vbiei_Vbi_ei*(0.0)+0.0*0.0+Vbiei*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mre*0.0))/(pModel->mre*VT)/(pModel->mre*VT)+2*Vbiei*0.0*(0.0)/(pModel->mre*VT)/(pModel->mre*VT)/(pModel->mre*VT));
  DIOY_Vbi_ei_Vbi_ci=(0.0/(pModel->mre*VT)-(Vbiei_Vbi_ei*(0.0)+0.0*0.0+Vbiei*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mre*0.0))/(pModel->mre*VT)/(pModel->mre*VT)+2*Vbiei*0.0*(0.0)/(pModel->mre*VT)/(pModel->mre*VT)/(pModel->mre*VT));
  DIOY_Vbi_ei_Vbi_ei=(Vbiei_Vbi_ei_Vbi_ei/(pModel->mre*VT)-(Vbiei_Vbi_ei*(0.0)+Vbiei_Vbi_ei*0.0+Vbiei*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mre*0.0))/(pModel->mre*VT)/(pModel->mre*VT)+2*Vbiei*0.0*(0.0)/(pModel->mre*VT)/(pModel->mre*VT)/(pModel->mre*VT));
  DIOY_Vbi_ei_Vtnode_GND=(0.0/(pModel->mre*VT)-(Vbiei_Vbi_ei*((pModel->mre*VT_Vtnode_GND))+0.0*0.0+Vbiei*(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+pModel->mre*0.0))/(pModel->mre*VT)/(pModel->mre*VT)+2*Vbiei*0.0*((pModel->mre*VT_Vtnode_GND))/(pModel->mre*VT)/(pModel->mre*VT)/(pModel->mre*VT));
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=(-Vbiei*(pModel->mre*VT_Vtnode_GND)/(pModel->mre*VT)/(pModel->mre*VT));
#endif
#endif
DIOY=(Vbiei/(pModel->mre*VT));
EXIT_IF_ISNAN((Vbiei/(pModel->mre*VT)))
if
((pModel->ires>0.0))
{
if
((DIOY>80))
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=DIOY_Vbi_ei;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+0.0+(+DIOY_Vbi_ei_Vs_ci-0.0));
  le_Vbi_ei_Vbi_ci=(+0.0+(+DIOY_Vbi_ei_Vbi_ci-0.0));
  le_Vbi_ei_Vbi_ei=(+0.0+(+DIOY_Vbi_ei_Vbi_ei-0.0));
  le_Vbi_ei_Vtnode_GND=(+0.0+(+DIOY_Vbi_ei_Vtnode_GND-0.0));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=DIOY_Vtnode_GND;
#endif
#endif
le=(1+(DIOY-80));
EXIT_IF_ISNAN((1+(DIOY-80)))
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=0.0;
  DIOY_Vs_ci_Vbi_ci=0.0;
  DIOY_Vs_ci_Vbi_ei=0.0;
  DIOY_Vs_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=0.0;
  DIOY_Vbi_ci_Vbi_ci=0.0;
  DIOY_Vbi_ci_Vbi_ei=0.0;
  DIOY_Vbi_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=0.0;
  DIOY_Vbi_ei_Vbi_ci=0.0;
  DIOY_Vbi_ei_Vbi_ei=0.0;
  DIOY_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=0.0;
#endif
#endif
DIOY=80;
EXIT_IF_ISNAN(80)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=0.0;
  le_Vbi_ei_Vbi_ci=0.0;
  le_Vbi_ei_Vbi_ei=0.0;
  le_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=0.0;
#endif
#endif
le=1;
EXIT_IF_ISNAN(1)
}
{
double m00_limexp(d00_limexp0,DIOY)
#if defined(_DERIVATEFORDDX)
double m10_limexp(d10_limexp0,d00_limexp0,DIOY)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=((le_Vbi_ei*d00_limexp0)+(le*DIOY_Vbi_ei*d10_limexp0));
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+le_Vbi_ei_Vs_ci*d00_limexp0+le_Vbi_ei*DIOY_Vs_ci*d10_limexp0+le_Vs_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vs_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vs_ci));
  le_Vbi_ei_Vbi_ci=(+le_Vbi_ei_Vbi_ci*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ci*d10_limexp0+le_Vbi_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ci));
  le_Vbi_ei_Vbi_ei=(+le_Vbi_ei_Vbi_ei*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ei*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ei));
  le_Vbi_ei_Vtnode_GND=(+le_Vbi_ei_Vtnode_GND*d00_limexp0+le_Vbi_ei*DIOY_Vtnode_GND*d10_limexp0+le_Vtnode_GND*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vtnode_GND*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vtnode_GND));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=((le_Vtnode_GND*d00_limexp0)+(le*DIOY_Vtnode_GND*d10_limexp0));
#endif
#endif
le=(le*d00_limexp0);
EXIT_IF_ISNAN((le*d00_limexp0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ire_Vtnode_GND=((ires_t_Vtnode_GND*(le-1.0))+(ires_t*le_Vtnode_GND));
#endif
ire_Vbi_ei=(ires_t*le_Vbi_ei);
#if defined(_DERIVATE2)
  ire_Vbi_ei_Vtnode_GND=(+0.0*(le-1.0)+0.0*le_Vtnode_GND+ires_t_Vtnode_GND*le_Vbi_ei+ires_t*(+le_Vbi_ei_Vtnode_GND-0.0));
  ire_Vbi_ei_Vbi_ei=(+0.0*(le-1.0)+0.0*le_Vbi_ei+0.0*le_Vbi_ei+ires_t*(+le_Vbi_ei_Vbi_ei-0.0));
#endif
#endif
ire=(ires_t*(le-1.0));
EXIT_IF_ISNAN((ires_t*(le-1.0)))
if
((DIOY<=(-14.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ire_Vtnode_GND=(-ires_t_Vtnode_GND);
#endif
ire_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ire_Vbi_ei_Vtnode_GND=0.0;
  ire_Vbi_ei_Vbi_ei=0.0;
#endif
#endif
ire=(-ires_t);
EXIT_IF_ISNAN((-ires_t))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ire_Vtnode_GND=0.0;
#endif
ire_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  ire_Vbi_ei_Vtnode_GND=0.0;
  ire_Vbi_ei_Vbi_ei=0.0;
#endif
#endif
ire=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ijbe_Vtnode_GND=(ibe_Vtnode_GND+ire_Vtnode_GND);
#endif
ijbe_Vbi_ei=(ibe_Vbi_ei+ire_Vbi_ei);
#if defined(_DERIVATE2)
  ijbe_Vbi_ei_Vtnode_GND=(+ibe_Vbi_ei_Vtnode_GND+ire_Vbi_ei_Vtnode_GND);
  ijbe_Vbi_ei_Vbi_ei=(+ibe_Vbi_ei_Vbi_ei+ire_Vbi_ei_Vbi_ei);
#endif
#endif
pInst->ijbe=(ibe+ire);
EXIT_IF_ISNAN((ibe+ire))
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=0.0;
  DIOY_Vs_ci_Vbi_ci=0.0;
  DIOY_Vs_ci_Vbi_ei=0.0;
  DIOY_Vs_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ci=(Vbici_Vbi_ci/(pModel->mbc*VT));
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=(0.0/(pModel->mbc*VT)-(Vbici_Vbi_ci*(0.0)+0.0*0.0+Vbici*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mbc*0.0))/(pModel->mbc*VT)/(pModel->mbc*VT)+2*Vbici*0.0*(0.0)/(pModel->mbc*VT)/(pModel->mbc*VT)/(pModel->mbc*VT));
  DIOY_Vbi_ci_Vbi_ci=(Vbici_Vbi_ci_Vbi_ci/(pModel->mbc*VT)-(Vbici_Vbi_ci*(0.0)+Vbici_Vbi_ci*0.0+Vbici*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mbc*0.0))/(pModel->mbc*VT)/(pModel->mbc*VT)+2*Vbici*0.0*(0.0)/(pModel->mbc*VT)/(pModel->mbc*VT)/(pModel->mbc*VT));
  DIOY_Vbi_ci_Vbi_ei=(0.0/(pModel->mbc*VT)-(Vbici_Vbi_ci*(0.0)+0.0*0.0+Vbici*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->mbc*0.0))/(pModel->mbc*VT)/(pModel->mbc*VT)+2*Vbici*0.0*(0.0)/(pModel->mbc*VT)/(pModel->mbc*VT)/(pModel->mbc*VT));
  DIOY_Vbi_ci_Vtnode_GND=(0.0/(pModel->mbc*VT)-(Vbici_Vbi_ci*((pModel->mbc*VT_Vtnode_GND))+0.0*0.0+Vbici*(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+pModel->mbc*0.0))/(pModel->mbc*VT)/(pModel->mbc*VT)+2*Vbici*0.0*((pModel->mbc*VT_Vtnode_GND))/(pModel->mbc*VT)/(pModel->mbc*VT)/(pModel->mbc*VT));
#endif
DIOY_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=0.0;
  DIOY_Vbi_ei_Vbi_ci=0.0;
  DIOY_Vbi_ei_Vbi_ei=0.0;
  DIOY_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=(-Vbici*(pModel->mbc*VT_Vtnode_GND)/(pModel->mbc*VT)/(pModel->mbc*VT));
#endif
#endif
DIOY=(Vbici/(pModel->mbc*VT));
EXIT_IF_ISNAN((Vbici/(pModel->mbc*VT)))
if
((pModel->ibcs>0.0))
{
if
((DIOY>80))
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=DIOY_Vbi_ci;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=(+0.0+(+DIOY_Vbi_ci_Vs_ci-0.0));
  le_Vbi_ci_Vbi_ci=(+0.0+(+DIOY_Vbi_ci_Vbi_ci-0.0));
  le_Vbi_ci_Vbi_ei=(+0.0+(+DIOY_Vbi_ci_Vbi_ei-0.0));
  le_Vbi_ci_Vtnode_GND=(+0.0+(+DIOY_Vbi_ci_Vtnode_GND-0.0));
#endif
le_Vbi_ei=DIOY_Vbi_ei;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+0.0+(+DIOY_Vbi_ei_Vs_ci-0.0));
  le_Vbi_ei_Vbi_ci=(+0.0+(+DIOY_Vbi_ei_Vbi_ci-0.0));
  le_Vbi_ei_Vbi_ei=(+0.0+(+DIOY_Vbi_ei_Vbi_ei-0.0));
  le_Vbi_ei_Vtnode_GND=(+0.0+(+DIOY_Vbi_ei_Vtnode_GND-0.0));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=DIOY_Vtnode_GND;
#endif
#endif
le=(1+(DIOY-80));
EXIT_IF_ISNAN((1+(DIOY-80)))
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=0.0;
  DIOY_Vs_ci_Vbi_ci=0.0;
  DIOY_Vs_ci_Vbi_ei=0.0;
  DIOY_Vs_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=0.0;
  DIOY_Vbi_ci_Vbi_ci=0.0;
  DIOY_Vbi_ci_Vbi_ei=0.0;
  DIOY_Vbi_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=0.0;
  DIOY_Vbi_ei_Vbi_ci=0.0;
  DIOY_Vbi_ei_Vbi_ei=0.0;
  DIOY_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=0.0;
#endif
#endif
DIOY=80;
EXIT_IF_ISNAN(80)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=0.0;
  le_Vbi_ei_Vbi_ci=0.0;
  le_Vbi_ei_Vbi_ei=0.0;
  le_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=0.0;
#endif
#endif
le=1;
EXIT_IF_ISNAN(1)
}
{
double m00_limexp(d00_limexp0,DIOY)
#if defined(_DERIVATEFORDDX)
double m10_limexp(d10_limexp0,d00_limexp0,DIOY)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=((le_Vbi_ci*d00_limexp0)+(le*DIOY_Vbi_ci*d10_limexp0));
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=(+le_Vbi_ci_Vs_ci*d00_limexp0+le_Vbi_ci*DIOY_Vs_ci*d10_limexp0+le_Vs_ci*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vs_ci*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vs_ci));
  le_Vbi_ci_Vbi_ci=(+le_Vbi_ci_Vbi_ci*d00_limexp0+le_Vbi_ci*DIOY_Vbi_ci*d10_limexp0+le_Vbi_ci*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ci*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vbi_ci));
  le_Vbi_ci_Vbi_ei=(+le_Vbi_ci_Vbi_ei*d00_limexp0+le_Vbi_ci*DIOY_Vbi_ei*d10_limexp0+le_Vbi_ei*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ei*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vbi_ei));
  le_Vbi_ci_Vtnode_GND=(+le_Vbi_ci_Vtnode_GND*d00_limexp0+le_Vbi_ci*DIOY_Vtnode_GND*d10_limexp0+le_Vtnode_GND*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vtnode_GND*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vtnode_GND));
#endif
le_Vbi_ei=((le_Vbi_ei*d00_limexp0)+(le*DIOY_Vbi_ei*d10_limexp0));
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+le_Vbi_ei_Vs_ci*d00_limexp0+le_Vbi_ei*DIOY_Vs_ci*d10_limexp0+le_Vs_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vs_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vs_ci));
  le_Vbi_ei_Vbi_ci=(+le_Vbi_ei_Vbi_ci*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ci*d10_limexp0+le_Vbi_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ci));
  le_Vbi_ei_Vbi_ei=(+le_Vbi_ei_Vbi_ei*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ei*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ei));
  le_Vbi_ei_Vtnode_GND=(+le_Vbi_ei_Vtnode_GND*d00_limexp0+le_Vbi_ei*DIOY_Vtnode_GND*d10_limexp0+le_Vtnode_GND*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vtnode_GND*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vtnode_GND));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=((le_Vtnode_GND*d00_limexp0)+(le*DIOY_Vtnode_GND*d10_limexp0));
#endif
#endif
le=(le*d00_limexp0);
EXIT_IF_ISNAN((le*d00_limexp0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci)V(bi,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
ijbc_Vtnode_GND=((ibcs_t_Vtnode_GND*(le-1.0))+(ibcs_t*le_Vtnode_GND));
#endif
ijbc_Vbi_ci=(ibcs_t*le_Vbi_ci);
#if defined(_DERIVATE2)
  ijbc_Vbi_ci_Vtnode_GND=(+0.0*(le-1.0)+0.0*le_Vtnode_GND+ibcs_t_Vtnode_GND*le_Vbi_ci+ibcs_t*(+le_Vbi_ci_Vtnode_GND-0.0));
  ijbc_Vbi_ci_Vbi_ci=(+0.0*(le-1.0)+0.0*le_Vbi_ci+0.0*le_Vbi_ci+ibcs_t*(+le_Vbi_ci_Vbi_ci-0.0));
  ijbc_Vbi_ci_Vbi_ei=(+0.0*(le-1.0)+0.0*le_Vbi_ei+0.0*le_Vbi_ci+ibcs_t*(+le_Vbi_ci_Vbi_ei-0.0));
#endif
#if defined(_DERIVATE)
ijbc_Vbi_ei=(ibcs_t*le_Vbi_ei);
#endif
#endif
pInst->ijbc=(ibcs_t*(le-1.0));
EXIT_IF_ISNAN((ibcs_t*(le-1.0)))
if
((DIOY<=(-14.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci)V(bi,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
ijbc_Vtnode_GND=(-ibcs_t_Vtnode_GND);
#endif
ijbc_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  ijbc_Vbi_ci_Vtnode_GND=0.0;
  ijbc_Vbi_ci_Vbi_ci=0.0;
  ijbc_Vbi_ci_Vbi_ei=0.0;
#endif
#if defined(_DERIVATE)
ijbc_Vbi_ei=0.0;
#endif
#endif
pInst->ijbc=(-ibcs_t);
EXIT_IF_ISNAN((-ibcs_t))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci)V(bi,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
ijbc_Vtnode_GND=0.0;
#endif
ijbc_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  ijbc_Vbi_ci_Vtnode_GND=0.0;
  ijbc_Vbi_ci_Vbi_ci=0.0;
  ijbc_Vbi_ci_Vbi_ei=0.0;
#endif
#if defined(_DERIVATE)
ijbc_Vbi_ei=0.0;
#endif
#endif
pInst->ijbc=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(bi,ci) ddxprobe= */
ibi_Vtnode_GND=(ijbe_Vtnode_GND+ijbc_Vtnode_GND);
ibi_Vbi_ei=(ijbe_Vbi_ei+ijbc_Vbi_ei);
ibi_Vbi_ci=ijbc_Vbi_ci;
#endif
ibi=(pInst->ijbe+pInst->ijbc);
EXIT_IF_ISNAN((pInst->ijbe+pInst->ijbc))
if
((Vbici<0))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND) */
v_bord_Vtnode_GND=((eavl_t_Vtnode_GND*vdci_t)+(eavl_t*vdci_t_Vtnode_GND));
#endif
v_bord=(eavl_t*vdci_t);
EXIT_IF_ISNAN((eavl_t*vdci_t))
if
(((vdci_t-Vbici)>v_bord))
{
{
double m00_exp(d00_exp0,(-cc))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
a_iavl_Vtnode_GND=((((kavl_t_Vtnode_GND*vdci_t-kavl_t*vdci_t_Vtnode_GND)/vdci_t/vdci_t)*d00_exp0)+((kavl_t/vdci_t)*(-cc_Vtnode_GND)*d10_exp0));
#endif
a_iavl_Vb_ci=((kavl_t/vdci_t)*(-cc_Vb_ci)*d10_exp0);
#if defined(_DERIVATE2)
  a_iavl_Vb_ci_Vtnode_GND=(+(0.0/vdci_t-(0.0*vdci_t_Vtnode_GND+kavl_t_Vtnode_GND*0.0+kavl_t*0.0)/vdci_t/vdci_t+2*kavl_t*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)*d00_exp0+0.0*(-cc_Vtnode_GND)*d10_exp0+((kavl_t_Vtnode_GND*vdci_t-kavl_t*vdci_t_Vtnode_GND)/vdci_t/vdci_t)*(-cc_Vb_ci)*d10_exp0+(kavl_t/vdci_t)*(m20_exp((-cc))*(-cc_Vtnode_GND)*(-cc_Vb_ci)+d10_exp0*0.0));
  a_iavl_Vb_ci_Vb_ci=(+(0.0/vdci_t-(0.0*0.0+0.0*0.0+kavl_t*0.0)/vdci_t/vdci_t+2*kavl_t*0.0*0.0/vdci_t/vdci_t/vdci_t)*d00_exp0+0.0*(-cc_Vb_ci)*d10_exp0+0.0*(-cc_Vb_ci)*d10_exp0+(kavl_t/vdci_t)*(m20_exp((-cc))*(-cc_Vb_ci)*(-cc_Vb_ci)+d10_exp0*0.0));
  a_iavl_Vb_ci_Vbi_ci=(+(0.0/vdci_t-(0.0*0.0+0.0*0.0+kavl_t*0.0)/vdci_t/vdci_t+2*kavl_t*0.0*0.0/vdci_t/vdci_t/vdci_t)*d00_exp0+0.0*(-cc_Vbi_ci)*d10_exp0+0.0*(-cc_Vb_ci)*d10_exp0+(kavl_t/vdci_t)*(m20_exp((-cc))*(-cc_Vbi_ci)*(-cc_Vb_ci)+d10_exp0*0.0));
#endif
a_iavl_Vbi_ci=((kavl_t/vdci_t)*(-cc_Vbi_ci)*d10_exp0);
#if defined(_DERIVATE2)
  a_iavl_Vbi_ci_Vtnode_GND=(+(0.0/vdci_t-(0.0*vdci_t_Vtnode_GND+kavl_t_Vtnode_GND*0.0+kavl_t*0.0)/vdci_t/vdci_t+2*kavl_t*0.0*vdci_t_Vtnode_GND/vdci_t/vdci_t/vdci_t)*d00_exp0+0.0*(-cc_Vtnode_GND)*d10_exp0+((kavl_t_Vtnode_GND*vdci_t-kavl_t*vdci_t_Vtnode_GND)/vdci_t/vdci_t)*(-cc_Vbi_ci)*d10_exp0+(kavl_t/vdci_t)*(m20_exp((-cc))*(-cc_Vtnode_GND)*(-cc_Vbi_ci)+d10_exp0*0.0));
  a_iavl_Vbi_ci_Vb_ci=(+(0.0/vdci_t-(0.0*0.0+0.0*0.0+kavl_t*0.0)/vdci_t/vdci_t+2*kavl_t*0.0*0.0/vdci_t/vdci_t/vdci_t)*d00_exp0+0.0*(-cc_Vb_ci)*d10_exp0+0.0*(-cc_Vbi_ci)*d10_exp0+(kavl_t/vdci_t)*(m20_exp((-cc))*(-cc_Vb_ci)*(-cc_Vbi_ci)+d10_exp0*0.0));
  a_iavl_Vbi_ci_Vbi_ci=(+(0.0/vdci_t-(0.0*0.0+0.0*0.0+kavl_t*0.0)/vdci_t/vdci_t+2*kavl_t*0.0*0.0/vdci_t/vdci_t/vdci_t)*d00_exp0+0.0*(-cc_Vbi_ci)*d10_exp0+0.0*(-cc_Vbi_ci)*d10_exp0+(kavl_t/vdci_t)*(m20_exp((-cc))*(-cc_Vbi_ci)*(-cc_Vbi_ci)+d10_exp0*0.0));
#endif
#endif
a_iavl=((kavl_t/vdci_t)*d00_exp0);
EXIT_IF_ISNAN(((kavl_t/vdci_t)*d00_exp0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
iavl_Vtnode_GND=((((itf_Vtnode_GND*a_iavl)+(itf*a_iavl_Vtnode_GND))*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord))))+((itf*a_iavl)*(v_bord_Vtnode_GND+((cc_Vtnode_GND*((vdci_t-Vbici)-v_bord))+((1+cc)*(vdci_t_Vtnode_GND-v_bord_Vtnode_GND))))));
#endif
#if defined(_DERIVATE)
iavl_Vbi_ei=itf_Vbi_ei*a_iavl*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)));
#endif
iavl_Vb_ci=((((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci))*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord))))+((itf*a_iavl)*cc_Vb_ci*((vdci_t-Vbici)-v_bord)));
#if defined(_DERIVATE2)
  iavl_Vb_ci_Vtnode_GND=(+(+itf_Vb_ci_Vtnode_GND*a_iavl+itf_Vb_ci*a_iavl_Vtnode_GND+itf_Vtnode_GND*a_iavl_Vb_ci+itf*a_iavl_Vb_ci_Vtnode_GND)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci))*(v_bord_Vtnode_GND+(((cc_Vtnode_GND*((vdci_t-Vbici)-v_bord))+((1+cc)*(vdci_t_Vtnode_GND-v_bord_Vtnode_GND)))))+(((itf_Vtnode_GND*a_iavl)+(itf*a_iavl_Vtnode_GND)))*cc_Vb_ci*((vdci_t-Vbici)-v_bord)+(itf*a_iavl)*(+0.0+(+(+0.0+cc_Vb_ci_Vtnode_GND)*((vdci_t-Vbici)-v_bord)+cc_Vb_ci*(vdci_t_Vtnode_GND-v_bord_Vtnode_GND)+cc_Vtnode_GND*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vb_ci_Vbi_ei=(+(+itf_Vb_ci_Vbi_ei*a_iavl+itf_Vb_ci*0.0+itf_Vbi_ei*a_iavl_Vb_ci+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci))*(0.0)+(itf_Vbi_ei*a_iavl)*cc_Vb_ci*((vdci_t-Vbici)-v_bord)+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+cc_Vb_ci*0.0+0.0*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vb_ci_Vb_ci=(+(+itf_Vb_ci_Vb_ci*a_iavl+itf_Vb_ci*a_iavl_Vb_ci+itf_Vb_ci*a_iavl_Vb_ci+itf*a_iavl_Vb_ci_Vb_ci)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci))*(cc_Vb_ci*((vdci_t-Vbici)-v_bord))+(((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci)))*cc_Vb_ci*((vdci_t-Vbici)-v_bord)+(itf*a_iavl)*(+0.0+(+(+0.0+cc_Vb_ci_Vb_ci)*((vdci_t-Vbici)-v_bord)+cc_Vb_ci*0.0+cc_Vb_ci*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vb_ci_Vbi_ci=(+(+itf_Vb_ci_Vbi_ci*a_iavl+itf_Vb_ci*a_iavl_Vbi_ci+itf_Vbi_ci*a_iavl_Vb_ci+itf*a_iavl_Vb_ci_Vbi_ci)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci))*(((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci))))+(((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci)))*cc_Vb_ci*((vdci_t-Vbici)-v_bord)+(itf*a_iavl)*(+0.0+(+(+0.0+cc_Vb_ci_Vbi_ci)*((vdci_t-Vbici)-v_bord)+cc_Vb_ci*(-Vbici_Vbi_ci)+cc_Vbi_ci*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vb_ci_Vci_ei=(+(+itf_Vb_ci_Vci_ei*a_iavl+itf_Vb_ci*0.0+itf_Vci_ei*a_iavl_Vb_ci+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci))*(0.0)+(itf_Vci_ei*a_iavl)*cc_Vb_ci*((vdci_t-Vbici)-v_bord)+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+cc_Vb_ci*0.0+0.0*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
#endif
iavl_Vbi_ci=((((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci))*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord))))+((itf*a_iavl)*((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci)))));
#if defined(_DERIVATE2)
  iavl_Vbi_ci_Vtnode_GND=(+(+itf_Vbi_ci_Vtnode_GND*a_iavl+itf_Vbi_ci*a_iavl_Vtnode_GND+itf_Vtnode_GND*a_iavl_Vbi_ci+itf*a_iavl_Vbi_ci_Vtnode_GND)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci))*(v_bord_Vtnode_GND+(((cc_Vtnode_GND*((vdci_t-Vbici)-v_bord))+((1+cc)*(vdci_t_Vtnode_GND-v_bord_Vtnode_GND)))))+(((itf_Vtnode_GND*a_iavl)+(itf*a_iavl_Vtnode_GND)))*((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci)))+(itf*a_iavl)*(+0.0+(+(+0.0+cc_Vbi_ci_Vtnode_GND)*((vdci_t-Vbici)-v_bord)+cc_Vbi_ci*(vdci_t_Vtnode_GND-v_bord_Vtnode_GND)+cc_Vtnode_GND*(-Vbici_Vbi_ci)+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vbi_ci_Vbi_ei=(+(+itf_Vbi_ci_Vbi_ei*a_iavl+itf_Vbi_ci*0.0+itf_Vbi_ei*a_iavl_Vbi_ci+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci))*(0.0)+(itf_Vbi_ei*a_iavl)*((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci)))+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+cc_Vbi_ci*0.0+0.0*(-Vbici_Vbi_ci)+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vbi_ci_Vb_ci=(+(+itf_Vbi_ci_Vb_ci*a_iavl+itf_Vbi_ci*a_iavl_Vb_ci+itf_Vb_ci*a_iavl_Vbi_ci+itf*a_iavl_Vbi_ci_Vb_ci)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci))*(cc_Vb_ci*((vdci_t-Vbici)-v_bord))+(((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci)))*((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci)))+(itf*a_iavl)*(+0.0+(+(+0.0+cc_Vbi_ci_Vb_ci)*((vdci_t-Vbici)-v_bord)+cc_Vbi_ci*0.0+cc_Vb_ci*(-Vbici_Vbi_ci)+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vbi_ci_Vbi_ci=(+(+itf_Vbi_ci_Vbi_ci*a_iavl+itf_Vbi_ci*a_iavl_Vbi_ci+itf_Vbi_ci*a_iavl_Vbi_ci+itf*a_iavl_Vbi_ci_Vbi_ci)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci))*(((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci))))+(((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci)))*((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci)))+(itf*a_iavl)*(+0.0+(+(+0.0+cc_Vbi_ci_Vbi_ci)*((vdci_t-Vbici)-v_bord)+cc_Vbi_ci*(-Vbici_Vbi_ci)+cc_Vbi_ci*(-Vbici_Vbi_ci)+(1+cc)*(+(+0.0-Vbici_Vbi_ci_Vbi_ci)-0.0))));
  iavl_Vbi_ci_Vci_ei=(+(+itf_Vbi_ci_Vci_ei*a_iavl+itf_Vbi_ci*0.0+itf_Vci_ei*a_iavl_Vbi_ci+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci))*(0.0)+(itf_Vci_ei*a_iavl)*((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci)))+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+cc_Vbi_ci*0.0+0.0*(-Vbici_Vbi_ci)+(1+cc)*(+(+0.0-0.0)-0.0))));
#endif
iavl_Vci_ei=itf_Vci_ei*a_iavl*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)));
#if defined(_DERIVATE2)
  iavl_Vci_ei_Vtnode_GND=(+(+itf_Vci_ei_Vtnode_GND*a_iavl+itf_Vci_ei*a_iavl_Vtnode_GND+itf_Vtnode_GND*0.0+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+itf_Vci_ei*a_iavl*(v_bord_Vtnode_GND+(((cc_Vtnode_GND*((vdci_t-Vbici)-v_bord))+((1+cc)*(vdci_t_Vtnode_GND-v_bord_Vtnode_GND)))))+(((itf_Vtnode_GND*a_iavl)+(itf*a_iavl_Vtnode_GND)))*0.0+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+0.0*(vdci_t_Vtnode_GND-v_bord_Vtnode_GND)+cc_Vtnode_GND*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vci_ei_Vbi_ei=(+(+itf_Vci_ei_Vbi_ei*a_iavl+itf_Vci_ei*0.0+itf_Vbi_ei*0.0+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+itf_Vci_ei*a_iavl*(0.0)+(itf_Vbi_ei*a_iavl)*0.0+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+0.0*0.0+0.0*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vci_ei_Vb_ci=(+(+itf_Vci_ei_Vb_ci*a_iavl+itf_Vci_ei*a_iavl_Vb_ci+itf_Vb_ci*0.0+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+itf_Vci_ei*a_iavl*(cc_Vb_ci*((vdci_t-Vbici)-v_bord))+(((itf_Vb_ci*a_iavl)+(itf*a_iavl_Vb_ci)))*0.0+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+0.0*0.0+cc_Vb_ci*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vci_ei_Vbi_ci=(+(+itf_Vci_ei_Vbi_ci*a_iavl+itf_Vci_ei*a_iavl_Vbi_ci+itf_Vbi_ci*0.0+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+itf_Vci_ei*a_iavl*(((cc_Vbi_ci*((vdci_t-Vbici)-v_bord))+((1+cc)*(-Vbici_Vbi_ci))))+(((itf_Vbi_ci*a_iavl)+(itf*a_iavl_Vbi_ci)))*0.0+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+0.0*(-Vbici_Vbi_ci)+cc_Vbi_ci*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
  iavl_Vci_ei_Vci_ei=(+(+itf_Vci_ei_Vci_ei*a_iavl+itf_Vci_ei*0.0+itf_Vci_ei*0.0+itf*0.0)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))+itf_Vci_ei*a_iavl*(0.0)+(itf_Vci_ei*a_iavl)*0.0+(itf*a_iavl)*(+0.0+(+(+0.0+0.0)*((vdci_t-Vbici)-v_bord)+0.0*0.0+0.0*0.0+(1+cc)*(+(+0.0-0.0)-0.0))));
#endif
#endif
pInst->iavl=((itf*a_iavl)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord))));
EXIT_IF_ISNAN(((itf*a_iavl)*(v_bord+((1+cc)*((vdci_t-Vbici)-v_bord)))))
}
else
{
{
double m00_logE(d00_logE0,(1/cc))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1/cc))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
lncc_Vtnode_GND=(-1*cc_Vtnode_GND/cc/cc)*d10_logE0;
#endif
lncc_Vb_ci=(-1*cc_Vb_ci/cc/cc)*d10_logE0;
#if defined(_DERIVATE2)
  lncc_Vb_ci_Vtnode_GND=(m20_logE((1/cc))*(-1*cc_Vtnode_GND/cc/cc)*(-1*cc_Vb_ci/cc/cc)+d10_logE0*(0.0/cc-(0.0*cc_Vtnode_GND+0.0*cc_Vb_ci+1*cc_Vb_ci_Vtnode_GND)/cc/cc+2*1*cc_Vb_ci*cc_Vtnode_GND/cc/cc/cc));
  lncc_Vb_ci_Vb_ci=(m20_logE((1/cc))*(-1*cc_Vb_ci/cc/cc)*(-1*cc_Vb_ci/cc/cc)+d10_logE0*(0.0/cc-(0.0*cc_Vb_ci+0.0*cc_Vb_ci+1*cc_Vb_ci_Vb_ci)/cc/cc+2*1*cc_Vb_ci*cc_Vb_ci/cc/cc/cc));
  lncc_Vb_ci_Vbi_ci=(m20_logE((1/cc))*(-1*cc_Vbi_ci/cc/cc)*(-1*cc_Vb_ci/cc/cc)+d10_logE0*(0.0/cc-(0.0*cc_Vbi_ci+0.0*cc_Vb_ci+1*cc_Vb_ci_Vbi_ci)/cc/cc+2*1*cc_Vb_ci*cc_Vbi_ci/cc/cc/cc));
#endif
lncc_Vbi_ci=(-1*cc_Vbi_ci/cc/cc)*d10_logE0;
#if defined(_DERIVATE2)
  lncc_Vbi_ci_Vtnode_GND=(m20_logE((1/cc))*(-1*cc_Vtnode_GND/cc/cc)*(-1*cc_Vbi_ci/cc/cc)+d10_logE0*(0.0/cc-(0.0*cc_Vtnode_GND+0.0*cc_Vbi_ci+1*cc_Vbi_ci_Vtnode_GND)/cc/cc+2*1*cc_Vbi_ci*cc_Vtnode_GND/cc/cc/cc));
  lncc_Vbi_ci_Vb_ci=(m20_logE((1/cc))*(-1*cc_Vb_ci/cc/cc)*(-1*cc_Vbi_ci/cc/cc)+d10_logE0*(0.0/cc-(0.0*cc_Vb_ci+0.0*cc_Vbi_ci+1*cc_Vbi_ci_Vb_ci)/cc/cc+2*1*cc_Vbi_ci*cc_Vb_ci/cc/cc/cc));
  lncc_Vbi_ci_Vbi_ci=(m20_logE((1/cc))*(-1*cc_Vbi_ci/cc/cc)*(-1*cc_Vbi_ci/cc/cc)+d10_logE0*(0.0/cc-(0.0*cc_Vbi_ci+0.0*cc_Vbi_ci+1*cc_Vbi_ci_Vbi_ci)/cc/cc+2*1*cc_Vbi_ci*cc_Vbi_ci/cc/cc/cc));
#endif
#endif
lncc=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_exp(d00_exp0,(((1/pModel->zci)-1)*lncc))
double m00_exp(d00_exp1,((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
iavl_Vtnode_GND=((((kavl_t_Vtnode_GND*itf)+(kavl_t*itf_Vtnode_GND))*d00_exp1)+((kavl_t*itf)*((((-1)/pModel->zci)*lncc_Vtnode_GND)-((eavl_t_Vtnode_GND*d00_exp0)+(eavl_t*(((1/pModel->zci)-1)*lncc_Vtnode_GND)*d10_exp0)))*d10_exp1));
#endif
#if defined(_DERIVATE)
iavl_Vbi_ei=(kavl_t*itf_Vbi_ei)*d00_exp1;
#endif
iavl_Vb_ci=(((kavl_t*itf_Vb_ci)*d00_exp1)+((kavl_t*itf)*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))*d10_exp1));
#if defined(_DERIVATE2)
  iavl_Vb_ci_Vtnode_GND=(+(+0.0*itf+0.0*itf_Vtnode_GND+kavl_t_Vtnode_GND*itf_Vb_ci+kavl_t*itf_Vb_ci_Vtnode_GND)*d00_exp1+(kavl_t*itf_Vb_ci)*(((((-1)/pModel->zci)*lncc_Vtnode_GND))-(((eavl_t_Vtnode_GND*d00_exp0)+(eavl_t*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*d10_exp0))))*d10_exp1+(((kavl_t_Vtnode_GND*itf)+(kavl_t*itf_Vtnode_GND)))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*(((((-1)/pModel->zci)*lncc_Vtnode_GND))-(((eavl_t_Vtnode_GND*d00_exp0)+(eavl_t*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*d10_exp0))))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*lncc_Vtnode_GND+0.0*lncc_Vb_ci+((-1)/pModel->zci)*lncc_Vb_ci_Vtnode_GND)-(+0.0*d00_exp0+0.0*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*d10_exp0+eavl_t_Vtnode_GND*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*(((1/pModel->zci)-1)*lncc_Vb_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*lncc_Vtnode_GND+0.0*lncc_Vb_ci+((1/pModel->zci)-1)*lncc_Vb_ci_Vtnode_GND))))));
  iavl_Vb_ci_Vbi_ei=(+(+0.0*itf+0.0*itf_Vbi_ei+0.0*itf_Vb_ci+kavl_t*itf_Vb_ci_Vbi_ei)*d00_exp1+(kavl_t*itf_Vb_ci)*((0.0)-((eavl_t*(0.0)*d10_exp0)))*d10_exp1+((kavl_t*itf_Vbi_ei))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*((0.0)-((eavl_t*(0.0)*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*0.0+0.0*lncc_Vb_ci+((-1)/pModel->zci)*0.0)-(+0.0*d00_exp0+0.0*(0.0)*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*(0.0)*(((1/pModel->zci)-1)*lncc_Vb_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*0.0+0.0*lncc_Vb_ci+((1/pModel->zci)-1)*0.0))))));
  iavl_Vb_ci_Vb_ci=(+(+0.0*itf+0.0*itf_Vb_ci+0.0*itf_Vb_ci+kavl_t*itf_Vb_ci_Vb_ci)*d00_exp1+(kavl_t*itf_Vb_ci)*(((((-1)/pModel->zci)*lncc_Vb_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vb_ci))*d10_exp0)))*d10_exp1+((kavl_t*itf_Vb_ci))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*(((((-1)/pModel->zci)*lncc_Vb_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vb_ci))*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*lncc_Vb_ci+0.0*lncc_Vb_ci+((-1)/pModel->zci)*lncc_Vb_ci_Vb_ci)-(+0.0*d00_exp0+0.0*((((1/pModel->zci)-1)*lncc_Vb_ci))*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*((((1/pModel->zci)-1)*lncc_Vb_ci))*(((1/pModel->zci)-1)*lncc_Vb_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*lncc_Vb_ci+0.0*lncc_Vb_ci+((1/pModel->zci)-1)*lncc_Vb_ci_Vb_ci))))));
  iavl_Vb_ci_Vbi_ci=(+(+0.0*itf+0.0*itf_Vbi_ci+0.0*itf_Vb_ci+kavl_t*itf_Vb_ci_Vbi_ci)*d00_exp1+(kavl_t*itf_Vb_ci)*(((((-1)/pModel->zci)*lncc_Vbi_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vbi_ci))*d10_exp0)))*d10_exp1+((kavl_t*itf_Vbi_ci))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*(((((-1)/pModel->zci)*lncc_Vbi_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vbi_ci))*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*lncc_Vbi_ci+0.0*lncc_Vb_ci+((-1)/pModel->zci)*lncc_Vb_ci_Vbi_ci)-(+0.0*d00_exp0+0.0*((((1/pModel->zci)-1)*lncc_Vbi_ci))*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*((((1/pModel->zci)-1)*lncc_Vbi_ci))*(((1/pModel->zci)-1)*lncc_Vb_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*lncc_Vbi_ci+0.0*lncc_Vb_ci+((1/pModel->zci)-1)*lncc_Vb_ci_Vbi_ci))))));
  iavl_Vb_ci_Vci_ei=(+(+0.0*itf+0.0*itf_Vci_ei+0.0*itf_Vb_ci+kavl_t*itf_Vb_ci_Vci_ei)*d00_exp1+(kavl_t*itf_Vb_ci)*((0.0)-((eavl_t*(0.0)*d10_exp0)))*d10_exp1+((kavl_t*itf_Vci_ei))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*((0.0)-((eavl_t*(0.0)*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vb_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*0.0+0.0*lncc_Vb_ci+((-1)/pModel->zci)*0.0)-(+0.0*d00_exp0+0.0*(0.0)*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vb_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*(0.0)*(((1/pModel->zci)-1)*lncc_Vb_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*0.0+0.0*lncc_Vb_ci+((1/pModel->zci)-1)*0.0))))));
#endif
iavl_Vbi_ci=(((kavl_t*itf_Vbi_ci)*d00_exp1)+((kavl_t*itf)*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))*d10_exp1));
#if defined(_DERIVATE2)
  iavl_Vbi_ci_Vtnode_GND=(+(+0.0*itf+0.0*itf_Vtnode_GND+kavl_t_Vtnode_GND*itf_Vbi_ci+kavl_t*itf_Vbi_ci_Vtnode_GND)*d00_exp1+(kavl_t*itf_Vbi_ci)*(((((-1)/pModel->zci)*lncc_Vtnode_GND))-(((eavl_t_Vtnode_GND*d00_exp0)+(eavl_t*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*d10_exp0))))*d10_exp1+(((kavl_t_Vtnode_GND*itf)+(kavl_t*itf_Vtnode_GND)))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*(((((-1)/pModel->zci)*lncc_Vtnode_GND))-(((eavl_t_Vtnode_GND*d00_exp0)+(eavl_t*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*d10_exp0))))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*lncc_Vtnode_GND+0.0*lncc_Vbi_ci+((-1)/pModel->zci)*lncc_Vbi_ci_Vtnode_GND)-(+0.0*d00_exp0+0.0*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*d10_exp0+eavl_t_Vtnode_GND*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*(((1/pModel->zci)-1)*lncc_Vbi_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*lncc_Vtnode_GND+0.0*lncc_Vbi_ci+((1/pModel->zci)-1)*lncc_Vbi_ci_Vtnode_GND))))));
  iavl_Vbi_ci_Vbi_ei=(+(+0.0*itf+0.0*itf_Vbi_ei+0.0*itf_Vbi_ci+kavl_t*itf_Vbi_ci_Vbi_ei)*d00_exp1+(kavl_t*itf_Vbi_ci)*((0.0)-((eavl_t*(0.0)*d10_exp0)))*d10_exp1+((kavl_t*itf_Vbi_ei))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*((0.0)-((eavl_t*(0.0)*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*0.0+0.0*lncc_Vbi_ci+((-1)/pModel->zci)*0.0)-(+0.0*d00_exp0+0.0*(0.0)*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*(0.0)*(((1/pModel->zci)-1)*lncc_Vbi_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*0.0+0.0*lncc_Vbi_ci+((1/pModel->zci)-1)*0.0))))));
  iavl_Vbi_ci_Vb_ci=(+(+0.0*itf+0.0*itf_Vb_ci+0.0*itf_Vbi_ci+kavl_t*itf_Vbi_ci_Vb_ci)*d00_exp1+(kavl_t*itf_Vbi_ci)*(((((-1)/pModel->zci)*lncc_Vb_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vb_ci))*d10_exp0)))*d10_exp1+((kavl_t*itf_Vb_ci))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*(((((-1)/pModel->zci)*lncc_Vb_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vb_ci))*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*lncc_Vb_ci+0.0*lncc_Vbi_ci+((-1)/pModel->zci)*lncc_Vbi_ci_Vb_ci)-(+0.0*d00_exp0+0.0*((((1/pModel->zci)-1)*lncc_Vb_ci))*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*((((1/pModel->zci)-1)*lncc_Vb_ci))*(((1/pModel->zci)-1)*lncc_Vbi_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*lncc_Vb_ci+0.0*lncc_Vbi_ci+((1/pModel->zci)-1)*lncc_Vbi_ci_Vb_ci))))));
  iavl_Vbi_ci_Vbi_ci=(+(+0.0*itf+0.0*itf_Vbi_ci+0.0*itf_Vbi_ci+kavl_t*itf_Vbi_ci_Vbi_ci)*d00_exp1+(kavl_t*itf_Vbi_ci)*(((((-1)/pModel->zci)*lncc_Vbi_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vbi_ci))*d10_exp0)))*d10_exp1+((kavl_t*itf_Vbi_ci))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*(((((-1)/pModel->zci)*lncc_Vbi_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vbi_ci))*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*lncc_Vbi_ci+0.0*lncc_Vbi_ci+((-1)/pModel->zci)*lncc_Vbi_ci_Vbi_ci)-(+0.0*d00_exp0+0.0*((((1/pModel->zci)-1)*lncc_Vbi_ci))*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*((((1/pModel->zci)-1)*lncc_Vbi_ci))*(((1/pModel->zci)-1)*lncc_Vbi_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*lncc_Vbi_ci+0.0*lncc_Vbi_ci+((1/pModel->zci)-1)*lncc_Vbi_ci_Vbi_ci))))));
  iavl_Vbi_ci_Vci_ei=(+(+0.0*itf+0.0*itf_Vci_ei+0.0*itf_Vbi_ci+kavl_t*itf_Vbi_ci_Vci_ei)*d00_exp1+(kavl_t*itf_Vbi_ci)*((0.0)-((eavl_t*(0.0)*d10_exp0)))*d10_exp1+((kavl_t*itf_Vci_ei))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))*d10_exp1+(kavl_t*itf)*(m20_exp(((((-1)/pModel->zci)*lncc)-(eavl_t*d00_exp0)))*((0.0)-((eavl_t*(0.0)*d10_exp0)))*((((-1)/pModel->zci)*lncc_Vbi_ci)-(eavl_t*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0))+d10_exp1*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+(-1)*0.0)/pModel->zci/pModel->zci+2*(-1)*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)*lncc+0.0*0.0+0.0*lncc_Vbi_ci+((-1)/pModel->zci)*0.0)-(+0.0*d00_exp0+0.0*(0.0)*d10_exp0+0.0*(((1/pModel->zci)-1)*lncc_Vbi_ci)*d10_exp0+eavl_t*(m20_exp((((1/pModel->zci)-1)*lncc))*(0.0)*(((1/pModel->zci)-1)*lncc_Vbi_ci)+d10_exp0*(+(+(0.0/pModel->zci-(0.0*0.0+0.0*0.0+1*0.0)/pModel->zci/pModel->zci+2*1*0.0*0.0/pModel->zci/pModel->zci/pModel->zci)-0.0)*lncc+0.0*0.0+0.0*lncc_Vbi_ci+((1/pModel->zci)-1)*0.0))))));
#endif
iavl_Vci_ei=(kavl_t*itf_Vci_ei)*d00_exp1;
#if defined(_DERIVATE2)
  iavl_Vci_ei_Vtnode_GND=(+(+0.0*itf+0.0*itf_Vtnode_GND+kavl_t_Vtnode_GND*itf_Vci_ei+kavl_t*itf_Vci_ei_Vtnode_GND)*d00_exp1+(kavl_t*itf_Vci_ei)*(((((-1)/pModel->zci)*lncc_Vtnode_GND))-(((eavl_t_Vtnode_GND*d00_exp0)+(eavl_t*((((1/pModel->zci)-1)*lncc_Vtnode_GND))*d10_exp0))))*d10_exp1+(((kavl_t_Vtnode_GND*itf)+(kavl_t*itf_Vtnode_GND)))*0.0+(kavl_t*itf)*0.0);
  iavl_Vci_ei_Vbi_ei=(+(+0.0*itf+0.0*itf_Vbi_ei+0.0*itf_Vci_ei+kavl_t*itf_Vci_ei_Vbi_ei)*d00_exp1+(kavl_t*itf_Vci_ei)*((0.0)-((eavl_t*(0.0)*d10_exp0)))*d10_exp1+((kavl_t*itf_Vbi_ei))*0.0+(kavl_t*itf)*0.0);
  iavl_Vci_ei_Vb_ci=(+(+0.0*itf+0.0*itf_Vb_ci+0.0*itf_Vci_ei+kavl_t*itf_Vci_ei_Vb_ci)*d00_exp1+(kavl_t*itf_Vci_ei)*(((((-1)/pModel->zci)*lncc_Vb_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vb_ci))*d10_exp0)))*d10_exp1+((kavl_t*itf_Vb_ci))*0.0+(kavl_t*itf)*0.0);
  iavl_Vci_ei_Vbi_ci=(+(+0.0*itf+0.0*itf_Vbi_ci+0.0*itf_Vci_ei+kavl_t*itf_Vci_ei_Vbi_ci)*d00_exp1+(kavl_t*itf_Vci_ei)*(((((-1)/pModel->zci)*lncc_Vbi_ci))-((eavl_t*((((1/pModel->zci)-1)*lncc_Vbi_ci))*d10_exp0)))*d10_exp1+((kavl_t*itf_Vbi_ci))*0.0+(kavl_t*itf)*0.0);
  iavl_Vci_ei_Vci_ei=(+(+0.0*itf+0.0*itf_Vci_ei+0.0*itf_Vci_ei+kavl_t*itf_Vci_ei_Vci_ei)*d00_exp1+(kavl_t*itf_Vci_ei)*((0.0)-((eavl_t*(0.0)*d10_exp0)))*d10_exp1+((kavl_t*itf_Vci_ei))*0.0+(kavl_t*itf)*0.0);
#endif
#endif
pInst->iavl=((kavl_t*itf)*d00_exp1);
EXIT_IF_ISNAN(((kavl_t*itf)*d00_exp1))
}
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
iavl_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
iavl_Vbi_ei=0.0;
#endif
iavl_Vb_ci=0.0;
#if defined(_DERIVATE2)
  iavl_Vb_ci_Vtnode_GND=0.0;
  iavl_Vb_ci_Vbi_ei=0.0;
  iavl_Vb_ci_Vb_ci=0.0;
  iavl_Vb_ci_Vbi_ci=0.0;
  iavl_Vb_ci_Vci_ei=0.0;
#endif
iavl_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  iavl_Vbi_ci_Vtnode_GND=0.0;
  iavl_Vbi_ci_Vbi_ei=0.0;
  iavl_Vbi_ci_Vb_ci=0.0;
  iavl_Vbi_ci_Vbi_ci=0.0;
  iavl_Vbi_ci_Vci_ei=0.0;
#endif
iavl_Vci_ei=0.0;
#if defined(_DERIVATE2)
  iavl_Vci_ei_Vtnode_GND=0.0;
  iavl_Vci_ei_Vbi_ei=0.0;
  iavl_Vci_ei_Vb_ci=0.0;
  iavl_Vci_ei_Vbi_ci=0.0;
  iavl_Vci_ei_Vci_ei=0.0;
#endif
#endif
pInst->iavl=0;
EXIT_IF_ISNAN(0)
}
if
((cje0_t>0.0))
{
{
double m00_logE(d00_logE0,aje_t)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->ze))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,aje_t)
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=((vde_t_Vtnode_GND*(1.0-d00_exp1))+(vde_t*(-((-aje_t_Vtnode_GND*d10_logE0)/pModel->ze)*d10_exp1)));
#endif
vf=(vde_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vde_t*(1.0-d00_exp1)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=0.0;
  xvf_Vs_ci_Vbi_ei=0.0;
  xvf_Vs_ci_Vb_ci=0.0;
  xvf_Vs_ci_Vtnode_GND=0.0;
  xvf_Vs_ci_Vbi_ci=0.0;
#endif
xvf_Vbi_ei=((-Vbiei_Vbi_ei)/VT);
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*0.0+0.0*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ei_Vbi_ei=((+0.0-Vbiei_Vbi_ei_Vbi_ei)/VT-((-Vbiei_Vbi_ei)*0.0+(-Vbiei_Vbi_ei)*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ei_Vb_ci=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*0.0+0.0*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
  xvf_Vbi_ei_Vtnode_GND=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vbi_ei_Vbi_ci=((+0.0-0.0)/VT-((-Vbiei_Vbi_ei)*0.0+0.0*0.0+(vf-Vbiei)*0.0)/VT/VT+2*(vf-Vbiei)*0.0*0.0/VT/VT/VT);
#endif
xvf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=0.0;
  xvf_Vb_ci_Vbi_ei=0.0;
  xvf_Vb_ci_Vb_ci=0.0;
  xvf_Vb_ci_Vtnode_GND=0.0;
  xvf_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vbiei)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=0.0;
  xvf_Vbi_ci_Vbi_ei=0.0;
  xvf_Vbi_ci_Vb_ci=0.0;
  xvf_Vbi_ci_Vtnode_GND=0.0;
  xvf_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
xvf=((vf-Vbiei)/VT);
EXIT_IF_ISNAN(((vf-Vbiei)/VT))
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=0.0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=0.0;
  xvf2_Vs_ci_Vbi_ei=0.0;
  xvf2_Vs_ci_Vb_ci=0.0;
  xvf2_Vs_ci_Vtnode_GND=0.0;
  xvf2_Vs_ci_Vbi_ci=0.0;
#endif
xvf2_Vbi_ei=((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vs_ci*xvf+xvf_Vbi_ei*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vs_ci)+0.0));
  xvf2_Vbi_ei_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vbi_ei*xvf+xvf_Vbi_ei*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vbi_ei)+0.0));
  xvf2_Vbi_ei_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vb_ci*xvf+xvf_Vbi_ei*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vb_ci)+0.0));
  xvf2_Vbi_ei_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vtnode_GND*xvf+xvf_Vbi_ei*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vtnode_GND)+0.0));
  xvf2_Vbi_ei_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vbi_ci*xvf+xvf_Vbi_ei*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vbi_ci)+0.0));
#endif
xvf2_Vb_ci=((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vs_ci*xvf+xvf_Vb_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vs_ci)+0.0));
  xvf2_Vb_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ei*xvf+xvf_Vb_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ei)+0.0));
  xvf2_Vb_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vb_ci*xvf+xvf_Vb_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vb_ci)+0.0));
  xvf2_Vb_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vtnode_GND*xvf+xvf_Vb_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vb_ci+xvf*xvf_Vb_ci_Vtnode_GND)+0.0));
  xvf2_Vb_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ci*xvf+xvf_Vb_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ci)+0.0));
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=0.0;
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=0.0;
  v_j_Vs_ci_Vbi_ei=0.0;
  v_j_Vs_ci_Vb_ci=0.0;
  v_j_Vs_ci_Vtnode_GND=0.0;
  v_j_Vs_ci_Vbi_ci=0.0;
#endif
v_j_Vbi_ei=(-(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vs_ci+xvf2_Vbi_ei_Vs_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vbi_ei+xvf2_Vbi_ei_Vbi_ei))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vb_ci+xvf2_Vbi_ei_Vb_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vtnode_GND+xvf2_Vbi_ei_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vbi_ci+xvf2_Vbi_ei_Vbi_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
v_j_Vb_ci=(-(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vs_ci+xvf2_Vb_ci_Vs_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ei+xvf2_Vb_ci_Vbi_ei))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=0.0;
#endif
x_Vci_ei=0.0;
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=0.0;
  x_Vci_ei_Vci_ei=0.0;
#endif
#endif
x=(1.0-pModel->ze);
EXIT_IF_ISNAN((1.0-pModel->ze))
{
double m00_logE(d00_logE0,(1.0-(v_j/vde_t)))
double m00_exp(d00_exp1,(x*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(v_j/vde_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
y_Vs_ci=0.0;
#if defined(_DERIVATE2)
  y_Vs_ci_Vs_ci=0.0;
  y_Vs_ci_Vci_ei=0.0;
  y_Vs_ci_Vbi_ei=0.0;
  y_Vs_ci_Vb_ci=0.0;
  y_Vs_ci_Vtnode_GND=0.0;
  y_Vs_ci_Vbi_ci=0.0;
#endif
y_Vci_ei=(-x_Vci_ei*d00_logE0*d10_exp1);
#if defined(_DERIVATE2)
  y_Vci_ei_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vde_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vs_ci/vde_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*x_Vci_ei*d00_logE0+d10_exp1*(+x_Vci_ei_Vci_ei*d00_logE0+x_Vci_ei*0.0+x_Vci_ei*0.0+x*0.0)));
  y_Vci_ei_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vde_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vbi_ei/vde_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vde_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vb_ci/vde_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0)))*x_Vci_ei*d00_logE0+d10_exp1*(+x_Vci_ei_Vtnode_GND*d00_logE0+x_Vci_ei*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0+x_Vtnode_GND*0.0+x*0.0)));
  y_Vci_ei_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vde_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vbi_ci/vde_t))*d10_logE0+0.0*0.0+x*0.0)));
#endif
y_Vbi_ei=(-(x*(-(v_j_Vbi_ei/vde_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ei_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vs_ci/vde_t))*(-(v_j_Vbi_ei/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vs_ci/vde_t-(v_j_Vbi_ei*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vbi_ei_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ei/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ei/vde_t))*d10_logE0+x*0.0)));
  y_Vbi_ei_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vbi_ei/vde_t))*(-(v_j_Vbi_ei/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vbi_ei/vde_t-(v_j_Vbi_ei*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vbi_ei_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vb_ci/vde_t))*(-(v_j_Vbi_ei/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vb_ci/vde_t-(v_j_Vbi_ei*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vbi_ei_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0)))*(x*(-(v_j_Vbi_ei/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ei/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*(-(v_j_Vbi_ei/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vtnode_GND/vde_t-(v_j_Vbi_ei*vde_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*vde_t_Vtnode_GND/vde_t/vde_t/vde_t))))));
  y_Vbi_ei_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vbi_ci/vde_t))*(-(v_j_Vbi_ei/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vbi_ci/vde_t-(v_j_Vbi_ei*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
#endif
y_Vb_ci=(-(x*(-(v_j_Vb_ci/vde_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vb_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vs_ci/vde_t))*(-(v_j_Vb_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vs_ci/vde_t-(v_j_Vb_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vb_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vb_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vb_ci/vde_t))*d10_logE0+x*0.0)));
  y_Vb_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vde_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vde_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vbi_ei/vde_t))*(-(v_j_Vb_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ei/vde_t-(v_j_Vb_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vb_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vb_ci/vde_t))*(-(v_j_Vb_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vb_ci/vde_t-(v_j_Vb_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vb_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0)))*(x*(-(v_j_Vb_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vb_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*(-(v_j_Vb_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vtnode_GND/vde_t-(v_j_Vb_ci*vde_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*vde_t_Vtnode_GND/vde_t/vde_t/vde_t))))));
  y_Vb_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vbi_ci/vde_t))*(-(v_j_Vb_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ci/vde_t-(v_j_Vb_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
#endif
#if defined(_DERIVATE)
y_Vtnode_GND=(-((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0))*d10_exp1);
#endif
y_Vbi_ci=(-(x*(-(v_j_Vbi_ci/vde_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vs_ci/vde_t))*(-(v_j_Vbi_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vs_ci/vde_t-(v_j_Vbi_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vbi_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ci/vde_t))*d10_logE0+x*0.0)));
  y_Vbi_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vbi_ei/vde_t))*(-(v_j_Vbi_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ei/vde_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vbi_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vb_ci/vde_t))*(-(v_j_Vbi_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vde_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
  y_Vbi_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0)))*(x*(-(v_j_Vbi_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-((v_j_Vtnode_GND*vde_t-v_j*vde_t_Vtnode_GND)/vde_t/vde_t))*(-(v_j_Vbi_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vde_t-(v_j_Vbi_ci*vde_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*vde_t_Vtnode_GND/vde_t/vde_t/vde_t))))));
  y_Vbi_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vde_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vde_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vde_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vde_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vde_t)))*(-(v_j_Vbi_ci/vde_t))*(-(v_j_Vbi_ci/vde_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vde_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vde_t/vde_t+2*v_j*0.0*0.0/vde_t/vde_t/vde_t))))));
#endif
#endif
y=(1.0-d00_exp1);
EXIT_IF_ISNAN((1.0-d00_exp1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
qjei_Vtnode_GND=(((((((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND))*y)+((cje0_t*vde_t)*y_Vtnode_GND))*x-((cje0_t*vde_t)*y)*x_Vtnode_GND)/x/x)+((((aje_t_Vtnode_GND*cje0_t)+(aje_t*cje0_t_Vtnode_GND))*(Vbiei-v_j))+((aje_t*cje0_t)*(-v_j_Vtnode_GND))));
#endif
qjei_Vci_ei=((((cje0_t*vde_t)*y_Vci_ei)*x-((cje0_t*vde_t)*y)*x_Vci_ei)/x/x);
#if defined(_DERIVATE2)
  qjei_Vci_ei_Vtnode_GND=(+((+(+0.0*vde_t+0.0*vde_t_Vtnode_GND+cje0_t_Vtnode_GND*0.0+cje0_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y_Vci_ei+(cje0_t*vde_t)*y_Vci_ei_Vtnode_GND)/x-(((cje0_t*vde_t)*y_Vci_ei)*x_Vtnode_GND+((((((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y)+((cje0_t*vde_t)*y_Vtnode_GND)))*x_Vci_ei+((cje0_t*vde_t)*y)*x_Vci_ei_Vtnode_GND)/x/x+2*((cje0_t*vde_t)*y)*x_Vci_ei*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_t+0.0*cje0_t_Vtnode_GND+aje_t_Vtnode_GND*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((aje_t_Vtnode_GND*cje0_t)+(aje_t*cje0_t_Vtnode_GND)))*0.0+(aje_t*cje0_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vci_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vci_ei+(cje0_t*vde_t)*y_Vci_ei_Vci_ei)/x-(((cje0_t*vde_t)*y_Vci_ei)*x_Vci_ei+((((0.0)*y)+((cje0_t*vde_t)*y_Vci_ei)))*x_Vci_ei+((cje0_t*vde_t)*y)*x_Vci_ei_Vci_ei)/x/x+2*((cje0_t*vde_t)*y)*x_Vci_ei*x_Vci_ei/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*0.0+(aje_t*cje0_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vbi_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vci_ei+(cje0_t*vde_t)*y_Vci_ei_Vbi_ei)/x-(((cje0_t*vde_t)*y_Vci_ei)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ei)))*x_Vci_ei+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*x_Vci_ei*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*0.0+(aje_t*cje0_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vb_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vci_ei+(cje0_t*vde_t)*y_Vci_ei_Vb_ci)/x-(((cje0_t*vde_t)*y_Vci_ei)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vb_ci)))*x_Vci_ei+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*x_Vci_ei*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*0.0+(aje_t*cje0_t)*(+0.0-0.0)));
  qjei_Vci_ei_Vbi_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vci_ei+(cje0_t*vde_t)*y_Vci_ei_Vbi_ci)/x-(((cje0_t*vde_t)*y_Vci_ei)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ci)))*x_Vci_ei+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*x_Vci_ei*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*0.0+(aje_t*cje0_t)*(+0.0-0.0)));
#endif
qjei_Vbi_ei=((((cje0_t*vde_t)*y_Vbi_ei)/x)+((aje_t*cje0_t)*(Vbiei_Vbi_ei-v_j_Vbi_ei)));
#if defined(_DERIVATE2)
  qjei_Vbi_ei_Vtnode_GND=(+((+(+0.0*vde_t+0.0*vde_t_Vtnode_GND+cje0_t_Vtnode_GND*0.0+cje0_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y_Vbi_ei+(cje0_t*vde_t)*y_Vbi_ei_Vtnode_GND)/x-(((cje0_t*vde_t)*y_Vbi_ei)*x_Vtnode_GND+((((((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y)+((cje0_t*vde_t)*y_Vtnode_GND)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_t+0.0*cje0_t_Vtnode_GND+aje_t_Vtnode_GND*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((aje_t_Vtnode_GND*cje0_t)+(aje_t*cje0_t_Vtnode_GND)))*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(aje_t*cje0_t)*(+0.0-v_j_Vbi_ei_Vtnode_GND)));
  qjei_Vbi_ei_Vci_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vbi_ei+(cje0_t*vde_t)*y_Vbi_ei_Vci_ei)/x-(((cje0_t*vde_t)*y_Vbi_ei)*x_Vci_ei+((((0.0)*y)+((cje0_t*vde_t)*y_Vci_ei)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*x_Vci_ei/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(aje_t*cje0_t)*(+0.0-0.0)));
  qjei_Vbi_ei_Vbi_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vbi_ei+(cje0_t*vde_t)*y_Vbi_ei_Vbi_ei)/x-(((cje0_t*vde_t)*y_Vbi_ei)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ei)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(aje_t*cje0_t)*(+Vbiei_Vbi_ei_Vbi_ei-v_j_Vbi_ei_Vbi_ei)));
  qjei_Vbi_ei_Vb_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vbi_ei+(cje0_t*vde_t)*y_Vbi_ei_Vb_ci)/x-(((cje0_t*vde_t)*y_Vbi_ei)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vb_ci)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(aje_t*cje0_t)*(+0.0-v_j_Vbi_ei_Vb_ci)));
  qjei_Vbi_ei_Vbi_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vbi_ei+(cje0_t*vde_t)*y_Vbi_ei_Vbi_ci)/x-(((cje0_t*vde_t)*y_Vbi_ei)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ci)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(aje_t*cje0_t)*(+0.0-v_j_Vbi_ei_Vbi_ci)));
#endif
qjei_Vb_ci=((((cje0_t*vde_t)*y_Vb_ci)/x)+((aje_t*cje0_t)*(-v_j_Vb_ci)));
#if defined(_DERIVATE2)
  qjei_Vb_ci_Vtnode_GND=(+((+(+0.0*vde_t+0.0*vde_t_Vtnode_GND+cje0_t_Vtnode_GND*0.0+cje0_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y_Vb_ci+(cje0_t*vde_t)*y_Vb_ci_Vtnode_GND)/x-(((cje0_t*vde_t)*y_Vb_ci)*x_Vtnode_GND+((((((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y)+((cje0_t*vde_t)*y_Vtnode_GND)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_t+0.0*cje0_t_Vtnode_GND+aje_t_Vtnode_GND*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((aje_t_Vtnode_GND*cje0_t)+(aje_t*cje0_t_Vtnode_GND)))*(-v_j_Vb_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vb_ci_Vtnode_GND)));
  qjei_Vb_ci_Vci_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vb_ci+(cje0_t*vde_t)*y_Vb_ci_Vci_ei)/x-(((cje0_t*vde_t)*y_Vb_ci)*x_Vci_ei+((((0.0)*y)+((cje0_t*vde_t)*y_Vci_ei)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*x_Vci_ei/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*(-v_j_Vb_ci)+(aje_t*cje0_t)*(+0.0-0.0)));
  qjei_Vb_ci_Vbi_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vb_ci+(cje0_t*vde_t)*y_Vb_ci_Vbi_ei)/x-(((cje0_t*vde_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ei)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*(-v_j_Vb_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vb_ci_Vbi_ei)));
  qjei_Vb_ci_Vb_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vb_ci+(cje0_t*vde_t)*y_Vb_ci_Vb_ci)/x-(((cje0_t*vde_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vb_ci)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(-v_j_Vb_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vb_ci_Vb_ci)));
  qjei_Vb_ci_Vbi_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vb_ci+(cje0_t*vde_t)*y_Vb_ci_Vbi_ci)/x-(((cje0_t*vde_t)*y_Vb_ci)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ci)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*(-v_j_Vb_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vb_ci_Vbi_ci)));
#endif
qjei_Vbi_ci=((((cje0_t*vde_t)*y_Vbi_ci)/x)+((aje_t*cje0_t)*(-v_j_Vbi_ci)));
#if defined(_DERIVATE2)
  qjei_Vbi_ci_Vtnode_GND=(+((+(+0.0*vde_t+0.0*vde_t_Vtnode_GND+cje0_t_Vtnode_GND*0.0+cje0_t*0.0)*y+0.0*y_Vtnode_GND+(((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y_Vbi_ci+(cje0_t*vde_t)*y_Vbi_ci_Vtnode_GND)/x-(((cje0_t*vde_t)*y_Vbi_ci)*x_Vtnode_GND+((((((cje0_t_Vtnode_GND*vde_t)+(cje0_t*vde_t_Vtnode_GND)))*y)+((cje0_t*vde_t)*y_Vtnode_GND)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cje0_t+0.0*cje0_t_Vtnode_GND+aje_t_Vtnode_GND*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vtnode_GND)+(((aje_t_Vtnode_GND*cje0_t)+(aje_t*cje0_t_Vtnode_GND)))*(-v_j_Vbi_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vbi_ci_Vtnode_GND)));
  qjei_Vbi_ci_Vci_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vbi_ci+(cje0_t*vde_t)*y_Vbi_ci_Vci_ei)/x-(((cje0_t*vde_t)*y_Vbi_ci)*x_Vci_ei+((((0.0)*y)+((cje0_t*vde_t)*y_Vci_ei)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*x_Vci_ei/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*0.0+(0.0)*(-v_j_Vbi_ci)+(aje_t*cje0_t)*(+0.0-0.0)));
  qjei_Vbi_ci_Vbi_ei=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vbi_ci+(cje0_t*vde_t)*y_Vbi_ci_Vbi_ei)/x-(((cje0_t*vde_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ei)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(Vbiei_Vbi_ei-v_j_Vbi_ei)+(0.0)*(-v_j_Vbi_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vbi_ci_Vbi_ei)));
  qjei_Vbi_ci_Vb_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vbi_ci+(cje0_t*vde_t)*y_Vbi_ci_Vb_ci)/x-(((cje0_t*vde_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vb_ci)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(-v_j_Vbi_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vbi_ci_Vb_ci)));
  qjei_Vbi_ci_Vbi_ci=(+((+(+0.0*vde_t+0.0*0.0+0.0*0.0+cje0_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vbi_ci+(cje0_t*vde_t)*y_Vbi_ci_Vbi_ci)/x-(((cje0_t*vde_t)*y_Vbi_ci)*0.0+((((0.0)*y)+((cje0_t*vde_t)*y_Vbi_ci)))*0.0+((cje0_t*vde_t)*y)*0.0)/x/x+2*((cje0_t*vde_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cje0_t+0.0*0.0+0.0*0.0+aje_t*0.0)*(Vbiei-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*(-v_j_Vbi_ci)+(aje_t*cje0_t)*(+0.0-v_j_Vbi_ci_Vbi_ci)));
#endif
#endif
pInst->qjei=((((cje0_t*vde_t)*y)/x)+((aje_t*cje0_t)*(Vbiei-v_j)));
EXIT_IF_ISNAN(((((cje0_t*vde_t)*y)/x)+((aje_t*cje0_t)*(Vbiei-v_j))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci) ddxprobe=V(ei,GND)V(s,GND)V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
qjei_Vtnode_GND=0.0;
#endif
qjei_Vci_ei=0.0;
#if defined(_DERIVATE2)
  qjei_Vci_ei_Vtnode_GND=0.0;
  qjei_Vci_ei_Vci_ei=0.0;
  qjei_Vci_ei_Vbi_ei=0.0;
  qjei_Vci_ei_Vb_ci=0.0;
  qjei_Vci_ei_Vbi_ci=0.0;
#endif
qjei_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  qjei_Vbi_ei_Vtnode_GND=0.0;
  qjei_Vbi_ei_Vci_ei=0.0;
  qjei_Vbi_ei_Vbi_ei=0.0;
  qjei_Vbi_ei_Vb_ci=0.0;
  qjei_Vbi_ei_Vbi_ci=0.0;
#endif
qjei_Vb_ci=0.0;
#if defined(_DERIVATE2)
  qjei_Vb_ci_Vtnode_GND=0.0;
  qjei_Vb_ci_Vci_ei=0.0;
  qjei_Vb_ci_Vbi_ei=0.0;
  qjei_Vb_ci_Vb_ci=0.0;
  qjei_Vb_ci_Vbi_ci=0.0;
#endif
qjei_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  qjei_Vbi_ci_Vtnode_GND=0.0;
  qjei_Vbi_ci_Vci_ei=0.0;
  qjei_Vbi_ci_Vbi_ei=0.0;
  qjei_Vbi_ci_Vb_ci=0.0;
  qjei_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
pInst->qjei=0.00;
EXIT_IF_ISNAN(0.00)
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(s,GND)V(ei,GND) */
#if defined(_DERIVATE)
qje_Vtnode_GND=((qjei_Vtnode_GND*cje0_t-pInst->qjei*cje0_t_Vtnode_GND)/cje0_t/cje0_t);
#endif
qje_Vbi_ei=(qjei_Vbi_ei/cje0_t);
#if defined(_DERIVATE2)
  qje_Vbi_ei_Vtnode_GND=(qjei_Vbi_ei_Vtnode_GND/cje0_t-(qjei_Vbi_ei*cje0_t_Vtnode_GND+qjei_Vtnode_GND*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*cje0_t_Vtnode_GND/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ei_Vbi_ei=(qjei_Vbi_ei_Vbi_ei/cje0_t-(qjei_Vbi_ei*0.0+qjei_Vbi_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ei_Vci_ei=(qjei_Vbi_ei_Vci_ei/cje0_t-(qjei_Vbi_ei*0.0+qjei_Vci_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ei_Vb_ci=(qjei_Vbi_ei_Vb_ci/cje0_t-(qjei_Vbi_ei*0.0+qjei_Vb_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ei_Vbi_ci=(qjei_Vbi_ei_Vbi_ci/cje0_t-(qjei_Vbi_ei*0.0+qjei_Vbi_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
#endif
qje_Vci_ei=(qjei_Vci_ei/cje0_t);
#if defined(_DERIVATE2)
  qje_Vci_ei_Vtnode_GND=(qjei_Vci_ei_Vtnode_GND/cje0_t-(qjei_Vci_ei*cje0_t_Vtnode_GND+qjei_Vtnode_GND*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*cje0_t_Vtnode_GND/cje0_t/cje0_t/cje0_t);
  qje_Vci_ei_Vbi_ei=(qjei_Vci_ei_Vbi_ei/cje0_t-(qjei_Vci_ei*0.0+qjei_Vbi_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vci_ei_Vci_ei=(qjei_Vci_ei_Vci_ei/cje0_t-(qjei_Vci_ei*0.0+qjei_Vci_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vci_ei_Vb_ci=(qjei_Vci_ei_Vb_ci/cje0_t-(qjei_Vci_ei*0.0+qjei_Vb_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vci_ei_Vbi_ci=(qjei_Vci_ei_Vbi_ci/cje0_t-(qjei_Vci_ei*0.0+qjei_Vbi_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
#endif
qje_Vb_ci=(qjei_Vb_ci/cje0_t);
#if defined(_DERIVATE2)
  qje_Vb_ci_Vtnode_GND=(qjei_Vb_ci_Vtnode_GND/cje0_t-(qjei_Vb_ci*cje0_t_Vtnode_GND+qjei_Vtnode_GND*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*cje0_t_Vtnode_GND/cje0_t/cje0_t/cje0_t);
  qje_Vb_ci_Vbi_ei=(qjei_Vb_ci_Vbi_ei/cje0_t-(qjei_Vb_ci*0.0+qjei_Vbi_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vb_ci_Vci_ei=(qjei_Vb_ci_Vci_ei/cje0_t-(qjei_Vb_ci*0.0+qjei_Vci_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vb_ci_Vb_ci=(qjei_Vb_ci_Vb_ci/cje0_t-(qjei_Vb_ci*0.0+qjei_Vb_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vb_ci_Vbi_ci=(qjei_Vb_ci_Vbi_ci/cje0_t-(qjei_Vb_ci*0.0+qjei_Vbi_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
#endif
qje_Vbi_ci=(qjei_Vbi_ci/cje0_t);
#if defined(_DERIVATE2)
  qje_Vbi_ci_Vtnode_GND=(qjei_Vbi_ci_Vtnode_GND/cje0_t-(qjei_Vbi_ci*cje0_t_Vtnode_GND+qjei_Vtnode_GND*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*cje0_t_Vtnode_GND/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ci_Vbi_ei=(qjei_Vbi_ci_Vbi_ei/cje0_t-(qjei_Vbi_ci*0.0+qjei_Vbi_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ci_Vci_ei=(qjei_Vbi_ci_Vci_ei/cje0_t-(qjei_Vbi_ci*0.0+qjei_Vci_ei*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ci_Vb_ci=(qjei_Vbi_ci_Vb_ci/cje0_t-(qjei_Vbi_ci*0.0+qjei_Vb_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
  qje_Vbi_ci_Vbi_ci=(qjei_Vbi_ci_Vbi_ci/cje0_t-(qjei_Vbi_ci*0.0+qjei_Vbi_ci*0.0+pInst->qjei*0.0)/cje0_t/cje0_t+2*pInst->qjei*0.0*0.0/cje0_t/cje0_t/cje0_t);
#endif
#endif
qje=(pInst->qjei/cje0_t);
EXIT_IF_ISNAN((pInst->qjei/cje0_t))
if
((rbi0_t>0.0))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
Qz_nom_Vtnode_GND=((((qje_Vtnode_GND/pModel->vr0e)+(qjci_Vtnode_GND/pModel->vr0c))+((itf_Vtnode_GND*ickf-itf*ickf_Vtnode_GND)/ickf/ickf))+(itr_Vtnode_GND/ickr));
Qz_nom_Vbi_ei=(((qje_Vbi_ei/pModel->vr0e)+(itf_Vbi_ei/ickf))+(itr_Vbi_ei/ickr));
Qz_nom_Vci_ei=(((qje_Vci_ei/pModel->vr0e)+(itf_Vci_ei/ickf))+(itr_Vci_ei/ickr));
Qz_nom_Vb_ci=((((qje_Vb_ci/pModel->vr0e)+(qjci_Vb_ci/pModel->vr0c))+((itf_Vb_ci*ickf-itf*ickf_Vb_ci)/ickf/ickf))+(itr_Vb_ci/ickr));
Qz_nom_Vbi_ci=((((qje_Vbi_ci/pModel->vr0e)+(qjci_Vbi_ci/pModel->vr0c))+((itf_Vbi_ci*ickf-itf*ickf_Vbi_ci)/ickf/ickf))+(itr_Vbi_ci/ickr));
#endif
Qz_nom=((((1+(qje/pModel->vr0e))+(pInst->qjci/pModel->vr0c))+(itf/ickf))+(itr/ickr));
EXIT_IF_ISNAN(((((1+(qje/pModel->vr0e))+(pInst->qjci/pModel->vr0c))+(itf/ickf))+(itr/ickr)))
{
double m00_sqrt(d00_sqrt0,((Qz_nom*Qz_nom)+0.01))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Qz_nom*Qz_nom)+0.01))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
fQz_Vtnode_GND=(0.5*(Qz_nom_Vtnode_GND+((Qz_nom_Vtnode_GND*Qz_nom)+(Qz_nom*Qz_nom_Vtnode_GND))*d10_sqrt0));
fQz_Vbi_ei=(0.5*(Qz_nom_Vbi_ei+((Qz_nom_Vbi_ei*Qz_nom)+(Qz_nom*Qz_nom_Vbi_ei))*d10_sqrt0));
fQz_Vci_ei=(0.5*(Qz_nom_Vci_ei+((Qz_nom_Vci_ei*Qz_nom)+(Qz_nom*Qz_nom_Vci_ei))*d10_sqrt0));
fQz_Vb_ci=(0.5*(Qz_nom_Vb_ci+((Qz_nom_Vb_ci*Qz_nom)+(Qz_nom*Qz_nom_Vb_ci))*d10_sqrt0));
fQz_Vbi_ci=(0.5*(Qz_nom_Vbi_ci+((Qz_nom_Vbi_ci*Qz_nom)+(Qz_nom*Qz_nom_Vbi_ci))*d10_sqrt0));
#endif
fQz=(0.5*(Qz_nom+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(Qz_nom+d00_sqrt0)))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
rbi_Vtnode_GND=((rbi0_t_Vtnode_GND*fQz-rbi0_t*fQz_Vtnode_GND)/fQz/fQz);
rbi_Vbi_ei=(-rbi0_t*fQz_Vbi_ei/fQz/fQz);
rbi_Vci_ei=(-rbi0_t*fQz_Vci_ei/fQz/fQz);
rbi_Vb_ci=(-rbi0_t*fQz_Vb_ci/fQz/fQz);
rbi_Vbi_ci=(-rbi0_t*fQz_Vbi_ci/fQz/fQz);
#endif
rbi=(rbi0_t/fQz);
EXIT_IF_ISNAN((rbi0_t/fQz))
if
((ibi>0.0))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
eta_Vtnode_GND=(((((pModel->fgeo*rbi_Vtnode_GND)*ibi)+((pModel->fgeo*rbi)*ibi_Vtnode_GND))*VT-((pModel->fgeo*rbi)*ibi)*VT_Vtnode_GND)/VT/VT);
eta_Vbi_ei=((((pModel->fgeo*rbi_Vbi_ei)*ibi)+((pModel->fgeo*rbi)*ibi_Vbi_ei))/VT);
eta_Vci_ei=((pModel->fgeo*rbi_Vci_ei)*ibi/VT);
eta_Vb_ci=((pModel->fgeo*rbi_Vb_ci)*ibi/VT);
eta_Vbi_ci=((((pModel->fgeo*rbi_Vbi_ci)*ibi)+((pModel->fgeo*rbi)*ibi_Vbi_ci))/VT);
#endif
eta=(((pModel->fgeo*rbi)*ibi)/VT);
EXIT_IF_ISNAN((((pModel->fgeo*rbi)*ibi)/VT))
if
((eta<1e-6))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
rbi_Vtnode_GND=((rbi_Vtnode_GND*(1-(0.5*eta)))+(rbi*(-(0.5*eta_Vtnode_GND))));
rbi_Vbi_ei=((rbi_Vbi_ei*(1-(0.5*eta)))+(rbi*(-(0.5*eta_Vbi_ei))));
rbi_Vci_ei=((rbi_Vci_ei*(1-(0.5*eta)))+(rbi*(-(0.5*eta_Vci_ei))));
rbi_Vb_ci=((rbi_Vb_ci*(1-(0.5*eta)))+(rbi*(-(0.5*eta_Vb_ci))));
rbi_Vbi_ci=((rbi_Vbi_ci*(1-(0.5*eta)))+(rbi*(-(0.5*eta_Vbi_ci))));
#endif
rbi=(rbi*(1-(0.5*eta)));
EXIT_IF_ISNAN((rbi*(1-(0.5*eta))))
}
else
{
{
double m00_logE(d00_logE0,(eta+1))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(eta+1))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
rbi_Vtnode_GND=((((rbi_Vtnode_GND*d00_logE0)+(rbi*eta_Vtnode_GND*d10_logE0))*eta-(rbi*d00_logE0)*eta_Vtnode_GND)/eta/eta);
rbi_Vbi_ei=((((rbi_Vbi_ei*d00_logE0)+(rbi*eta_Vbi_ei*d10_logE0))*eta-(rbi*d00_logE0)*eta_Vbi_ei)/eta/eta);
rbi_Vci_ei=((((rbi_Vci_ei*d00_logE0)+(rbi*eta_Vci_ei*d10_logE0))*eta-(rbi*d00_logE0)*eta_Vci_ei)/eta/eta);
rbi_Vb_ci=((((rbi_Vb_ci*d00_logE0)+(rbi*eta_Vb_ci*d10_logE0))*eta-(rbi*d00_logE0)*eta_Vb_ci)/eta/eta);
rbi_Vbi_ci=((((rbi_Vbi_ci*d00_logE0)+(rbi*eta_Vbi_ci*d10_logE0))*eta-(rbi*d00_logE0)*eta_Vbi_ci)/eta/eta);
#endif
rbi=((rbi*d00_logE0)/eta);
EXIT_IF_ISNAN(((rbi*d00_logE0)/eta))
}
}
}
}
else
{
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
rbi_Vtnode_GND=0.0;
rbi_Vbi_ei=0.0;
rbi_Vci_ei=0.0;
rbi_Vb_ci=0.0;
rbi_Vbi_ci=0.0;
#endif
rbi=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(bi,ei)V(ci,ei)V(b,ci)V(bi,ci) ddxprobe= */
rb_Vtnode_GND=(rbi_Vtnode_GND+rbx_t_Vtnode_GND);
rb_Vbi_ei=rbi_Vbi_ei;
rb_Vci_ei=rbi_Vci_ei;
rb_Vb_ci=rbi_Vb_ci;
rb_Vbi_ci=rbi_Vbi_ci;
#endif
rb=(rbi+rbx_t);
EXIT_IF_ISNAN((rbi+rbx_t))
if
((pModel->itss>0.0))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe= */
HSUM_Vtnode_GND=(pModel->msf*VT_Vtnode_GND);
#endif
HSUM=(pModel->msf*VT);
EXIT_IF_ISNAN((pModel->msf*VT))
{
double m00_limexp(d00_limexp0,(Vbci/HSUM))
#if defined(_DERIVATE)
double m10_limexp(d10_limexp0,d00_limexp0,(Vbci/HSUM))
#endif
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND) ddxprobe= */
HSa_Vb_ci=(Vbci_Vb_ci/HSUM)*d10_limexp0;
HSa_Vtnode_GND=(-Vbci*HSUM_Vtnode_GND/HSUM/HSUM)*d10_limexp0;
#endif
HSa=d00_limexp0;
EXIT_IF_ISNAN(d00_limexp0)
}
{
double m00_limexp(d00_limexp0,(Vsci/HSUM))
#if defined(_DERIVATE)
double m10_limexp(d10_limexp0,d00_limexp0,(Vsci/HSUM))
#endif
#if defined(_DERIVATE) /* probe=V(s,ci)V(tnode,GND) ddxprobe= */
HSb_Vs_ci=(Vsci_Vs_ci/HSUM)*d10_limexp0;
HSb_Vtnode_GND=(-Vsci*HSUM_Vtnode_GND/HSUM/HSUM)*d10_limexp0;
#endif
HSb=d00_limexp0;
EXIT_IF_ISNAN(d00_limexp0)
}
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(b,ci)V(s,ci) ddxprobe= */
HSI_Tsu_Vtnode_GND=((itss_t_Vtnode_GND*(HSa-HSb))+(itss_t*(HSa_Vtnode_GND-HSb_Vtnode_GND)));
HSI_Tsu_Vb_ci=(itss_t*HSa_Vb_ci);
HSI_Tsu_Vs_ci=(itss_t*(-HSb_Vs_ci));
#endif
HSI_Tsu=(itss_t*(HSa-HSb));
EXIT_IF_ISNAN((itss_t*(HSa-HSb)))
}
else
{
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(b,ci)V(s,ci) ddxprobe= */
HSI_Tsu_Vtnode_GND=0.0;
HSI_Tsu_Vb_ci=0.0;
HSI_Tsu_Vs_ci=0.0;
#endif
HSI_Tsu=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=(Vsci_Vs_ci/(pModel->msc*VT));
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=(Vsci_Vs_ci_Vs_ci/(pModel->msc*VT)-(Vsci_Vs_ci*(0.0)+Vsci_Vs_ci*0.0+Vsci*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->msc*0.0))/(pModel->msc*VT)/(pModel->msc*VT)+2*Vsci*0.0*(0.0)/(pModel->msc*VT)/(pModel->msc*VT)/(pModel->msc*VT));
  DIOY_Vs_ci_Vbi_ci=(0.0/(pModel->msc*VT)-(Vsci_Vs_ci*(0.0)+0.0*0.0+Vsci*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->msc*0.0))/(pModel->msc*VT)/(pModel->msc*VT)+2*Vsci*0.0*(0.0)/(pModel->msc*VT)/(pModel->msc*VT)/(pModel->msc*VT));
  DIOY_Vs_ci_Vbi_ei=(0.0/(pModel->msc*VT)-(Vsci_Vs_ci*(0.0)+0.0*0.0+Vsci*(+0.0*VT+0.0*0.0+0.0*0.0+pModel->msc*0.0))/(pModel->msc*VT)/(pModel->msc*VT)+2*Vsci*0.0*(0.0)/(pModel->msc*VT)/(pModel->msc*VT)/(pModel->msc*VT));
  DIOY_Vs_ci_Vtnode_GND=(0.0/(pModel->msc*VT)-(Vsci_Vs_ci*((pModel->msc*VT_Vtnode_GND))+0.0*0.0+Vsci*(+0.0*VT+0.0*VT_Vtnode_GND+0.0*0.0+pModel->msc*0.0))/(pModel->msc*VT)/(pModel->msc*VT)+2*Vsci*0.0*((pModel->msc*VT_Vtnode_GND))/(pModel->msc*VT)/(pModel->msc*VT)/(pModel->msc*VT));
#endif
DIOY_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=0.0;
  DIOY_Vbi_ci_Vbi_ci=0.0;
  DIOY_Vbi_ci_Vbi_ei=0.0;
  DIOY_Vbi_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=0.0;
  DIOY_Vbi_ei_Vbi_ci=0.0;
  DIOY_Vbi_ei_Vbi_ei=0.0;
  DIOY_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=(-Vsci*(pModel->msc*VT_Vtnode_GND)/(pModel->msc*VT)/(pModel->msc*VT));
#endif
#endif
DIOY=(Vsci/(pModel->msc*VT));
EXIT_IF_ISNAN((Vsci/(pModel->msc*VT)))
if
((pModel->iscs>0.0))
{
if
((DIOY>80))
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=DIOY_Vs_ci;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=(+0.0+(+DIOY_Vs_ci_Vs_ci-0.0));
  le_Vs_ci_Vbi_ci=(+0.0+(+DIOY_Vs_ci_Vbi_ci-0.0));
  le_Vs_ci_Vbi_ei=(+0.0+(+DIOY_Vs_ci_Vbi_ei-0.0));
  le_Vs_ci_Vtnode_GND=(+0.0+(+DIOY_Vs_ci_Vtnode_GND-0.0));
#endif
le_Vbi_ci=DIOY_Vbi_ci;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=(+0.0+(+DIOY_Vbi_ci_Vs_ci-0.0));
  le_Vbi_ci_Vbi_ci=(+0.0+(+DIOY_Vbi_ci_Vbi_ci-0.0));
  le_Vbi_ci_Vbi_ei=(+0.0+(+DIOY_Vbi_ci_Vbi_ei-0.0));
  le_Vbi_ci_Vtnode_GND=(+0.0+(+DIOY_Vbi_ci_Vtnode_GND-0.0));
#endif
le_Vbi_ei=DIOY_Vbi_ei;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+0.0+(+DIOY_Vbi_ei_Vs_ci-0.0));
  le_Vbi_ei_Vbi_ci=(+0.0+(+DIOY_Vbi_ei_Vbi_ci-0.0));
  le_Vbi_ei_Vbi_ei=(+0.0+(+DIOY_Vbi_ei_Vbi_ei-0.0));
  le_Vbi_ei_Vtnode_GND=(+0.0+(+DIOY_Vbi_ei_Vtnode_GND-0.0));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=DIOY_Vtnode_GND;
#endif
#endif
le=(1+(DIOY-80));
EXIT_IF_ISNAN((1+(DIOY-80)))
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
DIOY_Vs_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vs_ci_Vs_ci=0.0;
  DIOY_Vs_ci_Vbi_ci=0.0;
  DIOY_Vs_ci_Vbi_ei=0.0;
  DIOY_Vs_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ci_Vs_ci=0.0;
  DIOY_Vbi_ci_Vbi_ci=0.0;
  DIOY_Vbi_ci_Vbi_ei=0.0;
  DIOY_Vbi_ci_Vtnode_GND=0.0;
#endif
DIOY_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  DIOY_Vbi_ei_Vs_ci=0.0;
  DIOY_Vbi_ei_Vbi_ci=0.0;
  DIOY_Vbi_ei_Vbi_ei=0.0;
  DIOY_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
DIOY_Vtnode_GND=0.0;
#endif
#endif
DIOY=80;
EXIT_IF_ISNAN(80)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=0.0;
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=0.0;
  le_Vs_ci_Vbi_ci=0.0;
  le_Vs_ci_Vbi_ei=0.0;
  le_Vs_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=0.0;
  le_Vbi_ci_Vbi_ci=0.0;
  le_Vbi_ci_Vbi_ei=0.0;
  le_Vbi_ci_Vtnode_GND=0.0;
#endif
le_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=0.0;
  le_Vbi_ei_Vbi_ci=0.0;
  le_Vbi_ei_Vbi_ei=0.0;
  le_Vbi_ei_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=0.0;
#endif
#endif
le=1;
EXIT_IF_ISNAN(1)
}
{
double m00_limexp(d00_limexp0,DIOY)
#if defined(_DERIVATEFORDDX)
double m10_limexp(d10_limexp0,d00_limexp0,DIOY)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ci)V(bi,ei)V(tnode,GND) ddxprobe=V(bi,GND)V(ci,GND) */
le_Vs_ci=((le_Vs_ci*d00_limexp0)+(le*DIOY_Vs_ci*d10_limexp0));
#if defined(_DERIVATE2)
  le_Vs_ci_Vs_ci=(+le_Vs_ci_Vs_ci*d00_limexp0+le_Vs_ci*DIOY_Vs_ci*d10_limexp0+le_Vs_ci*DIOY_Vs_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vs_ci*DIOY_Vs_ci+d10_limexp0*DIOY_Vs_ci_Vs_ci));
  le_Vs_ci_Vbi_ci=(+le_Vs_ci_Vbi_ci*d00_limexp0+le_Vs_ci*DIOY_Vbi_ci*d10_limexp0+le_Vbi_ci*DIOY_Vs_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ci*DIOY_Vs_ci+d10_limexp0*DIOY_Vs_ci_Vbi_ci));
  le_Vs_ci_Vbi_ei=(+le_Vs_ci_Vbi_ei*d00_limexp0+le_Vs_ci*DIOY_Vbi_ei*d10_limexp0+le_Vbi_ei*DIOY_Vs_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ei*DIOY_Vs_ci+d10_limexp0*DIOY_Vs_ci_Vbi_ei));
  le_Vs_ci_Vtnode_GND=(+le_Vs_ci_Vtnode_GND*d00_limexp0+le_Vs_ci*DIOY_Vtnode_GND*d10_limexp0+le_Vtnode_GND*DIOY_Vs_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vtnode_GND*DIOY_Vs_ci+d10_limexp0*DIOY_Vs_ci_Vtnode_GND));
#endif
le_Vbi_ci=((le_Vbi_ci*d00_limexp0)+(le*DIOY_Vbi_ci*d10_limexp0));
#if defined(_DERIVATE2)
  le_Vbi_ci_Vs_ci=(+le_Vbi_ci_Vs_ci*d00_limexp0+le_Vbi_ci*DIOY_Vs_ci*d10_limexp0+le_Vs_ci*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vs_ci*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vs_ci));
  le_Vbi_ci_Vbi_ci=(+le_Vbi_ci_Vbi_ci*d00_limexp0+le_Vbi_ci*DIOY_Vbi_ci*d10_limexp0+le_Vbi_ci*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ci*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vbi_ci));
  le_Vbi_ci_Vbi_ei=(+le_Vbi_ci_Vbi_ei*d00_limexp0+le_Vbi_ci*DIOY_Vbi_ei*d10_limexp0+le_Vbi_ei*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ei*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vbi_ei));
  le_Vbi_ci_Vtnode_GND=(+le_Vbi_ci_Vtnode_GND*d00_limexp0+le_Vbi_ci*DIOY_Vtnode_GND*d10_limexp0+le_Vtnode_GND*DIOY_Vbi_ci*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vtnode_GND*DIOY_Vbi_ci+d10_limexp0*DIOY_Vbi_ci_Vtnode_GND));
#endif
le_Vbi_ei=((le_Vbi_ei*d00_limexp0)+(le*DIOY_Vbi_ei*d10_limexp0));
#if defined(_DERIVATE2)
  le_Vbi_ei_Vs_ci=(+le_Vbi_ei_Vs_ci*d00_limexp0+le_Vbi_ei*DIOY_Vs_ci*d10_limexp0+le_Vs_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vs_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vs_ci));
  le_Vbi_ei_Vbi_ci=(+le_Vbi_ei_Vbi_ci*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ci*d10_limexp0+le_Vbi_ci*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ci*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ci));
  le_Vbi_ei_Vbi_ei=(+le_Vbi_ei_Vbi_ei*d00_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le_Vbi_ei*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vbi_ei*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vbi_ei));
  le_Vbi_ei_Vtnode_GND=(+le_Vbi_ei_Vtnode_GND*d00_limexp0+le_Vbi_ei*DIOY_Vtnode_GND*d10_limexp0+le_Vtnode_GND*DIOY_Vbi_ei*d10_limexp0+le*(m20_limexp(DIOY)*DIOY_Vtnode_GND*DIOY_Vbi_ei+d10_limexp0*DIOY_Vbi_ei_Vtnode_GND));
#endif
#if defined(_DERIVATE)
le_Vtnode_GND=((le_Vtnode_GND*d00_limexp0)+(le*DIOY_Vtnode_GND*d10_limexp0));
#endif
#endif
le=(le*d00_limexp0);
EXIT_IF_ISNAN((le*d00_limexp0))
}
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(s,ci)V(bi,ci)V(bi,ei) ddxprobe= */
ijsc_Vtnode_GND=((iscs_t_Vtnode_GND*(le-1.0))+(iscs_t*le_Vtnode_GND));
ijsc_Vs_ci=(iscs_t*le_Vs_ci);
ijsc_Vbi_ci=(iscs_t*le_Vbi_ci);
ijsc_Vbi_ei=(iscs_t*le_Vbi_ei);
#endif
pInst->ijsc=(iscs_t*(le-1.0));
EXIT_IF_ISNAN((iscs_t*(le-1.0)))
if
((DIOY<=(-14.0)))
{
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(s,ci)V(bi,ci)V(bi,ei) ddxprobe= */
ijsc_Vtnode_GND=(-iscs_t_Vtnode_GND);
ijsc_Vs_ci=0.0;
ijsc_Vbi_ci=0.0;
ijsc_Vbi_ei=0.0;
#endif
pInst->ijsc=(-iscs_t);
EXIT_IF_ISNAN((-iscs_t))
}
}
else
{
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(s,ci)V(bi,ci)V(bi,ei) ddxprobe= */
ijsc_Vtnode_GND=0.0;
ijsc_Vs_ci=0.0;
ijsc_Vbi_ci=0.0;
ijsc_Vbi_ei=0.0;
#endif
pInst->ijsc=0.0;
EXIT_IF_ISNAN(0.0)
}
#ifdef _DYNAMIC
if
((pModel->vpts<1.0e2))
{
#ifdef _DYNAMIC
if
((cjs0_t>0.0))
{
#if defined(_DYNAMIC)
zr=(pModel->zs/4.0);
EXIT_IF_ISNAN((pModel->zs/4.0))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vp_Vtnode_GND=(-vds_t_Vtnode_GND);
#endif
vp=(pModel->vpts-vds_t);
EXIT_IF_ISNAN((pModel->vpts-vds_t))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zs))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vds_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vds_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vds_t*(1.0-d00_exp1)))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
cmax_Vtnode_GND=(2.4*cjs0_t_Vtnode_GND);
#endif
cmax=(2.4*cjs0_t);
EXIT_IF_ISNAN((2.4*cjs0_t))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(vds_t/pModel->vpts))
double m00_exp(d00_exp1,((pModel->zs-zr)*d00_logE0))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(vds_t/pModel->vpts))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
cr_Vtnode_GND=((cjs0_t_Vtnode_GND*d00_exp1)+(cjs0_t*((pModel->zs-zr)*(vds_t_Vtnode_GND/pModel->vpts)*d10_logE0)*d10_exp1));
#endif
cr=(cjs0_t*d00_exp1);
EXIT_IF_ISNAN((cjs0_t*d00_exp1))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=VT_Vtnode_GND;
#endif
#endif
a=VT;
EXIT_IF_ISNAN(VT)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ve_Vs_ci=((-Vsci_Vs_ci)/a);
#if defined(_DERIVATE2)
  ve_Vs_ci_Vs_ci=((+0.0-Vsci_Vs_ci_Vs_ci)/a-((-Vsci_Vs_ci)*0.0+(-Vsci_Vs_ci)*0.0+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*0.0*0.0/a/a/a);
  ve_Vs_ci_Vci_ei=((+0.0-0.0)/a-((-Vsci_Vs_ci)*a_Vci_ei+0.0*0.0+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*0.0*a_Vci_ei/a/a/a);
  ve_Vs_ci_Vbi_ei=((+0.0-0.0)/a-((-Vsci_Vs_ci)*a_Vbi_ei+0.0*0.0+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*0.0*a_Vbi_ei/a/a/a);
  ve_Vs_ci_Vb_ci=((+0.0-0.0)/a-((-Vsci_Vs_ci)*a_Vb_ci+0.0*0.0+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*0.0*a_Vb_ci/a/a/a);
  ve_Vs_ci_Vtnode_GND=((+0.0-0.0)/a-((-Vsci_Vs_ci)*a_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*0.0*a_Vtnode_GND/a/a/a);
  ve_Vs_ci_Vbi_ci=((+0.0-0.0)/a-((-Vsci_Vs_ci)*a_Vbi_ci+0.0*0.0+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*0.0*a_Vbi_ci/a/a/a);
#endif
ve_Vci_ei=(-(vf-Vsci)*a_Vci_ei/a/a);
#if defined(_DERIVATE2)
  ve_Vci_ei_Vs_ci=((+0.0-0.0)/a-(0.0*0.0+(-Vsci_Vs_ci)*a_Vci_ei+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*a_Vci_ei*0.0/a/a/a);
  ve_Vci_ei_Vci_ei=((+0.0-0.0)/a-(0.0*a_Vci_ei+0.0*a_Vci_ei+(vf-Vsci)*a_Vci_ei_Vci_ei)/a/a+2*(vf-Vsci)*a_Vci_ei*a_Vci_ei/a/a/a);
  ve_Vci_ei_Vbi_ei=((+0.0-0.0)/a-(0.0*a_Vbi_ei+0.0*a_Vci_ei+(vf-Vsci)*a_Vci_ei_Vbi_ei)/a/a+2*(vf-Vsci)*a_Vci_ei*a_Vbi_ei/a/a/a);
  ve_Vci_ei_Vb_ci=((+0.0-0.0)/a-(0.0*a_Vb_ci+0.0*a_Vci_ei+(vf-Vsci)*a_Vci_ei_Vb_ci)/a/a+2*(vf-Vsci)*a_Vci_ei*a_Vb_ci/a/a/a);
  ve_Vci_ei_Vtnode_GND=((+0.0-0.0)/a-(0.0*a_Vtnode_GND+vf_Vtnode_GND*a_Vci_ei+(vf-Vsci)*a_Vci_ei_Vtnode_GND)/a/a+2*(vf-Vsci)*a_Vci_ei*a_Vtnode_GND/a/a/a);
  ve_Vci_ei_Vbi_ci=((+0.0-0.0)/a-(0.0*a_Vbi_ci+0.0*a_Vci_ei+(vf-Vsci)*a_Vci_ei_Vbi_ci)/a/a+2*(vf-Vsci)*a_Vci_ei*a_Vbi_ci/a/a/a);
#endif
ve_Vbi_ei=(-(vf-Vsci)*a_Vbi_ei/a/a);
#if defined(_DERIVATE2)
  ve_Vbi_ei_Vs_ci=((+0.0-0.0)/a-(0.0*0.0+(-Vsci_Vs_ci)*a_Vbi_ei+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*a_Vbi_ei*0.0/a/a/a);
  ve_Vbi_ei_Vci_ei=((+0.0-0.0)/a-(0.0*a_Vci_ei+0.0*a_Vbi_ei+(vf-Vsci)*a_Vbi_ei_Vci_ei)/a/a+2*(vf-Vsci)*a_Vbi_ei*a_Vci_ei/a/a/a);
  ve_Vbi_ei_Vbi_ei=((+0.0-0.0)/a-(0.0*a_Vbi_ei+0.0*a_Vbi_ei+(vf-Vsci)*a_Vbi_ei_Vbi_ei)/a/a+2*(vf-Vsci)*a_Vbi_ei*a_Vbi_ei/a/a/a);
  ve_Vbi_ei_Vb_ci=((+0.0-0.0)/a-(0.0*a_Vb_ci+0.0*a_Vbi_ei+(vf-Vsci)*a_Vbi_ei_Vb_ci)/a/a+2*(vf-Vsci)*a_Vbi_ei*a_Vb_ci/a/a/a);
  ve_Vbi_ei_Vtnode_GND=((+0.0-0.0)/a-(0.0*a_Vtnode_GND+vf_Vtnode_GND*a_Vbi_ei+(vf-Vsci)*a_Vbi_ei_Vtnode_GND)/a/a+2*(vf-Vsci)*a_Vbi_ei*a_Vtnode_GND/a/a/a);
  ve_Vbi_ei_Vbi_ci=((+0.0-0.0)/a-(0.0*a_Vbi_ci+0.0*a_Vbi_ei+(vf-Vsci)*a_Vbi_ei_Vbi_ci)/a/a+2*(vf-Vsci)*a_Vbi_ei*a_Vbi_ci/a/a/a);
#endif
ve_Vb_ci=(-(vf-Vsci)*a_Vb_ci/a/a);
#if defined(_DERIVATE2)
  ve_Vb_ci_Vs_ci=((+0.0-0.0)/a-(0.0*0.0+(-Vsci_Vs_ci)*a_Vb_ci+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*a_Vb_ci*0.0/a/a/a);
  ve_Vb_ci_Vci_ei=((+0.0-0.0)/a-(0.0*a_Vci_ei+0.0*a_Vb_ci+(vf-Vsci)*a_Vb_ci_Vci_ei)/a/a+2*(vf-Vsci)*a_Vb_ci*a_Vci_ei/a/a/a);
  ve_Vb_ci_Vbi_ei=((+0.0-0.0)/a-(0.0*a_Vbi_ei+0.0*a_Vb_ci+(vf-Vsci)*a_Vb_ci_Vbi_ei)/a/a+2*(vf-Vsci)*a_Vb_ci*a_Vbi_ei/a/a/a);
  ve_Vb_ci_Vb_ci=((+0.0-0.0)/a-(0.0*a_Vb_ci+0.0*a_Vb_ci+(vf-Vsci)*a_Vb_ci_Vb_ci)/a/a+2*(vf-Vsci)*a_Vb_ci*a_Vb_ci/a/a/a);
  ve_Vb_ci_Vtnode_GND=((+0.0-0.0)/a-(0.0*a_Vtnode_GND+vf_Vtnode_GND*a_Vb_ci+(vf-Vsci)*a_Vb_ci_Vtnode_GND)/a/a+2*(vf-Vsci)*a_Vb_ci*a_Vtnode_GND/a/a/a);
  ve_Vb_ci_Vbi_ci=((+0.0-0.0)/a-(0.0*a_Vbi_ci+0.0*a_Vb_ci+(vf-Vsci)*a_Vb_ci_Vbi_ci)/a/a+2*(vf-Vsci)*a_Vb_ci*a_Vbi_ci/a/a/a);
#endif
#if defined(_DERIVATE)
ve_Vtnode_GND=((vf_Vtnode_GND*a-(vf-Vsci)*a_Vtnode_GND)/a/a);
#endif
ve_Vbi_ci=(-(vf-Vsci)*a_Vbi_ci/a/a);
#if defined(_DERIVATE2)
  ve_Vbi_ci_Vs_ci=((+0.0-0.0)/a-(0.0*0.0+(-Vsci_Vs_ci)*a_Vbi_ci+(vf-Vsci)*0.0)/a/a+2*(vf-Vsci)*a_Vbi_ci*0.0/a/a/a);
  ve_Vbi_ci_Vci_ei=((+0.0-0.0)/a-(0.0*a_Vci_ei+0.0*a_Vbi_ci+(vf-Vsci)*a_Vbi_ci_Vci_ei)/a/a+2*(vf-Vsci)*a_Vbi_ci*a_Vci_ei/a/a/a);
  ve_Vbi_ci_Vbi_ei=((+0.0-0.0)/a-(0.0*a_Vbi_ei+0.0*a_Vbi_ci+(vf-Vsci)*a_Vbi_ci_Vbi_ei)/a/a+2*(vf-Vsci)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  ve_Vbi_ci_Vb_ci=((+0.0-0.0)/a-(0.0*a_Vb_ci+0.0*a_Vbi_ci+(vf-Vsci)*a_Vbi_ci_Vb_ci)/a/a+2*(vf-Vsci)*a_Vbi_ci*a_Vb_ci/a/a/a);
  ve_Vbi_ci_Vtnode_GND=((+0.0-0.0)/a-(0.0*a_Vtnode_GND+vf_Vtnode_GND*a_Vbi_ci+(vf-Vsci)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vf-Vsci)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  ve_Vbi_ci_Vbi_ci=((+0.0-0.0)/a-(0.0*a_Vbi_ci+0.0*a_Vbi_ci+(vf-Vsci)*a_Vbi_ci_Vbi_ci)/a/a+2*(vf-Vsci)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
ve=((vf-Vsci)/a);
EXIT_IF_ISNAN(((vf-Vsci)/a))
#endif
#ifdef _DYNAMIC
if
((ve<=80.0))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,ve)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=ve_Vs_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vs_ci+d10_exp0*ve_Vs_ci_Vs_ci);
  ex1_Vs_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vs_ci+d10_exp0*ve_Vs_ci_Vci_ei);
  ex1_Vs_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vs_ci+d10_exp0*ve_Vs_ci_Vbi_ei);
  ex1_Vs_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vs_ci+d10_exp0*ve_Vs_ci_Vb_ci);
  ex1_Vs_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vs_ci+d10_exp0*ve_Vs_ci_Vtnode_GND);
  ex1_Vs_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vs_ci+d10_exp0*ve_Vs_ci_Vbi_ci);
#endif
ex1_Vci_ei=ve_Vci_ei*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vci_ei+d10_exp0*ve_Vci_ei_Vs_ci);
  ex1_Vci_ei_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vci_ei+d10_exp0*ve_Vci_ei_Vci_ei);
  ex1_Vci_ei_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vci_ei+d10_exp0*ve_Vci_ei_Vbi_ei);
  ex1_Vci_ei_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vci_ei+d10_exp0*ve_Vci_ei_Vb_ci);
  ex1_Vci_ei_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vci_ei+d10_exp0*ve_Vci_ei_Vtnode_GND);
  ex1_Vci_ei_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vci_ei+d10_exp0*ve_Vci_ei_Vbi_ci);
#endif
ex1_Vbi_ei=ve_Vbi_ei*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vbi_ei+d10_exp0*ve_Vbi_ei_Vs_ci);
  ex1_Vbi_ei_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vbi_ei+d10_exp0*ve_Vbi_ei_Vci_ei);
  ex1_Vbi_ei_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vbi_ei+d10_exp0*ve_Vbi_ei_Vbi_ei);
  ex1_Vbi_ei_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vbi_ei+d10_exp0*ve_Vbi_ei_Vb_ci);
  ex1_Vbi_ei_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vbi_ei+d10_exp0*ve_Vbi_ei_Vtnode_GND);
  ex1_Vbi_ei_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vbi_ei+d10_exp0*ve_Vbi_ei_Vbi_ci);
#endif
ex1_Vb_ci=ve_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vb_ci+d10_exp0*ve_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=ve_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=ve_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(ve)*ve_Vs_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(ve)*ve_Vci_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(ve)*ve_Vbi_ei*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(ve)*ve_Vb_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(ve)*ve_Vtnode_GND*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(ve)*ve_Vbi_ci*ve_Vbi_ci+d10_exp0*ve_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=ex1_Vs_ci;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=(+0.0+ex1_Vs_ci_Vs_ci);
  ee1_Vs_ci_Vci_ei=(+0.0+ex1_Vs_ci_Vci_ei);
  ee1_Vs_ci_Vbi_ei=(+0.0+ex1_Vs_ci_Vbi_ei);
  ee1_Vs_ci_Vb_ci=(+0.0+ex1_Vs_ci_Vb_ci);
  ee1_Vs_ci_Vtnode_GND=(+0.0+ex1_Vs_ci_Vtnode_GND);
  ee1_Vs_ci_Vbi_ci=(+0.0+ex1_Vs_ci_Vbi_ci);
#endif
ee1_Vci_ei=ex1_Vci_ei;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=(+0.0+ex1_Vci_ei_Vs_ci);
  ee1_Vci_ei_Vci_ei=(+0.0+ex1_Vci_ei_Vci_ei);
  ee1_Vci_ei_Vbi_ei=(+0.0+ex1_Vci_ei_Vbi_ei);
  ee1_Vci_ei_Vb_ci=(+0.0+ex1_Vci_ei_Vb_ci);
  ee1_Vci_ei_Vtnode_GND=(+0.0+ex1_Vci_ei_Vtnode_GND);
  ee1_Vci_ei_Vbi_ci=(+0.0+ex1_Vci_ei_Vbi_ci);
#endif
ee1_Vbi_ei=ex1_Vbi_ei;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=(+0.0+ex1_Vbi_ei_Vs_ci);
  ee1_Vbi_ei_Vci_ei=(+0.0+ex1_Vbi_ei_Vci_ei);
  ee1_Vbi_ei_Vbi_ei=(+0.0+ex1_Vbi_ei_Vbi_ei);
  ee1_Vbi_ei_Vb_ci=(+0.0+ex1_Vbi_ei_Vb_ci);
  ee1_Vbi_ei_Vtnode_GND=(+0.0+ex1_Vbi_ei_Vtnode_GND);
  ee1_Vbi_ei_Vbi_ci=(+0.0+ex1_Vbi_ei_Vbi_ci);
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=(-((a_Vci_ei*d00_logE0)+(a*ee1_Vci_ei*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=(+0.0-(+a_Vci_ei_Vci_ei*d00_logE0+a_Vci_ei*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vci_ei)));
  vj1_Vci_ei_Vbi_ei=(+0.0-(+a_Vci_ei_Vbi_ei*d00_logE0+a_Vci_ei*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vbi_ei)));
  vj1_Vci_ei_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vci_ei*ee1_Vs_ci*d10_logE0+0.0*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vs_ci)));
  vj1_Vci_ei_Vb_ci=(+0.0-(+a_Vci_ei_Vb_ci*d00_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vb_ci)));
  vj1_Vci_ei_Vtnode_GND=(+0.0-(+a_Vci_ei_Vtnode_GND*d00_logE0+a_Vci_ei*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vtnode_GND)));
  vj1_Vci_ei_Vbi_ci=(+0.0-(+a_Vci_ei_Vbi_ci*d00_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vbi_ci)));
#endif
vj1_Vbi_ei=(-((a_Vbi_ei*d00_logE0)+(a*ee1_Vbi_ei*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=(+0.0-(+a_Vbi_ei_Vci_ei*d00_logE0+a_Vbi_ei*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vci_ei)));
  vj1_Vbi_ei_Vbi_ei=(+0.0-(+a_Vbi_ei_Vbi_ei*d00_logE0+a_Vbi_ei*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vbi_ei)));
  vj1_Vbi_ei_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vbi_ei*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vs_ci)));
  vj1_Vbi_ei_Vb_ci=(+0.0-(+a_Vbi_ei_Vb_ci*d00_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vb_ci)));
  vj1_Vbi_ei_Vtnode_GND=(+0.0-(+a_Vbi_ei_Vtnode_GND*d00_logE0+a_Vbi_ei*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vtnode_GND)));
  vj1_Vbi_ei_Vbi_ci=(+0.0-(+a_Vbi_ei_Vbi_ci*d00_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vbi_ci)));
#endif
vj1_Vs_ci=(-(a*ee1_Vs_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=(+0.0-(+0.0*d00_logE0+0.0*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vci_ei)));
  vj1_Vs_ci_Vbi_ei=(+0.0-(+0.0*d00_logE0+0.0*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vbi_ei)));
  vj1_Vs_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+0.0*ee1_Vs_ci*d10_logE0+0.0*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vs_ci)));
  vj1_Vs_ci_Vb_ci=(+0.0-(+0.0*d00_logE0+0.0*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vb_ci)));
  vj1_Vs_ci_Vtnode_GND=(+0.0-(+0.0*d00_logE0+0.0*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vtnode_GND)));
  vj1_Vs_ci_Vbi_ci=(+0.0-(+0.0*d00_logE0+0.0*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vbi_ci)));
#endif
vj1_Vb_ci=(-((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=(+0.0-(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj1_Vb_ci_Vbi_ei=(+0.0-(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj1_Vb_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj1_Vb_ci_Vb_ci=(+0.0-(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj1_Vb_ci_Vtnode_GND=(+0.0-(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj1_Vb_ci_Vbi_ci=(+0.0-(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=(vf_Vtnode_GND-((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj1_Vbi_ci=(-((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0)));
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=(+0.0-(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj1_Vbi_ci_Vbi_ei=(+0.0-(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj1_Vbi_ci_Vs_ci=(+0.0-(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj1_Vbi_ci_Vb_ci=(+0.0-(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj1_Vbi_ci_Vtnode_GND=(+0.0-(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj1_Vbi_ci_Vbi_ci=(+0.0-(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj1=(vf-(a*d00_logE0));
EXIT_IF_ISNAN((vf-(a*d00_logE0)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj1_Vci_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vci_ei_Vci_ei=0.0;
  vj1_Vci_ei_Vbi_ei=0.0;
  vj1_Vci_ei_Vs_ci=0.0;
  vj1_Vci_ei_Vb_ci=0.0;
  vj1_Vci_ei_Vtnode_GND=0.0;
  vj1_Vci_ei_Vbi_ci=0.0;
#endif
vj1_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ei_Vci_ei=0.0;
  vj1_Vbi_ei_Vbi_ei=0.0;
  vj1_Vbi_ei_Vs_ci=0.0;
  vj1_Vbi_ei_Vb_ci=0.0;
  vj1_Vbi_ei_Vtnode_GND=0.0;
  vj1_Vbi_ei_Vbi_ci=0.0;
#endif
vj1_Vs_ci=Vsci_Vs_ci;
#if defined(_DERIVATE2)
  vj1_Vs_ci_Vci_ei=0.0;
  vj1_Vs_ci_Vbi_ei=0.0;
  vj1_Vs_ci_Vs_ci=Vsci_Vs_ci_Vs_ci;
  vj1_Vs_ci_Vb_ci=0.0;
  vj1_Vs_ci_Vtnode_GND=0.0;
  vj1_Vs_ci_Vbi_ci=0.0;
#endif
vj1_Vb_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vb_ci_Vci_ei=0.0;
  vj1_Vb_ci_Vbi_ei=0.0;
  vj1_Vb_ci_Vs_ci=0.0;
  vj1_Vb_ci_Vb_ci=0.0;
  vj1_Vb_ci_Vtnode_GND=0.0;
  vj1_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
vj1_Vtnode_GND=0.0;
#endif
vj1_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  vj1_Vbi_ci_Vci_ei=0.0;
  vj1_Vbi_ci_Vbi_ei=0.0;
  vj1_Vbi_ci_Vs_ci=0.0;
  vj1_Vbi_ci_Vb_ci=0.0;
  vj1_Vbi_ci_Vtnode_GND=0.0;
  vj1_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
vj1=Vsci;
EXIT_IF_ISNAN(Vsci)
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
a_Vci_ei=0.0;
#if defined(_DERIVATE2)
  a_Vci_ei_Vci_ei=0.0;
  a_Vci_ei_Vbi_ei=0.0;
  a_Vci_ei_Vb_ci=0.0;
  a_Vci_ei_Vbi_ci=0.0;
  a_Vci_ei_Vtnode_GND=0.0;
#endif
a_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ei_Vci_ei=0.0;
  a_Vbi_ei_Vbi_ei=0.0;
  a_Vbi_ei_Vb_ci=0.0;
  a_Vbi_ei_Vbi_ci=0.0;
  a_Vbi_ei_Vtnode_GND=0.0;
#endif
a_Vb_ci=0.0;
#if defined(_DERIVATE2)
  a_Vb_ci_Vci_ei=0.0;
  a_Vb_ci_Vbi_ei=0.0;
  a_Vb_ci_Vb_ci=0.0;
  a_Vb_ci_Vbi_ci=0.0;
  a_Vb_ci_Vtnode_GND=0.0;
#endif
a_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  a_Vbi_ci_Vci_ei=0.0;
  a_Vbi_ci_Vbi_ei=0.0;
  a_Vbi_ci_Vb_ci=0.0;
  a_Vbi_ci_Vbi_ci=0.0;
  a_Vbi_ci_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
a_Vtnode_GND=((0.1*vp_Vtnode_GND)+(4.0*VT_Vtnode_GND));
#endif
#endif
a=((0.1*vp)+(4.0*VT));
EXIT_IF_ISNAN(((0.1*vp)+(4.0*VT)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vr_Vci_ei=((vj1_Vci_ei*a-(vp+vj1)*a_Vci_ei)/a/a);
#if defined(_DERIVATE2)
  vr_Vci_ei_Vci_ei=((+0.0+vj1_Vci_ei_Vci_ei)/a-(vj1_Vci_ei*a_Vci_ei+vj1_Vci_ei*a_Vci_ei+(vp+vj1)*a_Vci_ei_Vci_ei)/a/a+2*(vp+vj1)*a_Vci_ei*a_Vci_ei/a/a/a);
  vr_Vci_ei_Vbi_ei=((+0.0+vj1_Vci_ei_Vbi_ei)/a-(vj1_Vci_ei*a_Vbi_ei+vj1_Vbi_ei*a_Vci_ei+(vp+vj1)*a_Vci_ei_Vbi_ei)/a/a+2*(vp+vj1)*a_Vci_ei*a_Vbi_ei/a/a/a);
  vr_Vci_ei_Vs_ci=((+0.0+vj1_Vci_ei_Vs_ci)/a-(vj1_Vci_ei*0.0+vj1_Vs_ci*a_Vci_ei+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vci_ei*0.0/a/a/a);
  vr_Vci_ei_Vb_ci=((+0.0+vj1_Vci_ei_Vb_ci)/a-(vj1_Vci_ei*a_Vb_ci+vj1_Vb_ci*a_Vci_ei+(vp+vj1)*a_Vci_ei_Vb_ci)/a/a+2*(vp+vj1)*a_Vci_ei*a_Vb_ci/a/a/a);
  vr_Vci_ei_Vtnode_GND=((+0.0+vj1_Vci_ei_Vtnode_GND)/a-(vj1_Vci_ei*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vci_ei+(vp+vj1)*a_Vci_ei_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vci_ei*a_Vtnode_GND/a/a/a);
  vr_Vci_ei_Vbi_ci=((+0.0+vj1_Vci_ei_Vbi_ci)/a-(vj1_Vci_ei*a_Vbi_ci+vj1_Vbi_ci*a_Vci_ei+(vp+vj1)*a_Vci_ei_Vbi_ci)/a/a+2*(vp+vj1)*a_Vci_ei*a_Vbi_ci/a/a/a);
#endif
vr_Vbi_ei=((vj1_Vbi_ei*a-(vp+vj1)*a_Vbi_ei)/a/a);
#if defined(_DERIVATE2)
  vr_Vbi_ei_Vci_ei=((+0.0+vj1_Vbi_ei_Vci_ei)/a-(vj1_Vbi_ei*a_Vci_ei+vj1_Vci_ei*a_Vbi_ei+(vp+vj1)*a_Vbi_ei_Vci_ei)/a/a+2*(vp+vj1)*a_Vbi_ei*a_Vci_ei/a/a/a);
  vr_Vbi_ei_Vbi_ei=((+0.0+vj1_Vbi_ei_Vbi_ei)/a-(vj1_Vbi_ei*a_Vbi_ei+vj1_Vbi_ei*a_Vbi_ei+(vp+vj1)*a_Vbi_ei_Vbi_ei)/a/a+2*(vp+vj1)*a_Vbi_ei*a_Vbi_ei/a/a/a);
  vr_Vbi_ei_Vs_ci=((+0.0+vj1_Vbi_ei_Vs_ci)/a-(vj1_Vbi_ei*0.0+vj1_Vs_ci*a_Vbi_ei+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vbi_ei*0.0/a/a/a);
  vr_Vbi_ei_Vb_ci=((+0.0+vj1_Vbi_ei_Vb_ci)/a-(vj1_Vbi_ei*a_Vb_ci+vj1_Vb_ci*a_Vbi_ei+(vp+vj1)*a_Vbi_ei_Vb_ci)/a/a+2*(vp+vj1)*a_Vbi_ei*a_Vb_ci/a/a/a);
  vr_Vbi_ei_Vtnode_GND=((+0.0+vj1_Vbi_ei_Vtnode_GND)/a-(vj1_Vbi_ei*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vbi_ei+(vp+vj1)*a_Vbi_ei_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vbi_ei*a_Vtnode_GND/a/a/a);
  vr_Vbi_ei_Vbi_ci=((+0.0+vj1_Vbi_ei_Vbi_ci)/a-(vj1_Vbi_ei*a_Vbi_ci+vj1_Vbi_ci*a_Vbi_ei+(vp+vj1)*a_Vbi_ei_Vbi_ci)/a/a+2*(vp+vj1)*a_Vbi_ei*a_Vbi_ci/a/a/a);
#endif
vr_Vs_ci=(vj1_Vs_ci/a);
#if defined(_DERIVATE2)
  vr_Vs_ci_Vci_ei=((+0.0+vj1_Vs_ci_Vci_ei)/a-(vj1_Vs_ci*a_Vci_ei+vj1_Vci_ei*0.0+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*0.0*a_Vci_ei/a/a/a);
  vr_Vs_ci_Vbi_ei=((+0.0+vj1_Vs_ci_Vbi_ei)/a-(vj1_Vs_ci*a_Vbi_ei+vj1_Vbi_ei*0.0+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*0.0*a_Vbi_ei/a/a/a);
  vr_Vs_ci_Vs_ci=((+0.0+vj1_Vs_ci_Vs_ci)/a-(vj1_Vs_ci*0.0+vj1_Vs_ci*0.0+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*0.0*0.0/a/a/a);
  vr_Vs_ci_Vb_ci=((+0.0+vj1_Vs_ci_Vb_ci)/a-(vj1_Vs_ci*a_Vb_ci+vj1_Vb_ci*0.0+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*0.0*a_Vb_ci/a/a/a);
  vr_Vs_ci_Vtnode_GND=((+0.0+vj1_Vs_ci_Vtnode_GND)/a-(vj1_Vs_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*0.0+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*0.0*a_Vtnode_GND/a/a/a);
  vr_Vs_ci_Vbi_ci=((+0.0+vj1_Vs_ci_Vbi_ci)/a-(vj1_Vs_ci*a_Vbi_ci+vj1_Vbi_ci*0.0+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*0.0*a_Vbi_ci/a/a/a);
#endif
vr_Vb_ci=((vj1_Vb_ci*a-(vp+vj1)*a_Vb_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vb_ci_Vci_ei=((+0.0+vj1_Vb_ci_Vci_ei)/a-(vj1_Vb_ci*a_Vci_ei+vj1_Vci_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vci_ei/a/a/a);
  vr_Vb_ci_Vbi_ei=((+0.0+vj1_Vb_ci_Vbi_ei)/a-(vj1_Vb_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ei/a/a/a);
  vr_Vb_ci_Vs_ci=((+0.0+vj1_Vb_ci_Vs_ci)/a-(vj1_Vb_ci*0.0+vj1_Vs_ci*a_Vb_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vb_ci*0.0/a/a/a);
  vr_Vb_ci_Vb_ci=((+0.0+vj1_Vb_ci_Vb_ci)/a-(vj1_Vb_ci*a_Vb_ci+vj1_Vb_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vb_ci/a/a/a);
  vr_Vb_ci_Vtnode_GND=((+0.0+vj1_Vb_ci_Vtnode_GND)/a-(vj1_Vb_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vtnode_GND/a/a/a);
  vr_Vb_ci_Vbi_ci=((+0.0+vj1_Vb_ci_Vbi_ci)/a-(vj1_Vb_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vb_ci+(vp+vj1)*a_Vb_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vb_ci*a_Vbi_ci/a/a/a);
#endif
#if defined(_DERIVATE)
vr_Vtnode_GND=(((vp_Vtnode_GND+vj1_Vtnode_GND)*a-(vp+vj1)*a_Vtnode_GND)/a/a);
#endif
vr_Vbi_ci=((vj1_Vbi_ci*a-(vp+vj1)*a_Vbi_ci)/a/a);
#if defined(_DERIVATE2)
  vr_Vbi_ci_Vci_ei=((+0.0+vj1_Vbi_ci_Vci_ei)/a-(vj1_Vbi_ci*a_Vci_ei+vj1_Vci_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vci_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vci_ei/a/a/a);
  vr_Vbi_ci_Vbi_ei=((+0.0+vj1_Vbi_ci_Vbi_ei)/a-(vj1_Vbi_ci*a_Vbi_ei+vj1_Vbi_ei*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ei)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ei/a/a/a);
  vr_Vbi_ci_Vs_ci=((+0.0+vj1_Vbi_ci_Vs_ci)/a-(vj1_Vbi_ci*0.0+vj1_Vs_ci*a_Vbi_ci+(vp+vj1)*0.0)/a/a+2*(vp+vj1)*a_Vbi_ci*0.0/a/a/a);
  vr_Vbi_ci_Vb_ci=((+0.0+vj1_Vbi_ci_Vb_ci)/a-(vj1_Vbi_ci*a_Vb_ci+vj1_Vb_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vb_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vb_ci/a/a/a);
  vr_Vbi_ci_Vtnode_GND=((+0.0+vj1_Vbi_ci_Vtnode_GND)/a-(vj1_Vbi_ci*a_Vtnode_GND+(vp_Vtnode_GND+vj1_Vtnode_GND)*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vtnode_GND)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vtnode_GND/a/a/a);
  vr_Vbi_ci_Vbi_ci=((+0.0+vj1_Vbi_ci_Vbi_ci)/a-(vj1_Vbi_ci*a_Vbi_ci+vj1_Vbi_ci*a_Vbi_ci+(vp+vj1)*a_Vbi_ci_Vbi_ci)/a/a+2*(vp+vj1)*a_Vbi_ci*a_Vbi_ci/a/a/a);
#endif
#endif
vr=((vp+vj1)/a);
EXIT_IF_ISNAN(((vp+vj1)/a))
#endif
#ifdef _DYNAMIC
if
((vr<=80.0))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,vr)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
ex1_Vs_ci=vr_Vs_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vs_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vs_ci+d10_exp0*vr_Vs_ci_Vs_ci);
  ex1_Vs_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vs_ci+d10_exp0*vr_Vs_ci_Vci_ei);
  ex1_Vs_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vs_ci+d10_exp0*vr_Vs_ci_Vbi_ei);
  ex1_Vs_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vs_ci+d10_exp0*vr_Vs_ci_Vb_ci);
  ex1_Vs_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vs_ci+d10_exp0*vr_Vs_ci_Vtnode_GND);
  ex1_Vs_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vs_ci+d10_exp0*vr_Vs_ci_Vbi_ci);
#endif
ex1_Vci_ei=vr_Vci_ei*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vci_ei_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vci_ei+d10_exp0*vr_Vci_ei_Vs_ci);
  ex1_Vci_ei_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vci_ei+d10_exp0*vr_Vci_ei_Vci_ei);
  ex1_Vci_ei_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vci_ei+d10_exp0*vr_Vci_ei_Vbi_ei);
  ex1_Vci_ei_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vci_ei+d10_exp0*vr_Vci_ei_Vb_ci);
  ex1_Vci_ei_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vci_ei+d10_exp0*vr_Vci_ei_Vtnode_GND);
  ex1_Vci_ei_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vci_ei+d10_exp0*vr_Vci_ei_Vbi_ci);
#endif
ex1_Vbi_ei=vr_Vbi_ei*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ei_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vbi_ei+d10_exp0*vr_Vbi_ei_Vs_ci);
  ex1_Vbi_ei_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vbi_ei+d10_exp0*vr_Vbi_ei_Vci_ei);
  ex1_Vbi_ei_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vbi_ei+d10_exp0*vr_Vbi_ei_Vbi_ei);
  ex1_Vbi_ei_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vbi_ei+d10_exp0*vr_Vbi_ei_Vb_ci);
  ex1_Vbi_ei_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vbi_ei+d10_exp0*vr_Vbi_ei_Vtnode_GND);
  ex1_Vbi_ei_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vbi_ei+d10_exp0*vr_Vbi_ei_Vbi_ci);
#endif
ex1_Vb_ci=vr_Vb_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vb_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vs_ci);
  ex1_Vb_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vci_ei);
  ex1_Vb_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ei);
  ex1_Vb_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vb_ci);
  ex1_Vb_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vtnode_GND);
  ex1_Vb_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vb_ci+d10_exp0*vr_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ex1_Vtnode_GND=vr_Vtnode_GND*d10_exp0;
#endif
ex1_Vbi_ci=vr_Vbi_ci*d10_exp0;
#if defined(_DERIVATE2)
  ex1_Vbi_ci_Vs_ci=(m20_exp(vr)*vr_Vs_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vs_ci);
  ex1_Vbi_ci_Vci_ei=(m20_exp(vr)*vr_Vci_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vci_ei);
  ex1_Vbi_ci_Vbi_ei=(m20_exp(vr)*vr_Vbi_ei*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ei);
  ex1_Vbi_ci_Vb_ci=(m20_exp(vr)*vr_Vb_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vb_ci);
  ex1_Vbi_ci_Vtnode_GND=(m20_exp(vr)*vr_Vtnode_GND*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vtnode_GND);
  ex1_Vbi_ci_Vbi_ci=(m20_exp(vr)*vr_Vbi_ci*vr_Vbi_ci+d10_exp0*vr_Vbi_ci_Vbi_ci);
#endif
#endif
ex1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
ee1_Vs_ci=ex1_Vs_ci;
#if defined(_DERIVATE2)
  ee1_Vs_ci_Vs_ci=(+0.0+ex1_Vs_ci_Vs_ci);
  ee1_Vs_ci_Vci_ei=(+0.0+ex1_Vs_ci_Vci_ei);
  ee1_Vs_ci_Vbi_ei=(+0.0+ex1_Vs_ci_Vbi_ei);
  ee1_Vs_ci_Vb_ci=(+0.0+ex1_Vs_ci_Vb_ci);
  ee1_Vs_ci_Vtnode_GND=(+0.0+ex1_Vs_ci_Vtnode_GND);
  ee1_Vs_ci_Vbi_ci=(+0.0+ex1_Vs_ci_Vbi_ci);
#endif
ee1_Vci_ei=ex1_Vci_ei;
#if defined(_DERIVATE2)
  ee1_Vci_ei_Vs_ci=(+0.0+ex1_Vci_ei_Vs_ci);
  ee1_Vci_ei_Vci_ei=(+0.0+ex1_Vci_ei_Vci_ei);
  ee1_Vci_ei_Vbi_ei=(+0.0+ex1_Vci_ei_Vbi_ei);
  ee1_Vci_ei_Vb_ci=(+0.0+ex1_Vci_ei_Vb_ci);
  ee1_Vci_ei_Vtnode_GND=(+0.0+ex1_Vci_ei_Vtnode_GND);
  ee1_Vci_ei_Vbi_ci=(+0.0+ex1_Vci_ei_Vbi_ci);
#endif
ee1_Vbi_ei=ex1_Vbi_ei;
#if defined(_DERIVATE2)
  ee1_Vbi_ei_Vs_ci=(+0.0+ex1_Vbi_ei_Vs_ci);
  ee1_Vbi_ei_Vci_ei=(+0.0+ex1_Vbi_ei_Vci_ei);
  ee1_Vbi_ei_Vbi_ei=(+0.0+ex1_Vbi_ei_Vbi_ei);
  ee1_Vbi_ei_Vb_ci=(+0.0+ex1_Vbi_ei_Vb_ci);
  ee1_Vbi_ei_Vtnode_GND=(+0.0+ex1_Vbi_ei_Vtnode_GND);
  ee1_Vbi_ei_Vbi_ci=(+0.0+ex1_Vbi_ei_Vbi_ci);
#endif
ee1_Vb_ci=ex1_Vb_ci;
#if defined(_DERIVATE2)
  ee1_Vb_ci_Vs_ci=(+0.0+ex1_Vb_ci_Vs_ci);
  ee1_Vb_ci_Vci_ei=(+0.0+ex1_Vb_ci_Vci_ei);
  ee1_Vb_ci_Vbi_ei=(+0.0+ex1_Vb_ci_Vbi_ei);
  ee1_Vb_ci_Vb_ci=(+0.0+ex1_Vb_ci_Vb_ci);
  ee1_Vb_ci_Vtnode_GND=(+0.0+ex1_Vb_ci_Vtnode_GND);
  ee1_Vb_ci_Vbi_ci=(+0.0+ex1_Vb_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
ee1_Vtnode_GND=ex1_Vtnode_GND;
#endif
ee1_Vbi_ci=ex1_Vbi_ci;
#if defined(_DERIVATE2)
  ee1_Vbi_ci_Vs_ci=(+0.0+ex1_Vbi_ci_Vs_ci);
  ee1_Vbi_ci_Vci_ei=(+0.0+ex1_Vbi_ci_Vci_ei);
  ee1_Vbi_ci_Vbi_ei=(+0.0+ex1_Vbi_ci_Vbi_ei);
  ee1_Vbi_ci_Vb_ci=(+0.0+ex1_Vbi_ci_Vb_ci);
  ee1_Vbi_ci_Vtnode_GND=(+0.0+ex1_Vbi_ci_Vtnode_GND);
  ee1_Vbi_ci_Vbi_ci=(+0.0+ex1_Vbi_ci_Vbi_ci);
#endif
#endif
ee1=(1.0+ex1);
EXIT_IF_ISNAN((1.0+ex1))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,ee1)
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,ee1)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=((a_Vci_ei*d00_logE0)+(a*ee1_Vci_ei*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=(+0.0+(+a_Vci_ei_Vci_ei*d00_logE0+a_Vci_ei*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vci_ei)));
  vj2_Vci_ei_Vbi_ei=(+0.0+(+a_Vci_ei_Vbi_ei*d00_logE0+a_Vci_ei*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vbi_ei)));
  vj2_Vci_ei_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vci_ei*ee1_Vs_ci*d10_logE0+0.0*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vs_ci)));
  vj2_Vci_ei_Vb_ci=(+0.0+(+a_Vci_ei_Vb_ci*d00_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vb_ci)));
  vj2_Vci_ei_Vtnode_GND=(+0.0+(+a_Vci_ei_Vtnode_GND*d00_logE0+a_Vci_ei*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vtnode_GND)));
  vj2_Vci_ei_Vbi_ci=(+0.0+(+a_Vci_ei_Vbi_ci*d00_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vci_ei+d10_logE0*ee1_Vci_ei_Vbi_ci)));
#endif
vj2_Vbi_ei=((a_Vbi_ei*d00_logE0)+(a*ee1_Vbi_ei*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=(+0.0+(+a_Vbi_ei_Vci_ei*d00_logE0+a_Vbi_ei*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vci_ei)));
  vj2_Vbi_ei_Vbi_ei=(+0.0+(+a_Vbi_ei_Vbi_ei*d00_logE0+a_Vbi_ei*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vbi_ei)));
  vj2_Vbi_ei_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vbi_ei*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vs_ci)));
  vj2_Vbi_ei_Vb_ci=(+0.0+(+a_Vbi_ei_Vb_ci*d00_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vb_ci)));
  vj2_Vbi_ei_Vtnode_GND=(+0.0+(+a_Vbi_ei_Vtnode_GND*d00_logE0+a_Vbi_ei*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vtnode_GND)));
  vj2_Vbi_ei_Vbi_ci=(+0.0+(+a_Vbi_ei_Vbi_ci*d00_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ei+d10_logE0*ee1_Vbi_ei_Vbi_ci)));
#endif
vj2_Vs_ci=(a*ee1_Vs_ci*d10_logE0);
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=(+0.0+(+0.0*d00_logE0+0.0*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vci_ei)));
  vj2_Vs_ci_Vbi_ei=(+0.0+(+0.0*d00_logE0+0.0*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vbi_ei)));
  vj2_Vs_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+0.0*ee1_Vs_ci*d10_logE0+0.0*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vs_ci)));
  vj2_Vs_ci_Vb_ci=(+0.0+(+0.0*d00_logE0+0.0*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vb_ci)));
  vj2_Vs_ci_Vtnode_GND=(+0.0+(+0.0*d00_logE0+0.0*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vtnode_GND)));
  vj2_Vs_ci_Vbi_ci=(+0.0+(+0.0*d00_logE0+0.0*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vs_ci+d10_logE0*ee1_Vs_ci_Vbi_ci)));
#endif
vj2_Vb_ci=((a_Vb_ci*d00_logE0)+(a*ee1_Vb_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=(+0.0+(+a_Vb_ci_Vci_ei*d00_logE0+a_Vb_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vci_ei)));
  vj2_Vb_ci_Vbi_ei=(+0.0+(+a_Vb_ci_Vbi_ei*d00_logE0+a_Vb_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ei)));
  vj2_Vb_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vb_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vs_ci)));
  vj2_Vb_ci_Vb_ci=(+0.0+(+a_Vb_ci_Vb_ci*d00_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vb_ci)));
  vj2_Vb_ci_Vtnode_GND=(+0.0+(+a_Vb_ci_Vtnode_GND*d00_logE0+a_Vb_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vtnode_GND)));
  vj2_Vb_ci_Vbi_ci=(+0.0+(+a_Vb_ci_Vbi_ci*d00_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vb_ci+d10_logE0*ee1_Vb_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=((-vp_Vtnode_GND)+((a_Vtnode_GND*d00_logE0)+(a*ee1_Vtnode_GND*d10_logE0)));
#endif
vj2_Vbi_ci=((a_Vbi_ci*d00_logE0)+(a*ee1_Vbi_ci*d10_logE0));
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=(+0.0+(+a_Vbi_ci_Vci_ei*d00_logE0+a_Vbi_ci*ee1_Vci_ei*d10_logE0+a_Vci_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vci_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vci_ei)));
  vj2_Vbi_ci_Vbi_ei=(+0.0+(+a_Vbi_ci_Vbi_ei*d00_logE0+a_Vbi_ci*ee1_Vbi_ei*d10_logE0+a_Vbi_ei*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ei*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ei)));
  vj2_Vbi_ci_Vs_ci=(+0.0+(+0.0*d00_logE0+a_Vbi_ci*ee1_Vs_ci*d10_logE0+0.0*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vs_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vs_ci)));
  vj2_Vbi_ci_Vb_ci=(+0.0+(+a_Vbi_ci_Vb_ci*d00_logE0+a_Vbi_ci*ee1_Vb_ci*d10_logE0+a_Vb_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vb_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vb_ci)));
  vj2_Vbi_ci_Vtnode_GND=(+0.0+(+a_Vbi_ci_Vtnode_GND*d00_logE0+a_Vbi_ci*ee1_Vtnode_GND*d10_logE0+a_Vtnode_GND*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vtnode_GND*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vtnode_GND)));
  vj2_Vbi_ci_Vbi_ci=(+0.0+(+a_Vbi_ci_Vbi_ci*d00_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a_Vbi_ci*ee1_Vbi_ci*d10_logE0+a*(m20_logE(ee1)*ee1_Vbi_ci*ee1_Vbi_ci+d10_logE0*ee1_Vbi_ci_Vbi_ci)));
#endif
#endif
vj2=((-vp)+(a*d00_logE0));
EXIT_IF_ISNAN(((-vp)+(a*d00_logE0)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj2_Vci_ei=vj1_Vci_ei;
#if defined(_DERIVATE2)
  vj2_Vci_ei_Vci_ei=vj1_Vci_ei_Vci_ei;
  vj2_Vci_ei_Vbi_ei=vj1_Vci_ei_Vbi_ei;
  vj2_Vci_ei_Vs_ci=vj1_Vci_ei_Vs_ci;
  vj2_Vci_ei_Vb_ci=vj1_Vci_ei_Vb_ci;
  vj2_Vci_ei_Vtnode_GND=vj1_Vci_ei_Vtnode_GND;
  vj2_Vci_ei_Vbi_ci=vj1_Vci_ei_Vbi_ci;
#endif
vj2_Vbi_ei=vj1_Vbi_ei;
#if defined(_DERIVATE2)
  vj2_Vbi_ei_Vci_ei=vj1_Vbi_ei_Vci_ei;
  vj2_Vbi_ei_Vbi_ei=vj1_Vbi_ei_Vbi_ei;
  vj2_Vbi_ei_Vs_ci=vj1_Vbi_ei_Vs_ci;
  vj2_Vbi_ei_Vb_ci=vj1_Vbi_ei_Vb_ci;
  vj2_Vbi_ei_Vtnode_GND=vj1_Vbi_ei_Vtnode_GND;
  vj2_Vbi_ei_Vbi_ci=vj1_Vbi_ei_Vbi_ci;
#endif
vj2_Vs_ci=vj1_Vs_ci;
#if defined(_DERIVATE2)
  vj2_Vs_ci_Vci_ei=vj1_Vs_ci_Vci_ei;
  vj2_Vs_ci_Vbi_ei=vj1_Vs_ci_Vbi_ei;
  vj2_Vs_ci_Vs_ci=vj1_Vs_ci_Vs_ci;
  vj2_Vs_ci_Vb_ci=vj1_Vs_ci_Vb_ci;
  vj2_Vs_ci_Vtnode_GND=vj1_Vs_ci_Vtnode_GND;
  vj2_Vs_ci_Vbi_ci=vj1_Vs_ci_Vbi_ci;
#endif
vj2_Vb_ci=vj1_Vb_ci;
#if defined(_DERIVATE2)
  vj2_Vb_ci_Vci_ei=vj1_Vb_ci_Vci_ei;
  vj2_Vb_ci_Vbi_ei=vj1_Vb_ci_Vbi_ei;
  vj2_Vb_ci_Vs_ci=vj1_Vb_ci_Vs_ci;
  vj2_Vb_ci_Vb_ci=vj1_Vb_ci_Vb_ci;
  vj2_Vb_ci_Vtnode_GND=vj1_Vb_ci_Vtnode_GND;
  vj2_Vb_ci_Vbi_ci=vj1_Vb_ci_Vbi_ci;
#endif
#if defined(_DERIVATE)
vj2_Vtnode_GND=vj1_Vtnode_GND;
#endif
vj2_Vbi_ci=vj1_Vbi_ci;
#if defined(_DERIVATE2)
  vj2_Vbi_ci_Vci_ei=vj1_Vbi_ci_Vci_ei;
  vj2_Vbi_ci_Vbi_ei=vj1_Vbi_ci_Vbi_ei;
  vj2_Vbi_ci_Vs_ci=vj1_Vbi_ci_Vs_ci;
  vj2_Vbi_ci_Vb_ci=vj1_Vbi_ci_Vb_ci;
  vj2_Vbi_ci_Vtnode_GND=vj1_Vbi_ci_Vtnode_GND;
  vj2_Vbi_ci_Vbi_ci=vj1_Vbi_ci_Vbi_ci;
#endif
#endif
vj2=vj1;
EXIT_IF_ISNAN(vj1)
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(tnode,GND) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
vj4_Vs_ci=(Vsci_Vs_ci-vj1_Vs_ci);
#if defined(_DERIVATE2)
  vj4_Vs_ci_Vs_ci=(+Vsci_Vs_ci_Vs_ci-vj1_Vs_ci_Vs_ci);
  vj4_Vs_ci_Vci_ei=(+0.0-vj1_Vs_ci_Vci_ei);
  vj4_Vs_ci_Vbi_ei=(+0.0-vj1_Vs_ci_Vbi_ei);
  vj4_Vs_ci_Vb_ci=(+0.0-vj1_Vs_ci_Vb_ci);
  vj4_Vs_ci_Vbi_ci=(+0.0-vj1_Vs_ci_Vbi_ci);
  vj4_Vs_ci_Vtnode_GND=(+0.0-vj1_Vs_ci_Vtnode_GND);
#endif
vj4_Vci_ei=(-vj1_Vci_ei);
#if defined(_DERIVATE2)
  vj4_Vci_ei_Vs_ci=(+0.0-vj1_Vci_ei_Vs_ci);
  vj4_Vci_ei_Vci_ei=(+0.0-vj1_Vci_ei_Vci_ei);
  vj4_Vci_ei_Vbi_ei=(+0.0-vj1_Vci_ei_Vbi_ei);
  vj4_Vci_ei_Vb_ci=(+0.0-vj1_Vci_ei_Vb_ci);
  vj4_Vci_ei_Vbi_ci=(+0.0-vj1_Vci_ei_Vbi_ci);
  vj4_Vci_ei_Vtnode_GND=(+0.0-vj1_Vci_ei_Vtnode_GND);
#endif
vj4_Vbi_ei=(-vj1_Vbi_ei);
#if defined(_DERIVATE2)
  vj4_Vbi_ei_Vs_ci=(+0.0-vj1_Vbi_ei_Vs_ci);
  vj4_Vbi_ei_Vci_ei=(+0.0-vj1_Vbi_ei_Vci_ei);
  vj4_Vbi_ei_Vbi_ei=(+0.0-vj1_Vbi_ei_Vbi_ei);
  vj4_Vbi_ei_Vb_ci=(+0.0-vj1_Vbi_ei_Vb_ci);
  vj4_Vbi_ei_Vbi_ci=(+0.0-vj1_Vbi_ei_Vbi_ci);
  vj4_Vbi_ei_Vtnode_GND=(+0.0-vj1_Vbi_ei_Vtnode_GND);
#endif
vj4_Vb_ci=(-vj1_Vb_ci);
#if defined(_DERIVATE2)
  vj4_Vb_ci_Vs_ci=(+0.0-vj1_Vb_ci_Vs_ci);
  vj4_Vb_ci_Vci_ei=(+0.0-vj1_Vb_ci_Vci_ei);
  vj4_Vb_ci_Vbi_ei=(+0.0-vj1_Vb_ci_Vbi_ei);
  vj4_Vb_ci_Vb_ci=(+0.0-vj1_Vb_ci_Vb_ci);
  vj4_Vb_ci_Vbi_ci=(+0.0-vj1_Vb_ci_Vbi_ci);
  vj4_Vb_ci_Vtnode_GND=(+0.0-vj1_Vb_ci_Vtnode_GND);
#endif
vj4_Vbi_ci=(-vj1_Vbi_ci);
#if defined(_DERIVATE2)
  vj4_Vbi_ci_Vs_ci=(+0.0-vj1_Vbi_ci_Vs_ci);
  vj4_Vbi_ci_Vci_ei=(+0.0-vj1_Vbi_ci_Vci_ei);
  vj4_Vbi_ci_Vbi_ei=(+0.0-vj1_Vbi_ci_Vbi_ei);
  vj4_Vbi_ci_Vb_ci=(+0.0-vj1_Vbi_ci_Vb_ci);
  vj4_Vbi_ci_Vbi_ci=(+0.0-vj1_Vbi_ci_Vbi_ci);
  vj4_Vbi_ci_Vtnode_GND=(+0.0-vj1_Vbi_ci_Vtnode_GND);
#endif
#if defined(_DERIVATE)
vj4_Vtnode_GND=(-vj1_Vtnode_GND);
#endif
#endif
vj4=(Vsci-vj1);
EXIT_IF_ISNAN((Vsci-vj1))
#endif
#if defined(_DYNAMIC)
ez=(1.0-pModel->zs);
EXIT_IF_ISNAN((1.0-pModel->zs))
#endif
#if defined(_DYNAMIC)
ezr=(1.0-zr);
EXIT_IF_ISNAN((1.0-zr))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(1.0-(vj1/vds_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj1/vds_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj1_Vci_ei=(-(vj1_Vci_ei/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vci_ei_Vci_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vci_ei/vds_t))*(-(vj1_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vci_ei_Vci_ei/vds_t-(vj1_Vci_ei*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vci_ei_Vbi_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ei/vds_t))*(-(vj1_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vci_ei_Vbi_ei/vds_t-(vj1_Vci_ei*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vci_ei_Vs_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vs_ci/vds_t))*(-(vj1_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vci_ei_Vs_ci/vds_t-(vj1_Vci_ei*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vci_ei_Vb_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vb_ci/vds_t))*(-(vj1_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vci_ei_Vb_ci/vds_t-(vj1_Vci_ei*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vci_ei_Vtnode_GND=(m20_logE((1.0-(vj1/vds_t)))*(-((vj1_Vtnode_GND*vds_t-vj1*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj1_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vci_ei_Vtnode_GND/vds_t-(vj1_Vci_ei*vds_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj1_Vci_ei_Vbi_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ci/vds_t))*(-(vj1_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vci_ei_Vbi_ci/vds_t-(vj1_Vci_ei*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
vdj1_Vbi_ei=(-(vj1_Vbi_ei/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ei_Vci_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vci_ei/vds_t))*(-(vj1_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ei_Vci_ei/vds_t-(vj1_Vbi_ei*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ei_Vbi_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ei/vds_t))*(-(vj1_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ei_Vbi_ei/vds_t-(vj1_Vbi_ei*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ei_Vs_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vs_ci/vds_t))*(-(vj1_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ei_Vs_ci/vds_t-(vj1_Vbi_ei*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ei_Vb_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vb_ci/vds_t))*(-(vj1_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ei_Vb_ci/vds_t-(vj1_Vbi_ei*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ei_Vtnode_GND=(m20_logE((1.0-(vj1/vds_t)))*(-((vj1_Vtnode_GND*vds_t-vj1*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj1_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ei_Vtnode_GND/vds_t-(vj1_Vbi_ei*vds_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ei_Vbi_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ci/vds_t))*(-(vj1_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ei_Vbi_ci/vds_t-(vj1_Vbi_ei*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
vdj1_Vs_ci=(-(vj1_Vs_ci/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vs_ci_Vci_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vci_ei/vds_t))*(-(vj1_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vs_ci_Vci_ei/vds_t-(vj1_Vs_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vs_ci_Vbi_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ei/vds_t))*(-(vj1_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vs_ci_Vbi_ei/vds_t-(vj1_Vs_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vs_ci_Vs_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vs_ci/vds_t))*(-(vj1_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vs_ci_Vs_ci/vds_t-(vj1_Vs_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vs_ci_Vb_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vb_ci/vds_t))*(-(vj1_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vs_ci_Vb_ci/vds_t-(vj1_Vs_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vs_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vds_t)))*(-((vj1_Vtnode_GND*vds_t-vj1*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj1_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vs_ci_Vtnode_GND/vds_t-(vj1_Vs_ci*vds_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj1_Vs_ci_Vbi_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ci/vds_t))*(-(vj1_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vs_ci_Vbi_ci/vds_t-(vj1_Vs_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
vdj1_Vb_ci=(-(vj1_Vb_ci/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vb_ci_Vci_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vci_ei/vds_t))*(-(vj1_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vci_ei/vds_t-(vj1_Vb_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ei/vds_t))*(-(vj1_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ei/vds_t-(vj1_Vb_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vb_ci_Vs_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vs_ci/vds_t))*(-(vj1_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vs_ci/vds_t-(vj1_Vb_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vb_ci_Vb_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vb_ci/vds_t))*(-(vj1_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vb_ci/vds_t-(vj1_Vb_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vds_t)))*(-((vj1_Vtnode_GND*vds_t-vj1*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj1_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vtnode_GND/vds_t-(vj1_Vb_ci*vds_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj1_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ci/vds_t))*(-(vj1_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vb_ci_Vbi_ci/vds_t-(vj1_Vb_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
#if defined(_DERIVATE)
vdj1_Vtnode_GND=(-((vj1_Vtnode_GND*vds_t-vj1*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0;
#endif
vdj1_Vbi_ci=(-(vj1_Vbi_ci/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj1_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vci_ei/vds_t))*(-(vj1_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vci_ei/vds_t-(vj1_Vbi_ci*0.0+vj1_Vci_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ei/vds_t))*(-(vj1_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ei/vds_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ei*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vs_ci/vds_t))*(-(vj1_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vs_ci/vds_t-(vj1_Vbi_ci*0.0+vj1_Vs_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vb_ci/vds_t))*(-(vj1_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vb_ci/vds_t-(vj1_Vbi_ci*0.0+vj1_Vb_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj1/vds_t)))*(-((vj1_Vtnode_GND*vds_t-vj1*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj1_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vtnode_GND/vds_t-(vj1_Vbi_ci*vds_t_Vtnode_GND+vj1_Vtnode_GND*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj1_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj1/vds_t)))*(-(vj1_Vbi_ci/vds_t))*(-(vj1_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj1_Vbi_ci_Vbi_ci/vds_t-(vj1_Vbi_ci*0.0+vj1_Vbi_ci*0.0+vj1*0.0)/vds_t/vds_t+2*vj1*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
#endif
vdj1=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(1.0-(vj2/vds_t)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(vj2/vds_t)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(bi,GND)V(ei,GND)V(s,GND) */
vdj2_Vci_ei=(-(vj2_Vci_ei/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vci_ei_Vci_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vci_ei/vds_t))*(-(vj2_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vci_ei_Vci_ei/vds_t-(vj2_Vci_ei*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vci_ei_Vbi_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ei/vds_t))*(-(vj2_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vci_ei_Vbi_ei/vds_t-(vj2_Vci_ei*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vci_ei_Vs_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vs_ci/vds_t))*(-(vj2_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vci_ei_Vs_ci/vds_t-(vj2_Vci_ei*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vci_ei_Vb_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vb_ci/vds_t))*(-(vj2_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vci_ei_Vb_ci/vds_t-(vj2_Vci_ei*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vci_ei_Vtnode_GND=(m20_logE((1.0-(vj2/vds_t)))*(-((vj2_Vtnode_GND*vds_t-vj2*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj2_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vci_ei_Vtnode_GND/vds_t-(vj2_Vci_ei*vds_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj2_Vci_ei_Vbi_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ci/vds_t))*(-(vj2_Vci_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vci_ei_Vbi_ci/vds_t-(vj2_Vci_ei*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
vdj2_Vbi_ei=(-(vj2_Vbi_ei/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ei_Vci_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vci_ei/vds_t))*(-(vj2_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ei_Vci_ei/vds_t-(vj2_Vbi_ei*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ei_Vbi_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ei/vds_t))*(-(vj2_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ei_Vbi_ei/vds_t-(vj2_Vbi_ei*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ei_Vs_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vs_ci/vds_t))*(-(vj2_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ei_Vs_ci/vds_t-(vj2_Vbi_ei*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ei_Vb_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vb_ci/vds_t))*(-(vj2_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ei_Vb_ci/vds_t-(vj2_Vbi_ei*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ei_Vtnode_GND=(m20_logE((1.0-(vj2/vds_t)))*(-((vj2_Vtnode_GND*vds_t-vj2*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj2_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ei_Vtnode_GND/vds_t-(vj2_Vbi_ei*vds_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ei_Vbi_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ci/vds_t))*(-(vj2_Vbi_ei/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ei_Vbi_ci/vds_t-(vj2_Vbi_ei*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
vdj2_Vs_ci=(-(vj2_Vs_ci/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vs_ci_Vci_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vci_ei/vds_t))*(-(vj2_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vs_ci_Vci_ei/vds_t-(vj2_Vs_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vs_ci_Vbi_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ei/vds_t))*(-(vj2_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vs_ci_Vbi_ei/vds_t-(vj2_Vs_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vs_ci_Vs_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vs_ci/vds_t))*(-(vj2_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vs_ci_Vs_ci/vds_t-(vj2_Vs_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vs_ci_Vb_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vb_ci/vds_t))*(-(vj2_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vs_ci_Vb_ci/vds_t-(vj2_Vs_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vs_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vds_t)))*(-((vj2_Vtnode_GND*vds_t-vj2*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj2_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vs_ci_Vtnode_GND/vds_t-(vj2_Vs_ci*vds_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj2_Vs_ci_Vbi_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ci/vds_t))*(-(vj2_Vs_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vs_ci_Vbi_ci/vds_t-(vj2_Vs_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
vdj2_Vb_ci=(-(vj2_Vb_ci/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vb_ci_Vci_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vci_ei/vds_t))*(-(vj2_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vci_ei/vds_t-(vj2_Vb_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vb_ci_Vbi_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ei/vds_t))*(-(vj2_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ei/vds_t-(vj2_Vb_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vb_ci_Vs_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vs_ci/vds_t))*(-(vj2_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vs_ci/vds_t-(vj2_Vb_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vb_ci_Vb_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vb_ci/vds_t))*(-(vj2_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vb_ci/vds_t-(vj2_Vb_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vb_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vds_t)))*(-((vj2_Vtnode_GND*vds_t-vj2*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj2_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vtnode_GND/vds_t-(vj2_Vb_ci*vds_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj2_Vb_ci_Vbi_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ci/vds_t))*(-(vj2_Vb_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vb_ci_Vbi_ci/vds_t-(vj2_Vb_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
#if defined(_DERIVATE)
vdj2_Vtnode_GND=(-((vj2_Vtnode_GND*vds_t-vj2*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0;
#endif
vdj2_Vbi_ci=(-(vj2_Vbi_ci/vds_t))*d10_logE0;
#if defined(_DERIVATE2)
  vdj2_Vbi_ci_Vci_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vci_ei/vds_t))*(-(vj2_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vci_ei/vds_t-(vj2_Vbi_ci*0.0+vj2_Vci_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ci_Vbi_ei=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ei/vds_t))*(-(vj2_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ei/vds_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ei*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ci_Vs_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vs_ci/vds_t))*(-(vj2_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vs_ci/vds_t-(vj2_Vbi_ci*0.0+vj2_Vs_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ci_Vb_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vb_ci/vds_t))*(-(vj2_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vb_ci/vds_t-(vj2_Vbi_ci*0.0+vj2_Vb_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ci_Vtnode_GND=(m20_logE((1.0-(vj2/vds_t)))*(-((vj2_Vtnode_GND*vds_t-vj2*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(vj2_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vtnode_GND/vds_t-(vj2_Vbi_ci*vds_t_Vtnode_GND+vj2_Vtnode_GND*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t)));
  vdj2_Vbi_ci_Vbi_ci=(m20_logE((1.0-(vj2/vds_t)))*(-(vj2_Vbi_ci/vds_t))*(-(vj2_Vbi_ci/vds_t))+d10_logE0*(+0.0-(vj2_Vbi_ci_Vbi_ci/vds_t-(vj2_Vbi_ci*0.0+vj2_Vbi_ci*0.0+vj2*0.0)/vds_t/vds_t+2*vj2*0.0*0.0/vds_t/vds_t/vds_t)));
#endif
#endif
vdj2=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
#endif
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(vdj2*ez))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj1_Vci_ei=((cjs0_t*(-vdj2_Vci_ei*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vci_ei_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vci_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vci_ei*ez+d10_exp0*(+vdj2_Vci_ei_Vci_ei*ez+vdj2_Vci_ei*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vci_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vci_ei_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vci_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vci_ei*ez+d10_exp0*(+vdj2_Vci_ei_Vbi_ei*ez+vdj2_Vci_ei*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vci_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vci_ei_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vci_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vci_ei*ez+d10_exp0*(+vdj2_Vci_ei_Vs_ci*ez+vdj2_Vci_ei*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vci_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vci_ei_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vci_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vci_ei*ez+d10_exp0*(+vdj2_Vci_ei_Vb_ci*ez+vdj2_Vci_ei*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vci_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vci_ei_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjs0_t_Vtnode_GND*(-vdj2_Vci_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vci_ei*ez+d10_exp0*(+vdj2_Vci_ei_Vtnode_GND*ez+vdj2_Vci_ei*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vci_ei*ez*d10_exp0))*0.0+(((cjs0_t_Vtnode_GND*(1.0-d00_exp0))+(cjs0_t*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vci_ei_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vci_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vci_ei*ez+d10_exp0*(+vdj2_Vci_ei_Vbi_ci*ez+vdj2_Vci_ei*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vci_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
qj1_Vbi_ei=((cjs0_t*(-vdj2_Vbi_ei*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vbi_ei_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vbi_ei*ez+d10_exp0*(+vdj2_Vbi_ei_Vci_ei*ez+vdj2_Vbi_ei*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ei_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vbi_ei*ez+d10_exp0*(+vdj2_Vbi_ei_Vbi_ei*ez+vdj2_Vbi_ei*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ei_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vbi_ei*ez+d10_exp0*(+vdj2_Vbi_ei_Vs_ci*ez+vdj2_Vbi_ei*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ei_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vbi_ei*ez+d10_exp0*(+vdj2_Vbi_ei_Vb_ci*ez+vdj2_Vbi_ei*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ei_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjs0_t_Vtnode_GND*(-vdj2_Vbi_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vbi_ei*ez+d10_exp0*(+vdj2_Vbi_ei_Vtnode_GND*ez+vdj2_Vbi_ei*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ei*ez*d10_exp0))*0.0+(((cjs0_t_Vtnode_GND*(1.0-d00_exp0))+(cjs0_t*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ei_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vbi_ei*ez+d10_exp0*(+vdj2_Vbi_ei_Vbi_ci*ez+vdj2_Vbi_ei*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ei*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
qj1_Vs_ci=((cjs0_t*(-vdj2_Vs_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vs_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vs_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vs_ci*ez+d10_exp0*(+vdj2_Vs_ci_Vci_ei*ez+vdj2_Vs_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vs_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vs_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vs_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vs_ci*ez+d10_exp0*(+vdj2_Vs_ci_Vbi_ei*ez+vdj2_Vs_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vs_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vs_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vs_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vs_ci*ez+d10_exp0*(+vdj2_Vs_ci_Vs_ci*ez+vdj2_Vs_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vs_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vs_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vs_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vs_ci*ez+d10_exp0*(+vdj2_Vs_ci_Vb_ci*ez+vdj2_Vs_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vs_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vs_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjs0_t_Vtnode_GND*(-vdj2_Vs_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vs_ci*ez+d10_exp0*(+vdj2_Vs_ci_Vtnode_GND*ez+vdj2_Vs_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vs_ci*ez*d10_exp0))*0.0+(((cjs0_t_Vtnode_GND*(1.0-d00_exp0))+(cjs0_t*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vs_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vs_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vs_ci*ez+d10_exp0*(+vdj2_Vs_ci_Vbi_ci*ez+vdj2_Vs_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vs_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
qj1_Vb_ci=((cjs0_t*(-vdj2_Vb_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjs0_t_Vtnode_GND*(-vdj2_Vb_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ez+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+(((cjs0_t_Vtnode_GND*(1.0-d00_exp0))+(cjs0_t*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vb_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vb_ci*ez+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ez+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vb_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#if defined(_DERIVATE)
qj1_Vtnode_GND=(((cjs0_t_Vtnode_GND*(1.0-d00_exp0))+(cjs0_t*(-vdj2_Vtnode_GND*ez*d10_exp0)))/ez);
#endif
qj1_Vbi_ci=((cjs0_t*(-vdj2_Vbi_ci*ez*d10_exp0))/ez);
#if defined(_DERIVATE2)
  qj1_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vci_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vci_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ei*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ei*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vs_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vs_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vb_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vb_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ez)*d10_exp0)+cjs0_t_Vtnode_GND*(-vdj2_Vbi_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vtnode_GND*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ez+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+(((cjs0_t_Vtnode_GND*(1.0-d00_exp0))+(cjs0_t*(-(vdj2_Vtnode_GND*ez)*d10_exp0))))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
  qj1_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ez)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ez*d10_exp0)+cjs0_t*(+0.0-(m20_exp((vdj2*ez))*(vdj2_Vbi_ci*ez)*vdj2_Vbi_ci*ez+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ez+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ez-((cjs0_t*(-vdj2_Vbi_ci*ez*d10_exp0))*0.0+((cjs0_t*(-(vdj2_Vbi_ci*ez)*d10_exp0)))*0.0+(cjs0_t*(1.0-d00_exp0))*0.0)/ez/ez+2*(cjs0_t*(1.0-d00_exp0))*0.0*0.0/ez/ez/ez);
#endif
#endif
qj1=((cjs0_t*(1.0-d00_exp0))/ez);
EXIT_IF_ISNAN(((cjs0_t*(1.0-d00_exp0))/ez))
}
#endif
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(vdj1*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj2_Vci_ei=((cr*(-vdj1_Vci_ei*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vci_ei_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vci_ei*ezr+d10_exp0*(+vdj1_Vci_ei_Vci_ei*ezr+vdj1_Vci_ei*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vci_ei_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vci_ei*ezr+d10_exp0*(+vdj1_Vci_ei_Vbi_ei*ezr+vdj1_Vci_ei*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vci_ei_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vci_ei*ezr+d10_exp0*(+vdj1_Vci_ei_Vs_ci*ezr+vdj1_Vci_ei*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vci_ei_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vci_ei*ezr+d10_exp0*(+vdj1_Vci_ei_Vb_ci*ezr+vdj1_Vci_ei*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vci_ei_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vci_ei*ezr+d10_exp0*(+vdj1_Vci_ei_Vtnode_GND*ezr+vdj1_Vci_ei*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vci_ei*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vci_ei_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vci_ei*ezr+d10_exp0*(+vdj1_Vci_ei_Vbi_ci*ezr+vdj1_Vci_ei*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
qj2_Vbi_ei=((cr*(-vdj1_Vbi_ei*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vbi_ei_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vbi_ei*ezr+d10_exp0*(+vdj1_Vbi_ei_Vci_ei*ezr+vdj1_Vbi_ei*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ei_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vbi_ei*ezr+d10_exp0*(+vdj1_Vbi_ei_Vbi_ei*ezr+vdj1_Vbi_ei*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ei_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vbi_ei*ezr+d10_exp0*(+vdj1_Vbi_ei_Vs_ci*ezr+vdj1_Vbi_ei*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ei_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vbi_ei*ezr+d10_exp0*(+vdj1_Vbi_ei_Vb_ci*ezr+vdj1_Vbi_ei*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ei_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vbi_ei*ezr+d10_exp0*(+vdj1_Vbi_ei_Vtnode_GND*ezr+vdj1_Vbi_ei*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ei*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ei_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vbi_ei*ezr+d10_exp0*(+vdj1_Vbi_ei_Vbi_ci*ezr+vdj1_Vbi_ei*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
qj2_Vs_ci=((cr*(-vdj1_Vs_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vs_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vs_ci*ezr+d10_exp0*(+vdj1_Vs_ci_Vci_ei*ezr+vdj1_Vs_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vs_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vs_ci*ezr+d10_exp0*(+vdj1_Vs_ci_Vbi_ei*ezr+vdj1_Vs_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vs_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vs_ci*ezr+d10_exp0*(+vdj1_Vs_ci_Vs_ci*ezr+vdj1_Vs_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vs_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vs_ci*ezr+d10_exp0*(+vdj1_Vs_ci_Vb_ci*ezr+vdj1_Vs_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vs_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vs_ci*ezr+d10_exp0*(+vdj1_Vs_ci_Vtnode_GND*ezr+vdj1_Vs_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vs_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vs_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vs_ci*ezr+d10_exp0*(+vdj1_Vs_ci_Vbi_ci*ezr+vdj1_Vs_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
qj2_Vb_ci=((cr*(-vdj1_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vci_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ei*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vs_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vb_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vtnode_GND*ezr+vdj1_Vb_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vb_ci*ezr+d10_exp0*(+vdj1_Vb_ci_Vbi_ci*ezr+vdj1_Vb_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj2_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj1_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj2_Vbi_ci=((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj2_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vci_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vci_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vci_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ei*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ei*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ei*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vs_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vs_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vs_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vb_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vb_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vb_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vtnode_GND*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vtnode_GND*ezr+vdj1_Vbi_ci*0.0+vdj1_Vtnode_GND*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj1_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj2_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj1_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj1_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj1*ezr))*(vdj1_Vbi_ci*ezr)*vdj1_Vbi_ci*ezr+d10_exp0*(+vdj1_Vbi_ci_Vbi_ci*ezr+vdj1_Vbi_ci*0.0+vdj1_Vbi_ci*0.0+vdj1*0.0))))/ezr-((cr*(-vdj1_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj1_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj2=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
#endif
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(vdj2*ezr))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(bi,GND)V(ci,GND)V(s,GND) */
qj3_Vci_ei=((cr*(-vdj2_Vci_ei*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vci_ei_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vci_ei*ezr+d10_exp0*(+vdj2_Vci_ei_Vci_ei*ezr+vdj2_Vci_ei*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vci_ei_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vci_ei*ezr+d10_exp0*(+vdj2_Vci_ei_Vbi_ei*ezr+vdj2_Vci_ei*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vci_ei_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vci_ei*ezr+d10_exp0*(+vdj2_Vci_ei_Vs_ci*ezr+vdj2_Vci_ei*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vci_ei_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vci_ei*ezr+d10_exp0*(+vdj2_Vci_ei_Vb_ci*ezr+vdj2_Vci_ei*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vci_ei_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vci_ei*ezr+d10_exp0*(+vdj2_Vci_ei_Vtnode_GND*ezr+vdj2_Vci_ei*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vci_ei*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vci_ei_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vci_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vci_ei*ezr+d10_exp0*(+vdj2_Vci_ei_Vbi_ci*ezr+vdj2_Vci_ei*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vci_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
qj3_Vbi_ei=((cr*(-vdj2_Vbi_ei*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vbi_ei_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vbi_ei*ezr+d10_exp0*(+vdj2_Vbi_ei_Vci_ei*ezr+vdj2_Vbi_ei*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ei_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vbi_ei*ezr+d10_exp0*(+vdj2_Vbi_ei_Vbi_ei*ezr+vdj2_Vbi_ei*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ei_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vbi_ei*ezr+d10_exp0*(+vdj2_Vbi_ei_Vs_ci*ezr+vdj2_Vbi_ei*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ei_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vbi_ei*ezr+d10_exp0*(+vdj2_Vbi_ei_Vb_ci*ezr+vdj2_Vbi_ei*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ei_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vbi_ei*ezr+d10_exp0*(+vdj2_Vbi_ei_Vtnode_GND*ezr+vdj2_Vbi_ei*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ei*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ei_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ei*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vbi_ei*ezr+d10_exp0*(+vdj2_Vbi_ei_Vbi_ci*ezr+vdj2_Vbi_ei*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ei*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
qj3_Vs_ci=((cr*(-vdj2_Vs_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vs_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vs_ci*ezr+d10_exp0*(+vdj2_Vs_ci_Vci_ei*ezr+vdj2_Vs_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vs_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vs_ci*ezr+d10_exp0*(+vdj2_Vs_ci_Vbi_ei*ezr+vdj2_Vs_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vs_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vs_ci*ezr+d10_exp0*(+vdj2_Vs_ci_Vs_ci*ezr+vdj2_Vs_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vs_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vs_ci*ezr+d10_exp0*(+vdj2_Vs_ci_Vb_ci*ezr+vdj2_Vs_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vs_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vs_ci*ezr+d10_exp0*(+vdj2_Vs_ci_Vtnode_GND*ezr+vdj2_Vs_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vs_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vs_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vs_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vs_ci*ezr+d10_exp0*(+vdj2_Vs_ci_Vbi_ci*ezr+vdj2_Vs_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vs_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
qj3_Vb_ci=((cr*(-vdj2_Vb_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vb_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vci_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ei*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vs_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vb_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vtnode_GND*ezr+vdj2_Vb_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vb_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vb_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vb_ci*ezr+d10_exp0*(+vdj2_Vb_ci_Vbi_ci*ezr+vdj2_Vb_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vb_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#if defined(_DERIVATE)
qj3_Vtnode_GND=(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-vdj2_Vtnode_GND*ezr*d10_exp0)))/ezr);
#endif
qj3_Vbi_ci=((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))/ezr);
#if defined(_DERIVATE2)
  qj3_Vbi_ci_Vci_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vci_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vci_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vci_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vci_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vci_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ei=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ei*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ei*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ei*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ei*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ei*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vs_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vs_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vs_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vs_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vs_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vs_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vb_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vb_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vb_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vb_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vb_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vb_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vtnode_GND=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vtnode_GND*ezr)*d10_exp0)+cr_Vtnode_GND*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vtnode_GND*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vtnode_GND*ezr+vdj2_Vbi_ci*0.0+vdj2_Vtnode_GND*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+(((cr_Vtnode_GND*(1.0-d00_exp0))+(cr*(-(vdj2_Vtnode_GND*ezr)*d10_exp0))))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
  qj3_Vbi_ci_Vbi_ci=((+0.0*(1.0-d00_exp0)+0.0*(-(vdj2_Vbi_ci*ezr)*d10_exp0)+0.0*(-vdj2_Vbi_ci*ezr*d10_exp0)+cr*(+0.0-(m20_exp((vdj2*ezr))*(vdj2_Vbi_ci*ezr)*vdj2_Vbi_ci*ezr+d10_exp0*(+vdj2_Vbi_ci_Vbi_ci*ezr+vdj2_Vbi_ci*0.0+vdj2_Vbi_ci*0.0+vdj2*0.0))))/ezr-((cr*(-vdj2_Vbi_ci*ezr*d10_exp0))*0.0+((cr*(-(vdj2_Vbi_ci*ezr)*d10_exp0)))*0.0+(cr*(1.0-d00_exp0))*0.0)/ezr/ezr+2*(cr*(1.0-d00_exp0))*0.0*0.0/ezr/ezr/ezr);
#endif
#endif
qj3=((cr*(1.0-d00_exp0))/ezr);
EXIT_IF_ISNAN(((cr*(1.0-d00_exp0))/ezr))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
qjs_Vci_ei=(((qj1_Vci_ei+qj2_Vci_ei)-qj3_Vci_ei)*vds_t+(cmax*vj4_Vci_ei));
#endif
#if defined(_DERIVATE)
qjs_Vbi_ei=(((qj1_Vbi_ei+qj2_Vbi_ei)-qj3_Vbi_ei)*vds_t+(cmax*vj4_Vbi_ei));
#endif
qjs_Vs_ci=(((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*vds_t+(cmax*vj4_Vs_ci));
#if defined(_DERIVATE2)
  qjs_Vs_ci_Vci_ei=(+(+(+(+qj1_Vs_ci_Vci_ei+qj2_Vs_ci_Vci_ei)-qj3_Vs_ci_Vci_ei)*vds_t+((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*0.0+((qj1_Vci_ei+qj2_Vci_ei)-qj3_Vci_ei)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vci_ei+0.0*vj4_Vs_ci+cmax*vj4_Vs_ci_Vci_ei));
  qjs_Vs_ci_Vbi_ei=(+(+(+(+qj1_Vs_ci_Vbi_ei+qj2_Vs_ci_Vbi_ei)-qj3_Vs_ci_Vbi_ei)*vds_t+((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*0.0+((qj1_Vbi_ei+qj2_Vbi_ei)-qj3_Vbi_ei)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vbi_ei+0.0*vj4_Vs_ci+cmax*vj4_Vs_ci_Vbi_ei));
  qjs_Vs_ci_Vs_ci=(+(+(+(+qj1_Vs_ci_Vs_ci+qj2_Vs_ci_Vs_ci)-qj3_Vs_ci_Vs_ci)*vds_t+((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*0.0+((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vs_ci+0.0*vj4_Vs_ci+cmax*vj4_Vs_ci_Vs_ci));
  qjs_Vs_ci_Vb_ci=(+(+(+(+qj1_Vs_ci_Vb_ci+qj2_Vs_ci_Vb_ci)-qj3_Vs_ci_Vb_ci)*vds_t+((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*0.0+((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vb_ci+0.0*vj4_Vs_ci+cmax*vj4_Vs_ci_Vb_ci));
  qjs_Vs_ci_Vtnode_GND=(+(+(+(+qj1_Vs_ci_Vtnode_GND+qj2_Vs_ci_Vtnode_GND)-qj3_Vs_ci_Vtnode_GND)*vds_t+((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*vds_t_Vtnode_GND+((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vtnode_GND+cmax_Vtnode_GND*vj4_Vs_ci+cmax*vj4_Vs_ci_Vtnode_GND));
  qjs_Vs_ci_Vbi_ci=(+(+(+(+qj1_Vs_ci_Vbi_ci+qj2_Vs_ci_Vbi_ci)-qj3_Vs_ci_Vbi_ci)*vds_t+((qj1_Vs_ci+qj2_Vs_ci)-qj3_Vs_ci)*0.0+((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*0.0+((qj1+qj2)-qj3)*0.0)+(+0.0*vj4+0.0*vj4_Vbi_ci+0.0*vj4_Vs_ci+cmax*vj4_Vs_ci_Vbi_ci));
#endif
#if defined(_DERIVATE)
qjs_Vb_ci=(((qj1_Vb_ci+qj2_Vb_ci)-qj3_Vb_ci)*vds_t+(cmax*vj4_Vb_ci));
#endif
#if defined(_DERIVATE)
qjs_Vtnode_GND=(((((qj1_Vtnode_GND+qj2_Vtnode_GND)-qj3_Vtnode_GND)*vds_t)+(((qj1+qj2)-qj3)*vds_t_Vtnode_GND))+((cmax_Vtnode_GND*vj4)+(cmax*vj4_Vtnode_GND)));
#endif
#if defined(_DERIVATE)
qjs_Vbi_ci=(((qj1_Vbi_ci+qj2_Vbi_ci)-qj3_Vbi_ci)*vds_t+(cmax*vj4_Vbi_ci));
#endif
#endif
qjs=((((qj1+qj2)-qj3)*vds_t)+(cmax*vj4));
EXIT_IF_ISNAN(((((qj1+qj2)-qj3)*vds_t)+(cmax*vj4)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
qjs_Vci_ei=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vbi_ei=0.0;
#endif
qjs_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qjs_Vs_ci_Vci_ei=0.0;
  qjs_Vs_ci_Vbi_ei=0.0;
  qjs_Vs_ci_Vs_ci=0.0;
  qjs_Vs_ci_Vb_ci=0.0;
  qjs_Vs_ci_Vtnode_GND=0.0;
  qjs_Vs_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vb_ci=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vbi_ci=0.0;
#endif
#endif
qjs=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
#endif /* if(...) */
}
else
{
#ifdef _DYNAMIC
if
((cjs0_t>0.0))
{
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,2.4)
double m00_exp(d00_exp1,((-d00_logE0)/pModel->zs))
#if defined(_DERIVATE) /* probe=V(tnode,GND) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
vf_Vtnode_GND=vds_t_Vtnode_GND*(1.0-d00_exp1);
#endif
vf=(vds_t*(1.0-d00_exp1));
EXIT_IF_ISNAN((vds_t*(1.0-d00_exp1)))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf_Vs_ci=((-Vsci_Vs_ci)/VT);
#if defined(_DERIVATE2)
  xvf_Vs_ci_Vs_ci=((+0.0-Vsci_Vs_ci_Vs_ci)/VT-((-Vsci_Vs_ci)*0.0+(-Vsci_Vs_ci)*0.0+(vf-Vsci)*0.0)/VT/VT+2*(vf-Vsci)*0.0*0.0/VT/VT/VT);
  xvf_Vs_ci_Vbi_ei=((+0.0-0.0)/VT-((-Vsci_Vs_ci)*0.0+0.0*0.0+(vf-Vsci)*0.0)/VT/VT+2*(vf-Vsci)*0.0*0.0/VT/VT/VT);
  xvf_Vs_ci_Vb_ci=((+0.0-0.0)/VT-((-Vsci_Vs_ci)*0.0+0.0*0.0+(vf-Vsci)*0.0)/VT/VT+2*(vf-Vsci)*0.0*0.0/VT/VT/VT);
  xvf_Vs_ci_Vtnode_GND=((+0.0-0.0)/VT-((-Vsci_Vs_ci)*VT_Vtnode_GND+vf_Vtnode_GND*0.0+(vf-Vsci)*0.0)/VT/VT+2*(vf-Vsci)*0.0*VT_Vtnode_GND/VT/VT/VT);
  xvf_Vs_ci_Vbi_ci=((+0.0-0.0)/VT-((-Vsci_Vs_ci)*0.0+0.0*0.0+(vf-Vsci)*0.0)/VT/VT+2*(vf-Vsci)*0.0*0.0/VT/VT/VT);
#endif
xvf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ei_Vs_ci=0.0;
  xvf_Vbi_ei_Vbi_ei=0.0;
  xvf_Vbi_ei_Vb_ci=0.0;
  xvf_Vbi_ei_Vtnode_GND=0.0;
  xvf_Vbi_ei_Vbi_ci=0.0;
#endif
xvf_Vb_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vb_ci_Vs_ci=0.0;
  xvf_Vb_ci_Vbi_ei=0.0;
  xvf_Vb_ci_Vb_ci=0.0;
  xvf_Vb_ci_Vtnode_GND=0.0;
  xvf_Vb_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
xvf_Vtnode_GND=((vf_Vtnode_GND*VT-(vf-Vsci)*VT_Vtnode_GND)/VT/VT);
#endif
xvf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  xvf_Vbi_ci_Vs_ci=0.0;
  xvf_Vbi_ci_Vbi_ei=0.0;
  xvf_Vbi_ci_Vb_ci=0.0;
  xvf_Vbi_ci_Vtnode_GND=0.0;
  xvf_Vbi_ci_Vbi_ci=0.0;
#endif
#endif
xvf=((vf-Vsci)/VT);
EXIT_IF_ISNAN(((vf-Vsci)/VT))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((xvf*xvf)+1.921812))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xvf*xvf)+1.921812))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ei,GND)V(ci,GND)V(bi,GND)V(s,GND) */
xvf2_Vs_ci=((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vs_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci))+d10_sqrt0*(+(+xvf_Vs_ci_Vs_ci*xvf+xvf_Vs_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vs_ci+xvf*xvf_Vs_ci_Vs_ci)+0.0));
  xvf2_Vs_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci))+d10_sqrt0*(+(+xvf_Vs_ci_Vbi_ei*xvf+xvf_Vs_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vs_ci+xvf*xvf_Vs_ci_Vbi_ei)+0.0));
  xvf2_Vs_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci))+d10_sqrt0*(+(+xvf_Vs_ci_Vb_ci*xvf+xvf_Vs_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vs_ci+xvf*xvf_Vs_ci_Vb_ci)+0.0));
  xvf2_Vs_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci))+d10_sqrt0*(+(+xvf_Vs_ci_Vtnode_GND*xvf+xvf_Vs_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vs_ci+xvf*xvf_Vs_ci_Vtnode_GND)+0.0));
  xvf2_Vs_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci))+d10_sqrt0*(+(+xvf_Vs_ci_Vbi_ci*xvf+xvf_Vs_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vs_ci+xvf*xvf_Vs_ci_Vbi_ci)+0.0));
#endif
xvf2_Vbi_ei=((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ei_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vs_ci*xvf+xvf_Vbi_ei*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vs_ci)+0.0));
  xvf2_Vbi_ei_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vbi_ei*xvf+xvf_Vbi_ei*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vbi_ei)+0.0));
  xvf2_Vbi_ei_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vb_ci*xvf+xvf_Vbi_ei*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vb_ci)+0.0));
  xvf2_Vbi_ei_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vtnode_GND*xvf+xvf_Vbi_ei*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vtnode_GND)+0.0));
  xvf2_Vbi_ei_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei))+d10_sqrt0*(+(+xvf_Vbi_ei_Vbi_ci*xvf+xvf_Vbi_ei*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ei+xvf*xvf_Vbi_ei_Vbi_ci)+0.0));
#endif
xvf2_Vb_ci=((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vb_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vs_ci*xvf+xvf_Vb_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vs_ci)+0.0));
  xvf2_Vb_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ei*xvf+xvf_Vb_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ei)+0.0));
  xvf2_Vb_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vb_ci*xvf+xvf_Vb_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vb_ci)+0.0));
  xvf2_Vb_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vtnode_GND*xvf+xvf_Vb_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vb_ci+xvf*xvf_Vb_ci_Vtnode_GND)+0.0));
  xvf2_Vb_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci))+d10_sqrt0*(+(+xvf_Vb_ci_Vbi_ci*xvf+xvf_Vb_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vb_ci+xvf*xvf_Vb_ci_Vbi_ci)+0.0));
#endif
#if defined(_DERIVATE)
xvf2_Vtnode_GND=((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND))*d10_sqrt0;
#endif
xvf2_Vbi_ci=((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))*d10_sqrt0;
#if defined(_DERIVATE2)
  xvf2_Vbi_ci_Vs_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vs_ci*xvf)+(xvf*xvf_Vs_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vs_ci*xvf+xvf_Vbi_ci*xvf_Vs_ci+xvf_Vs_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vs_ci)+0.0));
  xvf2_Vbi_ci_Vbi_ei=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ei*xvf)+(xvf*xvf_Vbi_ei)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ei*xvf+xvf_Vbi_ci*xvf_Vbi_ei+xvf_Vbi_ei*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ei)+0.0));
  xvf2_Vbi_ci_Vb_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vb_ci*xvf)+(xvf*xvf_Vb_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vb_ci*xvf+xvf_Vbi_ci*xvf_Vb_ci+xvf_Vb_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vb_ci)+0.0));
  xvf2_Vbi_ci_Vtnode_GND=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vtnode_GND*xvf)+(xvf*xvf_Vtnode_GND)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vtnode_GND*xvf+xvf_Vbi_ci*xvf_Vtnode_GND+xvf_Vtnode_GND*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vtnode_GND)+0.0));
  xvf2_Vbi_ci_Vbi_ci=(m20_sqrt(((xvf*xvf)+1.921812))*(((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci)))*((xvf_Vbi_ci*xvf)+(xvf*xvf_Vbi_ci))+d10_sqrt0*(+(+xvf_Vbi_ci_Vbi_ci*xvf+xvf_Vbi_ci*xvf_Vbi_ci+xvf_Vbi_ci*xvf_Vbi_ci+xvf*xvf_Vbi_ci_Vbi_ci)+0.0));
#endif
#endif
xvf2=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
v_j_Vs_ci=(-(VT*(xvf_Vs_ci+xvf2_Vs_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vs_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+VT*(+xvf_Vs_ci_Vs_ci+xvf2_Vs_ci_Vs_ci))*0.5+(VT*(xvf_Vs_ci+xvf2_Vs_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vs_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+VT*(+xvf_Vs_ci_Vbi_ei+xvf2_Vs_ci_Vbi_ei))*0.5+(VT*(xvf_Vs_ci+xvf2_Vs_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vs_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+VT*(+xvf_Vs_ci_Vb_ci+xvf2_Vs_ci_Vb_ci))*0.5+(VT*(xvf_Vs_ci+xvf2_Vs_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vs_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vs_ci+xvf2_Vs_ci)+VT*(+xvf_Vs_ci_Vtnode_GND+xvf2_Vs_ci_Vtnode_GND))*0.5+(VT*(xvf_Vs_ci+xvf2_Vs_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vs_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+VT*(+xvf_Vs_ci_Vbi_ci+xvf2_Vs_ci_Vbi_ci))*0.5+(VT*(xvf_Vs_ci+xvf2_Vs_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
v_j_Vbi_ei=(-(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ei_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vs_ci+xvf2_Vbi_ei_Vs_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vbi_ei+xvf2_Vbi_ei_Vbi_ei))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vb_ci+xvf2_Vbi_ei_Vb_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vtnode_GND+xvf2_Vbi_ei_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ei_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+VT*(+xvf_Vbi_ei_Vbi_ci+xvf2_Vbi_ei_Vbi_ci))*0.5+(VT*(xvf_Vbi_ei+xvf2_Vbi_ei))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
v_j_Vb_ci=(-(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vb_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vs_ci+xvf2_Vb_ci_Vs_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ei+xvf2_Vb_ci_Vbi_ei))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vb_ci+xvf2_Vb_ci_Vb_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vtnode_GND+xvf2_Vb_ci_Vtnode_GND))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vb_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+VT*(+xvf_Vb_ci_Vbi_ci+xvf2_Vb_ci_Vbi_ci))*0.5+(VT*(xvf_Vb_ci+xvf2_Vb_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#if defined(_DERIVATE)
v_j_Vtnode_GND=(vf_Vtnode_GND-((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND)))*0.5);
#endif
v_j_Vbi_ci=(-(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.5);
#if defined(_DERIVATE2)
  v_j_Vbi_ci_Vs_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vs_ci+xvf2_Vs_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vs_ci+xvf2_Vbi_ci_Vs_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vs_ci+xvf2_Vs_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ei=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ei+xvf2_Vbi_ei)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ei+xvf2_Vbi_ci_Vbi_ei))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ei+xvf2_Vbi_ei)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vb_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vb_ci+xvf2_Vb_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vb_ci+xvf2_Vbi_ci_Vb_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vb_ci+xvf2_Vb_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vtnode_GND=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vtnode_GND+xvf2_Vtnode_GND)+VT_Vtnode_GND*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vtnode_GND+xvf2_Vbi_ci_Vtnode_GND))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+(((VT_Vtnode_GND*(xvf+xvf2))+(VT*(xvf_Vtnode_GND+xvf2_Vtnode_GND))))*0.0+(VT*(xvf+xvf2))*0.0));
  v_j_Vbi_ci_Vbi_ci=(+0.0-(+(+0.0*(xvf+xvf2)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+0.0*(xvf_Vbi_ci+xvf2_Vbi_ci)+VT*(+xvf_Vbi_ci_Vbi_ci+xvf2_Vbi_ci_Vbi_ci))*0.5+(VT*(xvf_Vbi_ci+xvf2_Vbi_ci))*0.0+((VT*(xvf_Vbi_ci+xvf2_Vbi_ci)))*0.0+(VT*(xvf+xvf2))*0.0));
#endif
#endif
v_j=(vf-((VT*(xvf+xvf2))*0.5));
EXIT_IF_ISNAN((vf-((VT*(xvf+xvf2))*0.5)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(ci,ei) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
#if defined(_DERIVATE)
x_Vtnode_GND=0.0;
#endif
x_Vci_ei=0.0;
#if defined(_DERIVATE2)
  x_Vci_ei_Vtnode_GND=0.0;
  x_Vci_ei_Vci_ei=0.0;
#endif
#endif
x=(1.0-pModel->zs);
EXIT_IF_ISNAN((1.0-pModel->zs))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(1.0-(v_j/vds_t)))
double m00_exp(d00_exp1,(x*d00_logE0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0-(v_j/vds_t)))
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,ci)V(ci,ei)V(bi,ei)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(ci,GND)V(ei,GND)V(bi,GND)V(s,GND) */
y_Vs_ci=(-(x*(-(v_j_Vs_ci/vds_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vs_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vs_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vs_ci/vds_t))*(-(v_j_Vs_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vs_ci_Vs_ci/vds_t-(v_j_Vs_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vs_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vs_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vs_ci/vds_t))*d10_logE0+x*0.0)));
  y_Vs_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vds_t))*d10_logE0))*(x*(-(v_j_Vs_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ei/vds_t))*(-(v_j_Vs_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vs_ci_Vbi_ei/vds_t-(v_j_Vs_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vs_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vs_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vb_ci/vds_t))*(-(v_j_Vs_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vs_ci_Vb_ci/vds_t-(v_j_Vs_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vs_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0)))*(x*(-(v_j_Vs_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vs_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(v_j_Vs_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vs_ci_Vtnode_GND/vds_t-(v_j_Vs_ci*vds_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t))))));
  y_Vs_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vs_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ci/vds_t))*(-(v_j_Vs_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vs_ci_Vbi_ci/vds_t-(v_j_Vs_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
#endif
y_Vci_ei=(-x_Vci_ei*d00_logE0*d10_exp1);
#if defined(_DERIVATE2)
  y_Vci_ei_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vds_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vs_ci/vds_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*x_Vci_ei*d00_logE0+d10_exp1*(+x_Vci_ei_Vci_ei*d00_logE0+x_Vci_ei*0.0+x_Vci_ei*0.0+x*0.0)));
  y_Vci_ei_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vds_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vbi_ei/vds_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vds_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vb_ci/vds_t))*d10_logE0+0.0*0.0+x*0.0)));
  y_Vci_ei_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0)))*x_Vci_ei*d00_logE0+d10_exp1*(+x_Vci_ei_Vtnode_GND*d00_logE0+x_Vci_ei*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0+x_Vtnode_GND*0.0+x*0.0)));
  y_Vci_ei_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vds_t))*d10_logE0))*x_Vci_ei*d00_logE0+d10_exp1*(+0.0*d00_logE0+x_Vci_ei*(-(v_j_Vbi_ci/vds_t))*d10_logE0+0.0*0.0+x*0.0)));
#endif
y_Vbi_ei=(-(x*(-(v_j_Vbi_ei/vds_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ei_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vs_ci/vds_t))*(-(v_j_Vbi_ei/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vs_ci/vds_t-(v_j_Vbi_ei*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vbi_ei_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ei/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ei/vds_t))*d10_logE0+x*0.0)));
  y_Vbi_ei_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ei/vds_t))*(-(v_j_Vbi_ei/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vbi_ei/vds_t-(v_j_Vbi_ei*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vbi_ei_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vb_ci/vds_t))*(-(v_j_Vbi_ei/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vb_ci/vds_t-(v_j_Vbi_ei*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vbi_ei_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0)))*(x*(-(v_j_Vbi_ei/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ei/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(v_j_Vbi_ei/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vtnode_GND/vds_t-(v_j_Vbi_ei*vds_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t))))));
  y_Vbi_ei_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ei/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ci/vds_t))*(-(v_j_Vbi_ei/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ei_Vbi_ci/vds_t-(v_j_Vbi_ei*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
#endif
y_Vb_ci=(-(x*(-(v_j_Vb_ci/vds_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vb_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vs_ci/vds_t))*(-(v_j_Vb_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vs_ci/vds_t-(v_j_Vb_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vb_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vb_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vb_ci/vds_t))*d10_logE0+x*0.0)));
  y_Vb_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vds_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ei/vds_t))*(-(v_j_Vb_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ei/vds_t-(v_j_Vb_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vb_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vb_ci/vds_t))*(-(v_j_Vb_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vb_ci/vds_t-(v_j_Vb_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vb_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0)))*(x*(-(v_j_Vb_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vb_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(v_j_Vb_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vtnode_GND/vds_t-(v_j_Vb_ci*vds_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t))))));
  y_Vb_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vb_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ci/vds_t))*(-(v_j_Vb_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vb_ci_Vbi_ci/vds_t-(v_j_Vb_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
#endif
#if defined(_DERIVATE)
y_Vtnode_GND=(-((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0))*d10_exp1);
#endif
y_Vbi_ci=(-(x*(-(v_j_Vbi_ci/vds_t))*d10_logE0)*d10_exp1);
#if defined(_DERIVATE2)
  y_Vbi_ci_Vs_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vs_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vs_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vs_ci/vds_t))*(-(v_j_Vbi_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vs_ci/vds_t-(v_j_Vbi_ci*0.0+v_j_Vs_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vbi_ci_Vci_ei=(+0.0-(m20_exp((x*d00_logE0))*(x_Vci_ei*d00_logE0)*(x*(-(v_j_Vbi_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*0.0+x_Vci_ei*(-(v_j_Vbi_ci/vds_t))*d10_logE0+x*0.0)));
  y_Vbi_ci_Vbi_ei=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ei/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ei/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ei/vds_t))*(-(v_j_Vbi_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ei/vds_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ei*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vbi_ci_Vb_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vb_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vb_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vb_ci/vds_t))*(-(v_j_Vbi_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vb_ci/vds_t-(v_j_Vbi_ci*0.0+v_j_Vb_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
  y_Vbi_ci_Vtnode_GND=(+0.0-(m20_exp((x*d00_logE0))*(((x_Vtnode_GND*d00_logE0)+(x*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0)))*(x*(-(v_j_Vbi_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*d10_logE0+x_Vtnode_GND*(-(v_j_Vbi_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-((v_j_Vtnode_GND*vds_t-v_j*vds_t_Vtnode_GND)/vds_t/vds_t))*(-(v_j_Vbi_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vtnode_GND/vds_t-(v_j_Vbi_ci*vds_t_Vtnode_GND+v_j_Vtnode_GND*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*vds_t_Vtnode_GND/vds_t/vds_t/vds_t))))));
  y_Vbi_ci_Vbi_ci=(+0.0-(m20_exp((x*d00_logE0))*((x*(-(v_j_Vbi_ci/vds_t))*d10_logE0))*(x*(-(v_j_Vbi_ci/vds_t))*d10_logE0)+d10_exp1*(+0.0*d00_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+0.0*(-(v_j_Vbi_ci/vds_t))*d10_logE0+x*(m20_logE((1.0-(v_j/vds_t)))*(-(v_j_Vbi_ci/vds_t))*(-(v_j_Vbi_ci/vds_t))+d10_logE0*(+0.0-(v_j_Vbi_ci_Vbi_ci/vds_t-(v_j_Vbi_ci*0.0+v_j_Vbi_ci*0.0+v_j*0.0)/vds_t/vds_t+2*v_j*0.0*0.0/vds_t/vds_t/vds_t))))));
#endif
#endif
y=(1.0-d00_exp1);
EXIT_IF_ISNAN((1.0-d00_exp1))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
qjs_Vci_ei=((((cjs0_t*vds_t)*y_Vci_ei)*x-((cjs0_t*vds_t)*y)*x_Vci_ei)/x/x);
#endif
#if defined(_DERIVATE)
qjs_Vbi_ei=((((cjs0_t*vds_t)*y_Vbi_ei)/x)+((2.4*cjs0_t)*(-v_j_Vbi_ei)));
#endif
qjs_Vs_ci=((((cjs0_t*vds_t)*y_Vs_ci)/x)+((2.4*cjs0_t)*(Vsci_Vs_ci-v_j_Vs_ci)));
#if defined(_DERIVATE2)
  qjs_Vs_ci_Vci_ei=(+((+(+0.0*vds_t+0.0*0.0+0.0*0.0+cjs0_t*0.0)*y+0.0*y_Vci_ei+(0.0)*y_Vs_ci+(cjs0_t*vds_t)*y_Vs_ci_Vci_ei)/x-(((cjs0_t*vds_t)*y_Vs_ci)*x_Vci_ei+((((0.0)*y)+((cjs0_t*vds_t)*y_Vci_ei)))*0.0+((cjs0_t*vds_t)*y)*0.0)/x/x+2*((cjs0_t*vds_t)*y)*0.0*x_Vci_ei/x/x/x)+(+(+0.0*cjs0_t+0.0*0.0+0.0*0.0+2.4*0.0)*(Vsci-v_j)+0.0*0.0+(0.0)*(Vsci_Vs_ci-v_j_Vs_ci)+(2.4*cjs0_t)*(+0.0-0.0)));
  qjs_Vs_ci_Vbi_ei=(+((+(+0.0*vds_t+0.0*0.0+0.0*0.0+cjs0_t*0.0)*y+0.0*y_Vbi_ei+(0.0)*y_Vs_ci+(cjs0_t*vds_t)*y_Vs_ci_Vbi_ei)/x-(((cjs0_t*vds_t)*y_Vs_ci)*0.0+((((0.0)*y)+((cjs0_t*vds_t)*y_Vbi_ei)))*0.0+((cjs0_t*vds_t)*y)*0.0)/x/x+2*((cjs0_t*vds_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjs0_t+0.0*0.0+0.0*0.0+2.4*0.0)*(Vsci-v_j)+0.0*(-v_j_Vbi_ei)+(0.0)*(Vsci_Vs_ci-v_j_Vs_ci)+(2.4*cjs0_t)*(+0.0-v_j_Vs_ci_Vbi_ei)));
  qjs_Vs_ci_Vs_ci=(+((+(+0.0*vds_t+0.0*0.0+0.0*0.0+cjs0_t*0.0)*y+0.0*y_Vs_ci+(0.0)*y_Vs_ci+(cjs0_t*vds_t)*y_Vs_ci_Vs_ci)/x-(((cjs0_t*vds_t)*y_Vs_ci)*0.0+((((0.0)*y)+((cjs0_t*vds_t)*y_Vs_ci)))*0.0+((cjs0_t*vds_t)*y)*0.0)/x/x+2*((cjs0_t*vds_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjs0_t+0.0*0.0+0.0*0.0+2.4*0.0)*(Vsci-v_j)+0.0*(Vsci_Vs_ci-v_j_Vs_ci)+(0.0)*(Vsci_Vs_ci-v_j_Vs_ci)+(2.4*cjs0_t)*(+Vsci_Vs_ci_Vs_ci-v_j_Vs_ci_Vs_ci)));
  qjs_Vs_ci_Vb_ci=(+((+(+0.0*vds_t+0.0*0.0+0.0*0.0+cjs0_t*0.0)*y+0.0*y_Vb_ci+(0.0)*y_Vs_ci+(cjs0_t*vds_t)*y_Vs_ci_Vb_ci)/x-(((cjs0_t*vds_t)*y_Vs_ci)*0.0+((((0.0)*y)+((cjs0_t*vds_t)*y_Vb_ci)))*0.0+((cjs0_t*vds_t)*y)*0.0)/x/x+2*((cjs0_t*vds_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjs0_t+0.0*0.0+0.0*0.0+2.4*0.0)*(Vsci-v_j)+0.0*(-v_j_Vb_ci)+(0.0)*(Vsci_Vs_ci-v_j_Vs_ci)+(2.4*cjs0_t)*(+0.0-v_j_Vs_ci_Vb_ci)));
  qjs_Vs_ci_Vtnode_GND=(+((+(+0.0*vds_t+0.0*vds_t_Vtnode_GND+cjs0_t_Vtnode_GND*0.0+cjs0_t*0.0)*y+0.0*y_Vtnode_GND+(((cjs0_t_Vtnode_GND*vds_t)+(cjs0_t*vds_t_Vtnode_GND)))*y_Vs_ci+(cjs0_t*vds_t)*y_Vs_ci_Vtnode_GND)/x-(((cjs0_t*vds_t)*y_Vs_ci)*x_Vtnode_GND+((((((cjs0_t_Vtnode_GND*vds_t)+(cjs0_t*vds_t_Vtnode_GND)))*y)+((cjs0_t*vds_t)*y_Vtnode_GND)))*0.0+((cjs0_t*vds_t)*y)*0.0)/x/x+2*((cjs0_t*vds_t)*y)*0.0*x_Vtnode_GND/x/x/x)+(+(+0.0*cjs0_t+0.0*cjs0_t_Vtnode_GND+0.0*0.0+2.4*0.0)*(Vsci-v_j)+0.0*(-v_j_Vtnode_GND)+((2.4*cjs0_t_Vtnode_GND))*(Vsci_Vs_ci-v_j_Vs_ci)+(2.4*cjs0_t)*(+0.0-v_j_Vs_ci_Vtnode_GND)));
  qjs_Vs_ci_Vbi_ci=(+((+(+0.0*vds_t+0.0*0.0+0.0*0.0+cjs0_t*0.0)*y+0.0*y_Vbi_ci+(0.0)*y_Vs_ci+(cjs0_t*vds_t)*y_Vs_ci_Vbi_ci)/x-(((cjs0_t*vds_t)*y_Vs_ci)*0.0+((((0.0)*y)+((cjs0_t*vds_t)*y_Vbi_ci)))*0.0+((cjs0_t*vds_t)*y)*0.0)/x/x+2*((cjs0_t*vds_t)*y)*0.0*0.0/x/x/x)+(+(+0.0*cjs0_t+0.0*0.0+0.0*0.0+2.4*0.0)*(Vsci-v_j)+0.0*(-v_j_Vbi_ci)+(0.0)*(Vsci_Vs_ci-v_j_Vs_ci)+(2.4*cjs0_t)*(+0.0-v_j_Vs_ci_Vbi_ci)));
#endif
#if defined(_DERIVATE)
qjs_Vb_ci=((((cjs0_t*vds_t)*y_Vb_ci)/x)+((2.4*cjs0_t)*(-v_j_Vb_ci)));
#endif
#if defined(_DERIVATE)
qjs_Vtnode_GND=(((((((cjs0_t_Vtnode_GND*vds_t)+(cjs0_t*vds_t_Vtnode_GND))*y)+((cjs0_t*vds_t)*y_Vtnode_GND))*x-((cjs0_t*vds_t)*y)*x_Vtnode_GND)/x/x)+(((2.4*cjs0_t_Vtnode_GND)*(Vsci-v_j))+((2.4*cjs0_t)*(-v_j_Vtnode_GND))));
#endif
#if defined(_DERIVATE)
qjs_Vbi_ci=((((cjs0_t*vds_t)*y_Vbi_ci)/x)+((2.4*cjs0_t)*(-v_j_Vbi_ci)));
#endif
#endif
qjs=((((cjs0_t*vds_t)*y)/x)+((2.4*cjs0_t)*(Vsci-v_j)));
EXIT_IF_ISNAN(((((cjs0_t*vds_t)*y)/x)+((2.4*cjs0_t)*(Vsci-v_j))))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
qjs_Vci_ei=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vbi_ei=0.0;
#endif
qjs_Vs_ci=0.0;
#if defined(_DERIVATE2)
  qjs_Vs_ci_Vci_ei=0.0;
  qjs_Vs_ci_Vbi_ei=0.0;
  qjs_Vs_ci_Vs_ci=0.0;
  qjs_Vs_ci_Vb_ci=0.0;
  qjs_Vs_ci_Vtnode_GND=0.0;
  qjs_Vs_ci_Vbi_ci=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vb_ci=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vtnode_GND=0.0;
#endif
#if defined(_DERIVATE)
qjs_Vbi_ci=0.0;
#endif
#endif
qjs=0.00;
EXIT_IF_ISNAN(0.00)
#endif
}
#endif /* if(...) */
}
#endif /* if(...) */
#if defined(_DERIVATE) /* probe=V(ci,c)V(ei,e)V(b,bi)V(s,ci)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
pterm_Vci_c=0.0;
pterm_Vei_e=0.0;
pterm_Vb_bi=0.0;
pterm_Vs_ci=0.0;
pterm_Vtnode_GND=0.0;
pterm_Vbi_ei=0.0;
pterm_Vb_ci=0.0;
pterm_Vbi_ci=0.0;
pterm_Vci_ei=0.0;
#endif
pterm=0;
EXIT_IF_ISNAN(0)
if
(((pModel->flsh==1)&&(pModel->rth>=0.001)))
{
#if defined(_DERIVATE) /* probe=V(ci,c)V(ei,e)V(b,bi)V(s,ci)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
pterm_Vci_c=0.0;
pterm_Vei_e=0.0;
pterm_Vb_bi=0.0;
pterm_Vs_ci=0.0;
pterm_Vtnode_GND=(it_Vtnode_GND*Vciei+((iavl_Vtnode_GND*(vdci_t-Vbici))+(pInst->iavl*vdci_t_Vtnode_GND)));
pterm_Vbi_ei=(it_Vbi_ei*Vciei+iavl_Vbi_ei*(vdci_t-Vbici));
pterm_Vb_ci=(it_Vb_ci*Vciei+iavl_Vb_ci*(vdci_t-Vbici));
pterm_Vbi_ci=(it_Vbi_ci*Vciei+((iavl_Vbi_ci*(vdci_t-Vbici))+(pInst->iavl*(-Vbici_Vbi_ci))));
pterm_Vci_ei=(((it_Vci_ei*Vciei)+(pInst->it*Vciei_Vci_ei))+iavl_Vci_ei*(vdci_t-Vbici));
#endif
pterm=((pInst->it*Vciei)+(pInst->iavl*(vdci_t-Vbici)));
EXIT_IF_ISNAN(((pInst->it*Vciei)+(pInst->iavl*(vdci_t-Vbici))))
}
else
{
if
(((pModel->flsh==2)&&(pModel->rth>=0.001)))
{
#if defined(_DERIVATE) /* probe=V(ci,c)V(ei,e)V(b,bi)V(s,ci)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
pterm_Vci_c=0.0;
pterm_Vei_e=0.0;
pterm_Vb_bi=0.0;
pterm_Vs_ci=((ijsc_Vs_ci*Vsci)+(pInst->ijsc*Vsci_Vs_ci));
pterm_Vtnode_GND=(((((Vciei*it_Vtnode_GND)+((vdci_t_Vtnode_GND*pInst->iavl)+((vdci_t-Vbici)*iavl_Vtnode_GND)))+ijbe_Vtnode_GND*Vbiei)+ijbc_Vtnode_GND*Vbici)+ijsc_Vtnode_GND*Vsci);
pterm_Vbi_ei=(((((Vciei*it_Vbi_ei)+((vdci_t-Vbici)*iavl_Vbi_ei))+((ijbe_Vbi_ei*Vbiei)+(pInst->ijbe*Vbiei_Vbi_ei)))+ijbc_Vbi_ei*Vbici)+ijsc_Vbi_ei*Vsci);
pterm_Vb_ci=((Vciei*it_Vb_ci)+((vdci_t-Vbici)*iavl_Vb_ci));
pterm_Vbi_ci=((((Vciei*it_Vbi_ci)+(((-Vbici_Vbi_ci)*pInst->iavl)+((vdci_t-Vbici)*iavl_Vbi_ci)))+((ijbc_Vbi_ci*Vbici)+(pInst->ijbc*Vbici_Vbi_ci)))+ijsc_Vbi_ci*Vsci);
pterm_Vci_ei=(((Vciei_Vci_ei*pInst->it)+(Vciei*it_Vci_ei))+((vdci_t-Vbici)*iavl_Vci_ei));
#endif
pterm=(((((Vciei*pInst->it)+((vdci_t-Vbici)*pInst->iavl))+(pInst->ijbe*Vbiei))+(pInst->ijbc*Vbici))+(pInst->ijsc*Vsci));
EXIT_IF_ISNAN((((((Vciei*pInst->it)+((vdci_t-Vbici)*pInst->iavl))+(pInst->ijbe*Vbiei))+(pInst->ijbc*Vbici))+(pInst->ijsc*Vsci)))
if
((rb>=0.001))
{
#if defined(_DERIVATE) /* probe=V(ci,c)V(ei,e)V(b,bi)V(s,ci)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
pterm_Vci_c=0.0;
pterm_Vei_e=0.0;
pterm_Vb_bi=(pterm_Vb_bi+(((Vbbi_Vb_bi*Vbbi)+(Vbbi*Vbbi_Vb_bi))/rb));
pterm_Vs_ci=pterm_Vs_ci;
pterm_Vtnode_GND=(pterm_Vtnode_GND+(-(Vbbi*Vbbi)*rb_Vtnode_GND/rb/rb));
pterm_Vbi_ei=(pterm_Vbi_ei+(-(Vbbi*Vbbi)*rb_Vbi_ei/rb/rb));
pterm_Vb_ci=(pterm_Vb_ci+(-(Vbbi*Vbbi)*rb_Vb_ci/rb/rb));
pterm_Vbi_ci=(pterm_Vbi_ci+(-(Vbbi*Vbbi)*rb_Vbi_ci/rb/rb));
pterm_Vci_ei=(pterm_Vci_ei+(-(Vbbi*Vbbi)*rb_Vci_ei/rb/rb));
#endif
pterm=(pterm+((Vbbi*Vbbi)/rb));
EXIT_IF_ISNAN((pterm+((Vbbi*Vbbi)/rb)))
}
if
((pModel->re>=0.001))
{
#if defined(_DERIVATE) /* probe=V(ci,c)V(ei,e)V(b,bi)V(s,ci)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
pterm_Vci_c=0.0;
pterm_Vei_e=(pterm_Vei_e+(((Veie_Vei_e*Veie)+(Veie*Veie_Vei_e))/re_t));
pterm_Vb_bi=pterm_Vb_bi;
pterm_Vs_ci=pterm_Vs_ci;
pterm_Vtnode_GND=(pterm_Vtnode_GND+(-(Veie*Veie)*re_t_Vtnode_GND/re_t/re_t));
pterm_Vbi_ei=pterm_Vbi_ei;
pterm_Vb_ci=pterm_Vb_ci;
pterm_Vbi_ci=pterm_Vbi_ci;
pterm_Vci_ei=pterm_Vci_ei;
#endif
pterm=(pterm+((Veie*Veie)/re_t));
EXIT_IF_ISNAN((pterm+((Veie*Veie)/re_t)))
}
if
((pModel->rcx>=0.001))
{
#if defined(_DERIVATE) /* probe=V(ci,c)V(ei,e)V(b,bi)V(s,ci)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
pterm_Vci_c=(pterm_Vci_c+(((Vcic_Vci_c*Vcic)+(Vcic*Vcic_Vci_c))/rcx_t));
pterm_Vei_e=pterm_Vei_e;
pterm_Vb_bi=pterm_Vb_bi;
pterm_Vs_ci=pterm_Vs_ci;
pterm_Vtnode_GND=(pterm_Vtnode_GND+(-(Vcic*Vcic)*rcx_t_Vtnode_GND/rcx_t/rcx_t));
pterm_Vbi_ei=pterm_Vbi_ei;
pterm_Vb_ci=pterm_Vb_ci;
pterm_Vbi_ci=pterm_Vbi_ci;
pterm_Vci_ei=pterm_Vci_ei;
#endif
pterm=(pterm+((Vcic*Vcic)/rcx_t));
EXIT_IF_ISNAN((pterm+((Vcic*Vcic)/rcx_t)))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(xf2,GND)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
Itxf_Vxf2_GND=0.0;
#endif
#if defined(_DERIVATE)
Itxf_Vtnode_GND=itf_Vtnode_GND;
#endif
Itxf_Vbi_ei=itf_Vbi_ei;
#if defined(_DERIVATE2)
  Itxf_Vbi_ei_Vxf2_GND=0.0;
  Itxf_Vbi_ei_Vtnode_GND=itf_Vbi_ei_Vtnode_GND;
  Itxf_Vbi_ei_Vbi_ei=itf_Vbi_ei_Vbi_ei;
  Itxf_Vbi_ei_Vb_ci=itf_Vbi_ei_Vb_ci;
  Itxf_Vbi_ei_Vbi_ci=itf_Vbi_ei_Vbi_ci;
  Itxf_Vbi_ei_Vci_ei=itf_Vbi_ei_Vci_ei;
#endif
#if defined(_DERIVATE)
Itxf_Vb_ci=itf_Vb_ci;
#endif
Itxf_Vbi_ci=itf_Vbi_ci;
#if defined(_DERIVATE2)
  Itxf_Vbi_ci_Vxf2_GND=0.0;
  Itxf_Vbi_ci_Vtnode_GND=itf_Vbi_ci_Vtnode_GND;
  Itxf_Vbi_ci_Vbi_ei=itf_Vbi_ci_Vbi_ei;
  Itxf_Vbi_ci_Vb_ci=itf_Vbi_ci_Vb_ci;
  Itxf_Vbi_ci_Vbi_ci=itf_Vbi_ci_Vbi_ci;
  Itxf_Vbi_ci_Vci_ei=itf_Vbi_ci_Vci_ei;
#endif
#if defined(_DERIVATE)
Itxf_Vci_ei=itf_Vci_ei;
#endif
#endif
Itxf=itf;
EXIT_IF_ISNAN(itf)
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf,GND)V(tnode,GND)V(b,ci)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe= */
Qdeix_Vxf_GND=0.0;
Qdeix_Vtnode_GND=qf_Vtnode_GND;
Qdeix_Vb_ci=qf_Vb_ci;
Qdeix_Vbi_ci=qf_Vbi_ci;
Qdeix_Vbi_ei=qf_Vbi_ei;
Qdeix_Vci_ei=qf_Vci_ei;
#endif
Qdeix=qf;
EXIT_IF_ISNAN(qf)
#endif
if
(((pModel->flnqs!=0)&&(tf!=0)))
{
#if defined(_DERIVATE) /* probe=V(xf1,GND) ddxprobe= */
Vxf1_Vxf1_GND=1.0;
#endif
Vxf1=NP(xf1);
EXIT_IF_ISNAN(NP(xf1))
#if defined(_DERIVATE) /* probe=V(xf2,GND) ddxprobe=V(bi,GND) */
Vxf2_Vxf2_GND=1.0;
#endif
Vxf2=NP(xf2);
EXIT_IF_ISNAN(NP(xf2))
#if defined(_DERIVATE) /* probe=V(xf1,GND)V(xf2,GND)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
Ixf1_Vxf1_GND=0.0;
Ixf1_Vxf2_GND=(Vxf2_Vxf2_GND/tf)*pModel->t0;
Ixf1_Vtnode_GND=(((-itf_Vtnode_GND)*tf-(Vxf2-itf)*tf_Vtnode_GND)/tf/tf)*pModel->t0;
Ixf1_Vbi_ei=(((-itf_Vbi_ei)*tf-(Vxf2-itf)*tf_Vbi_ei)/tf/tf)*pModel->t0;
Ixf1_Vb_ci=(((-itf_Vb_ci)*tf-(Vxf2-itf)*tf_Vb_ci)/tf/tf)*pModel->t0;
Ixf1_Vbi_ci=(((-itf_Vbi_ci)*tf-(Vxf2-itf)*tf_Vbi_ci)/tf/tf)*pModel->t0;
Ixf1_Vci_ei=(((-itf_Vci_ei)*tf-(Vxf2-itf)*tf_Vci_ei)/tf/tf)*pModel->t0;
#endif
Ixf1=(((Vxf2-itf)/tf)*pModel->t0);
EXIT_IF_ISNAN((((Vxf2-itf)/tf)*pModel->t0))
#if defined(_DERIVATE) /* probe=V(xf2,GND)V(xf1,GND)V(tnode,GND)V(b,ci)V(bi,ci)V(ci,ei)V(bi,ei) ddxprobe= */
Ixf2_Vxf2_GND=(Vxf2_Vxf2_GND/tf)*pModel->t0;
Ixf2_Vxf1_GND=((-Vxf1_Vxf1_GND)/tf)*pModel->t0;
Ixf2_Vtnode_GND=(-(Vxf2-Vxf1)*tf_Vtnode_GND/tf/tf)*pModel->t0;
Ixf2_Vb_ci=(-(Vxf2-Vxf1)*tf_Vb_ci/tf/tf)*pModel->t0;
Ixf2_Vbi_ci=(-(Vxf2-Vxf1)*tf_Vbi_ci/tf/tf)*pModel->t0;
Ixf2_Vci_ei=(-(Vxf2-Vxf1)*tf_Vci_ei/tf/tf)*pModel->t0;
Ixf2_Vbi_ei=(-(Vxf2-Vxf1)*tf_Vbi_ei/tf/tf)*pModel->t0;
#endif
Ixf2=(((Vxf2-Vxf1)/tf)*pModel->t0);
EXIT_IF_ISNAN((((Vxf2-Vxf1)/tf)*pModel->t0))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf1,GND) ddxprobe= */
Qxf1_Vxf1_GND=(pModel->alit*Vxf1_Vxf1_GND)*pModel->t0;
#endif
Qxf1=((pModel->alit*Vxf1)*pModel->t0);
EXIT_IF_ISNAN(((pModel->alit*Vxf1)*pModel->t0))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf2,GND) ddxprobe= */
Qxf2_Vxf2_GND=((pModel->alit*Vxf2_Vxf2_GND)/3)*pModel->t0;
#endif
Qxf2=(((pModel->alit*Vxf2)/3)*pModel->t0);
EXIT_IF_ISNAN((((pModel->alit*Vxf2)/3)*pModel->t0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(xf2,GND)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
Itxf_Vxf2_GND=Vxf2_Vxf2_GND;
#endif
#if defined(_DERIVATE)
Itxf_Vtnode_GND=0.0;
#endif
Itxf_Vbi_ei=0.0;
#if defined(_DERIVATE2)
  Itxf_Vbi_ei_Vxf2_GND=0.0;
  Itxf_Vbi_ei_Vtnode_GND=0.0;
  Itxf_Vbi_ei_Vbi_ei=0.0;
  Itxf_Vbi_ei_Vb_ci=0.0;
  Itxf_Vbi_ei_Vbi_ci=0.0;
  Itxf_Vbi_ei_Vci_ei=0.0;
#endif
#if defined(_DERIVATE)
Itxf_Vb_ci=0.0;
#endif
Itxf_Vbi_ci=0.0;
#if defined(_DERIVATE2)
  Itxf_Vbi_ci_Vxf2_GND=0.0;
  Itxf_Vbi_ci_Vtnode_GND=0.0;
  Itxf_Vbi_ci_Vbi_ei=0.0;
  Itxf_Vbi_ci_Vb_ci=0.0;
  Itxf_Vbi_ci_Vbi_ci=0.0;
  Itxf_Vbi_ci_Vci_ei=0.0;
#endif
#if defined(_DERIVATE)
Itxf_Vci_ei=0.0;
#endif
#endif
Itxf=Vxf2;
EXIT_IF_ISNAN(Vxf2)
#if defined(_DERIVATE) /* probe=V(xf,GND) ddxprobe= */
Vxf_Vxf_GND=1.0;
#endif
Vxf=NP(xf);
EXIT_IF_ISNAN(NP(xf))
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(b,ci)V(bi,ci)V(ci,ei)V(bi,ei) ddxprobe= */
fact_Vtnode_GND=(-pModel->t0*tf_Vtnode_GND/tf/tf);
fact_Vb_ci=(-pModel->t0*tf_Vb_ci/tf/tf);
fact_Vbi_ci=(-pModel->t0*tf_Vbi_ci/tf/tf);
fact_Vci_ei=(-pModel->t0*tf_Vci_ei/tf/tf);
fact_Vbi_ei=(-pModel->t0*tf_Vbi_ei/tf/tf);
#endif
fact=(pModel->t0/tf);
EXIT_IF_ISNAN((pModel->t0/tf))
#if defined(_DERIVATE) /* probe=V(xf,GND)V(tnode,GND)V(b,ci)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe= */
Ixf_Vxf_GND=Vxf_Vxf_GND*fact;
Ixf_Vtnode_GND=(((-qf_Vtnode_GND)*fact)+((Vxf-qf)*fact_Vtnode_GND));
Ixf_Vb_ci=(((-qf_Vb_ci)*fact)+((Vxf-qf)*fact_Vb_ci));
Ixf_Vbi_ci=(((-qf_Vbi_ci)*fact)+((Vxf-qf)*fact_Vbi_ci));
Ixf_Vbi_ei=(((-qf_Vbi_ei)*fact)+((Vxf-qf)*fact_Vbi_ei));
Ixf_Vci_ei=(((-qf_Vci_ei)*fact)+((Vxf-qf)*fact_Vci_ei));
#endif
Ixf=((Vxf-qf)*fact);
EXIT_IF_ISNAN(((Vxf-qf)*fact))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf,GND) ddxprobe= */
Qxf_Vxf_GND=(pModel->alqf*Vxf_Vxf_GND)*pModel->t0;
#endif
Qxf=((pModel->alqf*Vxf)*pModel->t0);
EXIT_IF_ISNAN(((pModel->alqf*Vxf)*pModel->t0))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf,GND)V(tnode,GND)V(b,ci)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe= */
Qdeix_Vxf_GND=Vxf_Vxf_GND;
Qdeix_Vtnode_GND=0.0;
Qdeix_Vb_ci=0.0;
Qdeix_Vbi_ci=0.0;
Qdeix_Vbi_ei=0.0;
Qdeix_Vci_ei=0.0;
#endif
Qdeix=Vxf;
EXIT_IF_ISNAN(Vxf)
#endif
}
else
{
#if defined(_DERIVATE) /* probe=V(xf1,GND)V(xf2,GND)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe= */
Ixf1_Vxf1_GND=1.0;
Ixf1_Vxf2_GND=0.0;
Ixf1_Vtnode_GND=0.0;
Ixf1_Vbi_ei=0.0;
Ixf1_Vb_ci=0.0;
Ixf1_Vbi_ci=0.0;
Ixf1_Vci_ei=0.0;
#endif
Ixf1=NP(xf1);
EXIT_IF_ISNAN(NP(xf1))
#if defined(_DERIVATE) /* probe=V(xf2,GND)V(xf1,GND)V(tnode,GND)V(b,ci)V(bi,ci)V(ci,ei)V(bi,ei) ddxprobe= */
Ixf2_Vxf2_GND=1.0;
Ixf2_Vxf1_GND=0.0;
Ixf2_Vtnode_GND=0.0;
Ixf2_Vb_ci=0.0;
Ixf2_Vbi_ci=0.0;
Ixf2_Vci_ei=0.0;
Ixf2_Vbi_ei=0.0;
#endif
Ixf2=NP(xf2);
EXIT_IF_ISNAN(NP(xf2))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf1,GND) ddxprobe= */
Qxf1_Vxf1_GND=0.0;
#endif
Qxf1=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf2,GND) ddxprobe= */
Qxf2_Vxf2_GND=0.0;
#endif
Qxf2=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DERIVATE) /* probe=V(xf,GND)V(tnode,GND)V(b,ci)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe= */
Ixf_Vxf_GND=1.0;
Ixf_Vtnode_GND=0.0;
Ixf_Vb_ci=0.0;
Ixf_Vbi_ci=0.0;
Ixf_Vbi_ei=0.0;
Ixf_Vci_ei=0.0;
#endif
Ixf=NP(xf);
EXIT_IF_ISNAN(NP(xf))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(xf,GND) ddxprobe= */
Qxf_Vxf_GND=0.0;
#endif
Qxf=0;
EXIT_IF_ISNAN(0)
#endif
}
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci)V(bi,ei)V(b,ci)V(ci,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
Ibici_Vtnode_GND=(ijbc_Vtnode_GND-iavl_Vtnode_GND);
#endif
Ibici_Vbi_ci=(ijbc_Vbi_ci-iavl_Vbi_ci);
#if defined(_DERIVATE2)
  Ibici_Vbi_ci_Vtnode_GND=(+ijbc_Vbi_ci_Vtnode_GND-iavl_Vbi_ci_Vtnode_GND);
  Ibici_Vbi_ci_Vbi_ci=(+ijbc_Vbi_ci_Vbi_ci-iavl_Vbi_ci_Vbi_ci);
  Ibici_Vbi_ci_Vbi_ei=(+ijbc_Vbi_ci_Vbi_ei-iavl_Vbi_ci_Vbi_ei);
  Ibici_Vbi_ci_Vb_ci=(+0.0-iavl_Vbi_ci_Vb_ci);
  Ibici_Vbi_ci_Vci_ei=(+0.0-iavl_Vbi_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
Ibici_Vbi_ei=(ijbc_Vbi_ei-iavl_Vbi_ei);
#endif
Ibici_Vb_ci=(-iavl_Vb_ci);
#if defined(_DERIVATE2)
  Ibici_Vb_ci_Vtnode_GND=(+0.0-iavl_Vb_ci_Vtnode_GND);
  Ibici_Vb_ci_Vbi_ci=(+0.0-iavl_Vb_ci_Vbi_ci);
  Ibici_Vb_ci_Vbi_ei=(+0.0-iavl_Vb_ci_Vbi_ei);
  Ibici_Vb_ci_Vb_ci=(+0.0-iavl_Vb_ci_Vb_ci);
  Ibici_Vb_ci_Vci_ei=(+0.0-iavl_Vb_ci_Vci_ei);
#endif
Ibici_Vci_ei=(-iavl_Vci_ei);
#if defined(_DERIVATE2)
  Ibici_Vci_ei_Vtnode_GND=(+0.0-iavl_Vci_ei_Vtnode_GND);
  Ibici_Vci_ei_Vbi_ci=(+0.0-iavl_Vci_ei_Vbi_ci);
  Ibici_Vci_ei_Vbi_ei=(+0.0-iavl_Vci_ei_Vbi_ei);
  Ibici_Vci_ei_Vb_ci=(+0.0-iavl_Vci_ei_Vb_ci);
  Ibici_Vci_ei_Vci_ei=(+0.0-iavl_Vci_ei_Vci_ei);
#endif
#endif
pInst->Ibici=(pInst->ijbc-pInst->iavl);
EXIT_IF_ISNAN((pInst->ijbc-pInst->iavl))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci) ddxprobe= */
Qbci_Vb_ci=(pModel->cbcpar*Vbci_Vb_ci);
#endif
Qbci=(pModel->cbcpar*Vbci);
EXIT_IF_ISNAN((pModel->cbcpar*Vbci))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,e) ddxprobe= */
Qbe_Vb_e=(pModel->cbepar*Vbe_Vb_e);
#endif
Qbe=(pModel->cbepar*Vbe);
EXIT_IF_ISNAN((pModel->cbepar*Vbe))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe= */
Qbici_Vb_ci=(qjcii_Vb_ci+qr_Vb_ci);
Qbici_Vtnode_GND=(qjcii_Vtnode_GND+qr_Vtnode_GND);
Qbici_Vbi_ci=(qjcii_Vbi_ci+qr_Vbi_ci);
Qbici_Vbi_ei=qr_Vbi_ei;
Qbici_Vci_ei=qr_Vci_ei;
#endif
Qbici=(qjcii+qr);
EXIT_IF_ISNAN((qjcii+qr))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(xf,GND) ddxprobe= */
Qbiei_Vtnode_GND=(qjei_Vtnode_GND+Qdeix_Vtnode_GND);
Qbiei_Vci_ei=(qjei_Vci_ei+Qdeix_Vci_ei);
Qbiei_Vbi_ei=(qjei_Vbi_ei+Qdeix_Vbi_ei);
Qbiei_Vb_ci=(qjei_Vb_ci+Qdeix_Vb_ci);
Qbiei_Vbi_ci=(qjei_Vbi_ci+Qdeix_Vbi_ci);
Qbiei_Vxf_GND=Qdeix_Vxf_GND;
#endif
Qbiei=(pInst->qjei+Qdeix);
EXIT_IF_ISNAN((pInst->qjei+Qdeix))
#endif
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(s,ci)V(bi,ci)V(bi,ei) ddxprobe= */
ijsc_Vtnode_GND=(pModel->HICUMtype*ijsc_Vtnode_GND);
ijsc_Vs_ci=(pModel->HICUMtype*ijsc_Vs_ci);
ijsc_Vbi_ci=(pModel->HICUMtype*ijsc_Vbi_ci);
ijsc_Vbi_ei=(pModel->HICUMtype*ijsc_Vbi_ei);
#endif
pInst->ijsc=(pModel->HICUMtype*pInst->ijsc);
EXIT_IF_ISNAN((pModel->HICUMtype*pInst->ijsc))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ci,ei)V(bi,ei)V(s,ci)V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
qjs_Vci_ei=(pModel->HICUMtype*qjs_Vci_ei);
#endif
#if defined(_DERIVATE)
qjs_Vbi_ei=(pModel->HICUMtype*qjs_Vbi_ei);
#endif
qjs_Vs_ci=(pModel->HICUMtype*qjs_Vs_ci);
#if defined(_DERIVATE2)
  qjs_Vs_ci_Vci_ei=(+0.0*qjs+0.0*qjs_Vci_ei+0.0*qjs_Vs_ci+pModel->HICUMtype*qjs_Vs_ci_Vci_ei);
  qjs_Vs_ci_Vbi_ei=(+0.0*qjs+0.0*qjs_Vbi_ei+0.0*qjs_Vs_ci+pModel->HICUMtype*qjs_Vs_ci_Vbi_ei);
  qjs_Vs_ci_Vs_ci=(+0.0*qjs+0.0*qjs_Vs_ci+0.0*qjs_Vs_ci+pModel->HICUMtype*qjs_Vs_ci_Vs_ci);
  qjs_Vs_ci_Vb_ci=(+0.0*qjs+0.0*qjs_Vb_ci+0.0*qjs_Vs_ci+pModel->HICUMtype*qjs_Vs_ci_Vb_ci);
  qjs_Vs_ci_Vtnode_GND=(+0.0*qjs+0.0*qjs_Vtnode_GND+0.0*qjs_Vs_ci+pModel->HICUMtype*qjs_Vs_ci_Vtnode_GND);
  qjs_Vs_ci_Vbi_ci=(+0.0*qjs+0.0*qjs_Vbi_ci+0.0*qjs_Vs_ci+pModel->HICUMtype*qjs_Vs_ci_Vbi_ci);
#endif
#if defined(_DERIVATE)
qjs_Vb_ci=(pModel->HICUMtype*qjs_Vb_ci);
#endif
#if defined(_DERIVATE)
qjs_Vtnode_GND=(pModel->HICUMtype*qjs_Vtnode_GND);
#endif
#if defined(_DERIVATE)
qjs_Vbi_ci=(pModel->HICUMtype*qjs_Vbi_ci);
#endif
#endif
qjs=(pModel->HICUMtype*qjs);
EXIT_IF_ISNAN((pModel->HICUMtype*qjs))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci) ddxprobe= */
qjcx_Vb_ci=(pModel->HICUMtype*qjcx_Vb_ci);
qjcx_Vtnode_GND=(pModel->HICUMtype*qjcx_Vtnode_GND);
qjcx_Vbi_ci=(pModel->HICUMtype*qjcx_Vbi_ci);
#endif
qjcx=(pModel->HICUMtype*qjcx);
EXIT_IF_ISNAN((pModel->HICUMtype*qjcx))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci) ddxprobe= */
Qbci_Vb_ci=(pModel->HICUMtype*Qbci_Vb_ci);
#endif
Qbci=(pModel->HICUMtype*Qbci);
EXIT_IF_ISNAN((pModel->HICUMtype*Qbci))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,e) ddxprobe= */
Qbe_Vb_e=(pModel->HICUMtype*Qbe_Vb_e);
#endif
Qbe=(pModel->HICUMtype*Qbe);
EXIT_IF_ISNAN((pModel->HICUMtype*Qbe))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ci)V(bi,ei)V(b,ci)V(ci,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
Ibici_Vtnode_GND=(pModel->HICUMtype*Ibici_Vtnode_GND);
#endif
Ibici_Vbi_ci=(pModel->HICUMtype*Ibici_Vbi_ci);
#if defined(_DERIVATE2)
  Ibici_Vbi_ci_Vtnode_GND=(+0.0*pInst->Ibici+0.0*Ibici_Vtnode_GND+0.0*Ibici_Vbi_ci+pModel->HICUMtype*Ibici_Vbi_ci_Vtnode_GND);
  Ibici_Vbi_ci_Vbi_ci=(+0.0*pInst->Ibici+0.0*Ibici_Vbi_ci+0.0*Ibici_Vbi_ci+pModel->HICUMtype*Ibici_Vbi_ci_Vbi_ci);
  Ibici_Vbi_ci_Vbi_ei=(+0.0*pInst->Ibici+0.0*Ibici_Vbi_ei+0.0*Ibici_Vbi_ci+pModel->HICUMtype*Ibici_Vbi_ci_Vbi_ei);
  Ibici_Vbi_ci_Vb_ci=(+0.0*pInst->Ibici+0.0*Ibici_Vb_ci+0.0*Ibici_Vbi_ci+pModel->HICUMtype*Ibici_Vbi_ci_Vb_ci);
  Ibici_Vbi_ci_Vci_ei=(+0.0*pInst->Ibici+0.0*Ibici_Vci_ei+0.0*Ibici_Vbi_ci+pModel->HICUMtype*Ibici_Vbi_ci_Vci_ei);
#endif
#if defined(_DERIVATE)
Ibici_Vbi_ei=(pModel->HICUMtype*Ibici_Vbi_ei);
#endif
Ibici_Vb_ci=(pModel->HICUMtype*Ibici_Vb_ci);
#if defined(_DERIVATE2)
  Ibici_Vb_ci_Vtnode_GND=(+0.0*pInst->Ibici+0.0*Ibici_Vtnode_GND+0.0*Ibici_Vb_ci+pModel->HICUMtype*Ibici_Vb_ci_Vtnode_GND);
  Ibici_Vb_ci_Vbi_ci=(+0.0*pInst->Ibici+0.0*Ibici_Vbi_ci+0.0*Ibici_Vb_ci+pModel->HICUMtype*Ibici_Vb_ci_Vbi_ci);
  Ibici_Vb_ci_Vbi_ei=(+0.0*pInst->Ibici+0.0*Ibici_Vbi_ei+0.0*Ibici_Vb_ci+pModel->HICUMtype*Ibici_Vb_ci_Vbi_ei);
  Ibici_Vb_ci_Vb_ci=(+0.0*pInst->Ibici+0.0*Ibici_Vb_ci+0.0*Ibici_Vb_ci+pModel->HICUMtype*Ibici_Vb_ci_Vb_ci);
  Ibici_Vb_ci_Vci_ei=(+0.0*pInst->Ibici+0.0*Ibici_Vci_ei+0.0*Ibici_Vb_ci+pModel->HICUMtype*Ibici_Vb_ci_Vci_ei);
#endif
Ibici_Vci_ei=(pModel->HICUMtype*Ibici_Vci_ei);
#if defined(_DERIVATE2)
  Ibici_Vci_ei_Vtnode_GND=(+0.0*pInst->Ibici+0.0*Ibici_Vtnode_GND+0.0*Ibici_Vci_ei+pModel->HICUMtype*Ibici_Vci_ei_Vtnode_GND);
  Ibici_Vci_ei_Vbi_ci=(+0.0*pInst->Ibici+0.0*Ibici_Vbi_ci+0.0*Ibici_Vci_ei+pModel->HICUMtype*Ibici_Vci_ei_Vbi_ci);
  Ibici_Vci_ei_Vbi_ei=(+0.0*pInst->Ibici+0.0*Ibici_Vbi_ei+0.0*Ibici_Vci_ei+pModel->HICUMtype*Ibici_Vci_ei_Vbi_ei);
  Ibici_Vci_ei_Vb_ci=(+0.0*pInst->Ibici+0.0*Ibici_Vb_ci+0.0*Ibici_Vci_ei+pModel->HICUMtype*Ibici_Vci_ei_Vb_ci);
  Ibici_Vci_ei_Vci_ei=(+0.0*pInst->Ibici+0.0*Ibici_Vci_ei+0.0*Ibici_Vci_ei+pModel->HICUMtype*Ibici_Vci_ei_Vci_ei);
#endif
#endif
pInst->Ibici=(pModel->HICUMtype*pInst->Ibici);
EXIT_IF_ISNAN((pModel->HICUMtype*pInst->Ibici))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,ci)V(tnode,GND)V(bi,ci)V(bi,ei)V(ci,ei) ddxprobe= */
Qbici_Vb_ci=(pModel->HICUMtype*Qbici_Vb_ci);
Qbici_Vtnode_GND=(pModel->HICUMtype*Qbici_Vtnode_GND);
Qbici_Vbi_ci=(pModel->HICUMtype*Qbici_Vbi_ci);
Qbici_Vbi_ei=(pModel->HICUMtype*Qbici_Vbi_ei);
Qbici_Vci_ei=(pModel->HICUMtype*Qbici_Vci_ei);
#endif
Qbici=(pModel->HICUMtype*Qbici);
EXIT_IF_ISNAN((pModel->HICUMtype*Qbici))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei) ddxprobe=V(bi,GND) */
#if defined(_DERIVATE)
ijbe_Vtnode_GND=(pModel->HICUMtype*ijbe_Vtnode_GND);
#endif
ijbe_Vbi_ei=(pModel->HICUMtype*ijbe_Vbi_ei);
#if defined(_DERIVATE2)
  ijbe_Vbi_ei_Vtnode_GND=(+0.0*pInst->ijbe+0.0*ijbe_Vtnode_GND+0.0*ijbe_Vbi_ei+pModel->HICUMtype*ijbe_Vbi_ei_Vtnode_GND);
  ijbe_Vbi_ei_Vbi_ei=(+0.0*pInst->ijbe+0.0*ijbe_Vbi_ei+0.0*ijbe_Vbi_ei+pModel->HICUMtype*ijbe_Vbi_ei_Vbi_ei);
#endif
#endif
pInst->ijbe=(pModel->HICUMtype*pInst->ijbe);
EXIT_IF_ISNAN((pModel->HICUMtype*pInst->ijbe))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(tnode,GND)V(ci,ei)V(bi,ei)V(b,ci)V(bi,ci)V(xf,GND) ddxprobe= */
Qbiei_Vtnode_GND=(pModel->HICUMtype*Qbiei_Vtnode_GND);
Qbiei_Vci_ei=(pModel->HICUMtype*Qbiei_Vci_ei);
Qbiei_Vbi_ei=(pModel->HICUMtype*Qbiei_Vbi_ei);
Qbiei_Vb_ci=(pModel->HICUMtype*Qbiei_Vb_ci);
Qbiei_Vbi_ci=(pModel->HICUMtype*Qbiei_Vbi_ci);
Qbiei_Vxf_GND=(pModel->HICUMtype*Qbiei_Vxf_GND);
#endif
Qbiei=(pModel->HICUMtype*Qbiei);
EXIT_IF_ISNAN((pModel->HICUMtype*Qbiei))
#endif
#if defined(_DYNAMIC)
it_wop=(pModel->HICUMtype*pInst->it);
EXIT_IF_ISNAN((pModel->HICUMtype*pInst->it))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(xf2,GND)V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND)V(bi,GND) */
#if defined(_DERIVATE)
it_Vxf2_GND=(pModel->HICUMtype*Itxf_Vxf2_GND);
#endif
#if defined(_DERIVATE)
it_Vtnode_GND=(pModel->HICUMtype*(Itxf_Vtnode_GND-itr_Vtnode_GND));
#endif
it_Vbi_ei=(pModel->HICUMtype*(Itxf_Vbi_ei-itr_Vbi_ei));
#if defined(_DERIVATE2)
  it_Vbi_ei_Vxf2_GND=(+0.0*(Itxf-itr)+0.0*Itxf_Vxf2_GND+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+pModel->HICUMtype*(+Itxf_Vbi_ei_Vxf2_GND-0.0));
  it_Vbi_ei_Vtnode_GND=(+0.0*(Itxf-itr)+0.0*(Itxf_Vtnode_GND-itr_Vtnode_GND)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+pModel->HICUMtype*(+Itxf_Vbi_ei_Vtnode_GND-itr_Vbi_ei_Vtnode_GND));
  it_Vbi_ei_Vbi_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+pModel->HICUMtype*(+Itxf_Vbi_ei_Vbi_ei-itr_Vbi_ei_Vbi_ei));
  it_Vbi_ei_Vb_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+pModel->HICUMtype*(+Itxf_Vbi_ei_Vb_ci-itr_Vbi_ei_Vb_ci));
  it_Vbi_ei_Vbi_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+pModel->HICUMtype*(+Itxf_Vbi_ei_Vbi_ci-itr_Vbi_ei_Vbi_ci));
  it_Vbi_ei_Vci_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+pModel->HICUMtype*(+Itxf_Vbi_ei_Vci_ei-itr_Vbi_ei_Vci_ei));
#endif
it_Vb_ci=(pModel->HICUMtype*(Itxf_Vb_ci-itr_Vb_ci));
#if defined(_DERIVATE2)
  it_Vb_ci_Vxf2_GND=(+0.0*(Itxf-itr)+0.0*Itxf_Vxf2_GND+0.0*(Itxf_Vb_ci-itr_Vb_ci)+pModel->HICUMtype*(+Itxf_Vb_ci_Vxf2_GND-0.0));
  it_Vb_ci_Vtnode_GND=(+0.0*(Itxf-itr)+0.0*(Itxf_Vtnode_GND-itr_Vtnode_GND)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+pModel->HICUMtype*(+Itxf_Vb_ci_Vtnode_GND-itr_Vb_ci_Vtnode_GND));
  it_Vb_ci_Vbi_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+pModel->HICUMtype*(+Itxf_Vb_ci_Vbi_ei-itr_Vb_ci_Vbi_ei));
  it_Vb_ci_Vb_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+pModel->HICUMtype*(+Itxf_Vb_ci_Vb_ci-itr_Vb_ci_Vb_ci));
  it_Vb_ci_Vbi_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+pModel->HICUMtype*(+Itxf_Vb_ci_Vbi_ci-itr_Vb_ci_Vbi_ci));
  it_Vb_ci_Vci_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+pModel->HICUMtype*(+Itxf_Vb_ci_Vci_ei-itr_Vb_ci_Vci_ei));
#endif
it_Vbi_ci=(pModel->HICUMtype*(Itxf_Vbi_ci-itr_Vbi_ci));
#if defined(_DERIVATE2)
  it_Vbi_ci_Vxf2_GND=(+0.0*(Itxf-itr)+0.0*Itxf_Vxf2_GND+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+pModel->HICUMtype*(+Itxf_Vbi_ci_Vxf2_GND-0.0));
  it_Vbi_ci_Vtnode_GND=(+0.0*(Itxf-itr)+0.0*(Itxf_Vtnode_GND-itr_Vtnode_GND)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+pModel->HICUMtype*(+Itxf_Vbi_ci_Vtnode_GND-itr_Vbi_ci_Vtnode_GND));
  it_Vbi_ci_Vbi_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+pModel->HICUMtype*(+Itxf_Vbi_ci_Vbi_ei-itr_Vbi_ci_Vbi_ei));
  it_Vbi_ci_Vb_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+pModel->HICUMtype*(+Itxf_Vbi_ci_Vb_ci-itr_Vbi_ci_Vb_ci));
  it_Vbi_ci_Vbi_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+pModel->HICUMtype*(+Itxf_Vbi_ci_Vbi_ci-itr_Vbi_ci_Vbi_ci));
  it_Vbi_ci_Vci_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+pModel->HICUMtype*(+Itxf_Vbi_ci_Vci_ei-itr_Vbi_ci_Vci_ei));
#endif
it_Vci_ei=(pModel->HICUMtype*(Itxf_Vci_ei-itr_Vci_ei));
#if defined(_DERIVATE2)
  it_Vci_ei_Vxf2_GND=(+0.0*(Itxf-itr)+0.0*Itxf_Vxf2_GND+0.0*(Itxf_Vci_ei-itr_Vci_ei)+pModel->HICUMtype*(+Itxf_Vci_ei_Vxf2_GND-0.0));
  it_Vci_ei_Vtnode_GND=(+0.0*(Itxf-itr)+0.0*(Itxf_Vtnode_GND-itr_Vtnode_GND)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+pModel->HICUMtype*(+Itxf_Vci_ei_Vtnode_GND-itr_Vci_ei_Vtnode_GND));
  it_Vci_ei_Vbi_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ei-itr_Vbi_ei)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+pModel->HICUMtype*(+Itxf_Vci_ei_Vbi_ei-itr_Vci_ei_Vbi_ei));
  it_Vci_ei_Vb_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vb_ci-itr_Vb_ci)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+pModel->HICUMtype*(+Itxf_Vci_ei_Vb_ci-itr_Vci_ei_Vb_ci));
  it_Vci_ei_Vbi_ci=(+0.0*(Itxf-itr)+0.0*(Itxf_Vbi_ci-itr_Vbi_ci)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+pModel->HICUMtype*(+Itxf_Vci_ei_Vbi_ci-itr_Vci_ei_Vbi_ci));
  it_Vci_ei_Vci_ei=(+0.0*(Itxf-itr)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+0.0*(Itxf_Vci_ei-itr_Vci_ei)+pModel->HICUMtype*(+Itxf_Vci_ei_Vci_ei-itr_Vci_ei_Vci_ei));
#endif
#endif
pInst->it=(pModel->HICUMtype*(Itxf-itr));
EXIT_IF_ISNAN((pModel->HICUMtype*(Itxf-itr)))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(tnode,GND)V(bi,ei)V(b,ci)V(bi,ci)V(ci,ei) ddxprobe=V(ci,GND) */
#if defined(_DERIVATE)
iavl_Vtnode_GND=(pModel->HICUMtype*iavl_Vtnode_GND);
#endif
#if defined(_DERIVATE)
iavl_Vbi_ei=(pModel->HICUMtype*iavl_Vbi_ei);
#endif
iavl_Vb_ci=(pModel->HICUMtype*iavl_Vb_ci);
#if defined(_DERIVATE2)
  iavl_Vb_ci_Vtnode_GND=(+0.0*pInst->iavl+0.0*iavl_Vtnode_GND+0.0*iavl_Vb_ci+pModel->HICUMtype*iavl_Vb_ci_Vtnode_GND);
  iavl_Vb_ci_Vbi_ei=(+0.0*pInst->iavl+0.0*iavl_Vbi_ei+0.0*iavl_Vb_ci+pModel->HICUMtype*iavl_Vb_ci_Vbi_ei);
  iavl_Vb_ci_Vb_ci=(+0.0*pInst->iavl+0.0*iavl_Vb_ci+0.0*iavl_Vb_ci+pModel->HICUMtype*iavl_Vb_ci_Vb_ci);
  iavl_Vb_ci_Vbi_ci=(+0.0*pInst->iavl+0.0*iavl_Vbi_ci+0.0*iavl_Vb_ci+pModel->HICUMtype*iavl_Vb_ci_Vbi_ci);
  iavl_Vb_ci_Vci_ei=(+0.0*pInst->iavl+0.0*iavl_Vci_ei+0.0*iavl_Vb_ci+pModel->HICUMtype*iavl_Vb_ci_Vci_ei);
#endif
iavl_Vbi_ci=(pModel->HICUMtype*iavl_Vbi_ci);
#if defined(_DERIVATE2)
  iavl_Vbi_ci_Vtnode_GND=(+0.0*pInst->iavl+0.0*iavl_Vtnode_GND+0.0*iavl_Vbi_ci+pModel->HICUMtype*iavl_Vbi_ci_Vtnode_GND);
  iavl_Vbi_ci_Vbi_ei=(+0.0*pInst->iavl+0.0*iavl_Vbi_ei+0.0*iavl_Vbi_ci+pModel->HICUMtype*iavl_Vbi_ci_Vbi_ei);
  iavl_Vbi_ci_Vb_ci=(+0.0*pInst->iavl+0.0*iavl_Vb_ci+0.0*iavl_Vbi_ci+pModel->HICUMtype*iavl_Vbi_ci_Vb_ci);
  iavl_Vbi_ci_Vbi_ci=(+0.0*pInst->iavl+0.0*iavl_Vbi_ci+0.0*iavl_Vbi_ci+pModel->HICUMtype*iavl_Vbi_ci_Vbi_ci);
  iavl_Vbi_ci_Vci_ei=(+0.0*pInst->iavl+0.0*iavl_Vci_ei+0.0*iavl_Vbi_ci+pModel->HICUMtype*iavl_Vbi_ci_Vci_ei);
#endif
iavl_Vci_ei=(pModel->HICUMtype*iavl_Vci_ei);
#if defined(_DERIVATE2)
  iavl_Vci_ei_Vtnode_GND=(+0.0*pInst->iavl+0.0*iavl_Vtnode_GND+0.0*iavl_Vci_ei+pModel->HICUMtype*iavl_Vci_ei_Vtnode_GND);
  iavl_Vci_ei_Vbi_ei=(+0.0*pInst->iavl+0.0*iavl_Vbi_ei+0.0*iavl_Vci_ei+pModel->HICUMtype*iavl_Vci_ei_Vbi_ei);
  iavl_Vci_ei_Vb_ci=(+0.0*pInst->iavl+0.0*iavl_Vb_ci+0.0*iavl_Vci_ei+pModel->HICUMtype*iavl_Vci_ei_Vb_ci);
  iavl_Vci_ei_Vbi_ci=(+0.0*pInst->iavl+0.0*iavl_Vbi_ci+0.0*iavl_Vci_ei+pModel->HICUMtype*iavl_Vci_ei_Vbi_ci);
  iavl_Vci_ei_Vci_ei=(+0.0*pInst->iavl+0.0*iavl_Vci_ei+0.0*iavl_Vci_ei+pModel->HICUMtype*iavl_Vci_ei_Vci_ei);
#endif
#endif
pInst->iavl=(pModel->HICUMtype*pInst->iavl);
EXIT_IF_ISNAN((pModel->HICUMtype*pInst->iavl))
#endif
  _load_static_residual2(bi,ei,(gmin*(NP(bi)-NP(ei))))
  _load_static_jacobian4(bi,ei,bi,ei,(gmin))
  _load_static_residual2(bi,ci,(gmin*(NP(bi)-NP(ci))))
  _load_static_jacobian4(bi,ci,bi,ci,(gmin))
  _load_static_residual2(ci,ei,(gmin*(NP(ci)-NP(ei))))
  _load_static_jacobian4(ci,ei,ci,ei,(gmin))
  _load_static_residual2(b,s,(pModel->HICUMtype*HSI_Tsu))
  _load_static_jacobian4(b,s,s,ci,(pModel->HICUMtype*HSI_Tsu_Vs_ci))
  _load_static_jacobian4(b,s,b,ci,(pModel->HICUMtype*HSI_Tsu_Vb_ci))
  _load_static_jacobian2s(b,s,tnode,(pModel->HICUMtype*HSI_Tsu_Vtnode_GND))
  _load_static_residual2(s,ci,(pInst->ijsc+(gmin*(NP(s)-NP(ci)))))
  _load_static_jacobian4(s,ci,bi,ei,ijsc_Vbi_ei)
  _load_static_jacobian4(s,ci,bi,ci,ijsc_Vbi_ci)
  _load_static_jacobian4(s,ci,s,ci,(ijsc_Vs_ci+(gmin)))
  _load_static_jacobian2s(s,ci,tnode,ijsc_Vtnode_GND)
  _load_dynamic_residual2(s,ci,_DDT(qjs))
  _load_dynamic_jacobian4(s,ci,bi,ci,qjs_Vbi_ci)
  _load_dynamic_jacobian2s(s,ci,tnode,qjs_Vtnode_GND)
  _load_dynamic_jacobian4(s,ci,b,ci,qjs_Vb_ci)
  _load_dynamic_jacobian4(s,ci,s,ci,qjs_Vs_ci)
  _load_dynamic_jacobian4(s,ci,bi,ei,qjs_Vbi_ei)
  _load_dynamic_jacobian4(s,ci,ci,ei,qjs_Vci_ei)
  _load_dynamic_residual2(b,ci,_DDT(qjcx))
  _load_dynamic_jacobian4(b,ci,bi,ci,qjcx_Vbi_ci)
  _load_dynamic_jacobian2s(b,ci,tnode,qjcx_Vtnode_GND)
  _load_dynamic_jacobian4(b,ci,b,ci,qjcx_Vb_ci)
  _load_dynamic_residual2(b,ci,_DDT(Qbci))
  _load_dynamic_jacobian4(b,ci,b,ci,Qbci_Vb_ci)
  _load_dynamic_residual2(b,e,_DDT(Qbe))
  _load_dynamic_jacobian4(b,e,b,e,Qbe_Vb_e)
if
((pModel->re>=0.001))
{
  _load_static_residual2(ei,e,(Veie/re_t))
  _load_static_jacobian2s(ei,e,tnode,(-Veie*re_t_Vtnode_GND/re_t/re_t))
  _load_static_jacobian4(ei,e,ei,e,(Veie_Vei_e/re_t))
}
else
{
  _load_static_residual2(ei,e,(Veie/0.001))
  _load_static_jacobian4(ei,e,ei,e,(Veie_Vei_e/0.001))
}
if
((pModel->rcx>=0.001))
{
  _load_static_residual2(ci,c,(Vcic/rcx_t))
  _load_static_jacobian2s(ci,c,tnode,(-Vcic*rcx_t_Vtnode_GND/rcx_t/rcx_t))
  _load_static_jacobian4(ci,c,ci,c,(Vcic_Vci_c/rcx_t))
}
else
{
  _load_static_residual2(ci,c,(Vcic/0.001))
  _load_static_jacobian4(ci,c,ci,c,(Vcic_Vci_c/0.001))
}
if
(((pModel->rbi0>=0.001)||(pModel->rbx>=0.001)))
{
  _load_static_residual2(b,bi,((Vbbi/rb)+(gmin*Vbbi)))
  _load_static_jacobian4(b,bi,bi,ci,(-Vbbi*rb_Vbi_ci/rb/rb))
  _load_static_jacobian4(b,bi,b,ci,(-Vbbi*rb_Vb_ci/rb/rb))
  _load_static_jacobian4(b,bi,ci,ei,(-Vbbi*rb_Vci_ei/rb/rb))
  _load_static_jacobian4(b,bi,bi,ei,(-Vbbi*rb_Vbi_ei/rb/rb))
  _load_static_jacobian2s(b,bi,tnode,(-Vbbi*rb_Vtnode_GND/rb/rb))
  _load_static_jacobian4(b,bi,b,bi,((Vbbi_Vb_bi/rb)+(gmin*Vbbi_Vb_bi)))
}
else
{
  _load_static_residual2(b,bi,(Vbbi/0.001))
  _load_static_jacobian4(b,bi,b,bi,(Vbbi_Vb_bi/0.001))
}
  _load_static_residual2(bi,ci,pInst->Ibici)
  _load_static_jacobian4(bi,ci,ci,ei,Ibici_Vci_ei)
  _load_static_jacobian4(bi,ci,b,ci,Ibici_Vb_ci)
  _load_static_jacobian4(bi,ci,bi,ei,Ibici_Vbi_ei)
  _load_static_jacobian4(bi,ci,bi,ci,Ibici_Vbi_ci)
  _load_static_jacobian2s(bi,ci,tnode,Ibici_Vtnode_GND)
  _load_dynamic_residual2(bi,ci,_DDT(Qbici))
  _load_dynamic_jacobian4(bi,ci,ci,ei,Qbici_Vci_ei)
  _load_dynamic_jacobian4(bi,ci,bi,ei,Qbici_Vbi_ei)
  _load_dynamic_jacobian4(bi,ci,bi,ci,Qbici_Vbi_ci)
  _load_dynamic_jacobian2s(bi,ci,tnode,Qbici_Vtnode_GND)
  _load_dynamic_jacobian4(bi,ci,b,ci,Qbici_Vb_ci)
  _load_static_residual2(bi,ei,pInst->ijbe)
  _load_static_jacobian4(bi,ei,bi,ei,ijbe_Vbi_ei)
  _load_static_jacobian2s(bi,ei,tnode,ijbe_Vtnode_GND)
  _load_dynamic_residual2(bi,ei,_DDT(Qbiei))
  _load_dynamic_jacobian2s(bi,ei,xf,Qbiei_Vxf_GND)
  _load_dynamic_jacobian4(bi,ei,bi,ci,Qbiei_Vbi_ci)
  _load_dynamic_jacobian4(bi,ei,b,ci,Qbiei_Vb_ci)
  _load_dynamic_jacobian4(bi,ei,bi,ei,Qbiei_Vbi_ei)
  _load_dynamic_jacobian4(bi,ei,ci,ei,Qbiei_Vci_ei)
  _load_dynamic_jacobian2s(bi,ei,tnode,Qbiei_Vtnode_GND)
  _load_static_residual2(ci,ei,pInst->it)
  _load_static_jacobian4(ci,ei,ci,ei,it_Vci_ei)
  _load_static_jacobian4(ci,ei,bi,ci,it_Vbi_ci)
  _load_static_jacobian4(ci,ei,b,ci,it_Vb_ci)
  _load_static_jacobian4(ci,ei,bi,ei,it_Vbi_ei)
  _load_static_jacobian2s(ci,ei,tnode,it_Vtnode_GND)
  _load_static_jacobian2s(ci,ei,xf2,it_Vxf2_GND)
if
(((pModel->flsh==0)||(pModel->rth<0.001)))
{
  _load_static_residual1(tnode,(Vrth/0.001))
  _load_static_jacobian1(tnode,tnode,(Vrth_Vtnode_GND/0.001))
}
else
{
  _load_static_residual1(tnode,((Vrth/rth_t)-pterm))
  _load_static_jacobian2p(tnode,ci,ei,(-pterm_Vci_ei))
  _load_static_jacobian2p(tnode,bi,ci,(-pterm_Vbi_ci))
  _load_static_jacobian2p(tnode,b,ci,(-pterm_Vb_ci))
  _load_static_jacobian2p(tnode,bi,ei,(-pterm_Vbi_ei))
  _load_static_jacobian2p(tnode,s,ci,(-pterm_Vs_ci))
  _load_static_jacobian2p(tnode,b,bi,(-pterm_Vb_bi))
  _load_static_jacobian2p(tnode,ei,e,(-pterm_Vei_e))
  _load_static_jacobian2p(tnode,ci,c,(-pterm_Vci_c))
  _load_static_jacobian1(tnode,tnode,(((Vrth_Vtnode_GND*rth_t-Vrth*rth_t_Vtnode_GND)/rth_t/rth_t)-pterm_Vtnode_GND))
  _load_dynamic_residual1(tnode,_DDT((pModel->cth*Vrth)))
  _load_dynamic_jacobian1(tnode,tnode,(pModel->cth*Vrth_Vtnode_GND))
}
  _load_static_residual1(xf1,Ixf1)
  _load_static_jacobian2p(xf1,ci,ei,Ixf1_Vci_ei)
  _load_static_jacobian2p(xf1,bi,ci,Ixf1_Vbi_ci)
  _load_static_jacobian2p(xf1,b,ci,Ixf1_Vb_ci)
  _load_static_jacobian2p(xf1,bi,ei,Ixf1_Vbi_ei)
  _load_static_jacobian1(xf1,tnode,Ixf1_Vtnode_GND)
  _load_static_jacobian1(xf1,xf2,Ixf1_Vxf2_GND)
  _load_static_jacobian1(xf1,xf1,Ixf1_Vxf1_GND)
  _load_dynamic_residual1(xf1,_DDT(Qxf1))
  _load_dynamic_jacobian1(xf1,xf1,Qxf1_Vxf1_GND)
  _load_static_residual1(xf2,Ixf2)
  _load_static_jacobian2p(xf2,bi,ei,Ixf2_Vbi_ei)
  _load_static_jacobian2p(xf2,ci,ei,Ixf2_Vci_ei)
  _load_static_jacobian2p(xf2,bi,ci,Ixf2_Vbi_ci)
  _load_static_jacobian2p(xf2,b,ci,Ixf2_Vb_ci)
  _load_static_jacobian1(xf2,tnode,Ixf2_Vtnode_GND)
  _load_static_jacobian1(xf2,xf1,Ixf2_Vxf1_GND)
  _load_static_jacobian1(xf2,xf2,Ixf2_Vxf2_GND)
  _load_dynamic_residual1(xf2,_DDT(Qxf2))
  _load_dynamic_jacobian1(xf2,xf2,Qxf2_Vxf2_GND)
  _load_static_residual1(xf,Ixf)
  _load_static_jacobian2p(xf,ci,ei,Ixf_Vci_ei)
  _load_static_jacobian2p(xf,bi,ei,Ixf_Vbi_ei)
  _load_static_jacobian2p(xf,bi,ci,Ixf_Vbi_ci)
  _load_static_jacobian2p(xf,b,ci,Ixf_Vb_ci)
  _load_static_jacobian1(xf,tnode,Ixf_Vtnode_GND)
  _load_static_jacobian1(xf,xf,Ixf_Vxf_GND)
  _load_dynamic_residual1(xf,_DDT(Qxf))
  _load_dynamic_jacobian1(xf,xf,Qxf_Vxf_GND)
{
double oRPIi;
double oRMUi;
double oROi;
double gAVL;
double Cdei;
double Cdci;
double Cjei;
double Cjci;
double Cjcx;
double CBC;
double R_tot;
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IB]=ibe;
EXIT_IF_ISNAN(ibe)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IC]=pInst->it;
EXIT_IF_ISNAN(pInst->it)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB]=pInst->ijsc;
EXIT_IF_ISNAN(pInst->ijsc)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IAVL]=pInst->iavl;
EXIT_IF_ISNAN(pInst->iavl)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VBE]=(NP(b)-NP(e));
EXIT_IF_ISNAN((NP(b)-NP(e)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VBC]=(NP(b)-NP(c));
EXIT_IF_ISNAN((NP(b)-NP(c)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VCE]=(NP(c)-NP(e));
EXIT_IF_ISNAN((NP(c)-NP(e)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VSC]=(NP(s)-NP(c));
EXIT_IF_ISNAN((NP(s)-NP(c)))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMi]=+(it_Vbi_ei)+(it_Vbi_ci); /* indeed 3 */
EXIT_IF_ISNAN(GMi)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
oRPIi=+(ijbe_Vbi_ei); /* indeed 3 */
EXIT_IF_ISNAN(oRPIi)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RPIi]=(1.0/(oRPIi+1e-12));
EXIT_IF_ISNAN((1.0/(oRPIi+1e-12)))
#endif
#if defined(_DYNAMIC)
oRMUi=((-1)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-1)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RMUi]=(1.0/(oRMUi+1e-12));
EXIT_IF_ISNAN((1.0/(oRMUi+1e-12)))
#endif
#if defined(_DYNAMIC)
gAVL=(pModel->HICUMtype*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((pModel->HICUMtype*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
oROi=-(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(oROi)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ROi]=(1.0/((oROi+gAVL)+1e-12));
EXIT_IF_ISNAN((1.0/((oROi+gAVL)+1e-12)))
#endif
#if defined(_DYNAMIC)
Cdei=(((-1)*pModel->HICUMtype)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-1)*pModel->HICUMtype)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
Cjei=+(qjei_Vbi_ei)+(qjei_Vbi_ci); /* indeed 3 */
EXIT_IF_ISNAN(Cjei)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CPIi]=((Cjei+Cdei)+pModel->cbepar);
EXIT_IF_ISNAN(((Cjei+Cdei)+pModel->cbepar))
#endif
#if defined(_DYNAMIC)
Cdci=(((-1)*pModel->HICUMtype)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((((-1)*pModel->HICUMtype)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
Cjci=+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(Cjci)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CMUi]=(Cjci+Cdci);
EXIT_IF_ISNAN((Cjci+Cdci))
#endif
#if defined(_DYNAMIC)
Cjcx=((-1)*0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-1)*0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBCX]=(Cjcx+pModel->cbcpar);
EXIT_IF_ISNAN((Cjcx+pModel->cbcpar))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CCS]=+(qjs_Vs_ci); /* indeed 3 */
EXIT_IF_ISNAN(CCS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RBi]=rbi;
EXIT_IF_ISNAN(rbi)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RB]=rb;
EXIT_IF_ISNAN(rb)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RCXop]=rcx_t;
EXIT_IF_ISNAN(rcx_t)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_REop]=re_t;
EXIT_IF_ISNAN(re_t)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_BETADC]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IC]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IB]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IC]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IB]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_BETAAC]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMi]*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RPIi]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMi]*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RPIi]))
#endif
#if defined(_DYNAMIC)
R_tot=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RCXop]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_REop])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RB]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_REop])/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_BETAAC]));
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RCXop]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_REop])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RB]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_REop])/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_BETAAC])))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_TF]=tf;
EXIT_IF_ISNAN(tf)
#endif
#if defined(_DYNAMIC)
CBC=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CMUi]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBCX]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CMUi]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CBCX]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_FT]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMi]/((2*3.14159265358979323846)*((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CPIi]+CBC)+((R_tot*CBC)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMi]))));
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMi]/((2*3.14159265358979323846)*((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CPIi]+CBC)+((R_tot*CBC)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMi])))))
#endif
}
